* 	PROGRAM PREPSPEC
*
* Prepare trailed-spectrogram file .TRS for MEMECHO analysis.
* 	load times and spectra from ascii files
*	apply wavelength shifts
*	fit continua
*	clip ends and combine pixels
*	plot mean, slope, rms, or individual spectra
*	extract and plot light curves
*	display of trailed spectrogram images
*	save .TRS file for MEMECHO analysis
* 
* Apr 1990 Keith Horne @ STScI - quickie version for 5548 IUE spectra
* Sep 1990 KDH @ STScI - generalize to IUEPREP.FOR for 4151 IUE spectra
* Feb 1991 KDH @ STScI - generalize to PREPSPEC.FOR for 3516 LAG spectra
* Apr 1991 KDH @ IoA cambridge:
*		omit IMDISP display, use epsilon for bad data
* Apr 1991 KDH @ IOA Cambridge:
*		editor for continuum band wavelength limits
* May 1991 KDH @ STScI - editor for line wavelengths
* 		fit power-law continua
* May 1991 KDH @ STScI - fake error bars if absent on input data,
*		fake error bars as a menu option,
*		use sequence numbers if hjd's absent from input file
* Apr 1992 KDH @ Oxford - PGSWIN ->PGEWIN
* May 1992 KDH @ IoA/RGO - scale factors on input
* Jun 1992 KDH @ IoA/RGO - zshift
* Jun 1992 KDH @ IoA/RGO - add constant to spectra
* Aug 1992 KDH @ Amsterdam - fix bug in light curve error bars
* Aug 1992 KDH @ Amsterdam - add systematic error term
* Feb 1993 KDH @ STScI - add 5-column format with continua and absn spectrum
* May 1993 KDH @ STScI - boost maxwave to to cope with hst spectra
* May 1993 KDH @ STScI - fix bug error bar on mean spectrum.
* May 1993 KDH @ STScI - plot mean, slope, and rms spectra.
* May 1993 KDH @ STScI - plot linear fit on light curves
* May 1993 KDH @ STScI - allow negative wlims (for velocities)
* May 1993 KDH @ STScI - mark selected lines
* May 1993 KDH @ STScI - subtract mean and slope from trailed spectrograms
* May 1993 KDH @ STScI - improve greyscale plot titles
* May 1993 KDH @ STScI - rebin by pixel, angstrom, km/s
* May 1993 KDH @ STScI - greyscale option for normalized residuals
* Jul 1993 KDH @ STScI - fix bug in wavelength shift weights
* Jul 1993 KDH @ STScI - use -ve weight to use absn line in shifting
* Mar 1994 KDH @ Utrecht - use LOAD1DX, DUMP1DX, DUMP2DX
* Mar 1994 KDH @ Utrecht - move $ to formats
* May 1994 KDH @ STScI - copy Utrecht version to STScI
* May 1995 KDH @ St.And - PGMAP->PGGRAY, PGWEDGE->PGWEDG
* May 1995 KDH @ St.And - maxspec 300->500, maxwave 3800->5000
* May 1995 KDH @ St.And - ISPLIT=1 analyze all or =2 fast+slow variations
* May 1995 KDH @ St.And - use mean error bar sig0 to keep wgt close to 1
* May 1995 KDH @ St.And - rebin selections now with rest wavelengths
* Apr 1996 KDH @ St.And - Linear vs Power-law continuum fits
* Oct 1999 KDH @ St-And - parentheses in parameter statements
* 2001 Aug KDH @ St.And - use OPENFILE, adjust code for linux g77
* 2001 Aug KDH @ St.And - LOADCOL=3
* 2002 Dec KDH @ St.And - MJY
* 2003 Aug KDH @ St.And - INQ
* 2008 Sep KDH @ St.And - don't upcase file names, use pgagain
* 2009 Apr KDH @ St.And - expand error bars to allow for subpix jitter
* 2009 Apr KDH @ St.And - sub-pixel shift by linear/quadratic interpolation
* 2009 Apr KDH @ St.And - decomposition model
* 2009 Aug KDH @ St.And - more work on decomposition model
* 2009 Sep KDH @ St.A - chi^2 vs iterations
* 2009 Sep KDH @ St.A - bias and chi vs time and wavelength
* 2010 Jul KDH @ St.A - clip wavelengths before output
* 2010 Jul KDH @ St.A - change g77 to ifort compiler
* 2011 Aug KDH @ St.A - expand_l and line width editor
* 2011 Aug KDH @ St.A - let narrow and broad lines overlap
* 2011 Aug KDH @ St.A - mark continuum bands on plot
* 2011 Aug KDH @ St.A - HeII model - cloned from Halpha
* 2011 Aug KDH @ St.A - AGN list
* 2012 Jul KDH @ Dark - BIC plot
* 2012 Jul KDH @ Dark - output menu
* 2012 Jul KDH @ SAAO - Balmer Continuum
* 2012 Sep KDH @ StA - count lost spectra
* 2012 Sep KDH @ StA - maxspec 200 -> 270, maxwave 7000 -> 5000
* 2012 Sep KDH @ StA - revise output menu
* 2012 Sep KDH @ StA - final plot of wavelength jitter vs spectrum number
* 2012 Sep KDH @ StA - optimal average in rectify
* 2012 Oct KDH @ StA - maxspec 270 -> 320
* 2013 Mar KDH @ StA - maxspec 320 -> 350
* 2014 May KDH @ StA - U to change flux units, Nt on avgrms plot
* 2014 May KDH @ StA - add SDSS-RM 85,88,664,778
* 2014 May KDH @ StA - maxwave/maxspec 5000/320 -> 10000/190
* 2014 May KDH @ StA - more info on modelling plots
* 2014 May KDH @ StA - real*8 wave8, wavpic8, w8_w, real*4 wave, w_w
* 2014 Jun KDH @ StA - allow binning in observed/rest wavelengths
* 2014 Jun KDH @ StA - narrow [NeV] [NeIII] [SII] [OII] lines
* 2014 Jun KDH @ StA - detect dispersion jumps and fill in missing pixels
* 2014 Jun KDH @ StA - gabby
* 2014 Jul KDH @ StA - linestat
* 2014 Jul KDH @ StA - nwav(.)->nw_t(.)
* 2014 Jul KDH @ StA - longer input buffers and rebin if needed
* 2014 Jul KDH @ StA - chifix to fudge error bars
* 2014 Jul KDH @ StA - absn mask and model
* 2014 Jul KDH @ StA - timebase (HJD vs MJD vs RJD)
* 2014 Jul KDH @ StA - inflxdex (input) and inflxdex (plots)
* 2014 Aug KDH @ StA - customised multi-panel plots
* 2014 Aug KDH @ StA - absn line model .. testing
* 2014 Sep KDH @ StA - 13 more SDSS redshifts 
* 2014 Sep KDH @ StA - output calibrations and chi/bias
* 2014 Sep KDH @ StA - SDSS headers - read redshift
* 2014 Sep KDH @ StA - output avg and nlr spectrum
* 2014 Sep KDH @ StA - output line profiles and lightcurves
* 2014 Oct KDH @ StA - several more targets
* 2014 Dec KDH @ StA - MgII
* 2014 Dec KDH @ StA - output velocities avg rms med mad top fwhm
* 2014 Dec KDH @ StA - variable line lightcurves
* 2015 Jan KDH @ Annapolis - xw_w( i )
* 2015 Jan KDH @ Annapolis - linear regression at each time
* 2015 Jan KDH @ StA - line fluxes and hw10%
* 2015 Feb KDH @ StA - levenberg-marquardt parameter alam_t (DISABLE)
* 2015 Feb KDH @ StA - S/N on c(t) and p(t) plots
* 2015 Feb KDH @ StA - fit ln(p(t)) to keep p(t) positive.
* 2015 Mar KDH @ StA - avgrmsx for ML estimate of rms spectra
* 2015 Mar KDH @ StA - maxpcont 3->4 for sdss, 3->2 for HST
* 2015 Apr KDH @ StA - use sigpoly for correct error bar estimates
* 2015 Apr KDH @ StA - rmsraw and rmsbias to test rmsx
* 2015 Apr KDH @ StA - automatic adjustment of line windows
* 2015 May KDH @ StA - linestat_mcmc error bars
* 2015 May KDH @ StA - quit if no change in BIC after maxback iterations
* 2015 May KDH @ StA - limit automatic vblr/vnlr changes to +/- ivdiv
* 2015 May KDH @ StA - debug plots to check linewidth error bars
* 2015 May KDH @ StA - vacuum wavelengths
* 2015 May KDH @ StA - detect oscillations in vblr,vnlr
* 2015 Jun KDH @ StA - inner and outer fwhm
* 2015 Jun KDH @ StA - velocity profile plots
* 2015 Jul KDH @ StA - W command loads 5008 if linelist empty 
* 2015 Aug KDH @ StA - fixflx needs inflxdex, not iflxdex
* 2015 Oct KDH @ StA - real*8 rest, rest0, zshift
* 2015 Oct KDH @ StA - gaussian priors (e.g. on p(t)
* 2015 Nov KDH @ StA - znlr to over-ride nominal redshifts
* 2015 Nov KDH @ StA - major line labels on plots
* 2016 Mar KDH @ StA - 4151 redshift
* 2016 Mar KDH @ StA - scaling in avgrmsx
* 2016 Mar KDH @ StA - npcont_s, npscale_s, npshift_s, npblur_s
* 2016 Jun KDH @ StA - scale spectra before alignment
* 2016 Jul KDH @ StA - tweak data before computing rms spectrum
* 2016 Jul KDH @ StA - eliminate fcal
* 2016 Jul KDH @ StA - sigma clip thresholds cliphi, cliplo
* 2016 Jul KDH @ StA - mark clipped pixels on greyscale
* 2016 Jul KDH @ StA - clipped chi and bias spectrum and lightcurve
* 2016 Jul KDH @ StA - pgclip writes clip legend
* 2016 Jul KDH @ Iceland - rangtest (ran was failing with gfortran)
* 2016 Aug KDH @ StA - multiply error bars by chimedw prior to rmsx
* 2016 Aug KDH @ StA - timex (HJD vs sequence number on plots)
* 2016 Aug KDH @ StA - stiffen continuum fit to mean spectrum
* 2016 Aug KDH @ StA - output lightcurves with mean and rms restored
* 2016 Aug KDH @ StA - outfluxunit, ioutdex
* 2016 Sep KDH @ StA - misorder set to report times out of order
* 2016 Sep KDH @ StA - set timebase for .mjd .rjd files
* 2016 Sep KDH @ StA - maxpcont 5 -> 10, using cont_p, cont_tp
* 2017 Aug KDH @ StA - ifort gives NAN
* 2017 Aug KDH @ StA - trap NAN using x .ne. x
* 2017 Aug KDH @ StA - gfortran avoids NAN (but slow)
* 2017 Sep KDH @ StA - convert microns to angstroms on input
* 2017 Sep KDH @ StA - IR lines from Hermine Landt
* 2017 Sep KDH @ StA - maxc=15=>30
* 2017 Sep KDH @ StA - line flux on plots
* 2017 Oct KDH @ StA - suppress lines in NLR spectrum based on s/n
* 2017 Oct KDH @ StA - avoid NaN in linetop
* 2017 Oct KDH @ StA - softblr windows on continuum fits
* 2017 Oct KDH @ StA - add narrow Hdelta
* 2017 Oct KDH @ StA - stiffnlr for NLR separation
* 2018 Feb KDH @ STA - dumpstats
* 2018 Feb KDH @ STA - fix sig=0 => -1
* 2018 Feb KDH @ STA - require sigpic > 0 when rebinning
* 2018 Feb KDH @ STA - snr1, snr2, snrx (adopt snr1 = sqrt(chi^2-dof)
* 2018 Feb KDH @ STA - sdss bit ANDMASK, ORMASK
* 2018 Feb KDH @ STA - rectify1
* 2018 Feb KDH @ STA - fix bug linestat2 changing f(n)
* 2018 May KDH @ STA - elr_raw_w on plots
* 2018 May KDH @ STA - use dump1dh to put header lines on output files
* 2018 Jul KDH @ STA - window half-width file ps_nlr_blr
* 2018 Jul KDH @ STA - usemedmad in rectify1 (more stable to large outliers)
* 2018 Jul KDH @ STA - med2mad corrects mad bias (<rms> = 1.4826 <mad>)
* 2018 Jul KDH @ STA - mad2rms in chi_bias_w and chi_bias_t
* 2018 Sep KDH @ STA - label_flux, dumplc -> dumplch 
* 2018 Sep KDH @ STA - tlabel_flux, plabel_flux
* 2018 Sep KDH @ STA - multi-panel spectrum plot
* 2018 Sep KDH @ STA - jiggled linear continuum on line profile plots
* 2018 Sep KDH @ STA - cumulative continuum-subtracted profile
* 2018 Sep KDH @ STA - good_wt, good_w, good_t, nada, nadaw, nadat
* 2018 Sep KDH @ STA - separate years on greyscales
* 2018 Oct KDH @ StA - tower of splines (toggle tower)
* 2018 Oct KDH @ StA - AVGBLR model on AVG spectrum plot
* 2018 Oct KDH @ StA - fe2spec fitting
* 2018 Oct KDH @ StA - symbolic colour indices (kred,kblue, etc)
* 2019 Feb KDH @ StA - Add column rmsf_w (model) to rms_w.dat output file
* 2019 Mar KDH @ StA - maskabsn
* 2019 Aug KDH @ StA - subroutine fe2plot
* 2019 Aug KDH @ StA - usebalmask, maskbal, balfile, nbal, restbal_l, v1bal_l, v2bal_l
* 2019 Aug KDH @ StA - panic - debugging rmsblr model failing
* 2019 Aug KDH @ StA - fitavgblr_w, fitrmsblr_w, contrmsblr_w
* 2019 Nov KDH @ StA - omit comma after write(*,*),
* 2019 Nov KDH @ StA - y axis scale factor before pgewin
* 2019 Dec KDH @ StA - replot continuum band data
* 2019 Dec KDH @ StA - fix bug plotting multiple individual spectra
* 2020 Mar KDH @ StA - simpleplot option (for publications )
* 2020 Mar KDH @ StA - LW and CH to change linewidth and character height
* 2021 Jan KDH @ Crail - revise default lwide=2, csize=1.3
* 2021 Mar KDH @ StA - plot FeII velocity vs iteration
* 2021 Mar KDH @ StA - sort input times 
* 2021 Mar KDH @ StA - j2222 image a,b,c delays and scale factors
* 2021 Apr KDH @ StA - summaise lost/bad spectra, notime, nodata, npix_t, nbadpix_t
* 2021 Apr KDH @ StA - badpixpercent 20 -> 50
* 2021 Apr KDH @ StA - mark ly continuum
* 2021 Apr KDH @ StA - label_fe2 on avgrms plot
* 2021 Jun KDH @ StA - output spectra with/without NLR
* 2021 Jul KDH @ StA - add PG 1119+120 and Mrk 1044 
* 2021 Aug KDH @ StA - fix bug in Fe2 BoF(Vdisp) parabola mininum
* 2021 Aug KDH @ StA - pick timing file from tlist_l
* 2021 Aug KDH @ StA - special cases (intersection,union) for binning
* 2021 Aug KDH @ StA - safe 1/variance wgt=(sigok/sig)^2 in (0,1) prevents inf/inf=nan 
* 2021 Sep KDH @ StA - Convert 1/var to sig on 3-column sdssrm spectrum files
* 2021 Sep KDH @ StA - bhm field and target
* 2021 Sep KDH @ StA - Convert var to sig on 4-column sdssrm spectrum files
* 2021 Oct KDH @ StA - spline fit to chi(w) and mixfitdat model
* 2022 May KDH @ StA - bhm files now have sigma rather than variance in col 3
* 2022 Jul KDH @ Crail - Mrk1239, IC4329
* 2022 Jul KDH @ Crail - krmsx, kbias, kchi (better plot windows)
* 2022 Jul KDH @ Crail - vertical offset between spectra on plots
* 2022 Jul KDH @ Crail - nsite, name_s, isymb_s, nt_s, is_t, i_ts
* 2022 Jul KDH @ Crail - fe2kmsmin fe2kmsprior_min 100->30
* 2022 Aug KDH @ StA - spawn command to operating system
* 2022 Aug KDH @ StA - add Pa epsilon and zeta for Mrk 509
* 2022 Sep KDH @ StA - default continuum band file cband.dat
* 2023 Feb KDH @ Crail - mark line windows above and below plot window
* 2023 Feb KDH @ Crail - log/lin test to speed greyscale display
* 2023 Feb KDH @ Crail - compress eps(lam) on plots
* 2023 Feb KDH @ Crail - StA => 500 (for Mrk 817)
* 2023 Mar KDH @ Crail - guess next spectra to plot (DISABLE)
* 2023 Mar KDH @ Crail - add [SIII] 9533 if in range
* 2023 Mar KDH @ Crail - use PGPIC for greyscale image displays
* 2023 Apr KDH @ StA - validate ToDo list

* REMEMBER TO UPDATE VERSION AFTER SIGNIFICANT CHANGES !
	character*20 version /'2023 Apr'/

* OK for SDSS data:
c	parameter ( maxwave = 8900 )
c	parameter ( maxspec = 500 )

* Jul 2014 expand dimensions for HST STORM data:
c	parameter ( maxwave = 10000 )  ok with 190
c	parameter ( maxwave = 15000 )  ok with 180
c	parameter ( maxwave = 20000 )  not ok with 180
c	parameter ( maxwave = 18000 )  not ok with 180.  ok with 100
c	parameter ( maxwave = 20000 )  ok with 100
c	parameter ( maxwave = 25000 )  ok with 100
c Jul 2014: ok 30000 100 (for HST STORM data)
c Jul 2014: ok 17000 180 (for HST STORM data)
	parameter ( maxwave = 17000 )

c	parameter ( maxspec = 180 )
c 180->200 for n3227 floyds
c	parameter ( maxspec = 205 )
c 2021-03 205->300 for F9 3-yr floyds
c	parameter ( maxspec = 300 )
c 2023-02-23 300->500 for STORM2 Mrk817 floyds
	parameter ( maxspec = 500 )

* maxbuf used for long input data files
c	parameter ( maxbuf = 100000 )
	parameter ( maxbuf = 20000 )
	parameter ( maxhead = 100 )

* ifort -mcmodel=medium segfaults with maxwave,spec,stow=7000,1000,50000
* ifort -mcmodel=medium segfaults with maxspec=500
* ifort -mcmodel=medium ok with maxspec=400
* 2011 Aug -- now segfaults with maxspec=400
* ifort -mcmodel=medium segfaults with maxspec=300
* ifort -mcmodel=medium ok with maxspec,wave=200,7000
* 2012 Sep
* ifort -mcmodel=medium segfaults with maxspec,wave=270,7000
* ifort -mcmodel=medium ok with maxspec,wave=270,5000
* 2014 May
* ifort -mcmodel=medium segfaults with maxspec,wave=270,10000
* 2014 Jul
* ifort -mcmodel=medium OK with maxspec,wave=110,30000

	parameter ( maxiter = 50000 )
	parameter ( maxstage = 1000 )
	parameter ( maxsite = 100 )

	parameter ( maxw = maxwave )
	parameter ( maxt = maxspec )
	parameter ( maxwt = maxw * maxt )
* agn
	parameter ( maxagn = 100 )
* quasar images
	parameter ( maxq = 10 )
* lines
	parameter ( maxline = 500 )
* absorption lines
	parameter ( maxabsn = 1000 )
* list
	parameter ( maxlist = 1000 )

* spectral components
	parameter ( maxc = 30 )
	parameter ( maxl = 100 )
* poly terms for lambda-dependences
	parameter ( maxpoly = 10 )

* max plot pixels
* linux g77 can't handle this
c	parameter ( maxplot = max( maxwave, maxspec, maxiter ) )
	parameter ( maxplot = maxiter )
* max plot curves
	parameter( maxcurves = 20 )
* max grid values
	parameter( maxgrid = 10000 )

* parameters (phot,shift,blur,cont,comp,blr)
* KDH : CHECK TO SEE IF THIS IS LARGE ENOUGH
* KDH : 4 IS FOR PHOT, SHIFT, BLUR
	parameter ( maxp = 4 * maxpoly + maxc + 1 )

* logical toggles
* sdss or bhm target
	logical sdss / .false. /
	logical bhm / .false. /
	character*10 bhmfield
	
* logwave plot
	logical logwave
	common/logwave/ logwave
* simpleplot
	logical simpleplot
	common/simpleplot/ simpleplot
* absorption line mask
	logical useabsnmask/ .false. /
c	logical useabsnmask/ .true. /
* bal line mask
	logical usebalmask/ .true. /
* tower of splines
	logical fulltower/ .false. /
* vacuum wavelengths
	logical vacuum/ .true. /
* silence splfita and polyfita
	logical silent/ .true. /
	common/silent/ silent
* panic
	logical panic/.false./
	logical debug/.false./
* gabby
	logical gabby/ .false. /
c	logical gabby/ .true. /
	logical yes/ .true. /
	logical converged/ .false. /
	logical fe2converged/ .false. /
	logical plots, lastplot
	character*50 why

* iterations
* KDH : BIC AND CHI2 SHOULD PROBABLY BE REAL*8
	real*4 bic_i( maxiter )
	real*4 chi2_i( maxiter )
	real*4 chi2red_i( maxiter )
	real*8 chi2fix_i( maxiter )
	real*4 chiw_i( maxiter )
	real*4 chit_i( maxiter )
	real*4 dof_i( maxiter )
	integer*4 ndat_i( maxiter )
	integer*4 nfit_i( maxiter )
* nlr
	real*4 vnlr_i( maxiter )
	real*4 vnwant_i( maxiter )
	real*4 vn1_i( maxiter )
	real*4 vn2_i( maxiter )
	real*4 vn3_i( maxiter )
	real*4 vn4_i( maxiter )
* blr
	real*4 vblr_i( maxiter )
	real*4 vbwant_i( maxiter )
	real*4 vb1_i( maxiter )
	real*4 vb2_i( maxiter )
	real*4 vb3_i( maxiter )
	real*4 vb4_i( maxiter )
* fe2
	real*4 vfe2_i( maxiter )
	real*4 sigvfe2_i( maxiter )
	real*4 sclfe2_i( maxiter )

* iteration stages
	character*70 stage, todo_s( maxstage )
	character*70 model_s( maxstage )
	integer*4 iter_s( maxstage )
	real*8 chi2_s( maxstage )
	real*8 bic_s( maxstage )
	integer*4 ndat_s( maxstage )
	integer*4 nfit_s( maxstage )
	integer*4 npcont_s( maxstage )
	integer*4 npscale_s( maxstage )
	integer*4 npshift_s( maxstage )
	integer*4 npblur_s( maxstage )
	real*4 vnlr_s( maxstage )
	real*4 vblr_s( maxstage )
	logical chifix_s( maxstage )

* input buffers
	real*8 wbuf( maxbuf )
	real*4 dbuf( maxbuf )
	real*4 sbuf( maxbuf )
	real*4 cbuf( maxbuf )
	real*4 abuf( maxbuf )
	real*4 ebuf( maxbuf )

* pixel bits
	parameter( maxbit = 32 )
	logical*1 bit, bits( maxbit )
	logical*1 andmask( maxbit, maxbuf )
	logical*1  ormask( maxbit, maxbuf )

* agn
	character*50 agn, agn_a( maxagn )
	real*8 zshift, zshift_a( maxagn )

* quasar images
	character*10 name_q( maxq )
	character*10 tag, tag_q( maxq )
	real*4 delay_q( maxq )
	real*4 scale_q( maxq )
	integer*4 nt_q( maxq )

* redshift files
	parameter( maxz = 10 )
	character*75 zfiles( maxz )
	real*8 zfile, znlr, sigznlr
* velocity file (over-rides default vnlr, vblr)
	character*75 vfile

* spectra
	real*8 w8, dw8, wm8, wp8, wmn8, wmx8, wave8( maxw )

* initial spectrum arrays
* KDH : SHOULD MAKE THESE OBSOLETE
	real*4 wave( maxw )
	real*4 velocity( maxw )
	real*4 data( maxw )
	real*4 cont( maxw )
	real*4 absn( maxw )
	real*4 sigma( maxw )
	real*4 sigsys( maxw )
	real*4 sigjit( maxw )
	real*4 fakesigma( maxw )
	real*4 epsilon( maxw )
	real*4 datslo( maxw )
	real*4 conslo( maxw )
	real*4 sigslo( maxw )
	real*4 sysslo( maxw )
	real*4 datrms( maxw )
	real*4 conrms( maxw )
	real*4 stdrms( maxw )

* wavelengths
	real*8 val8, rest0, rest
	real*8 w8_w( maxw )
	real*4 w_w( maxw )
	real*4 xw_w( maxw )
* spectrum data
	real*4 v_w( maxw )
	real*4 dat_w( maxw )
	real*4 sig_w( maxw )
	real*4 pat_w( maxw )

	real*4 wgt_w( maxw )
	real*4 blrwgt_w( maxw )
	real*4 avgwgt_w( maxw )
c	real*4 rmswgt_w( maxw )

* decomposition model
* number of wavelength poly coefficients
	data npcont /3/
	data npscale /1/
	data npshift /1/
	data npblur /1/

* model spectrum and derivatives
	real*4 f_w( maxw )
	real*4 df_w( maxw )
	real*4 ddf_w( maxw )
	real*4 d3f_w( maxw )
	real*4 d4f_w( maxw )

	real*4 f_wt( maxwt )
	real*4 df_wt( maxwt )
	real*4 ddf_wt( maxwt )
	real*4 d3f_wt( maxwt )
	real*4 d4f_wt( maxwt )

* fitted spectrum
	real*4 fit_w( maxw )
	real*4 fit_wt( maxwt )
* difference
	real*4 dif_w( maxw )
	real*4 dif_wt( maxwt )
* error bars
	real*4 sig_wt( maxwt )
* spare image
	real*4 pic_wt( maxwt )
* normalised residuals
	real*4 chi_wt( maxwt )

* bad pixel mask
	logical bad_w( maxw )
	logical bad_t( maxt )
	logical bad_wt( maxwt )
* bad pixel histograms
	real*4 pixhi_t( maxt )
	real*4 pixlo_t( maxt )
	real*4 pixhi_w( maxw )
	real*4 pixlo_w( maxw )

* error bar fudge factors
	logical chifix / .false. /
	real*4 chifix_w( maxw )
	real*4 chifix_t( maxt )
	real*4 chifix_wt( maxwt )

* bias spectrum and lightcurve
	real*4 bias_w( maxw )
	real*4 bias_t( maxt )
	real*4 sigbias_w( maxw )
	real*4 sigbias_t( maxt )

* chi spectrum and lightcurve
	real*4 chi_w( maxw )
	real*4 chi_t( maxt )
	real*4 sigchi_w( maxw )
	real*4 sigchi_t( maxt )
	real*4 cdf_w( maxw )
	real*4 cdf_t( maxt )

* sigma-clipped versions
	real*4 chiclip_w( maxw )
	real*4 chiclip_t( maxt )
	real*4 sigchiclip_w( maxw )
	real*4 sigchiclip_t( maxt )

	real*4 biasclip_w( maxw )
	real*4 biasclip_t( maxt )
	real*4 sigbiasclip_w( maxw )
	real*4 sigbiasclip_t( maxt )

	real*4 chiclip_wt( maxwt )

* smoothed chi spectrum
	real*4 chifit_w( maxw )
	real*4 sigchifit_w( maxw )
* mixture model of chi spectrum
	real*4 chimix_w( maxw )
	real*4 sigchimix_w( maxw )

* avg spectrum
	real*4 avg_w( maxw )
	real*4 fitavg_w( maxw )
	real*4 sigavg_w( maxw )

* continuum 
	real*4 avgcont_w( maxw )
c	real*4 sigavgcont_w( maxw )
	real*4 cfitsig_w( maxw )
* fe2
	real*4 fe2_w( maxw )
	real*4 avgfe2_w( maxw )
	real*4 sigfe2_w( maxw )
	real*4 davgfe2_w( maxw )
* fe2 parameter grid
	real*8 bof8_k( maxgrid )
	real*4 dbof_k( maxgrid )
* scale factor grid
	real*4 fe2scl_k( maxgrid )
	real*4 fe2kms_k( maxgrid )
	real*4 fe2_k( maxgrid )
	real*4 fe2bof_k( maxgrid )
* 2021-04-20 KDH : real*8 array
	real*8 fe2bof8_k( maxgrid )

* velocity dispersion samples
	real*4 fe2kms_v( maxgrid )
	real*4 fe2scl_v( maxgrid )
c 2021-04-20 KDH : make fe2chi2_v real*8
	real*8 fe2chi2_v( maxgrid )

* sorted (vdisp_v increases)
	real*4 vdisp_v( maxgrid )
	real*4 dlnv_v( maxgrid )
	real*4 scl_v( maxgrid )
c 2021-04-20 KDH : make chi2_v real*8
	real*8 chi2_v( maxgrid )
	real*4 dchi2_v( maxgrid )
	real*4 prior_v( maxgrid )

c 2021-04-20 KDH : bof_v -> bof8_v (not used?)
c	real*8 bof8_v( maxgrid )

	real*4 dbof_v( maxgrid )
	real*4 wgt_v( maxgrid )
	real*4 sig_v( maxgrid )
	real*4 fit_v( maxgrid )

	integer*4 irank_k( maxgrid )
	integer*4 irank_v( maxgrid )
	real*8 fe2bof, fe2bofold

* spline tower
	parameter( maxlev = nint( 1 + alog( maxw/3.) / alog(2.) ) )
	real*4 fitavg_wn( maxw, maxlev )

* rms spectrum
	real*4 rmsraw_w( maxw )
	real*4 rmsbias_w( maxw )
	real*4 rms_w( maxw )
	real*4 sigrms_w( maxw )
* rms continuum
	real*4 rmscont_w( maxw )
	real*4 sigrmscont_w( maxw )
* rmsx of blr spectrum (continuum and tweaks subtracted)
	real*4 rmsb_w( maxw )
	real*4 sigrmsb_w( maxw )
* rms of the model
	real*4 rmsfit_w( maxw )
	real*4 rmsf_w( maxw )
* galaxy spectrum and lightcurve
	real*4 gal_w( maxw )
	real*4 gal_t( maxt )
	real*4 siggal_w( maxw )
	real*4 siggal_t( maxt )
* spectral masks
	logical mask, maskj, maski
	logical maska, maskb, maskc, maskp
	logical mask_w( maxw )
	logical maskbad( maxw )
	logical maskdim( maxw )
	logical masknlr( maxw )
	logical maskblr( maxw )
	logical maskvblr( maxw )

	logical maskbac( maxw )
	logical maskabsn( maxw )

* NLR
	real*4 elr_w( maxw )
	real*4 elr_t( maxt )
	real*4 signlr_w( maxw )
	real*4 signlr_t( maxt )

	real*4 elr_raw_w( maxw )

* BAL windows
	logical maskbal( maxw )
	character*75 balfile
	real*8 restbal_l( maxline )
	real*4 v1bal_l( maxline )
	real*4 v2bal_l( maxline )

* absorption spectrum
	logical dips/ .false. /
	real*4 datod_w( maxw )
	real*4 datdim_w( maxw )
	real*4 sigdim_w( maxw )
	real*4 difdim_w( maxw )
* absorption model (MW + IGM)
	real*4 fitdim_w( maxw )
	real*4 fitod_w( maxw )
* absorption model (intrinsic to agn)
	real*4 fitdim_agn_w( maxw )
	real*4 fitod_agn_w( maxw )

* absorption line model
	logical tweaklines/.false./
	integer*4 i1_l( maxabsn )
	integer*4 i2_l( maxabsn )
	real*8 wobs, wobs_l( maxabsn )
	real*8 wrest, wrest_l( maxabsn )
	real*8 wobs_lya, wrest_lya
	real*4 sigv_l( maxabsn )
	real*4 sigsigv_l( maxabsn )
	real*4 tau0_l( maxabsn )
	real*4 sigtau0_l( maxabsn )
	real*4 snr_l( maxabsn )
	integer*4 ltype_l( maxabsn )

* KDH : APPARENTLY NOT USED
c	character*256 lname, lname_l( maxabsn )	

	character*20 name
	character*256 record, header

* mean BLR
	real*4 avgblr_w( maxw )
	real*4 sigavgblr_w( maxw )
	real*4 fitavgblr_w( maxw )

* rms BLR
	real*4 blr_w( maxw )
	real*4 blr_t( maxt )
	real*4 datblr_w( maxw )
	real*4 sigblr_w( maxw )
	real*4 sigblr_t( maxt )

	real*4 fitrmsblr_w( maxw )
	real*4 contrmsblr_w( maxw )
	real*4 sigfitrmsblr_w( maxw )
* BaC
	real*4 bac_w( maxw )
	real*4 bac_t( maxt )
	real*4 sigbac_w( maxw )
	real*4 sigbac_t( maxt )

* continuum poly coefficients
	parameter( maxpcont = 10 )
	integer*4 ipcont( maxpoly )
	real*4 cont_p( maxpcont )
	real*4 sigcont_p( maxpcont )

	real*4 cont_tp( maxt, maxpcont )
	real*4 sigcont_tp( maxt, maxpcont )
	real*4 cavg_p( maxpcont )
	real*4 crms_p( maxpcont )

	real*4 cont_w( maxw )
	real*4 cont_wt( maxwt )
	real*4 sigcont_w( maxw )
	real*4 sigcont_wt( maxwt )

* flux calib
	logical logp/ .true. /
	parameter( maxpscale = 3 )
	integer*4 ipscale( maxpoly )
	real*4 p0_t( maxt )	
	real*4 p1_t( maxt )	
	real*4 p2_t( maxt )
	real*4 sigp0_t( maxt )	
	real*4 sigp1_t( maxt )	
	real*4 sigp2_t( maxt )

	real*4 p_wt( maxwt )
	real*4 fc_wt( maxwt )
	real*4 sigp_wt( maxwt )
	real*4 sigfc_wt( maxwt )

* pixel shifts
	parameter( maxpshift = 2 )
	integer*4 ipshift( maxpoly )
	real*4 x0_t( maxt )	
	real*4 x1_t( maxt )
	real*4 sigx0_t( maxt )	
	real*4 sigx1_t( maxt )	
	real*4 xc_wt( maxwt )
	real*4 sigxc_wt( maxwt )
* pixel blur
	parameter( maxpblur = 2 )
	integer*4 ipblur( maxpoly )
	real*4 s0_t( maxt )	
	real*4 s1_t( maxt )	
	real*4 sc_wt( maxwt )
	real*4 sigs0_t( maxt )	
	real*4 sigs1_t( maxt )	
	real*4 sigsc_wt( maxwt )

* light curve fits
	real*4 dfit( maxt )
	real*4 cfit( maxt )
* dispersion jumps
	integer*4 njump_t( maxt )
* total and bad pixel count
	integer*4 npix_t( maxt )
	integer*4 nbadpix_t( maxt )
	
* trailed spectrograms
* KDH - SHOULD CHANGE TO 1D ARRAYS DIMENSIONED MAXWT
	real*8 wavpic8( maxw, maxt )
	real*4 datpic( maxw, maxt )
	real*4 sigpic( maxw, maxt )
	real*4 abspic( maxw, maxt )
	real*4 conpic( maxw, maxt )
	real*4 epspic( maxw, maxt )
	real*4 shopic( maxw, maxt )
	real*4 pic( maxwt )

* good data mask (sigpic>0)
	logical good_w( maxw )
	logical good_t( maxt )
	logical good_wt( maxw, maxt )

* wavelength uncertainties
	real*4 sigpix( maxw )
	real*4 ddatdpix( maxw )
	real*4 sigwavpic( maxw, maxt )
	real*4 sigjitpic( maxw, maxt )
	real*4 sigpixpic( maxw, maxt )
	real*4 ddatdpixpic( maxw, maxt )

* input spectrum filenames and times
	character*100 timingfile
	character*100 spec_in( maxt )
	real*8 hjd_in( maxt )

* sites
	character*20 name_s( maxsite )
	integer*4 isymb_s( maxsite )
	integer*4 nt_s( maxsite )
	integer*4 i_ts( maxt, maxsite )
	integer*4 is_t( maxt )

* time-sorted spectra
	character*100 specfile_t( maxt )
	real*8 hjd_t( maxt )
	real*8 w1_t( maxt )
	real*8 w2_t( maxt )
	integer*4 n_t( maxt )
	integer*4 i_t( maxt )
* times
	character*10 timebase/'HJD'/
	real*8 hjd, tbar, trms
	real*4 dat_t( maxt )
	real*4 sig_t( maxt )
	real*4 time( maxt )
	real*8 time8( maxt )

	real*4 seq_t( maxt )
	real*4 see_t( maxt )
	real*4 air_t( maxt )
	integer*4 nw_t( maxt )
	real*4 buf1( maxwt )
	real*4 buf2( maxwt )
	real*4 buf3( maxwt )
	real*4 buf4( maxwt )
	real*4 buf5( maxwt )
* time (vs seq number) on plots
	logical timex/ .true. /

* continuum band limits
	parameter ( maxband = 50 )
	common/nband/ nband
	common/wlim1/ wlim1( maxband )
	common/wlim2/ wlim2( maxband )
	character*75 cfile / 'cband.dat' /
*-------------------------------------------------------------
* line fits
	real*4 wavline( maxline )
	real*4 widline( maxline )
	real*4 wgtline( maxline )
	real*4 pixline( maxline )

* rest wavelength
	real*8 rest_l( maxline )
* text, stagename, label
	character*20 text, text_l( maxline )
	character*1 stage_l( maxline )
	character*20 label_l( maxline )
* pixels
	integer*4 iw1_l( maxline )
	integer*4 iw2_l( maxline )
	integer*4 npix_l( maxline )
	real*4 blurpix_l( maxline )

* auto tweak of blr/nlr window
	logical vnlrtweak /.true./
	logical vblrtweak /.true./
	
* narrow/absorption/broad/continuum
	integer*4 nabc( maxline )
* line type 'N','A','B','C'
	character*2 linetype( maxline )
* linewidth expansion factor
	real*4 expand_l( maxline )
* line rank
	integer*4 i_l( maxline )
* list of lines
	integer*4 lines_l( maxline )

	real*4 wav_l( maxline )
	real*4 x_l( maxline )
	real*4 dat_l( maxline )
	real*4 sig_l( maxline )
	real*4 wmn_l( maxline )
	real*4 wmx_l( maxline )
* pgplot colour index
	integer*4 kolor_l( maxline )
	parameter( kblack=1, kred=2, kgreen=3, kblue=4, kcyan=5 )
	parameter( kmagenta=6, kyellow=7, korange=8, kyelgrn=9 )
	parameter( kblugrn=10, kltblue=11, kpurple=12, kpuce=13 )
	parameter( kdkgrey=14, kltgrey=15 )
* pgplot symbols
	parameter( kstar=18 )
* pgplot line styles
	parameter( kdash=2, kdashdot=3, kdot=4, kdashdot3=5 )
* number of fit parameters
	integer*4 nfit_l( maxline )
	integer*4 nfitcont_l( maxline )
	integer*4 nsmooth_l( maxline )

* line masks
	logical mask_wl( maxw, maxline )
* line spectra and lightcurves
	real*4 dat_wl( maxw, maxline )
	real*4 dat_tl( maxt, maxline )
	real*4 sig_wl( maxw, maxline )
	real*4 sig_tl( maxt, maxline )
	real*4 wgt_wl( maxw, maxline )

* line flux, centroid, linewidth
	real*4 flx_l( maxline )
	real*4 vmed_l( maxline )
	real*4 vmad_l( maxline )
	real*4 vavg_l( maxline )
	real*4 vrms_l( maxline )
	real*4 vtop_l( maxline )
	real*4 vlo_l( maxline )
	real*4 vhi_l( maxline )
	real*4 vlo10_l( maxline )
	real*4 vhi10_l( maxline )
	real*4 vfwhm_l( maxline )
	real*4 vhw10_l( maxline )
* error bars
	real*4 sigflx_l( maxline )
	real*4 sigvmed_l( maxline )
	real*4 sigvmad_l( maxline )
	real*4 sigvavg_l( maxline )
	real*4 sigvrms_l( maxline )
	real*4 sigvtop_l( maxline )
	real*4 sigvlo_l( maxline )
	real*4 sigvhi_l( maxline )
	real*4 sigvlo10_l( maxline )
	real*4 sigvhi10_l( maxline )
	real*4 sigvfwhm_l( maxline )
	real*4 sigvhw10_l( maxline )

* variable component flux, centroid, linewidth
	real*4 vflx_l( maxline )
	real*4 vvmed_l( maxline )
	real*4 vvmad_l( maxline )
	real*4 vvavg_l( maxline )
	real*4 vvrms_l( maxline )
	real*4 vvtop_l( maxline )
	real*4 vvlo_l( maxline )
	real*4 vvhi_l( maxline )
	real*4 vvlo10_l( maxline )
	real*4 vvhi10_l( maxline )
	real*4 vvfwhm_l( maxline )
	real*4 vvhw10_l( maxline )
* error bars
	real*4 sigvflx_l( maxline )
	real*4 sigvvmed_l( maxline )
	real*4 sigvvmad_l( maxline )
	real*4 sigvvavg_l( maxline )
	real*4 sigvvrms_l( maxline )
	real*4 sigvvtop_l( maxline )
	real*4 sigvvlo_l( maxline )
	real*4 sigvvhi_l( maxline )
	real*4 sigvvlo10_l( maxline )
	real*4 sigvvhi10_l( maxline )
	real*4 sigvvfwhm_l( maxline )
	real*4 sigvvhw10_l( maxline )

* variable  components
	integer*4 nline_c( maxc )
	integer*4 nfit_c( maxc )
	integer*4 npix_c( maxc )
	character*75 file_c( maxc )
	integer*4 line_lc( maxl, maxc )

* joint multi-parameter fits
* parameters
	real*4 par_p( maxp )
* error bars
	real*4 sig_p( maxp )
* gaussian priors
	real*4 prior_p( maxp )
	real*4 sigprior_p( maxp )
* parameter step
	real*4 dp_p( maxp )
* correlation vector
	real*8 c_p( maxp )
* hessian matrix
	real*8 h_pp( maxp * maxp )
* correlation matrix
	real*8 c_pp( maxp * maxp )
* parameter type
	integer*4 iphot_p( maxp )
	integer*4 ishift_p( maxp )
	integer*4 iblur_p( maxp )
	integer*4 icont_p( maxp )
	integer*4 icomp_p( maxp )
* parameter name
	character*20 text_p( maxp )
* old and new chi2
	real*8 chi2old, chi2new

* spectral patterns
	integer*4 iw1_p( maxp )
	integer*4 iw2_p( maxp )
	real*4 pat_pw( maxp * maxw )
	logical mask_pw( maxp * maxw )

* time-dependent parameters
	real*4 par_pt( maxp * maxt )
	real*4 sig_pt( maxp * maxt )
* time-dependent correlation matrix
	real*8 c_ppt( maxp * maxp * maxt )
* levenberg-marquardt parameter
	real*4 alam_t( maxt )
* KDH : CHI2_T NOT USED 
	real*8 chi2_t( maxt )
* caution
	real*4 caution_t( maxt )

* plot arrays
	real*4 xplot( maxplot )
	real*4 cplot( maxplot )
	real*4 yplot( maxplot )
	real*4 dyplot( maxplot )

	real*8 dplot1( maxplot )

* plot curves
	real*4 curves( maxplot, maxcurves )
	real*4 sigmas( maxplot, maxcurves )
	integer*4 kolors( maxcurves )
	character*70 labels( maxcurves )
	integer*4 iw_k( maxcurves )
	real*4 x_k( maxcurves )

* KDH : REPLACE plotn ARRAYS WITH curves ?
	real*4 plot0( maxplot )
	real*4 plot1( maxplot )
	real*4 plot2( maxplot )
	real*4 plot3( maxplot )
	real*4 plot4( maxplot )
	real*4 plot5( maxplot )
	real*4 plot6( maxplot )
	real*4 plot7( maxplot )
	real*4 plot8( maxplot )
	real*4 plot9( maxplot )
	real*4 plot10( maxplot )
	real*4 plot11( maxplot )
	real*4 plot12( maxplot )
	real*4 plot13( maxplot )
	real*4 plot14( maxplot )
	real*4 plot15( maxplot )
	real*4 plot16( maxplot )
	real*4 plot17( maxplot )
	real*4 plot18( maxplot )
	real*4 plot19( maxplot )
	real*4 plot20( maxplot )
	real*4 plot21( maxplot )
	real*4 plot22( maxplot )

* pgplot
	character*128 xlabel, ylabel, title, legend, legend2, label
	real*4 tr( 6 )
	DATA TR/ 0., 1., 0., 0., 0., 1. /
	INTEGER*4 PGEWIN
	logical pgagain

c	logical isnan
	character*100 todolist, todo
	character*10 toplot

* default multi-panel plot options
	character*10 toplot1 / 'E' /
	character*10 toplot2 / 'MB' /
	character*10 toplot3 / 'MEX' /
	character*10 toplot4 / 'MCBL' /
	character*10 toplot5 / 'MCBLX3' /
	character*10 toplot7 / 'MCBLE3XT' /


	character*256 hline, hlines( maxhead )
	character*100 list
	character*100 tlist, tlist_l( maxlist )
	character*100 file
	character*100 hjdfile
	character*100 hjdfile1
	character*128 prefix
	character*50 number
	character*100 reply
	character*100 fmt
	character*50 pmode

	character*100 specname( maxspec )
	character*20 fluxunit, outfluxunit

* KDH : ARE ALL THESE NEEDED ?
	REAL*8 OPZ, P8, OMP8, wobs1, wobs2
	REAL*8 SUM, SUMR, SUMC, SUMA, SUMCR, SUMW, SUMV, SUMJ, SIG0, SIGOK
	real*8 sum0, sum1, sum2, sum3
	REAL*8 SUMT, SUMTT, SUMDT, SUMCT, SUMCC, SUMDD

* options
	logical powerlaw / .true. /
	logical autofit / .true. /
* constants
	pi = 4. * atan2( 1., 1. )
	CLIGHT = CGS( 'C' )
	VKMS = 1.E5
	CKMS = CLIGHT / VKMS
	ANGST = CGS( 'ANGSTROM' )
	FMJY = CGS( 'MJY' )

* simple plot switch
	simpleplot = .true.
	simpleplot = .false.

* debug switch
	debug = .true.
	debug = .false.

* log wavelengths on plots
	logwave = .false.
	logwave = .true.

* test random number generator
	iseed = 596105
	write(*,*) 'Sanity check rang (gaussian random numbers).'
	call rangtest( iseed )
	write(*,*) 'AOK :)'

* test snr1,2,x
      do kk = -1, 0
      do k = 1,5
	n = 10. ** k
	n = min( maxplot, n )
	avg = 1.
	rms = 1.
	sig = 10. ** kk
      do i = 1, n
	s = sqrt( rms * rms + sig * sig )
	plot1( i ) = rang( avg, s, iseed )
	plot2( i ) = sig
	plot3( i ) = s
      end do
	call avgrmsx( n, plot1, plot2, good, a, r, siga, sigr )
	call optavg( n, plot1, plot2, opt, sigopt )
	call medmad( n, plot1, dmed, dmad )
	sum = 0.d0
	sum1 = 0.d0
	sum2 = 0.d0
	sum3 = 0.d0
      do i = 1, n
	s = plot2( i )
	d = plot1( i )
	stot = plot3( i )

* sane with total variance
	x = ( d - avg ) / stot
	sum = sum + abs( x )
* chi2 with total variance
	x = ( d - avg ) / stot
	sum2 = sum2 + x * x

* sane with error bars
	x = ( d - dmed ) / s
	sum1 = sum1 + abs( x )
* chi2 with error bars
	x = ( d - opt ) / s
	sum3 = sum3 + x * x

      end do
	sane = sum
	chi2 = sum2
	chi1 = sum1
	dof = max( 0, n - 1 )
	div = max( 1., dof )
	sigbymad = 1.4826

	sn1 = snr1( n, plot1, plot2 )
	sn2 = snr2( n, plot1, plot2 )
	snx = snrx( n, plot1, plot2 )
* analytic estimates
	sn1a = rms / sig * sqrt( 2. * dof )
	sn2a = rms / sig * sqrt( 2. * dof )
	snxa = sqrt( good )
	write(*,*)
	write(*,*) '------------ N', n, ' RMS', rms, ' SIG', sig
	write(*,*) 'sqrt(', n, ')', sqrt(real(n)), ' sqrt(', good, ' )', sqrt(good)
	write(*,*) ' SANE', sane, ' SANE/N', sane / n, '=', sigbymad, ' ?'
	write(*,*) ' Chi2', chi2, ' Chi2/N', chi2 / n, '=', 1, ' ?'
	write(*,*) '  SNR1', sn1, ' /', sn1a, ' =', sn1 / sn1a
	write(*,*) '  SNR2', sn2, ' /', sn2a, ' =', sn2 / sn2a
	write(*,*) '  SNRX', snx, ' /', snxa, ' =', snx / snxa
	write(*,*) ' med', dmed, ' avg', avg, ' AVG_ML', a, ' +/-', siga
	write(*,*) ' mad', dmad, ' rms', rms, ' RMS_ML', r, ' +/-', sigr
* next k
      end do
* next kk
      end do

c	read(*,*)

* silence spline fitting routine
	silent = .true.

* defaults ---------------------------------------

* number of lensed quasar images
	nq = 0

* Force proceed on spline fit failure
	nofail = 1

* min old pixels per new wavelength bin
	npixbin = 1
* pgplot line width
c	lwidedef = 3
	lwidedef = 2
	lwide = lwidedef
* pgplot character height
c	csizedef = 1.5
	csizedef = 1.3
	csize = csizedef
* analyze fast and slow variations
	ISPLIT = 2
* analyze total variance only
	ISPLIT = 1
* pixel jitter
	PIXJIT = 0.
* systematic err
	SYSERB = 0.
* flux units of input spectra
	fluxunit = 'MJY'
	inflxdex = 0
* flux units on plots
	iflxdex = 0
* flux units of output spectra
	outfluxunit = 'FLAM'
	ioutdex = 0

* interpolation level (0=no interpolation, 1=linear, 2=quadratic)
	linterp = 0
* line fit mode (1=weighted average, 2=optimal average, 3=linear fit)
	linemode_wgt = 1
	linemode_opt = 2
	linemode_trend = 3
	linemode = linemode_opt
* line fit plots
	lineplot_none = 0
	lineplot_final = 1
	lineplot_all = 2
	lineplot = lineplot_final
* decomposition iterations
	nits = -1
	iback = 0
	todolist = 'AC6J'
* lookback for convergence test
	maxback = 50
* lookback for oscillation test
	maxbackosc = 10
* stages
	nstage = 0
	stage = ' '
* continuum fits
	npolyc = 2
	NCYCLE = 100
	THRHI = 3 
	THRLO = -3.
* redshift
	zshift = 0.d0

* fe2 parameters
	fe2kms = 100.
	fe2ang = 1.
	fe2scl = 1.
	fe2opt = fe2scl
	fe2uv  = fe2scl
	fe2pct = 0.
	ngridv = 0
	rms_over_span_max = 0.1
	fe2kmsprior_min = 100.
	fe2kmsprior_min = 50.
	fe2kmsprior_min = 30.

	fe2kmsmin = 100.
	fe2kmsmin = 50.
	fe2kmsmin = 30.

	fe2kmsmax = 5000.

* gaussian priors (20%)
	siglnp0 = 0.2
* line window half-widths
	vblr = 3000
	vnlr = 500 
* nlr/blr window halfwidths from file
	vfile = 'ps_nlr_blr.dat'
* balfile
	balfile = 'ps_bal.dat'
	nbal = 0
* hard limits
	vbmax = 15000
	vnmax = 900
	vnmin = 300
* window half-width / mad
	sclmadn = 4.0
	sclmadb = 4.0
C 4 makes 085 too narrow
	sclmadn = 4.5
	sclmadb = 4.5
C 5 makes too many go to max
c	sclmadn = 5.0
c	sclmadb = 5.0
* window half-width / fwhm (not used)
	sclfwhm = 1.5
* window increment (km/s)
	ivdiv = 10
* max fractional change is 1/vfdiv
	vfdiv = 10
* stiff - used to separate NLR from AVG spectrum
	stiffnlr = 2.
	stiffnlr = 1.

* sigma clip thresholds
	cliphi = 6.
	cliplo = -cliphi
* agn
	iagn = 0
	agn = ' '
* sites
	nsite = 3
	nosite = 1
	name_s( 1 ) = '?'
	name_s( 2 ) = 'FTN'
	name_s( 3 ) = 'FTS'
	isymb_s( 1 ) = 23
* square
	isymb_s( 2 ) = 19
	isymb_s( 2 ) = 6
* circle
	isymb_s( 3 ) = 24
	isymb_s( 3 ) = 4
      do i = 1, nsite
	nt_s( i ) = 0
      end do

* pgplot colours
	kolor_axis = kblack
	kolor_label = kblack
	kolor_dat = kblack
	kolor_sig = kgreen

	kolor_avg = kblack
	kolor_rms = kdkgrey
	kolor_rms = kltblue

	kolor_sigrms = kyellow
	kolor_sigrms = korange
	kolor_sigrms = kcyan

	kolor_rmslines = kpurple
	kolor_rmslines = kltgrey
	kolor_fit = kdkgrey
	kolor_rmscont = kred
	kolor_cont = kred
	kolor_nlr = korange
	kolor_blr = kgreen
	kolor_bal = kpurple
	kolor_absn = kblue
	kolor_gal = 0
	kolor_fe2 = kltblue
	kolor_chi2 = kblue
	kolor_bic = kred
	kolor_dof = kblack
	kolor_hi = kgreen
	kolor_lo = korange

* lyman continuum 
	wlyc2 = 912.
* balmer continuum wavelength limits
	bac1 = 3600.
	bac2 = 3640.
* paschen continuum wavelength
	pac1 = 8000.
	pac2 = 8204.


* KDH: SHOULD ALLOW LINE LIST FROM FILES
* KDH: SHOULD GIVE EACH LINE A NAME

* UV lines ----------------------
	n = 0

* OVI
	n = n + 1
	rest_l( n ) = 1033.83d0
	line1034 = n
	line_o6 = n
* Ly alpha
	n = n + 1
	rest_l( n ) = 1215.67D0
	line1216 = n
	line_lya = n
* NV
* KDH : SHOULD USE MEAN FOR BROAD LINES
	n = n + 1
	rest_l( n ) = 1240.14d0
	line1240 = n
	line_n5 = n

      IF( .FALSE. ) THEN
	n = n + 1
	rest_l( n ) = 1238.82D0
	line1239 = n
	n = n + 1
	rest_l( n ) = 1242.80D0
	line1243 = n
      END IF
* Si IV
	label = 'Si\frIV\fn'
* KDH : USE MEAN FOR BROAD LINES
	n = n + 1
	rest_l( n ) = 1396.76d0
	line1396 = n
	line_si4 = n

      IF( .FALSE. ) THEN
	n = n + 1
	rest_l( n ) = 1393.76D0
	line1393 = n
	n = n + 1
	rest_l( n ) = 1402.77D0
	line1402 = n
      END IF
* C IV
* KDH : USE MEAN FOR BROAD LINES
	n = n + 1
	rest_l( n ) = 1549.06d0
	line1549 = n
* this puts civ label on plot
	line_c4 = n

      IF( .FALSE. ) THEN
	n = n + 1
	rest_l( n ) = 1548.20D0
	line1548 = n
	n = n + 1
	rest_l( n ) = 1550.77D0
	line1550 = n
      END IF

* He II
	n = n + 1
	rest_l( n ) = 1640.42D0
	line1640 = n
* this puts HeII label on plot
	line_1640 = n
* Al II
	n = n + 1
	rest_l( n ) = 1670.79d0
	line1670 = n
* N IV
	n = n + 1
	rest_l( n ) = 1718.55D0
	line1718 = n
* Si II
* KDH : USE MEAN FOR BROAD LINES
	n = n + 1
	rest_l( n ) = 1813.98d0
	line1813 = n
      IF( .FALSE. ) THEN
	n = n + 1
	rest_l( n ) = 1808.01D0
	line1808 = n
	n = n + 1
	rest_l( n ) = 1816.93D0
	line1816 = n
      END IF
* C III]
	n = n + 1
	rest_l( n ) = 1908.73D0
	line1909 = n
	line_c3 = n
* Mg II
	n = n + 1
	rest_l( n ) = 2798.75d0
	line2800 = n
	line_mg2 = n

* optical lines ----------------------
* vacuum wavelengths from VandenBerk et al 2001 ApJ 122, 549 Table 2.

* HI Balmer lines
* Halp (1.81A)
	n = n + 1
	linehalp = n
c	rest_l( n ) = 6562.479D0
	rest_l( n ) = 6562.80D0
	if( vacuum ) rest_l( n ) = 6564.61d0
* Hbet
	n = n + 1
	linehbet = n
	rest_l( n ) = 4861.327D0
	if( vacuum ) rest_l( n ) = 4862.68d0
* Hgam
	n = n + 1
	linehgam = n
	rest_l( n ) = 4340.465D0
	if( vacuum ) rest_l( n ) = 4341.68D0
* Hdel
	n = n + 1
	linehdel = n
	rest_l( n ) = 4101.735D0
	if( vacuum ) rest_l( n ) = 4102.89D0
* Heps
	n = n + 1
	lineheps = n
	rest_l( n ) = 3970.07D0
	if( vacuum ) rest_l( n ) = 3971.20D0

* vacuum wavelengths not available for these
	n = n + 1
	lineh6 = n
	rest_l( n ) = 3889.06d0
	if( vacuum ) rest_l( n ) = 3890.15d0
	n = n + 1
	lineh7 = n
	rest_l( n ) = 3835.40
	n = n + 1
	lineh8 = n
	rest_l( n ) = 3797.91
	n = n + 1
	lineh9 = n
	rest_l( n ) = 3770.06
	n = n + 1
	lineh10 = n
	rest_l( n ) = 3750.15        
	n = n + 1
	lineh11 = n
	rest_l( n ) = 3734.37
	n = n + 1
	lineh12 = n
	rest_l( n ) = 3721.95
	n = n + 1
	lineh13 = n
	rest_l( n ) = 3711.98
	n = n + 1
	lineh14 = n
	rest_l( n ) = 3703.86  

* HeII 4686 (1.37A)
	n = n + 1
	rest_l( n ) = 4685.65d0
	if( vacuum ) rest_l( n ) = 4687.02d0
	line4686 = n
	line_he2 = line4686
* HeI 4471 (1.28A)
	n = n + 1
	line4471 = n
	rest_l( n ) = 4471.477d0 
	if( vacuum ) rest_l( n ) = 4472.76d0
* HeI 5876 (1.63A)
	n = n + 1
	line5876 = n
	rest_l( n ) = 5875.662d0
	if( vacuum ) rest_l( n ) = 5877.29d0
	line_he1 = line5876

* OI 7774
      IF( .FALSE. ) THEN
	n = n + 1
	line7774 = n
* Eriksson and Toft (1979 A&A 71, 178)
	top = 0.0922 * 3.4 + 0.431 * 1.96 + 0.307 * 4.18 + 0.184 * 5.40
	bot = 0.0922 + 0.196 + 0.307 + 0.184
	rest = 7770 + top / bot

* Morton (1991, ApJS, 77, 119)
      if( vacuum ) then
	val8 = rest
      do i = 1, 5
	val8 = rest * ( 1.d0 + 2.735182d-4
     &	+ ( 131.4182d0 + 2.76249d8 / val8 / val8 ) / val8 / val8 )
      end do
	write(*,*) 'OI 7774 air', rest, ' vac', val8, ' dif', val8-rest
	rest = val8
      end if
	rest_l( n ) = rest
      END IF

* OI 8446 (2.2A)
	n = n + 1
	line8446 = n
	rest_l( n ) = 8446.5
	if( vacuum ) rest_l( n ) = 8448.7

* Pa zeta 9->3 (~2.5A)
	n = n + 1
	linepzet = n
	rest = pac2 * 81.d0 / ( 81.d0 - 9.d0 )
	rest_l( n ) = rest - 2.5
	if( vacuum ) rest_l( n ) = rest

* Pa eps 8->3 (~2.5A)   pac2 = 8204 => rest = 9547.6
	n = n + 1
	linepeps = n
	rest = pac2 * 64.d0 / ( 64.d0 - 9.d0 )
	rest_l( n ) = rest - 2.5
	if( vacuum ) rest_l( n ) = rest

* Pa del 7->3 (~3A)
	n = n + 1
	linepdel = n
	rest_l( n ) = 10052.1 - 3.
	if( vacuum ) rest_l( n ) = 10052.1
* HeI 10830 (3.2A)
	n = n + 1
	line10830 = n
	rest_l( n ) = 10830.20
	if( vacuum ) rest_l( n ) = 10833.2
* Pa gam 6->3 (~3A)
	n = n + 1
	linepgam = n
	rest_l( n ) = 10941.1 - 3.
	if( vacuum ) rest_l( n ) = 10941.1
* Pa bet 5->3 (3.5A)
	n = n + 1
	linepbet = n
	rest_l( n ) = 12818.1
	if( vacuum ) rest_l( n ) = 12821.6
* Pa alp 4->3 (5.1A)
	n = n + 1
	linepalp = n
	rest_l( n ) = 18751.0
	if( vacuum ) rest_l( n ) = 18756.1

* Balmer line aliases
	line_ha = linehalp
	line_hb = linehbet
	line_hg = linehgam
	line_hd = linehdel
* Paschen line aliases
	line_pa = linepalp
	line_pb = linepbet
	line_pg = linepgam
	line_pd = linepdel
	line_pe = linepeps
	line_pz = linepzet


* narrow lines (must follow broad lines) ------------------
	lastbroad = n
	narrow1 = n + 1
* HeII
	n = n + 1
	line3204 = n
	rest_l( n ) = 3203.07
	if( vacuum ) rest_l( n ) = 3204.07
	
* [NeV]
	n = n + 1
	line3346 = n
	rest_l( n ) = 3345.83d0
	if( vacuum ) rest_l( n ) = 3346.82d0
	line_ne5 = n
	n = n + 1
	line3426 = n
	rest_l( n ) = 3425.87d0
	if( vacuum ) rest_l( n ) = 3426.84d0
* [OII]
	n = n + 1
	line3727 = n
	rest_l( n ) = 3726.67d0
	if( vacuum ) rest_l( n ) = 3728.48d0
	line_o2 = n
* [NeIII]
	n = n + 1
	line3869 = n
	rest_l( n ) = 3868.75d0
	if( vacuum ) rest_l( n ) = 3869.85d0
* weaker
	n = n + 1
	line3967 = n
	rest_l( n ) = 3967.47d0
	if( vacuum ) rest_l( n ) = 3968.58d0

* [SII]
	n = n + 1
	line4069 = n
	rest_l( n ) = 4068.60d0
	if( vacuum ) rest_l( n ) = 4073.63d0
* weak line
      if( .false. ) then
	n = n + 1
	line4076 = n
	rest_l( n ) = 4076.35d0
      end if
* [OIII]
	n = n + 1
	line4363 = n
	rest_l( n ) = 4363.21d0
	if( vacuum ) rest_l( n ) = 4364.44d0

	n = n + 1
	line4959 = n
	rest_l( n ) = 4958.91D0
	if( vacuum ) rest_l( n ) = 4960.30d0

	n = n + 1
	line5007 = n
	rest_l( n ) = 5006.84D0
	if( vacuum ) rest_l( n ) = 5008.24d0
	line_o3 = n
* [NI]
	n = n + 1
	line5200 = n
	rest_l( n ) = 5199.82d0
	if( vacuum ) rest_l( n ) = 5200.53d0

* [FeVII]
	n = n + 1
	line5721 = n
	rest_l( n ) = 5721.11d0

* [FeVII]
	n = n + 1
	line6087 = n
	rest_l( n ) = 6086.92

* [OI]
	n = n + 1
	line6300 = n
	rest_l( n ) = 6300.30D0
	if( vacuum ) rest_l( n ) = 6302.05D0
	line_o1 = n

* [OI]
	n = n + 1
	line6364 = n
	rest_l( n ) = 6363.78d0
	if( vacuum ) rest_l( n ) = 6365.54d0
* [NII]
	n = n + 1
	line6548 = n
	rest_l( n ) = 6548.06D0
	if( vacuum ) rest_l( n ) = 6549.85D0

	n = n + 1
	line6583 = n
	rest_l( n ) = 6583.39D0
	if( vacuum ) rest_l( n ) = 6585.28D0
	line_n2 = n

* [SII] (1.82A)
	n = n + 1
	line6716 = n
	rest_l( n ) = 6716.47D0
	if( vacuum ) rest_l( n ) = 6718.29D0
	n = n + 1
	line6730 = n
	rest_l( n ) = 6730.85D0
	if( vacuum ) rest_l( n ) = 6732.67D0
	line_si2 = n

* [OII] (~2A)
	n = n + 1
	line7320 = n
	rest_l( n ) = 7320.9d0 - 2
	if( vacuum ) rest_l( n ) = 7320.9

* [S III] (~3A)
	n = n + 1
	line9071 = n
	rest_l( n ) = 9071.1d0 - 3
	if( vacuum ) rest_l( n ) = 9071.1

	n = n + 1
	line9533 = n
	rest_l( n ) = 9533.2d0 - 3
	if( vacuum ) rest_l( n ) = 9533.2

	line_s3 = n

* [FeII]
	n = n + 1
	line12567 = n
	rest_l( n ) = 12567.d0
	if( vacuum ) rest_l( n ) = rest_l( n ) + 3.5
	

* [SiX] (~4A)
	n = n + 1
	rest_l( n ) = 14304.9 - 4.
	if( vacuum ) rest_l( n ) = 14304.9

* [SiVI] (~5A)
      if( .false. ) then
	n = n + 1
	rest_l( n ) = 19650. - 5
	if( vacuum )rest_l( n ) = 19650.
      end if

* Br del
	n = n + 1
* Landt+2008 ApJS 174, 282.
	rest_l( n ) = 19650. - 5
	if( vacuum )rest_l( n ) = 19650.
* Kelleher+Podobedova 2008 JPCRD 37, 1285
	rest_l( n ) = 19641.
	if( vacuum )rest_l( n ) = 19646.

* narrow cores of broad lines ======================
* Lya narrow
	n = n + 1
	line1216n = n
	rest_l( line1216n ) = rest_l( line1216 )

* NIV]
	n = n + 1
	line1486 = n
	rest_l( line1486 ) = 1486.50

* C IV narrow
	n = n + 1
	line1548n = n
	rest_l( n ) = 1548.20d0
	n = n + 1
	line1550n = n
	rest_l( n ) = 1550.77d0

* He II narrow
	n = n + 1
	line1640n = n
	rest_l( n ) = rest_l( line1640 )	
* C III]
	n = n + 1
	line1909n = n
	rest_l( n ) = rest_l( line1909 )

* Ha narrow
	n = n + 1
	linehan = n
	rest_l( n ) = rest_l( line_ha )
* Hb narrow
	n = n + 1
	linehbn = n
	rest_l( n ) = rest_l( line_hb )
* Hg narrow
	n = n + 1
	linehgn = n
	rest_l( n ) = rest_l( line_hg )
* Hd narrow
	n = n + 1
	linehdn = n
	rest_l( n ) = rest_l( line_hd )
* HeII narrow
	n = n + 1
	line4686n = n
	rest_l( n ) = rest_l( line4686 )

* HeI 10830
	n = n + 1
	line10830n = n
	rest_l( n ) = rest_l( line10830 )
* Pa beta narrow
	n = n + 1
	linepbn = n
	rest_l( n ) = rest_l( line_pb )
* Pa alpha narrow
	n = n + 1
	linepan = n
	rest_l( n ) = rest_l( line_pa )

* last narrow line
	narrow2 = n

* lines to mark
	markline = narrow2

      if( markline .gt. maxline ) then
	write(*,*) '** TOO MANY LINES', markline, ' max', maxline
	stop '** PrepSpec abort.  :((('
      end if

* sort lines by rest wavelength
      do i=1,markline
	wav_l( i ) = rest_l( i )
      end do
	call quicksort( markline, wav_l, i_l )

	nbroad = 2
	narrow = 1
	nabsorp = 3

* broad lines
      do i = 1, lastbroad
	nabc(i) = nbroad
	linetype(i) = 'B'
      end do
* narrow lines
      do i = narrow1, narrow2
	nabc(i) = narrow
	linetype(i) = 'N'
      end do

* absorption lines
	nabsorp1 = 1
	nabsorp2 = 0
      do i = nabsorp1, nabsorp2
	nabc(i) = nabsorp
	linetype(i) = 'A'
      end do

* default line width expansion factors
* balmer
	expandhalp = 1.
	expandhbet = 1.
	expandhgam = 1.
	expandhdel = 1.
	expandheps = 1.
	expandbac = 0.
* He2
	expand1640 = 1
	expand4686 = 1.3
* Hei
	expand4471 = 1.
	expand5876 = 1.
* [NII]
	expand6548 = 1.
	expand6583 = 1.

* line colours
* 1   2   3   4   5   6   7   8   9   10  11  12  13  14  15
* blk red grn blu aqu mag yel orn ltg dkg ltb prp puc gry ltgry
	kolor_ha = kred
	kolor_he1 = kpurple
	kolor_hb = kblue
	kolor_he2 = kmagenta
	kolor_hg = kdkgrey
	kolor_hd = kltblue
	kolor_he = korange
	kolor_hz = kcyan
	kolor_mg2 = korange
	kolor_c3 = kred
	kolor_c4 = kblue
	kolor_si4 = kpuce
	kolor_si4 = kgreen
	kolor_n5 = kdkgrey
	kolor_lya = kred

	kolor_pa = kred
	kolor_pb = kblue
	kolor_10830 = kolor_he1
	
* narrow lines
	k = kolor_nlr
	k = kdkgrey
	kolor_ne5 = k
	kolor_o3 = k
	kolor_o2 = k
	kolor_o1 = k
	kolor_si2 = k
	kolor_n2 = k
	kolor_s3 = k

* balmer continuum
	kolor_bac = kblack
	kolor_lyc = kblack
	kolor_pac = kblack
	
* line atributes
      do i = 1, markline
	n = nabc( i )
	if( n .eq. narrow ) kolor = kolor_nlr
	if( n .eq. nbroad ) kolor = kolor_blr
	if( n .eq. nabsorp ) kolor = kolor_absn
* default label
	write( text, * ) nint( rest_l( i ) )
	if( n .eq. narrow ) call append( text, 'n' )
	if( n .eq. nbroad ) call append( text, 'b' )
	if( n .eq. nabsorp ) call append( text, 'a' )
	call nospace( text )
	kolor_l( i ) = kolor
	text_l( i ) = text
	label_l( i ) = text
	stage_l( i ) = ' '
      end do

* [NeV]
	l = line_ne5
	kolor_l( l ) = kolor_ne5
	label_l( l ) = '[Ne\frV\fn]'
* [OIII]
	l = line_o3
	kolor_l( l ) = kolor_o3
	label_l( l ) = '[O\frIII\fn]'
* [OII]
	l = line_o2
	kolor_l( l ) = kolor_o2
	label_l( l ) = '[O\frII\fn]'
* [OI]
	l = line_o1
	kolor_l( l ) = kolor_o1
	label_l( l ) = '[O\frI\fn]'
* [SiII]
	l = line_si2
	kolor_l( l ) = kolor_si2
	label_l( l ) = '[Si\frII\fn]'
* [NII]
	l = line_n2
	kolor_l( l ) = kolor_n2
	label_l( l ) = '[N\frII\fn]'

* Lya
	l = line_lya
	kolor_l( l ) = kolor_lya
	text_l( l ) = 'Lya'
	label_l( l ) = 'L\ga'
	stage_l( l ) = 'B'
* NV
	l = line_n5
	kolor_l( l ) = kolor_n5
	text_l( l ) = 'NV'
	label_l( l ) = 'N\frV\fn'
	stage_l( l ) = 'B'

* Halp
	l = line_ha
	kolor_l( l ) = kolor_ha
	text_l( l ) = 'Ha'
	label_l( l ) = 'H\ga'
	stage_l( l ) = 'B'
* Hbet
	l = line_hb
	kolor_l( l ) = kolor_hb
	text_l( l ) = 'Hb'
	label_l( l ) = 'H\gb'
	stage_l( l ) = 'B'
* Hgam
	l = line_hg
	kolor_l( l ) = kolor_hg
	text_l( l ) = 'Hg'
	label_l( l ) = 'H\gg'
	stage_l( l ) = 'B'
* Hdel
	l = line_hd
	kolor_l( l ) = kolor_hd
	text_l( l ) = 'Hd'
	label_l( l ) = 'H\gd'
	stage_l( l ) = 'B'

* Pa alpha
	l = line_pa
	kolor_l( l ) = kolor_ha
	text_l( l ) = 'Pa'
	label_l( l ) = 'P\ga'
	stage_l( l ) = 'B'
* Pa beta
	l = line_pb
	kolor_l( l ) = kolor_hb
	text_l( l ) = 'Pb'
	label_l( l ) = 'P\gb'
	stage_l( l ) = 'B'

* Pa gamma
	l = line_pg
	kolor_l( l ) = kolor_hg
	text_l( l ) = 'Pg'
	label_l( l ) = 'P\gg'
	stage_l( l ) = 'B'
* Pa delta
	l = line_pd
	kolor_l( l ) = kolor_hd
	text_l( l ) = 'Pd'
	label_l( l ) = 'P\gd'
	stage_l( l ) = 'B'

* Pa epsilon
	l = line_pe
	kolor_l( l ) = kolor_he
	text_l( l ) = 'Pe'
	label_l( l ) = 'P\ge'
	stage_l( l ) = 'B'

* Pa zeta
	l = line_pz
	kolor_l( l ) = kolor_hz
	text_l( l ) = 'Pz'
	label_l( l ) = 'P\gz'
	stage_l( l ) = 'B'

* HeI
	l = line5876
	kolor_l( l ) = kolor_he1
	text_l( l ) = 'HeI_5876'
	label_l( l ) = 'He\frI\fn'
	stage_l( l ) = 'B'

	l = line4471
	kolor_l( l ) = kolor_he1
	text_l( l ) = 'HeI_4471'
	label_l( l ) = 'He\frI\fn'
	stage_l( l ) = 'B'

	l = line10830
	kolor_l( l ) = kolor_he1
	text_l( l ) = 'HeI_10830'
	label_l( l ) = 'He\frI\fn'
	stage_l( l ) = 'B'

* HeII
      do i = 1, 2
	if( i .eq. 1 ) l = line4686
	if( i .eq. 2 ) l = line1640
	kolor_l( l ) = kolor_he2
c	text_l( l ) = 'HeII'
        if( l .eq. line4686 ) text_l( l ) = 'HeII_4686'
        if( l .eq. line1640 ) text_l( l ) = 'HeII_1640'
	label_l( l ) = 'He\frII\fn'
	stage_l( l ) = 'B'
      end do

* MgII
	l = line_mg2
	kolor_l( l ) = kolor_mg2
	text_l( l ) = 'MgII'
	label_l( l ) = 'Mg\frII\fn'
	stage_l( l ) = 'B'

* C[III]
	l = line_c3
	kolor_l( l ) = kolor_c3
	text_l( l ) = 'CIII]'
	label_l( l ) = 'C\frIII\fn]'
	stage_l( l ) = 'B'

* CIV
	l = line_c4
	kolor_l( l ) = kolor_c4
	text_l( l ) = 'CIV'
	label_l( l ) = 'C\frIV\fn'
	stage_l( l ) = 'B'

* SiIV
	l = line_si4
	kolor_l( l ) = kolor_si4
	text_l( l ) = 'SiIV'
	label_l( l ) = 'Si\frIV\fn'
	stage_l( l ) = 'B'

* [SIII]
	l = line_s3
	kolor_l( l ) = kolor_s3
	text_l( l ) = '[SIII]'
	label_l( l ) = '[S\frIII\fn]'
	stage_l( l ) = 'B'

* OI 8446
	l = line8446
	kolor_l( l ) = kolor_o1
	text_l( l ) = 'OI_8446'
	label_l( l ) = 'O\frI\fn'
	stage_l( l ) = 'B'


* KDH : SHOULD ADD ALL THE OTHER ONES BELOW

* variable line components (currently 1 line per component)
	kha = 1
	khb = 2
	k4686 = 3
	kmg2 = 4
	kc3 = 5
	k1640 = 6
	kc4 = 7
	ksi4 = 8
	kn5 = 9
	klya = 10
* ir lines
	kpa = 11
	kpb = 12
	k10830 = 13
	kpd = 14
	kpe = 15
	kpz = 16
	k8446 = 17

	ncomp = 17
	title = ' '
      do i = 1, ncomp
	nline_c( i ) = 1
	l = 0
      if( i .eq. kha ) then
	l = line_ha
	file = 'ha'
      else if( i .eq. khb ) then
	l = line_hb
	file = 'hb'
      else if( i .eq. k4686 ) then
	l = line4686
	file = 'he2_4686'
      else if( i .eq. kmg2 ) then
	l = line_mg2
	file = 'mg2'
      else if( i .eq. kc3 ) then
	l = line_c3
	file = 'c3'
      else if( i .eq. k1640 ) then
	l = line1640
	file = 'he2_1640'
      else if( i .eq. kc4 ) then
	l = line_c4
	file = 'c4'
      else if( i .eq. ksi4 ) then
	l = line_si4
	file = 'si4'
      else if( i .eq. kn5 ) then
	l = line_n5
	file = 'n5'
      else if( i .eq. klya ) then
	l = line_lya
	file = 'lya'
* IR lines
      else if( i .eq. kpa ) then
	l = line_pa
	file = 'pa'
      else if( i .eq. kpb ) then
	l = line_pb
	file = 'pb'
      else if( i .eq. kpg ) then
	l = line_pg
	file = 'pg'
      else if( i .eq. kpd ) then
	l = line_pd
	file = 'pd'
      else if( i .eq. kpe ) then
	l = line_pe
	file = 'pe'
      else if( i .eq. kpz ) then
	l = line_pz
	file = 'pz'
      else if( i .eq. k10830 ) then
	l = line10830
	file = 'he1_10830'
      else if( i .eq. k8446 ) then
	l = line8446
	file = 'o1_8446'
      end if
* stow
      if( l .gt. 0 ) then
	line_lc( 1, i ) = l
* 2022 Sep KDH : USE TEXT_L( L ) FOR FILE PREFIX
	file = text_l( l )
	file_c( i ) = file
	call append( title, file )
      end if
      end do
	write(*,*) 'VarBLR components:', ncomp, ' of max', maxc
	write(*,*) ' ', title(:len1(title))

* AGN indices -----------------------------------------------
	iarp151 = 1


	mrk6 = 2
	mrk50 = 3
	mrk290 = 4
	mrk817 = 5
	mrk335 = 6
	mrk1501 = 7

	n3227 = 8
	n3516 = 9
	n4051 = 10
	n5548 = 11
	n7469 = 12

	n5273 = 13

	ipg2130 = 14
	i3c120 = 15

	mrk352 = 16
	mrk926 = 17
	mrk1048 = 18
	mrk1298 = 19

	n4593 = 20
	n4151 = 21
	mrk876 = 22

	mcg0811 = 23
	n2617 = 24
	i3c382 = 25
	mrk374 = 26

	mrk142 = 27

* LAMP16-17 targets
	mrk841 = 28
	izw1 = 29

	nagn = 29

c	iagn = n5548
	tlist = ' '

* AGN14 targets

	n = mcg0811
	agn_a( n ) = 'MCG+08-11-011'
	zshift_a( n ) = 0.0205D0

	n = n2617
	agn_a( n ) = 'NGC 2617'
	zshift_a( n ) = 0.0142D0

	n = I3C382
	agn_a( n ) = '3C 382'
	zshift_a( n ) = 0.0579D0

	n = mrk374
	agn_a( n ) = 'Mrk 374'
	zshift_a( n ) = 0.0426D0

* LAMP16-17 targets

	n = mrk841
	agn_a( n ) = 'Mrk 841'
	zshift_a( n ) = 0.03642

	n = izw1
	agn_a( n ) = 'I Zw 1'
	zshift_a( n ) = 0.060875


* LCOGT AGN Key Project z~0.35 quasars
*    AGN     z
* 0007+00  0.315637
* 0013+00  0.362352
* 0124+14  0.339038
* 0129+14  0.364851
* 0153-10  0.360472
* 0247-07  0.352421
* 1218+02  0.327091
* 1224+04  0.357530
* 1324+03  0.305968
* 1346+09  0.336333
* 1435+02  0.304887
* 1438+02  0.375225
* 1537+05  0.306805
* 1609+05  0.338217
* 2322-09  0.370985
      if( .true. ) then
	n = nagn
	n = n + 1
	agn_a( n ) = '0007+00'
	zshift_a( n ) = 0.315637d0
	n = n + 1
	agn_a( n ) = '0013+00'
	zshift_a( n ) = 0.362352d0
	n = n + 1
	agn_a( n ) = '0124+14'
	zshift_a( n ) = 0.339038d0
	n = n + 1
	agn_a( n ) = '0129+14'
	zshift_a( n ) = 0.364851d0
	n = n + 1
	agn_a( n ) = '0153-10'
	zshift_a( n ) = 0.360472d0
	n = n + 1
	agn_a( n ) = '0247-07'
	zshift_a( n ) = 0.352421d0
	n = n + 1
	agn_a( n ) = '1218+02'
	zshift_a( n ) = 0.327091d0
	n = n + 1
	agn_a( n ) = '1224+04'
	zshift_a( n ) = 0.357530d0
	n = n + 1
	agn_a( n ) = '1324+03'
c	zshift_a( n ) = 0.305968d0
	zshift_a( n ) = 0.3043d0
	n = n + 1
	agn_a( n ) = '1346+09'
	zshift_a( n ) = 0.336333d0
	n = n + 1
	agn_a( n ) = '1435+02'
	zshift_a( n ) = 0.304887d0
	n = n + 1
	agn_a( n ) = '1438+02'
	zshift_a( n ) = 0.375225d0
	n = n + 1
	agn_a( n ) = '1537+05'
	zshift_a( n ) = 0.306805d0
	n = n + 1
	agn_a( n ) = '1609+05'
	zshift_a( n ) = 0.338217d0
	n = n + 1
	agn_a( n ) = '2322-09'
	zshift_a( n ) = 0.370985d0
	nagn = n
      end if

      if( nagn .gt. maxagn ) then
	write(*,*) '** TOO MANY AGN', nagn, ' >', maxagn, ' :(((('
	stop '** PrepSpec abort.  :((('
      end if

* Hermine Landt IRTF targets
	n = nagn
	n = n + 1
	mrk509 = n
	agn_a( n ) = 'Mrk 509'
* simbad
	zshift_a( n ) = 0.034076
* ned 
	zshift_a( n ) = 0.034397

	n = n + 1
	ifairall9 = n
	agn_a( n ) = 'Fairall 9'
* simbad
	zshift_a( n ) = 0.048175
* ned
	zshift_a( n ) = 0.047016
* floyds 2021-03
	zshift_a( n ) = 0.0455

	n = n + 1
	i1h2106m099 = n
	agn_a( n ) = '1H2106-099'
* ned
	zshift_a( n ) = 0.026515

* M.Ward target (Gamma-ray outburst)
	n = n + 1
	npks2004 = n
	agn_a( n ) = 'PKS 2004-447'
* simbad
	zshift_a( n ) = 0.24

* salt target (M.Hlabathe thesis)
	n = n + 1
	npg2304 = n
	agn_a( n ) = 'PG 2304+043'
	zshift_a( n ) = 0.042


* Mrk 279
	n = n + 1
	mrk279 = n
	agn_a( n ) = 'Mrk 279'
* simbad redshift
	zshift_a( n ) = 0.030601

* Mrk 590
	n = n + 1
	mrk590 = n
	agn_a( n ) = 'Mrk 590'
* simbad redshift
	zshift_a( n ) = 0.02609

* J2222
	n = n + 1
	j2222 = n
	agn_a( n ) = 'J2222+2745'
	zshift_a( n ) = 2.805

* PG 1119+120
	n = n + 1
	ipg1119 = n
	agn_a( n ) = 'PG 1119+120'
	zshift_a( n ) = 0.05020

* Mrk 1044
	n = n + 1
	mrk1044 = n
	agn_a( n ) = 'Mrk 1044'
	zshift_a( n ) = 0.01611

* Mrk 1239
	n = n + 1
	mrk1239 = n
	agn_a( n ) = 'Mrk 1239'
	zshift_a( n ) = 0.019927

* IC 4329
	n = n + 1
	ic4329 = n
	agn_a( n ) = 'IC 4329'
	zshift_a( n ) = 0.01514

* ESO 362-G18
	n = n + 1
	ieso362 = n
	agn_a( n ) = 'ESO 362-G18'
	zshift_a( n ) = 0.012445

	nagn = n


* AGN names and redshifts
* KDH : SHOULD ENTER THESE AS ABOVE

	agn_a( i3c382 ) = '3C 382'
	zshift_a( i3c382 ) = 0.0579d0

	agn_a( mrk374 ) = 'Mrk 374'
	zshift_a( mrk374 ) = 0.0426d0

	agn_a( n2617 ) = 'NGC 2617'
	zshift_a( mrk374 ) = 0.0142d0

	agn_a( mcg0811 ) = 'MCG+08-11-011'
	zshift_a( mrk374 ) = 0.0205d0

	agn_a( mrk876 ) = 'Mrk 876'
	zshift_a( mrk876 ) = 0.129d0

	agn_a( n4151 ) = 'NGC 4151'
	zshift_a( n4151 ) = 0.003262d0

	agn_a( n4593 ) = 'NGC 4593'
	zshift_a( n4593 ) = 0.008344d0

	agn_a( n5273 ) = 'NGC 5273'
	zshift_a( n5273 ) = 0.00342d0

	agn_a( n3227 )   = 'NGC 3227'
	zshift_a( n3227 ) = 0.003859d0
	zshift_a( n3227 ) = 0.0035d0

	agn_a( n5548 )   = 'NGC 5548'
	zshift_a( n5548 ) = 0.017175d0

	agn_a( n7469 )   = 'NGC 7469'
	zshift_a( n7469 ) = 0.01588d0
c	zshift_a( n7469 ) = 0.0165d0

	agn_a( mrk6 )    = 'Mrk 6'
	zshift_a( mrk6 ) = 0.018813d0

	agn_a( mrk50 )    = 'Mrk 50'
	zshift_a( mrk50 ) = 0.023433d0

	agn_a( mrk290 )    = 'Mrk 290'
	zshift_a( mrk290 ) = 0.02958d0
	zshift_a( mrk290 ) = 0.0305d0

	agn_a( mrk817 )    = 'Mrk 817'
	zshift_a( mrk817 ) = 0.03145d0

	agn_a( mrk1501 )    = 'Mrk 1501'
	zshift_a( mrk1501 ) = 0.0893d0

	agn_a( iarp151 ) = 'Arp 151'
	zshift_a( iarp151 ) = 0.0211d0

	agn_a( mrk335 )  = 'Mrk 335'
	zshift_a( mrk335 ) = 0.025785d0

	agn_a( n3516 )   = 'NGC 3516'
	zshift_a( n3516 ) = 0.008836d0

	agn_a( n4051 )   = 'NGC 4051'
	zshift_a( n4051 ) = 0.00234d0

	agn_a( i3c120 ) = '3C 120'
	zshift_a( i3c120 ) = 0.0330d0

	agn_a( ipg2130 ) = 'PG2130'
	zshift_a( ipg2130 ) = 0.0629d0


* AGN Key Project Targets
	agn_a( mrk352 ) = 'Mrk 352'
	agn_a( mrk926 ) = 'Mrk 926'
	agn_a( mrk1048 ) = 'Mrk 1048'
	agn_a( mrk1298 ) = 'Mrk 1298'

	zshift_a( mrk352 ) = 0.014864d0
	zshift_a( mrk926 ) = 0.04686d0
	zshift_a( mrk1048 ) = 0.04314d0
	zshift_a( mrk1298 ) = 0.0619d0


* Xiao target (Sinbad redshift)
	n = mrk142
	agn_a( n ) = 'Mrk 142'
	zshift_a( n ) = 0.04459


* welcome
	write(*,*)
	write(*,*) '**********************************************'
	write(*,*) ' Welcome to PrepSpec ! '
	write(*,*) ' Prepares AGN Spectra for MEMECHO mapping'
	write(*,*) '  Keith Horne copyright 1990 ...' 
	write(*,*) '  This Version: ', version(:len1(version))
	write(*,*) '**********************************************'
	write(*,*)


* agn menu
    1	write(*,*) 'AGN known to PREPSPEC:'
	n = (nagn+1)/2
      do i = 1, n
	k = i + n
      if( k .gt. nagn ) then
	write(*,'(I5,a,a15,a,f8.6)')
     &	i, ' ', agn_a( i ), ' z ', zshift_a( i )
* 2 columns
      else
	write(*,'(2(I5,a,a15,a,f8.6))')
     &	i, ' ', agn_a( i ), ' z ', zshift_a( i ),
     &	k, ' ', agn_a( k ), ' z ', zshift_a( k )
      end if
      end do
	call spawn( 'pwd' )

* select AGN
    2	write(*,*)
	write(*,*) 'Enter AGN name or number from table above.'
	write(*,*) ' SDSS-RM    : enter -N for RMID N=0...999'
	write(*,*) ' BHM-COSMOS : enter N C'
	write(*,*) ' BHM-SDSSRM : enter N S'
	write(*,*) ' BHM-XMMLSS : enter N X'

	write( reply, * ) iagn
	call nospace( reply )
	call inq( 'Select AGN (<-999 if not in list)', reply, reply )
	call word1( reply, l1, l2 )
	l = len1( reply )

* decode reply
c	write(*,*) 'REPLY : ', REPLY( : L )
* first word
	nword = 0
      IF( L .gt. 0 ) THEN
c	write(*,*) 'WORD1 : ', REPLY( L1 : L2 )
	nword = 1
* second word
      IF( L .GT. L2 ) THEN
	nword = 2
	CALL WORD1( REPLY( L2+1:), L3, L4 )
	l3 = l2 + l3
	l4 = l2 + l4
c	WRITE(*,*) 'WORD2 : ', REPLY( L3 : L4 )
      end if
      end if

* default to unknown agn
	i = -1000
	agn = '?'
	bhm = .false.
	sdss = .false.

* read a number
	read( reply, *, err=3 ) ival
* keep if between -999 and +999
	if( iabs( ival ) .le. 999 ) i = ival

* detect BHM field and target ID
	bhm = .false.
	ibhm = -1
	bhmfield = '?'	
* valid number (0,999) and 2 words
	yes = i .ge. 0 .and. i .le. 999 .and. nword .gt. 1
      if( yes ) then
* identify bhm field
	bhmfield = reply( l3 : l4 )
	call upcase( bhmfield, bhmfield )
      if( bhmfield(1:1) .eq. 'S' ) then
	bhmfield = 'sdssrm'
	ibhm = i
	write(*,*) 'BHM SDSSRM', i
      else if( bhmfield(1:1) .eq. 'C' ) then
	bhmfield = 'cosmos'
	ibhm = i
	write(*,*) 'BHM COSMOS', i
      else if( bhmfield(1:1) .eq. 'X' ) then
	bhmfield = 'xmmlss'
	ibhm = i
	write(*,*) 'BHM XMMLSS', i
      end if
* bhm field and target both good
	bhm = ibhm .ge. 0 .and. ibhm .le. 999
      if( bhm ) then
	write( agn, '(A,i4.4)') bhmfield(:len1(bhmfield)), ibhm
	write(*,*) 'BHM', bhm, ' Field : ', bhmfield(:len1(bhmfield)), ' ID', ibhm
      else
	bhmfield = '?'
      end if
      end if

* report
c	write(*,*) 'AGN ', agn(:len1(agn)), i, iagn

* detect SDSS target ID
	sdss = .false.
      if( .not. bhm ) then
	sdss = i .ge. -999 .and. i .le. 0
      if( sdss ) then
	i = iabs( i )
	write( agn, '(A,i3.3)' ) 'rm', i
	write(*,*) 'SDSS', sdss, ' ID', i, ' AGN ', agn(:len1(agn))
      end if
      end if

* report
c	write(*,*) 'AGN ', agn(:len1(agn)), i, iagn


* number out of range (or invalid on read)
    3	yes = i .lt. -999
* or in range of the agn table
	yes = yes .or. ( i .ge. 1 .and. i .le. nagn )
	yes = yes .or. nword .eq. 1
* and not a BHM or SDSS target
	yes = yes .and. .not. ( bhm .or. sdss )
      if( yes ) then
	write(*,*) 'Not an SDSS-RM or BHM target.'
* number in table and single word
      if( i .ge. 1 .and. i .le. nagn .and. nword .eq. 1 ) then
	iagn = i
	agn = agn_a( i )
* search for match in agn table
      else
	write(*,*) 'Check for a match in the AGN table.'
	call upcase( reply, reply )
	match = 0
      do iagn = 1, nagn
	agn = agn_a( iagn )
	call upcase( agn, agn )
c	write(*,*) l1, l2, l, ' ', reply(l1:l), ' ', agn(:len1(agn))
	k = index( agn, reply(l1:l) )
* match found
      if( k .gt. 0 ) then
	write(*,*) 'Match to AGN', iagn, ' ', agn(:len1(agn))
	i = iagn
* count matches
	match = match + 1
      end if
* next agn
      end do

* reject multiple match
      if( match .gt. 1 ) then
	write(*,*) 'Multiple match, please try again.'
	goto 2
* unique match
      else if( match .eq. 1 ) then
	agn = agn_a( i )
	iagn = i
* no match
      else
	write(*,*) 'No match found in the AGN table.'
	agn = '?'
	iagn = 0
      end if

      end if
* end yes
      end if

* user confirms or changes theAGN name
	write(*,*)
	call inq( 'AGN name:', agn, agn )
* report
	write(*,*) 'SDSS', sdss, ' BHM', bhm
	write(*,*) 'AGN ', agn(:len1(agn)), i, iagn

* set redshift and other defaults (over-ride below where needed)
	zshift = 0.
	fluxunit = 'FLAM'
	inflxdex = 0
	iflxdex = -15
	timebase = 'HJD'

      if( .not. ( sdss .or. bhm ) ) then
* agn in the list
      if( iagn .ge. 1 .and. iagn .le. nagn ) then
	zshift = zshift_a( iagn )
      end if

* SDSS-RM and BHM targets ------------------------------------
      else
	fluxunit = 'FLAM'
	inflxdex = -17
	iflxdex = -17	
	timebase = 'MJD'

* default timing file
      if( sdss ) then
	write( tlist, '(A,I3.3,A)') 'RM', i, '.mjd'
      else if( bhm ) then
	write( tlist, '(A,I4.4,A)') bhmfield(:len1(bhmfield)), i, '.mjd'
      end if

* defaults
	vnlr = 900.
	vblr = 3000.
* BLR range
	vbmax = 15000
* NLR range
	vnmax = 900. 
	vnmax = 1500.
	vnmin = 300.
* spectrophotometric calibration accuracy
	siglnp0 = 0.05
* scale error bars
	chifix = .true.

* KDH : should we turn off [NII] lines?

* default line windows
	expandbac = 0.
	expand4686 = 1.3
	expand1640 = 0.
* KDH : turn HeII 1640 on
	expand1640 = 1.3

	expand10830 = 1.
	expandpa = 1.
	expandpb = 1.
	expandpg = 1.
	expandpd = 1.
	expandpe = 1.
	expandpz = 1.

* KDH: SHOULD WE INPUT ZSHIFT, VNLR, VBLR ETC FROM A BIG FILE ?
* default linelist for sdss
      IF( .FALSE. ) THEN
      do l = 1, markline
	expand_l( l ) = 0.
      end do
	expand_l( line5007 ) = 1.
	expand_l( line4959 ) = 1.
	expand_l( linehalp ) = 1.
	expand_l( line4861 ) = 1.
	expand_l( line2800 ) = 1.
	expand_l( line1548 ) = 1.
	expand_l( line1550 ) = 1.
      END IF


* end sdss .or. bhm
      end if


* read redshift zfile from a file
	write(*,*)
	write(*,*) 'Look for a redshift file:'
	call spawn( 'head redshift*' )
	call spawn( '\rm delete_z.lis' )
	call spawn( 'ls redshift*.dat > delete_z.lis' )
	kk = maxz
	call loadlist( '@delete_z.lis', kk, zfiles )
	call spawn( '\rm delete_z.lis' )

	write(*,*) 'Redshift files found:', kk
	zfile = -1.
      do k = 1, kk
	write(*,*)
	file = zfiles( k )
	n = 1
	call loadlc1( file, 1, n, zfile )
* report
      if( n .le. 0 ) then
	write(*,*) '** NO REDSHIFT FROM FILE ', file(:len1(file))
* bad redshift
      else if( zfile .lt. 0.d0 ) then
	write(*,*) '** BAD REDSHIFT', zfile, ' IN FILE ', file(:len1(file))
* good redshift
      else
	write(*,*) 'Redshift', zfile, ' in file ', file(:len1(file))
* adopt last good redshift
	zshift = zfile
      end if
      end do

* inform user of sdss/bhm header option
      if( zshift .le. 0.d0 .and. ( sdss .or. bhm ) ) then
	write(*,*)
	write(*,*) 'Redshift ', zshift, 'probably invalid.'
	if( sdss ) write(*,*) 'ZFINAL from SDSS-RM spectrum file headlines.'
	if( bhm )  write(*,*) 'ZFINAL from BHM spectrum file headlines.'
	call spawn( 'grep ZFINAL *.dat' )
	write(*,*)
      end if

* edit redshift
	write(*,*)
	call inqd( 'Redshift:', zshift, zshift )
* a small negative redshift may still be ok

* other AGN-specific parameters
* NGC 3227
      if( iagn .eq. n3227 ) then
	tlist = 'ngc3227.hjd'
	vblr = 4800.
	vnlr = 900.
	expand4471 = 0.
	expandhgam = 1.
	expand4686 = 1.5
* Mrk 876
      else if( iagn .eq. mrk876 ) then
	tlist = 'mrk876.hjd'
	expand4686 = 0.
	expand4471 = 0.
* NGC 4151
      else if( iagn .eq. n4151 ) then
	tlist = 'n4151.hjd'
	expand4471 = 0.
	expand4686 = 0.

* NGC 4593
      else if( iagn .eq. n4593 ) then
	tlist = 'n4593.hjd'
	vnlr = 2000.
	vblr = 8000.
	expand4471 = 0.
	expandhgam = -1.
	expandhdel = -1
	expand4686 = -1.
	expand5876 = -1.

	expand6548 = 0.
	expand6583 = 0.


* NGC 5273
      else if( iagn .eq. n5273 ) then
	tlist = 'n5273.r.ss.hjd'

* NGC 5548
      else if( iagn .eq. n5548 ) then
	tlist = 'n5548.hjd'
	vnlr = 1200.
	vblr = 5000.
	expand10830 = -1.
	expandpa = -1.
	expandpb = -1.
	expandpg = -1
	expandpd = -1

* Mrk 509
      else if( iagn .eq. mrk509 ) then
	tlist = 'mrk509.hjd'
	vnlr = 1200.
	vblr = 5000.
	expand10830 = -1.
	expandpa = -1.
	expandpb = -1.
	expandpg = -1.
	expandpd = -1.
	expandpe = -1.
	expandpz = -1.

* NGC 7469
      else if( iagn .eq. n7469 ) then
	tlist = 'n7469.hjd'
	vnlr = 1200.
	vblr = 3000.
	expand4686 = 1.5
	expand4471 = 0.
	vnlr = 800.
	vblr = 2400.
	expand4686 = 2.
	expand4471 = 0.

* Mrk 6
      else if( iagn .eq. mrk6 ) then
	tlist = 'mrk6.hjd'
	vnlr = 1600
	vblr = 8000 
	expand4471 = 0.
	expand4686 = 0.
	expandhgam = 0.

* Mrk 290
      else if( iagn .eq. mrk290 ) then
	tlist = 'mrk290.hjd'
	vnlr = 900
	vblr = 4000
	expand4471 = 0.
	expand4686 = 1.5
* Mrk 335
      else if( iagn .eq. mrk335 ) then
	tlist = 'mrk335.hjd'
	vnlr = 1200
	vblr = 7000 
	expand4471 = 0.
* Mrk 817
      else if( iagn .eq. mrk817 ) then
	tlist = 'mrk817.hjd'
	vnlr = 1000
	vblr = 4200 
	expand4471 = 0.
* Mrk 841
      else if( iagn .eq. mrk841 ) then
	tlist = 'mrk841.hjd'
	expand4471 = 0.
	expand4686 = -1.2
	expandhgam = 1.
	expandhdel = 1.
* Mrk 1501
      else if( iagn .eq. mrk1501 ) then
	tlist = 'mrk1501.hjd'
	vnlr = 1500
	vblr = 7500 
	expand4471 = 0.
	expand4686 = 0.
	expandhgam = 0.
* NGC 4051
      else if( iagn .eq. n4051 ) then
	tlist = 'ngc4051.hjd'
	vnlr = 800
	vblr = 2500
	expand4471 = 0.
	expand4686 = 1.8
* NGC 3516
      else if( iagn .eq. n3516 ) then
	tlist = 'n3516.hjd'
* Mrk 352
      else if( iagn .eq. mrk352 ) then
	tlist = 'mrk352.hjd'
* Mrk 926
      else if( iagn .eq. mrk926 ) then
	tlist = 'mrk926.hjd'
	vnlr = 2000
	vblr = 5000
	vblrtweak = .false.
	vnlrtweak = .false.
	expandhalp = 1
	expandhbet = 1
	expandhgam = 0.
	expandhdel = 0.
	expandheps = 0.
	expand4686 = 0.
	expand4471 = 0.
	expand5876 = 0.

* Mrk 1048
      else if( iagn .eq. mrk1048 ) then
	tlist = 'mrk1048.hjd'
	vnlr = 1500
	vblr = 6000
	expand4686 = 0.
	expand4471 = 0.
	expandhgam = -1
	expandhdel = -1

	
* Mrk 1298
      else if( iagn .eq. mrk1298 ) then
	tlist = 'mrk1298.hjd'
* Arp 151
      else if( iagn .eq. iarp151 ) then
	tlist = 'arp151.hjd'
	expand4471 = 0.
	expand4686 = 0.
* Mrk 50
      else if( iagn .eq. mrk50 ) then
	tlist = 'mrk50.hjd'
	vnlr = 1000
	vblr = 5000
	expand4471 = 0.
	expand4686 = 1.5
	expandbac = 2
* 3C 120
      else if( iagn .eq. i3c120 ) then
	tlist = '3c120.hjd'
	vnlr = 1600
	vblr = 6500 
	expand4471 = 0.
	expand4686 = 0.
* PG2130
      else if( iagn .eq. ipg2130 ) then
	tlist = 'pg2130.hjd'
	vnlr = 1000
	vblr = 7000 
	expand4471 = 0.
	expand4686 = 0.
      end if

* over-ride default expansion factors
      do i = 1, markline
	expand_l( i ) = 1.0

* balmer lines
	if( i .eq. linehalp ) expand_l( i ) = expandhalp
	if( i .eq. linehbet ) expand_l( i ) = expandhbet
	if( i .eq. linehgam ) expand_l( i ) = expandhgam
	if( i .eq. linehdel ) expand_l( i ) = expandhdel
	if( i .eq. lineheps ) expand_l( i ) = expandheps
* He I
	if( i .eq. line4471 ) expand_l( i ) = expand4471
	if( i .eq. line5876 ) expand_l( i ) = expand5876
* He II
	if( i .eq. line4686 ) expand_l( i ) = expand4686
	if( i .eq. line1640 ) expand_l( i ) = expand1640
* [NII]
	if( i .eq. line6548 ) expand_l( i ) = expand6548
	if( i .eq. line6583 ) expand_l( i ) = expand6583
* ir lines
	if( i .eq. line10830 ) expand_l( i ) = expand10830
	if( i .eq. line_pa ) expand_l( i ) = expandpa
	if( i .eq. line_pb ) expand_l( i ) = expandpb
	if( i .eq. line_pg ) expand_l( i ) = expandpg
	if( i .eq. line_pd ) expand_l( i ) = expandpd
	if( i .eq. line_pe ) expand_l( i ) = expandpe
	if( i .eq. line_pz ) expand_l( i ) = expandpz

* disable broad high-order Balmer lines
      if( nabc( i ) .eq. nbroad ) then
	l = nint( rest_l( i ) )
	if( l .ge. 3600 .and. l .le. 4000 ) expand_l( i ) = 0.
      end if

      end do

* stow 1 + z
	OPZ = 1.D0 + zshift

* quasar images
	nq = 0

* J2222 multi-image quasar
*
* Dahle 2013 ApJ 773, 146
* dmag_AB = 0.340(7)
* dmag_AC = 0.483(12)
*
* Dryland 2019 MSc thesis
* t_AB = -42.44(+1.44,-1.36)
* t_AC = 696.65(+2.1 ,-2.0 )
* dmag_AB = 0.353
* dmag_AC = 0.515

      if( iagn .eq. j2222 ) then
	nq = 3
	name_q( 1 ) = 'A'
	name_q( 2 ) = 'B'
	name_q( 3 ) = 'C'
* tags are spectrum filename substrings identifying the image
	tag_q( 1 ) = 'qsoa'
	tag_q( 2 ) = 'qsob'
	tag_q( 3 ) = 'qsoc'
* delays align times with first image
	delay_q( 1 ) = 0.
	delay_q( 2 ) = -42.44
	delay_q( 3 ) = 696.65
* scale factors remove differential magnification
	scale_q( 1 ) = 1.
	scale_q( 2 ) = 10. ** ( 0.4 * 0.353 )
	scale_q( 3 ) = 10. ** ( 0.4 * 0.515 )
      end if

* report
      if( nq .gt. 0 ) then
c	agn = agn_a( iagn )
	write(*,*)
	write(*,*) 'AGN ', agn(:len1(agn)), ' Lensed images', nq
      do i = 1, nq
	name = name_q( i )
	delay = delay_q( i )
	scale = scale_q( i )
	fmag = -2.5 * alog10( scale )
	write(*,*) i, ' ', name(:len1(name)), delay, ' days', fmag, ' mag'
      end do
      end if

* get timing file with list of spectrum filenames and hjds

    5	write(*,*)
	write(*,*) 'Timing file : 2-column ascii file, e.g. .hjd or .mjd'
	write(*,*) ' Col 1 : spectrum filename'
	write(*,*) ' Col 2 : HJD (or MJD or other time)'

* candidate timing files:


	write(*,*)
	write(*,*) 'Candidate timing files:'
	call spawn( 'ls -l *.*jd' )

      if( tlist .eq. ' ' ) then
	call spawn( 'ls *.*jd > delete.lis' )
	call spawn( 'head delete.lis' )
	nlist = maxlist
	call loadlist( '@delete.lis', nlist, tlist_l )
	write(*,*) 'nlist', nlist
      if( nlist .ge. 1 ) then
	j = 1
      do i = 1, nlist
	tlist = tlist_l( i )
	k = len1( tlist )
	write(*,*) i, ' ', tlist(:k )
	if( k .lt. len1( tlist_l(j) ) ) j = i
      end do
* default tlist has the shortest name
	tlist = tlist_l( j )
      else
	write(*,*) 'No obvious candidates found.'
      end if
      end if

* user selects timing file
	write(*,*)
      if( nlist .gt. 0 ) then
	write(*,*) 'Enter a filename or number from the list above.'
      else
	write(*,*) 'Enter the name of your timing file.'
      end if
c	write(*,*)
    	call inq( 'Timing file : ', tlist, file )
	IF( FILE .EQ. ' ' ) GOTO 100
* pick file from the list
      if( index( file, '.' ) .le. 0 ) then
	read( file, *, err=7 ) i	
	if( i .ge. 1 .and. i .le. nlist ) file = tlist_l( i )
      end if

* read lines from the timing file
    7	n = maxlist
	call loadlist( '@'//file(:len1(file)), n, spec_in )
	write(*,*) 'Input list', n, ' of max', maxlist
	if( n .le. 0 ) goto 5
      if( n .eq. maxlist ) then
	write(*,*) '** WARNING: SPEC_IN FULL AT MAX=', MAXLIST
      end if
* stow timing file name
	timingfile = file

* input spectrum filename and hjd
	nin = n
	n = 0
      do i = 1, nin
	file = spec_in( i )
	write(*,*) i, ' ', file(:len1(file))
	call word1( file, l1, l2 )
* skip empty lines
      if( l1 .ge. 1 .and. l2 .ge. l1 ) then
* skip comment lines
      if( file(l1:l1) .ne. '!' .and. file(l1:l1) .ne. '#' ) then
* read HJD
      if( len1( file ) .gt. l2 ) then
* KDH : SHOULD TRAP ERROR HERE
	read( file(l2+1:), * ) hjd
      else
	hjd = n + 1
      end if
* stow
	n = n + 1
	hjd_in( n ) = hjd
	write(*,*) i, n, hjd, ' ', file(l1:l2)
      end if
      end if
      end do
	ninput = nin
	notime = nin - n
	write(*,*) 'Good spectra', n, ' lost', notime
	nin = n

* apply time delays
      if( nq .gt. 0 ) then
      do i = 1, nq
	nt_q( i ) = 0
      end do
      do i = 1, nin
	file = spec_in( i )
	hjd = hjd_in( i )
* image number
	iq = 0
      do j = 1, nq
	tag = tag_q( j )
	if( index( file, tag(:len1(tag)) ) .gt. 0 ) iq = j
      end do
      if( iq .gt. 0 ) then
	nt_q( iq ) = nt_q( iq ) + 1
	hjd = hjd - dble( delay_q( iq ) )
      end if
* stow
	hjd_in( i ) = hjd
      end do
* report
	write(*,*) 'Lensed images', nq
      do i = 1, nq
	name = name_q( i )
	delay = delay_q( i )
	n = nt_q( i )
	write(*,*) i, ' ', name(:len1(name)), ' epochs', n, ' delay', delay, ' days'
      end do
      end if

* sort by hjd
	n = nin
	call quicksort8( n, hjd_in, i_t )
	write(*,*) 'Times:', hjd_in( i_t( 1 ) ), hjd_in( i_t( n ) )
	write(*,*) 'Chronological sequence:'
      do j = 1, n
	i = i_t( j )
	file = spec_in( i )
	hjd = hjd_in( i )
	call word1( file, l1, l2 )
	write(*,*) i, j, hjd, ' ', file(l1:l2)
* stow in chronological order
	hjd_t( j ) = hjd
	tlist_l( j ) = file
      end do
	tlist = timingfile
	nin = n

* KDH - NO LONGER NEEDED AS TIMING FILE ALREADY LOADED
* open timing file
c	file = timingfile
c	IUNIT = 11
c	CALL OPENFILE( IUNIT, FILE, 'FORMATTED', 'OLD', IER )
c	IF( IER .NE. 0 ) GOTO 5
c	TLIST = FILE

* timebase (default is HJD)
	file = timingfile
	timebase = 'HJD'
	if( index( file, '.mjd' ) .gt. 0 ) timebase = 'MJD'
	if( index( file, '.rjd' ) .gt. 0 ) timebase = 'RJD'
	write(*,*) 'Timebase : ', timebase( :len1(timebase) )

* KDH - DO THESE AFTER READING IN ?
*------------------------------------------------------------
* HST data on 5548
	ig160m = index( tlist, 'g160m' )
	ig130m = index( tlist, 'g130m' )
	ihst = index( tlist, 'hst' )
	yes = ig160m .gt. 0 .or. ig130m .gt. 0 .or. ihst .gt. 0
      if( yes ) then
	ihst = 1
* continuum poly
	npcont = 2
* select lines
      do i = 1, lastbroad
	expand_l( i ) = 0.
      end do
	expand_l( line_lya ) = 1.
	expand_l( line_n5 ) = 1.
	expand_l( line_si4 ) = 1.
	expand_l( line_c4 ) = 1.
	expand_l( line1640 ) = 1.

	vblr = 10000.
	vnlr = 1500.
	fluxunit = 'FLAM'
	inflxdex = 0
	iflxdex = -14
      end if

*------------------------------------------------------------
* mdm data
	mdm = index( tlist, 'mdm' )
      if( mdm .ne. 0 ) then
	vblr = 10000.
	vnlr = 1200.
	fluxunit = 'FLAM'
	inflxdex = -15
	iflxdex = -15
      end if
*------------------------------------------------------------
* SDSS fluxes are 1d-17 erg/cm2/s/A
      if( sdss .or. bhm ) then
	fluxunit = 'FLAM'
	inflxdex = -17
	iflxdex = -17	
* continuum poly
	npcont = 5
* BaC off
	expandbac = 0.
* HeII off
	expand_4687 = 0.
* end sdss or bhm
      end if

* loop for spectrum input
	nbin = 1
    9	NSPEC = 0
c	IOPEN = 0

	nodata = 0

* time-sorted spectra
	in = 0
      DO ISPEC = 1, MAXSPEC
	write(*,*)
	write(*,*) '----------- Spectrum', ispec, ' of', maxspec, ' ----------'

* read spectrum file name
c   10	READ( IUNIT, '(A)', ERR=10, END=50 ) FILE
   10	in = in + 1
	if( in .gt. nin ) goto 50
	file = tlist_l( in )
	 hjd =   hjd_t( in )

* KDH : THESE SANITY CHECKS HARMLESS BUT NO LONGER NEEDED
	IF( FILE.EQ.' ' ) GOTO 10
	CALL WORD1( FILE, L1, L2 )
* skip commented lines
	IF( FILE(L1:L1) .EQ. '!' .OR. FILE(L1:L1) .EQ. '#' ) GOTO 10
* report filename
	WRITE(*,*) 'Spectrum File : ', FILE( :LEN1(FILE) )
	write(*,*) 'Chronological time:', hjd

* SDSS or BHM redshift  ----------------------------------------
      if( zshift .le. 0.d0 .and. ( sdss .or. bhm ) ) then
* redshift from file
      if( zfile .gt. 0.d0 ) then
	z = zfile
* redshift from sdss header
      else
	call sdssheader( file, z )
      end if
* sanity check
      if( z .ne. zshift ) then
	write(*,*) '** Old redshift', zshift, ' ==>', z
      if( ispec .gt. 1 ) then
	write(*,*) '** WARNING -- DIFFERENT REDSHIFTS IN SDSS FILES. :((('
	stop '** PrepSpec abort.  :((('
      end if
	zshift = z
	opz = 1.d0 + zshift
      end if
      end if

* columns of data in each spectrum file
* (faster if you set this correctly)

	LOADKRISS = 0
	LOADCOL = 3

* 4-column hst data (column 4 is data quality 0=good)
      if( ihst .ne. 0 ) then
	loadcol = 4
	if( ig130m .ne. 0 ) write(*,*) 'HST grating G130M'
	if( ig160m .ne. 0 ) write(*,*) 'HST grating G160M'
      end if

* 4-column sdss-rm spectra (column 4 is data quality 0=good)
* KDH : THERE IS A 5TH COLUMN ALSO DATA QUALITY FLAG
      if( sdss .or. bhm ) then
	loadcol = 4
	if( sdss ) write(*,*) 'SDSS-RM spectra. loadcol', loadcol
	if( bhm ) write(*,*) 'BHM spectra. loadcol', loadcol
      end if

	nbuf = 0
	NWAVE = 0
	long = 0
	longbuf = 0
	minbuf = maxbuf
* load the data from Jerry Kriss 5548 data file
      IF( LOADKRISS .NE. 0 ) THEN
	write(*,*) 'Kriss data files.'
	NWAVE = maxw
	CALL LOAD_KRISS( FILE, NWAVE, WAVE8, DATA, SIGMA,
     #	EPSILON, HJD, TITLE )
      END IF

* load 5-column ascii data
      IF( NWAVE .LE. 0 ) THEN
      IF( LOADCOL .GE. 5 ) THEN
	write(*,*) '5-column data files.'
	NWAVE = maxw
	CALL LOADLC5( FILE(L1:L2), 5, NWAVE, WAVE8, DATA, SIGMA,
     &	CONT, ABSN )

* long spectrum (input buffers full)
      if( nwave .eq. maxw ) then
	nbuf = maxbuf
	CALL LOADLC5( FILE(L1:L2), 5, nbuf, wbuf, dbuf, sbuf,
     &		cbuf, abuf )
	write(*,*) '** WARNING: LONG SPECTRUM', nbuf, ' MAX', maxw

* decode sdss data quality flag bits
* KDH : ANDMASK AND ORMASK ARE NOT CURRENTLY USED
      if( ( sdss .or. bhm ) .and. nbuf .gt. 0 ) then
	write(*,*) 'Decode SDSS ANDMASK and ORMASK'
	nbit = 28
	nbit = min( nbit, maxbit )
      do i = 1, nbuf
	m = nint( cbuf( i ) )
	call i2bits( m, nbit, andmask( 1, i ) )
	m = nint( abuf( i ) )
	call i2bits( m, nbit, ormask( 1, i ) )
      end do
      end if

* simple rebin
	needbin = 1 + ( nbuf -1 ) / maxw
      if( needbin .gt. nbin ) then
	write(*,*) '** BIN FACTOR', nbin, ' =>', needbin
	nbin = needbin
	if( ispec .gt. 1 ) goto 9
      end if
	n = 0
	nbad = 0
      do i1 = 1, nbuf-nbin+1, nbin
	sum = 0.d0
	sumw = 0.d0
	sumv = 0.d0
	sumc = 0.d0
	suma = 0.d0
	nsum = 0
	i2 = i1 + nbin - 1
      do i = i1, i2
	sumw = sumw + wbuf( i )
      if( wbuf( i ) .gt. 0. .and. sbuf( i ) .gt. 0. ) then
	nsum = nsum + 1
	sum  = sum  + dbuf( i )
* KDH : THIS MIGHT OVER/UNDER FLOW
	sumv = sumv + sbuf( i ) * sbuf( i )
	sumc = sumc + cbuf( i )
	suma = suma + abuf( i )	
      end if
      end do
* stow
	n = n + 1
	wave8( n ) = sumw / nbin
	ndiv = max( 1, nsum )
	data( n ) = sum / ndiv
	sigma( n ) = dsqrt( sumv ) / ndiv
	cont( n ) = sumc / ndiv
	absn( n ) = suma / ndiv

* KDH : SIGMA( N ) = 0 => -1 HERE? (THIS IS DONE LATER)
	if( sigma( n ) .le. 0. ) nbad = nbad + 1

* report sumv over/underflow
      if( sumv .ne. sumv ) then
	write(*,*) '** BAD SUMV', sumv, ' at LAM', wave8( n )
      end if

* next bin
      end do
	write(*,*) '** BIN FACTOR', nbin, ' to', n, ' pixels.'
	write(*,*) 'Bad pixels', nbad, ' =', nbad*100./max(1,n), ' %'
	nwave = n

* END if( nwave .eq. maxw ) then
      end if
* END IF( LOADCOL .GE. 5 ) 
      END IF

* divide by absorption spectrum and fake the epsilon array
      IF( NWAVE .GT. 0 ) THEN
      DO I = 1, NWAVE
	EPSILON(I) = -1000.
      IF( ABSN(I) .GT. 0. ) THEN
	DATA(I) = DATA(I) / ABSN(I)
	SIGMA(I) = SIGMA(I) / ABSN(I)
	IF( SIGMA(I) .GT. 0. ) EPSILON(I) = 1000.
      END IF
      END DO
	WRITE(*,*) ' data divided by absorption spectrum.'
      END IF

* load 4-column ascii data
      IF( NWAVE .LE. 0 ) THEN
      IF( LOADCOL .GE. 4 ) THEN
	write(*,*) '4-column data files.'
	NWAVE = maxw
	CALL LOADLC4( FILE(L1:L2), 4, NWAVE, WAVE8, DATA, SIGMA, EPSILON )

* KDH: 2022-05-05 - disable since files are now OK.
      IF( .FALSE. ) THEN
* KDH: 2021-09 - J.Trump's 4-column spectra have variances in column 3
      if( bhm .or. ( sdss .and. file(L1:L1) .eq. 's' ) ) then
      do i = 1, nwave
	s = sigma( i )
	if( s .gt. 0. ) sigma( i ) = sqrt( s )
      end do
	write(*,*) '** WARNING: Column 3 variance -> sigma.'
      end if
      END IF

* decode sdss pixel bits
* KDH: ANDMASK NOT CURRENTLY USED
      if( ( sdss .or. bhm ) .and. nwave .gt. 0 ) then
	write(*,*) 'Decode SDSS ANDMASK'
	nbit = 28
	nbit = min( nbit, maxbit )
      do i = 1, nwave
	m = nint( epsilon( i ) )
	call i2bits( m, nbit, andmask( 1, i ) )
      if( i .eq. 1 ) then
	mx = m
	mn = m
      end if
	mx = max( mx, m )
	mn = min( mn, m )
      end do

* report
	m = mn
      do k = 1, 2
	title = ' '
	call i2bits( m, nbit, bits )
      do i = nbit, 1, -1
	if( mod( i, 5 ) .eq. 0 ) call append( title, '.' )
      if( bits( i ) ) then
	call append( title, '1' )
      else
	call append( title, '0' )
      end if
      end do
	call nospace( title )
	write(*,*) ' ', title(:len1(title)), ' =', m
	m = mx
      end do

      end if

* long spectrum
      if( nwave .eq. maxw ) then
	nbuf = maxbuf
	CALL LOADLC4( FILE(L1:L2), 4, nbuf, WBUF, DBUF, SBUF, EBUF )
	write(*,*) '** WARNING: LONG SPECTRUM', nbuf, ' MAX', maxw

* simple rebin
	needbin = 1 + ( nbuf -1 ) / maxw
      if( needbin .gt. nbin ) then
	write(*,*) '** BIN FACTOR', nbin, ' =>', needbin
	nbin = needbin
	if( ispec .gt. 1 ) goto 9
      end if
	n = 0
	nbad = 0
      do i1 = 1, nbuf-nbin+1, nbin
	sum = 0.d0
	sumw = 0.d0
	sumv = 0.d0
	sume = 0.d0
	nsum = 0
	i2 = i1 + nbin - 1
      do i = i1, i2
	sumw = sumw + wbuf( i )
      if( wbuf( i ) .gt. 0. .and. sbuf( i ) .gt. 0. ) then
	nsum = nsum + 1
	sum  = sum  + dbuf( i )
	sumv = sumv + sbuf( i ) * sbuf( i )
	sume = sume + ebuf( i )	
      end if
      end do
* stow
	n = n + 1
	wave8( n ) = sumw / nbin
	ndiv = max( 1, nsum )
	data( n ) = sum / ndiv
	sigma( n ) = dsqrt( sumv ) / ndiv
	epsilon( n ) = sume / ndiv

* report sumv over/underflow
      if( sumv .ne. sumv ) then
	write(*,*) '** BAD SUMV', sumv, ' at LAM', wave8( n )
      end if

* HST and SDSS-RM data have data quality in column 4 (0=good)
      if( ( sdss .or. bhm ) .or. ihst .ne. 0 ) then
      if( sume .eq. 0.d0 ) then
	epsilon( n ) = 1000.
      else
	sigma( n ) = - abs( sigma( n ) )
	epsilon( n ) = -1000.
      end if
      end if
	if( sigma( n ) .le. 0. ) nbad = nbad + 1
* next bin
      end do
	write(*,*) '** BIN FACTOR', nbin, ' to', n, ' pixels.'
	write(*,*) 'Bad pixels', nbad, ' =', nbad*100./max(1,n), ' %'
	nwave = n

      end if

* END IF( LOADCOL .GE. 4 )
      END IF

* load 3-column ascii data
      IF( NWAVE.LE.0 ) THEN
      IF( LOADCOL .GE. 3 ) THEN
	write(*,*) '3-column data files.'
	NWAVE = maxw
	CALL LOADLC3( FILE(L1:L2), 3, NWAVE, WAVE8, DATA, SIGMA )


* Jon Trump provided 3-column with 1/sig^3 in column 3
* convert inverse-variance to error bar
      if( bhm .and. nwave .gt. 0 ) then
	write(*,*) '3-column SDSS spectra from J.Trump'
	write(*,*) 'Convert 1/variance to sigma. Nw', nwave
	call mnmx( nwave, sigma, smn, smx )
      do i = 1, nwave
	s = sigma( i )
      if( s .gt. 0. ) then
	s = sqrt( 1. / s )
      else
	s = -1.
      end if
	sigma( i ) = s
      end do
	write(*,*) ' 1/variance', smn, smx
	call mnmx( nwave, sigma, smn, smx )
	write(*,*) 'sigma(flux)', smn, smx
      end if



* long spectrum
      if( nwave .eq. maxw ) then
	nbuf = maxbuf
	CALL LOADLC3( FILE(L1:L2), 3, nbuf, wbuf, dbuf, sbuf )
	write(*,*) '** WARNING: LONG SPECTRUM', nbuf, ' MAX', maxw


* simple rebin
	needbin = 1 + ( nbuf -1 ) / maxw
      if( needbin .gt. nbin ) then
	write(*,*) '** BIN FACTOR', nbin, ' =>', needbin
	nbin = needbin
	if( ispec .gt. 1 ) goto 9
      end if
	n = 0
      do i1 = 1, nbuf-nbin+1, nbin
	sum = 0.d0
	sumw = 0.d0
	sumv = 0.d0
	nsum = 0
	i2 = i1 + nbin - 1
      do i = i1, i2
	sumw = sumw + wbuf( i )
      if( wbuf( i ) .gt. 0. .and. sbuf( i ) .gt. 0. ) then
	nsum = nsum + 1
	sum  = sum  + dbuf( i )
	sumv = sumv + sbuf( i ) * sbuf( i )
      end if
      end do
* stow
	n = n + 1
	wave8( n ) = sumw / nbin
	ndiv = max( 1, nsum )
	data( n ) = sum / ndiv
	sigma( n ) = dsqrt( sumv ) / ndiv

* report sumv over/underflow
      if( sumv .ne. sumv ) then
	write(*,*) '** BAD SUMV', sumv, ' at LAM', wave8( n )
      end if
* next bin
      end do
	write(*,*) '** BIN FACTOR', nbin, ' to', n, ' pixels.'
	nwave = n
      end if

* END IF( LOADCOL .GE. 3 )
      END IF

* load 2-column ascii data
      IF( NWAVE.LE.0 ) THEN
      IF( LOADCOL .GE. 2 ) THEN
	write(*,*) '2-column data files.'
	NWAVE = maxw
	CALL LOADLC2( FILE(L1:L2), 2, NWAVE, WAVE8, DATA )
* long spectrum
      if( nwave .eq. maxw ) then
	nbuf = maxbuf
	CALL LOADLC2( FILE(L1:L2), 2, nbuf, WBUF, DBUF )
	write(*,*) '** WARNING: LONG SPECTRUM', nbuf, ' MAX', maxw

* simple rebin
	needbin = 1 + ( nbuf -1 ) / maxw
      if( needbin .gt. nbin ) then
	write(*,*) '** BIN FACTOR', nbin, ' =>', needbin

* KDH : SHOULD WE RE-BIN PREVIOUS SPECTRA AT THIS POINT ?

	nbin = needbin
	if( ispec .gt. 1 ) goto 9
      end if
	n = 0
      do i1 = 1, nbuf-nbin+1, nbin
	sum = 0.d0
	sumw = 0.d0
	nsum = 0
	i2 = i1 + nbin - 1
      do i = i1, i2
	sumw = sumw + wbuf( i )
      if( wbuf( i ) .gt. 0. ) then
	nsum = nsum + 1
	sum  = sum  + dbuf( i )
      end if
      end do
* stow
	n = n + 1
	wave8( n ) = sumw / nbin
	data( n ) = sum / max( 1, nsum )
* next bin
      end do
	write(*,*) '** BIN FACTOR', nbin, ' to', n, ' pixels.'
	nwave = n
      end if

* END IF( LOADCOL .GE. 2 )
      END IF

      IF( NWAVE.LE.0 ) THEN
	WRITE(*,*) '** FAILED TO READ FILE ', FILE(:LEN1(FILE))
	GOTO 10
      END IF
* fake error bars
	CALL SIGFAKE( NWAVE, DATA, SIGMA )

* END IF( NWAVE.LE.0 )
      END IF

* bad data mask
      DO I=1,NWAVE
	EPSILON(I) = 1000.
	IF( SIGMA(I) .LE. 0. ) EPSILON(I) = -1000.
      END DO
* END IF( NWAVE.LE.0 )
      END IF
* END IF( NWAVE .LE. 0 )
      END IF


* fix zero sigmas
      if( nwave .gt. 0 ) then
	nfix = 0
      do i = 1, nwave
      if( sigma( i ) .eq. 0. ) then
	nfix = nfix + 1
	sigma( i ) = -1.
	w = wave8( i )
	d = data( i )
	write(*,*) '** SIG=0 => -1 AT PIX', i, ' LAM', w, ' DAT', d
      end if
      end do
      if( nfix .gt. 0 ) then
	write(*,*) '** SIG=0 PIXELS FIXED', NFIX
      end if
      end if

	long = max( long, nwave )
	longbuf = max( longbuf, nwave, nbuf )
	minbuf = min( minbuf, max( nwave, nbuf ) )


* filename and JD from timing file
	WRITE(*,*) FILE

* stow title 
c	TITLE = FILE(:LEN1(FILE))
* keep filename but omit HJD (can be added later on plots)
	CALL WORD1( FILE, L1, L2 )
	TITLE = FILE( L1 : L2 )

* HJD from timing file
	NUMBER = FILE(L2+1:)
	CALL WORD1( NUMBER, L1, L2 )

	IER = 1
      IF( L1 .GT. 0 ) THEN
	READ( NUMBER, *, ERR=11, end=11 ) HJD
	IF( HJD .GT. 0.D0 ) IER = 0
      END IF

   11 IF( IER .NE. 0 ) THEN
	WRITE(*,*) '** FAILED TO READ TIME FROM FILE ', FILE(:LEN1(FILE))
	HJD = NSPEC+1
      END IF

* END IF( NWAVE .LE. 0 )
      END IF

* HJD from chronological list
	diff = hjd - hjd_t( in )
      if( diff .ne. 0. ) then
	write(*,*) 'HJD', hjd
	hjd = hjd_t( in )
	write(*,*) 'HJD', hjd, ' diff', diff
      end if

* report
	n = int( hjd )
	WRITE(*,*) 'input ', timebase(:len1(timebase))
     &		, '=', HJD, ' =', n, ' +', hjd - n
* fix hjd
	if( n .ge. 1000 .and. n .lt. 10000 ) hjd = hjd + 2440000
	if( n .ge. 10000 .and. n .lt. 100000 ) hjd = hjd + 2400000
	n = int( hjd )
	WRITE(*,*) 'fixed ', timebase(:len1(timebase))
     &		, '=', HJD, ' =', n, ' +', hjd - n

      IF( JDSUB .LE. 0 ) THEN
	JDSUB = NINT( HJD - MOD( HJD, 1.D4 ) )
	write(*,*) 'nint(', hjd, ' -', mod( hjd, 1d4 ), ' ) =', jdsub
	JD0 = 0
	IF( JDSUB.GE.1000 .AND. JDSUB.LT.10000 ) JD0 = JDSUB +   2440000
	IF( JDSUB.LT.10000 ) JD0 = JDSUB +   2440000
	IF( JDSUB.GE.10000 .AND. JDSUB.LT.100000 ) JD0 = JDSUB + 2400000
	IF( JDSUB.GE.100000 .AND. JDSUB.LT.1000000) JD0 = JDSUB +2000000
      END IF
* truncate hjd
	HJD = HJD - JDSUB
	WRITE(*,*) 'JDSUB : ', JDSUB, ' JD0', JD0, ' THJD', HJD

* scale factor (lensed quasar image)
	scale = 1.
      if( nq .gt. 0 ) then
	iq = 0
      do i = 1, nq
	tag = tag_q( i )
	if( index( file, tag(:len1(tag)) ) .gt. 0 ) iq = i
      end do
      if( iq .gt. 0 ) then
	name = name_q( iq )
	scale = scale_q( iq )
	write(*,*) 'Quasar image ', name(:len1(name)), ' scale', scale
      end if
      end if

* scale factor (from timing file )
      IF( L1.GT.0 .AND. L2 .LT. LEN1( NUMBER ) ) THEN
	NUMBER = NUMBER(L2+1:)
	READ( NUMBER, *, ERR=12, end=12 ) VAL
	IF( VAL .GT. 0. ) SCALE = VAL
      end if

* apply scale fctor

   12 IF( SCALE.NE.1. ) THEN
      DO I=1,NWAVE
	DATA(I)  =  DATA(I) * SCALE
	SIGMA(I) = SIGMA(I) * SCALE
      END DO
	WRITE(*,*) 'DATA AND SIGMA SCALED BY FACTOR : ', SCALE
      END IF

* seeing ( from timing file )
	CALL WORD1( NUMBER, L1, L2 )
      IF( L1.GT.0 .AND. L2 .LT. LEN1( NUMBER ) ) THEN
	SEE = 0.
	NUMBER = NUMBER(L2+1:)
	READ( NUMBER, *, ERR=13, end=13 ) VAL
	IF( VAL .GT. 0. ) SEE = VAL
   13	WRITE(*,*) 'SEEING: ', SEE
      END IF

* airmass ( from timing file )
	CALL WORD1( NUMBER, L1, L2 )
      IF( L1.GT.0 .AND. L2 .LT. LEN1( NUMBER ) ) THEN
	AIR = 0.
	NUMBER = NUMBER(L2+1:)
	READ( NUMBER, *, ERR=14, end=14 ) VAL
	IF( VAL .GT. 0. ) AIR = VAL
   14	WRITE(*,*) 'AIRMASS: ', AIR
      END IF

* KDH : May need to check logic of the if blocks
c      END IF
c      END IF


* trap and repair nan
      do i=1,nwave
	dat = data( i )
	sig = sigma( i )
	yes = isnan( dat ) .or. isnan( sig )
      if( yes ) then
	if( isnan( dat ) ) dat = 0.
      if( sig .eq. sig ) then
	sig = - abs( sig )
      else
	sig = -1.	
      end if
	data( i ) = dat
	sigma( i ) = sig
	epsilon( i ) = 0.
      end if	
      end do


	WRITE(*,*) 'NWAVE=', NWAVE, WAVE8(1), WAVE8(NWAVE)

* convert micron wavelengths  to Angstroms
      if( wave8( nwave ) .lt. 100. .and. wave8( 1 ) .lt. 100. ) then
	write(*,*) '** Convert micron wavelengths to Angstroms'
      do i = 1, nwave
	wave8( i ) = wave8( i ) * 1e4
      end do
	WRITE(*,*) 'NWAVE=', NWAVE, WAVE8(1), WAVE8(NWAVE)
      end if


* real*4 wavelengths
   15 do i = 1, nwave
	wave(i) = wave8(i)
      end do

* check monotonic wavelengths
	iup = 1
	if( wave8( nwave ) .lt. wave8( 1 ) ) iup = -1
      do i = 1, nwave
	ip = max( 1, min( nwave, i + iup ) )
	im = max( 1, min( nwave, i - iup ) )
      if( wave8( i ) - wave8( im ) .lt. 0.d0 ) then
	write(*,*) '** WAVELENGTHS NOT MONOTONIC. :(((('
	write(*,*) im, wave8( im ), wave( im )
	write(*,*)  i, wave8( i  ), wave( i  )
	write(*,*) ip, wave8( ip ), wave( ip )
	stop '** PrepSpec abort.  :((('
      end if
      if( wave( i ) - wave( im ) .lt. 0. ) then
	write(*,*) '** REAL*4 WAVELENGTHS NOT MONOTONIC. :(((('
	write(*,*) im, wave8( im ), wave( im )
	write(*,*)  i, wave8( i  ), wave( i  )
	write(*,*) ip, wave8( ip ), wave( ip )
	stop '** PrepSpec abort.  :((('
      end if
      end do
	write(*,*) '** Wavelengths ascend. :).'

* dispersions
      do i = 1, nwave
	im = max( i - 1, 1 )
	ip = min( im + 1, nwave )
	im = max( ip - 1, 1 )
	dang = ( wave8( ip ) - wave8( im ) ) / max( 1, ip - im )
	plot2( i ) = dang
	plot3( i ) = ckms * dang / wave8( i )
      end do
	call mnmx( nwave, plot2, dmn, dmx )
	call mnmx( nwave, plot3, vmn, vmx )
	write(*,*) ' (A/pix)', dmn, dmx, ' km/s/pix', vmn, vmx

* find dispersion jumps
	njump = 0
	k = 0
      do i = 1, nwave
* median of nearby dispersions
	ip3 = min( i + 3, nwave )
	im3 = max( i - 3, 1 )
	call medmad( ip3-im3+1, plot2(im3), dmed, dmad )
* dispersion jump
	ip = min( i + 1, nwave )
	im = max( i - 1, 1 )
	test = plot2( i ) - plot2( im )
      if( abs(test) .gt. 0.2 * dmed ) then
	njump = njump + 1
	write(*,*) '** DISPERSION JUMP', i, test, ' A/pix', nint(100*test/dmed), ' % :(((('
* 2023-Mar-10 KDH: display wider range around the jump
      IF( .TRUE. ) THEN
      do j = im3, ip3
	write(*,*) j , wave( j ), plot2( j ), plot2( j ) / dmed
      end do
      ELSE
	if( im .ne. i ) write(*,*) im, wave( im ), plot2( im ), plot2( im ) / dmed
	write(*,*) i , wave( i ), plot2( i ), plot2( i ) / dmed
	if( ip .ne. i ) write(*,*) ip, wave( ip ), plot2( ip ), plot2( ip ) / dmed
      END IF
      end if

* repair missing pixels
	pix = plot2( i ) / dmed - 1.
	ipix = nint( pix )
      if( ipix .ne. 0 .and. abs( pix - ipix ) .lt. 0.02 ) then
	i1 = i
	if( i1 .eq. 1 ) i1 = 2
	lost = iabs( ipix )
	write(*,*) 'Pixel gap', pix, lost, ' before pixel', i1, wave( i1 )
* evacuate gap
	nwnew = nwave + lost
	i1new = i1 + lost
      do k = nwnew, i1new, -1
	j = k - lost
	wave8( k ) = wave8( j )

	data( k ) = data( j )
	sigma( k ) = sigma( j )
	cont( k ) = cont( j )
	absn( k ) = absn( j )
	epsilon( k ) = epsilon( j )

      end do
	write(*,*) 'wave(', i1, nwave, ' ) => wave(', i1new, nwnew, ' )'

* fill gap
      do j = 1, lost
	k = i1new - j
	wave8( k ) = wave8( i1new ) - j * iup * dmed
	write(*,*) j, ' wave8(', k, ') <= ', wave8( k )

* could do something fancier here:
	data( k ) = data( i1new )
	sigma( k ) = - abs( sigma( i1new ) )
	cont( k ) = cont( i1new )
	absn( k ) = absn( i1new )
	epsilon( k ) = -1000.

      end do
	write(*,*) 'Nw', nwave, ' =>', nwnew
	nwave = nwnew
	write(*,*) ' ---- gap filled. Restart gap search.'
	goto 15
      end if

* next wavelength
      end do

* report
	write(*,*) '** DISPERSION JUMPS', njump, ' REMAIN IN SPECTRUM', ispec
* stow
	njump_t( ispec ) = njump

* plot dispersion jumps
	yes = .false.
      if( njump .gt. 0 .and. yes ) then

   16	call pgstart( 1, 1, notused )
	call pgbgw
	lwide = lwidedef
	csize = csizedef
	call pgslw( lwide )
	call pgsch( csize )

	call mnmx( nwave, wave, xmn, xmx )
	call mnmx( nwave, plot2, ymn, ymx )
	add = 0.05 * ( ymx - ymn )
	ymx = ymx + add
	ymn = ymn - add
	add = 0.05 * ( xmx - xmn )
	xmx = xmx + add
	xmn = xmn - add
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	xlabel = '\gl (\A)'
      if( zshift .ne. 0.d0 ) then
	call append( xlabel, 'z =' )
	call append_f( xlabel, real(zshift), '(f15.4)' )
      end if
	ylabel = 'Dispersion (\A/pix)'
c	title = file( :len1(file) )
	call pglabel( xlabel, ylabel, title )
	call pgmtxt( 't', 0.5, 0., 0., agn(:len1(agn)) )
	call pgbin( nwave, wave, plot2, .true. )
	call pgstop
	if( pgagain() ) goto 16
      end if


* count good data points (and note plot limits)

	NGOOD = 0
      DO I=1,NWAVE
      IF( SIGMA(I) .GT. 0. ) THEN
	NGOOD = NGOOD + 1
      IF( NGOOD.EQ.1 ) THEN
	DMN = DATA(I)
	DMX = DMN
	WMN = WAVE(I)
	WMX = WMN
	smn = sigma(i)
	smx = smn
      ELSE
	DMN = MIN( DMN, DATA(I) )
	DMX = MAX( DMX, DATA(I) )
	WMN = MIN( WMN, WAVE(I) )
	WMX = MAX( WMX, WAVE(I) )
	smn = min( smn, sigma(i) )
	smx = max( smx, sigma(i) )
      END IF
      END IF
      END DO

* report
	nbad = nwave - ngood
	pct = nbad * 100. / max( 1, nwave )
	WRITE(*,*) ' Bad data:', nbad, ' of', nwave, pct, ' %'
	pct = ngood * 100. / max( 1, nwave )
	WRITE(*,*) 'Good data:', NGOOD, ' of', nwave, pct, ' %'
* stow
	nbadpix_t( ispec ) = nbad
	npix_t( ispec ) = nwave

* skip bad spectra
	mingood = 1
	badpixpercent = 50.
	pctmin = 20.
	pctmin = badpixpercent
      if( ngood .le. mingood .or. pct .lt. pctmin ) then
      if( ngood .le. mingood ) then
	write(*,*) '** NO DATA FOR INPUT SPECTRUM', ispec, ' :(((('
	write(*,*) '** ngood', ngood, ' min', mingood
      else
	write(*,*) '** INSUFFICIENT DATA FOR INPUT SPECTRUM', ispec, ' :(((('
	write(*,*) '** % good data ', pct, ' min', pctmin
      end if
	call mnmx( nwave, data, dmn, dmx )
	call mnmx( nwave, sigma, smn, smx )
	write(*,*) ' dat', dmn, dmx, ' sig', smn, smx
	write(*,*) '** SKIPPING THIS SPECTRUM.'
	nodata = nodata + 1
      else
	write(*,*) ' dat', dmn, dmx, ' sig', smn, smx

* fake error bars
c	CALL SIGFAKE( NWAVE, DATA, FAKESIGMA )
	
* stow good spectrum

	NSPEC = NSPEC + 1
      DO I = 1, NWAVE
	DATPIC( I, NSPEC ) = DATA( I )
	SIGPIC( I, NSPEC ) = SIGMA( I )
	EPSPIC( I, NSPEC ) = EPSILON( I )
	WAVPIC8( I, NSPEC ) = WAVE8( I )
	CONPIC( I, NSPEC ) = CONT( I )
	ABSPIC( I, NSPEC ) = ABSN( I )
	SIGJITPIC( I, NSPEC ) = 0.
	SIGPIXPIC( I, NSPEC ) = 0.
	IM = MAX( I-1, 1 )
	IP = MIN( I+1, NWAVE )
	SLOPE = ( DATA(IP) - DATA(IM) ) / MAX(1,IP-IM)
	DDATDPIXPIC( I, NSPEC ) = SLOPE
      END DO

* specname is the input file name (previously stowed in TITLE)
c	SPECNAME( NSPEC ) = TITLE
	call word1( file, l1, l2 )
	SPECNAME( NSPEC ) = file( l1 : l2 )
	nw_t( NSPEC ) = NWAVE
	TIME( NSPEC ) = HJD
	time8( nspec ) = hjd

	WRITE(*,*) 'INPUT SPECTRUM', ISPEC, ' STOWED SPECTRUM', NSPEC
	
      end if

* report
	nt = nspec
	nw = nw_t( nt )
	hjd = time8( nt )
	write(*,*) 'Nt', nt, ' ', timebase(:len1(timebase)), hjd
	write(*,*) 'Nw', nw, wavpic8( 1, nt ), wavpic8( nw, nt )

* next spectrum ispec
      END DO

* report
	write(*,*) '** WARNING: SPECTRUM BUFFER FULL.  :(((.'
	write(*,*) '** MAXIMUM SPECTRA', MAXSPEC
	write(*,*) 'Count lost spectra:'

* report lost spectra
	LOST = 0
   48	READ( IUNIT, '(A)', ERR=499, END=49 ) FILE
	IF( FILE.EQ.' ' ) GOTO 48
	CALL WORD1( FILE, L1, L2 )
	IF( FILE(L1:L1) .EQ. '!' .OR. FILE(L1:L1) .EQ. '#' ) GOTO 48
	LOST = LOST + 1
	GOTO 48
  499	write(*,*) '** ERROR READING FROM TIMING FILE.'
	GOTO 48

   49 if( lost .gt. 0 ) then
	WRITE(*,*) '** WARNING: SPECTRA', nspec+lost,
     &		' MAX', maxspec, ' LOST', lost
      end if
	lostspec = lost

* close spectrum file
   50	write(*,*)
	write(*,*) '------ Last Spectrum', nspec, ' of max', maxspec, ' ----------'


* report lost input spectra with no times or no data
	write(*,*)
	write(*,*) '-------------------------------------------------'
	write(*,*) '** LOST SPECTRA (NO TIME):', notime, ' of', ninput
	write(*,*) '** LOST SPECTRA (NO DATA):', nodata, ' of', ninput
	write(*,*) '   max bad pixels', nint( badpixpercent ), ' %'
	write(*,*) '** KEPT SPECTRA (  GOOD ):', nspec, ' of', ninput
	write(*,*)
	WRITE(*,*) 'Spectra', NSPEC, ' Input Npix', minbuf, longbuf, ' max', maxbuf


* report lost pixels
      if( longbuf .gt. maxbuf ) then
	lost = longbuf - maxbuf
	write(*,*) '** WARNING: LAMBDAS', longbuf,
     &		' MAX', maxbuf, ' LOST', lost
      end if

	if( nbin .ne. 1 ) write(*,*) '** WARNING: INPUT SPECTRA BINNED BY FACTOR', nbin

* report lost wavelengths
      if( long .gt. maxwave ) then
	lost = long - maxwave
	write(*,*) '** WARNING: LAMBDAS', long,
     &		' MAX', maxwave, ' LOST', lost
      end if

* report uneven nwave
	call mnmxi( nt, nw_t, nwmn, nwmx )
      if( nwmn .ne. nwmx ) then
	write(*,*)
	write(*,*) '** WARNING: UNEVEN SPECTRUM NPIX', nwmn, nwmx
	im = 1
	call word1( specname( im ), l1, l2 )
	l = len1( specname( im ) )
	nw = nw_t(im)
	lam1 = wavpic8(1,im)
	lam2 = wavpic8(nw,im)
	write(*,*) 'Nw', nw, ' (', lam1, lam2, ') ', specname(im)(:l2)
      do i = 2, nt
	nw = nw_t(i)
      if( nw .ne. nw_t(im) ) then
	lam1 = wavpic8(1,i)
	lam2 = wavpic8(nw,i)
	call word1( specname( im ), l1, l2 )
	l = len1( specname( i ) )
	write(*,*) 'Nw', nw, ' (', lam1, lam2, ') ', specname(i)(:l2)
	im = i
      end if
      end do
      end if

* report spectra with bad pixels
	ibad = 0
      do i = 1, nt
	nw = nw_t( i )
	nbad = 0
      do iw = 1, nw
	s = sigpic( iw, i )
	if( s .le. 0. ) nbad = nbad + 1
      end do
	nbadpix_t( i ) = nbad
	if( nbad .gt. 0 ) ibad = ibad + 1
      end do
	write(*,*)
	write(*,*) '** Spectra with bad pixels:', ibad, ' of', nt
      if( ibad .gt. 0 ) then
	call quicksorti( nt, nbadpix_t, i_t )
      do ir = nt, 1, -1
	i = i_t( ir )
	nbad = nbadpix_t( i )
      if( nbad .gt. 0 ) then
	nw = nw_t( i )
	pct = nbad * 100. / nw 
	call word1( specname(i), l1, l2 )
	write(*,*) '** Spec', i, ' ', specname(i)(:l2)
	write(*,*) '   Bad Pix', nbad, ' of', nw, ' = ', nint(pct), ' %'
      end if
      end do
      end if

* report buffer use
	write(*,*)
	write(*,*) 'Nt', nspec, ' of max', maxspec
     &		, ' =', nspec*100./maxspec, ' %'
	write(*,*) 'Nw range', nwmn, nwmx, ' of max', maxwave
     &		, ' =', nwmx*100./maxwave, ' %'
	n = nwmx * nspec
	m = maxwave * maxspec
	write(*,*) 'Nw x Nt', n, ' of max', m, ' =', n*100./m, ' %'

* prefix for output files
      if( agn .ne. ' ' ) then
	prefix = agn
	call nospace( prefix )
      end if

* report dispersion jumps
	nt = nspec
	call mnmxi( nt, njump_t, jmn, jmx )
	write(*,*) 'Unrepaired dispersion jumps:', jmn, jmx
      if( jmx .gt. jmn ) then
	n = 20
      do i = 1, nt, n
	title = ' '
	call append_i( title, i )
	call append( title, ':' )
      do j = i, min( i + n - 1, nt )
	call append_i( title, njump_t( j ) )
      end do
	write(*,*) title( : len1( title ) )
      end do
      end if

* sanity-check times

	n = 0
      do i = 2, nt
	im = max( 1, i - 1 )
      if( time8(i) .le. time8(im) ) then
	n = n + 1
	if( n .eq. 1 ) write(*,*) '** WARNING: TIMES OUT OF ORDER :((('
	write(*,*) '** Old', time8(im), ' ', specname(im)(:len1(specname(im)))
	write(*,*) '** New', time8(i),  ' ', specname(i)(:len1(specname(i)))
	write(*,*) '** Dif', time8(i)-time8(im), ' not positive.'
	
      end if
      end do
	misorder = n

* known sites
	write(*,*)
	write(*,*) 'Sites', nsite
	write(*,*) ( i, name_s(i)(:len1(name_s(i))), i=1,nsite )

* match spectra with known sites
	nomatch = nosite
      do i = 1, nt
	file = specname( i )
	call upcase( file, file )
	match = nomatch
      do j = 1, nsite
	name = name_s( j )
      if( index( file, name(:len1(name)) ) .gt. 0 ) then
	match = j
	nt_s( j ) = nt_s( j ) + 1
	i_ts( nt_s( j ), j ) = i
	cycle
      end if
* next site j
      end do
* stow
	is_t( i ) = match
* report
	name = name_s( match )
	write(*,*) 'Spec', i, ' Site', match, ' ', file(:len1(file))
* next spec i
      end do
* summary
	write(*,*)
	write(*,*) 'Sites', nsite
      do i = 1, nsite
	name = name_s( i )
	write(*,*) 'Site', i, ' Nt', nt_s(i), ' ', name(:len1(name))
      end do



* NLR/BLR window half-widths
	write(*,*)
	write(*,*) 'Line window half-widths:'
	n = 1
	file = vfile
	call load1d2( file, 2, n, val1, val2 )
      if( n .gt. 0 ) then
	write(*,*) '  Default: NLR', nint(vnlr), ' BLR', nint(vblr)
	write(*,*) 'Over-ride from file ', file(:len1(file))
	write(*,*) 'From file: NLR', val1, ' BLR', val2 
	if( val1 .ne. 0 ) vnlr = val1
	if( val2 .ne. 0 ) vblr = val2
	vnlrtweak = vnlr .lt. 0.
	vblrtweak = vblr .lt. 0.
	vnlr = abs( vnlr )
	vblr = abs( vblr )
      end if
	write(*,*) ' NLR', nint(vnlr), vnlrtweak
     &		,  ' BLR', nint(vblr), vblrtweak, ' km/s'


* BAL windows
	nbal = 0
      if( usebalmask ) then
	n = maxline
	file = balfile
      if( n .gt. 0 ) then
	write(*,*)
	write(*,*) 'BAL windows from ', file(:len1(file))
	call loadlc3( file, 3, n, restbal_l, v1bal_l, v2bal_l )
	write(*,*) 'BAL windows:', n
      do i = 1, n
	v1 = v1bal_l( i )
	v2 = v2bal_l( i )
	v1bal_l( i ) = min( v1, v2 )
	v2bal_l( i ) = max( v1, v2 )
	write(*,*) i, restbal_l(i), v1bal_l(i), v2bal_l(i)
      end do
	write(*,*)
	nbal = n

* expand vblr to be at least 5% wider than BAL
      if( n .gt. 0 ) then
	call mnmx( n, v1bal_l, vlo, v )
	call mnmx( n, v2bal_l, v, vhi )
	xtra = 1.05
	v = max( abs( vlo * xtra ), abs( vhi * xtra ) )
      if( vblr .lt. v ) then
	write(*,*) 'Expand BLR', nint(vblr), ' ->', nint( v )
	vblr = max( vblr, v )
      end if
      end if

      end if
      end if



* command node

  100	CALL INQ( 'PrepSpec >', ' ', REPLY )

* command to operating system
      IF( REPLY(1:1) .EQ. '$' ) THEN
      if( len1( reply ) .gt. 1 ) then
	reply = reply(2:)
      else
	CALL INQ( 'Command to operating system: ', 'pwd', reply )
      end if
	if( len1( reply ) .gt. 0 ) call spawn( reply )
	GOTO 100
      END IF

	CALL UPCASE( REPLY, REPLY )

	nt = nspec
	nw = nwave
      do i=1,nt
	seq_t(i) = i
      end do

      IF( REPLY.EQ.'Q' ) THEN
	CALL INQ( 'Do you REALLY want to quit ? ', 'N', REPLY )
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY.EQ.'Y' ) STOP
	GOTO 100
      END IF



	IF( REPLY.EQ.'A' ) GOTO 1
	IF( REPLY.EQ.'T' ) GOTO 5
	IF( REPLY.EQ.'U' ) GOTO 103
	IF( REPLY.EQ.'Z' ) GOTO 105
	IF( REPLY.EQ.'E' ) GOTO 106
	IF( REPLY.EQ.'F' ) GOTO 110
	IF( REPLY.EQ.'+' ) GOTO 115
	IF( REPLY.EQ.'V' ) GOTO 120
	IF( REPLY.EQ.'D' ) GOTO 130
	IF( REPLY.EQ.'J' ) GOTO 140
	IF( REPLY.EQ.'W' ) GOTO 150
	IF( REPLY.EQ.'C' ) GOTO 160
	IF( REPLY.EQ.'B' ) GOTO 180
	IF( REPLY.EQ.'S' ) GOTO 200
	IF( REPLY.EQ.'L' ) GOTO 300
	IF( REPLY.EQ.'I' ) GOTO 400
	IF( REPLY.EQ.'M' ) GOTO 500

* command menu

	WRITE(*,*) ' A ... AGN ', agn(:len1(agn))
	WRITE(*,*) ' U ... Units ', fluxunit(:len1(fluxunit)), ' 10^(', iflxdex, ' )'
	WRITE(*,*) ' Z ... redshift Z =', ZSHIFT

c	WRITE(*,*) ' T ... Times', NSPEC, ' ', timebase(:len1(timebase))
c     &		, TIME(1), TIME(NSPEC), ' ', tlist(:len1(tlist))

	title = ' T ... Times'
	call append_i( title, NSPEC )
	call append( title, timebase( : len1( timebase ) ) )
	call append_f( title, time( 1 ), '*' )
	call append_f( title, time( nspec ), '*' )
	call append( title, tlist( : len1( tlist ) ) )
	write(*,*) title(:len1(title))

* warnings
	if( lostspec .gt. 0 ) write(*,*) '** WARNING: SPECTRUM BUFFER FULL. LOST', lostspec
	if( misorder .ne. 0 ) write(*,*) '** WARNING: TIMES OUT OF ORDER.  JUMPS', misorder

	WRITE(*,*) ' W ... Wavelength alignment', linemode, linterp
	W1 = WAVE(1)/OPZ
	W2 = WAVE(NWAVE)/OPZ
	WRITE(*,*) ' B ... Bin pixels', NWAVE, W1, W2
	WRITE(*,*) ' + ... Add constant to spectra'
	WRITE(*,*) ' F ... Fake error-bar spectra'
	WRITE(*,*) ' E ... systematic Error ', SYSERB, ' percent'
	WRITE(*,*) ' J ... Jitter', PIXJIT, ' pixels'
	WRITE(*,*) ' C ... Continuum fits'
	WRITE(*,*) ' L ... Light curves Nt =', nspec
	WRITE(*,*) ' S ... Spectra ISPLIT =', ISPLIT
	WRITE(*,*) ' V ... Velocity at wavelength ', REST0
	WRITE(*,*) ' I ... Image display'
	WRITE(*,*) ' M ... Model spectral variations'
	WRITE(*,*) ' D ... Dump trailed-spectrogram to disk file'
	WRITE(*,*) ' $ ... Send command to operating system'
	WRITE(*,*) ' Q ... Quit'
	GOTO 100

* set flux unit

  103	write(*,*) 'Spectra', nspec
      if( nspec .gt. 0 ) then
	dmn = datpic(1,1)
	dmx = dmn
      do i=1,nspec
	call mnmx( nw_t(i), datpic(1,i), dmn1, dmx1 )
	dmn = min( dmn, dmn1 )
	dmx = max( dmx, dmx1 )
      end do
	write(*,*) 'Data range', dmn, dmx 
      end if

	write(*,*) 'Flux Unit may be FLAM or MJY'
	call inq( 'Flux Unit', fluxunit, reply )
	call upcase( reply, reply )
	if( reply .eq. 'FLAM' .or. reply .eq. 'MJY' ) fluxunit = reply(:len1(reply))

* input units (power of 10)
	call inqi( 'Flux Units (dex) of input spectra', inflxdex, inflxdex )	

* plot units (power of 10)
	call inqi( 'Flux Units (dex) for plots', iflxdex, iflxdex )	

	GOTO 100

* set redshift

  105 do i=1,nagn
	write(*,'(I5,a,a12,a,f8.6)') i, ' ', agn_a(i), ' z ', zshift_a(i)
      end do
	call inqd( 'Enter redshift', zshift, zshift )
	OPZ = 1.D0 + ZSHIFT
	write(*,*) '1+z =', opz
	GOTO 100

* set systematic error

  106	call inqr( 'Systematic error (%)', syserb, val )
	if( val .ge. 0 ) syserb = val
	GOTO 100

* Fake error bar spectra

  110	WRITE(*,*) 'FAKING ERROR BARS ON SPECTRA'
	WRITE(*,*) 'Will use SIGFAKE to estimate Poisson error bars.'
	WRITE(*,'(A,$)') ' Percentage scale errors (0-100) : '
	READ(*,*) PERCENT
	SCALE = MAX( 0., PERCENT/100. )
	
      DO ISPEC=1,NSPEC
	NWAVE = nw_t(ISPEC)
	NEW = 0
      DO I=1,NWAVE
      IF( SIGPIC(I,ISPEC).GT.0. ) THEN
	NEW = NEW + 1
	DATA(NEW) = DATPIC(I,ISPEC)
      END IF
      END DO
      IF( NEW.GT.3 ) THEN
	CALL SIGFAKE( NEW, DATA, FAKESIGMA )
	NEW = 0
      DO I=1,NWAVE
      IF( SIGPIC(I,ISPEC).GT.0. ) THEN
	NEW = NEW + 1
	VAR = FAKESIGMA(NEW)*FAKESIGMA(NEW) + (DATA(I) * SCALE)**2
	SIGPIC(I,ISPEC) = SQRT( MAX( 0., VAR ) )
      END IF
      END DO
      END IF
      END DO
	GOTO 100

* add constant to each spectrum
  115	WRITE(*,'(A,$)') ' Constant to add to spectra : '
	READ(*,*, ERR=115 ) ADD
	IF( ADD.EQ.0. ) GOTO 100
      DO ISPEC=1,NSPEC
	NWAVE = nw_t(ISPEC)
      DO I=1,NWAVE
	CONPIC(I,ISPEC) = CONPIC(I,ISPEC) + ADD
	DATPIC(I,ISPEC) = DATPIC(I,ISPEC) + ADD
      END DO
      END DO
	WRITE(*,*) 'Constant', ADD, ' added to spectrum', 1, ' to', NSPEC
	GOTO 100

* select wavelength for velocity scale

  120   WRITE(*,*) 'Old rest wavelength : ', REST0
*	call inqd( 'New rest wavelength :', rest0, rest0 )
	WRITE(*,'(A,$)') ' New rest wavelength : '
	READ(*,*,ERR=100) VAL8
	IF( VALUE.GE.0. ) REST0 = VAL8
        GOTO 100



* DUMP TRAILED SPECTROGRAM DATA TO DISK FILE

  130	WRITE(*,*) 'Continuum-subtracted trailed spectrogram'
	NWAVE = nw_t( 1 )
	WRITE(*,*) 'NSPEC=', NSPEC, ' NWAVE=', NWAVE
	CALL INQ( 'Output file : ', 'NONE', FILE )
	REPLY = FILE
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY .EQ. ' ' ) GOTO 100
	IF( REPLY .EQ. 'NONE') GOTO 100
	IPUT = 0
      DO I=1,NSPEC
      DO J=1,NWAVE
	IPUT = IPUT + 1
	BUF1(IPUT) = DATPIC(J,I) - CONPIC(J,I)
	BUF2(IPUT) = SIGPIC(J,I)
	BUF2(IPUT) = SQRT( SIGPIC(J,I)**2
     #		+ ( SYSERB * 0.01 * BUF1(IPUT) )**2 )
      END DO
      END DO

* NOTE: WAVELENGTHS SHOULD BE REAL*8 :(((
      DO J=1,NWAVE
	WAVE(J) = wavpic8(J,1) / OPZ
      END DO
	CALL DUMP2D2( FILE, 2, NWAVE, NSPEC, WAVE, TIME,
     #	BUF1, BUF2 )
	GOTO 100

* JITTER 

  140	WRITE(*,*) 'JITTER - expands error bars to allow for jitter'
	CALL INQR( 'Pixel jitter', PIXJIT, VAL )
      IF( VAL .GT. 0 ) THEN
	PIXJIT = VAL
      DO ISPEC=1,NSPEC
	NWAVE = nw_t(ISPEC)
      DO I=1,NWAVE
	DATA(I) = DATPIC(I,ISPEC)
	WAVE(I) = wavpic8(I,ISPEC)
	IM = MAX( I-1, 1 )
	IP = MIN( I+1, NWAVE )
	DM = DATPIC(IM,ISPEC)
	DP = DATPIC(IP,ISPEC)
	SLOPE = ( DP - DM ) / MAX(1,IP-IM)
	SIGJIT( I ) = ABS( SLOPE * PIXJIT )
	SIGJITPIC( I, ISPEC ) = SIGJIT(I)
	SIGPIXPIC( I, ISPEC ) = PIXJIT
	DDATDPIXPIC( I, ISPEC ) = SLOPE
      END DO
      END DO
      END IF
	GOTO 100

* ALIGN WAVELENGTH SCALES

  150	WRITE(*,*)

      if( narrow1 .gt. 0 .and. narrow2 .ge. narrow1 ) then

* report
      do i = 1, nspec
	nw = nw_t( i )
	w8 = min( wavpic8( 1, i ), wavpic8( nw, i ) ) / opz
* min
	if( i .eq. 1 ) wmn8 = w8
	w8lo = min( wmn8, w8 )
	plot1( i ) = w8
* max
	w8 = max( wavpic8( 1, i ), wavpic8( nw, i ) ) / opz
	if( i .eq. 1 ) wmx8 = w8
	wmx8 = max( wmx8, w8 )
	plot2( i ) = w8
* dispersion
	plot3( i ) = ( plot2( i ) - plot1( i ) ) / max( 1, nw-1 )
* next spectrum
      end do
	call mnmxi( nspec, nw_t, mn, mx )
	call mnmx( nspec, plot1, blumn, blumx )
	call mnmx( nspec, plot2, redmn, redmx )
	call mnmx( nspec, plot3, damn, damx )
	call medmad( nspec, plot3, damed, damad )
	wlo = blumn
	whi = redmx
	wlo = wmn8
	whi = wmx8

	write(*,*)
	if( opz .ne. 1.d0 ) write(*,*) 'REST wavelengths. z =', zshift
	write(*,*) 'Spectra', nspec, ' Nw min,max', mn, mx
	write(*,*) ' Blu', blumn, blumx, ' diff', blumx - blumn
	write(*,*) ' Red', redmn, redmx, ' diff', redmx - redmn
	write(*,*) 'Intersection:', blumx, redmn, blumx-redmn
	write(*,*) '  Full range:', wlo, whi, whi - wlo
	p = 200. * ( damx - damn ) / ( damx + damn )
	write(*,*) '  Mean A/pix:', damn, damx, p, ' %'
	write(*,*) 'Median A/pix:', damed, ' MAD', damad
	yes = mn .eq. mx .and. blumn .eq. blumx .and. redmn .eq. redmx

      if( yes ) then
	write(*,*) ' WAVELENGTH RANGES ARE IDENTICAL :).'
      end if

	nbin = 1 + ( wmx8 - wmn8 ) / damed
	da8 = (wmx8 - wmn8) / max( 1, nbin - 1 )
	write(*,*)
	write(*,*) 'Union of rest-wavelength scales:'
	write(*,*) ' (', wmx8, ' -', wmn8, ')'
	write(*,*) '/(', nbin, ' -', 1, ') =', da8, ' A/pix' 


* count narrow lines in range
	n = 0
      do i = 1, markline
	rest = rest_l( i )
      if( nabc( i ) .eq. narrow ) then
	if( wlo .le. rest .and. rest .le. whi ) n = n + 1
      end if
      end do

* report narrow lines in range
      if( n .gt. 0 ) then
	write(*,*)
	write(*,*) 'Candidate narrow lines:', n, ' zshift', real(zshift)
	write(*,*) ' Rest(A)   Rest(A)  Pixel  Wave(A)  Disp(A)   (km/s)'
	nw = nw_t( 1 )

* KDH : PUT SPECTRUM 1 ONTO THE UNION WAVELENGTH SCALE ?


* reference spectrum 1
	is = 1
	nw = nw_t( is )
      do iw = 1, nw
* rest wavelength (A)
	plot1( iw ) = wavpic8( iw, is ) / opz
* rest dispersion (A/pix)
	ip = min( iw + 1, nw )
	im = max( iw - 1, 1 )
	plot2( iw ) = ( wavpic8( ip, is ) - wavpic8( im, is ) )
     &		/ max( 1, ip - im ) / opz
* spectrum data
	plot3( iw ) = datpic( ip, is )
* next wavelenfth iw
      end do

	igab = 0
	if( gabby ) igab = 1
	gabby = .false.

* lines
      do lrank = 1, markline
	i = i_l( lrank )
* narrow lines
      if( nabc( i ) .eq. narrow ) then
	rest = rest_l( i )
* in range
      if( wlo .le. rest .and. rest .le. whi ) then
	w = rest
	call lookup( nw, plot1, w, i1, i2, p )
	pix = i1 * (1.-p) + p * i2
	w = terp1( nw, plot1, i1, i2, p )
	dang = terp1( nw, plot2, i1, i2, p )
	v = dang * ckms / w
	write(*,'(i8,f10.3,i8,i8,f10.5,f8.1)')
     &		nint( rest ), rest, nint(pix), nint(w), dang, v


* KDH : SHOULD WE DO THIS FOR ALL LINES ?
* ADD 5008 [OIII] IF AVAILABLE
* ADD 9533 [SIII] IF AVAILABLE
      if( nline .eq. 0 ) then
      if( i .eq. line5007 .or. i .eq. line9533 ) then
	if( i .eq. line5007 ) write(*,*) ' [OIII] is in range :)', rest
	if( i .eq. line9533 ) write(*,*) ' [SIII] is in range :)', rest

* find max/min within specified velocity of rest wavelength
	vfwhm = 800
	k0 = nint( i1 + p )
* second loop has revised estimates of k0, vfwhm
	nloop = 3
      do loop = 1, nloop
	if( gabby ) write(*,*)
* search from -fwhm to +fwhm
	vhw = vfwhm * 1.5
	p = rest * vhw / ckms / dang
	n = max( 1, nint( rest * vhw / ckms / dang ) )
c	write(*,*) 'WinHW', nint(vhw), ' km/s', p, ' pixels'
	k1 = max( k0 - n, 1 )
	k2 = min( k0 + n, nwave )
* find max and min
	khi = k1
	klo = k1
	n = k2 - k1 + 1
	v = ckms * n * dang / rest
      if( gabby ) then
	write(*,*) 'Search', nint(v),' km/s', n * dang, ' A', n, ' pixels', k1, k2
      end if
      do k = k1, k2
	y = plot3( k )
	w = plot1( k )
	v = ckms * ( w - rest ) / rest
	yhi = plot3( khi )
	ylo = plot3( klo )
	if( y .gt. yhi ) khi = k
	if( y .lt. ylo ) klo = k
      if( gabby ) then
	write(*,*) '   Y(', k, ' ) =', y, y/yhi, ' ', nint(v), ' km/s', w-rest, ' A'
      end if
      end do
      if( gabby ) then
	write(*,*) 'Hi Y(', khi, ' ) =', yhi
	write(*,*) 'Lo Y(', klo, ' ) =', ylo
      end if
* parabola thru 3 points
	kstep = 1
	k0 = khi
	km = max( k0 - 1, 1 )
	if( km .eq. k0 ) k0 = k0 + 1
	kp = min( k0 + 1, nwave )
	if( kp .eq. k0 ) k0 = k0 - 1
* KDH : SHOULD TRY TO STEP TO APPROX FWHM POINTS
	ym = plot3( km )
	y0 = plot3( k0 )
	yp = plot3( kp )
	n = max( 1, kp - km )
	b = ( yp - ym ) / n
	c = ( yp + ym - y0 - y0 ) / n
      if( gabby ) then
	write(*,*) '   Y(', km, ' ) =', ym
	write(*,*) '   Y(', k0, ' ) =', y0
	write(*,*) '   Y(', kp, ' ) =', yp
	write(*,*) ' Polyfit Y =', y0, ' +', b, ' X +', c, ' X^2'
      end if
      if( c .ge. 0. ) then
	if( gabby ) write(*,*) 'Not a local max :('
      else
* poly fit is y = y0 + b x + c x^2
* poly peak
	x = -b / ( c + c )
	xpk = k0 + x
	ypk = y0 + x * ( b + c * x )
c	write(*,*) ' Peak at X', xpk, ' Y', ypk
* half peak flux
	yh = ( ypk + ylo ) / 2.
* fwhm from curvature at the top
	hwhm = sqrt( ( yh - ypk ) / c )
	fwhm = 2. * hwhm
	xlo = xpk - hwhm
	xhi = xpk + hwhm
	v = ckms * fwhm * dang / rest
	if( gabby ) write(*,*) '  Half Peak at Y', yh, ' X', xlo, xhi
      if( gabby .or. loop .eq. nloop ) then
	write(*,*) 'FWHM', nint(v), ' km/s', fwhm * dang, ' A', fwhm, ' pixels'
      end if
* check
	hwhm = fwhm / 2.
	klo = nint( xlo )
	khi = nint( xhi )
      if( gabby ) then
	write(*,*) '  dat(', klo, ' ) =', plot3( klo )
	write(*,*) '  dat(', khi, ' ) =', plot3( khi )
      end if
      end if
* KDH : COULD REVISE FWHM BASED ON THESE POINTS
* next loop with revised k0, vfwhm
	vfwhm = ckms * fwhm * dang / rest
      end do
* add to linelist
	nline = nline + 1
	wavline( nline ) = rest
	widline( nline ) = fwhm * dang
	wgtline( nline ) = 1.
      end if
      end if

      end if
      end if
* next lrank
      end do
	gabby = igab .ne. 0
      end if
      end if

	write(*,*)
	WRITE(*,*) 'Lines selected for aligning wavelength scales: ', NLINE
      DO I=1,NLINE
	WRITE(*,*) I, ' rest(A)', WAVLINE(I), ' fwhm(A)', WIDLINE(I), ' wgt', WGTLINE(I)
      END DO

      if( linterp .eq. 0 ) then
	write(*,*) 'Interpolation: NONE'
      else if( linterp .eq. 1 ) then
	write(*,*) 'Interpolation: LINEAR'
      else
	write(*,*) 'Interpolation: QUADRATIC'
      end if

      if( linemode .eq. linemode_wgt ) then
	write(*,*) 'Fitmode', linemode, ' WEIGHTED average of pixel shifts.'
      else if( linemode .eq. linemode_opt ) then
	write(*,*) 'Fitmode', linemode, ' OPTIMAL average of pixel shifts.'
      else if( linemode .eq. linemode_trend ) then
	write(*,*) 'Fitmode', linemode, ' TREND to pixel shifts vs wavelength.'
      end if

      if( lineplot .eq. lineplot_none ) then
	write(*,*) 'Plots: ', lineplot, ' no plots'
      else if( lineplot .eq. lineplot_final ) then
	write(*,*) 'Plots: ', lineplot, ' final plot only'
      else if( lineplot .eq. lineplot_all ) then
	write(*,*) 'Plots: ', lineplot, ' individual and final plots'
      end if


* command node
	WRITE(*,*) 'Enter W for wavelength scale dispersion plot.'
	WRITE(*,'(A,$)') ' Add, Delete, Load, Save, Quit or Continue : '
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY.EQ.'Q' ) GOTO 100

* wavelength scale and dispersion plot

      if( reply .eq. 'W' ) then
  152	nx = 1
	ny = 3
	ipanw = 1
	ipanwc = 2
	ipandw = 3
	npan = 3
	call pgstart( nx, ny, nouse )
	call pgbgw
	csize = 1.5
	call pgsch( csize )
* panels
      do ipan = 1, npan

* x range
	xmn = wavpic8( 1, 1 )
	xmx = xmn
      do is = 1, nspec
	nw = nw_t( is )
      do iw = 1, nw
	w = wavpic8( iw, is )
	xmn = min( xmn, w )
	xmx = max( xmx, w )
      end do
      end do

* linear approx to 1st wavelength scale
	is = 1
	nw = nw_t( is )
	dw8  = ( wavpic8( nw, is ) - wavpic8( 1, is ) ) / max( 1, nw - 1 )
	w8 =   wavpic8(  1, is ) - dw8
	write(*,*) 'Reference wavelength scale', w8, ' + I *', dw8

* y range
* ipanw = pixel vs lambda
      if( ipan .eq. ipanw ) then
	ylabel = 'pixel'
	ymn = 0.5
	ymx = ymn
      do i = 1, nspec
	nw = nw_t( i )
	ymx = max( ymx, nw + 0.5 )
      end do
* ipandw  = dispersion (A/pix)
* ipanwc = changes 
      else if( ipan .eq. ipandw .or. ipan .eq. ipanwc ) then
	if( ipan .eq. ipandw ) ylabel = 'dispersion d\gl (\A/pixel)'
	if( ipan .eq. ipanwc ) ylabel = 'changes \gD\gl (\A)'
	yes = .true.
      do i = 1, nspec
	nw = nw_t( i )
      do iw = 1, nw
	y = wavpic8( iw, i ) - ( w8 + iw * dw8 )
      if( ipan .eq. ipandw ) then
	im = max( iw - 1, 1 )
	ip = min( iw + 1, nw )
	y = ( wavpic8( ip,i ) - wavpic8( im,i ) ) / max( 1, ip - im )
      end if
      if( yes ) then
	ymn = y
	ymx = y
	yes = .false.
      end if
	ymn = min( ymn, y )
	ymx = max( ymx, y )
* next wavelength iw
      end do
* next spec i
      end do
      end if

* expand ranges
	xtra = 0.05
	add = ( xmx - xmn ) * xtra
	xmn = xmn - add
	xmx = xmx + add
	add = ( ymx - ymn ) * xtra
	if( add .eq. 0. ) add = 0.1
	ymn = ymn - add
	ymx = ymx + add

	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
* label
	xlabel = 'observed wavelength \gl'
      if( ipan .eq. ipanw ) then
	ylabel = 'pixel'
      else if( ipan .eq. ipandw ) then
	ylabel = 'dispersion \gD\gl (\A/pixel)'
      else if( ipan .eq. ipandw ) then
	ylabel = 'dispersion \gD\gl (\A/pixel)'

      end if
	title = ' '
	call append_i( title, nspec )
	call append( title, 'Wavelength Scales' )
	call pglabel( xlabel, ylabel, title )
* spectra
      do i = 1, nspec
	nw = nw_t( i )
      do iw = 1, nw
	plot1( iw ) = wavpic8( iw, i )
      if( ipan .eq. ipanw ) then
	plot2( iw ) = iw
* dispersion
      else if( ipan .eq. ipandw ) then
	im = max( iw - 1, 1 )
	ip = min( iw + 1, nw )
	da = ( wavpic8( ip,i ) - wavpic8( im,i ) ) / max(1, ip - im )
	plot2( iw ) = da
* changes
      else if( ipan .eq. ipanwc ) then
	plot2( iw ) = wavpic8( iw,i ) - ( w8 + iw * dw8 )
      end if
      end do
	call pgsci( 1 + mod( i, 15 ) )
	call pgline( nw, plot1, plot2 )
      end do
	call pgsci( 1 )
* next panel ipan
      end do
* close
	call pgstop
	if( pgagain() ) goto 152
	goto 150
      end if

* edit interpolation mode
	if( reply .eq. '0' ) linterp = 0
	if( reply .eq. '1' ) linterp = 1
	if( reply .eq. '2' ) linterp = 2
      if( reply .eq. 'I' ) then

	write(*,*) '0 = sub-pixel shifts tweak the wavelengths - no interpolation.'
	write(*,*) '1 = sub-pixel shifts removed by linear interpolation.'
	write(*,*) '2 = sub-pixel shifts removed by quadratic interpolation.'
	call inqi( 'Interpolation mode (0-2)', linterp, ival )
	if( ival.ge. 0 .and. ival .le. 2 ) linterp = ival
	goto 150
      end if

* edit line plot option
      if( reply .eq. 'P' ) then
	write(*,*) lineplot_none,  ' no plots'
	write(*,*) lineplot_final, ' final plot only'
	write(*,*) lineplot_all,   ' individual and final plots'
	call inqi( 'Plot option (0-2)', lineplot, ival )
	if( ival .eq. lineplot_none ) lineplot = ival
	if( ival .eq. lineplot_final ) lineplot = ival
	if( ival .eq. lineplot_all ) lineplot = ival
	goto 150
      end if

* edit fit mode
	if( reply .eq. 'W' ) linemode = linemode_wgt
	if( reply .eq. 'O' ) linemode = linemode_opt
	if( reply .eq. 'T' ) linemode = linemode_trend

      if( reply .eq. 'F' ) then
	write(*,*) linemode_wgt, ' weighted average of line shifts'
	write(*,*) linemode_opt, ' optimal average of line shifts'
	write(*,*) linemode_trend, ' linear trend fit to line shifts'
	call inqi( 'Fitmode', linemode, ival )
	if( ival .eq. linemode_wgt ) linemode = ival
	if( ival .eq. linemode_opt ) linemode = ival
	if( ival .eq. linemode_trend ) linemode = ival
	goto 150
      end if

* add lines by hand
      IF( REPLY.EQ.'A' ) THEN
      IF( NLINE.GE.MAXLINE ) THEN
	WRITE(*,*) 'Line list is full.'
      ELSE

* candidate narrow lines
      if( .false. ) then
	n = 0
      do lrank = 1, markline
	i = i_l( lrank )
      if( nabc(i) .eq. narrow ) then
	rest = rest_l( i )
      if( rest .ge. wlo .and. rest .le. whi ) then
	n = n + 1
	dplot1( n ) = rest
      end if
      end if
* next lrank
      end do
      if( n .gt. 0 ) then
	write(*,*) 'AGN narrow lines:', n
	write(*,*) ( dplot1(i), i=1,n )
      end if
      end if

	WRITE(*,*) '(negative weight for absorption lines)'
	WRITE(*,*) 
     #	'New line center(Ang), FWHM(Ang), weight (0,0,0 quits) :'
	NEXT = NLINE + 1
      DO I=NEXT,MAXLINE
	WRITE(*, '(1X,I3,A,$)' ) I, ' : '
	READ(*,*,ERR=150) WAVLINE(I), WIDLINE(I), WGTLINE(I)
	IF( WAVLINE(I) .LE. 0. .OR. WIDLINE(I) .LE. 0.
     #	.OR. WGTLINE(I) .EQ. 0. ) GOTO 150
	NLINE = NLINE + 1
      END DO
	WRITE(*,*) 'Line list is full.'
      END IF

* delete lines
      ELSE IF( REPLY.EQ.'D' ) THEN
	WRITE(*,'(A,$)') ' First and last lines to delete: '
	READ(*,*,ERR=150) I1, I2
	I1 = MAX( I1, 1 )
	I2 = MIN( I2, NLINE )
      IF( I2.GE.I1 ) THEN
      IF( I2.LT.NLINE ) THEN
	IPUT = I1
      DO IGET=I2+1,NLINE
	WAVLINE(IPUT) = WAVLINE(IGET)
	WIDLINE(IPUT) = WIDLINE(IGET)
	WGTLINE(IPUT) = WGTLINE(IGET)
	IPUT = IPUT + 1
      END DO
      END IF
	NLINE = NLINE - ( I2 - I1 + 1 )
      END IF

* load lines from a file
      ELSE IF( REPLY.EQ.'L') THEN
	call inq( 'Line input file:', ' ', FILE )
      IF( FILE .NE. ' ' ) THEN
	NEXT = NLINE + 1
	NEW = MAXLINE - NLINE
	CALL LOAD1D3( FILE, 3, NEW,
     #		WAVLINE(NEXT), WIDLINE(NEXT), WGTLINE(NEXT) )
	IF( NEW.GT.0 ) NLINE = NLINE + NEW
      END IF

* save lines in a file
      ELSE IF( REPLY.EQ.'S') THEN
	call inq( 'Line save file:', ' ', FILE )
      IF( FILE.NE. ' ' ) THEN
	call textlabel_wave( label, zshift )
	HLINES( 1 ) = 'Narrow lines for PrepSpec spectrum alignment.'
	HLINES( 2 ) = ' Col 1 : ' // label(:len1(label))
	HLINES( 3 ) = ' Col 2 : Linewidth  FWHM (A)'
	HLINES( 4 ) = ' Col 3 : Line weight'
	NH = 4
	CALL DUMP1D3H( FILE, NH, HLINES, 3, NLINE, WAVLINE, WIDLINE, WGTLINE )
      END IF
      END IF
	IF( REPLY.NE.'C' ) GOTO 150
	IF( NLINE.LE.0 ) GOTO 100

* loop thru spectra

      DO ISPEC=1,NSPEC
	NWAVE = nw_t( ispec )
	f = 10. ** ( inflxdex - iflxdex )
      DO IW=1,NWAVE
	WAVE(IW) = wavpic8(IW,ISPEC) / OPZ
	DATA(IW) = DATPIC(IW,ISPEC) * f
	sigma(iw) = sigpic(iw,ispec) * f
      END DO
	WCEN = ( WAVE(NWAVE) + WAVE(1) ) / 2.
	WRANGE = WAVE(NWAVE) - WAVE(1) 

* KDH : DWAVE assumes constant dispersion - not always true.
	DWAVE = WRANGE / MAX( 1, NWAVE-1 )

	write(*,*)
	write(*,*) '--------------------------------------', ispec, ' of', nspec
	WRITE(*,*) 'ISPEC=', ISPEC, ' NWAVE=', NWAVE
	WRITE(*,*) 'Wavelengths', WAVE(1), WAVE(NWAVE)
	write(*,*) 'centre', wcen, ' range', wrange, ' dispersion', DWAVE, ' A/pix'
	write(*,*) 'flx unit scale factor', f

* check constant dispersion assumption
      do i = 1, nwave
	im = max( i - 1, 1 )
	ip = min( i + 1, nwave )
	dw = ( wave( ip ) - wave( im ) ) / max( 1, ip - im )
	plot1(i) = dw
      end do
	call mnmx( nwave, plot1, dwmn, dwmx )
	call avgrms( nwave, plot1, dwavg, dwrms )
	call avgrms( nwave, plot1, dwmed, dwmad )
	test1 = ( dwmx - dwmn ) / ( dwmx + dwmn )
	test2 = dwrms / dwavg
	test3 = dwmad / dwmed
	write(*,*) 'Constant dispersion check:'
	write(*,*) ' min', dwmn,  ' max', dwmx,  ' dif/sum', test1, nint(100*test1), '%'
	write(*,*) ' avg', dwavg, ' rms', dwrms, ' rms/avg', test2, nint(100*test2), '%'
	write(*,*) ' med', dwmed, ' mad', dwmad, ' mad/med', test3, nint(100*test3), '%'
	test = max( abs( test1 ), abs( test2 ), abs( test3 ) )
      if( test .gt. 0.01 ) then
	write(*,*) '** WARNING: CONSTANT DISPERSION FALSE :((((.'
      else
	write(*,*) 'Constant dispersion assumption looks good :).'
      end if

* compute mean pixel shift over all lines
	SUM = 0.D0
	SUMW = 0.D0
	SUMV = 0.D0
	SUM1 = 0.D0
	SUM2 = 0.D0
	ROOT8LN2 = SQRT( 8. * ALOG(2.) )
      DO L=1,NLINE
	CEN = WAVLINE(L)
	WID = WIDLINE(L)
	WGT = ABS( WGTLINE(L) )
	ESIG = ROOT8LN2 * WIDLINE(L) / DWAVE
	IFLIP = 1
	IF( WGTLINE(L).LT.0. ) IFLIP = -1
* find rough line peak
	IPEAK = 0
	W1 = CEN - WID
	W2 = CEN + WID
	ilo = nwave
	ihi = 1
      DO I=1,NWAVE
      IF( WAVE(I) .GT. W1 .AND. WAVE(I) .LT. W2 ) THEN
	ilo = min( ilo, i )
	ihi = max( ihi, i )
	IF( IPEAK.EQ.0 ) IPEAK = I
	IF( IFLIP*DATA(I) .GE. IFLIP*DATA(IPEAK) ) IPEAK = I
      END IF
      END DO
	WRITE(*,*) CEN, ' at', WAVE(IPEAK), ' A =', IPEAK, ' pix'
* tweak up the peak
	CALL MEDIAN( DATA, NWAVE, IPEAK, ESIG, RBIN, SIGBIN, IFLIP )
* estimate continuum noise level
	sigcont = sqrt( ( sigma( ilo )**2 + sigma( ihi )**2 ) / 2. )
	sigmed = xmedian( ihi-ilo+1, sigma( ilo ) )
	datcont = ( data( ilo ) + data( ihi ) ) / 2.
	datmed = xmedian( ihi-ilo+1, data( ilo ) )
	write(*,*) 'continuum data ', datcont, ' median', datmed
	write(*,*) 'continuum sigma', sigcont, ' median', sigmed
* uncertainty in line centre
	write(*,*) 'sigbin', sigbin, ' sigcont', sigcont
	sigbin = sigcont * sigbin

	WRITE(*,*) CEN, ' at', WAVE(IPEAK), ' +/-', SIGBIN*DWAVE, ' A'
	WRITE(*,*) CEN, ' at', RBIN, ' +/-', SIGBIN, ' pix'
	write(*,*) 'Error', cen - wave(ipeak), ' peak pixel.'

	IF( ISPEC.EQ.1 ) PIXLINE(L) = RBIN
	SHIFT = RBIN - PIXLINE(L)
	WRITE(*,*) '      Shift=', SHIFT, ' weight=', WGT
* weighted average
	SUM = SUM + WGT * SHIFT
	VAR = SIGBIN * SIGBIN
	SUMV = SUMV + WGT * WGT * VAR
	SUMW = SUMW + WGT
* optimal average
	SUM1 = SUM1 + SHIFT / VAR
	SUM2 = SUM2 + 1. / VAR
* stow for trend fit
	WAV_L(L) = CEN
	X_L(L) = ( CEN - WHALF ) / WRANGE
	DAT_L(L) = SHIFT
	SIG_L(L) = SIGBIN
* next line
      END DO

* shift spectra to align with the first one

	IF( ISPEC.EQ.1 ) NWAVE0 = NWAVE
	WRITE(*,*) ISPEC, ' ', SPECNAME(ISPEC)(:LEN1(SPECNAME(ISPEC)))

* weighted shift
	SHIFT = SUM / SUMW
	SIGSHIFT = DSQRT( SUMV ) / SUMW
	WSHIFT = SHIFT
* integer and fractional pixel shift
	ISHIFT = NINT( SHIFT )
	PSHIFT = SHIFT - ISHIFT
	WRITE(*,*) ' Mean Shift=', SHIFT, ' =',
     &		ISHIFT, ' +', PSHIFT, ' +/-', SIGSHIFT
* chi2 of the weighted shift
	sum = 0.d0
      do i=1,nline
	eta = ( dat_l(i) - shift ) / sig_l(i)
	sum = sum + eta * eta
      end do
	chi2 = sum
	chi2red = sum / max( 1, nline - 1 )
	write(*,*) 'Chi2', chi2, ' / (', nline, ' - 1 ) =', chi2red
	chi2wgt = chi2
	chi2redwgt = chi2red


* optimal shift
	OSHIFT = SUM1 / SUM2
	ESHIFT = DSQRT( 1.D0 / SUM2 )
	WRITE(*,*) '  Opt Shift=', OSHIFT, ' =',
     &		NINT(OSHIFT), ' +', OSHIFT-NINT(OSHIFT), ' +/-', ESHIFT
* chi2 of the optimal shift
	sum = 0.d0
      do i=1,nline
	eta = ( dat_l(i) - oshift ) / sig_l(i)
	sum = sum + eta * eta
      end do
	chi2 = sum
	chi2red = sum / max( 1, nline - 1 )
	write(*,*) 'Chi2', chi2, ' / (', nline, ' - 1 ) =', chi2red
	chi2opt = chi2
	chi2redopt = chi2red


* fit trend to line shifts
	write(*,*) 'Linear fit to shift vs wavelength:'
	call fitline( nline, x_l, dat_l, sig_l,
     &		xpiv, afit, bfit, asig, bsig )
	wpiv = whalf + wrange * xpiv 
	write(*,*) '  pivot x', xpiv, ' w', wpiv
	write(*,*) '  shift', afit, ' +/-', asig, ' pixels'
	write(*,*) '  trend', bfit, ' +/-', bsig, ' pixels'

* chi2 of the fitted line
	sum = 0.d0
      do i = 1, nline
	wav = wav_l( i )
	dat = dat_l( i )
	sig = sig_l( i )
	piv = ( wav - wpiv ) / wrange
	fit = afit + piv * bfit
	eta = ( dat - fit ) / sig
	sum = sum + eta * eta
      end do
	chi2 = sum
	chi2red = sum / max( 1, nline - 2 )
	write(*,*) 'Chi2', chi2, ' / (', nline, ' - 2 ) =', chi2red

* plot the fit
* open plot
      if( lineplot .eq. lineplot_all ) then

  155	call pgstart( 1, 1, new )
	lwide = lwidedef
	call pgslw( lwide )
	call pgbgw
	csize = csizedef
	call pgsch( csize )

* window
	xmn = wave( 1 )
	xmx = wave( nwave )

	ymx = 5.
	ymn = - ymx
	if( nline .gt. 0 ) call mnmx( nline, dat_l, dmn, dmx )
	ymx = 1.1 * max( abs( dmx ), abs( dmn ), 5. )
	ymn = - ymx
	ymx = max( ymx, max( 0., dmx ) + 0.25 * ( ymx - ymn ) )

	call pgsci( kolor_axis )
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgsls( kdot )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
	call pgsls( 1 )
* label
	xlabel = 'wavelength (\A)'
	xlabel = '\gl (\A)'
      if( zshift .ne. 0.d0 ) then
	call append( xlabel, ' z =' )
	call append_f( xlabel, real(zshift), '(f10.4)' )
      end if
	ylabel = 'pixel shift'
	title = ' '
	call append_i( title, ispec )
	call append( title, specname(ispec))
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )

	if( agn .ne. ' ' ) call pgmtxt('t',0.5,0.0, 0.0, agn )

	kolor_trend = kred
	kolor_opt = kblack
	kolor_wgt = kblue

* weighted shift
	call pgsci( kolor_wgt )
	title = '\gx\u2\d ='
	call append_n( title, chi2wgt, 4 )
	call append( title, ' / (' )
	call append_i( title, nline )
	call append( title, ' - 1 ) =' )
	call append_f( title, chi2redwgt, '(f15.3)' )
	call nospace( title )
	call pgmtxt( 't', -1.5, 0.95, 1.0, title(:len1(title)) )
	title = '\gD ='
	call append_datsig( title, shift, sigshift, 2 )
	call nospace( title )
	title = 'Avg ' // title(:len1(title))
	call pgmtxt( 'T', -1.5, 0.05, 0.0, title )

* optimal shift
	call pgsci( kolor_opt )
	title = '\gx\u2\d ='
	call append_n( title, chi2opt, 4 )
	call append( title, ' / (' )
	call append_i( title, nline )
	call append( title, ' - 1 ) =' )
	call append_f( title, chi2redopt, '(f15.3)' )
	call nospace( title )
	call pgmtxt( 't', -3., 0.95, 1.0, title(:len1(title)) )
	title = '\gD ='
	call append_datsig( title, oshift, eshift, 2 )
	call nospace( title )
	title = 'Opt ' // title(:len1(title))
	call pgmtxt( 'T', -3., 0.05, 0., title )

* trend
	call pgsci( kolor_trend )
	title = '\gx\u2\d ='
	call append_n( title, chi2, 4 )
	call append( title, ' / (' )
	call append_i( title, nline )
	call append( title, ' - 2 ) =' )
	call append_f( title, chi2red, '(f15.3)' )
	call nospace( title )
c	title = 'Trend ' // title(:len1(title))
	call pgmtxt( 't', -4.5, 0.95, 1.0, title )

	title = '\gD ='
	call append_datsig( title, afit, asig, 2 )
	call nospace( title )
	title = 'Trend ' // title(:len1(title))
	call pgmtxt( 'T', -4.5, 0.05, 0., title )
	call append( title, '+' )
	title = ' '
	call append_datsig( title, bfit, bsig, 2 )
	call nospace( title )
	call append( title, ' X' )
	if( title(1:1) .ne. '-' ) title = '+' // title(:len1(title))
	title = '        ' // title(:len1(title))
	call pgmtxt( 'T', -6., 0.05, 0., title )

* data
	call pgsci( kolor_sig )
	call pgerrb( 6, nline, wav_l, dat_l, sig_l, 1. )
	call pgsci( kolor_dat )
	call pgpt( nline, wav_l, dat_l, 23 )

* optimal shift
	call pgsci( kolor_opt )
      do k=-1,1
	y = oshift + k * eshift
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
      end do

* weighted shift
	call pgsci( kolor_wgt )
	call pgsls( kdash )
      do k=-1,1
	y = shift + k * sigshift
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
      end do
	call pgsls( 1 )

* trend shift
	np = 100
      do i=1,np
	p = (i-0.5)/max(1,np)
	w = xmn * (1.-p) + xmx * p
	piv = ( w -  wpiv ) / wrange
	y = afit + piv * bfit
	sig = sqrt( asig * asig + ( piv * bsig )**2 )
	plot1(i) = w
	plot2(i) = y
	plot3(i) = sig
      end do
	call pgsci( kolor_trend )
      do k=-1,1
      do i=1,np
	plot4(i) = plot2(i) + k * plot3(i)
      end do
	call pgline( np, plot1, plot4 )
      end do
	call pgsci( kblack )
* close plot
	call pgstop
	if( pgagain() ) goto 155
* end of plots
      end if


* which line shifts to use
      if( linemode .eq. linemode_wgt ) then
	write(*,*) ' Using weighted shift.'
	SHIFT = WSHIFT
	ISHIFT = NINT( SHIFT )
	PSHIFT = SHIFT - ISHIFT
      else if( linemode .eq. linemode_opt ) then
	write(*,*) ' Using optimal shift.'
	SHIFT = OSHIFT
	ISHIFT = NINT( SHIFT )
	PSHIFT = SHIFT - ISHIFT
      else if( linemode .eq. linemode_trend ) then
	write(*,*) ' Using Linear Trend shifts.'
      end if

* wavelength shift
	ASHIFT = DWAVE * PSHIFT

* KDH: USE THE UNION OF ALL WAVELENGTH RANGES
* RATHER THAN THE FIRST SPECTRUM'S WAVELENGTH RANGE ?
* HOW TO MERGE THE WAVELENGTH SCALES OF OFFSET SPECTRA ?

      DO I=1,NWAVE0
	IGET = I + ISHIFT
* require pixel range overlap with spectrum 1
      IF( IGET.GE.1 .AND. IGET.LE.NWAVE ) THEN

* take data from pixel nearest to wavelength of first spectrum
	WAVE8(I) = wavpic8(I,1) / OPZ

	DATA(I) = DATPIC(IGET,ISPEC)
	EPSILON(I) = EPSPIC(IGET,ISPEC)
	SIGMA(I) = SIGPIC(IGET,ISPEC)

* linear fit to shift vs wavelength
      if( linemode .eq. 3 ) then
	piv = ( wave8(i) - wpiv ) / wrange
	shift = afit + bfit * piv
	sigshift = sqrt( asig * asig + ( bsig * piv )**2 )
	ishift = nint( shift )
	pshift = shift - ishift
      end if

* no interpolation - tweak wavelengths 
      IF( LINTERP .LE. 0 ) THEN
	IP = MIN( I + 1, NWAVE )
	IF( IP .GT. I ) DISP = ( WAVE8(IP) - WAVE8(I) ) / MAX(1,IP-I)
	WAVE8(I) = WAVE8(I) - PSHIFT * DISP
C	WAVE8(I) = WAVE8(I) - ASHIFT
* data slope
      ELSE
	IM = MAX( IGET - 1, 1 )
	IP = MIN( IGET + 1, NWAVE )
	DP = DATPIC(IP,ISPEC)
	D0 = DATA(I)
	DM = DATPIC(IM,ISPEC)
	SLOPE = ( DP - DM ) / MAX( 1, IP - IM )
* linear interpolation
	DATA(I) = D0 + SLOPE * PSHIFT
* quadratic interpolation
      IF( LINTERP .GT. 1 .AND. IP - IM .EQ. 2 ) THEN
	CURV = ( DP + DM ) * 0.5  - D0
	DATA(I) = DATA(I) + CURV * PSHIFT * PSHIFT
      END IF
* data jitter due to uncertainty in the pixel shift
	SIGJIT( I ) = ABS( SIGSHIFT * SLOPE )
	DDATDPIX( I ) = SLOPE
	SIGPIX( I ) = SIGSHIFT
      END IF
* off ends of the data
      ELSE
	WAVE8( I ) = wavpic8(I,1) / OPZ
	DATA( I ) = 0.
	EPSILON( I ) = -800.
	SIGMA( I ) = -1.
	SIGJIT( I ) = 0.
	SIGPIX( I ) = 0.
	DDATDPIX( I ) = 0.
      END IF
* next wavelength
      END DO

* stow
      DO I=1,NWAVE0
	wavpic8(I,ISPEC) = WAVE8(I) * OPZ
	DATPIC(I,ISPEC) = DATA(I)
	SIGPIC(I,ISPEC) = SIGMA(I)
	EPSPIC(I,ISPEC) = EPSILON(I)
	SIGJITPIC(I,ISPEC) = SIGJIT(I)
	SIGPIXPIC(I,ISPEC) = SIGPIX(I)
	DDATDPIXPIC(I,ISPEC) = DDATDPIX(I)
      END DO
	nw_t( ispec ) = NWAVE0

c      END IF

* stow for 
      if( lineplot .ne. lineplot_none ) then
	xplot( ispec ) = ispec
* optimal average
	plot5( ispec ) = oshift
	plot6( ispec ) = eshift
* weighted average
	plot7( ispec ) = wshift
	plot8( ispec ) = sigshift
      end if

* next spectrum
      END DO

* report
	write(*,*) 'Note: Spectra shifted to nearest pixel, then'
      IF( LINTERP .LE. 0 ) THEN
	write(*,*) 'sub-pixel shifts tweak the wavelengths.'
      ELSE IF( LINTERP .EQ. 1 ) THEN
	write(*,*) 'sub-pixel shifts removed by linear interpolation.'
      ELSE
	write(*,*) 'sub-pixel shifts removed by quadratic interpolation.'
      END IF

	write(*,*)
	if( opz .ne. 1.d0 ) write(*,*) 'REST wavelengths. z =', zshift
	write(*,*) 'Before alignment:'
	write(*,*) 'Spectra', nspec, ' Nw', mn, mx
	write(*,*) 'Nlam', mn, mx, ' dif', mx - mn
	write(*,*) ' Blu', blumn, blumx, ' dif', blumx - blumn
	write(*,*) ' Red', redmn, redmx, ' dif', redmx - redmn
	write(*,*) 'Full range:', wlo, whi, whi - wlo

      do i = 1, nspec
	plot1(i) = wavpic8( 1, i ) / opz
	plot2(i) = wavpic8( nw_t(i), i ) / opz
      end do
	call mnmxi( nspec, nw_t, mn, mx )
	call mnmx( nspec, plot1, blumn, blumx )
	call mnmx( nspec, plot2, redmn, redmx )
	wlo = blumn
	whi = redmx

	write(*,*)
	write(*,*) 'After alignment:'
	write(*,*) 'Spectra', nspec, ' Nw', mn, mx
	write(*,*) 'Nlam', mn, mx, ' dif', mx - mn
	write(*,*) ' Blu', blumn, blumx, ' dif', blumx - blumn
	write(*,*) ' Red', redmn, redmx, ' dif', redmx - redmn
	write(*,*) 'Full range:', wlo, whi, whi - wlo


* final plot pixel shift vs spectrum number
      if( lineplot .ne. lineplot_none ) then
  158	call pgstart( 1, 1, notused )
	lwide = lwidedef
	call pgslw( lwide )
	call pgbgw
	csize = csizedef
	call pgsch( csize )
	call pgsci( kblack )

	xmn = 0.
	xmx = nspec + 1
	call mnmx( nspec, plot5, omn, omx )
	call mnmx( nspec, plot7, ymn, ymx )
	ymn = min( ymn, omn )
	ymx = max( ymx, omx )
	ymn = nint( ymn - 1. )
	ymx = nint( ymx + 1. )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
      do k=-1,1
	y = 0.5 * k
	call pgsls( 1 + 3 * iabs( k ) )
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
      end do
	call pgsls( 1 )
	xlabel = 'spectrum'
	ylabel = 'pixel shift'
	title = agn
c	if( iagn .gt. 0 ) title = agn_a( iagn )
	call append( title, ' Wavelength Jitter' )
	call pglabel( xlabel, ylabel, title )

	kolor_wgt = kred
	kolor_opt = kblue

* weighted average
	call pgsci( kolor_wgt )
	call pgerrb( 6, nspec, xplot, plot7, plot8, 0. )
	call pgpt( nspec, xplot, plot7, 2 )
	legend = char(2) // ' weighted shifts'
	call pgmtxt( 'T', -1.5, 0.05, 0., legend(:len1(legend)) )

* optimal average
	call pgsci( kolor_opt )
	call pgerrb( 6, nspec, xplot, plot5, plot6, 1. )
	legend = char(21) // ' optimal shifts'
	call pgmtxt( 'T', -3.0, 0.05, 0., legend(:len1(legend)) )

	call pgsci( kblack )
	call pgpt( nspec, xplot, plot5, 21 )

	call pgstop
	if( pgagain() ) goto 158
      end if


	GOTO 100

* CONTINUUM FITS :

  160	WRITE(*,*) 'Continuum Fit Parameters:'
	WRITE(*,*) ' NPOLYC=', npolyc
	WRITE(*,*) ' NCYCLE=', NCYCLE
	WRITE(*,*) ' THRHI=', THRHI
	WRITE(*,*) ' THRLO=', THRLO
	WRITE(*,'(A,$)') ' New values (0 keeps old ) : '
	READ(*,*,ERR=160) I1, I2, VAL1, VAL2
	IF( I1.GT.0 ) npolyc = I1
	IF( I2.GT.0 ) NCYCLE = I2
	IF( MAX( VAL1, VAL2 ) .GT. 0. ) THRHI = MAX( VAL1, VAL2 )
	IF( MIN( VAL1, VAL2 ) .LT. 0. ) THRLO = MIN( VAL1, VAL2 )

* summary of continuum bands
  170	WRITE(*,*) 'Continuum (REST WAVELENGTH) bands: ', NBAND
      DO I=1,NBAND
	WRITE(*,*) I, WLIM1(I), WLIM2(I)
      END DO
* command node
	WRITE(*,'(A,$)') ' Add, Delete, Load, Save, Quit or Continue : '
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY.EQ.'Q' ) GOTO 100
* add continuum bands by hand
      IF( REPLY.EQ.'A' ) THEN
      IF( NBAND.GE.MAXBAND ) THEN
	WRITE(*,*) 'Continuum band list is full.'
      ELSE
	WRITE(*,*) 'New continuum band angstrom limits (0,0 quits) :'
	NEXT = NBAND + 1
      DO I=NEXT,MAXBAND
	WRITE(*, '(1X,I3,A,$)' ) I, ' : '
	READ(*,*,ERR=170) WLIM1(I), WLIM2(I)
	IF( WLIM2(I).LE.WLIM1(I) ) GOTO 170
	NBAND = NBAND + 1
      END DO
	WRITE(*,*) 'Continuum band list is full.'
      END IF
* delete continuum bands
      ELSE IF( REPLY.EQ.'D' ) THEN
	WRITE(*,'(A,$)') ' First and last bands to delete: '
	READ(*,*,ERR=170) I1, I2
	I1 = MAX( I1, 1 )
	I2 = MIN( I2, NBAND )
      IF( I2.GE.I1 ) THEN
      IF( I2.LT.NBAND ) THEN
	IPUT = I1
      DO IGET=I2+1,NBAND
	WLIM1(IPUT) = WLIM1(IGET)
	WLIM2(IPUT) = WLIM2(IGET)
	IPUT = IPUT + 1
      END DO
      END IF
	NBAND = NBAND - ( I2 - I1 + 1 )
      END IF
* load continuum bands from a file
      ELSE IF( REPLY.EQ.'L') THEN
c	WRITE(*,'(A,$)') ' Continuum band input file: '
c	READ(*,'(A)') FILE
	FILE = CFILE
	CALL INQ( 'Continuum band input file:', FILE, FILE )
      IF( FILE.NE. ' ' ) THEN
	NEXT = NBAND + 1
	NEW = MAXBAND - NBAND
	CALL LOAD1D2( FILE, 2, NEW, WLIM1(NEXT), WLIM2(NEXT) )
      IF( NEW .GT. 0 ) THEN
	NBAND = NBAND + NEW
	CFILE = FILE
      END IF
      END IF
* save continuum bands in a file
      ELSE IF( REPLY.EQ.'S') THEN
	WRITE(*,'(A,$)') ' Continuum band save file: '
	READ(*,'(A)') FILE
      IF( FILE.NE. ' ' ) THEN
	HLINES( 1 ) = 'Continuum Bands'
	HLINES( 2 ) = ' Col 1 : Blue edge (A)'
	HLINES( 3 ) = ' Col 2 : Red  edge (A)'
	NH = 3
	CALL DUMP1D2H( FILE, NH, HLINES, 2, NBAND, WLIM1, WLIM2 )
      END IF
      END IF
	IF( REPLY.NE.'C' ) GOTO 170
	IF( NBAND.LE.0 ) GOTO 100

* power-law vs linear fit
c	WRITE(*,*) '** WARNING: Power-law fit is biased high for noisy data.'
	reply = 'L'
	if( powerlaw ) reply = 'P'
	call inq( 'Linear or Power-law continuum fit ?', reply, reply )
	call upcase( reply, reply )
	POWERLAW = REPLY.EQ.'P'

* loop thru spectra
      DO ISPEC=1,NSPEC
	NWAVE = nw_t( ispec )
* copy spectra for continuum fitting
      DO I=1,NWAVE
* redshift wavelengths
	WAVE(I) = wavpic8( I, ISPEC ) / OPZ
	DATA(I) = DATPIC( I, ISPEC )
	SIGMA(I) = SIGPIC( I, ISPEC )
	EPSILON(I) = EPSPIC( I, ISPEC )
      END DO
* select continuum data points
	NFIT = 0
      DO I=1,NWAVE
      IF( SIGMA(I) .GT. 0. ) THEN
	SIGMA(I) = - ABS( SIGMA(I) )
      DO IB=1,NBAND
      IF( WAVE(I) .GE. WLIM1(IB) .AND. WAVE(I) .LE. WLIM2(IB) ) THEN
	SIGMA(I) = ABS( SIGMA(I) )
	NFIT = NFIT + 1
      END IF
      END DO
      END IF
      END DO
	WRITE(*,*) 'ISPEC=', ISPEC, ' NWAVE=', NWAVE, ' NFIT=', NFIT

* convert to log-log for power-law fit
      IF( POWERLAW ) THEN
	WRITE(*,*) 'Converting wavelengths and fluxes to logs'
      DO I=1,NWAVE
	WAVE(I) = ALOG( WAVE(I) )
      IF( SIGMA(I).GT. 0. ) THEN
      IF( DATA(I) .GT. 0. ) THEN
	SIGMA(I) = SIGMA(I) / DATA(I)
	DATA(I) = ALOG( DATA(I) )
      ELSE
	SIGMA(I) = - SIGMA(I)
	NFIT = NFIT - 1
      END IF
      END IF
      END DO
      END IF
* fit poly continuum
	CALL POLYFITA( NWAVE, WAVE, DATA, SIGMA, CONT,
     #	npolyc, NCYCLE, THRHI, THRLO, IFAIL )
      IF( IFAIL.NE.0 ) THEN
	WRITE(*,*) CHAR(7), '** POLYFITA failed.', IFAIL
      END IF

* save fitted continuum
      IF( POWERLAW ) THEN
      DO I=1,NWAVE
	CONPIC(I,ISPEC) = EXP( CONT(I) )
      END DO
      ELSE
      DO I=1,NWAVE
        CONPIC(I,ISPEC) = CONT(I)
      END DO
      END IF
* next spectrum
      END DO
	GOTO 100

* rebin pixels

  180	WRITE(*,*) 'Z=', zshift
	call inq( 'O[bserved] or R[est] wavelengths?', 'R', reply )
	call upcase( reply, reply )
	ibinrest = -1
	if( reply(1:1) .eq. 'O' ) ibinrest = 0
	if( reply(1:1) .eq. 'R' ) ibinrest = 1
      if( ibinrest .lt. 0 ) then
	write(*,*) '** Invalid reply. Please try again.'
	goto 180
      end if

* remove redshift
      if( ibinrest .ne. 0 ) then
      DO I = 1, NSPEC
	NWAVE = nw_t( i )
      DO J = 1, NWAVE
	wavpic8( J, I ) = wavpic8( J, I ) / OPZ
      END DO
      END DO
	write(*,*) 'Observed -> Rest wavelengths'
      else
	write(*,*) 'Observed wavelengths:'
      end if

* report before binning
      do i = 1, nspec
	n = nw_t( i )
	plot1( i ) = wavpic8( 1, i )
	plot2( i ) = wavpic8( n, i )
	ip = min( 3, n )
	im = max( n-3, 1 )
	bdisp = ( wavpic8(ip,i) - wavpic8(1,i) ) / max( 1, ip - 1 )
	rdisp = ( wavpic8(n,i) - wavpic8(im,i) ) / max( 1, n - im )
	plot3(i) = bdisp
	plot4(i) = rdisp

	write(*,*) i, n, ' wobs:', plot1(i), plot2(i)
      end do
	call mnmxi( nspec, nw_t, mn, mx )
	call mnmx( nspec, plot1, blumn, blumx )
	call mnmx( nspec, plot2, redmn, redmx )
	wlo = blumn
	whi = redmx
	bjit = blumx - blumn
	rjit = redmx - redmn
	call medmad( nspec, plot3, bdisp, x )
	call medmad( nspec, plot4, rdisp, x )
	bjitpix = bjit / bdisp
	rjitpix = rjit / rdisp
	write(*,*)
	write(*,*) 'Spectra Nt', nspec, ' Wavelengths Nw', mn, mx
	write(*,*) ' Blu', blumn, blumx, ' diff', bjit, ' A', bjitpix, ' pix'
	write(*,*) ' Red', redmn, redmx, ' diff', rjit, ' A', rjitpix, ' pix'
	write(*,*) 'Full wavelength range:', wlo, whi, whi - wlo

	WRITE(*,*)
     &	'      pixel     wavelength(A)       (A/pix)     (km/s/pix)'
	nw = nw_t( 1 )
      do j = 1, nw
      if( j .le. 3 ..or. j .ge. nw-2
     &		.or. mod( j, nw/5 ) .eq. 0 ) then
	i =  max(1, min( nw, j ) )
	ip = min( i+1, nw )
	im = max( i-1, 1 )
	DANG = ( wavpic8(IP,1) - wavpic8(IM,1) ) / MAX(1,IP-IM)
	DKMS = CKMS * DANG / wavpic8(I,1)
	WRITE(*,*) I, wavpic8(I,1), DANG, DKMS
      end if
      END DO

* wavelength range
	write(*,*) 'Waves  Union:', blumn, redmx, ' A'
	write(*,*) 'Intersection:', blumx, redmn, ' A'
	write(*,*) '  Difference:', bjit, rjit, ' A'
	write(*,*) '             ', bjitpix, rjitpix, ' pix'
* union (round out by 1 Angstrom )
	kdiv = 1
	add = kdiv
	w1u = kdiv * nint( ( blumn - add ) / kdiv )
	w2u = kdiv * nint( ( redmx + add ) / kdiv )
* intersection ( round in by 1 Angstrom )
	w1n = kdiv * nint( ( blumx + add ) / kdiv )
	w2n = kdiv * nint( ( redmn - add ) / kdiv )
* default ( intersection rounded in by 10 A )
	kdiv = 10
	add = kdiv
	w1 = kdiv * nint( ( blumx + add ) / kdiv )
	w2 = kdiv * nint( ( redmn - add ) / kdiv )

	write(*,*) 'Enter -1 -1 for intersection', w1n, w2n
	write(*,*) '       1  1 for union       ', w1u, w2u
	write(*,*) '       0  0 for no binning'

* user choice
	call inq2r( 'Rebin Wavelength Range', w1, w2 )

* treat special cases
      if( w1 .eq. w2 ) then
	i = nint( w1 )
* union
      if( i .eq. +1 ) then
	w1 = w1u
	w2 = w2u
* intersection
      else if( i .eq. -1 ) then
	w1 = w1n
	w2 = w2n
* no binning
      else
	goto 188
      end if
      end if
* ascending wavelengths
	WAVE1 = MIN( W1, W2 )
	WAVE2 = MAX( W1, W2 )

* bin constraints

	WRITE(*,*) ' Minimum PIXELs, ANGSTROMs, KM/S per new bin ? '
	val1 = max( 1, npixbin )
	val2 = max( 0., dang )
	val3 = max( 0., dkms )
	val2 = 0.
	val3 = 0.
	call inq3r( 'Min Pix, Ang, Km/s', val1, val2, val3 )
	npixbin = max( 1, nint( val1 ) )
	dang = max( 0., val2 )
	dkms = max( 0., val3 )

	nbin = npixbin
	write(*,*) 'Adopted Min Pix/Ang/Kms:', nbin, dang, dkms
c	read(*,*)

	IF( NBIN.LE.0 .AND. DANG.LE.0. .AND. DKMS.LE.0. ) GOTO 188
	VFACTOR = EXP( ABS( DKMS / CKMS ) )

* loop thru spectra
      DO ISPEC = 1, NSPEC
	NWAVE = nw_t( ispec )
	wlo = min( wavpic8( 1, ispec ), wavpic8( nwave, ispec ) )
	whi = max( wavpic8( 1, ispec ), wavpic8( nwave, ispec ) )
	disp = ( whi - wlo ) / max( 1, nwave - 1 )
	write(*,*)
	WRITE(*,*) 'ISPEC=', ISPEC, ' Pixels:', NWAVE, disp, ' A/pix'
	WRITE(*,*) 'waves:', wlo, whi, ' span:', whi-wlo

* first pixel
	IW1 = 0
      DO I = 1, NWAVE
	TEST = ABS( wavpic8(I,ISPEC) - WAVE1 )
      IF( IW1 .LE. 0 .OR. TEST .LT. BEST ) THEN
	BEST = TEST
	IW1 = I
      END IF
      END DO
	WRITE(*,*) IW1, WAVE1, wavpic8(IW1,ISPEC), wavpic8(IW1,ISPEC) - WAVE1

* last pixel
	IW2 = 0
      DO I=1,NWAVE
	TEST = ABS( wavpic8(I,ISPEC) - WAVE2 )
      IF( IW2 .LE. 0 .OR. TEST .LT. BEST ) THEN
	BEST = TEST
	IW2 = I
      END IF
      END DO
	WRITE(*,*) IW2, WAVE2, wavpic8(IW2,ISPEC), wavpic8(IW2,ISPEC) - WAVE2
	IWAV1 = MIN( IW1, IW2 )
	IWAV2 = MAX( IW1, IW2 )
	NPIXIN = IWAV2 - IWAV1 + 1
	write(*,*) 'Input pixels:', IWAV1, ' thru', IWAV2, ' =', NPIXIN

	IPUT = 0
* pixel range to average : I1 to I2 inclusive
	I2 = IWAV1-1
* pixel limits of next bin
  185	I1 = I2 + 1
	I2 = I2 + MAX( 1, NBIN )
* wavelength span required for this bin
	WMAX = MAX( wavpic8( I1, ISPEC ) * VFACTOR,
     &		wavpic8( I1, ISPEC ) + DANG )
	WMIN = MIN( wavpic8( I1, ISPEC ) / VFACTOR,
     &		wavpic8( I1, ISPEC ) - DANG )
* add a pixel (if needed)
  187 IF( wavpic8( I2, ISPEC ) .GT. WMIN
     &	.AND. wavpic8( I2, ISPEC ) .LT. WMAX ) THEN
	I2 = I2 + 1
	IF( I2 .LT. IWAV2 ) GOTO 187
	write(*,*) 'Bin', iput+1, ' pixels', i1, i2, i2-i1+1
      END IF

* count all and good pixels
	NSUM = 0
	NSUMG = 0
	sigok = 0.D0
      DO I = I1, I2
	s = sigpic( i, ispec )
	NSUM = NSUM + 1
      if( s .gt. 0. ) then
	NSUMG = NSUMG + 1
	if( nsumg .eq. 1 ) sigok = s
	sigok = min( s, sigok )
c	sigok = sigok + s
      else
	d = datpic( i, ispec )
	w = wavpic8( i, ispec )
	write(*,*) '** pix', i, ' lam', nint(w), ' dat', d, ' sig', s
      end if
      END DO
* sigok = mean of positive error bars
c	sigok = sigok / max( 1, nsumg )
	if( sigok .le. 0. ) sigok = 1.D0

	SUMW = 0.D0
	SUM = 0.D0
	SUMA = 0.D0
	SUMC = 0.D0
	SUMV = 0.D0
	SUMJ = 0.D0
	EPS = 1000
	N = 0
      DO I = I1, I2
* pixels with positive error bar (or all if none are good)
	s = sigpic( i, ispec )
      if( s .gt. 0. .or. nsumg .le. 0 ) then
	N = N + 1
	SUM  = SUM  + DATPIC( I, ISPEC )
	SUMW = SUMW + wavpic8( I, ISPEC )
	SUMC = SUMC + CONPIC( I, ISPEC )
	SUMA = SUMA + ABSPIC( I, ISPEC )
* KDH : scale by sigok to avoid underflow/overflow
	s = s / sigok
	SUMV = SUMV + s * s
	SUMJ = SUMJ + SIGPIXPIC( I, ISPEC ) * SIGPIXPIC( I, ISPEC )
      end if
	EPS = MIN( EPS, EPSPIC( I, ISPEC ) )
      END DO

* uncertainty due to wavelength jitter
* KDH : COULD USE SIGOK SCALING HERE 
	sig1 = ddatdpixpic( i1, ispec ) * sigpixpic( i1, ispec ) 
      if( i2 .eq. i1 ) then
	varj = sig1 * sig1
      else
	sig2 = ddatdpixpic( i2, ispec ) * sigpixpic( i2, ispec ) 
	varj = ( sig1 + sig2 )**2
      end if

* trap errors
* empty bin
	ibad = 0
      if( nsum .le. 0 ) then
	write(*,*) '** ERROR : NO PIXELS. NSUM', nsum
	ibad = ibad + 100
      end if

* invalid wavelength
      if( sumw .le. 0.d0 ) then
	write(*,*) '** ERROR : INVALID WAVELENGTH. SUMW', sumw
	ibad = ibad + 10
      end if

* invalid error bar
      if( sumv .le. 0.d0 ) then
	write(*,*) '** ERROR : INVALID ERROR BAR. SUMV', sumv
	ibad = ibad + 1
      end if

* terminate fatal error
      if( ibad .ne. 0 ) then
	write(*,*) '** ISPEC', ispec, ' BIN', IPUT + 1, ' PIXELS', I1, I2
      if( nsum .gt. 1 ) then
	write(*,*) '** LAM:', ( wavpic8( i, ispec ), i = i1, i2 )
	write(*,*) '** DAT:', ( datpic( i, ispec ), i = i1, i2 )
	write(*,*) '** SIG:', ( sigpic( i, ispec ), i = i1, i2 )
	write(*,*) '** EPS:', ( epspic( i, ispec ), i = i1, i2 )
      else if( nsum .gt. 0 ) then
	write(*,*) '** LAM:', ( wavpic8( i, ispec ), i = i1, i2 )
     &		, ' DAT:', ( datpic( i, ispec ), i = i1, i2 )
     &		, ' SIG:', ( sigpic( i, ispec ), i = i1, i2 )
     &		, ' EPS:', ( epspic( i, ispec ), i = i1, i2 )
      end if
	if( ibad .gt. 1 ) STOP
      end if

* stow mean values
* KDH : N IS NOW CALCULATED IN THE LOOP ABOVE
C	N = MAX( 1, NSUM )
C	IF( NSUMG .GT. 0 ) N = MAX( 1, MIN( N, NSUMG ) )
	N = MAX( N, 1 )
	IPUT = IPUT + 1
	wavpic8( IPUT, ISPEC ) = SUMW / N
	DATPIC( IPUT, ISPEC ) = SUM / N
	CONPIC( IPUT, ISPEC ) = SUMC / N
	ABSPIC( IPUT, ISPEC ) = SUMA / N
	SIGPIC( IPUT, ISPEC ) = sigok * DSQRT( MAX( 0.D0, SUMV ) ) / N
	EPSPIC( IPUT, ISPEC ) = EPS
* KDH COULD USE SIGOK SCALING HERE
	SIGPIXPIC( IPUT, ISPEC ) = SQRT( SUMJ / N ) / N
	SIGJITPIC( IPUT, ISPEC ) = sqrt( max( 0.d0, varj ) ) / N

* report warning of bad pixels
      if( nsumg .lt. nsum ) then
	w = wavpic8( iput, ispec )
	write(*,*) '** WARNING: BIN', IPUT, ' LAM', NINT( W ),
     &		' BAD PIX', nsum-nsumg, ' OF', nsum
* mark bin with sig<0 if no good data
      if( nsumg .le. 0 ) then
	s = -sigpic( iput, ispec )
	if( s .eq. 0. ) s = -1.
	sigpic( iput, ispec ) = s
      end if
      end if

* next new pixel
	IF( I2 .LE. IWAV2 - NBIN ) GOTO 185
* total number of new pixels
	nw_t( ispec ) = IPUT
	WRITE(*,*) 'NPIX=', IWAV2 - IWAV1 + 1, ' NEWPIX=', nw_t( ispec )
* derivative of spectrum
      DO I = 1, IPUT
	IM = MAX( I - 1, 1 )
	IP = MIN( I + 1, IPUT )
	DP = DATPIC( IP, ISPEC )
	DM = DATPIC( IM, ISPEC )
	DDATDPIXPIC( I, ISPEC ) = ( DP - DM ) / MAX( 1, IP - IM )
      END DO
* next spectrum
       END DO

* report - give the pre-binning specs
	write(*,*)
	write(*,*) 'Before Binning:'
	write(*,*) 'Spectra', nspec, ' Nw', mn, mx
	write(*,*) ' Blu', blumn, blumx, ' dif', bjit, ' A', bjitpix, ' pix'
	write(*,*) ' Red', redmn, redmx, ' dif', rjit, ' A', rjitpix, ' pix'
	write(*,*) 'Full wavelength range:', wlo, whi, whi - wlo

* compute post-binning specs

  186 do i = 1, nspec
	n = nw_t( i )
	plot1(i) = wavpic8( 1, i )
	plot2(i) = wavpic8( n, i )
	ip = min( 3, n )
	im = max( n-3, 1 )
	bdisp = ( wavpic8( ip, i ) - wavpic8(  1, i ) ) / max( 1, ip - 1 )
	rdisp = ( wavpic8(  n, i ) - wavpic8( im, i ) ) / max( 1, n - im )
	plot3(i) = bdisp
	plot4(i) = rdisp
      end do

* report after binning
	call mnmxi( nspec, nw_t, mn, mx )
	call mnmx( nspec, plot1, blumn, blumx )
	call mnmx( nspec, plot2, redmn, redmx )
	wlo = blumn
	whi = redmx
	bjit = blumx - blumn
	rjit = redmx - redmn
	call medmad( nspec, plot3, bdisp, x )
	call medmad( nspec, plot4, rdisp, x )
	bjitpix = bjit / bdisp
	rjitpix = rjit / rdisp
	write(*,*)
	write(*,*) 'After Binning:'
	write(*,*) 'Spectra Nt', nspec, ' Wavelengths Nw', mn, mx
	write(*,*) ' Blu', blumn, blumx, ' dif', bjit, ' A', bjitpix, ' pix'
	write(*,*) ' Red', redmn, redmx, ' dif', rjit, ' A', rjitpix, ' pix'
	write(*,*) 'Full wavelength range:', wlo, whi, whi - wlo

* pixel count mismatch
      if( mx .ne. mn ) then
	write(*,*)
	write(*,*) '** WARNING: BINNED SPECTRA HAVE DIFFERENT NUMBER OF PIXELS.'
	write(*,*) '** NW_T:', ( nw_t(i),i=1,nspec )
	write(*,*) '** NEWPIX RANGES FROM ', mn, ' TO', mx
	write(*,*) '** SNIP', mx-mn, ' PIXEL(S) OFF THE END, LEAVING', mn, ' PIXELS.'
	call inq(' OK to snip? (Y/N) ?', 'Y', reply )
	call upcase( reply, reply )
      if( reply .eq. 'Y' ) then
      do i = 1, nspec
	nw_t( i ) = mn
      end do
	write(*,*) 'Spectra snipped to', mn, ' pixels.'
	goto 186
      else
	write(*,*) 'Spectra NOT snipped.'
      end if
c	stop
      end if

* abort if end wavelength grids don't match
      if( mn .ne. mx .or. abs(bjitpix) .gt. 1.0
     &		.or. abs(rjitpix) .gt. 1.0 ) then
	write(*,*)
	write(*,*) '** WARNING: UNEQUAL WAVELENGTH GRIDS AFTER BINNING'
	if( mn .ne. mx ) write(*,*) 'Nw:', ( nw_t( i ), i=1,nspec )
	call inq(' OK to proceed? (Y/N) ?', 'N', reply )
	call upcase( reply, reply )
	if( reply .ne. 'Y' ) stop
      end if


* check for good data at all wavelengths
	nw = mn
	nt = nspec
	i1 = nw
	i2 = 0
      do iw = 1, nw
	ng = 0
      do it = 1, nt
	wav = wavpic8( iw, it )
	dat = datpic( iw, it )
	sig = sigpic( iw, it )
	if( wav .gt. 0. .and. sig .gt. 0. ) ng = ng + 1
	plot1( it ) = wav
	plot2( it ) = dat
	plot3( it ) = sig
      end do

* report if no data found
      if( ng .le. 0 ) then
	write(*,*)
	write(*,*) '** NO DATA FOR PIXEL', iw, ' OF', nw
	call mnmx( nt, plot1, wmn, wmx )
	call mnmx( nt, plot2, dmn, dmx )
	call mnmx( nt, plot3, smn, smx )
	write(*,*) '** lam', wmn, wmx
	write(*,*) '** dat', dmn, dmx
	write(*,*) '** sig', smn, smx
      if( nt .lt. 50 ) then
c	jump = max( 1, nt / 50 )
	jump = 1
	if( wmx .ne. wmn ) write(*,*) '** lam', ( plot1( i ), i = 1, nt, jump )
	if( dmx .ne. dmn ) write(*,*) '** dat', ( plot2( i ), i = 1, nt, jump )
	if( smx .ne. smn ) write(*,*) '** sig', ( plot3( i ), i = 1, nt, jump )
      end if
      else
	i1 = min( i1, iw )
	i2 = max( i2, iw ) 
      end if
* next time it
      end do

	label = 'Pixel range with good data: ('
	call append_i( label, i1 )
	call append_i( label, i2 )
	call append( label, ') =' )
	call append_i( label, i2 - i1 + 1 )
	call append( label, 'of' )
	call append_i( label, nw )
	write(*,*) label( : len1( label ) )

      if( i1 .gt. 1 .or. i2 .lt. nw ) then
	if( i1 .gt. 1 ) write(*,*) 'Clip pixels', 1, ' to', i1-1, ' =', i1-1
	if( i2 .lt. nw ) write(*,*) 'Clip pixels', i2+1, ' to', nw, ' =', nw-i2
      do it = 1, nt
	iw = 0
      do i = i1, i2
	iw = iw + 1
	wavpic8( iw, it ) = wavpic8( i, it )
	DATPIC( iw, it ) = datpic( i, it )
	CONPIC( iw, it ) = conpic( i, it )
	ABSPIC( iw, it ) = abspic( i, it )
	SIGPIC( iw, it ) = sigpic( i, it )
	EPSPIC( iw, it ) = epspic( i, it )
	SIGPIXPIC( iw, it ) = sigpixpic( i, it )
	SIGJITPIC( iw, it ) = sigjitpic( i, it )
	DDATDPIXPIC( iw, it ) = ddatdpixpic( i, it )
      end do
	nw_t( it ) = iw
      end do
	write(*,*) 'Clipped pixels', nw-iw, ' of', nw, ' =', (nw-iw)*100./nw, ' %'
	write(*,*) 'Nw=', nw, ' =>', iw 
	nw = iw
      end if

* re-apply redshift
  188 if( ibinrest .ne. 0 ) then
      DO I=1,NSPEC
	NWAVE = nw_t( i )
      DO J=1,NWAVE
	wavpic8( J, I ) = wavpic8( J, I ) * OPZ
      END DO
      END DO
	write(*,*) 'rest -> observed wavelengths'
      end if

	nwave = nw_t( 1 )
      do i = 1, nwave
	wave( i ) = wavpic8( i, 1 )
      end do

	GOTO 100

* plot spectra

  200	isplit_avg_rms = 1
	isplit_avg_rms_slope = 2
	isplit_all = 0

	f = 10. ** ( inflxdex - iflxdex )
	write(*,*) 'y axis flux units', 1. / f

	WRITE(*,*) 'NSPEC=', NSPEC
	WRITE(*,*) 'ISPLIT=0 for individual spectra (default)'
	WRITE(*,*) '      -X offset X flux units between spectra'
	WRITE(*,*) '       1 for AVG and RMS spectra'
	WRITE(*,*) '       2 for AVG, RMS and SLOPE'

	WRITE(*,'(A,$)') ' First and Last spectrum & ISPLIT : '
	READ(*,'(A)') REPLY


	IER = 1
	offset = 0.
	READ(REPLY,*,ERR=201,END=201 ) ISPEC1, ISPEC2, VAL


* offset between spectra
      if( val .le. 0 ) then
	isplit = 0
	offset = abs( val )
	ier = 0
      else if( val .le. 2 ) then
	isplit = nint( val )
	offset = 0.
	ier = 0
      else
	ier = 1
      end if
	write(*,*) 'Offset between spectra:', offset

  201 IF( IER .NE. 0 ) THEN
	ISPLIT = 0
	READ(REPLY,*,ERR=202,END=202 ) ISPEC1, ISPEC2
	IER = 0
  202 IF( IER .NE. 0 ) THEN
	READ(REPLY,*,ERR=100,END=100 ) ISPEC1
	ispec2 = ispec1
      END IF
      END IF

  203	IF( ISPEC2 .LT. ISPEC1 ) GOTO 100
	ISPEC1 = MAX( ISPEC1, 1 )
	ISPEC2 = MIN( ISPEC2, NSPEC )


* stow spectrum range and number (for later use)
	isp1 = ispec1
	isp2 = ispec2
	nsp = isp2 - isp1 + 1

  205	write(*,*) ispec1, ispec2, nspec
	write(*,*) isp1, isp2, nsp


* report
	if( isplit .eq. isplit_all )
     &		write(*,*) 'Plot', nsp, ' spectra offset by', offset
	if( isplit .eq. isplit_avg_rms )
     &		write(*,*) 'Plot AVG and RMS of', nsp, ' spectra.'
	if( isplit .eq. isplit_avg_rms_slope )
     &		write(*,*) 'Plot AVG, RMS and SLOPE of', nsp, ' spectra.'


* NWAVE = max number of wavelengths over all spectra
	NWAVE = NW_t( ispec1 )
      DO I = ISPEC1, ISPEC2
	N = NW_T( I )
	NWAVE = MAX( NWAVE, N )
	w1 = wavpic8( 1, i )
	w2 = wavpic8( n, i )
	call medmad( n, datpic(1,i), dmed,  dmad )

* report (useful to have list of spectra on the plot)
	title = 'spec'
	call append_i( title, i )
	call append( title, 'Nw' )
	call append_i( title, n )
	call append_i( title, nint( w1 ) )
	call append_i( title, nint( w2 ) )
	l = len1( specname( i ) )
	call append( title, specname( i )( : l ) )
	call append( title, 'med' )
	call append_n( title, dmed, 2 )
	call append( title, 'mad' )
	p = dmad * 100. / dmed
	call append_n( title, p, 2 )
	call append( title, '%' )
	write(*,*) title( : len1( title ) )

* next spectrum i
      END DO
* report
	write(*,*) 'Nt', ispec2-ispec1+1, ' Spectra', ispec1, ispec2
	write(*,*) 'Nw', nwave, ' z', zshift, ' 1+z', opz


* plot format
	nx = 1
	ny = 1
	npan = 1

* multi-panel
      if( isplit .le. 0 ) then
c	npan = ispec2 - ispec1 + 1
	npan = isp2 - isp1 + 1
	if( isplit .ne. 0 ) ny = npan
      end if
	write(*,*) 'nx,ny,npan', nx, ny, npan

* open
* KDH 2023 FEB - DEFER
      IF( .FALSE. ) THEN
	CALL PGSTART( nx, ny, notused )
	lwide = lwidedef
	call pgslw( lwide )
	csize = csizedef
	call pgsch( csize )
	call pgbgw
      END IF

* full data range
	dmnall = datpic(1,isp1)
	dmxall = dmnall
	wmnall = wavpic8(1,isp1)
	wmxall = wmnall
c	WRITE(*,*) 'isp1', isp1, ' isp2', isp2
      do i = isp1, isp2
	n = nw_t(i)
	call dmnmx( n, wavpic8(1,i), wmn8, wmx8 )
	call  mnmx( n, datpic(1,i), dmn,  dmx )
	call  mnmx( n, sigpic(1,i), smn,  smx )
c	write(*,*) i, n, real(wmn8), real(wmx8), dmn, dmx
	dmnall = min( dmnall, dmn )
	dmxall = max( dmxall, dmx )
	wmnall = min( wmnall, real(wmn8) )
	wmxall = max( wmxall, real(wmn8) )
      end do
* KDH : USE THIS LATER FOR PLOT WINDOW
	write(*,*) 'Waves', wmnall, wmxall, ' Data', dmnall, dmxall

* flux scale factor
	flxscl = 10. ** ( inflxdex - iflxdex )
	f = flxscl
	write(*,*) 'Flux scale factor:', f

* loop over plot panels
      do ipan = 1, npan
c	write(*,*) 'Panel', ipan, ' of', npan

* restrict spectrum range for this panel
* KDH : 1 spectrum per "panel", with vertical offsets
      if( isplit .le. 0 ) then
	isp = isp1 + ipan - 1
	ispec1 = isp
	ispec2 = isp
c	write(*,*) 'Panel', ipan, ' Spectrum', isp
      end if

* report range of spectra on this panel
      if( ispec1 .ne. ispec2 ) then
c	write(*,*)
	write(*,*) 'Spectra (', ispec1, ' thru', ispec2, ') =', ispec2-ispec1+1
      else
	nwave = nw_t( ispec1 )
	write(*,*) 'Spectrum', ispec1, ' Nw', nwave
      end if

* report data range for this panel
      do i = ispec1, ispec2
	n = nw_t(i)
	call dmnmx( n, wavpic8(1,i), wmn8, wmx8 )
	call  mnmx( n, datpic(1,i), dmn,  dmx )
	call  mnmx( n, sigpic(1,i), smn,  smx )
c	write(*,*) i, n, real(wmn8), real(wmx8), dmn*f, dmx*f
      end do


* wavelength loop
* KDH : be careful not to use i inside this loop
      DO I=1,NWAVE
* report 
      IF( .FALSE. ) THEN
* KDH: AVOID FAILURE IF I > NW_T(ISPEC1)
c      if( mod(i,max(1,nwave/nprint)) .eq. 1 ) then
	n = nw_t( ispec1 )
      if( i .eq. 1 .or. i .eq. n .or. mod(i,max(1,n/5)) .eq. 0 ) then
	write(*,*) i, wavpic8(i,ispec1), datpic(i,ispec1)*f, sigpic(i,ispec1)*f
      end if
      END IF

* mean error bar SIG0 (for scaling weights)
* KDH : SAFER TO USE MEDIAN ?
* KDH : USE SIGOK = SMALLEST POSITIVE ERROR BAR
	SIG0 = 0.D0
	SIGJ = 0.D0
	NSUM = 0
	sigok = 0.D0
      DO ISPEC = ISPEC1, ISPEC2
	last = nw_t( ispec )
      IF( I .LE. last ) THEN
	s = sigpic( i, ispec )
      IF( S .GT. 0. ) THEN
	SIG0 = SIG0 + s
	SIGJ = SIGJ + SIGJITPIC(I,ISPEC)
	NSUM = NSUM + 1
* smallest positive error bar
	if( nsum .eq. 1 ) sigok = s
	sigok = min( sigok, DBLE(s) )
      END IF
      END IF
      END DO
	nsumg = nsum
	SIG0 = SIG0 / MAX(1,NSUM)
	SIGJ = SIGJ / MAX(1,NSUM)
* report
      if( nsum .le. 0 .or. sig0 .le. 0.D0 .OR. SIGOK .LE. 0.D0) then
	write(*,*) '**', i, ' nsum', nsum, ' sig0', sig0, ' sigOK', SIGOK, ' no valid data :(.'
      end if

* prevent divide by 0
	if( SIG0 .LE. 0.D0 ) SIG0 = 1.D0
	if( sigok .le. 0.D0 ) sigok = 1.D0
* sums over time
	NSUM = 0
	SUM = 0.D0
	SUMD = 0.D0
	SUMC = 0.D0
	SUMW = 0.D0
	SUMA = 0.D0
	SUMT = 0.D0
	EPS = 1000.
      DO ISPEC = ISPEC1, ISPEC2
	last = nw_t( ispec )
      IF( I .LE. last ) THEN
	s = sigpic( i, ispec )
	wgt = 1.
	if( nsumg .gt. 0 .and. s .gt. 0. ) WGT = ( SIGok / s )**2
      IF( s .GT. 0. .and. wgt .gt. 0. ) THEN
	NSUM = NSUM + 1
	SUM = SUM + WGT
	SUMD = SUMD + WGT * DATPIC(I,ISPEC)
	SUMC = SUMC + WGT * CONPIC(I,ISPEC)
	SUMW = SUMW + WGT * wavpic8(I,ISPEC) / OPZ
	SUMA = SUMA + WGT * ABSPIC(I,ISPEC)
	SUMT = SUMT + WGT * TIME8(ISPEC)
	EPS = MIN( EPS, EPSPIC(I,ISPEC) )
      END IF
* KDH : debug report
c      if( i .ge. last - 1 ) then
c	write(*,*) i, ispec, ' wgt=(', sigok, ' /', s, ' )^2=', wgt, ' sum', sum
c      end if
      END IF
* next ispec
      END DO
	IF( NSUM.LE.0 ) SUM = 1.D0

* KDH : DEBUG REPORT
      if( nsum .le. 0 .or. sum .le. 0. .or. sum .ne. sum ) then
	write(*,*) '** pix', i, ' nsum', nsum, ' sum', sum, ' no data :(.'
	sum = 1.
      end if

* mean values
	DATA(I) = SUMD / SUM
	CONT(I) = SUMC / SUM
	SIGSYS(I) = SYSERB * 0.01 * DATA(I)
	add = sigsys( i ) / sigok
	SIGMA(I) = sigok * DSQRT( 1.d0 / SUM + add * add )
	SIGJIT(I) = SIGJ / SUM
	ABSN(I) = SUMA / SUM
	WAVE8(I) = SUMW / SUM
	IF( NSUM.LE.0 ) WAVE8(I) = wavpic8(I,ISPEC1) / OPZ
	WAVE(I) = WAVE8(I)
	XPLOT(I) = WAVE(I)

c KDH : DEBUG REPORT
c      if( xplot(i) .ne. xplot(i) ) then
c	write(*,*) '** xplot(', i, ' )=',  sumw, ' /', sum, ' =', xplot(i)
c	write(*,*) '** data', data(i), ' sigma', sigma(i), ' :(.'
c      end if

      IF( REST0 .GT. 0.D0 ) THEN
	XPLOT(I) = CKMS * ( WAVE8(I) - REST0 ) / REST0
      END IF
	IF( NSUM.LE.0 ) EPS = -1000.
	EPSILON(I) = EPS
* mean and rms time
	TBAR = SUMT / SUM
	SUMTT = 0.D0
      DO ISPEC = ISPEC1, ISPEC2
      IF( I .LE. NW_t( ispec ) ) THEN
      IF( SIGPIC(I,ISPEC) .GT. 0. ) THEN
	WGT = ( SIGok / SIGPIC(I,ISPEC) )**2
	SUMTT = SUMTT + WGT * (TIME8(ISPEC)-TBAR) **2
      END IF
      END IF
* next ispec
      END DO
	TRMS = SQRT( MAX(0.D0, SUMTT / SUM ) )
	IF( NSUM.LE.1 ) TRMS = 1.D0
* analysis of time variance
	SUMDD = 0.D0
	SUMCC = 0.D0
	SUMDT = 0.D0
	SUMCT = 0.D0
      DO ISPEC = ISPEC1, ISPEC2
      IF( I .LE. nw_t( ispec ) ) THEN
      IF( SIGPIC(I,ISPEC) .GT. 0. ) THEN
	WGT = ( SIGok / SIGPIC(I,ISPEC) )**2
	TIM = ( TIME8(ISPEC) - TBAR ) / TRMS
	DAT = DATPIC(I,ISPEC) - DATA(I)
	CON = CONPIC(I,ISPEC) - CONT(I)
	SUMDD = SUMDD + WGT * DAT * DAT
	SUMCC = SUMCC + WGT * CON * CON
	SUMDT = SUMDT + WGT * DAT * TIM
	SUMCT = SUMCT + WGT * CON * TIM 
      END IF
      END IF
* next ispec
      END DO
* rms of slow variations
	DATSLO(I) = SUMDT / SUM
	SYSSLO(I) = SYSERB * 0.01 * 0.
	add = sysslo(i) / sigok
	SIGSLO(I) = sigok * SQRT( 1.0 / SUM + add * add )
	CONSLO(I) = SUMCT / SUM
* rms of slow and fast variations
      IF( ISPLIT.EQ. isplit_avg_rms ) THEN
	DATRMS(I) = ( SUMDD - SIGok * SIGok * MAX(0,NSUM-1) )/ SUM
	DATRMS(I) = SQRT( MAX( 0., DATRMS(I) ) )
	STDRMS(I) = DATRMS(I) / SQRT( MAX(1.,FLOAT(NSUM-1)) )
	CONRMS(I) = SUMCC / SUM
	CONRMS(I) = SQRT( MAX( 0., CONRMS(I) ) )
* rms of fast variations
      ELSE IF( ISPLIT.EQ. isplit_avg_rms_slope ) THEN
	DATRMS(I) = ( SUMDD - SUMDT/SUM*SUMDT
     #		- SIGok * SIGok * MAX(0,NSUM-2) ) / SUM
	DATRMS(I) = SQRT( MAX( 0., DATRMS(I) ) )
	STDRMS(I) = DATRMS(I) / SQRT( MAX(1.,FLOAT(NSUM-2)) )
	CONRMS(I) = ( SUMCC - SUMCT/SUM*SUMCT ) / SUM
	CONRMS(I) = SQRT( MAX( 0., CONRMS(I) ) )
      END IF

* next wavelength I
       END DO


* frame first panel
      if( ipan .eq. 1 ) then

* title
      IF( ISP1 .eq. ISP2 ) THEN
	title = ' '
	call append_i( title, isp1 )
	call append( title, specname( isp1 ) )
c	TITLE = SPECNAME( ISP1 )
	call append( title, timebase )
	call append_f( title, time( ispec1 ), '(f15.4)' )
      ELSE
	title = ' '
	call append_i( title, isp1 )
	call append_i( title, isp2 )
	call append( title, timebase(:len1(timebase)) )
	call append_f( title, time( isp1 ), '(F15.3)' )
	call append_f( title, time( isp2 ), '(F15.3)' )
	call append( title, 'N\dt\u' )
	call append_i( title, isp2 - isp1 + 1 )
      END IF
	write(*,*) ' ', title(:len1(title))

* xlabel
	XLABEL = '\gl (\A)'
	IF( REST0 .GT. 0. ) WRITE( XLABEL, '(A,F9.2)' )
     #	'velocity (km/s)  \gl\d0\u=', REST0
	IF( ZSHIFT .NE. 0.D0 ) WRITE( XLABEL, '(A,F8.6)')
     #	XLABEL(:LEN1(XLABEL)) // '  z=', ZSHIFT
* y label
	call plotlabel_flux( ylabel, fluxunit, iflxdex )
* window
	CALL MNMX( NWAVE, XPLOT, XMN, XMX )
	CALL MNMX( NWAVE, DATA, YMN, YMX )
	write(*,*) 'XPLOT', XMN, XPLOT(1), XPLOT(NWAVE), XMX
	write(*,*) ' DATA', YMN*f, DATA(1)*f, DATA(NWAVE)*f, YMX*f


	CALL PGLIMIT( NWAVE, XPLOT, XMN, XMX, 0. )
	CALL PGLIMIT( NWAVE, DATA, YMN, YMX, 0. )

* KDH: TRY THIS TO COVER FULL RANGE OF DATA
      if( isplit .eq. isplit_all ) then
	ymn = dmnall
	ymx = dmxall
      end if

	YMN = MIN( YMN, 0. )
	YMX = MAX( YMX, 0. )
      IF( ISPLIT .ge. isplit_avg_rms_slope ) THEN
      DO I=1,NWAVE
	YMN = MIN( YMN, 0., DATSLO(I) )
	YMX = MAX( YMX, 0., DATSLO(I), DATRMS(I) )
      END DO
      END IF
	YMX = 1.05*YMX
	XRNG = ABS( XMX - XMN )
	XMN = XMN - 0.025*XRNG
	XMX = XMX + 0.025*XRNG

* edit plot window

	f = flxscl
	write(*,*) 'Flux scale factor', f
* scale y range
	YMN = YMN * f
	ymx = ymx * f

* expand y range for offsets
	write(*,*) 'Offset between spectra', offset

* expand window for offsets
      if( isplit .eq. 0 .and. offset .ne. 0 ) then
	noff = isp2 - isp1
	add = noff * offset
	write(*,*) 'Add to Ymx:', noff, ' x', offset, ' =', add
	ymx = ymx + add
      end if


* user choice
	IFAIL = PGEWIN( XMN, XMX, YMN, YMX )
* unscale y range
	ymn = ymn / f
	ymx = ymx / f
	IF( IFAIL.GT.0 ) GOTO 100

* 2023 FEB KDH - OPEN THE PLOT HERE ?

	CALL PGSTART( nx, ny, notused )
	lwide = lwidedef
	call pgslw( lwide )
	csize = csizedef
	call pgsch( csize )
	call pgbgw


* window
	CALL PGSCI( kolor_axis )
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	CALL PGENV( XMN, XMX, YMN * f, YMX * f, 0, 0 )
	call pgswin( xmn, xmx, ymn, ymx )
	CALL PGMOVE( XMN, 0. )
	CALL PGDRAW( XMX, 0. )

* mark lines
	call pgsls( kdot )
      DO I=1,MARKLINE
	XLINE = rest_l(I)
	IF( REST0 .GT. 0.D0 ) XLINE = CKMS * ( REST_L(I) - REST0 ) / REST0
	call pgsci( kolor_axis )
	if( nabc( i ) .eq. narrow ) call pgsci( kolor_nlr )
	CALL PGMOVE( XLINE, YMN )
	CALL PGDRAW( XLINE, YMX )
      END DO
	call pgsls( 1 )

* mark absorption lines
      if( dips ) then
	call markdips( nl, ltype_l, wobs_l, ymn, ymx, real(zshift) )
	call pgsci( kblack )
      end if

* mark balmer continuum
	call pgsci( kolor_bac )
	xline = bac2
	IF( REST0 .GT. 0.D0 ) XLINE = CKMS * ( XLINE - REST0 ) / REST0
	call pgmove( xline, ymn )
	call pgdraw( xline, ymx )

* mark Lyman continuum
	call pgsci( kolor_lyc )
	xline = wlyc2
	IF( REST0 .GT. 0.D0 ) XLINE = CKMS * ( XLINE - REST0 ) / REST0
	call pgmove( xline, ymn )
	call pgdraw( xline, ymx )

* mark paschen continuum
	call pgsci( kolor_pac )
	xline = pac2
	IF( REST0 .GT. 0.D0 ) XLINE = CKMS * ( XLINE - REST0 ) / REST0
	call pgmove( xline, ymn )
	call pgdraw( xline, ymx )

	call pgsls(1)

* mark continuum bands
      if( nband .gt. 0 ) then
	call pgsci( kgreen )
	call pgsci( kred )
	call pgsci( korange )
	p = 0.95
	y = ymn * ( 1.-p ) + ymx * p 
      do i=1,nband
	call pgmove( wlim1(i), y )
	call pgdraw( wlim2(i), y )
      end do
      end if

* labels
	CALL PGSCI( kolor_label )
	CALL PGLABEL( XLABEL, YLABEL, TITLE )
* legend
	call pgmtxt( 'T', 0.5, 0., 0., agn )
	call makelegend( legend, npolyc, syserb )
	call pgmtxt( 'T', 0.5, 1.0, 1.0, legend )

* first panel framed
      end if

* plot epsilon array (range -1000 to 1000 )
	CALL PGSWIN( XMN, XMX, -1e5, 2000. )
	kolor_eps = korange
	CALL PGSCI( kolor_eps )
	CALL PGBIN( NWAVE, XPLOT, EPSILON, .TRUE. )

* plot absorption
	AMN = ABSN(1)
	AMX = AMN
      DO I=1,NWAVE
	AMN = MIN( AMN, ABSN(I) )
	AMX = MAX( AMX, ABSN(I) )
      END DO
      IF( AMN.LT.AMX ) THEN
	write(*,*) 'ABSN', AMN, AMX
	CALL PGSCI( korange )
	CALL PGSWIN( XMN, XMX, -1., 1. )
	CALL PGBIN( NWAVE, XPLOT, ABSN, .TRUE. )
      END IF

* plot AVG spectrum
	CALL PGSWIN( XMN, XMX, YMN, YMX )
	CALL PGSCI( kolor_axis )
	if( isplit .gt. 0 ) call pgsci( kblack )

* shift plot window to implement offset
      if( offset .gt. 0. ) then
	add = ( isp - isp1 ) * offset / f
c	write(*,*) 'Spectrum', isp, ' offset', add
	call pgswin( xmn, xmx, ymn-add, ymx-add )
      end if

* histogram data
	CALL PGBIN( NWAVE, XPLOT, DATA, .TRUE. )

* right margin label
	n = max( 1, nint( nwave / 10. ) )
	i = nwave - n + 1
	call medmad( n, data( i ), dmed, dmad )
c	write(*,*) ' avg', i, n, ' med', dmed, ' mad', dmad

	label = ' '
      if( isplit .ge. isplit_avg_rms ) then
	label = 'avg'
      else if( isplit .le. 0 .and. offset .ne. 0. ) then
c	write(*,*) 'ispec', ispec1, isp, ispec2
	call append_i( label, isp )
      end if
	call pgtext( xmx, dmed, ' ' // label(:len1(label)) )


* plot RMS spectrum
      if( isplit .ge. isplit_avg_rms ) then
	call pgsci( kblue )
	CALL PGBIN( NWAVE, XPLOT, DATRMS, .TRUE. )

* right margin label
	call medmad( n, datrms(i), dmed, dmad )
	call pgtext( xmx, dmed, ' rms' )
c	write(*,*) ' rms', i, n, ' med', dmed, ' mad', dmad
      end if

* mark flagged or bad data
      do i = 1, nwave
      if( epsilon(i) .lt. 0. .or. sigma(i) .le. 0 ) then
	im = max( i-1, 1 )
	ip = min( i+1, nwave )
	call pgsci( kolor_eps )
	call pgbin( ip-im+1, xplot(im), data(im), .true. )
      if( isplit .ge. isplit_avg_rms ) then
	call pgbin( ip-im+1, xplot(im), datrms(im), .true. )
      end if
      end if
      end do

* plot slope spectrum
      IF( ISPLIT.ge. isplit_avg_rms_slope ) THEN
	CALL PGSCI( kgreen )
	CALL PGSLS( 1 )
	CALL PGBIN( NWAVE, XPLOT, DATSLO, .TRUE. )
	CALL PGSLS( 1 )
      END IF


* re-plot data used in continuum fit
	call pgsci( kcyan )
	call pgsci( kgreen )
	call pgsci( kred )
	call pgsci( korange )
      do i=1,nband
	call lookup( nwave, xplot, wlim1(i), k, im, p )
	call lookup( nwave, xplot, wlim2(i), ip, k, p )
	im = max( 1, min( nwave, im ) )	
	ip = max( 1, min( nwave, ip ) )
	k = min( im, ip )
	n = max(im,ip) - k + 1
      if( n .gt. 0 ) then
	call pgbin( n, xplot( k ), data( k ), .true. )
      if( isplit .ge. isplit_avg_rms ) then
	call pgbin( n, xplot( k ), datrms( k ), .true. )
      end if
      end if
      end do

* plot the continua
	CALL PGSCI( kgreen )
	CALL PGSCI( kred )
	call pgsci( korange )
	CALL PGLINE( NWAVE, XPLOT, CONT )
      IF( ISPLIT .GT. 0 ) THEN
	CALL PGLINE( NWAVE, XPLOT, CONRMS )
      ELSE IF( ISPLIT.GT.1 ) THEN
	CALL PGLINE( NWAVE, XPLOT, CONSLO )
      END IF


* plot the error bar spectrum
	CALL PGSCI( kred )
	CALL PGBIN( NWAVE, XPLOT, SIGMA, .TRUE. )
	CALL PGSCI( kgreen )
	CALL PGBIN( NWAVE, XPLOT, SIGSYS, .TRUE. )
	CALL PGSCI( kblue )
	CALL PGBIN( NWAVE, XPLOT, SIGJIT, .TRUE. )
	CALL PGSCI( kblack )

* restore window (removes the offset )
	call pgswin( xmn, xmx, ymn, ymx )

* next panel ipan
      end do
* close
	CALL PGSTOP
* restore spectrum range
	ispec1 = isp1
	ispec2 = isp2
* again
	if( pgagain() ) goto 205


* dump AVG spectrum
      if( isplit .ge. isplit_avg_rms ) then
* headlines
	hlines( 1 ) = 'PrepSpec AVG Spectrum'
	call append( hlines(1), title(:len1(title)) )

	call textlabel_wave( label, zshift )
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	call textlabel_flux( label, fluxunit, iflxdex )
	hlines( 3 ) = ' Col 2 : ' // label(:len1(label))	
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	hlines( 5 ) = ' Col 4 : continuum'
	hlines( 6 ) = ' Col 5 : quality flag'
	nh = 6

	WRITE(*,*) 'Dump AVG spectrum to disk file ? '
	write(*,*) hlines(1)(:len1(hlines(1)))
	FILE = ' '
	CALL DUMPLC5h( FILE, nh, hlines,
     #	5, NWAVE, WAVE8, DATA, SIGMA, CONT, EPSILON )

* dump RMS spectrum
* headlines
	hlines( 1 ) = 'PrepSpec RMS spectrum'
	call append( hlines(1), title(:len1(title)) )

	WRITE(*,*) 'Dump RMS spectrum to disk file ? '
	write(*,*) hlines(1)(:len1(hlines(1)))
	FILE = ' '
	CALL DUMPLC5h( FILE, nh, hlines,
     #	5, NWAVE, WAVE8, DATRMS, STDRMS, CONRMS, EPSILON )

* dump SLOPE spectrum
      IF( ISPLIT .ge. isplit_avg_rms_slope ) THEN
* headlines
	hlines( 1 ) = 'PrepSpec SLOPE spectrum'
	call append( hlines(1), title(:len1(title)) )

	WRITE(*,*) 'Dump SLOPE spectrum to disk file ? '
	write(*,*) hlines(1)(:len1(hlines(1)))
	FILE = ' '
	CALL DUMPLC5h( FILE, nh, hlines,
     #	5, NWAVE, WAVE8, DATSLO, SIGSLO, CONSLO, EPSILON )
      END IF
      end if


* 2023-03-05 KDH guess next spectrum range to plot
* 2023-03-06 KDH DISABLE FOR NOW
      IF( .FALSE. ) THEN
      if( isplit .le. isplit_avg_rms ) then
	n = isp2 - isp1 + 1
	isp1 = min( isp1 + n, nspec )
	isp2 = min( isp2 + n, nspec )
	n = isp2 - isp1 + 1
      if( n .eq. 1 ) then
	write(*,*) 'Next spectrum', isp1, ' of max', nspec
      else if( n .gt. 1 ) then
	write(*,*) 'Old spectrum range', ispec1, ispec2, ' of max', nspec
	write(*,*) 'New spectrum range', isp1, isp2, ' of max', nspec
	write(*,*) 'Offset between spectra:', offset
      end if
	call inq( 'OK to plot ?', 'N', reply )
	call upcase( reply, reply )
      if( reply .eq. 'Y' ) then
	ispec1 = isp1
	ispec2 = isp2
	goto 203
      end if
      end if
      END IF


	GOTO 100

* plot a light curve

  300	WRITE(*,*) 'waves=', wavpic8(1,1)/OPZ, wavpic8(NW_t(1),1)/OPZ,
     #	' z=', ZSHIFT
	WRITE(*,'(A,$)') ' What wavelength range ? '
	READ(*,*,ERR=100) W1, W2
	IF( W1.EQ.W2 ) GOTO 100
	WAVE1 = MIN( W1, W2 )
	WAVE2 = MAX( W1, W2 )

	WRITE(*,'(A,$)') ' Subtract continuum ? [Y] '
	READ(*,'(A)') PMODE
	CALL UPCASE( PMODE, PMODE )
	IF( PMODE.EQ.' ' ) PMODE = 'Y'

	NPLOT = 0
      DO ISPEC=1,NSPEC
	NWAVE = nw_t( ispec )
	NSUM = 0
	SUM = 0.D0
* KDH : MAY NEED TO PROTECT SUMV FROM UNDERFLOW/OVERFLOW
	SUMV = 0.D0
	SUMC = 0.D0
	SUMA = 0.D0
	ilo = nwave
	ihi = 1
      DO I=1,NWAVE
      IF( WAVE1 .LE. wavpic8(I,ISPEC) / OPZ
     #	.AND. wavpic8(I,ISPEC) / OPZ .LE. WAVE2 ) THEN
	NSUM = NSUM + 1
	SUM = SUM + DATPIC(I,ISPEC)
	SUMC = SUMC + CONPIC(I,ISPEC)
	SUMA = SUMA + ABSPIC(I,ISPEC)
	SUMV = SUMV + SIGPIC(I,ISPEC)*SIGPIC(I,ISPEC)
	ilo = min( ilo, i )
	ihi = max( ihi, i )
      END IF
      END DO

      IF( NSUM.GT.0 ) THEN
* data variance due to pixel jitter
	sig1 = ddatdpixpic(ilo,ispec) * sigpixpic(ilo,ispec)
      if( ilo .eq. ihi ) then
	varj = sig1 * sig1
      else
	sig2 = ddatdpixpic(ihi,ispec) * sigpixpic(ihi,ispec)
	varj = ( sig1 + sig2 ) ** 2
      end if
* KDH : MAY NEED TO AVOID OVERFLOW/UNDERFLOW OF VARJ AND HENCE SUMV
	sumv = sumv + varj
* stow
	NPLOT = NPLOT + 1
	XPLOT(NPLOT) = TIME8( ISPEC )
	YPLOT(NPLOT) = SUM / NSUM
	CPLOT(NPLOT) = SUMC / NSUM
	DYPLOT(NPLOT) = DSQRT( MAX(0.D0, SUMV/(NSUM*NSUM) ) 
     #		+ (SYSERB * 0.01 * YPLOT(NPLOT))**2 )
	IF( PMODE.EQ.'Y' ) YPLOT(NPLOT) = YPLOT(NPLOT) - CPLOT(NPLOT)
      END IF
      END DO
	IF( NPLOT.LE.0 ) GOTO 100
* plot limits
	CALL PGLIMIT( NPLOT, XPLOT, XMN, XMX, 0. )
	XRNG = ABS( XMX - XMN )
	XMN = XMN - 0.025*XRNG
	XMX = XMX + 0.025*XRNG
	WRITE(*,*) XMN, TIME(1), TIME(NSPEC), XMX
	YMN = 0.
	YMX = 0.
      DO I=1,NPLOT
	YMX = MAX( YMX, YPLOT(I)+DYPLOT(I) )
	YMN = MIN( YMN, YPLOT(I)-DYPLOT(I) )
      END DO
	YRNG = ABS( YMX - YMN )
	IF( YMX .NE.0. ) YMX = YMX + 0.05 * YRNG
	IF( YMN .NE.0. ) YMN = YMN - 0.05 * YRNG
	IF( YMX .EQ. YMN ) YMX = YMN + 1
C	PGRND( YMX, NTICK )

* x label
	call label_time( xlabel, timebase, jdsub )
* y label
	call plotlabel_flux( ylabel, fluxunit, iflxdex )
* title
	WRITE( TITLE, * ) '\gl=( ', WAVE1, WAVE2, ')'
	IF( ZSHIFT.NE.0.D0 ) WRITE( TITLE, '(A,2F8.2, A, F8.6)' )
     #	'\gl=( ', WAVE1, WAVE2, ')  z=', ZSHIFT

* frame plot
  310	IFAIL = PGEWIN( XMN, XMX, YMN, YMX )
	IF( IFAIL.GT.0 ) GOTO 100
	CALL PGSTART( 1,1,NEW )
	lwide = lwidedef
	call pgslw( lwide )
	call pgbgw

	CALL PGSCI( kolor_axis )

c	CALL PGENV( XMN, XMX, YMN, YMX, 0, 0 )
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	f = 10. ** ( inflxdex - iflxdex )
	if( f .ne. 1. ) write(*,*) 'y axis flux scale factor', f
	CALL PGENV( XMN, XMX, YMN * f, YMX * f, 0, 0 )
	call pgswin( xmn, xmx, ymn, ymx )

	CALL PGMOVE( XMN, 0. )
	CALL PGDRAW( XMX, 0. )
* title
	CALL PGSCI( kolor_label )
	CALL PGLABEL( XLABEL, YLABEL, TITLE )
* legend
	call pgmtxt( 'T', 0.5, 0., 0., agn )
	call makelegend( legend, npolyc, syserb )
	call pgmtxt( 'T', 0.5, 1.0, 1.0, legend )

	CALL PGSCI( kolor_sig )
      DO I=1,NPLOT
	CALL PGERRY( 1, XPLOT(I), YPLOT(I)+DYPLOT(I),
     #		YPLOT(I)-DYPLOT(I), 0. )
      END DO
	CALL PGSCI( kolor_dat )
	CALL PGPT( NPLOT, XPLOT, YPLOT, 20 )

* plot fitted line
	CALL FITLINE( NPLOT, XPLOT, YPLOT, DYPLOT,
     #		X0, A, B, SIGA, SIGB )

	CALL PGSCI( kred )
	n = 100
      do k = -1,1
      do i = 1, n
	p = (i-1.)/max(1,n)
	x = xmn * (1.-p) + p * xmx
	y = a + b * (x-x0)
	e = sqrt( siga**2 + ( sigb * (x-x0) )**2 )
	plot1( i ) = x + k * e
	plot2( i ) = y + k * e
      end do
	call pgline( n, plot1, plot2 )
      end do


* plot continuum
	CALL PGSCI( kblue )
	IF( PMODE.NE.'Y' ) CALL PGLINE( NPLOT, XPLOT, CPLOT )
	CALL PGSCI( kblack )
	CALL PGSTOP

	if( pgagain() ) goto 310


	WRITE(*,*) 'Dump light curve to disk file ? '
	FILE = ' '
	call label_time( label, timebase, jdsub )
	HLINES( 1 ) = 'PrepSpec Lightcurve ' // TITLE( : LEN1(TITLE) )
	HLINES( 2 ) = ' Col 1 : ' // label(:len1(label))
	HLINES( 3 ) = ' Col 2 : data' // YLABEL( : LEN1(YLABEL) )
	HLINES( 4 ) = ' Col 3 : error bar on Col 2'
	NH = 4
	CALL DUMP1D3H( FILE, NH, HLINES, 3, NPLOT, XPLOT, YPLOT, DYPLOT )

	GOTO 100

* display greyscale image ---------------------------------------------------

  400	call mnmxi( nspec, nw_t, nwmn, nwmx )
	nwave = nwmx
	if( nwmx .ne. nwmn ) write(*,*) 'Nw mn', nwmn, ' mx', nwmx

	WRITE(*,*) 'Image Display Nw x Nt:', nwave, ' x', nspec
	WRITE(*,'(A,$)')
     #	' D(ata), S(igma), E(ps), C(ont), L(ines), A(bsn), N(orm) [D] '
	READ(*,'(A,$)') PMODE
	CALL UPCASE( PMODE, PMODE )
	IF( PMODE.EQ.' ' ) PMODE = 'D'


* flux unit power of 10
	funit = 1.
      if( pmode .eq. 'D' .or. pmode .eq. 'S'
     &	.or. pmode .eq. 'C' .or. pmode .eq. 'L' ) then
	funit = 10. ** ( inflxdex - iflxdex )
	write(*,*) 'Flux unit', funit
      end if

	ZMN = 0.
	ZMX = ZMN
      DO ISPEC = 1, NSPEC
c	w1 = wavpic8(1,ispec)
c	w2 = wavpic8(nw_t(ispec),ispec)
c	write(*,*) 'spec', ispec, ' wave', nw_t( ispec ), w1, w2

* data
      IF( PMODE.EQ.'D' ) THEN
      DO J=1,NW_T(ISPEC)
	SHOPIC(J,ISPEC) = DATPIC(J,ISPEC) * funit
      END DO
* sigma
      ELSE IF( PMODE.EQ.'S' ) THEN
      DO J=1,NW_T(ISPEC)
	SHOPIC(J,ISPEC) = SIGPIC(J,ISPEC) * funit
      END DO
* eps
      ELSE IF( PMODE.EQ.'E' ) THEN
      DO J=1,NW_T(ISPEC)
	SHOPIC(J,ISPEC) = EPSPIC(J,ISPEC)
      END DO
* continuum
      ELSE IF( PMODE.EQ.'C' ) THEN
      DO J=1,NW_T(ISPEC)
	SHOPIC(J,ISPEC) = CONPIC(J,ISPEC) * funit
      END DO
* absorption
      ELSE IF( PMODE.EQ.'A' ) THEN
      DO J=1,NW_T(ISPEC)
	SHOPIC(J,ISPEC) = ABSPIC(J,ISPEC)
      END DO
* (data - continuum)
      ELSE IF( PMODE.EQ.'L' .OR. PMODE.EQ.'N' ) THEN
      DO J=1,NW_T(ISPEC)
	SHOPIC(J,ISPEC) = ( DATPIC(J,ISPEC) - CONPIC(J,ISPEC) ) * funit
      END DO
      ELSE
	write(*,*) '** Invalid reply. Please try again.'
	GOTO 100
      END IF

      DO J=NW_T(ISPEC), NWAVE
	SHOPIC(J,ISPEC) = 0.
      END DO
      DO J=1,NW_T(ISPEC)
	s = shopic( j, ispec )
* skip NANs
      if( s .eq. s ) then
	ZMN = MIN( ZMN, s )
	ZMX = MAX( ZMX, s )
      end if
      END DO
* next spectrum
      END DO

* what part of mean and slope to subtract ?

	PARTAVG = 0.
	PARTSLO = 0.
      IF( PMODE.EQ.'D' .OR. PMODE.EQ.'C' .OR. PMODE.EQ.'L' 
     #	.OR. PMODE.EQ.'N' ) THEN
C	WRITE(*,'(A,$)') ' What part of mean and slope to subtract ? '
C	READ(*,*) PARTAVG, PARTSLO
	call inq2r( 'What part of MEAN and SLOPE to subtract ?', partavg, partslo )
      END IF

* what spectra 

	ISPEC1 = 0
	ISPEC2 = 0
      IF( PARTAVG.NE.0. .OR. PARTSLO.NE.0. ) THEN
	WRITE(*,*) 'NSPEC=', NSPEC
C      if( .false. ) then
C	WRITE(*,'(A,$)') ' FIRST  and LAST spectrum to average : '
C	READ(*,*,ERR=100 ) ISPEC1, ISPEC2
C	ISPEC2 = MIN( ISPEC2, NSPEC )
C      end if
	i1 = 1
	i2 = nspec
	call inq2i( 'FIRST and LAST spectrum to average', i1, i2 )	
	ispec1 = max( 1, min( nspec, min( i1, i2 ) ) )
	ispec2 = max( 1, min( nspec, max( i1, i2 ) ) )
      END IF

      IF( ISPEC1 .GE.1 .AND. ISPEC2 .GE. ISPEC1 ) THEN
	ZMN = 0.
	ZMX = 0.
* loop thru wavelengths
* KDH : WHAT ABOUT NW_T( ISPEC ) ?
      DO IW = 1,NWAVE
* sig0 = mean and sigok = smallest positive error bar
	sigok = -1.
	SIG0 = 0.D0
	NSUM = 0
      DO ISPEC = ISPEC1, ISPEC2
	sig = sigpic( iw, ispec )
      IF( sig .GT. 0. ) THEN
	SIG0 = SIG0 + s
	NSUM = NSUM + 1
	if( nsum .eq. 1 ) sigok = sig
	sigok = min( sigok, sig )
      END IF
      END DO
	SIG0 = SIG0 / MAX( 1, NSUM )
	if( sigok .le. 0. ) sigok = 1.
* compute mean of data and time
	SUM = 0.D0
	SUMD = 0.D0
	SUMT = 0.D0
      DO ISPEC=ISPEC1, ISPEC2
	sig = sigpic( iw, ispec )
	dat = shopic( iw, ispec )
      IF( sig .GT. 0. ) THEN
* safe 1/variance weight in (0,1)
	wgt = sigok / sig
	WGT = wgt * wgt
	SUM = SUM + WGT
	SUMD = SUMD + WGT * dat
	SUMT = SUMT + WGT * TIME8(ISPEC)
      END IF
      END DO
	IF( SUM.LE.0.D0 ) SUM = 1.D0
	DATA(iw) = SUMD / SUM

* compute slope
      IF( PARTSLO.NE.0. ) THEN
	TBAR = SUMT / SUM
	SUMTT = 0.D0
      DO ISPEC = ISPEC1, ISPEC2
	sig = sigpic( iw, ispec )
      IF( sig .GT. 0. ) THEN
* safe 1/variance weight in (0,1)
	wgt = sigok / sig
	WGT = wgt * wgt
	tim = time8( ispec ) - tbar
	SUMTT = SUMTT + WGT * tim * tim
      END IF
      END DO
	TRMS = DSQRT( MAX(0.D0, SUMTT / SUM ) )
	IF( TRMS.LE.0.D0 ) TRMS = 1.D0
	SUMDT = 0.D0
      DO ISPEC = ISPEC1, ISPEC2
	sig = sigpic( iw, ispec )
      IF( sig .GT. 0. ) THEN
* safe 1/variance weight in (0,1)
	wgt = sigok / sig
	WGT = wgt * wgt
	tim = time8( ispec ) - tbar
	TIM = tim / TRMS
	DAT = SHOPIC(iw,ISPEC) - DATA(iw)
	SUMDT = SUMDT + WGT * TIM * DAT
      END IF
      END DO
	DATSLO(iw) = SUMDT / SUM
      END IF

* loop thru spectra
	if( iw .eq. 1 ) n = 0
      DO ISPEC = 1, NSPEC
	dat = shopic( iw, ispec )
	sig = sigpic( iw, ispec )
* subtract mean
	IF( PARTAVG.NE.0. ) dat = dat - PARTAVG * DATA(iw)
* subtract slope
	IF( PARTSLO.NE.0. ) dat = dat
     #		- PARTSLO * DATSLO(iw) * (TIME8(ISPEC) - TBAR ) / TRMS
* divide by error bar
	IF( PMODE.EQ.'N' .AND. sig .GT. 0. ) dat = dat / sig
* stow
	shopic( iw, ispec ) = dat
	n = n + 1
	pic( n ) = dat
* revise range
	ZMN = MIN( ZMN, dat )
	ZMX = MAX( ZMX, dat )
* next spectrum ispec
      END DO
* next wavelength iw
      END DO
      END IF

* stats
	n = 0
      do iw = 1, nwave
      do it = 1, nspec
	n = n + 1
	pic( n ) = shopic( iw, it )
      end do
      end do
	call medmad( n, pic, zmed, zmad )
	call avgrms( n, pic, zavg, zrms )

* plot labels
	XLABEL = '\gl (\A)'
      IF( REST0 .GT. 0. ) THEN
	WRITE( XLABEL, '(A,F10.2)' )
     #	'velocity (km/s)  \gl\do\u = ', REST0
      END IF
      IF( ZSHIFT .NE. 0.D0 ) THEN
	WRITE( XLABEL(LEN1(XLABEL)+1:), '(A,F6.4)' ) '  z = ', ZSHIFT
      END IF
	YLABEL = 'spectrum ('
	call append_i( ylabel, 1 )
	call append( ylabel, '-' )
	call append_i( ylabel, nspec )
	call append( ylabel, ')' )
* plot title
      IF( PMODE.EQ.'A' ) THEN
	TITLE = 'absorption spectra'
      ELSE IF( PMODE.EQ.'E' ) THEN
	TITLE = 'epsilon vectors'
      ELSE IF( PMODE.EQ.'S' ) THEN
	TITLE = 'error bars'
      ELSE IF( PMODE.EQ.'C' ) THEN
	TITLE = 'continuum'
      ELSE IF( PMODE.EQ.'L' .OR. PMODE.EQ.'N' ) THEN
	TITLE = 'data - continuum'
      ELSE IF( PMODE.EQ.'D' ) THEN
	TITLE = ' '
      END IF
      IF( PARTSLO.NE.0 .OR. PARTAVG.NE.0. ) THEN
	IF( PMODE.EQ.'D' ) TITLE = 'data'
      IF( PARTAVG.EQ.1. ) THEN
	TITLE = TITLE(:LEN1(TITLE)) // ' - mean'
      ELSE IF( PARTAVG.GT.0. ) THEN
	WRITE( TITLE(LEN1(TITLE)+1:), *) ' - ', PARTAVG, ' * mean'
      ELSE IF( PARTAVG.LT.0. ) THEN
	WRITE( TITLE(LEN1(TITLE)+1:), *) ' + ', ABS(PARTAVG), ' * mean'
      END IF
      IF( PARTSLO.EQ.1. ) THEN
	TITLE = TITLE(:LEN1(TITLE)) // ' - slope'
      ELSE IF( PARTSLO.GT.0. ) THEN
	WRITE( TITLE(LEN1(TITLE)+1:), *) ' - ', PARTSLO, ' * slope'
      ELSE IF( PARTSLO.LT.0. ) THEN
	WRITE( TITLE(LEN1(TITLE)+1:), *) ' + ', ABS(PARTSLO), ' * slope'
      END IF
      END IF
	IF( PMODE.EQ.'N' )
     #	TITLE = '( ' // TITLE(:LEN1(TITLE)) // ' ) / \gs '

* plot limits (and central value)
	XMN = wavpic8(1,1) / OPZ
	XMX = wavpic8(NW_T(1),1) / OPZ
	IXHALF = MAX(1,NW_T(1)/2)
	XHALF = wavpic8( IXHALF,1 ) / OPZ

* velocity scale
      IF( REST0 .GT. 0.D0 ) THEN
	XMN = CKMS * ( XMN - REST0 ) / REST0
	XMX = CKMS * ( XMX - REST0 ) / REST0
	XHALF = CKMS * ( XHALF - REST0 ) / REST0
      END IF

* KDH : IS WAVELENGTH SCALE CLOSER TO LINEAR OR TO LOG ?
	xlin = ( xmx - xhalf ) / ( xhalf - xmn )
	xlog = alog10( xmx / xhalf ) / alog10( xhalf / xmn )
	write(*,*) 'Right/Left ratio Linear', xlin, ' Log', xlog

	LOGX = 0
	if( abs( alog( xlin ) ) .gt. abs( alog( xlog ) ) ) LOGX = 1
	IF( REST0 .GT. 0.D0 ) LOGX = 0
      IF( LOGX .NE. 0 ) THEN
	XMN = ALOG10( XMN )
	XMX = ALOG10( XMX )
	XHALF = ALOG10( XHALF )
	write(*,*) 'Wavelength scale closer to LOG'
      ELSE
	write(*,*) 'Wavelength scale closer to LINEAR'
      END IF

* TR array 
	DX = ( XMX - XMN ) / MAX( 1, NW_T(1)-1 )
	IYHALF = MAX(1,NSPEC/2)
	YHALF = MAX(1,NSPEC/2)
	XMN = XMN - 0.5 * DX
	XMX = XMN + NWAVE * DX
	YMN = 0.5
	YMX = NSPEC + 0.5
	TR(6) = 1.
	TR(5) = 0.
	TR(4) = 0.
	TR(3) = 0.
	TR(2) = DX
	TR(1) = XMN - 0.5 * TR(2)

* linearity test
	XTEST = ABS( ( TR(1) + IXHALF * TR(2) - XHALF ) / TR(2) )
	YTEST = ABS( ( TR(4) + IYHALF * TR(6) - YHALF ) / TR(6) )
	WRITE(*,*) 'XTEST', XTEST, ' YTEST', YTEST

* get BG and FG
  460	WRITE(*,*) '   MIN MAX :', ZMN, ZMX
	write(*,*) '   AVG RMS :', ZAVG, ZRMS
	write(*,*) '   MED MAD :', ZMED, ZMAD
* med +/- 5 mad
	ADD = ZMAD * 5.
	FG1 = MAX( ZMN, ZMED - ADD )
	BG1 = MIN( ZMX, ZMED + ADD )
* symmetrise
	x = max( abs( bg1 ), abs( fg1 ) )
	fgs = - x
	bgs = + x

* recommended
	fg = fg1
	bg = bg1
      if( partavg .ne. 0. .or. partslo .ne. 0. ) then
	fg = fgs
	bg = bgs
      end if
* report options
      IF( BGp .ne. FGp ) THEN
	write(*,*) '  Previous :', fgp, bgp
      END IF
	write(*,*) 'MED+/-5*MAD:', fg1, bg1
	write(*,*) ' Symmetric :', fgs, bgs
	write(*,*) ' Recommend :', fg, bg
	VAL1 = FG
	VAL2 = BG
	CALL INQ2R( 'LO (white)  and HI (black)', VAL1, VAL2 )
      IF( VAL1 .NE. VAL2 ) THEN
	FG = VAL1
	BG = VAL2
      ELSE IF( VAL1 .NE. 0. ) THEN
	GOTO 100
      END IF
* stow previous fg,bg for next time
	fgp = fg
	bgp = bg
* plot
	CALL PGSTART(1,1,NEW)
	lwide = lwidedef
	call pgslw( lwide )
	call pgbgw
	CALL PGSCI( kolor_axis )
* viewport
	CALL PGVSTD
* window
	CALL PGSWIN( XMN, XMX, YMN, YMX )
	CALL PGSCI( kolor_axis )

      IF( LOGX .EQ. 0 ) THEN
	CALL PGBOX( 'BCNST', 0., 0, 'BCNST', 0., 0 )
      ELSE
C	CALL PGBOX( 'BCNSTL', 0., 0, 'BCNST', 0., 0 )
	CALL PGBOX( 'BCSTL', 0., 0, 'BCNST', 0., 0 )
	call pgloglam( xmn, xmx, ymn, ymx )
      END IF

* title
	CALL PGSCI( kolor_label )
	CALL PGLABEL( XLABEL, YLABEL, TITLE )
* legend
	call pgmtxt( 'T', 0.5, 0., 0., agn )
	call makelegend( legend, npolyc, syserb )
	call pgmtxt( 'T', 0.5, 1.0, 1.0, legend )


* 2023 MAY - USE PGPIC
      IF( .TRUE. ) THEN
* KDH: HOW TO HANDLE MORE DIVERSE WAVELENGTH SCALES ?
* rest wavelengths of first spectrum 
      do i = 1, nwave
	x = wavpic8(i,1) / opz
	if( logx .ne. 0 ) x = alog10( x )
	xplot( i ) = x
      end do
* spectrum number
      do i = 1, nspec
	yplot( i ) = i
      end do
	call pgpic( 'G', shopic, maxw, nspec, 1,nwave, 1,nspec, 
     &	bg, fg, xplot, yplot )

* OBSOLETE pggray 
      ELSE
* display entire map if close to linear
	TEST = 0.1
      IF( XTEST.LT.TEST .AND. YTEST.LT.TEST ) THEN
	write(*,*) 'PGGRAY entire map.'
	write(*,*) 'TR:', (tr(i),i=1,6)
	write(*,*) 'pggray(', 1, nwave, 1, nspec, bg, fg, ' )'
	CALL PGGRAY( SHOPIC, maxw, NSPEC, 1,NWAVE, 1,NSPEC,
     &	BG, FG, TR )

* display map column blocks
      ELSE IF( XTEST.GE.TEST .AND. YTEST.LT.TEST ) THEN
	write(*,*) 'PGGRAY column blocks'
	I1 = 1
      DO I2=MIN(NWAVE,3),NWAVE
	TR(2) = ( wavpic8(I2,1) - wavpic8(I1,1) ) / OPZ / MAX(1,I2-I1)
	TR(1) = wavpic8(I1,1) / OPZ
	IHALF = ( I1+I2 ) / 2
	HALF = wavpic8(IHALF,1) / OPZ
      IF( REST0 .GT. 0.D0 ) THEN
	HALF = ( CKMS * HALF - REST0 ) / REST0
	TR(1) = CKMS * ( TR(1) - REST0 ) / REST0
	TR(2) = CKMS * TR(2) / REST0
      END IF
	TR(1) = TR(1) - I1*TR(2)
	XTST = ABS( ( TR(1) + IHALF*TR(2) - HALF ) / TR(2) )
      IF( XTST.GT.TEST .OR. I2.GE.NWAVE ) THEN
	I2M = I2 - 1
	IF( I2.GE.NWAVE ) I2M = NWAVE
        TR(2) = ( wavpic8(I2M,1) - wavpic8(I1,1) ) / OPZ / MAX(1,I2M-I1)
	TR(1) = wavpic8(I1,1) / OPZ
      IF( REST0 .GT. 0.D0 ) THEN
        TR(1) = CKMS * ( TR(1) - REST0 ) / REST0
        TR(2) = CKMS * TR(2) / REST0
      END IF
	TR(1) = TR(1) - I1 * TR(2)
	write(*,*) 'pggray(', i1, i2m, 1, nspec, ' )'
	CALL PGGRAY( SHOPIC, maxw, NSPEC, I1,I2M, 1,NSPEC,
     #	BG,FG, TR )
	I1 = I2
      END IF
      END DO

* display map row blocks
      ELSE IF( XTEST.LT.TEST .AND. YTEST.GE.TEST ) THEN
	write(*,*) 'PGGRAY row blocks'
	I1 = 1
      DO I2=MIN(NSPEC,3),NSPEC
	TR(6) = FLOAT( I2 - I1 ) / MAX(1,I2-I1)
	TR(4) = I1 - I1 * TR(6)
	IHALF = ( I1+I2 ) / 2
	HALF = IHALF
	YTST = ABS( ( TR(4) + IHALF*TR(6) - HALF ) / TR(6) )
      IF( YTST.GT.TEST .OR. I2.GE.NSPEC ) THEN
	I2M = I2 - 1
	IF( I2.GE.NSPEC ) I2M = NSPEC
        TR(6) = FLOAT( I2M - I1 ) / MAX(1,I2M-I1)
	TR(4) = I1 - I1 * TR(6)
	write(*,*) 'pggray(', 1, nwave, i1, i2m, bg, fg, ' )'
	CALL PGGRAY( SHOPIC, maxw, NSPEC, 1,NWAVE, I1,I2M,
     #	BG,FG, TR )
	I1 = I2
      END IF
      END DO

      END IF
* end pggrey
      END IF

* redraw box
	CALL PGSCI( kolor_axis )
      IF( LOGX .EQ. 0 ) THEN
	CALL PGBOX( 'BCNST', 0., 0, 'BCNST', 0., 0 )
      ELSE
c	CALL PGBOX( 'BCNSTL', 0., 0, 'BCNST', 0., 0 )
	CALL PGBOX( 'BCSTL', 0., 0, 'BCNST', 0., 0 )
	call pgloglam( xmn, xmx, ymn, ymx )
      END IF

* KDH : NOW DONE BEFORE GREYSCALE
C      IF( .FALSE. ) THEN
* title
C	CALL PGSCI( kolor_label )
C	CALL PGLABEL( XLABEL, YLABEL, TITLE )
* legend
C	call pgmtxt( 'T', 0.5, 0., 0., agn )
C	call makelegend( legend, npolyc, syserb )
C	call pgmtxt( 'T', 0.5, 1.0, 1.0, legend )
C      END IF

* wedge
	CALL PGSCI( kolor_axis )

* flux label
	label = ' '
      IF(     PMODE .NE. 'N'
     &	.AND. PMODE .NE. 'A'
     &	.AND. PMODE .NE. 'E' ) THEN
	call plotlabel_flux( label, fluxunit, iflxdex )
      END IF
	CALL PGWEDG( 'R', 1.5, 2.5, BG, FG, label(:len1(label)) )
	CALL PGSCI( kblack )
* KDH: pgelut doesn't seem to work.
C	CALL PGELUT
	CALL PGSTOP

	if( pgagain() ) goto 460

	GOTO 100

* ========================================
* model the spectral variations

  500	write(*,*) 'PrepSpec modelling.'

* no data
	call mnmxi( nt, nw_t, mn, mx )
      if( mn .le. 0 .or. mx .le. 0 ) then
	write(*,*) '** NO DATA TO MODEL', mn, mx
	goto 100
      end if

* variable number of wavelengths
      if( mx .eq. mn ) then
	nw = mx
	write(*,*) 'All spectra have same number of pixels', nw, ' :)'
      else
	write(*,*) '** Spectrum pixels range from ', MN, ' to', MX
	write(*,*) '** Please bin spectra to equalize number of pixels'
	write(*,*) '** before attempting to model the spectra.  Sorry.'
	goto 100
      end if

* sanit check wavelength scales
	n = 0
      do it = 1, nt
      do iw = 1, nw
	im = max( iw - 1, 1 )
	ip = min( iw + 1, nw )
	w = wavpic8( iw, it )
	wm = wavpic8( im, it )
	wp = wavpic8( ip, it )
	dw = ( wavpic8( ip, it ) - wavpic8( im, it ) ) / max( 1, ip - im )
* stow
	plot1( iw ) = w
	plot2( iw ) = dw
	plot3( iw ) = ckms * dw / w
* count and report backsteps
      if( iw .gt. im .and. wavpic8( iw, it ) .le. wavpic8( im, it ) ) then
	n = n + 1
	write(*,*) 'Spec', it, ' lam', iw, nint(w), ' backstep', w - wm, ' :((.'
      end if
* next iw
      end do
* abort if wavelengths don't ascend
      if( n .gt. 0 ) then
	write(*,*) '** Wavelengths should ascend.'
	write(*,*) '** Please fix the wavelength backsteps'
	write(*,*) '** before attempting to model the spectra.  Sorry.'
	goto 100
      end if
* stats
	call mnmx( nw, plot1, wmn, wmx )
	call mnmx( nw, plot2, dwmn, dwmx )
	call mnmx( nw, plot3, dvmn, dvmx )
	nw1 = max( 1, nw - 1 )
	dw = ( wavpic8( nw, it ) - wavpic8( 1, it ) ) / nw1
	dv = dlog( wavpic8( nw, it ) / wavpic8( 1, it ) ) * ckms / nw1
* stow
	plot4( it ) = wmn
	plot5( it ) = wmx
	plot6( it ) = dw
	plot7( it ) = dv
c	plot8( it ) = dwmn
c	plot9( it ) = dwmx
c	plot10( it ) = dvmn
c	plot11( it ) = dvmx
* next it
      end do
* report
	write(*,*) 'Wavelengths ascend :).'
	call mnmx( nt, plot4, w1mn, w1mx )
	call mnmx( nt, plot5, wnmn, wnmx )
	call mnmx( nt, plot6, dwmn, dwmx )
	call mnmx( nt, plot7, dvmn, dvmx )
      if( w1mn .eq. w1mx .and. wnmn .eq. wnmx ) then
	write(*,*) 'Wavelength ranges identical :).'
	write(*,*) ' lam/A', w1mn, ' to', wnmx
	write(*,*) 'dlam/A', dwmn
	write(*,*) 'dv/kms', dvmn
      else
	write(*,*) 'Wavelength ranges differ.'
	write(*,*) ' lam/A', w1mn, w1mx, ' to', wnmx, wnmx 
	write(*,*) 'dlam/A', dwmn, dwmx
	write(*,*) 'dv/kms', dvmn, dvmn
      end if

* count and flag missing data (nada => no data)
	nada = 0
	nadaw = 0
	nadat = 0
      do it = 1, nt
	yes = .false.
      do iw = 1, nw
	good_wt( iw, it ) = sigpic( iw, it ) .gt. 0.
	yes = yes .or. good_wt( iw, it )
	if( .not. good_wt( iw, it ) ) nada = nada + 1
      end do
* times with good data at 1 or more wavelengths
	if( .not. yes ) nadat = nadat + 1
	good_t( it ) = yes
      end do

* wavelengths with good data at 1 or more times
      do iw = 1, nw
	yes = .false.
      do it=1,nt
	yes = yes .or. good_wt( iw, it )
      end do
	if( .not. yes ) nadaw = nadaw + 1
	good_w( iw ) = yes
      end do
* report
	write(*,*) 'Missing times', nadat, ' of', nt, ' =', nadat * 100. / nt, ' %'
	write(*,*) 'Missing waves', nadaw, ' of', nw, ' =', nadaw * 100. / nw, ' %'
	write(*,*) 'Missing data ', nada,  ' of', nw*nt, ' =', nada * 100. / nw /nt, ' %'

* KDH : 2020-Mar-15 REPORT DATA GAPS
* report bad wavelengths
	ngw = 0
	lastgoodw = 0
      do iw = 1, nw
	ngt = 0
* data at iw ?
      do it = 1, nt
	sig = sigpic( iw, it )
	if( sig .gt. 0. ) ngt = ngt + 1
      end do
	yes = ngt .gt. 0
* report start of data gap
      if( .not. yes ) then
	w = wavpic8( iw, 1 )
      if( lastgoodw .eq. iw - 1 ) then
	write(*,*) '** NO DATA AT PIXEL', iw, w, ' A :(((.'
      end if
      end if
* report end of data gap
      if( ( yes .and. lastgoodw .lt. iw - 2 )
     &	.or. ( .not. yes .and. iw .eq. nw ) ) then
	ngap = iw - 1 - lastgoodw
	write(*,*) '**    THROUGH PIXEL', iw-1, w, ' GAP', ngap
      end if
* count wavelengths with good data
      if( yes ) then
	ngw = ngw + 1
	lastgoodw = iw
      end if
* next iw
      end do
	nbadw = nw - ngw
      if( nbadw .gt. 0 ) then
	write(*,*) '** NO DATA AT', nbadw, ' OF', nw, ' WAVELENGTHS. :((('
      else
	write(*,*) 'Bad wavelengths', nbadw, ' of', nw, ' :)'
      end if

* defaults
	if( vblr .eq. 0. ) vblr = 3000
	if( vnlr .eq. 0. ) vnlr = 800
	if( vdim .le. 0. ) vdim = 50
	lastit = nits
	todo = ' '


* active lines
	wlo = w_w(  1 ) * exp( - vblr / ckms )
	whi = w_w( nw ) * exp( vblr / ckms )
	lineson = 0
      do i = 1, markline
      if( rest_l( i ) .ge. wlo .and. rest_l( i ) .le. whi ) then
	if( expand_l( i ) .gt. 0. ) lineson = lineson + 1
      end if
      end do

* count good data
	ngood = 0
      do it = 1, nt
      do iw = 1, nw
	i = iw + nw * ( it - 1 )
	sig_wt( i ) = sigpic( iw, it )
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
	if( sig .gt. 0. ) ngood = ngood + 1
      end do
      end do

	ntw = nt * nw
	nbad = nt * nw - ngood
	pc = nbad * 100. / (nt*nw)
	ndof = max( 0, ngood - nfit )
	pcd = ndof * 100. / max( 1, ngood )

	if( nits .lt. 0 ) goto 520


* KDH : SANITY CHECK (TWEAK?) REDSHIFT
* tweak redshift
	yes = .true.
	if( yes ) write(*,*) 'Redshift check using selected Median NLR velocities.'
	if( .not. yes ) write(*,*) 'Redshift check using selected Mean NLR velocities.'
	ng = 0
	sum = 0.d0
	sumw = 0.d0
	nsum = 0
	sum1 = 0.d0
	sum2 = 0.d0
      do lrank = 1, markline
	l = i_l( lrank )
	k = nabc( l )
      if( k .eq. narrow ) then
	n = npix_l( l )
      if( n .gt. 0 ) then
      if(   l .eq. line5007
     & .or. l .eq. line4959
     & .or. l .eq. line3727 ) then
	lw = nint( rest_l( l ) )
      if( yes ) then
	v = vmed_l( l )
	sigv = sigvmed_l( l )
      else
	v = vavg_l( l )
	sigv = sigvavg_l( l )
      end if
	dz = v * opz / ckms
	sigz = sigv * opz / ckms
	znlr = zshift + dz
      if( sigv .gt. 0. ) then
	write(*,*) lw, ' v', nint(v), '+/-', nint(sigv)
     &		, ' dz', dz, ' znlr', znlr, ' +/-', sigz
      else
	write(*,*) lw, ' v', v, ' dz', dz, ' znlr', znlr, ' +/-', sigz
      end if
* unweighted
	nsum = nsum + 1
	sum1 = sum1 + v
	sum2 = sum2 + v * v
* weighted
      if( sigv .gt. 0. ) then
	ng = ng + 1
	wgt = 1. / ( sigv * sigv )
	sum = sum + wgt * v
	sumw = sumw + wgt
      end if

      end if
      end if
      end if
* next line
      end do
      if( nsum .le. 0 ) then
	write(*,*) 'No NLR lines selected.'
      else
* sample mean
	v = sum1 / max( 1, nsum )
	sigv = sqrt( ( sum2 - sum1*sum1 / max(1,nsum) ) / max(1,nsum-1) )
	dz = v * opz / ckms
	sigz = sigv * opz / ckms
	write(*,*) '   Mean v', v, ' +/-', sigv, ' dz', dz
* opt average
      if( ng .le. 0 ) then
	write(*,*) '** WARNING: NO ERROR BARS ON NLR VELOCITIES.'
      else
	write(*,*) 'Good NLR velocity sigmas:', ng
	v = sum / sumw
	sigv = sqrt( 1.d0 / sumw )
	dz = v * opz / ckms
	sigz = sigv * opz / ckms
	write(*,*) 'Optimal v', v, ' +/-', sigv, ' dz', dz
      end if
	znlr = zshift + dz
	sigznlr = sigdz
	write(*,*) ' z', zshift, ' ->', znlr, ' +/-', sigz
      end if


* 2020-Mar-15 KDH sanity check wavelengths
	ngw = 0
      do iw = 1, nw
	n = 0
      do it = 1, nt
	if( wavpic8(iw,it) .gt. 0. ) n = n + 1
      end do
	if( n .eq. nt ) ngw = ngw + 1
      end do
      if( ngw .lt. nw ) then
	write(*,*) '** WAVPIC8(IW,IT) BAD WAVES', NW - NGW, ' :((.'
      end if

* menu
	write(*,*)
	write(*,*) 
     &	'------------------------------------------------------'
	write(*,*) 'PrepSpec Modelling Nw', nw, ' Nt', nt, ' Nt*Nw', nt*nw
	write(*,*) ' Good data ', ngood, ' Bad', nbad, ' =', nint(pc), ' %'
	write(*,*) ' Parameters', nfit, ' DoF', ndof, ' =', nint(pcd), ' %'
	sigscale = min( chimedw, chimedt )
	if( sigscale .gt. 0. ) write(*,*) 'chimedw', chimedw, ' chimedt', chimedt, ' sigscale', sigscale
	if( nbadw .gt. 0 ) write(*,*) '** NO DATA AT', nbadw, ' OF', nw, ' WAVELENGTHS. :((('

* model
	write(*,*)
     &	'------------------------------------------------------'
	write( title, '(a,5(a,i4))' )
     &		  'M ... Model:'
     &		, ' cont', npcont
     &		, ' phot', npscale
     &		, ' shift', npshift
     &		, ' blur', npblur
     &		, ' absn', npabsn
	write(*,*) title(:len1(title))

* gaussian prior
      if( siglnp0 .gt. 0. ) then
	write(*,*) 'G ... Gaussian Prior( p(t) ) rms', 100.*siglnp0, ' %'
      else
	write(*,*) 'G ... Gaussian Prior( p(t) ) rms = infinity.'
      end if

* lines
	write(*,*) 'L ... Lines:', markline, ' active', lineson
      if( dips ) then
	write(*,*) '   Galactic:', nl_galactic, ' <sigv>', vgal_avg, ' rms', vgal_rms
	write(*,*) '  Intrinsic:', nl_intrinsic, '<sigv>', vint_avg, ' rms', vint_rms
      end if

* velocity window half-widths
	write(*,*) 'K ... KM/S of WinHW: NLR', nint(vnlr), vnlrtweak, ' BLR', nint(vblr), vblrtweak
* window half-width targets
	vn = vnwant
	vb = vbwant
	write(*,*) '             Target: NLR', nint( vn ), vnlrtweak, ' BLR', nint(vb), vblrtweak
      IF( .FALSE. ) THEN
	title = '       Target WinHW: NLR'
	call append_i( title, nint( vn ) )
	call append( title, ' BLR' )
	call append_i( title, nint( vb ) )
	write(*,*) title(:len1(title))
      END IF

	title = '               V1-4: NLR'
	call append_i( title, nint( vn1 ) )
	call append_i( title, nint( vn2 ) )
	call append_i( title, nint( vn3 ) )
	call append_i( title, nint( vn4 ) )
c	call append_f( title, vnmadavg4, '*' )

	call append( title, ' BLR' )
	call append_i( title, nint( vb1 ) )
	call append_i( title, nint( vb2 ) )
	call append_i( title, nint( vb3 ) )
	call append_i( title, nint( vb4 ) )
c	call append_f( title, vbmadavg4, '*' )

	write(*,*) title(:len1(title))

* reset
	write(*,*) 'R ... Reset model'

* avg 
	write(*,*) ' A ... Avg spectrum', baravg, ' rms', barrms, ' nfit', nfitavg
* fe2
      if( fe2uv .gt. 0. .or. fe2opt .gt. 0. ) then
	title =    '       Fe2'
	call append_n( title, fe2scl, 3 )
	call append  ( title, '=' )
	call append_i( title, nint( fe2pct ) )
	call append  ( title, '%  vdisp' )
	call append_i( title, nint( fe2kms ) )
	call append  ( title, ' +/-' )
	call append_i( title, nint( sigfe2kms ) )
	call append  ( title, ' km/s' )
	write(*,*) title( : len1(title ) ) 
c	write(*,*) '       Fe2 ', fe2scl, ' =', nint(fe2pct), ' %'
c     &	,'  sig_v', nint(fe2kms), ' +/-', nint(sigfe2kms), ' km/s'
      else
	write(*,*) '       Fe2 Omitted.'
      end if

* continuum
	call avgrms( nt, cont_tp, c0avg, c0rms )
	write(*,*) ' C ... Continuum c0', c0avg, ' rms', c0rms, ' nfit', nfitcont

      do k = 2, npcont 
	call avgrms( nt, cont_tp(1,k), avg, rms )
	title =    '       cont('
	call append_i( title, k - 1 )
	call append( title, ' ) avg' )
	call append_f( title, avg, '*' )
	call append( title, ' ) rms' )
	call append_f( title, rms, '*' )
	write(*,*) title(:len1(title))
c	write(*,*) '       cont(', k-1, ' ) avg', avg, ' rms', rms

      if( .false. ) then
	title = 'c'
	call append_i( title, k-1 )
	call nospace( title )
	call append_f( title, avg, '*' )
	call append( title, 'rms' )
	call append_f( title, rms, '*' )
c	call append( title, 'S/N' )
c	call append_n( title, s, 2 )
	write(*,*) '                 ', title( :len1(title) )
      end if
      end do


* NLR
	write(*,*) ' N ... NLR spec', elrwmn, elrwmx, ' npix', npixnlr, ' nfit', nfitnlr
	write(*,*) '       NLR stiffness', stiffnlr
* BLR
      if( nfitblr .eq. 0 ) then
	write(*,*) ' B ... BLR spec', blrwmn, blrwmx, ' npix', npixblr, ' nfit', nfitblr
      else
	write(*,*) ' B ... BLR spec', blrwmn, blrwmx, ' npix', npixblr, ' nfit', nfitblr
     &		,' /', nt, ' =', real( nfitblr ) / nt

* KDH : THIS FAILS IF H-GAMMA NOT AN ACTIVE BLR LINE
      IF( .FALSE. ) THEN
	lineblr = line_hg
	l = lineblr
* linecen
      if( .false. ) then
	write(*,*) '       lcrv', blrtavg, ' rms', blrtrms, ' flx', vflx_l(l)
	fmt = '(5(a,i6))'
	write(*,fmt) '        Vavg', nint(vvavg_l(l))
     &		, '  med', nint(vvmed_l(l)), '  top', nint(vvtop_l(l))
      end if
* linewidths
	write(*,fmt) '         rms', nint(vvrms_l(l))
     &		, '  mad', nint(vvmad_l(l)), ' fwhm', nint(vvfwhm_l(l))
     &		, ' hw10', nint(vvhw10_l(l))
      end if
      END IF


* VarBLR components
	ngc = 0
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
      if( nfit_l( l ) .gt. 0 ) then
	ngc = ngc + 1
	plot1( ngc ) = ic
	plot2( ngc ) = rest_l( l )
	write(*,*) ic, il, ' Npix', npix_c( ic ), ' Nfit', nfit_l( l )
      end if
      end if
      end do
	write(*,*) '   VarBLR components:', ngc, ' of', ncomp, ' npix', npixvblr

* sort by wavelength
	call quicksort( ngc, plot2, i_l )
      do i = 1, ngc
	ic = nint( plot1( i_l( i ) ) )
	l = line_lc( 1, ic )
	np = npix_c( ic )
      if( np .gt. 0 ) then
	nf = nfit_l( l )
	call mnmx( nt, dat_tl(1,l), dmn, dmx )
	if( dmn .eq. dmx .and. dmn .eq. 0. ) nf = 0
	call mnmx( nw, dat_wl(1,l), dmn, dmx )
	title = ' '
	call append( title, stage_l( l ) )
	call append( title, '...' )
	title = ' '
	call append( title, text_l( l ) )
	call append_i( title, nint( rest_l( l ) ) )
	call append( title, 'spec' )
	call append_f( title, dmn, '*' )
	call append_f( title, dmx, '*' )
	call append( title, 'npix' )
	call append_i( title, np )
	call append( title, 'nfit' )
	call append_i( title, nf )
      if( nf .ne. 0 ) then
	call append( title, '/' )
	call append_i( title, nt )
	call append( title, '=' )
	call append_n( title, real(nf)/nt, 2 )
      end if
	write(*,*) '   ' // title( : len1(title) )
      if( nf .gt. 0 ) then
	call avgrms( nt, dat_tl(1,l), avg, rms )
	write(*,*) '      lcrv', avg, ' rms', rms, ' flx', vflx_l(l)
	fmt = '(5(a,i6))'
* linecen
c      IF( .false. ) then
      IF( .true. ) then
	write(*,fmt) '   AVG Vavg', nint(vavg_l(l))
     &		, '  med', nint(vmed_l(l)), '  top', nint(vtop_l(l))
	write(*,fmt) '   RMS Vavg', nint(vvavg_l(l))
     &		, '  med', nint(vvmed_l(l)), '  top', nint(vvtop_l(l))
      END IF
* linewidths
	write(*,fmt) '    AVG rms', nint(vrms_l(l))
     &		, '  mad', nint(vmad_l(l)), ' fwhm', nint(vfwhm_l(l))
     &		, ' hw10', nint(vhw10_l(l))
	write(*,fmt) '    RMS rms', nint(vvrms_l(l))
     &		, '  mad', nint(vvmad_l(l)), ' fwhm', nint(vvfwhm_l(l))
     &		, ' hw10', nint(vvhw10_l(l))

      end if
      end if
* next VarBLR component lc
      end do

      if( npixbac .gt. 0 ) then
	write(*,*) ' Z ... BaC spec', bacwmn, bacwmx, nfitbac
      if( nfitbac .gt. 0 ) then
	write(*,*) '           lcrv', bactavg, ' rms', bactrms
      end if
      end if

c	write(*,*) ' G ... Gal spec', galwmn, galwmx, nfitgal
c      if( nfitgal .gt. 0 ) then
c	write(*,*) '           lcrv', galtavg, ' rms', galtrms
c      end if

	write(*,*) ' J ... Joint tweak of all lightcurves.'
	write(*,*) ' F ... Flux jitter f0', f0avg, ' rms', f0rms, nfitphot

* KDH : DEBUG REPORT
	call mnmx( nt, p0_t, pmn, pmx )
	call mnmx( nt, sigp0_t, smn, smx )
	write(*,*) '       mnmx', pmn, pmx, ' erb', smn, smx
* END DEBUG REPORT

	if( npscale .gt. 1 )
     &	write(*,*) '              tilt f1', f1avg, ' rms', f1rms
	write(*,*) ' W ... Wavelength jitter x0', x0avg, ' rms', x0rms, nfitshift
	if( npshift .gt. 1 )
     &	write(*,*) '                    tilt x1', x1avg, ' rms', x1rms
	write(*,*) ' S ... Seeing jitter s0', s0avg, ' rms', s0rms, nfitblur
	if( npblur .gt. 1 )
     &	write(*,*) '                tilt s1', s1avg, ' rms', s1rms
	write(*,*) ' T ... Optical depth mn', odmn, ' mx', odmx, npabsn, ' tweak', tweaklines
	write(*,*) 'I ... Iterate', nits, ' ', todolist(:len1(todolist))
	write(*,*) 'P ... Plot (or 1..8 for 1 to 8-panel plot)'
	write(*,*) 'V ... Velocity Profile Plots'


	label = 'X ... Chi^2 / ('
	call append_i( label, nt * nw )
	call append( label, '-' )
	call append_i( label, nfit )
	call append( label, ') =' )
	call append_f( label, chi2red, '(f15.4)' )
	call append( label, '=>' )
	call append_f( label, chi2fixred, '(f15.4)' )
	write(*,*) label(:len1(label))

	write(*,*) 'E ... Error bar scaling', chifix, ' Chi^2/dof =>', chi2fixred
	write(*,*) '# ... Sigma Clip', kliplo, ' <', cliplo, kliphi, ' >', cliphi
	write(*,*) 'D ... Debug Diagnostics', gabby
	write(*,*) 'LW ... Line Width', lwidedef
	write(*,*) 'CH ... Character Height', csizedef
	write(*,*) 'H ... HJD (vs sequence number) on lightcurve plots', timex
	write(*,*) '* ... Log wavelength on plots', logwave
	write(*,*) 'O ... Output to disk files'
	write(*,*) 'Q ... Quit PrepSpec Modelling'
	write(*,*)
     &	'------------------------------------------------------'

* DEBUG OUTPUT
      if( nt .gt. 0 .and. gabby ) then
* pick a time
	it = min( nt, 12 )
	write(*,*) 'Epoch', it, ' of', nt
* phot
	write(*,*) 'phot p0_t', p0_t( it ), ' +/-', sigp0_t( it )
* cont
      do k = 1, npcont
	c = cont_tp( it, k )
	s = sigcont_tp( it, k )
	write(*,*) 'cont(', k-1, ' )', c, ' +/-', s
	cont_p( k ) = c
	sigcont_p( k ) = s
      end do
* hbeta line
	l = line_hb
      if( npix_l( l ) .gt. 0 ) then
	write(*,*) 'Hb', dat_tl( it, l ), ' +/-', sig_tl( it, l )
      end if

* parameters
	np = npar
	write(*,*) 'Joint fit parameters:', np
      if( np .gt. 0 ) then
      do i = 1, np
	ipt = i + np * ( it - 1 )
	p = par_pt( ipt )
	sig = sig_pt( ipt )
	text = text_p( i )
	write(*,'( 1x, a5, i3, 2(a,1pe11.3) )' )
     &		text(: len1(text) ), i
     &		, ' ', p
     &		, ' +/-', sig
      end do

* correlations
	write(*,*) 'Correlation matrix:'
	i = 1 + np * np * ( it - 1 )
	call showmat( np, c_ppt( i ), text_p )
      end if
	write(*,*) 'Continuum:'
	i0t = nw * ( it - 1 )
      do ix = -1,1
	if( ix .eq. -1 ) iw = 1
	if( ix .eq.  0 ) iw = (1+nw)/2
	if( ix .eq.  1 ) iw = nw
	iwt = i0t + iw
	c = cont_wt( iwt )
	s = sigcont_wt( iwt )
	l = nint( w_w( iw ) )
	write(*,*) 'c(', l, ' )', c, ' +/-', s
      end do

      if( np .gt. 0 .and. npcont .gt. 0 ) then
      do k = 1, npcont
	cont_p( k ) = cont_tp( it, k )
      end do
      do ix = -1, 1
	x = ix
	i = 1 + np * ( it - 1 )
	j = 1 + np * ( i - 1 )
	c = poly4( npcont, cont_p, x )
	s = sigpoly( x, np, npcont, ipcont, sig_pt(i), c_ppt(j) )
	write(*,*) 'c(', ix, ' )', c, ' +/-', s
      end do
      end if

* tweak line window half-width
* KDH : THIS CODE MUST MATCH SAME CODE ELSEWHERE
* KDH : SHOULD MAKE IT A SUBROUTINE
*--------------------------------------------------
* NLR options
	vn1 = sclmadn * vnmadavg2
	vn2 = sclfwhm * vnfwhmavg2
	vn3 = sclmadn * vnmadavg3
	vn4 = sclmadn * vnmadavg4
	kn1 = nint( vn1 )
	kn2 = nint( vn2 )
	kn3 = nint( vn3 )
	kn4 = nint( vn4 )
	write(*,*) 'VNLR 1-4:', kn1, kn2, kn3, kn4
* flx^2 weights
	vn = vn1
* geometric mean of flx^2 means of vmad and vfwhm
	vn = sqrt( vn1 * vn2 )
* (flx/vmad)^2 weights
	vn = vn3
* pick
	vn = vn3
	if( vn .le. 0. ) vn = vnlr
* stow
	vnwant = vn
*--------------------------------------------------
* BLR options
	vb1 = sclmadb * vbmadavg2
	vb2 = sclfwhm * vbfwhmavg2
	vb3 = sclmadb * vbmadavg3
	vb4 = sclmadb * vbmadavg4
	kb1 = nint( vb1 )
	kb2 = nint( vb2 )
	kb3 = nint( vb3 )
	kb4 = nint( vb4 )
	write(*,*) 'VBLR 1-4:', kb1, kb2, kb3, kb4
* flx^2 weights
c	vb = vb1
* geometric mean of flx^2 means of vmad and vfwhm
c	vb = sqrt( vb1 ) * sqrt( vb2 )
* (flx/vmad)^2 weights
c	vb = vb3
* pick
	vb = vb3
* KDH : USUALLY VB2 < VB3
c	vb = vb2
c	vb = sqrt( abs( vb2 ) ) * sqrt( abs( vb3 ) )
c	vb = sqrt( vb ) * sqrt( abs( vblr ) )
	if( vb .le. 0. ) vb = vblr
* stow
	vbwant = vb
* timid ?
      if( .false. ) then
	vn = sqrt( vn * vnlr )
	vb = sqrt( vb * vblr )
      end if
* round off
	vnwin = ivdiv * nint( vn / ivdiv )
	vbwin = ivdiv * nint( vb / ivdiv )
* hard limits
	vnwin = min( vnmax, max( vnmin, vnwin ) )
	vbmin = 2. * vnwin
	vbwin = min( vbmax, max( vbmin, vbwin ) )

* detect oscillations
	n = maxbackosc
	n2 = n * 2
	i = nits
	if( nstage .gt. 1 ) i = nits - iter_s( nstage-1 )
      if( i .gt. n2 ) then
	i1 = nits - n
	i2 = i1 - n
*--------------------------------------------------
* nlr converged
      if( vnlrtweak ) then
	call mnmx( n, vnlr_i( i1 ), vmn, vmx )
      if( vmn .eq. vmx ) then
	write(*,*) 'NLR converged', nint( vmn )
c	vnwin = vmn
* nlr oscillating
      else
	call mnmx( n, vnlr_i( i2 ), vmn1, vmx1 )
	call avgrms( n, vnlr_i( i2 ), avg, rms )
      if( vmn .eq. vmn1 .and. vmx .eq. vmx1 ) then
	write(*,*) 'NLR oscillating', nint( vmn ), nint( vmx ), ' avg', nint( avg )
	write(*,*) i2, ' :', ( nint( vnlr_i( i ) ), i = i2, i2 + n - 1 )
	write(*,*) i1, ' :', ( nint( vnlr_i( i ) ), i = i1, i1 + n - 1 )
* KDH : WHY NOT MOVE VMWIN HERE ? USER MAY HAVE CHANGED WINDOWS.
c	vnwin = vmn
c	if( avg .gt. ( vmn + vmx ) / 2. ) vnwin = vmx
      end if
      end if
      end if
*--------------------------------------------------
* blr converged
      if( vblrtweak ) then
	call mnmx( n, vblr_i( i1 ), vmn, vmx )
      if( vmn .eq. vmx ) then
	write(*,*) 'BLR converged', nint( vmn )
* KDH : WHY NOT MOVE VBWIN HERE ? USER MAY HAVE CHANGED WINDOWS.
c	vbwin = vmn
* blr oscillating
      else
	call mnmx( n, vblr_i( i2 ), vmn1, vmx1 )
	call avgrms( n, vblr_i( i2 ), avg, rms )
      if( vmn .eq. vmn1 .and. vmx .eq. vmx1 ) then
	write(*,*) 'BLR oscillating', nint( vmn ), nint( vmx ), ' avg', nint( avg )
	write(*,*) i2, ' :', ( nint( vblr_i( i ) ), i = i2, i2 + n - 1 )
	write(*,*) i1, ' :', ( nint( vblr_i( i ) ), i = i1, i1 + n - 1 )
c	vbwin = vmn
c	if( avg .gt. ( vmn + vmx ) / 2. ) vbwin = vmx
      end if
      end if
      end if
      end if

* report changes
* NLR tweak ( KDH : CODE DUPLICATED ELSEWHERE )
      if( vnlrtweak .and. vnwin .gt. 0 ) then
      if( nint( vnlr ) .ne. nint( vnwin ) ) then
	record = ' NLR:'
* targets
	call append_n( record, sclmadn, 2 )
	call append( record, 'MAD' )
	call append_i( record, nint( vn1 ) )
	call append_f( record, sclfwhm, '(f10.2)' )
	call append( record, 'FWHM' )
	call append_i( record, nint( vn2 ) )
* old -> new 
	call append( record, 'VNLR' )
	call append_i( record, nint( vnlr ) )
      if( nint( vn ) .ne. nint( vnwin ) ) then
	call append( record, '->' )
	call append_i( record, nint( vn ) )
      end if
	call append( record, '->' )
	call append_i( record, nint( vnwin ) )
* step
	call append( record, 'dV' )
	call append_i( record, nint( vnwant - vnlr ) )
	call append( record, '->' )
	call append_i( record, nint( vnwin - vnlr ) )
	write(*,*) record( : len1( record ) )
      end if
c	vnlr = vnwin
      end if

* BLR tweak (KDH : CODE DUPLICATED ELSEWHERE )
      if( vblrtweak .and. vbwin .gt. 0. ) then
      if( nint( vblr ) .ne. nint( vbwin ) ) then
	record = ' BLR:'
* targets
	call append_n( record, sclmadb, 2 )
	call append( record, 'MAD' )
	call append_i( record, nint( vb1 ) )
	call append_f( record, sclfwhm, '(f10.2)' )
	call append( record, 'FWHM' )
	call append_i( record, nint( vb2 ) )
* old -> new 
	call append( record, 'VBLR' )
	call append_i( record, nint( vblr ) )
      if( nint( vb ) .ne. nint( vbwin ) ) then
	call append( record, '->' )
	call append_i( record, nint( vb ) )
      end if
	call append( record, '->' )
	call append_i( record, nint( vbwin ) )
* step
	call append( record, 'dV' )
	call append_i( record, nint( vbwant - vblr ) )
	call append( record, '->' )
	call append_i( record, nint( vbwin - vblr ) )
	write(*,*) record( : len1( record ) )
      end if
c	vblr = vbwin
      end if

	write(*,*)
     &	'------------------------------------------------------'
      end if
* END DEBUG OUTPUT

* legend of fit stages
	ib = 1
      do j = 1, nstage
	i = iter_s( j )
	if( bic_i( i ) .lt. bic_i( ib ) ) ib = i
      end do

      do j = 1, nstage
	i1 = 1
	i = iter_s( j )
	n = i
      if( j .gt. 1 ) then
	i1 = iter_s( j - 1 ) + 1
	n = n - iter_s( j - 1 )
      end if
	nf = nfit_i( i )
	nd = ndat_i( i )
	ndf = max( 0, nd - nf )
	b = bic_i( i )
	im = max( i1, i - 10 )
	db = ( bic_i( i ) - bic_i( im ) ) / max( 1, i - im )
	legend = todo_s(j)
	call append_i( legend, n )
	call append_i( legend, ndat_i( i ) )
	call append_i( legend, nfit_i( i ) )
	call append  ( legend, 'BIC' )
	call append_f( legend, bic_i( i ), '(f20.2)' )
	call append_f( legend, db, '(f20.3)' )
	call append  ( legend, 'Chi2 /' )
	call append_i( legend, ndf )
	call append  ( legend, '=' )
	call append_f( legend, chi2red_i(i), '(f20.4)' )
c	write(*,*) legend( : len1( legend ) )
      end do

* next todo

  510 if( len1( todo ) .gt. 0 ) then
	if( index( todo, 'J' ) .gt. 0 ) goto 551
	reply = todo(1:1)
	todo = todo(2:len1(todo))
	if( gabby ) write(*,*)
	legend = 'Iter'
	call append_i( legend, nits )
	call append( legend, 'to go' )
	call append_i( legend, lastit - nits )
	call append( legend, 'Next:' )
	call append( legend, reply(:len1(reply)) )
	call append( legend, ' to do' )
	call append_i( legend, len1( todo ) )
	call append( legend, todo( : len1( todo ) ) )
	write(*,*) legend( : len1( legend ) )

* new iteration
      else if( nits .lt. lastit ) then
	nits = nits + 1
	todo = todolist

* tweak line window half-width
* KDH : THIS CODE MUST MATCH SAME CODE ELSEWHERE
* KDH : SHOULD MAKE IT A SUBROUTINE
*--------------------------------------------------
* NLR options
	vn1 = sclmadn * vnmadavg2
	vn2 = sclfwhm * vnfwhmavg2
	vn3 = sclmadn * vnmadavg3
	vn4 = sclmadn * vnmadavg4
	kn1 = nint( vn1 )
	kn2 = nint( vn2 )
	kn3 = nint( vn3 )
	kn4 = nint( vn4 )
	write(*,*) 'VNLR 1-4:', kn1, kn2, kn3, kn4
* flx^2 weights
	vn = vn1
* geometric mean of flx^2 means of vmad and vfwhm
	vn = sqrt( vn1 * vn2 )
* (flx/vmad)^2 weights
	vn = vn3
* pick
	vn = vn3
	if( vn .le. 0. ) vn = vnlr
* stow
	vnwant = vn
*--------------------------------------------------
* BLR options
	vb1 = sclmadb * vbmadavg2
	vb2 = sclfwhm * vbfwhmavg2
	vb3 = sclmadb * vbmadavg3
	vb4 = sclmadb * vbmadavg4
	kb1 = nint( vb1 )
	kb2 = nint( vb2 )
	kb3 = nint( vb3 )
	kb4 = nint( vb4 )
	write(*,*) 'VBLR 1-4:', kb1, kb2, kb3, kb4
* flx^2 weights
	vb = vb1
* geometric mean of flx^2 means of vmad and vfwhm
	vb = sqrt( vb1 ) * sqrt( vb2 )
* (flx/vmad)^2 weights
	vb = vb3
* pick
	vb = vb3
* KDH : USUALLY VB2 < VB3
c	vb = vb2
c	vb = sqrt( abs( vb2 ) ) * sqrt( abs( vb3 ) )
c	vb = sqrt( vb ) * sqrt( abs( vblr ) )
	if( vb .le. 0. ) vb = vblr
* stow
	vbwant = vb

* step toward new width
	step = abs( vn - vnlr )
* KDH : WHY LIMIT STEP TO VNLR / VFDIV ?
	if( vfdiv .gt. 0. ) step = min( step, vnlr / vfdiv )
	if( vn .gt. vnlr + ivdiv ) vn = vnlr + step
	if( vn .lt. vnlr - ivdiv ) vn = vnlr - step

	step = abs( vb - vblr )
* KDH : WHY LIMIT STEP TO VBLR / VFDIV ?
	if( vfdiv .gt. 0. ) step = min( step, vblr / vfdiv )
	if( vb .gt. vblr + ivdiv ) vb = vblr + step
	if( vb .lt. vblr - ivdiv ) vb = vblr - step
* round to ivdiv
	vbwin = ivdiv * nint( vb / ivdiv )
	vnwin = ivdiv * nint( vn / ivdiv )
* hard limits
	vnwin = min( vnmax, max( vnmin, vnwin ) )
	vbmin = 2. * vnwin
	vbwin = min( vbmax, max( vbmin, vbwin ) )

* detect oscillations
	n = maxbackosc
	n2 = n * 2
	i = nits
	if( nstage .gt. 1 ) i = nits - iter_s( nstage-1 )
      if( i .gt. n2 ) then
	i1 = nits - n
	i2 = i1 - n
* nlr converged
      if( vnlrtweak ) then
	call mnmx( n, vnlr_i( i1 ), vmn, vmx )
      if( vmn .eq. vmx ) then
	write(*,*) 'NLR converged', nint( vmn )
	vnwin = vmn
* nlr oscillating
      else
	call mnmx( n, vnlr_i( i2 ), vmn1, vmx1 )
	call avgrms( n, vnlr_i( i2 ), avg, rms )
      if( vmn .eq. vmn1 .and. vmx .eq. vmx1 ) then
	write(*,*) 'NLR oscillating', nint( vmn ), nint( vmx ), ' avg', nint( avg )
	write(*,*) i2, ' :', ( nint( vnlr_i( i ) ), i = i2, i2 + n - 1 )
	write(*,*) i1, ' :', ( nint( vnlr_i( i ) ), i = i1, i1 + n - 1 )
	vnwin = vmn
	if( avg .gt. ( vmx + vmn ) / 2. ) vnwin = vmx
      end if
      end if
      end if

* blr converged
      if( vblrtweak ) then
	call mnmx( n, vblr_i( i1 ), vmn, vmx )
      if( vmn .eq. vmx ) then
	write(*,*) 'BLR converged', nint( vmx )
	vbwin = vmn
* blr oscillating
      else
	call mnmx( n, vblr_i( i2 ), vmn1, vmx1 )
	call avgrms( n, vblr_i( i2 ), avg, rms )
      if( vmn .eq. vmn1 .and. vmx .eq. vmx1 ) then
	write(*,*) 'BLR oscillating', nint( vmn ), nint( vmx ), ' avg', nint( avg )
	write(*,*) i2, ' :', ( nint( vblr_i( i ) ), i = i2, i2 + n - 1 )
	write(*,*) i1, ' :', ( nint( vblr_i( i ) ), i = i1, i1 + n - 1 )
	vbwin = vmn
	if( avg .gt. ( vmn + vmx ) / 2. ) vbwin = vmx
      end if
      end if
      end if
      end if

* report changes
* NLR tweak ( KDH : CODE DUPLICATED ELSEWHERE )
      if( vnlrtweak .and. vnwin .gt. 0 ) then
      if( nint( vnlr ) .ne. nint( vnwin ) ) then
	record = ' NLR:'
* targets
	call append_n( record, sclmadn, 2 )
	call append( record, 'MAD' )
	call append_i( record, nint( vn1 ) )
	call append_f( record, sclfwhm, '(f10.2)' )
	call append( record, 'FWHM' )
	call append_i( record, nint( vn2 ) )
* old -> new 
	call append( record, 'VNLR' )
	call append_i( record, nint( vnlr ) )
      if( nint( vn ) .ne. nint( vnwin ) ) then
	call append( record, '->' )
	call append_i( record, nint( vn ) )
      end if
	call append( record, '->' )
	call append_i( record, nint( vnwin ) )
* step
	call append( record, 'dV' )
	call append_i( record, nint( vnwant - vnlr ) )
	call append( record, '->' )
	call append_i( record, nint( vnwin - vnlr ) )
	write(*,*) record( : len1( record ) )
      end if

* take the step
	knlr = nint( vnlr )
	knwin = nint( vnwin )
	knwant = nint( vnwant )
	write(*,*) 'Step NLR', knlr, ' ->', knwin, ' want', knwant
	vnlr = vnwin
      else
* no step taken
	knlr = nint( vnlr )
	write(*,*) 'Step NLR', knlr, ' ->', knwin, ' NOT taken.', vnlrtweak
      end if

* BLR tweak (KDH : CODE DUPLICATED ELSEWHERE )
      if( vblrtweak .and. vbwin .gt. 0. ) then
      if( nint( vblr ) .ne. nint( vbwin ) ) then
	record = ' BLR:'
* targets
	call append_n( record, sclmadb, 2 )
	call append( record, 'MAD' )
	call append_i( record, nint( vb1 ) )
	call append_f( record, sclfwhm, '(f10.2)' )
	call append( record, 'FWHM' )
	call append_i( record, nint( vb2 ) )
* old -> new 
	call append( record, 'VBLR' )
	call append_i( record, nint( vblr ) )
      if( nint( vb ) .ne. nint( vbwin ) ) then
	call append( record, '->' )
	call append_i( record, nint( vb ) )
      end if
	call append( record, '->' )
	call append_i( record, nint( vbwin ) )
* step
	call append( record, 'dV' )
	call append_i( record, nint( vbwant - vblr ) )
	call append( record, '->' )
	call append_i( record, nint( vbwin - vblr ) )
	write(*,*) record( : len1( record ) )
      end if

* take the step
	kblr = nint( vblr )
	kbwin = nint( vbwin )
	kbwant = nint( vbwant )
	write(*,*) 'Step BLR', kblr, ' ->', kbwin, ' want', kbwant
	vblr = vbwin
      else
* no step taken
	kblr = nint( vblr )
	kbwin = nint( vwin )
	write(*,*) 'Step BLR', vblr, ' ->', vbwin, ' NOT taken.', vblrtweak
      end if

	goto 510

* new command
      else
	call inq( 'PrepSpec Modelling >', ' ', reply )

* command to operating system
      IF( REPLY(1:1) .EQ. '$' ) THEN
      if( len1( reply ) .gt. 1 ) then
	reply = reply(2:)
      else
	CALL INQ( 'Command to operating system: ', 'pwd', reply )
      end if
	if( len1( reply ) .gt. 0 ) call spawn( reply )
	GOTO 510
      END IF
	call upcase( reply, reply )
      end if

* quit modelling
	if( reply .eq. 'Q' ) goto 100

* plots
	if( reply .eq. 'X' ) goto 580
* linewidth
      if( reply .eq. 'LW' ) then
	i = lwidedef
	call inqi( 'Default Line Width for Plots', i, i )
	if( i .gt. 0 ) lwidedef = i
	goto 500
      end if

* character height
      if( reply .eq. 'CH' ) then
	val = csizedef
	call inqr( 'Default Character Height for Plots', val, val )
	if( val .gt. 0 ) csizedef = val
	goto 500
      end if

* simple plots (KDH: a bit awkward)
	simpleplot = .true.
	if( reply .eq. 'PS' ) goto 590
	if( reply .eq. '1S' ) goto 590
	if( reply .eq. '2S' ) goto 590
	if( reply .eq. '3S' ) goto 590
	if( reply .eq. '4S' ) goto 590
	if( reply .eq. '5S' ) goto 590
	if( reply .eq. '6S' ) goto 590
	if( reply .eq. '7S' ) goto 590
	if( reply .eq. '8S' ) goto 590
	if( reply .eq. 'VS' ) goto 600

* multi-panel plots
	simpleplot = .false.
	if( reply .eq. 'P' ) goto 590
	if( reply .eq. '1' ) goto 590
	if( reply .eq. '2' ) goto 590
	if( reply .eq. '3' ) goto 590
	if( reply .eq. '4' ) goto 590
	if( reply .eq. '5' ) goto 590
	if( reply .eq. '6' ) goto 590
	if( reply .eq. '7' ) goto 590
	if( reply .eq. '8' ) goto 590
	if( reply .eq. 'V' ) goto 600

* model
	if( reply .eq. 'K' ) goto 512
	if( reply .eq. 'L' ) goto 513
	if( reply .eq. 'M' ) goto 515
	if( reply .eq. 'R' ) goto 520 
* output
	if( reply .eq. 'O' ) goto 570

* tweak all specified fit components jointly
c	if( reply .eq. 'J' ) goto 551
	if( index( reply, 'J' ) .gt. 0 ) goto 551

* tweak fit components singly
	if( reply .eq. 'A' ) goto 530
	if( reply .eq. 'C' ) goto 545
	if( reply .eq. 'B' ) goto 540

	if( reply .eq. 'N' ) goto 535
* DISABLE BALMER CONTINUUM
c	if( reply .eq. 'Z' ) goto 544

* calibrations
	if( reply .eq. 'W' ) goto 555
	if( reply .eq. 'S' ) goto 560
	if( reply .eq. 'F' ) goto 565


* clip thresholds
      if( reply .eq. '#' ) then
* report
  509	n = nw * nt
	klip = kliplo + kliphi
	write(*,*) 'Sigma clip :', klip, ' of', n, ' =', klip * 100. / n, ' %'
	write(*,*) ' >', cliphi, ' :', kliphi, ' of', klip, ' =', nint( kliphi * 100. / klip ), ' %'
	write(*,*) ' <', cliphi, ' :', kliplo, ' of', klip, ' =', nint( kliplo * 100. / klip ), ' %'
	s = 2.5 * ( alog10( real( max( 1, n ) ) ) / 2. )**(2./3.)
	write(*,*) 'Nt*Nw', n, ' Expect', s, ' sigma outliers.'
	write(*,*) ' Note: 0 0 disables sigma clipping.'

	val1 = cliplo
	val2 = cliphi
	call inq2r( 'Sigma clip LOW (<0) and HIGH (>0) thresholds', val1, val2 )

      if( val1 .ne. cliplo .or. val2 .ne. cliphi ) then
	cliplo = min( 0., val1 )
	cliphi = max( 0., val2 )

* clip pixels
	call pixclip( nw, nt, chi_wt, bad_wt, cliplo, cliphi,
     &	kliplo, kliphi, pixlo_w, pixhi_w, pixlo_t, pixhi_t ) 

	call mnmx( nw, pixlo_w, pmn, p1mx )
	call mnmx( nw, pixhi_w, pmn, p2mx )
	write(*,*) nw, 'pix/bin lo', p1mx, ' hi', p2mx

	call mnmx( nt, pixlo_t, pmn, p1mx )
	call mnmx( nt, pixhi_t, pmn, p2mx )
	write(*,*) nt, 'pix/bin lo', p1mx, ' hi', p2mx

	goto 509
      end if
	goto 500
      end if

* gaussian prior on p(t)
      if( reply .eq. 'G' ) then
	val = siglnp0 * 100.
	write(*,*) 'Enter 0 or <0 for Uniform prior.'
	call inqr( 'Gaussian Prior on p(t): RMS (%)', val, val )
	siglnp0 = max( 0., val / 100. )
	goto 500
      end if


* toggle gabby
      if( reply .eq. 'D' ) then
	reply = 'Y'
	if( gabby ) reply = 'N'
	call inq( 'Diagnostic output (Y/N) ?', reply, reply )
	call upcase( reply, reply )
	gabby = reply .eq. 'Y'
	goto 500
      end if

* toggle timex
      if( reply .eq. 'H' ) then
	reply = 'Y'
	if( timex ) reply = 'N'
	call inq( 'HJD (vs sequence number) on lightcurve plots ?', reply, reply )
	call upcase( reply, reply )
	timex = reply .eq. 'Y'
	goto 500
      end if


* toggle logwave
      if( reply .eq. '*' ) then
	reply = 'Y'
	if( logwave ) reply = 'N'
	call inq( 'Log wavelength scales on spectrum plots ?', reply, reply )
	call upcase( reply, reply )
	logwave = reply .eq. 'Y'
	goto 500
      end if


* toggle error bar scaling
      if( reply .eq. 'E' ) then
	reply = 'N'
	if( chifix ) reply = 'Y'
	call inq( 'Error bar scaling (Y/N) ?', reply, reply )
	call upcase( reply, reply )
	chifix = reply .eq. 'Y'
	goto 500
      end if

* toggle tweaklines
      if( reply .eq. 'T' ) then
	reply = 'N'
	if( tweaklines ) reply = 'Y'
	call inq( 'Tweak Absn Lines (Y/N) ?', reply, reply )
	call upcase( reply, reply )
	tweaklines = reply .eq. 'Y'
	goto 500
      end if


* ===============================================
* iterations
      if( reply .eq. 'I' ) then

      if( nstage .ge. 1 ) then
	l = len1( todo_s( nstage ) )
	write(*,*) 'Stage:', nstage, ' ', todo_s( nstage )(:l)
      end if

* to do list
	write(*,*) 'Which model components to tweak ?'
	write(*,*) '  Components:  A=avg,  C=continuum,  B=BLR'
	write(*,*) 'Calibrations:  F=flux, W=wavelength, S=seeing'
	write(*,*) ' ACBFWS tweaks the corresponding model component / calibration'
	write(*,*) ' J invokes joint parameter fits (vs iterative optimal scaling)'
	write(*,*) ' P(or 1..6,8) plots the fit'
	write(*,*) ' X plots Chi^2/BIC vs iteration'
	write(*,*) 'Prefix + to add or - to omit items from the ToDo list.' 
  511	call inq( 'ToDo : ', todolist, reply )
	call upcase( reply, reply )
	l = len1( reply )
      if( l .gt. 0 ) then
* extend todo list
	ip = index( reply, '+' )
	im = index( reply, '-' )
      if( ip .gt. 0 ) then
	todolist = todolist(:len1(todolist)) // reply(ip+1:)
	goto 511
* remove components from todo list
      else if( im .gt. 0 ) then
	l = len1(reply)
      do i = im+1, l
	k = index( todolist, reply(i:i) )
	if( k .gt. 0 ) todolist = todolist(:k-1) // todolist(k+1:)
      end do
	goto 511
* validate proposed todo list
      else
	ka = index( reply, 'A' )
	kc = index( reply, 'C' )
	kb = index( reply, 'B' )
	kf = index( reply, 'F' )
	kw = index( reply, 'W' )
	ks = index( reply, 'S' )
      if(   ka .gt. 0 .or. kc .gt. 0 .or. kb .gt. 0
     & .or. kf .gt. 0 .or. kw .gt. 0 .or. ks .gt. 0 ) then
	write(*,*) 'New ToDo list validated AOK.'
	todolist = reply(:len1(reply))
* read a number of iterations
      else
	write(*,*) '** New ToDo list not recognised : ', reply(:len1(reply))
	read( reply, *, err=511, end=511 ) ival
      if( ival .le. 0 ) then
	write(*,*) '** Please try again.'
	goto 511
      else
	newits = ival
      end if
      end if
      end if

* end l > 0 ?
      end if

* report todo list
	write(*,*) 'ToDo : ', todolist(:len1(todolist))

* new iterations
	if( newits .le. 0 ) newits = 1
	call inqi( 'Iterations', newits, ival )
      if( ival .gt. 0 ) then
	newits = ival
	lastit = nits + newits
	todo = todolist

* stage
	write(*,*) 'ToDo : ', todo(:len1(todo))
	stage = ' '
	if( index( todo, 'A' ) .gt. 0 ) call append( stage, 'A' )
	if( index( todo, 'C' ) .gt. 0 ) call append( stage, 'C' )
	if( index( todo, 'B' ) .gt. 0 ) call append( stage, 'B' )
	if( index( todo, 'F' ) .gt. 0 ) call append( stage, 'F' )
	if( index( todo, 'W' ) .gt. 0 ) call append( stage, 'W' )
	if( index( todo, 'S' ) .gt. 0 ) call append( stage, 'S' )
C	if( index( todo, 'E' ) .gt. 0 ) call append( stage, 'E' )
	call nospace( stage )
	write(*,*) 'Stage: ', stage(:len1(stage))

* empty stage
      if( stage .eq. ' ' ) then
	n = 0
	write(*,*) '** empty stage.'
      else

* first stage
      if( nstage .le. 0 ) then
	n = 1
* too many stages
      else if( nstage .ge. maxstage ) then
	write(*,*) '** STAGE BUFFER FULL.  MAX=', maxstage
	stop
* check for changes
      else if( nstage .lt. maxstage ) then

	n = 0
* todo change
      if( stage .ne. todo_s( nstage ) ) then
	n = n + 10000
	l = len1( todo_s( nstage ) )
	write(*,*) 'STAGE ', todo_s( nstage )(:l), ' => ', stage(:len1(stage))
      end if
* npcont change
      if( index( stage, 'C' ) .gt. 0 .and.
     &	npcont .ne. npcont_s( nstage ) ) then
	n = n + 1
	write(*,*) 'C poly', npcont_s( nstage ), ' =>', npcont
      end if
* npscale change
      if( index( stage, 'F' ) .gt. 0 .and.
     &	npscale .ne. npscale_s( nstage ) ) then
	n = n + 10
	write(*,*) 'F poly', npscale_s( nstage ), ' =>', npscale
      end if
* npshift change
      if( index( stage, 'W' ) .gt. 0 .and.
     &	npshift .ne. npshift_s( nstage ) ) then
	n = n + 100
	write(*,*) 'W poly', npshift_s( nstage ), ' =>', npshift
      end if
* npblur change
      if( index( stage, 'S' ) .gt. 0 .and.
     &	npblur .ne. npblur_s( nstage ) ) then
	n = n + 1000
	write(*,*) 'S poly', npblur_s( nstage ), ' =>', npblur
      end if

* KDH: SHOULD ALSO CHECK FOR CHANGES IN NUMBER OF VARIABLE COMPONENTS


* 2023 FEB KDH : THIS WILL NOT OCCUR WITH 'E' NOT ADDED TO STAGE ABOVE
* chifix changes
      if( index( stage, 'E' ) .gt. 0 ) then
      if(  ( chifix .and. ( .not. chifix_s( nstage ) ) ) .or. 
     &     ( chifix_s( nstage ) .and. ( .not. chifix ) ) ) then
	n = n + 10000
	write(*,*) 'Stage', stage(:len1(stage)), index( stage, 'E' )
	write(*,*) 'ChiFix', chifix_s( nstage ), ' =>', chifix
      end if
      end if

* end checking for new stage
      end if

* new stage detected
      if( n .gt. 0 ) then
	nstage = nstage + 1
	write(*,*) 'New stage', nstage, ' of', maxstage
* stow
	iter_s( nstage ) = lastit
	todo_s( nstage ) = stage( :len1( stage ) )
	npcont_s( nstage ) = npcont
	npscale_s( nstage ) = npscale
	npshift_s( nstage ) = npshift
	npblur_s( nstage ) = npblur
	chifix_s( nstage ) = chifix
c      end if

* KDH : CONSTRUCT MODEL NAME
	kc = 1
	kf = 2
	kw = 3
	ks = 4
	kb = 5
	ke = 6
	nk = max( kc, kf, kw, ks, kb, ke )
	label = ' '
* will this not always be the case ?
      IF( nstage .gt. 0 ) then
	label = todo_s( nstage )
      do k = 1, nk
	l = len1( label )
	title = label(:l)
	i = 0
      if( k .eq. kc ) then
	i = index( title, 'C' )
	n = nfitcont
	j = npcont
	if( i .gt. 0 ) write(*,*) 'Continuum fit nfitcont', n, ' npcont', j
      else if( k .eq. kf ) then
	i = index( title, 'F' )
	n = nfitphot
	j = npscale
      else if( k .eq. kw ) then
	i = index( title, 'W' )
	n = nfitshift
	j = npshift
      else if( k .eq. ks ) then
	i = index( title, 'S' )
	n = nfitblur
	j = npblur
      else if( k .eq. kb ) then
	i = index( title, 'B' )
	j = 0
	n = 0
* VarBLR components
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	ll = line_lc( 1, ic )
	if( nfit_l( ll ) .gt. 0 ) j = j + 1
	if( nfit_l( ll ) .gt. 0 ) n = n + nfit_l( ll )
      end if
      end do
* error-bar scaling
      else if( k .eq. ke ) then
	i = index( title, 'E' )
	j = 0
	n = 0  	
      end if

* insert subscript
      if( i .gt. 0 .and. n .gt. 0 .and. j .gt. 1 ) then
	label = title(:i)
	call append( label, '\d' )
	call append_i( label, j )
	call append( label, '\u' )
	if( l .gt. i ) call append( label, title(i+1:l) )
	write(*,*) label(:len1(label))
	call nospace( label )
	write(*,*) label(:len1(label))
      end if
* next k
      end do

* end nstage .gt. 0
c      END IF

	model_s( nstage ) = label
	write(*,*) 'Model : ', label(:len1(label))

* end n > 0 (new stage detected)
      end if

* end nstage in (1,maxstage)
      end if
* end stage not ' '
      end if
* end ival > 0
      end if


* command not recognised
      else
	goto 500
      end if
	if( index( todo, 'J' ) .gt. 0 ) goto 551
	goto 510

*---------------------------------------------------------------
* revise NLR and BLR velocity widths and windows
  512	continue

* KDH : THIS IS DONE AFTER EACH ITERATION

* recommend revised window widths
	write(*,*)
	write(*,*) 'Line window half-width options:'

* Evaluate various measures of linewidth
* NLR/BLR/VBLR loop
* KDH : STRIP THIS DOWN SO IT IS SILENT
	ln = 1
	lb = 2
	lv = 3
      do loop = 1, 3
	if( loop .eq. ln ) ntest = narrow
	if( loop .eq. lb ) ntest = nbroad
	if( loop .eq. lv ) ntest = nbroad

* flx divisor
	nf = 0
	f = 0.
	fa = 0.
* snr divisor
	ns = 0
	s = 0.
	sa = 0.
      do lrank = 1, markline
	l = i_l( lrank )
      if( npix_l( l ) .gt. 0 .and. nabc( l ) .eq. ntest ) then
      if( .not. ( iw1_l( l ) .le. 1. .or. iw2_l( l ) .ge. nw ) ) then
	flx = flx_l( l )
	sig = sigflx_l( l )
      if( loop .eq. lv ) then
	flx = vflx_l( l )
	sig = sigvflx_l( l )
      end if
	snr = 0.
	if( sig .gt. 0. ) snr = flx / sig
* good flx
      if( flx .ne. 0. ) then
	nf = nf + 1
	f = max( f, flx )
	fa = max( fa, abs( flx ) )
      end if
* good snr
      if( snr .ne. 0. ) then
	ns = ns + 1
	s = max( s, snr )
	sa = max( s, abs( snr ) ) 
      end if
      end if
      end if
* next lrank
      end do

* KDH : NS COMES UP 0

* flx divisor
	if( f .lt. 0. ) f = fa
	divf = f / 1000.
	divf = fa / 1000.
* snr divisor
	divs = sa / 1000.

* line count
	n = max( nf, ns )
      if( n .gt. 0 ) then
	write(*,*)
	if( loop .eq. ln ) write(*,*) '   NLR lines', nf, ' FLX divisor', divf
	if( loop .eq. ln ) write(*,*) '   NLR lines', ns, ' S/N divisor', divs

	if( loop .eq. lb ) write(*,*) '   BLR lines', nf, ' FLX divisor', divf
	if( loop .eq. lb ) write(*,*) '   BLR lines', ns, ' S/N divisor', divs

	if( loop .eq. lv ) write(*,*) ' VarBLR lines', nf, ' FLX divisor', divf
	if( loop .eq. lv ) write(*,*) ' VarBLR lines', ns, ' S/N divisor', divs

* line loop
	k = 0
	kbig = 0
	lbig = 0
      do lrank = 1, markline
	l = i_l( lrank )
      if( npix_l( l ) .gt. 0 .and. nabc( l ) .eq. ntest ) then
	w0 = rest_l( l )
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	expand = expand_l( l )
* KDH : SHOULD WE SKIP IF EXPAND < 0 ?
	flx = flx_l( l )
	sigflx = sigflx_l( l )
	vmad = vmad_l( l )
	vmed = vmed_l( l )
	vrms = vrms_l( l )
	vfwhm = vfwhm_l( l )
      if( loop .eq. lv ) then
	flx = vflx_l( l )
	sigflx = sigvflx_l( l )
	vmad = vvmad_l( l )
	vmed = vvmed_l( l )
	vrms = vvrms_l( l )
	vfwhm = vvfwhm_l( l )
      end if
* relative flux
	if( divf .ne. 0. ) flx = flx / divf
* snr 
	snr = 0.
	if( sigflx .ne. 0. ) snr = flx / abs( sigflx )
* relative snr
* KDH : DO WE NEED S/N DIVISOR ?
	if( divs .ne. 0. ) snr = snr / divs

      if( vrms .gt. 0. .or. vmad .gt. 0. ) then
* report
	text = text_l( l )
	write(*, '( i5, i7, 4( a, i6 ), 2( a, i6 ), 1x, a )' )
     &		k+1, nint( w0 )
     &		, ' Vmad', nint( vmad )
     &		, ' Vrms', nint( vrms )
     &		, ' FWHM', nint( vfwhm )
     &		, ' WinHW', nint( vblr * expand )
     &		, ' S/N', nint( snr )
     &		, ' FLX', nint( flx )
     &		, text(:len1(text))

* skip
      if( iw1 .le. 1. .or. iw2 .ge. nw ) then
	write(*,*) '** SKIP', nint(w0), ' CLIPPED WINDOW', iw1, iw2, ' :(((.'
* else if( expand .eq. 0. ) then
	write(*,*) '** SKIP', nint(w0), ' WINDOW', iw1, iw2, ' expand', expand, ' :(((.'
* stow
      else
	k = k + 1
* width options
	plot1( k ) = vmad
	plot2( k ) = vrms
	plot3( k ) = vfwhm
	plot4( k ) = vmad / expand
	plot5( k ) = vrms / expand
* downweight shifted lines
	x = vmed / vmad
	wgt = exp( -0.5 * x * x )
* downweight low s/n < 20 lines
      if( sigflx .gt. 0. ) then
	snr = flx / sigflx
	s = max( 0., snr )
	ss = s * s
	s0 = 20.
	wgt = wgt * ss / ( ss + s0 * s0 )
      end if
* weight options
	plot6( k ) = wgt * abs( flx )
	plot7( k ) = wgt * flx * flx
	plot8( k ) = wgt * ( flx / vmad )**2
	plot9( k ) = wgt
* note line with largest flux
      if( k .eq. 1 .or. abs( flx ) .gt. big ) then
	kbig = k
	big = abs( flx )
	lbig = l
	lambig = nint( rest_l( lbig ) )
      end if

      end if
      end if
      end if
* next lrank
      end do
      end if

* NLR/BLR linewidth stats
	call medmad( n, plot1, vmad, vmadmad )
	call medmad( n, plot2, vrms, vrmsmad )
	call medmad( n, plot3, vfwhm, vfwhmmad )
      if( n .gt. 0 ) then
	write(*, '( 1x, a, i4, 4( a, i6 ), a )' )
     &		'   Median of', n
     &		, ' Vmad', nint( vmad )
     &		, ' Vrms', nint( vrms )
     &		, ' FWHM', nint( vfwhm ), ' km/s'
      end if
* flux-weighted mean
	call wgtavg( n, plot1, plot6, vmadavg )
	call wgtavg( n, plot2, plot6, vrmsavg )
	call wgtavg( n, plot3, plot6, vfwhmavg )
      if( n .gt. 0 ) then
	write(*, '( 1x, a, i4, 4( a, i6 ), a )' )
     &		' Flux-avg of', n
     &		, ' Vmad', nint( vmadavg )
     &		, ' Vrms', nint( vrmsavg )
     &		, ' FWHM', nint( vfwhmavg ), ' km/s'
      end if
* flux^2-weighted mean
	call wgtavg( n, plot1, plot7, vvmadavg2 )
	call wgtavg( n, plot2, plot7, vvrmsavg2 )
	call wgtavg( n, plot3, plot7, vvfwhmavg2 )
      if( n .gt. 0 ) then
	write(*, '( 1x, a, i4, 4( a, i6 ), a )' )
     &		'Flx^2-avg of', n
     &		, ' Vmad', nint( vvmadavg2 )
     &		, ' Vrms', nint( vvrmsavg2 )
     &		, ' FWHM', nint( vvfwhmavg2 ), ' km/s'
      end if
* (flux/Vmad)^2-weighted mean
	call wgtavg( n, plot1, plot8, vvmadavg3 )
	call wgtavg( n, plot2, plot8, vvrmsavg3 )
	call wgtavg( n, plot3, plot8, vvfwhmavg3 )
      if( n .gt. 0 ) then
	write(*, '( 1x, a, i4, 4( a, i6 ), a )' )
     &		'(Flx/Vmad)^2-avg of', n
     &		, ' Vmad', nint( vvmadavg3 )
     &		, ' Vrms', nint( vvrmsavg3 )
     &		, ' FWHM', nint( vvfwhmavg3 ), ' km/s'
      end if
* (S/N)^2 weighted mean
	call wgtavg( n, plot1, plot9, vvmadavg4 )
	call wgtavg( n, plot2, plot9, vvrmsavg4 )
	call wgtavg( n, plot3, plot9, vvfwhmavg4 )
      if( n .gt. 0 ) then
	write(*, '( 1x, a, i4, 4( a, i6 ), a )' )
     &		'(S/N)^2-avg of', n
     &		, ' Vmad', nint( vvmadavg4 )
     &		, ' Vrms', nint( vvrmsavg4 )
     &		, ' FWHM', nint( vvfwhmavg4 ), ' km/s'
      end if

* window halfwidth options
* narrow lines
      if( loop .eq. ln ) then
	n_nlr = n
	l_nlr = lbig
	lam_nlr = lambig
	call medmad( n, plot4, vnmadx, vnmadxmad )
	call medmad( n, plot5, vnrmsx, vnrmsxmad )
	vnmad1 = plot4( kbig )
	vnrms1 = plot5( kbig )

	call wgtavg( n, plot4, plot6, vnmadavg )
	call wgtavg( n, plot5, plot6, vnrmsavg )

	call wgtavg( n, plot4, plot7, vnmadavg2 )
	call wgtavg( n, plot5, plot7, vnrmsavg2 )

	call wgtavg( n, plot4, plot8, vnmadavg3 )
	call wgtavg( n, plot5, plot8, vnrmsavg3 )

	call wgtavg( n, plot4, plot9, vnmadavg4 )
	call wgtavg( n, plot5, plot9, vnrmsavg4 )

      if( vnmadavg4 .le. 0. ) then
	write(*,*) '** WARNING: VNMADAVG4=', vnmadavg4
	write(*,*) 'plot4:', (plot4(i),i=1,n)
	write(*,*) 'plot9:', (plot9(i),i=1,n)
      end if

* broad lines
      else if( loop .eq. lb ) then
	n_blr = n
	l_blr = lbig
	lam_blr = lambig
	call medmad( n, plot4, vbmadx, vbmadxmad )
	call medmad( n, plot5, vbrmsx, vbrmsxmad )
	vbmad1 = plot4( kbig )
	vbrms1 = plot5( kbig )

	call wgtavg( n, plot4, plot6, vbmadavg )
	call wgtavg( n, plot5, plot6, vbrmsavg )

	call wgtavg( n, plot4, plot7, vbmadavg2 )
	call wgtavg( n, plot5, plot7, vbrmsavg2 )

	call wgtavg( n, plot4, plot8, vbmadavg3 )
	call wgtavg( n, plot5, plot8, vbrmsavg3 )

	call wgtavg( n, plot4, plot9, vbmadavg4 )
	call wgtavg( n, plot5, plot9, vbrmsavg4 )

      if( vbmadavg4 .le. 0. ) then
	write(*,*) '** WARNING: VBMADAVG4=', vbmadavg4
	write(*,*) 'plot4:', (plot4(i),i=1,n)
	write(*,*) 'plot9:', (plot9(i),i=1,n)
      end if


* variable broad lines
      else if( loop .eq. lv ) then
	n_vblr = n
	l_vblr = lbig
	lam_vblr = lambig
	call medmad( n, plot4, vbmadx, vvbmadxmad )
	call medmad( n, plot5, vbrmsx, vvbrmsxmad )
	vvbmad1 = plot4( kbig )
	vvbrms1 = plot5( kbig )

	call wgtavg( n, plot4, plot6, vvbmadavg )
	call wgtavg( n, plot5, plot6, vvbrmsavg )

	call wgtavg( n, plot4, plot7, vvbmadavg2 )
	call wgtavg( n, plot5, plot7, vvbrmsavg2 )

	call wgtavg( n, plot4, plot8, vvbmadavg3 )
	call wgtavg( n, plot5, plot8, vvbrmsavg3 )

	call wgtavg( n, plot4, plot9, vvbmadavg4 )
	call wgtavg( n, plot5, plot9, vvbrmsavg4 )

      if( vvbmadavg4 .le. 0. ) then
	write(*,*) '** WARNING: VVBMADAVG4=', vvbmadavg4
	write(*,*) 'plot4:', (plot4(i),i=1,n)
	write(*,*) 'plot9:', (plot9(i),i=1,n)
      end if

      end if

* next NLR/BLR/VBLR loop
      end do

      if( n_nlr .gt. 0 .or. n_blr .gt. 0 ) then
	title = '( NLR'
	call append_i( title, lam_nlr )
	call append( title, 'BLR' )
	call append_i( title, lam_blr )
	call append( title, ')' )

* window scale factor
	text = ' '
	call append_n( text, sclmadn, 2 )
      if( sclmadb .ne. sclmadn ) then
	call append( text, '/' )
	call append_n( text, sclmadb, 2 )
	text = '(' // text(:len1(text)) // ')'
      end if
	call nospace(text)
	lt = len1(text)
	kmsn = nint( sclmadn * vnmad1 )
	kmsb = nint( sclmadb * vbmad1 )
	write(*,*) ' 1 ... V -> ', text(:lt), ' x Vmad =', kmsn, kmsb, ' ', title(:len1(title))
	kmsn = nint( sclmadn * vnmadx )
	kmsb = nint( sclmadb * vbmadx )
	write(*,*) ' 2 ... ', text(:lt), ' x med(Vmad) =', kmsn, kmsb
	kmsn = nint( sclmadn * vnrmsx )
	kmsb = nint( sclmadb * vbrmsx )
	write(*,*) ' 3 ... ', text(:lt), ' x med(Vrms) =', kmsn, kmsb
	kmsn = nint( sclmadn * vnmadavg )
	kmsb = nint( sclmadb * vbmadavg )
	write(*,*) ' 4 ... ', text(:lt), '   x  <Vmad> =', kmsn, kmsb, ' (flux-weighted)'
	kmsn = nint( sclmadn * vnmadavg2 )
	kmsb = nint( sclmadb * vbmadavg2 )
	write(*,*) ' 5 ... ', text(:lt), '   x  <Vmad> =', kmsn, kmsb, ' (flux^2-weighted)'
	kmsn = nint( sclfwhm * vnfwhmavg2 )
	kmsb = nint( sclfwhm * vbfwhmavg2 )
	write(*,*) ' 6 ...', sclfwhm, ' x  <FWHM> =', kmsn, kmsb, ' (flux^2-weighted)'
	kmsn = nint( sclmadn * vnmadavg3 )
	kmsb = nint( sclmadb * vbmadavg3 )
	write(*,*) ' 7 ... ', text(:lt), '   x  <Vmad> =', kmsn, kmsb, ' ((Flx/Vmad)^2-weighted)'
	kmsn = nint( sclmadn * vnmadavg4 )
	kmsb = nint( sclmadb * vbmadavg4 )
	write(*,*) ' 8 ... ', text(:lt), '   x  <Vmad> =', kmsn, kmsb, ' ((S/N)^2-weighted)'

      end if

	write(*,*) '( < 0 enables auto-tweak NLR', vnlrtweak, ' BLR', vblrtweak, ' )'
	ival1 = nint( vnlr )
	ival2 = nint( vblr )
	if( vnlrtweak ) ival1 = - ival1
	if( vblrtweak ) ival2 = - ival2
* user selection
	call inq2i( 'NLR and BLR window half width (kms) ', ival1, ival2 )
* implement user selection
	i = iabs( ival1 )
      if( i .gt. 8 ) then
	vnlr = i
	vnlrtweak = ival1 .lt. 0
      else if( n_nlr .gt. 0 ) then
	v = vnlr
	if( i .eq. 1 ) v = nint( sclmadn * vnmad1 )
	if( i .eq. 2 ) v = nint( sclmadn * vnmadx )
	if( i .eq. 3 ) v = nint( sclmadn * vnrms1 )
	if( i .eq. 4 ) v = nint( sclmadn * vnmadavg )
	if( i .eq. 5 ) v = nint( sclmadn * vnmadavg2 )
	if( i .eq. 6 ) v = nint( sclfwhm * vnfwhmavg2 )
	if( i .eq. 7 ) v = nint( sclmadn * vnmadavg2 )
	if( i .eq. 8 ) v = nint( sclmadn * vnmadavg4 )
	vnlr = nint( abs( v ) )
	vnlrtweak = ival1 .lt. 0 
      end if

	i = iabs( ival2 )
      if( i .gt. 8 ) then
	vblr = i
	vblrtweak = ival2 .lt. 0
      else if( n_blr .gt. 0 ) then
	v = vblr
	if( i .eq. 1 ) v = nint( sclmadb * vbmad1 )
	if( i .eq. 2 ) v = nint( sclmadb * vbmadx )
	if( i .eq. 3 ) v = nint( sclmadb * vbrms1 )
	if( i .eq. 4 ) v = nint( sclmadb * vbmadavg )
	if( i .eq. 5 ) v = nint( sclmadb * vbmadavg2 )
	if( i .eq. 6 ) v = nint( sclfwhm * vbfwhmavg2 )
	if( i .eq. 7 ) v = nint( sclmadb * vbmadavg3 )
	if( i .eq. 8 ) v = nint( sclmadb * vbmadavg4 )
	vblr = nint( abs( v ) )
	vblrtweak = ival2 .lt. 0 
      end if

* report
	write(*,*) 'Window half-width NLR', nint( vnlr ), vnlrtweak
     &		, ' BLR', nint(vblr), vblrtweak
* round off
	write(*,*) 'Round to nearest', ivdiv, ' km/s'
	vblr = ivdiv * nint( vblr / ivdiv )
	vnlr = ivdiv * nint( vnlr / ivdiv )
* report
	write(*,*) 'Window half-width NLR', nint( vnlr ), vnlrtweak
     &		, ' BLR', nint(vblr), vblrtweak

	goto 514

*======================================================
* edit the linelist
  513	wlo = w_w( 1 ) * exp( - vblr / ckms )
	whi = w_w( nw ) * exp( vblr / ckms )

* make expand < 0 for VarBLR lines
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
	expand = expand_l( l )
	expand_l( l ) = - abs( expand )
      end if
      end do

* count active lines in range
	lineson = 0
      do i = 1, markline
	expand = expand_l( i )
	rest = rest_l( i )
      if( wlo .le. rest .and. rest .le. whi ) then
	if( expand .ne. 0. ) lineson = lineson + 1
      end if
      end do
	write(*,*) 'Lines:', markline, ' Active lines in range:', lineson

* line types
      do k = 1, 2
	if( k .eq. 1 ) nwant = narrow
	if( k .eq. 2 ) nwant = nbroad
* column heads
	fmt = '(a6, a8, 2a4, a15)'
	write(*,fmt) 'line', 'Rest(A)', 'B/N', 'Var', 'V(HW)(km/s)'
* lines increasing with wavelength
      do lrank = 1, markline
	l = i_l( lrank )
	n = nabc( l )
      if( n .eq. nwant ) then
	rest = rest_l( l )
	text = text_l( l )
	expand = expand_l( l )
* velocity half-widths
	v = vblr
	if( n .eq. narrow ) v = vnlr
	iv = nint( v )
	ive = nint( v * expand )
* variable lines
	reply = ' '
	if( expand .lt. 0. ) reply = 'Var'
      if( rest .ge. wlo .and. rest .le. whi ) then
	fmt = '(i6, i8, 1x,a3,a5, i6,'' ('', i6, '' x'', f5.2, '' ) '', a)'
	write(*,fmt) l, nint( rest ), linetype( l ), reply, ive, iv, expand, text(:len1(text))
      end if
      end if
* next lrank
      end do
* next k
      end do

* report VarBLR lines in/out of range
	notin = 0
	invar = 0
	title = ' '
	label = ' '
      do lrank = 1, markline
	l = i_l( lrank )
	ic = 0
      do i = 1, ncomp
	if( l .eq. line_lc(1,i) ) ic = i
      end do
      if( ic .gt. 0 ) then
	rest = rest_l( l )
	text = text_l( l )
	lt = len1( text )
	lam = nint( rest )
	expand = expand_l( l )
* variable lines have expand < 0
      if( expand .lt. 0. ) then
* out of range
      if( rest .lt. wlo .or. rest .gt. whi ) then
	notin = notin + 1
	call append( title, text(:lt) )
	call append_i( title, lam )
* in range
      else 
	invar = invar + 1
	call append( label, text(:lt) )
	call append_i( label, lam )
      end if
      end if
      end if
* next lrank
      end do
	write(*,*) 'VarBLR lines enabled:', invar, ' of', ncomp, ' max', maxc
	if( invar .gt. 0 ) write(*,*) ' ', label(:len1(label) )
      if( notin .gt. 0 ) then
	write(*,*) 'VarBLR lines out of range:', notin
	write(*,*) ' ' // title(:len1(title))
      end if

* balmer continuum
      if( bac2 .ge. wlo .and. bac2 .le. whi ) then
	iv = nint( vblr )
	ive = nint( vblr * expandbac )
	write(*,*) 'BaC:', nint( bac1 ), nint( bac2 ) 
     &		, ive, ' (', iv, ' x', expandbac, ' )'
	write(*,*)
	write(*,*) '-1 ... Balmer Continuum component.'
      else
	write(*,*)
      end if

* fe2
	label = ' F ... Fe2 uv'
	call append_f( label, fe2uv, '*' )
	call append( label, ' opt' )
	call append_f( label, fe2opt, '*' )
	call append( label, ' kms' )
	call append_i( label, nint( fe2kms ) )
	call append( label, ' A' )
	call append_n( label, fe2ang, 2 )
	write(*,*) label(:len1(label))

	write(*,*) ' N ... forces a Narrow line (e.g. 5008n )'
	write(*,*) ' B ... forces a Broad line  (e.g. 4861b )'
	write(*,*) ' C ... Clear the linelist. (cn/cb clears narrow/broad lines)'
	write(*,*) ' A ... Activate  linelist. (an/ab activates narrow/broad lines)'
	write(*,*) ' V ... Variable  linelist. (vb makes all broad lines variable)'
	write(*,*) ' Q ... Quit when finished.'
* select
 5131	call inq( 'Enter a line number or wavelength > ', ' ', reply )
	call upcase( reply, reply )

* strip comments
	i = index( reply, '!' )
	if( i .ge. 1 ) reply = reply(:max(1,i-1))
	i = index( reply, '#' )
	if( i .ge. 1 ) reply = reply(:max(1,i-1))

	if( reply .eq. ' ' ) goto 513
	if( reply .eq. '0' ) goto 513
	if( reply .eq. 'Q' ) goto 514

* fe2 model -------------------------------------
      if( reply(1:1) .eq. 'F' ) then
	write(*,*) 'Fe2 model:'
	call inq2r( ' UV, Opt factors', fe2uv, fe2opt )
	call inq2r( ' RMS blur km/s, Ang', fe2kms, fe2ang )
	fe2uv  = max( 0., fe2uv )
	fe2opt = max( 0., fe2opt )
	fe2ang = max( 0., fe2ang )
	fe2kms = max( 0., fe2kms )
      if( fe2uv .eq. 0. .and. fe2opt .eq. 0. ) then
	fe2scl = 0.
	sigfe2kms = 0.
      end if
	goto 513
      end if
* end fe2 model -------------------------------------

* note presence of meaningful letters
	ia = index( reply, 'A' )
	iv = index( reply, 'V' )
	ic = index( reply, 'C' )
	in = index( reply, 'N' )
	ib = index( reply, 'B' )
	if( in .gt. 0 ) iv = 0
	if( in .gt. 0 ) ib = 0
	write(*,*) 'ic', ic, ' ia', ia, ' in', in, ' ib', ib, ' iv', iv

* clear linelist -----------------------
      if( ic .gt. 0 ) then
	nn = 0
	nb = 0
      do i = 1, markline
	n = nabc( i )
	k = 1
	if( in .gt. 0 .and. n .ne. narrow ) k = 0
	if( ib .gt. 0 .and. n .ne. nbroad ) k = 0
      if( k .gt. 0 ) then
	expand_l( i ) = 0.
	if( n .eq. narrow ) nn = nn + 1
	if( n .eq. nbroad ) nb = nb + 1
      end if
      end do
* report
      if( in .gt. 0 .and. ib .le. 0 ) then
	write(*,*) 'NARROW lines cleared', nn
      else if( ib .gt. 0 .and. in .le. 0 ) then
	write(*,*) 'BROAD lines cleared', nb
      else
	write(*,*) nn, ' NARROW and', nb, ' BROAD lines cleared.'
      end if
	goto 513
      end if
* end clear linelist -----------------------

* activate (make variable) the full linelist -------------------
      if( ( ia .gt. 0 .or. iv .gt. 0 ) 
     &	.and. ( in .gt. 0 .or. ib .gt. 0 ) ) then
	nn = 0
	nb = 0
	i1 = markline + 1
	i2 = 0
      do i = 1, markline
* skip lines out of range
	rest = rest_l( i )
	if( rest .lt. wlo .or. rest .gt. whi ) cycle
	i1 = min( i1, i )
	i2 = max( i2, i )
	n = nabc( i )
	e = expand_l( i )
	k = 0
	if( in .gt. 0 .and. n .eq. narrow ) k = 1
	if( ib .gt. 0 .and. n .eq. nbroad ) k = 1
      if( k .gt. 0 ) then
	e = abs( e )
	if( e .eq. 0. ) e = 1.
	if( iv .gt. 0 ) e = -e
	expand_l( i ) = e
	if( n .eq. narrow ) nn = nn + 1
	if( n .eq. nbroad ) nb = nb + 1
      end if
* next line i
      end do
* report
      if( in .gt. 0 .and. ib .le. 0 ) then
	write(*,*) nn, ' NARROW lines activated.'
      else if( ib .gt. 0 .and. in .le. 0 ) then
      if( iv .eq. 0 ) then
	write(*,*) nb, ' BROAD lines activated.'
      else
	write(*,*) nb, ' BROAD lines made variable.'
      end if
      else
	write(*,*) nn, ' NARROW and', nb, ' BROAD lines activated.'
      end if
* KDH : NEED TO DO MORE HERE FOR VARIABLE LINES
* NEED TO ADD NEW VARIABLE LINES TO THE COMPONENTS LIST.
	goto 5132
c	goto 513
      end if
* end activate (make variable) the full linelist -------------------


* identify the requested line --------------------

* strip letter N (narrow) or B (broad) from reply
      if( in .gt. 0 ) then
	reply = reply(:in-1) // reply(in+1:)
	write(*,*) 'Narrow Line ', reply(:len1(reply))
* broad line
      else if( ib .gt. 0 ) then
	reply = reply(:ib-1) // reply(ib+1:)
	write(*,*) 'Broad Line ', reply(:len1(reply))
* line both broad and narrow
      else
	write(*,*) 'Broad', ib, ' Narrow', in, ' Line ', reply(:len1(reply))
      end if

* k is line number or wavelength (or k<0 for BaC)
	read( reply, *, err=5131, end=5131 ) k
* k is sequence number
      if( k .ge. 1 .and. k .le. markline ) then
* k is wavelength
      else if( k .gt. 0 ) then
	lam = k
	k = 0
	lbest = i_l( 1 )
      do j = 1, markline
* compare wavelength to best so far
	lj = i_l( j )
	lamj = nint( rest_l( lj ) )
	lamb = nint( rest_l( lbest ) )
	lower = abs( lam - lamj ) - abs( lam - lamb )
* better or equal match
      if( lower .le. 0 ) then
	n = nabc( lj )
	nb = nabc( lbest )
* better match
	if( lower .lt. 0 
* equal match to specified narrow line
     &	.or. ( in .gt. 0 .and. n .eq. narrow )
* equal match to specified broad line
     &	.or. ( ib .gt. 0 .and. n .eq. nbroad )
* equal match to unspecified line type - default to broad
     &	.or. ( in .le. 0 .and. ib .le. 0 .and. nb .ne. nbroad )
* new best line
     &	) lbest = lj
      end if
* match within 1 angstrom
      if( lamj .eq. lam ) then
* first match
	if( k .eq. 0 ) write(*,*)
* force narrow
	n = nabc( lj )
      if( in .gt. 0 .and. ib .le. 0 ) then
      if( n .eq. narrow ) then
	write(*,*) 'Match to NARROW line', lj, lamj
	k = lj
      end if
* force broad
      else if( ib .gt. 0 .and. in .le. 0 ) then
      if( n .eq. nbroad ) then
	write(*,*) 'Match to BROAD line', lj, lamj
	k = lj
      end if
* allow either but prefer broad
      else if( n .eq. nbroad ) then
	write(*,*) 'Match to BROAD line', lj, lamj
	k = lj
      else if( k .eq. 0 .and. n .eq. narrow ) then
	write(*,*) 'Match to NARROW line', lj, lamj
	k = lj
      end if
      end if
* next j
      end do
      end if
* k should now be a line number, 0 if no match, <0 for BaC.

* no match
      if( k .eq. 0 ) then
	write(*,*) '** SORRY, NO LINES MATCH ', reply(:len1(reply)), ' :('
* try closest line
      if( lbest .gt. 0 .and. lbest .le. markline ) then
	write(*,*) '** TRY CLOSEST MATCH ', lbest, rest_l( lbest )
	k = lbest
      else
	goto 5131
      end if
      end if

* edit BaC
      if( k .lt. 0 ) then
	write(*,*) 'BaC wavelength', nint( bac1 ), nint( bac2 ),
     &	 ' expand Vblr by', expand
	val1 = bac1
	val2 = expandbac
	call inq2r( 'Start wavelength and expand factor', val1, val2 )
	if( val1 .gt. 2500. ) bac1 = val1
	expandbac = max( 0., val2 )
	goto 513
      end if

* oops
      if( k .gt. markline ) then
	write(*,*) '** Line', k, ' of', markline, '??? Something wrong. :(.'
	write(*,*)
	goto 5131
      end if

	I1 = K
	I2 = K

* KDH : LOOP OVER LINES I1 TO I2
 5132 DO I = I1, I2
* extract line parameters
	rest = rest_l( i )
	lam = nint( rest )

* skip lines out of range
      if( rest .lt. wlo .or. rest .gt. whi ) then
	if( gabby ) write(*,*) '** Line', lam, ' out of range (', wlo, whi, ')'
	cycle
      end if

* report line details
	expand = expand_l( i )
	text = text_l( i )
	lt = len1( text )
	n = nabc( i )
	v = vblr
	if( n .eq. narrow ) v = vnlr
	iv = nint( v )
	ive = nint( v * expand )
	write(*,*)
	write(*,*) i, lam, ' ', linetype( i ), ' ', iv, ' Expand', expand
	write(*,*) 'WinHW (km/s) ', ive, ' (', iv, ' x', expand, ' )'

* find variable lines in the component list
	kc = 0
      if( expand .lt. 0. ) then
      do ic = 1, ncomp
	if( i .eq. line_lc( 1, ic ) ) kc = ic	
      end do
      if( kc .gt. 0 ) then
	file = file_c( kc )
	write(*,*) 'VarBLR component', kc, ' outfile prefix : ', file(:len1(file))
      else
	write(*,*) '** WARNING : Variable line not in VarBLR list.'
      end if
      end if


* single line
      if( i1 .eq. i2 ) then
* inform user on options
	write(*,*) 'Enter 0 to de-activate line.'
      if( n .eq. nbroad ) then
	write(*,*) 'Negative gives BLR line its own lightcurve.'
	if( ncomp .ge. maxc ) write(*,*) '** WARNING: VarBLR COMPONENTS', ncomp, ' MAX', maxc
      end if
* new expansion factor
	call inqr( 'Enter WinHW (km/s) or expansion factor', expand, val )
	expand = val
* large value is in km/s
	if( abs( val ) .ge. 10. ) expand = val / v
* activate multiple lines
      else if( ia .gt. 0 ) then
      if(   ( n .eq. nbroad .and. ib .gt. 0 ) 
     & .or. ( n .eq. narrow .and. in .gt. 0 ) ) then
	expand = abs( expand )
	if( expand .eq. 0. ) expand = 1.
      end if
* make variable multiple lines
      else if( iv .gt. 0 .and. n .eq. nbroad ) then
	expand = - abs( expand )
	if( expand .eq. 0. ) expand = -1.
      end if
* we now have a new value for expand

* only BLR lines can be variable
      if( n .ne. nbroad ) then
	expand = abs( expand )
	write(*,*) '** WARNING - only BLR lines can be variable.'
* BLR line
      else

* match to components list
	match = 0
      do ic = 1, ncomp
	if( i .eq. line_lc( 1, ic ) ) match = ic
      end do
* KDH : DON'T WE ALREADY KNOW THIS -- MATCH = KC
	write(*,*) 'Match', match, ' kc', kc

* new variable line -------------------
      IF( match .eq. 0 .and. expand .lt. 0. ) then
	write(*,*) 'New VarBLR line:', lam, ' ', text(:lt)
* list full
      if( ncomp .ge. maxc ) then
	expand = abs( expand )
	write(*,*) '** ERROR: VarBLR COMPONENTS', ncomp, ' MAX', maxc
	write(*,*)
	goto 5131
      end if
* component pixels
	npc = npix_l( i )
* KDH : IS THIS CHANGE NEEDED ?
	if( rest .lt. w_w( 1 ) .or. w_w( nw ) .le. rest ) npc = 0
	write(*,*) 'Pixels in range:', npc
* outfile prefix
	file = text(:lt)
* 2022 Sep KDH : ALWAYS USE TEXT_L( I ) FOR THE FILE PREFIX
	call nospace( file )
C	call inq( 'Outfile prefix ', file, file )
* stow new variable line component
	ic = ncomp + 1
	line_lc( 1, ic ) = i
	file_c( ic ) = file
	nline_c( ic ) = 1
	nfit_c( ic ) = 0
	npix_c( ic ) = npc
	write(*,*) 'Variable line components', ncomp, ' =>', ic
	ncomp = ic
* end new variable line -------------------

* remove line from VarBLR list ----------------
      ELSE IF( match .ne. 0 .and. expand .ge. 0. ) then
	j = 0
      do ic = 1, ncomp
      if( ic .ne. match ) then
	j = j + 1
	line_lc( 1, j ) = line_lc( 1, ic )
	nline_c( j ) = nline_c( ic )
	file_c( j ) = file_c( ic )
	nfit_c( j ) = nfit_c( ic )
	npix_c( j ) = npix_c( ic )
      end if
      end do
	write(*,*) 'Removed VarBLR line:', lam, ' ', text(:lt)
	write(*,*) 'VarBLR components', ncomp, ' =>', j
	ncomp = j
      END IF
* end remove line from VarBLR list ----------------

      end if
* end BLR line

* stow
	expand_l( i ) = expand
C NEXT LINE I
      END DO
	goto 513

* restore sign of expand_l
  514 do i = 1, markline
	expand_l( i ) = abs( expand_l( i ) )
      end do

* option to reset model 
c	call inq( 'Reset model?', 'Y', reply )
	call inq( 'Reset model?', 'N', reply )
	call upcase( reply, reply )
	if( reply .eq. 'Y' ) goto 520
	goto 510

* model parameters
  515	write(*,*) 'Model components can be polynomials in log(wavelength):'
	write(*,*) '      1 = constant, 2 = linear, 3 = quadratic, etc.'
	write(*,*) ' C ... Continuum poly ', npcont, ' max', maxpcont
	write(*,*) ' F ... (or P) Photometric factor', npscale, ' max', maxpscale
	write(*,*) ' W ... (or X) Wavelength shift', npshift, ' max', maxpshift
	write(*,*) ' S ... (or B) Seeing (blur)   ', npblur, ' max', maxpblur
	write(*,*) ' G ... Gaussian prior on p(t)', 100*siglnp0, ' %'
	write(*,*) ' A ... Absorption line model', npabsn
      if( nl .gt. 0 ) then
	write(*,*) '      Galactic  lines', nl_galactic
	write(*,*) '      Intrinsic lines', nl_intrinsic
      end if
	write(*,*) ' Q .. Quit'
	reply = ' '
	call inq( 'What to change ?', reply, reply )
	call upcase( reply, reply )
	if( reply(1:1) .eq. 'Q' ) goto 514

* continuum
      if( reply(1:1) .eq. 'C' ) then
	ival = npcont
	write(*,*) 'Max', maxpcont
	call inqi( 'Continuum poly', ival, ival )
	if( ival .gt. 0 ) npcont = max( 1, min( maxpcont, ival ) )
* scale
      else if( reply(1:1) .eq. 'F' .or. reply(1:1) .eq. 'P' ) then
	ival = npscale
	write(*,*) 'Max', maxpscale
	call inqi( 'Photometric factor poly', ival, ival )
	if( ival .gt. 0 ) npscale = max( 1, min( maxpscale, ival ) )
* shift
      else if( reply(1:1) .eq. 'W' .or. reply(1:1) .eq. 'X' ) then
	ival = npshift
	write(*,*) 'Max', maxpshift
	call inqi( 'Pixel shift poly', ival, ival )
	if( ival .gt. 0 ) npshift = max( 1, min( maxpshift, ival ) )
* blur
      else if( reply(1:1) .eq. 'S' .or. reply(1:1) .eq. 'B' ) then
	ival = npblur
	write(*,*) 'Max', maxpblur
	call inqi( 'Pixel blur poly', ival, ival )
	if( ival .gt. 0 ) npblur = max( 1, min( maxpblur, ival ) )
* gaussian prior on p(t)
      else if( reply(1:1) .eq. 'G' ) then
	val = siglnp0 * 100.
	write(*,*) 'Enter 0 or <0 for Uniform prior.'
	call inqr( 'Prior on photometric factor (RMS %)', val, val )
	siglnp0 = max( 0., val / 100. )

* absorption line model
      else if( reply(1:1) .eq. 'A' ) then
	ival = npabsn
	call inqi( 'Absorption line model (0,1) ', ival, ival )
	npabsn = max( 0, min( 1, ival ) )
	dips = npabsn .gt. 0

* load up absorption lines
      if( dips ) then

* KDH: SHOULD SORT THESE AND CLIP ONES NOT ON THE SPECTRUM
* KDH: SHOULD USE THE EXTANT LINE LIST 

	write(*,*)
	write(*,*) 'Absorption line model: input ascii files giving'
	write(*,*) '  1 Observed wavelength (A)'
	write(*,*) '  2 SigV = velocity dispersion (km/s)'
	write(*,*) '  3 1-sigma error bar on SigV'
	write(*,*) '  4 log10(tau0) (tau0 = line centre optical depth)'
	write(*,*) '  5 error bar on log10(tau0)'
	write(*,*) '  6 S/N ratio'
	write(*,*) 'One file for galactic lines, one for intrinsic lines.'
	write(*,*)

* galactic lines
	file = 'lines_galactic.dat'
	call inq( 'Galactic line file:', file, file )
	n = maxabsn
	call loadlc6( file, 6, n, wobs_l,
     &		sigv_l, sigsigv_l, 
     &		tau0_l, sigtau0_l, snr_l )
	write(*,*) 'Galactic lines:', n
	l1 = 1
	l2 = n
	write(*,*) 'Line  Wobs  SigV  log10(tau0)  S/N'
      do l = l1, l2
	write(*,*) l, real(wobs_l(l)), sigv_l(l), tau0_l(l), snr_l(l)
      end do
	l1_galactic = l1
	l2_galactic = l2
	nl_galactic = n

* intrinsic lines
	i = n + 1
	n = maxabsn - n
	file = 'lines_intrinsic.dat'
	call inq( 'Intrinsic line file:', file, file )

	call loadlc6( file, 6, n, wobs_l(i),
     &		sigv_l(i), sigsigv_l(i),
     &		tau0_l(i), sigtau0_l(i), snr_l(i) )
	write(*,*) 'Intrinsic lines:', n
	l1 = i
	l2 = i + n - 1
	write(*,*) 'Line  Wobs  SigV  log10(tau0)  S/N'
      do l = l1, l2
	write(*,*) l, real(wobs_l(l)), sigv_l(l), tau0_l(l), snr_l(l)
      end do
	nl_intrinsic = n
	l1_intrinsic = l1
	l2_intrinsic = l2
* total
	nl = nl_galactic + nl_intrinsic
	write(*,*) 'Total absn lines:', nl_galactic, ' +', nl_intrinsic, ' =', nl

* logtau0 -> tau0
	call mnmx( nl, tau0_l, tmn, tmx )
	write(*,*) 'Log10(tau0) mn, mx', tmn, tmx
      do i = 1, nl
	tlog = tau0_l( i )
	slog = sigtau0_l( i )
	t = 10. ** tlog
	s = t * slog * alog( 10. )
	tau0_l( i ) = t
	sigtau0_l( i ) = s
      end do
	call mnmx( nl, tau0_l, tmn, tmx )
	write(*,*) 'tau0 mn, mx', tmn, tmx

* line types
	ltype_galactic = 1
	ltype_intrinsic = 2
	l1 = l1_galactic
	l2 = l2_galactic
	ltype = ltype_galactic
	n = 0
      do l = l1, l2
	n = n + 1
	ltype_l( l ) = ltype
      end do
	write(*,*) 'Galactic lines', n, ' of', nl_galactic

	i1 = l1_intrinsic
	i2 = l2_intrinsic
	l = ltype_intrinsic
	n = 0
      do i = i1, i2
	n = n + 1
	ltype_l( i ) = l
      end do
	write(*,*) 'Intrinsic lines', n, ' of', nl_intrinsic

* rest wavelengths
	write(*,*) 'Observed -> Rest wavelengths 1+z', opz
	n = 0
      do i = 1, nl
	wrest_l( i ) = wobs_l( i ) / opz
	n = n + 1
      end do
	write(*,*) 'Lines', n, ' of', nl
      end if

* damped lya
	wobs_lya = 1215.58972167969
	wrest_lya = wobs_lya / opz
	v1_lya = 613.
	tau0_lya = 1.e10
	write(*,*) 'Damped Ly alpha'
	write(*,*) ' Wobs', wobs_lya
	write(*,*) ' V(tau=1)', v1_lya
	write(*,*) ' tau0', tau0_lya
	write(*,*) ' '
	write(*,*) '5548 absorption line model initialised.'

	goto 515

      else
	write(*,*) 'Please try again.  :((((.'
      end if
	goto 515

* reset calibration --------------------------------------------------------

  520	write(*,*) 'RESET CALIBRATION:'

* wipe Fe2 velocity dispersion grid
	ngridv = 0
* evaluate absorption spectrum
	write(*,*) 'Evaluating Absorption Line spectrum Nw', nw
      do i = 1, nw
	fitod_w( i ) = 0.
	fitod_agn_w( i ) = 0.
	fitdim_w( i ) = 1.
	fitdim_agn_w( i ) = 1.
      end do
      if( dips ) then
	write(*,*) 'w_w', w_w( 1 ), w_w( nw )
	call linespans( nw, w_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l )
	l = ltype_galactic
	call odspec( nw, w8_w, fitod_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, l )
	l = ltype_intrinsic
	call odspec( nw, w8_w, fitod_agn_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, l )

      do i = 1, nw
	od = fitod_w( i )
c	wobs = w8_w( i ) * opz
c	od = od + odlya( wobs, wobs_lya, v1_lya, tau0_lya )
* stow
	fitod_w( i ) = od
	fitdim_w( i ) = exp( - od )
	fitdim_agn_w( i ) = exp( - fitod_agn_w( i ) )
      end do
      end if

* wavelengths
      do iw = 1, nw
	lam = nint( w_w( iw ) )
	x = xw_w( iw )
      if( dips ) then
	od = fitod_w( iw ) + fitod_agn_w( iw )
	dim = exp( - od )
      end if
* times
	iwt = iw - nt
      do it = 1, nt
	iwt = iwt + nt
	wobs = wavpic8( iw, it )
	dat = datpic( iw, it )
	sig = sigpic( iw, it )
	if( chifix ) sig = sig * chifix_wt( iwt )
	fit = fit_wt( iwt )
	f = f_wt( iwt )
* continuum
      do k = 1, npcont
	cont_p( k ) = cont_tp( it, k )
      end do
	c = poly4( npcont, cont_p, x )

* noisy poly
      if( npar .gt. 0 .and. npcont .gt. 0 ) then
	i = 1 + npar * ( it - 1 )
	j = 1 + npar * ( i - 1 )	
	sigc = sigpoly( x, npar, npcont, ipcont, sig_pt( i ), c_ppt( j ) )
* ignore covariances
      else
	xx = x * x
      do k = 1, npcont
	sigcont_p( k ) = sigcont_tp( it, k )**2
      end do
	v = poly4( npcont, sigcont_p, xx )
	sigc = sqrt( max( 0., v ) )
      end if

* correct for absorption
* KDH: BOTH INTRINSIC AND GALACTIC LINES :(
      if( dips ) then
	dat = dat / dim
	sig = sig / dim
      end if
* stow
	plot1( it ) = wobs / opz
	plot2( it ) = dat
	plot3( it ) = sig
	plot4( it ) = c
	plot5( it ) = sigc
	plot6( it ) = fit
	plot7( it ) = f
	plot8( it ) = dat - c
* next time it
      end do

* count good data
	ngood = 0
	ncgood = 0
      do i = 1, nt
	if( plot3( i ) .gt. 0. ) ngood = ngood + 1
	if( plot5( i ) .gt. 0. ) ncgood = ncgood + 1
      end do

* equal weights if no error bars
      if( ngood .le. 0 ) then
      do i = 1, nt
	plot3( i ) = 1.
      end do
	ngood = nt
      end if

* mean wavelength
* KDH : SHOULD USE REAL*8 FOR WAVELENGTHS
	call optavgrms( nt, plot1, plot3, avg, rms )

* sanity check
      if( avg .le. 0. ) then
	write(*,*) '** ERROR: mean lam(', iw, ' ) =', avg, ' rms', rms
	write(*,*) 'Nt', nt, ' Nw', nw, ' Ngood', ngood
	write(*,*) 'wavpic8(', iw, ', it ):'
	write(*,*) (wavpic8(iw,j),j=1,nt)
	write(*,*) 'plot1 = wobs/(1+z):', ' (1+z)=', opz
	write(*,*) (plot1(j),j=1,nt)
	write(*,*) 'plot3 = sigmas:', ' chifix=', chifix
	write(*,*) (plot3(j),j=1,nt)
	stop '** PrepSpec abort.  :((('
      end if

* stow
* wavelengths
	w_w( iw ) = avg
	w8_w( iw ) = avg

* avg spectrum
	call optavg( nt, plot2, plot3, avg, sig )
	avg_w( iw ) = avg
	sigavg_w( iw ) = sig

* degrees of freedom
	dof = max( 1, ngood - 1 )
* optimal avg and rms
	call optavgrms( nt, plot2, plot3, avg, rms )
	rmsraw = rms
* rms bias
	sum = 0.d0
      do i = 1, nt
	sig = plot3( i )
      if( sig .gt. 0. ) then
	sum = sum + sig * sig
      end if
      end do
	rmsbias = sqrt( sum / dof )

* same for the continuum
	call optavgrms( nt, plot4, plot3, cavg, crms )
	fac = sqrt( 2. / dof )
	sigrms  =  rms * fac
	sigcrms = crms * fac

* rms of continuum-subtracted data
c	call optavgrms( nt, plot8, plot3, avgb, rmsb )

* 2021-11-11 KDH : TRY CHANGING TO RMSX
	call avgrmsx( nt, plot8, plot3, good, avgb, rmsb, sigavgb, sigrmsb )
	blr = rmsb
	sigblr = rmsb * fac

* guestimate of rms for the blr  (not debiased to be conservative)
c	blr    = rms
c	sigblr = sigrms

* ML estimate of mean and excess variance
      if( iw .eq. 1 ) then
	ngw1 = 0
	ngw2 = 0
	nbw = 0
      end if
	if( ngood .ge. 1 ) ngw1 = ngw1 + 1

* avgrmsx if 2 or more epochs
      IF( ngood .ge. 2 ) then
	call avgrmsx( nt, plot2, plot3, good, avg, rms, sigavg, sigrms )
* debiased sample variance
	ngw2 = ngw2 + 1
      ELSE
	nbw = nbw + 1
	rms = sqrt( max( 0., rmsraw * rmsraw - rmsbias * rmsbias ) )
	sigrms = rms * fac
      END IF

* report sparse lightcurves
      if( ngood .le. 2 ) then
	write(*,*)
	write(*,*) '** WARNING: Sparce lightcurve at pixel iw', iw, ' lam', nint(w_w( iw ))
	write(*,*) '** Good epochs for RMS', ngood, ' of', nt
	call mnmx( nt, plot1, wmn, wmx )
	call mnmx( nt, plot2, dmn, dmx )
	call mnmx( nt, plot3, smn, smx )
	write(*,*) '** lam', nt, wmn, wmx
	if( wmn .ne. wmx ) write(*,*) ( plot1( i ), i = 1, nt )
	write(*,*) '** dat', nt, dmn, dmx
	if( dmn .ne. dmx ) write(*,*) ( plot2( i ), i = 1, nt )
	write(*,*) '** sig', nt, smn, smx
	if( smn .ne. smx ) write(*,*) ( plot3( i ), i = 1, nt )
      end if

* ML estimate of continuum mean and excess variance
	if( iw .eq. 1 ) ngcw = 0
      if( ncgood .ge. 2 ) then
	ngcw = ngcw + 1
	call avgrmsx( nt, plot4, plot5, good, c, crms, sigc, sigcrms )
      end if

* KDH 2020-07-30 - TRY REPLACING WITH AVGRMS
c	call avgrms( nt, plot4, c, crms )

* rms of the fit
	call avgrms( nt, plot6, avg, rmsfit )
* rms of the calibrated fit
	call avgrms( nt, plot7, avgf, rmsf )

* 2020-07-29 KDH - for E.Cackett 4593 HST paper
* ML estimate (to agree with crms above)
C      if( ncgood .ge. 2 ) then
C	call avgrmsx( nt, plot6, plot5, good, avgfit, rmsfit, sigavgfit, sigrmsfit )
C	call avgrmsx( nt, plot7, plot5, good, avgf, rmsf, sigavgf, sigrmsf )
C      end if

* stow the RESET calibration
	blr_w( iw )     = blr
	rms_w( iw )     = rms
	rmscont_w( iw ) = crms
	rmsfit_w( iw )  = rmsfit
	rmsf_w( iw )    = rmsf
	rmsraw_w( iw )  = rmsraw
	rmsbias_w( iw ) = rmsbias
	rmsb_w( iw )    = rmsb

	sigblr_w( iw ) = sigblr
	sigrms_w( iw ) = sigrms
	sigrmscont_w( iw ) = sigcrms
	sigrmsb_w( iw ) = sigrmsb

* next wavelength iw
      end do

      if( ngw1 .eq. nw ) then
	write(*,*) 'Good waves for AVG', ngw1, ' of', nw, ' :)))'
      else
	write(*,*) '** BAD WAVES FOR AVG', nw-ngw1, ' of', nw, ' :(((('
      end if

      if( ngw2 .eq. nw ) then
	write(*,*) 'Good waves for RMS', ngw2, ' of', nw, ' :)))'
      else
	write(*,*) '** BAD WAVES FOR RMS', nw-ngw2, ' of', nw, ' :(((('
      end if

      if( ngcw .eq. nw ) then
	write(*,*) 'Good waves for continuum RMS', ngcw, ' of', nw, ' :)))'
      else
	write(*,*) '** BAD WAVES FOR CONTINUUM RMS', nw-ngcw, ' of', nw, ' :(((('
      end if

* sanity check
	nbad = 0
      do i = 2, nw
      if( w_w( i ) .lt. w_w( i-1 ) ) then
	nbad = nbad + 1
	write(*,*) '** WAVELENGTHS OUT OF ORDER :(((('

* try to fix
	w = ( w_w(i-1) + w_w(i+1) ) / 2.
      do j=max( 2, i-3 ), min( nw, i+3 )
	write(*,*) j, w_w( j ), w_w( j ) - w_w( j-1 )
	if( j .eq. i ) write(*,*) j, ' fix?', w_w(j), ' ==>', w
      end do
* KDH : DON'T TRY TO FIX IT
c	w_w( i ) = w
c	stop '** PrepSpec abort.  :((('
      end if
      end do

      if( nbad .eq. 0 ) then
	write(*,*) 'Wavelengths ascend. :)'
      else
	write(*,*) 'Wavelengths out of order.', nbad, ' :((((('
      end if

* compute xw_w(i) ranging from -1 to +1
	call xwcalc( nw, w_w, xw_w )
	if( gabby ) write(*,*) 'xwcalc', nw, xw_w(1), xw_w(nw)

* KDH: SHOULD PROBABLY EVALUATE AND DIVIDE BY ABSN SPECTRUM
*      OUTSIDE THE ABOVE LOOPS
      IF( .FALSE. ) THEN
      if( dips ) then
      do i = 1, nw
	od = fitod_w( i ) + fitod_agn_w( i )
	dim = exp( - od )
	avg_w( i ) = avg_w( i ) / dim
	sigavg_w( i ) = sigavg_w( i ) / dim
	blr_w( i ) = blr_w( i ) / dim
	rms_w( i ) = rms_w( i ) / dim
	rmsraw_w( i ) = rmsraw_w( i ) / dim
	rmscont_w( i ) = rmscont_w( i ) / dim
	rmsb_w( i ) = rmsb_w( i ) / dim

	sigblr_w( i ) = sigblr_w( i ) / dim
	sigrms_w( i ) = sigrms_w( i ) / dim
	sigrmscont_w( i ) = sigrmscont_w( i ) / dim
	sigrmsb_w( i ) = sigrmsb_w( i ) / dim
      end do
      end if
      END IF

* report

c      if( dips ) then
	call mnmx( nw, fitod_w, omin, omax )
	call medmad( nw, fitod_w, omed, omad )
	write(*,*) 'Optical depth  Galactic: med', omed, ' max', omax
	call mnmx( nw, fitod_agn_w, omin, omax )
	call medmad( nw, fitod_agn_w, omed, omad )
	write(*,*) 'Optical depth Intrinsic: med', omed, ' max', omax
c      end if

	call mnmx( nw, w_w, wmn, wmx )
	write(*,*) 'w_w min', wmn, ' max', wmx
	call avgrms( nw, avg_w, avg, rms )
	write(*,*) 'avg_w avg', avg, ' rms', rms
	call avgrms( nw, rms_w, avg, rms )
	write(*,*) 'rms_w avg', avg, ' rms', rms
	call avgrms( nw, blr_w, avg, rms )
	write(*,*) 'blr_w avg', avg, ' rms', rms

* reset line masks
	write(*,*) 'Initialise Line Masks.'
	npixdim = 0
	npixblr = 0
	npixvblr = 0
	npixnlr = 0
	npixbac = 0
	npixbal = 0
      do l = 1, markline
	npix_l( l ) = 0
	iw1_l( l ) = nw + 1
	iw2_l( l ) = 0
      do i = 1, nw
	mask_wl( i, l ) = .false.
      end do
      end do

* wavelength loop
      do iw = 1,nw
	w = w8_w( iw )
* KDH : IS SIG USED ANYWHERE ?
	sig = sigblr_w( iw )
	maskdim( iw ) = .false.
	maskbad( iw ) = .false.
	maskblr( iw ) = .false.
	masknlr( iw ) = .false.
	maskbac( iw ) = .false.
	maskvblr( iw ) = .false.
	maskabsn( iw ) = .false.

* BAL mask
	mask = .false.
	npixbal = 0
      do i = 1, nbal
	v1 = v1bal_l( i )
	v2 = v2bal_l( i )
	w0 = restbal_l( i )
	v = ckms * alog( w / w0 )
	mask = mask .or. ( v .ge. min( v1, v2 ) .and. v .le. max( v1, v2 ) )
      end do
	maskbal( iw ) = mask
	if( mask ) npixbal = npixbal + 1

* report BAL window edges
	im = max( iw - 1, 1 )
      if(      maskbal( iw ) .and. .not. maskbal( im ) ) then
	write(*,*) ' BAL mask  ON at', iw, w
      else if( maskbal( im ) .and. .not. maskbal( iw ) ) then
	write(*,*) ' BAL mask OFF at', iw, w
      end if
c      end if

* balmer continuum
      if( expandbac .gt. 0. .and. bac1 .lt. bac2 ) then
	v1 = ckms * dlog( w / dble(bac1) )
	v2 = ckms * dlog( w / dble(bac2) )
      if( v1 .gt. 0. .and. v2 .le. vblr * expandbac ) then
* 2023 Feb 21 KDH : TEMPORARILY ENABLE
      IF( .TRUE. ) THEN
c temporarily disable
C     IF( .FALSE. ) THEN
	maskbac( iw ) = .true.
	npixbac = npixbac + 1
      END IF
* if maskblr is false, make it true
      if( .not. maskblr( iw ) )then
	maskblr( iw ) = .true.
	npixblr = npixblr + 1
      end if
      end if
      end if

* lines -------------------------------------------------
      do l = 1, markline
	rest = rest_l( l )
	v = ckms * log( w / rest )
	expand = expand_l( l )

* broad lines
      if( nabc( l ) .eq. nbroad ) then
      if( abs( v ) .le. vblr * expand ) then
	mask_wl( iw, l ) = .true.
	npix_l( l ) = npix_l( l ) + 1
	iw1_l( l ) = min( iw1_l( l ), iw )
	iw2_l( l ) = max( iw2_l( l ), iw )
* avoid double-count when lines overlap
      if( .not. maskblr( iw ) ) then
	maskblr( iw ) = .true.
	npixblr = npixblr + 1
      end if
      end if

* narrow lines
      else if( nabc( l ) .eq. narrow ) then
      if( abs( v ) .le. vnlr * expand ) then
	mask_wl( iw, l ) = .true.
	npix_l( l ) = npix_l( l ) + 1
	iw1_l( l ) = min( iw1_l( l ), iw )
	iw2_l( l ) = max( iw2_l( l ), iw )
      if( .not. masknlr( iw ) ) then
	masknlr( iw ) = .true.
	npixnlr = npixnlr + 1
      end if
      end if
      end if
* next line l
      end do

* next wavelength iw
      end do

	write(*,*) 'BaC pixels', npixbac


* VarBLR components within range
	ngc = 0
      do ic = 1, ncomp
	n = 0
	l = line_lc( 1, ic )
	rest = rest_l( l )
      if( w_w( 1 ) .le. rest .and. rest .le. w_w( nw ) ) then
	n = npix_l( l )
      end if
	if( n .gt. 0 ) ngc = ngc + 1
	npix_c( ic ) = n
      end do

* VarBLR line mask
      do iw = 1, nw
	maskvblr( iw ) = .false.
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
      if( .not. maskvblr( iw ) ) then
	l = line_lc( 1, ic )
      if( iw1_l( l ) .le. iw .and. iw .le. iw2_l( l ) ) then
	maskvblr( iw ) = .true.
	npixvblr = npixvblr + 1
      end if
      end if
      end if
* next component ic
      end do
* next wavelength iw
      end do

* report
	write(*,*) 'NLR pixels:', npixnlr, ' VarBLR components:', ngc,
     &		' of', ncomp, ' max', maxc
	write(*,*) 'BLR pixels:', npixblr, ' VarBLR pixels:', npixvblr
	write(*,*) 'BaC pixels:', npixbac, ' VarBaC pixels:', npixvbac

	record = ' '
	nopix = 0
      do l = 1, markline
	text = text_l( l )
	lt = len1( text )
	n = npix_l( l )
      if( n .gt. 0 ) then
	write(*,*) text(:lt) // ' pixels:', n
      else
	nopix = nopix + 1
	call append( record, text(:lt) )
      end if
      end do
      if( nopix .gt. 0 ) then
	write(*,*) 'Lines with 0 pixels:', nopix
	write(*,*) record(:len1(record))
      end if

* report
	ngc = 0
      do i = 1, ncomp
	if( npix_c( i ) .gt. 0 ) ngc = ngc + 1
      end do
	write(*,*) 'VarBLR components:', ngc, ' of', ncomp, ' max', maxc
      do i = 1, ncomp
	n = npix_c( i )
      if( n .gt. 0 ) then
	l = line_lc( 1, i )
	text = text_l( l )
	write(*,*) 'Component', i, ' line', l, ' ', text(:len1(text)), ' pixels:', n
      end if
      end do

	write(*,*) 'BaC pixels:', npixbac
	write(*,*) 'Dim pixels:', npixdim
	ng = 0
      do iw = 1, nw
	mask = maskblr(iw) .or. masknlr(iw) .or. maskdim(iw)
	if( .not. mask ) ng = ng + 1
      end do
	p = ng * 100. / nw
	write(*,*) 'non-line (=continuum) pixels:', ng, ' of', nw, ' =', p, ' %'

* VarBLR components
	ngc = 0
      do ic = 1, ncomp
	if( npix_c( ic ) .gt. 0 ) ngc = ngc + 1
      end do

* VarBLR pixels
	write(*,*) 'VarBLR components:', ngc, ' of', ncomp, ' npix', npixvblr

* KDH : TRIM THIS TO (IW1,IW2) ?   THE MASK_WL DOES THAT.
* each dat_wl is a copy of blr_w
* 2019 AUG KDH : TRY MAKING THIS RMS_W = RMSx
      do ic = 1, ncomp
	l = line_lc( 1, ic )
	text = text_l( l )
	n = npix_c( ic )
      do iw = 1, nw
	dat = blr_w( iw )
	sig = sigblr_w( iw )
	dat = rms_w( iw )
c	sig = sigrms_w( iw )
* set to zero if outside blr window
	if( .not. mask_wl( iw, l ) ) dat = 0.
* stow
	dat_wl( iw, l ) = dat
	sig_wl( iw, l ) = sig
      end do
      if( n .gt. 0 .or. gabby ) then
	call avgrms( nw, dat_wl( 1, l ), avg, rms )
	write(*,*) ic, ' ', text(:len1(text)), ' Spec avg', avg, ' rms', rms, ' npix', n
      end if

* 2019 AUG KDH : CHECK IF SIGMAS OK HERE - THEY ARE OK.
c      IF( .FALSE. ) THEN
	ngs = 0
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	n = iw2 - iw1 + 1
      if( n .gt. 0 ) then
      do iw = iw1, iw2
	sig = sig_wl( iw, l )
	if( sig .gt. 0. ) ngs = ngs + 1
      end do
	write(*,*) 'Pixels', iw1, iw2, ' good', ngs, ' of', n
	panic = ng .lt. max(1,n/2) 
	if( panic ) gabby = .true.
	if( panic ) write(*,*) 'PANIC! 1'
      end if
c      END IF

* next component
      end do

* KDH 2019 AUG : THIS PANIC DOES NOT OCCUR
      if( gabby ) then
	if( panic ) stop 'PANIC! 1'
      end if

* BaC spectrum
	n = 0
      do iw = 1, nw
	bac_w( iw ) = blr_w( iw )
	sigbac_w( iw ) = sigblr_w( iw )
      if( maskbac( iw ) ) then
	n = n + 1
      else
	bac_w( iw ) = 0.
      end if
      end do
	call avgrms( nw, bac_w, avg, rms )
	write(*,*) 'bac_w avg', avg, ' rms', rms, ' npix', n

* reset spectra ---------------------------------------------
	write(*,*) 'Initialising spectra. Nw', nw

* KDH : WHY SEGFAULT HERE ?
	igab = 0
	if( gabby ) igab = 1
	gabby = .true.
      do iw = 1, nw

* KDH : WHY DOES THIS WRITE PREVENT A SEGFAULT ?
      if( gabby ) then
      if(    iw .le. 5
     &	.or. mod( iw,nw/10) .eq. 0 
     &	.or. iw .eq. nw ) then
	write(*,*) iw, ' of', nw
      end if
      end if

* galaxy
	gal_w( iw ) = 0.
	siggal_w( iw ) = 0.
* narrow lines
	elr_w( iw ) = 0.
	signlr_w( iw ) = 0.
	elr_raw_w( iw ) = 0.
* optical depth spectrum
	datod_w( iw ) = 0.
* absorption spectrum
	datdim_w( iw ) = 1.
	sigdim_w( iw ) = 0.

* KDH: EVALUATE THE ABSORPTION LINE MODEL
* KDH: SLOW - SHOULD DO THIS OUTSIDE THE WAVELENGTH LOOP
      IF( .FALSE. ) THEN
	fitdim_w( iw ) = 1.
	difdim_w( iw ) = 0.
      if( dips ) then
	wobs = w8_w( iw ) * opz	
* galactic lines
	ltype = ltype_galactic
	od = odlines( wobs, nl, wobs_l, sigv_l, tau0_l, ltype_l, ltype )
c	od = od + odlya( wobs, wobs_lya, v1_lya, tau0_lya )
	dim = exp( -od )
	fitod_w( iw ) = od 
	fitdim_w( iw ) = dim	
* intrinsic lines
	ltype = ltype_intrinsic
	od = odlines( wobs, nl, wobs_l, sigv_l, tau0_l, ltype_l, ltype )
	dim = exp( -od )
	fitod_agn_w( iw ) = od 
	fitdim_agn_w( iw ) = dim	
      end if
      END IF

* error bar scaling
	chifix_w( iw ) = 1.
* chi
	chi_w( iw ) = 1.
	chiclip_w( iw ) = 1.
* bias
	bias_w( iw ) = 0.
	biasclip_w( iw ) = 0.
* next wavelength iw
      end do
	write(*,*) 'Spectra initialised. Nw', nw
	gabby = igab .gt. 0 

* reset of spectra finished
*-------------------------------------------------------------------
* reset lightcurves
	write(*,*) 'Initialising lightcurves. Nt', nt
      do l = 1, markline
	nfit_l( l ) = 0
      do it = 1, nt
	dat_tl( it, l ) = 0.
	sig_tl( it, l ) = 0.
      end do
      end do

      do it = 1, nt
	if( gabby ) write(*,*) 'TIME', IT, ' OF', NT, '-------------'
	gal_t( it ) = 0.
	blr_t( it ) = 0.
	bac_t( it ) = 0.
	elr_t( it ) = 1.

	alam_t( it ) = 1.e-3
	caution_t( it ) = 0.5

	if( gabby ) WRITE(*,*) 'LINES'

* continuum
      do k = 1, npcont
	cont_tp( it, k ) = 0.
	sigcont_tp( it, k ) = 0. 
      end do

	if( gabby ) WRITE(*,*) 'CONT'
* flux 
	p0_t( it ) = 1.
	if( logp ) p0_t( it ) = 0.
	p1_t( it ) = 0.
	p2_t( it ) = 0.
	if( gabby ) WRITE(*,*) 'FLUX'
* shift
	x0_t( it ) = 0.
	x1_t( it ) = 0.
	if( gabby ) WRITE(*,*) 'SHIFT'
* blur
	s0_t( it ) = 0.
	s1_t( it ) = 0.
	if( gabby ) WRITE(*,*) 'BLUR'
* error bars
	siggal_t( it ) = 0.
	sigblr_t( it ) = 0.
	sigbac_t( it ) = 0.
	signlr_t( it ) = 0.
	sigp0_t( it ) = 0.
	sigp1_t( it ) = 0.
	sigp2_t( it ) = 0.
      do k = 1, npcont
	sigcont_tp( it, k ) = 0. 
      end do
	sigx0_t( it ) = 0.
	sigx1_t( it ) = 0.
	sigs0_t( it ) = 0.
	sigs1_t( it ) = 0.
	if( gabby ) WRITE(*,*) 'ERROR BARS'
* chi-bias
	chifix_t( it ) = 1.
	chi_t( it ) = 1.
	bias_t( it ) = 0.
	chiclip_t( it ) = 1.
	biasclip_t( it ) = 0.
	if( gabby ) WRITE(*,*) 'CHI'
* next time it
      end do
	write(*,*) 'Lightcurves initialised. Nt', nt

      do i = 1, nw * nt
	chifix_wt( i ) = 1.
	bad_wt( i ) = .false.
      end do

	nits = 0
	iback = 0
	lastit = 0
	nstage = 0
	stage = ' '

* number of fitted parameters
	nfitavg = nw
	nfitcont = 0
	nfitblr = 0
	nfitbac = 0
	nfitgal = 0
	nfitshift = 0
	nfitblur = 0
	nfitphot = 0

	write(*,*) 'decomposition model reset.'
	write(*,*) '----------------------------------'

* KDH : AFTER RESET, NEED WE CONTINUE HERE ?
* KDH : MAYBE SO, TO COMPUTE SOME OTHER THINGS.

* enforce constraints ----------------------------------------------

  524	if( gabby ) write(*,*) 'Enforce constraints.'

* reset line masks -------------------------------

	if( gabby ) write(*,*) 'Reset masks for VNLR / BLR = ', vnlr, vblr
* KDH : THIS REPEATS CODE ABOVE - TRY TO AVOID THAT

* pixel counts
	npixdim = 0
	npixblr = 0
	npixvblr = 0
	npixnlr = 0
	npixbac = 0
	npixvbac = 0
      do l = 1, markline
	npix_l( l ) = 0
	iw1_l( l ) = nw + 1
	iw2_l( l ) = 0
      do i = 1, nw
	mask_wl( i, l ) = .false.
      end do
      end do

* wavelengths
      do iw = 1, nw
	w = w8_w( iw )
* KDH : IS SIG USED ANYWHERE BELOW ?
	sig = sigblr_w( iw )
	maskdim( iw ) = .false.
	maskbad( iw ) = .false.
	maskblr( iw ) = .false.
	maskvblr( iw ) = .false.
	masknlr( iw ) = .false.
	maskbac( iw ) = .false.

* 2019 AUG KDH : DO WE NEED TO SET MASKABSN AND MASKBAL HERE?

* balmer continuum
      if( expandbac .gt. 0. .and. bac1 .lt. bac2 ) then
	v1 = ckms * log( w / dble(bac1) )
	v2 = ckms * log( w / dble(bac2) )
      if( v1 .gt. 0. .and. v2 .le. vblr * expandbac ) then
	npixbac = npixbac + 1
	maskbac( iw ) = .true.
      if( .not. maskblr( iw ) )then
	maskblr( iw ) = .true.
	npixblr = npixblr + 1
      end if
      end if
      end if

* lines
      do l = 1, markline
	rest = rest_l( l )
	v = ckms * log( w / rest )
	expand = expand_l( l )
* broad lines
      if( nabc( l ) .eq. nbroad ) then
      if( abs( v ) .le. vblr * expand ) then
	mask_wl( iw, l ) = .true.
	npix_l( l ) = npix_l( l ) + 1
	iw1_l( l ) = min( iw1_l( l ), iw )
	iw2_l( l ) = max( iw2_l( l ), iw )
* avoid double-count when lines overlap
      if( .not. maskblr( iw ) ) then
* KDH : BLR PIXELS SHOULD OMIT VarBLR PIXELS
	maskblr( iw ) = .true.
	npixblr = npixblr + 1
      end if
      end if

* narrow lines
      else if( nabc( l ) .eq. narrow ) then
      if( abs( v ) .le. vnlr * expand ) then
	mask_wl( iw, l ) = .true.
	npix_l( l ) = npix_l( l ) + 1
	iw1_l( l ) = min( iw1_l( l ), iw )
	iw2_l( l ) = max( iw2_l( l ), iw )
      if( .not. masknlr( iw ) ) then
	masknlr( iw ) = .true.
	npixnlr = npixnlr + 1
      end if
      end if
      end if
* next line l
      end do
* next wavelength iw
      end do

* VarBLR pixels
      do iw = 1, nw
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
      if( .not. maskvblr( iw ) ) then
	l = line_lc( 1, ic )
      if( iw1_l( l ) .le. iw .and. iw .le. iw2_l( l ) ) then
	maskvblr( iw ) = .true.
	npixvblr = npixvblr + 1
      end if
      end if
      end if
      end do
      end do


* report
      if( gabby ) then
	write(*,*) 'NLR pixels:', npixnlr
	write(*,*) 'BLR pixels:', npixblr, ' VarBLR pixels:', npixvblr
	record = ' '
	nopix = 0
      do l = 1, markline
	text = text_l( l )
	lt = len1( text )
	n = npix_l( l )
      if( n .gt. 0 ) then
	write(*,*) text(:lt) // ' pixels:', n
      else
	nopix = nopix + 1
	call append( record, text(:lt) )
      end if
      end do
      if( nopix .gt. 0 ) then
	write(*,*) 'Lines with 0 pixels:', nopix
	write(*,*) record(:len1(record))
      end if

* report
	ngc = 0
      do ic = 1, ncomp
	if( npix_c( ic ) .gt. 0 ) ngc = ngc + 1
c	l = line_lc( 1, ic )
c	if( npix_l( l ) .gt. 0 ) ngc = ngc + 1
      end do
	write(*,*) 'VarBLR components:', ngc, ' of', ncomp, ' max', maxc

      do ic = 1, ncomp
	n = npix_c( ic )
      if( n .gt. 0 ) then
	text = text_l( l )
	write(*,*) text(:len1(text)), ' pixels:', n
      end if
      end do
	write(*,*) 'BaC pixels:', npixbac
	write(*,*) 'Dim pixels:', npixdim
	ng = 0
      do iw = 1, nw
	mask = maskblr(iw) .or. masknlr(iw) .or. maskdim(iw)
	if( .not. mask ) ng = ng + 1
      end do
	p = ng * 100. / nw
	write(*,*) 'non-line (=continuum) pixels:', ng, ' of', nw, ' =', p, ' %'

      end if

* normalise photometry calibration

  525	call avgrms( nt, p0_t, avg, rms )
	call optavgrms( nt, p0_t, sigp0_t, oavg, orms )
	call medmad( nt, p0_t, p0med, p0mad )
      if( gabby ) then
	write(*,*)
	write(*,*) 'Flux scale avg', avg, ' rms', rms
	write(*,*) '       opt avg', oavg, ' rms', orms
	write(*,*) '           med', p0med, ' mad', p0mad
      end if

* preserve median of photometric factor
      if( logp ) then
      do i = 1, nt
	p0_t( i ) = p0_t( i ) - p0med
      end do
	div = exp( p0med )
      else
	div = p0med
      if( div .ne. 0. .and. div .ne. 1. ) then
	f = 1. / div
      do i = 1, nt
	p0_t( i ) = p0_t( i ) * f
	p1_t( i ) = p1_t( i ) * f
	p2_t( i ) = p2_t( i ) * f
	sigp0_t( i ) = sigp0_t( i ) * f
	sigp1_t( i ) = sigp1_t( i ) * f
	sigp2_t( i ) = sigp2_t( i ) * f
      end do
      end if
* report
	write(*,*) 'Divide p(t) by median', div
	call avgrms( nt, p0_t, avg, rms )
	call optavgrms( nt, p0_t, sigp0_t, oavg, orms )
	call medmad( nt, p0_t, p0med, p0mad )
      if( gabby ) then
	write(*,*) 'Flux scale avg', avg, ' rms', rms
	write(*,*) '       opt avg', oavg, ' rms', orms
	write(*,*) '           med', p0med, ' mad', p0mad
      end if
      end if

* rescale spectra of variable components
* KDH : SHOULD THESE USE THE COVARIANCE ESTIMATES ?
      if( div .ne. 0. .and. div .ne. 1. ) then
	f = div
	write(*,*) 'Rescale BLR, BAC by', f
      do i = 1, nw
* KDH : ALSO SCALE DATBLR_W AND SIGBLR_W ?
	blr_w( i ) = blr_w( i ) * f
	bac_w( i ) = bac_w( i ) * f
      end do
* correct all model components 
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
      do i = 1, nw
	dat_wl( i, l ) = dat_wl( i, l ) * f
	sig_wl( i, l ) = sig_wl( i, l ) * f
      end do
      end if
* next component ic
      end do
* rescale lightcurves
	write(*,*) 'Rescale cont, shift, blur by', f
      do i = 1, nt
* continuum
      do k = 1, npcont
	cont_tp( i, k ) = cont_tp( i, k ) * f
	sigcont_tp( i, k ) = sigcont_tp( i, k ) * f
      end do
* shifts
	x0_t( i ) = x0_t( i ) * f
	x1_t( i ) = x1_t( i ) * f
	sigx0_t( i ) = sigx0_t( i ) * f
	sigx1_t( i ) = sigx1_t( i ) * f
* blurs
	s0_t( i ) = s0_t( i ) * f
	s1_t( i ) = s1_t( i ) * f
	sigs0_t( i ) = sigs0_t( i ) * f
	sigs1_t( i ) = sigs1_t( i ) * f
* next time
      end do
* KDH : ALSO ADJUST COVARIANCES ?
      end if

* pixel shifts
	call avgrms( nt, x0_t, avg, rms )
	call medmad( nt, x0_t, xmed, xmad )
      if( gabby ) then
	write(*,*)
	write(*,*) 'Pixel shift avg', avg, ' rms', rms
	write(*,*) '            med', xmed, ' mad', xmad
      end if
	add = -avg
      if( add .ne. 0. ) then
	if( gabby ) write(*,*) 'Add', add, ' pixels.'
      do i = 1, nt
	x0_t( i ) = x0_t( i ) + add
      end do
	call avgrms( nt, x0_t, avg, rms )
	call medmad( nt, x0_t, xmed, xmad )
      if( gabby ) then
	write(*,*) 'Pixel shift avg', avg, ' rms', rms
	write(*,*) '            med', xmed, ' mad', xmad
      end if
      end if

	if( gabby ) write(*,*)

* KDH: CAN WE OMIT WHEN BLR ETC HAVE NOT BEEN ALTERED?

* rectify BaC lightcurve 
	call rectify( nt, bac_t, sigbac_t, nw, bac_w )
* rectify BLR lightcurve
	call rectify( nt, blr_t, sigblr_t, nw, blr_w )
* rectify BLR components
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
c      if( npix_l( l ) .gt. 0 ) then

* KDH : RESTRICT DAT_WL TO RANGE OF THIS LINE ?
* KDH : SHOULD BE OK
c	call rectify( nt, dat_tl(1,l), sig_tl(1,l), nw, dat_wl(1,l) )
	call rectify1( nt, dat_tl(1,l), sig_tl(1,l), nw, dat_wl(1,l), 1 )

* KDH : DO THIS ONLY IF LINE FITTING IS ON
* KDH : SKIP BECAUSE DIFFERENT WEIGHTS NOW USED
      IF( .FALSE. ) THEN
      IF( index( todolist, 'B' ) .gt. 0 ) THEN
* sanity check
	call avgrms( nw, dat_wl(1,l), avg, rms )
      if( avg .lt. 0. ) then
	text = text_l( l )
	write(*,*) text(:len1(text)), ' Spectrum: avg', avg, ' rms', rms
	write(*,*) '** ERROR Rectified Spectrum avg < 0 :((((('
!	pause
	stop
      end if
      END IF

* sanity check
	call optavgrms( nt, dat_tl(1,l), sig_tl(1,l), a, r )
	if( r .le. 0. ) call avgrms( nt, dat_tl(1,l), sig_tl(1,l), a, r )
      if( abs( a ) .gt. 1.e-6 * abs( r )  .or. r .le. 0. ) then
	write(*,*) '** ERROR Rectified Lightcurve avg', a, ' rms', r
	call mnmx( nt, dat_tl(1,l), dmn, dmx )
	call mnmx( nt, sig_tl(1,l), smn, smx )
	text = text_l( l )
	lt = len1( text )
	write(*,*) 'line', l, ' ', text(:lt), ' Nt', nt
	write(*,*) ' dat', dmn, dmx, ' sig', smn, smx
	STOP
      end if
      END IF

      end if
* next component ic
      end do

* BLR ------------------------------------------------------------

* DEBUG REPORT
	igab = 0
	if( gabby ) igab = 1
* KDH : SET GABBY .TRUE. TO ENABLE DEBUGGING INFO
	gabby = .true.
	gabby = .false.
	if( gabby ) write(*,*) 'Gabby', igab, gabby

* Continuum Fit ---------------------

* total velocity range
	vtot = ckms * alog( w_w( nw ) / w_w( 1 ) )

* splines for BLR continuum fit
* 1 spline per 20 BLR WinHW
* KDH : TRY STIFFER SPLINE : 1 PER 20 * VBLR
	nspline = max( 1, nint( vtot / ( 20. * vblr ) ) )
* KDH : WHY USE JUST 1 SPLINE?
* just use 1 spline.
c	nspline = 1

	nfitblrcont = nspline
	if( gabby ) write(*,*) 'fit BLR continuum with splfit(', nspline, ' ).'

* data and error bars for BLR continuum fit
	ng = 0
      do iw = 1, nw
	dat = blr_w( iw )
* KDH : DO THESE SIGMAS INCLUDE CONTINUUM REGIONS ?
	sig = sigblr_w( iw )
* KDH : USE SIGAVG_W ?
C	sig = sigavg_w( iw )
	mask = maskblr( iw ) .or. masknlr( iw )

* 2019 AUG KDH : try rms_w (ML estimate) - DISASTER!
	dat = rms_w( iw )
c	sig = sigrms_w( iw )


* KDH 2019 May : MASK ABSN
	mask = mask .or. maskabsn( i )
* KDH 2019 Aug : MASK BAL
	mask = mask .or. maskbal( i )
* KDH 2023 Feb 21 : MASK BAC
	mask = mask .or. maskbac( i )

* sig < 0 indicates masked data
	if( mask ) sig = - abs( sig )	
* stow
	dat_w( iw ) = dat
	sig_w( iw ) = sig
	if( sig .gt. 0. ) ng = ng + 1
      end do
* report
      if( gabby .or. nw .eq. ng ) then
	pct = ( nw - ng ) * 100. / nw 
	write(*,*) 'masked line pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if

* KDH : SOFT WINDOWS -- CODE REPEATED ELSEWHERE
	nl = lastbroad
      do i = 1, nw
	mask_w( i ) = masknlr( i )
     &		.or. maskabsn( i )
     &		.or. maskbal( i )
* KDH 2023 Feb 21 : MASK BAC (NEEDED FOR RM160)
     &		.or. maskbac( i )
      end do
	call softblr( nw, w_w, wgt_w, dat_w, sig_w, mask_w,
     &		nl, expand_l, iw1_l, iw2_l )
* stow for later plots
      do i = 1, nw
	blrwgt_w( i ) = wgt_w( i )
c	rmswgt_w( i ) = wgt_w( i )
      end do

* report
	p = 0.
      do i = 1, nw
      if( sig_w( i ) .gt. 0. ) then
	p = p + wgt_w( i )
      end if
      end do
      if( gabby .or. p .le. 0. ) then
	call mnmx( nw, wgt_w, wmn, wmx )
	write(*,*) 'BLR Continuum pixel weights', wmn, wmx
	pct = ( nw - p ) * 100. / nw 
	write(*,*) 'soft BLR pixels:', nint(nw-p), ' of', nw, ' =', pct, ' %'
      end if

* sigma clip
	ncycle = 10
	thrlo = -5.
	thrhi = 2.
* report
      if( gabby ) then
	write(*,*) 'reject cycles', ncycle, ' clip', thrlo, thrhi, ' sigma.'
      end if

* RM772 SPLINE FIT IS CRASHING WITH 0 ON END OF SPECTRUM
* debug sanity check
	call dmnmx( nw, w_w, wmn, wmx )
	call mnmx( nw, dat_w, bmn, bmx )
	call mnmx( nw, sig_w, smn, smx )
* report
      if( gabby .or. smn .eq. smx .or. smx .lt. 0. ) then
	write(*,*) 'Nw', nw, w_w(1), w_w(nw)
	write(*,*) 'lam:', wmn, wmx, w_w(1), w_w(nw)
	write(*,*) 'blr:', bmn, bmx, dat_w(1), dat_w(nw)
	write(*,*) 'sig:', smn, smx, sig_w(1), sig_w(nw)
      end if

* stow pre-fit sigmas for later plot
	call peqp( nw, plot1, sig_w )

* BLR continuum spline fit (using soft windows)
      if( autofit ) then
	call splfita( nw, w_w, dat_w, sig_w, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
      else
	call splfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if

* stow post-fit sigmas for later plot
	call peqp( nw, plot2, dat_w )
	call peqp( nw, plot3, sig_w )

* DEBUG REPORT
      if( ifail .ne. 0 ) then
	write(*,*) '** SPLFITA FAILED :(((', ifail
	call mnmx( nw, blr_w, bmn, bmx )
	call mnmx( nw, sigblr_w, smn, smx )
	call mnmx( nw, sig_w, gmn, gmx )
	call mnmxpos( nw, sig_w, pmn, pmx )
	write(*,*) '    blr_w', bmn, bmx
	write(*,*) ' sigblr_w', smn, smx
	write(*,*) '    sig_w', gmn, gmx
	write(*,*) '  sig_w>0', pmn, pmx

* CRASHING ON RMID_018 MODEL A ITER 3
* NOFAIL ALLOWS US TO PROCEED IN THIS CASE (SO BATCH JOBS COMPLETE)
      if( gabby .or. nofail .eq. 0 ) then
	WRITE(*,*) '** PLEASE TRY SPLFITR (MAKE PLOTS TO DIAGNOSE):'
	call splfitr( nw, w_w, blr_w, sig_w, fit_w, ifail )
      end if

      end if

* subtract continuum
* KDH : SHOULD WE ADJUST SIG_W HERE ?
	ng = 0
      do iw = 1, nw
* KDH : STOW LATER ?
	dat_w( iw ) = dat_w( iw ) - fit_w( iw )
	datblr_w( iw ) = dat_w( iw )
	if( sig_w( iw ) .gt. 0. ) ng = ng + 1
      end do
* report
      if( gabby ) then
	pct = ( nw - ng ) * 100. / nw 
	write(*,*) 'masked pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if
	call avgrms( nw, dat_w, avg, rms )
	if( gabby ) write(*,*) 'blr_w avg', avg, ' rms', rms


* 2019 AUG KDH : DEBUG PLOT TO SEE SOFT WINDOWS
      if( .false. ) then
  915	call pgstart(1,2,nouse)
	call pgbgw
	csize = csizedef
	call pgsch( csize )
	call mnmx( nw, w_w, xmn, xmx )
	call medmad( nw, blr_w, dmed, dmad )
	call medmad( nw, rms_w, rmed, rmad )
	write(*,*) 'RMS BLR spectrum med', dmed, ' mad', dmad
	call mnmx( nw, plot2, ymn, ymx )
	call medmad( nw, plot3, smed, smad )
	ymx = max( dmed, smed, rmed ) * 2.
	ymx = max( 0., ymx )
	ymn = min( 0., ymn )
	add = ( ymx - ymn ) * 0.05
	ymn = ymn - add
	ymx = ymx + add
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
	xlabel = 'rest wavelength \gl (\A)'
	ylabel = 'flux'
	title = 'RMS Continuum fit : Nspline'
	call append_i( title, nspline )
	call append( title, 'clip' )
	call append_n( title, thrlo, 2 )
	call append_n( title, thrhi, 2 )
	call pglabel( xlabel, ylabel, title )
* blr spectrum 
	call pgsci( kltgrey )
	call pgbin( nw, w_w, blr_w, .true. )
* rmsx spectrum 
	call pgsci( kolor_rms )
	call pgbin( nw, w_w, rms_w, .true. )
* rms spectrum 
	call pgsci( kblack )
	call pgbin( nw, w_w, plot2, .true. )
* fitted continuum
	call pgsci( kolor_rmscont )
	call pgline( nw, w_w, fit_w )
* rms - continuum
	call pgsci( kblue )
	call pgbin( nw, w_w, dat_w, .true. )
* post-fit error bars
	call pgsci( kgreen )
	call pgbin( nw, w_w, sig_w, .true. )
* pre-fit error bars
	call pgsci( korange )
	call pgbin( nw, w_w, plot1, .true. )
	call pgsci( kblack )
* soft window
	ymn = 0.
	ymx = 1.
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	title = 'Soft Windows for RMS Continuum Fit'
	ylabel = ' '
	call pglabel( xlabel, ylabel, title )
	call pgsci( kblue )
	call pgbin( nw, w_w, blrwgt_w, .true. )
* line windows
      do i = 1, nl
	expand = expand_l( i )
	iw1 = iw1_l( i )
	iw2 = iw2_l( i )
      if( expand .ne. 0. .and. iw1 .gt. 0. .and. iw2 .gt. iw1 ) then
	y = 0.95
	k = kgreen
	if( expand .lt. 0. ) y = 0.92
	if( expand .lt. 0. ) k = kred
	call pgsci( k )
	x = w_w( iw1 )
	call pgmove( x, y )
	x = w_w( iw2 )
	call pgdraw( x, y )
      end if
      end do
	call pgsci( kblack )
	call pgstop
	if( pgagain() ) goto 915

      end if


* smooth BLR spectrum -----------------------------
* 4 splines per BLR WinHW
	v = vblr / 4.
* KDH : TRY MORE FLEXIBLE FIT TO FIX RMID_272
* 2 splines per NLR WinHW 
c	v = min( v, vnlr / 2. )
* KDH : TRY THIS TO FIX RMID_085
	v = vblr / 3.
	v = max( v, vnlr * 3. )
	nspline = max( 1, nint( vtot / v ) )

* KDH : SHOULD TRY A CURVE-OF-GROWTH FOR WIDE RANGE OF NSPLINE

	nfitblrblur = nspline
	if( gabby ) write(*,*) 'smooth BLR with splfit(', nspline, ' ).'
	ng = 0
* error bars for blr fit
      do iw = 1, nw
	sig = sigblr_w( iw )
	sig_w( iw ) = sig
* KDH 2019 AUG : MASK BAL - WORKS AOK
	if( maskbal( iw ) ) sig = - abs( sig )
	if( sig .gt. 0. ) ng = ng + 1
      end do
* report
      if( gabby ) then
	pct = ( nw - ng ) * 100. / nw
	write(*,*) 'masked pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if

* sigma clip
	ncycle = 10
	thrhi = 100.
	thrlo = -100.

* KDH 2019 MAY : CLIP TO AVOID DIPS ON ABSORPTION LINES
	thrlo = -3.
	thrlo = -2.5
      if( gabby ) then
	write(*,*) 'reject cycles', ncycle, ' clip', thrlo, thrhi, ' sigma.'
      end if

* spline fit to smooth BLR spectrum
* KDH 2019 MAY : FIT BY HAND TO SANITY CHECK
	AUTOFIT = .FALSE.
	AUTOFIT = .TRUE.
      if( autofit ) then
	call splfita( nw, w_w, dat_w, sig_w, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
      else
	WRITE(*,*) 'Smooth the BLR spectrum'
	call splfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if
	AUTOFIT = .TRUE.

* stow smoothed spectrum
* KDH : SHOULD WE MODIFY FITSIG_W OR SIGBLR_W HERE ?
	blurpix = real( ng ) / nfitblrblur

* KDH : IF IDIVED = 1, VarBLR LINES VANISH AFTER ~35 ITS. ??
	idived = 1
	idived = 0
	div = sqrt( max( 1., blurpix ) )
	if( idived .eq. 0 ) div = 1.
	if( gabby .or. div .ne. 1. ) 
     &	write(*,*) 'BLR blurpix', blurpix, ' =', ng, ' /', nfitblrblur

	ng = 0
      do iw = 1, nw
	sig = sig_w( iw )
	dat = dat_w( iw )
	fit = fit_w( iw )
	if( sig .gt. 0. ) ng = ng + 1
* stow
	dat_w( iw ) = fit
	sig_w( iw ) = sig / div
	datblr_w( iw ) = dat
	fitavgblr_w( iw ) = fit
      end do
	blurpixblr = blurpix

* report
      if( gabby ) then
	pct = ( nw - ng ) * 100. / nw
	write(*,*) 'masked pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
	call avgrms( nw, dat_w, avg, rms )
	write(*,*) 'blr_w avg', avg, ' rms', rms
      end if

* zero non-BLR pixels
	ng = 0
      do iw = 1, nw
	mask = .not. maskblr( iw ) .or. maskbac( iw ) 
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
	mask = mask .or. mask_wl( iw, l )
      end if
      end do
      if( mask ) then
	dat_w( iw ) = 0.
      else
	ng = ng + 1
      end if
      end do
* report
      if( gabby ) then
	pct = ng * 100. / ( nw )
	write(*,*) 'BLR pixels kept:', ng, ' of', nw, ' =', pct, ' %'
      end if
* rectify BLR lightcurve
	call rectify( nt, blr_t, sigblr_t, nw, dat_w )
* report
      if( gabby ) then
	call avgrms( nw, dat_w, avg, rms )
	write(*,*) 'blr_w avg', avg, ' rms', rms
      end if
* positive BLR pixels
	ngp = 0
      do iw = 1, nw
	dat = dat_w( iw )
	if( dat .gt. 0 ) ngp = ngp + 1
	dat_w( iw ) = max( 0., dat )
      end do
	pct = ngp * 100. / max(1,ng)
* report
      if( gabby ) then
	write(*,*) 'Positive', ngp, ' of', ng, ' =', pct, ' %'
	call avgrms( nw, dat_w, avg, rms )
	write(*,*) 'blr_w avg', avg, ' rms', rms
      end if

* BLR degrees of freedom
c	write(*,*) 'NpixBLR', npixblr, ' NfitBLR', nfitblr
      if( nfitblr .gt. 0 ) then
	n = nfitblr
	nfitblr = ( nfitblrblur - nfitblrcont ) * pct / 100. + nt
c	if( gabby ) write(*,*) 'BLR degrees of freedom', n, ' ->', nfitblr
	write(*,*) 'BLR degrees of freedom', n, ' ->', nfitblr
	write(*,*) 'BLR blur', nfitblrblur, ' cont', nfitblrcont, ' pct', pct
      end if

* stow BLR spectrum
      do i = 1, nw
	blr_w( i ) = dat_w( i )
	sigblr_w( i ) = sig_w( i )
      end do

* BLR line stats -------------------------------------------------

* BEGIN DEBUG REPORT
      IF( .FALSE. ) THEN

      if( nfitblr .gt. 0 ) then
* Use Hbeta if active
* KDH : THIS FAILS WHEN BLR_W IS 0 OVER THE HBETA RANGE
	l = line_hb
* find strongest broad line
	lbest = 0
      do l = 1, markline
      if( expand_l( l ) .gt. 0. ) then
      if( nabc( l ) .eq. nbroad ) then
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	n = iw2 - iw1 + 1
      if( n .gt. 0 ) then
	call linestat1( n, w_w, blr_w(iw1), maskblr(iw1),
     &		flx, wavg, wrms, wmed, wmad, wtop, wlo, whi, wlo10, whi10 )
	if( lbest .eq. 0 ) best = flx
      if( flx .gt. best ) then
	lbest = l
	best = flx
      end if
      end if
      end if
      end if
      end do
	if( lbest .gt. 0 ) l = lbest      
	rest = rest_l( l )
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	n = iw2 - iw1 + 1
* KDH : SHOULD WE GET MCMC ERROR BARS HERE ?
* KDH : TOO SLOW
	call linestat1( n, w_w, blr_w(iw1), maskblr(iw1),
     &	 flx, wavg, wrms, wmed, wmad, wtop, wlo, whi, wlo10, whi10 )

* report error
      if( wmad .le. 0. ) then
	write(*,*)
	write(*,*) '** WARNING 1: SHOULD NOT HAPPEN: WMAD=', wmad, ' :(('
	write(*,*) 'line', l, ' rest', rest, ' BLR'
	write(*,*) ' pixels', iw1, iw2, ' npix', n
	write(*,*) 'lam top', nint(wtop), ' lo', nint(wlo), ' hi ', nint(whi)
	write(*,*) '    avg', nint(wavg), ' rms', nint(wrms)
	write(*,*) '    med', nint(wmed), ' mad', nint(wmad)

	call mnmx( n, blr_w(iw1), dmn, dmx )
	write(*,*) 'data', dmn, dmx, ' flx', flx
	write(*,*) 'mask', (maskblr(i), i=iw1,iw2)
c	write(*,*) 'nfb', nfb, ' nfc', nfc, ' nf', nf
      end if

* velocities
	vavg = ckms * dlog( wavg / rest )
	vmed = ckms * dlog( wmed / rest )
	vtop = ckms * dlog( wtop / rest )
	vlo =  ckms * dlog(  wlo / rest )
	vhi =  ckms * dlog(  whi / rest )
	vlo10 = ckms * dlog( wlo10 / rest )
	vhi10 = ckms * dlog( whi10 / rest )
	vrms = ckms * alog( 1. + wrms / wavg )
	vmad = ckms * alog( 1. + wmad / wmed )
	vfwhm = ckms * alog( whi / wlo )
	vhw10 = ckms * alog( whi10 / wlo10 ) / 2.
* fix integrated line flux
	call fixflx( real( rest ), flx, fluxunit, inflxdex )
	wfwhm = whi - wlo
	whw10 = ( whi10 - wlo10 ) / 2.
* report
      if( gabby ) then
	write(*,*) nint( rest ), '  Flx', flx, ' erg/cm2/s'
	write(*,*) nint( rest ), ' Wavg', wavg, nint( vavg ), ' km/s'
	write(*,*) nint( rest ), '  med', wmed, nint( vmed )
	write(*,*) nint( rest ), '  top', wtop, nint( vtop )
	write(*,*) nint( rest ), ' lo10', wlo10, nint( vlo10 )
	write(*,*) nint( rest ), '   lo', wlo,  nint( vlo )
	write(*,*) nint( rest ), '   hi', whi,  nint( vhi )
	write(*,*) nint( rest ), ' hi10', whi10, nint( vhi10 )
	write(*,*) nint( rest ), '  rms', wrms, nint( vrms )
	write(*,*) nint( rest ), '  mad', wmad, nint( vmad )
	write(*,*) nint( rest ), ' fwhm', wfwhm, nint(vfwhm)
	write(*,*) nint( rest ), ' hw10', whw10, nint(vhw10)
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
      if( iw1 .le. 1. .or. iw2 .ge. nw ) then
	write(*,*) '*** LINE WINDOW HITS SPECTRUM EDGE. :(.', iw1, iw2
      end if
      end if
      end if
      END IF
* END DEBUG REPORT

	gabby = igab .ne. 0
	if( gabby ) write(*,*) 'Gabby', igab, gabby
*-------------------------------------------------------------------
* VarBLR stats

* lines sorted by wavelength
	if( gabby ) write(*,*) 'RMS BLR stats'
      DO lrank = 1, markline
	l = i_l( lrank )
* broad line
      if( nabc( l ) .eq. nbroad ) then
* with pixels
	n = npix_l( l )
      if( n .gt. 0 ) then
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	text = text_l( l )
	lt = len1( text )

	if( gabby ) write(*,*) '---------------------------------'
* BLR spectrum data - no range :(
	call mnmx( n, dat_wl( iw1, l ), dmn, dmx )
      if( dmn .eq. dmx ) then
      if( gabby ) then
	write(*,*) '** No BLR spec for ', text(:lt), iw1, iw2, n, dmn, ' :(.'
      end if
* BLR spectrum data AOK
      else
      if( gabby ) then
	write(*,*) 'BLR spec for ', text(:lt), iw1, iw2, n, dmn, dmx
      end if

	rest = rest_l( l )

* VarBLR components
	m = 0
      do ic = 1, ncomp
* KDH : SHOULD WE REQUIRE LINE IN RANGE HERE ?
	if( l .eq. line_lc( 1, ic ) ) m = l
      end do

* VarBLR components
      IF( m .ne. 0 ) then
	call linestat1( n, w_w(iw1), dat_wl(iw1,l), mask_wl(iw1,l), 
     &		flx, wavg, wrms, wmed, wmad, wtop, wlo, whi, wlo10, whi10 )
* report error
      if( wmad .le. 0. ) then
	write(*,*)
	write(*,*) '** WARNING 2: SHOULD NOT HAPPEN: WMAD=', wmad, ' :(('
	write(*,*) 'line', l, ' rest', rest, text(:lt)
	write(*,*) ' pixels', iw1, iw2, ' npix', n, ' nfit', nf
	write(*,*) 'lam top', nint(wtop), ' lo', nint(wlo), ' hi ', nint(whi)
	write(*,*) '    avg', nint(wavg), ' rms', nint(wrms)
	write(*,*) '    med', nint(wmed), ' mad', nint(wmad)

	call mnmx( n, dat_wl(iw1,l), dmn, dmx )
	write(*,*) 'data', dmn, dmx, ' flx', flx
	write(*,*) 'mask', (mask_wl(i,l), i=iw1,iw2)
      end if
	igab = 1

* BLR
      ELSE
	igab = 0
	call linestat1( n, w_w(iw1), blr_w(iw1), mask_wl(iw1,l), 
     &		flx, wavg, wrms, wmed, wmad, wtop, wlo, whi, wlo10, whi10 )
* report error
      if( wmad .le. 0. ) then
	write(*,*)
	write(*,*) '** WARNING 3: SHOULD NOT HAPPEN: WMAD=', wmad, ' :(('
	write(*,*) 'line', l, ' rest', rest, ' BLR'
	write(*,*) ' pixels', iw1, iw2, ' npix', n
	write(*,*) 'lam top', nint(wtop), ' lo', nint(wlo), ' hi ', nint(whi)
	write(*,*) '    avg', nint(wavg), ' rms', nint(wrms)
	write(*,*) '    med', nint(wmed), ' mad', nint(wmad)

	call mnmx( n, blr_w(iw1), dmn, dmx )
	write(*,*) 'data', dmn, dmx, ' flx', flx
	write(*,*) 'mask', (mask_wl(i,l), i=iw1,iw2)
      end if
      END IF

* velocities
	rest = rest_l( l )
	vavg = ckms * dlog( wavg / rest )
	vmed = ckms * dlog( wmed / rest )
	vtop = ckms * dlog( wtop / rest )
	vlo =  ckms * dlog(  wlo / rest )
	vhi =  ckms * dlog(  whi / rest )
	vlo10 = ckms * dlog( wlo10 / rest )
	vhi10 = ckms * dlog( whi10 / rest )
	vrms = ckms * alog( 1. + wrms / wavg )
	vmad = ckms * alog( 1. + wmad / wmed )
	vfwhm = ckms * alog( whi / wlo )
	vhw10 = ckms * alog( whi10 / wlo10 ) / 2.
* fix integrated line flux
	call fixflx( real( rest ), flx, fluxunit, inflxdex )
	wfwhm = whi - wlo
	whw10 = ( whi10 - wlo10 ) / 2.

* report
	w1 = w_w( iw1 )
	w2 = w_w( iw2 )
	v1 = ckms * dlog( w1 / rest )
	v2 = ckms * dlog( w2 / rest )
      if( gabby ) then
	write(*,*) 'RMS BLR line', l, ' rest', nint(rest), ' --------'
	write(*,*) ' pix', iw1, iw2, ' span', iw2-iw1+1, n
	write(*,*) ' lam', nint(w1), nint(w2), ' span', nint(w2-w1), ' A'
	write(*,*) ' vel', nint(v1), nint(v2), ' span', nint(v2-v1), ' km/s'
      if( iw1 .le. 1. .or. iw2 .ge. nw ) then
	write(*,*) '*** LINE WINDOW HITS SPECTRUM edge.', iw1, iw2, ' :((.'
      end if
	write(*,*) nint( rest ), '  Flx', flx, ' erg/cm2/s'
	write(*,*) nint( rest ), ' Wavg', wavg, nint( vavg ), ' km/s'
	write(*,*) nint( rest ), '  med', wmed, nint( vmed )
	write(*,*) nint( rest ), '  top', wtop, nint( vtop )
	write(*,*) nint( rest ), ' lo10', wlo10, nint( vlo10 )
	write(*,*) nint( rest ), '   lo', wlo,  nint( vlo )
	write(*,*) nint( rest ), '   hi', whi,  nint( vhi )
	write(*,*) nint( rest ), ' hi10', whi10, nint( vhi10 )
	write(*,*) nint( rest ), '  rms', wrms, nint( vrms )
	write(*,*) nint( rest ), '  mad', wmad, nint( vmad )
	write(*,*) nint( rest ), ' fwhm', wfwhm, nint(vfwhm)
	write(*,*) nint( rest ), ' hw10', whw10, nint(vhw10)
      end if

* stow
	vflx_l( l ) = flx
	vvavg_l( l ) = vavg
	vvrms_l( l ) = vrms
	vvmed_l( l ) = vmed
	vvmad_l( l ) = vmad
	vvtop_l( l ) = vtop
	vvlo_l( l ) = vlo
	vvhi_l( l ) = vhi
	vvlo10_l( l ) = vlo10
	vvhi10_l( l ) = vhi10
	vvfwhm_l( l ) = vfwhm
	vvhw10_l( l ) = vhw10

* error bars (place-holders)
      if( .false. ) then
	f = - 0.1
	sigvflx_l( l ) = f * flx
	sigvvavg_l( l ) = f * vrms
	sigvvrms_l( l ) = f * vrms
	sigvvmed_l( l ) = f * vmad
	sigvvmad_l( l ) = f * vmad
	sigvvtop_l( l ) = f * vmad
	sigvvlo_l( l ) = f * vmad
	sigvvhi_l( l ) = f * vmad
	sigvvlo10_l( l ) = f * vmad
	sigvvhi10_l( l ) = f * vmad
	sigvvfwhm_l( l ) = f * vmad
	sigvvhw10_l( l ) = f * vmad
      else
	f = -1.
	sigvflx_l( l ) = f
	sigvvavg_l( l ) = f
	sigvvrms_l( l ) = f
	sigvvmed_l( l ) = f
	sigvvmad_l( l ) = f
	sigvvtop_l( l ) = f
	sigvvlo_l( l )  = f
	sigvvhi_l( l )  = f
	sigvvlo10_l( l ) = f
	sigvvhi10_l( l ) = f
	sigvvfwhm_l( l ) = f
	sigvvhw10_l( l ) = f
      end if

      end if
      end if
      end if

* next lrank
      END DO

	if( gabby ) WRITE(*,*) 'LAST LINE.'

* VarBLR components ------------------------------------

* 2019 AUG KDH : SUSPECT THIS SMOOTHING IS PROBLEMATIC
* DEBUG ON
	IGAB_2019AUG = 0
	IF( GABBY ) IGAB_2019AUG = 1
	GABBY = .TRUE.

* KDH : THIS REPEATS A LOT OF CODE.
* ngc counts good components
	ngc = 0
      do ic = 1, ncomp
	if( npix_c( ic ) .gt. 0 ) ngc = ngc + 1
      end do

	if( gabby ) write(*,*) '========================================='
	if( gabby ) write(*,*) 'VarBLR components:', ngc, ' of', ncomp, ' max', maxc
* components
      DO ic = 1, ncomp

* branch here to rerun  
  911	l = line_lc( 1, ic )
	rest = rest_l( l )
	text = text_l( l )
	lt = len1( text )
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	n = npix_c( ic )

* require line data
      IF( N .GT. 0 ) THEN
	if( gabby ) write(*,*)
	if( gabby ) write(*,*) '--------- BLR component', ic, ' of', ncomp, ' -------------- ', text(:lt)
	if( gabby ) write(*,*) 'Line', l, ' ', text(:lt), ' pixels', iw1, iw2, n

* continuum fit parameters
	npoly = 0
* 1 spline per 5 x BLR WihHW.
	nspline = max( 1, nint( vtot / ( 5. * vblr ) ) )
	if( nspline .le. 1 ) npoly = 2
	nfitcont_l( l ) = max( nspline, npoly )

* report
      if( gabby ) then
      if( npoly .eq. 0 ) then
	write(*,*) 'remove ', text(:lt), ' continuum with splfit(', nspline, ' ).'
      else
	write(*,*) 'remove ', text(:lt), ' continuum with polyfit(', npoly, ' ).'
      end if
      end if

* data and error bars for continuum fit
* KDH : SHOULD THIS BE BLR_W OR DAT_WL ?
* KDH : USING BLR_W MIGHT REMOVE NEED TO RE-FIT AND RE-SMOOTH PER LINE
	ng = 0
      do i = 1, nw
	dat = dat_wl( i, l )
	sig = sigblr_w( i )
* mask pixels for continuum fit
	mask =  maskblr( i ) .or. masknlr( i )
* KDH 2019 May : MASK ABSN
	mask = mask .or. maskabsn( i )
* KDH 2019 Aug : MASK BAL
	mask = mask .or. maskbal( i )
	if( mask ) sig = - abs( sig )	
* stow
	dat_w( i ) = dat
	sig_w( i ) = sig
	if( sig .gt. 0. ) ng = ng + 1
      end do
	pct = ng * 100. / nw 
* report
      if( gabby .or. ng .le. 0 ) then
	write(*,*) 'continuum pixels:', ng, ' of', nw, ' =', pct, ' %'
	call mnmx( nw, dat_w, dmn, dmx )
	call mnmx( nw, sig_w, smn, smx )
	write(*,*) ' dat', dmn, dmx, ' sig', smn, smx
      end if

* this is for line l
* KDH : SOFT WINDOWS -- CODE REPEATED ELSEWHERE
	nl = lastbroad
      do i = 1, nw
	mask_w( i ) = masknlr( i )
     &		.or. maskabsn( i )
     &		.or.  maskbal( i )
* 2023 Feb 21 KDH: TRY MASKING BALMER CONTINUUM (NEEDED FOR RM160)
     &		.or. maskbac( i )
      end do
	call peqp( nw, plot1, sig_w )
	call softblr( nw, w_w, wgt_w, dat_w, sig_w, mask_w,
     &		nl, expand_l, iw1_l, iw2_l )

* stow for later plots
	call peqp( nw, wgt_wl( 1, l ), wgt_w )

* report
	p = 0.
      do i = 1, nw
      if( sig_w( i ) .gt. 0. ) then
	p = p + wgt_w( i )
      end if
      end do
      if( gabby .or. p .eq. 0 ) then
	call mnmx( nw, wgt_w, wmn, wmx )
	write(*,*) 'Continuum pixel weights', wmn, wmx
	pct = ( nw - p ) * 100. / nw 
	write(*,*) 'soft BLR pixels:', nint(nw-p), ' of', nw, ' =', pct, ' %'
      end if

* KDH 2019 AUG : DIAGNOSTIC PLOT CIV LINE
c      if( l .eq. line_c4 .and. debug ) then
c      if( l .eq. line_mg2 .and. debug ) then
c      if( .true. ) then
      if( .false. ) then
  910	call pgstart( 1, 1, notused )
	call pgbgw
	call pgsch( 1.5 )
	xmn = w_w( 1 )
	xmx = w_w( nw )
	ymn = min( 0., dmn, -0.5 * dmx )
	ymx = max( 0., 1.5 * dmx )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
	xlabel = 'rest wavelength (A)'
	ylabel = 'flux'
	title = 'RMS BLR Before Continuum Fit'
	call pglabel( xlabel, ylabel, title )
* rms_w
	call pgsci( kblue )
	call pgbin( nw, w_w, rms_w, .true. )
* rmsb_w
	call pgsci( kltgrey )
	call pgbin( nw, w_w, rmsb_w, .true. )
* data
	call pgsci( kblack )
	call pgbin( nw, w_w, dat_w, .true. )
* pre-softblr error bars
	call pgsci( kgreen )
	call pgbin( nw, w_w, plot1, .true. )
* post-softblr error bars
	call pgsci( korange )
	call pgbin( nw, w_w, sig_w, .true. )
* line window
	call pgsci( kred )
	call pgsls( kdot )
	x = w_w( iw1 )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	x = w_w( iw2 )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgsci( 1 )
	call pgsls( 1 )
	call pgstop
	if( pgagain() ) goto 910
      end if

* sigma-clip
	ncycle = 10
	thrhi = 2.
c	thrlo = -3.
	thrlo = -5.
* KDH 2019 MAY : TRY CLIP HERE
	THRLO = -3.
* report
      if( gabby ) then
	write(*,*) 'reject cycles', ncycle, ' clip', thrlo, thrhi, ' sigma.'
      end if

* stow pre-fit error bars
	call peqp( nw, plot1, sig_w )

* poly fit for line l (soft BLR windows)
      if( npoly .gt. 0 ) then
      if( autofit ) then
	call polyfita( nw, w_w, dat_w, sig_w, fit_w,
     &		npoly, ncycle, thrhi, thrlo, ifail )
      else
	call polyfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if

* spline fit of VarBLR continuum for line l (soft BLR windows)
* KDH : DO WE REALLY NEED TO REPEAT THIS FOR EACH LINE ?
      else
      if( autofit ) then
	call splfita( nw, w_w, dat_w, sig_w, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
      else
	call splfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if
      end if

* stow for later plot
	call peqp( nw, plot2, dat_w )
	call peqp( nw, plot3, sig_w )

* KDH : ABOVE FIT CHANGES SIG_W DUE TO CLIPPING
* KDH 2019 AUG : DIAGNOSTIC PLOT CIV LINE
c       if( l .eq. line_c4 .and. debug ) then
c       if( l .eq. line_mg2 .and. debug ) then
c       if( .true. ) then
       if( .false. ) then

  912	call pgstart( 1, 3, notused )

	call pgbgw
	call pgsch( 1.5 )
	xmn = w_w( 1 )
	xmx = w_w( nw )
	ymn = min( 0., dmn, -0.5 * dmx )
	ymx = max( 0., 1.5 * dmx )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
	xlabel = 'rest wavelength (A)'
	ylabel = 'flux'
	title = text(:lt)
	call append( title, 'RMS BLR Continuum' )
	call append( title, 'splfit(' )
	call append_i( title, nspline )
	call append( title, ')' )
	call pglabel( xlabel, ylabel, title )
* rms_w
	call pgsci( klblue )
	call pgbin( nw, w_w, rms_w, .true. )
* rmsb_w
	call pgsci( kltgrey )
	call pgbin( nw, w_w, rmsb_w, .true. )
* data
	call pgsci( kblack )
	call pgbin( nw, w_w, dat_w, .true. )
* fit
	call pgsci( kred )
	call pgline( nw, w_w, fit_w )
* pre-fit error bars
	call pgsci( kgreen )
	call pgbin( nw, w_w, plot1, .true. )
* post-fit error bars
	call pgsci( korange )
	call pgbin( nw, w_w, sig_w, .true. )
* line window
	call pgsci( kred )
	call pgsls( 4 )
	x = w_w( iw1 )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	x = w_w( iw2 )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgsci( 1 )
	call pgsls( 1 )

c      end if
* 2019 AUG KDH : DEBUG PLOT TO SEE SOFT WINDOWS
c  912	call pgstart(1,2,nouse)
c	call pgbgw
c	csize = csizedef
c	call pgsch( csize )

	call mnmx( nw, w_w, xmn, xmx )
	call medmad( nw, blr_w, dmed, dmad )
	call medmad( nw, rms_w, rmed, rmad )
	write(*,*) 'RMS BLR spectrum med', dmed, ' mad', dmad
	call mnmx( nw, plot2, ymn, ymx )
	call medmad( nw, plot3, smed, smad )
	ymx = max( dmed, smed, rmed ) * 2.
	ymx = max( 0., ymx )
	ymn = min( 0., ymn )
	add = ( ymx - ymn ) * 0.05
	ymn = ymn - add
	ymx = ymx + add
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
	xlabel = 'rest wavelength \gl (\A)'
	ylabel = 'flux'
	title = 'RMS Continuum fit : Nspline'
	call append_i( title, nspline )
	call append( title, 'clip' )
	call append_n( title, thrlo, 2 )
	call append_n( title, thrhi, 2 )
	call pglabel( xlabel, ylabel, title )
* blr spectrum 
	call pgsci( kltgrey )
	call pgbin( nw, w_w, blr_w, .true. )
* rmsx spectrum 
	call pgsci( kolor_rms )
	call pgbin( nw, w_w, rms_w, .true. )
* rms spectrum 
	call pgsci( kblack )
	call pgbin( nw, w_w, plot2, .true. )
* fitted continuum
	call pgsci( kolor_rmscont )
	call pgline( nw, w_w, fit_w )
* rms - continuum
	call pgsci( kblue )
	call pgbin( nw, w_w, dat_w, .true. )
* post-fit error bars
	call pgsci( kgreen )
	call pgbin( nw, w_w, sig_w, .true. )
* pre-fit error bars
	call pgsci( korange )
	call pgbin( nw, w_w, plot1, .true. )
	call pgsci( kblack )
* soft window
	ymn = 0.
	ymx = 1.
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	title = 'Soft Windows for RMS Continuum Fit'
	ylabel = ' '
	call pglabel( xlabel, ylabel, title )
	call pgsci( kblue )
	call pgbin( nw, w_w, blrwgt_w, .true. )
* line windows
      do i = 1, nl
	expand = expand_l( i )
	iw1 = iw1_l( i )
	iw2 = iw2_l( i )
      if( expand .ne. 0. .and. iw1 .gt. 0. .and. iw2 .gt. iw1 ) then
	y = 0.95
	k = kgreen
	if( expand .lt. 0. ) y = 0.92
	if( expand .lt. 0. ) k = kred
	call pgsci( k )
	x = w_w( iw1 )
	call pgmove( x, y )
	x = w_w( iw2 )
	call pgdraw( x, y )
      end if
      end do
	call pgsci( kblack )
	call pgstop
	if( pgagain() ) goto 912
* end diagnostic plot
      end if


* subtract continuum fit
* KDH : IF NG IS USED FOR DOF, SHOULD USE SOFT BLR PIXEL COUNT.
	ng = 0
      do i = 1, nw
	dat = dat_w( i )
	sig = sig_w( i )
	fit = fit_w( i )
* stow
	dat_w( i ) = dat - fit
	contrmsblr_w( i ) = fit
	if( sig .gt. 0. ) ng = ng + 1
      end do

* report
      if( gabby .or. ng .le. 0 ) then
	pct = ng * 100. / nw 
	write(*,*) 'continuum pixels:', ng, ' of', nw, ' =', pct, ' %'
	call avgrms( nw, dat_wl( 1, l ), avg, rms )
	write(*,*) text(:lt), ' dat_wl avg', avg, ' rms', rms
	call avgrms( nw, dat_w, avg, rms )
	write(*,*) text(:lt), '  dat_w avg', avg, ' rms', rms
      end if

* smooth the VarBLR spectrum for line l
* KDH : SHOULD NOT HAVE TO RE-DO THIS FOR EACH LINE
*	
	if( gabby ) write(*,*) 'Smooth ', text(:lt), ' RMS BLR spectrum'
	ng = 0
      do i = 1, nw
	sig = sig_wl( i, l )

C 2019 AUG KDH : THIS MIGHT BE THE BUG
* admit BLR windows
C	mask = .not. maskblr( i )
* mask narrow line windows
C	mask = mask .or. masknlr(i)
* admit this specific line only 
* 2019 AUG KDH - TRIED THIS, BUT GO BACK TO .NOT. MASKBLR
C	mask = .not. mask_wl( i, l )

* mask NLR windows NOT inside the BLR windows
	mask = masknlr(i) .and. .not. maskblr( i )
* KDH 2019 MAY : MASK ABSN
	mask = mask .or. maskabsn( i )
* KDH 2019 Aug : MASK BAL
	mask = mask .or. maskbal( i )
	if( mask ) sig = - abs( sig )
* stow
	sig_w( i ) = sig
	if( sig .gt. 0. ) ng = ng + 1
      end do
* total unmasked pixels
	ngfull = ng
* report
      if( gabby .or. ng .le. 0 ) then
	pct = ng * 100. / nw 
	write(*,*) 'RMS BLR pixels:', ng, ' of', nw, ' =', pct, ' %'
      end if

* KDH 2019 AUG : count good data before/after masking
	ng1 = 0
	ng0 = 0
      do i = iw1, iw2
	sig = sig_wl( i, l )
	if( sig .gt. 0. ) ng0 = ng0 + 1
	sig = sig_w( i )
	if( sig .gt. 0. ) ng1 = ng1 + 1
      end do
      if( gabby ) then
	write(*,*) text(:lt), ' pixels', iw1, iw2, ' good', ng0, ' =>', ng1, ' of', n
      end if

* KDH 2019 AUG : THIS PANIC DOES NOT OCCUR.' 
* panic 
	newpanic = 1
	if( panic ) newpanic = 0
	panic = ng .lt. max( 1, n/2 )
      if( panic ) then
	write(*,*) 'PANIC! 2'
      if( newpanic .ne. 0 .and. .not. gabby ) then
	gabby = .true.
	write(*,*) 'Rerun ', text(:lt),' for more diagnostics.'
	goto 911
      end if
      end if

* smooth fit - 3 splines per BLR WinHW
	splines_per_blrwin = 3.
	nspline = max( 1, nint( vtot / ( vblr / splines_per_blrwin ) ) )
      if( gabby ) then
	write(*,*) 'Smooth ', text(:lt), ' with splfit(', nspline, ' )'
	write(*,*) ' splines per BLR window:', splines_per_blrwin
      end if
* sigma clip
	ncycle = 10
	thrhi = 100.
	thrlo = -100.

* KDH 2019 MAY : TRY CLIPPING HERE
* KDH 2019 AUG : UNDO THIS
C	THRLO = -3.

      if( gabby ) then
	write(*,*) ' reject cycles', ncycle, ' clip', thrlo, thrhi, ' sigma.'
      end if

* good pixels before splfit
	ng0 = 0
      do i = iw1, iw2
	if( sig_w( i ) .gt. 0. ) ng0 = ng0 + 1
      end do
	if( gabby ) write(*,*) 'BEFORE splfit(', nspline, ' ) ng =', ng0, ' of', n

* stow pre-fit error bars
	call peqp( nw, plot1, sig_w )
* spline fit to smooth VarBLR spectrum for line l
      if( autofit ) then
	call splfita( nw, w_w, dat_w, sig_w, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
      else
	call splfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if

* good pixels after splfit
	ng1 = 0
      do i = iw1, iw2
	if( sig_w( i ) .gt. 0. ) ng1 = ng1 + 1
      end do
* KDH 2019 AUG : THE CLIPPED SPLINE FIT CHANGES THE ERROR BARS.'
* report change
      if( gabby .or. ng0 .ne. ng1 ) then
	write(*,*) 'BEFORE splfit(', nspline, ' ) ng =', ng0, ' of', n
	write(*,*) ' AFTER splfit(', nspline, ' ) ng =', ng1, ' of', n
      end if

* KDH 2019 AUG : DIAGNOSTIC PLOT CIV LINE
c      if( l .eq. line_c4 .and. debug ) then
c      if( l .eq. line_mg2 .and. debug ) then
c      if( .true. ) then
      if( .false. ) then
  913	call pgstart( 1, 1, notused )
	call pgbgw
	call pgsch( 1.5 )
	xmn = w_w( 1 )
	xmx = w_w( nw )
	ymn = min( 0., dmn, -0.5 * dmx )
	ymx = max( 0., 1.5 * dmx )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
	xlabel = 'rest wavelength (A)'
	ylabel = 'flux'
	title = 'RMS BLR ' // text(:lt)
	call append( title, 'splfit(' )
	call append_i( title, nspline )
	call append( title, ')' )
	call pglabel( xlabel, ylabel, title )
* rms_w
	call pgsci( kblue )
	call pgbin( nw, w_w, rms_w, .true. )
* rmsb_w
	call pgsci( kltgrey )
	call pgbin( nw, w_w, rmsb_w, .true. )
* data
	call pgsci( kblack )
	call pgbin( nw, w_w, dat_w, .true. )
* fit
	call pgsci( kred )
	call pgline( nw, w_w, fit_w )
* pre-fit error bars
	call pgsci( kgreen )
	call pgbin( nw, w_w, plot1, .true. )
* post-fit error bars
	call pgsci( korange )
	call pgbin( nw, w_w, sig_w, .true. )
* line window
	call pgsci( kred )
	call pgsls( 4 )
	x = w_w( iw1 )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	x = w_w( iw2 )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgsci( 1 )
	call pgsls( 1 )
	call pgstop
	if( pgagain() ) goto 913
      end if


* scale fit error bars by 1/sqrt(blurpix)
	nsmooth = nspline
* KDH : STOW THIS LATER?
	nsmooth_l( l ) = nspline
* KDH 2019 AUG : NG HERE SHOULD BE FOR FULL SPECTRUM !  IS THIS THE BUG?
	ng = ngfull
	blurpix = real( ng ) / nsmooth
	div = sqrt( min( 1., blurpix ) )
* KDH : IS THIS NOT ALREADY DONE ?
* KDH 2019 AUG : ERROR BARS KEEP GROWING UNLESS DIV = 1 HERE
	div = 1.

      if( gabby .or. ng. le. 0 .or. nsmooth .le. 0 ) then
	write(*,*) 'Blurpix', ng, ' /', nsmooth, ' =', blurpix
	write(*,*) 'Error bar divisor', div
      end if

* zero pixels outside line mask
* KDH : SHOULD WE ALSO SET SIG_WL = 0 HERE ?
* KDH : NO - WANT TO PULL BLR FIT DOWN OUTSIDE LINE MASK
	ng = 0
      do i = 1, nw
	sig = sig_w( i ) / div
	fit = fit_w( i )
	mask = mask_wl( i, l )
	dat = 0.
      if( mask ) then
	dat = fit
	if( sig .gt. 0. ) ng = ng + 1
      end if
* stow
	dat_w( i ) = dat
	sig_w( i ) = sig
	fitrmsblr_w( i ) = fit
	sigfitrmsblr_w( i ) = sig
      end do
	pct = ng * 100. / nw 

* report
      if( gabby .or. ng .le. 0 ) then
	if( ng .le. 0 ) write(*,*) '** WARNING: LINE', l, ' HAS NO VALID DATA. :((.'
	write(*,*) text(:lt), ' pixels kept:', ng, ' of', nw, ' =', pct, ' %'
      end if


* KDH : HBETA DEBUG
	IGAB = 0
	IF( GABBY ) IGAB = 1
	GABBY = GABBY .OR. L .EQ. LINE_HB 

* rectify
      if( gabby ) then
	write(*,*) 'Before Rectify1'
	call avgrms( nw, dat_w, avg, rms )
	write(*,*) text(:lt), ' avg', avg, ' rms', rms
      end if
c 	call rectify( nt, dat_tl(1,l), sig_tl(1,l), nw, dat_w )
	call rectify1( nt, dat_tl(1,l), sig_tl(1,l), nw, dat_w, 1 )
      if( gabby ) then
	write(*,*) 'After Rectify1'
	call avgrms( nw, dat_w, avg, rms )
	write(*,*) text(:lt), ' avg', avg, ' rms', rms
      end if

* clip negative bits
	ngp = 0
      do i = 1, nw
	dat = dat_w( i )
	dat = max( dat, 0. )
	if( dat .gt. 0. ) ngp = ngp + 1
	dat_w( i ) = dat
      end do
	pct = ngp * 100. / max( 1, nw )

* report
      if( gabby .or. ngp .le. 0 ) then
	if( ngp .le. 0 ) write(*,*) '** WARNING: NO POSITIVE DATA FOR ', text(:lt), ' :(('
	write(*,*) text(:lt), ' Positive data', ngp, ' of', nw, ' =', pct, ' %'


* KDH 2019 AUG : RM052 WHY IS MGII NOT POSITIVE ?' 
* panic 
	newpanic = 1
	if( panic ) newpanic = 0
c	panic = ng .lt. max( 1, n/2 )
	panic = l .eq. line_mg2 .and. ngp .le. 0 
      if( panic ) then
	write(*,*) 'PANIC! MgII < 0'
      if( newpanic .ne. 0 .and. .not. gabby ) then
	gabby = .true.
	write(*,*) 'Rerun ', text(:lt),' for more diagnostics.'
	goto 911
      end if
      end if



      if( gabby ) then
	call avgrms( nw, dat_wl( 1, l ), avg, rms )
	write(*,*) text(:lt), ' dat_wl avg', avg, ' rms', rms
      else
	call avgrms( nw, dat_w, avg, rms )
	write(*,*) text(:lt), ' dat_w  avg', avg, ' rms', rms
      end if
      end if

	GABBY = IGAB .NE. 0
* KDH : END OF HBETA DEBUG


* degrees of freedom
* KDH : OMIT THIS TEST. IT PREVENTS NFIT_L FROM UPDATING
* KDH : SHOULD IT BE NPIX_L( L ) ?
c	n = nfit_l( l )
	n = npix_l( l )
      if( n .gt. 0 ) then
	nfb = nsmooth_l( l )
	nfc = nfitcont_l( l )
* KDH : WHICH PCT SHOULD THIS BE ?
	nf = nt + ( nfb - nfc ) * pct / 100
	if( gabby ) write(*,*) text(:lt), ' dof', n, ' ->', nf
	nfit_l( l ) = nf
	nfit_c( ic ) = nf
* KDH : NO NEED TO CHANGE NPIX_C 
	npix_c( ic ) = n
      end if

* line stats
	nf = nfit_l( l )
      if( nf .gt. 0 ) then
	text = text_l( l )
	rest = rest_l( l )
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	n = npix_l( l )
	call linestat1( n, w_w(iw1), dat_w(iw1), mask_wl(iw1,l),
     &	 flx, wavg, wrms, wmed, wmad, wtop, wlo, whi, wlo10, whi10 )

* report error
      if( ngp .gt. 0 .and. wmad .le. 0. ) then
	write(*,*)
	write(*,*) '** WARNING 4: SHOULD NOT HAPPEN: WMAD=', wmad, ' :(('
	write(*,*) 'line', l, ' rest', rest, ' ', text(:lt)
	write(*,*) ' pixels', iw1, iw2
	write(*,*) '   npix', n, ' nfit', nf, ' ngp', ngp
	write(*,*) 'lam top', nint(wtop), ' lo', nint(wlo), ' hi ', nint(whi)
	write(*,*) '    avg', nint(wavg), ' rms', nint(wrms)
	write(*,*) '    med', nint(wmed), ' mad', nint(wmad)

	call mnmx( n, dat_w(iw1), dmn, dmx )
	write(*,*) 'data', dmn, dmx, ' flx', flx
	write(*,*) 'mask', (mask_wl(i,l), i=iw1,iw2)
      end if

* velocities
	rest = rest_l( l )
	vavg = ckms * dlog( wavg / rest )
	vmed = ckms * dlog( wmed / rest )
	vtop = ckms * dlog( wtop / rest )
	vlo =  ckms * dlog(  wlo / rest )
	vhi =  ckms * dlog(  whi / rest )
	vlo10 = ckms * dlog( wlo10 / rest )
	vhi10 = ckms * dlog( whi10 / rest )
	vrms = ckms * alog( 1. + wrms / wavg )
	vmad = ckms * alog( 1. + wmad / wmed )
	vfwhm = ckms * alog( whi / wlo )
	vhw10 = ckms * alog( whi10 / wlo10 ) / 2.
* fix integrated line flux
	call fixflx( real( rest ), flx, fluxunit, inflxdex )
	wfwhm = whi - wlo
	whw10 = ( whi10 - wlo10 ) / 2.
* report
      if( gabby ) then
	write(*,*) text(:len1(text)), ' line', l, ' rest', nint(rest)
	write(*,*) nint( rest ), '  Flx', flx, ' erg/cm2/s'
	write(*,*) nint( rest ), ' Wavg', wavg, nint( vavg ), ' km/s'
	write(*,*) nint( rest ), '  med', wmed, nint( vmed )
	write(*,*) nint( rest ), '  top', wtop, nint( vtop )

	write(*,*) nint( rest ), ' lo10', wlo10, nint( vlo10 )
	write(*,*) nint( rest ), '   lo', wlo,  nint( vlo )
	write(*,*) nint( rest ), '   hi', whi,  nint( vhi )
	write(*,*) nint( rest ), ' hi10', whi10, nint( vhi10 )

	write(*,*) nint( rest ), '  rms', wrms, nint( vrms )
	write(*,*) nint( rest ), '  mad', wmad, nint( vmad )
	write(*,*) nint( rest ), ' fwhm', wfwhm, nint(vfwhm)
	write(*,*) nint( rest ), ' hw10', whw10, nint(vhw10)
      end if

* KDH : TWEAK ERROR BARS TO ALLOW FOR SMOOTHING
	div = 1.
      if( idived .ne. 0 ) then
	div = 1. / sqrt( max( 1., blurpix ) )
      do i = 1, nw
	dat_w( i ) = dat_w( i )
	sig_w( i ) = sig_w( i ) / div
      end do
      end if
	if( div .ne. 1. ) write(*,*) 'Line', l, ' Sigma divisor', div

* 2019 AUG KDH : check error bars
	ng = 0
	ng0 = 0
      do i = iw1, iw2
	sig = sig_wl( i, l )
	if( sig .gt. 0. ) ng0 = ng0 + 1
	sig = sig_w( i )
	if( sig .gt. 0. ) ng = ng + 1
      end do
      if( gabby .or. ng .le. 0 ) then
	write(*,*) text(:lt), ' pixels', iw1, iw2, ' good', ng0, ' =>', ng, ' of', n
      end if

* 2019 AUG KDH : THIS PANIC DOES OCCUR.'
* panic
	newpanic = 1
	if( panic ) newpanic = 0
	panic = ng .lt. max( 1, n/2 )
      if( panic ) then
	write(*,*) 'PANIC! 3'
      if( newpanic .ne. 0 .and. .not. gabby ) then
	gabby = .true.
	write(*,*) 'Rerun ', text(:lt),' for more diagnostics.'
	goto 911
      end if
      end if

* stow spectrum
      if( gabby ) then
	call mnmx( nw, dat_w, dmn, dmx )
	ng = 0
      do i = 1, nw
	if( sig_w( i ) .gt. 0. ) ng = ng + 1
      end do
	write(*,*) 'Stowing ', text(:lt), ' line', l
     &		, ' good pixels', ng, ' of', nw

	ng = 0
      do i = iw1, iw2
	if( sig_w( i ) .gt. 0. ) ng = ng + 1
      end do
	write(*,*) 'Stowing ', text(:lt), ' line', l
     &		, ' good window pixels', ng, ' of', n

	write(*,*) ' dat_w', dmn, dmx
	call mnmx( nw, sig_w, smn, smx )
	write(*,*) ' sig_w', smn, smx, ' blurpix', blurpix
      end if

* stow
	blurpix_l( l ) = blurpix
      do i = 1, nw
	dat_wl( i, l ) = dat_w( i )
	sig_wl( i, l ) = sig_w( i )
      end do

* stow velocities
      if( gabby ) then
	write(*,*) 'Stowing ', text(:lt), ' velocities'
	write(*,*) ' rms', nint( vrms )
     &		, ' mad', nint( vmad )
     &		, ' fwhm', nint( vfwhm )
      end if
	vflx_l( l ) = flx
	vvavg_l( l ) = vavg
	vvrms_l( l ) = vrms
	vvmed_l( l ) = vmed
	vvmad_l( l ) = vmad
	vvtop_l( l ) = vtop
	vvlo_l( l ) = vlo
	vvhi_l( l ) = vhi
	vvlo10_l( l ) = vlo10
	vvhi10_l( l ) = vhi10
	vvfwhm_l( l ) = vfwhm
	vvhw10_l( l ) = vhw10

* error bars (place-holders)
      if( .false. ) then
	f = - 0.1
	sigvflx_l( l ) = f * flx
	sigvvavg_l( l ) = f * vrms
	sigvvrms_l( l ) = f * vrms
	sigvvmed_l( l ) = f * vmad
	sigvvmad_l( l ) = f * vmad
	sigvvtop_l( l ) = f * vmad
	sigvvlo_l( l ) = f * vmad
	sigvvhi_l( l ) = f * vmad
	sigvvlo10_l( l ) = f * vmad
	sigvvhi10_l( l ) = f * vmad
	sigvvfwhm_l( l ) = f * vmad
	sigvvhw10_l( l ) = f * vmad
      else
	f = -1.
	sigvflx_l( l ) = f
	sigvvavg_l( l ) = f
	sigvvrms_l( l ) = f
	sigvvmed_l( l ) = f
	sigvvmad_l( l ) = f
	sigvvtop_l( l ) = f
	sigvvlo_l( l )  = f
	sigvvhi_l( l )  = f
	sigvvlo10_l( l ) = f
	sigvvhi10_l( l ) = f
	sigvvfwhm_l( l ) = f
	sigvvhw10_l( l ) = f
      end if

      end if
* next ic spectral component
      END IF
      END DO

* DEBUG OFF
	GABBY = IGAB_2019AUG .NE. 0

      if( gabby ) then
* abort on panic
c	if( panic ) stop 'PANIC! 2 or 3'
* pause on panic
	if( panic ) call pause('PANIC! 2 OR 3')
      end if

* BaC ---------------------------------------

* splines for BaC continuum fit
* 1 spline per 5 BaC widths
	vbac = ckms * alog( bac2 / bac1 ) + vblr * expandbac
	nspline = max( 1, nint( vtot / ( 5. * vbac ) ) )
      if( gabby ) then
	write(*,*)
	write(*,*) 'remove BaC continuum with', nspline, ' splines.'
      end if
* mask lines
	ng = 0
      do i=1,nw
	sig = sigblr_w( i )

	mask = maskblr( i ) .or. masknlr( i )
* KDH 2019 MAY : MASK ABSN
	mask = mask .or. maskabsn( i )
* KDH 2019 Aug : MASK BAL
	mask = mask .or. maskbal( i )
	if( mask ) sig = - abs( sig )
* stow
	sig_w( i ) = sig
	if( sig .gt. 0. ) ng = ng + 1
      end do
	pct = ( nw - ng ) * 100. / nw 
      if( gabby ) then
	write(*,*) 'masked line pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if
* sigma clip
	ncycle = 10
	thrlo = -3.
	thrhi = 2.
      if( gabby ) then
	write(*,*) 'reject cycles', ncycle, ' clip', thrlo, thrhi, ' sigma.'
      end if

* spline fit to isolate BaC
      if( autofit ) then
	call splfita( nw, w_w, bac_w, sig_w, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
* sanity check the spline fit
      else
	call splfitr( nw, w_w, bac_w, sig_w, fit_w, ifail )
      end if
	nfitbaccont = nspline

* subtract continuum underlying BaC
	ng = 0
      do i=1,nw
	bac_w(i) = bac_w(i) - fit_w(i)
	if( sig_w(i) .gt. 0. ) ng = ng + 1
      end do
* report
	pct = ( nw - ng ) * 100. / nw 
      if( gabby ) then
	write(*,*) 'masked pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if
	call avgrms( nw, bac_w, avg, rms )
	if( gabby ) write(*,*) 'bac_w avg', avg, ' rms', rms

* smooth BaC spectrum
	ng = 0
      do i=1,nw
	sig = sigbac_w( i )

	mask = masknlr( i ) .and. ( .not. maskblr( i ) )
* KDH 2019 MAY : MASK ABSN
	mask = mask .or. maskabsn( i )
* KDH 2019 Aug : MASK BAL
	mask = mask .or. maskbal( i )
	if( mask ) sig = - abs( sig )
* stow
	sig_w(i) = sig
	if( sig .gt. 0. ) ng = ng + 1
      end do
	pct = ( nw - ng ) * 100. / nw 
      if( gabby ) then
	write(*,*) 'masked pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if

* smooth BaC fit
* 3 splines per BaC width
	nspline = max( 1, nint( vtot / ( vbac / 3. ) ) )
	if( gabby ) write(*,*) 'smooth BaC with', nspline, ' splines.'
	nfitbacblur = nspline
* sigma clip
	ncycle = 10
	thrlo = -100.
	thrhi = 100.
      if( gabby ) then
	write(*,*) 'reject cycles', ncycle, ' clip', thrlo, thrhi, ' sigma.'
      end if

* spline fit to smooth Balmer continuum
      if( autofit ) then
	call splfita( nw, w_w, bac_w, sig_w, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
* sanity check the spline fit
      else
	call splfitr( nw, w_w, bac_w, sig_w, fit_w, ifail )
      end if
* zero non-BaC pixels
	ng = 0
      do i=1,nw
      if( maskbac(i) ) then
	bac_w(i) = fit_w(i)
	if( sig_w(i) .gt. 0. ) ng = ng + 1
      else
	bac_w(i) = 0.
      end if
      end do
	pct = ng * 100. / nw 
      if( gabby ) then
	write(*,*) 'BaC pixels kept:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if
* rectify
	call rectify( nt, bac_t, sigbac_t, nw, bac_w )
	call avgrms( nw, bac_w, avg, rms )
	if( gabby ) write(*,*) 'bac_w avg', avg, ' rms', rms

* positive BaC
	ngp = 0
      do i=1,nw
	if( bac_w( i ) .gt. 0 ) ngp = ngp + 1
	bac_w( i ) = max( 0., bac_w( i ) )
      end do
	pct = ngp * 100. / max(1,ng)
      if( gabby ) then
	write(*,*) 'Positive', ngp, ' of', ng, ' =', pct, ' %'
	call avgrms( nw, bac_w, avg, rms )
	write(*,*) 'bac_w avg', avg, ' rms', rms
      end if

* BaC degrees of freedom
      if( nfitbac .gt. 0 ) then
	n = nfitbac
	nb = nfitbacblur
	nc = nfitbaccont
	nfitbac = ( nb - nc ) * pct/100. + nt
	if( gabby ) write(*,*) 'BaC degrees of freedom', n, ' ->', nfitbac
      end if

c      end if


* loop to separate AVG, NLR, and ABSN spectra

* KDH : TURN GABBY ON TO DEBUG 
	igab = 0
	if( gabby ) igab = 1
      IF( .FALSE. ) THEN
	gabby = .true.
	write(*,*) 'Gabby', gabby, ' for debugging.'
      END IF

	nloop = 1
      do loop = 1, nloop
	if( gabby ) write(*,*) 'Loop', loop, ' of', nloop

* revise AVG and NLR spectrum ===============
	if( gabby ) write(*,*) 
	if( gabby ) write(*,*) 'Revise AVG and NLR spectrum =========================='

      IF( .TRUE. ) THEN
c      IF( .FALSE. ) THEN
* total velocity range
	vtot = ckms * alog( w_w( nw ) / w_w( 1 ) )

* number of splines ( one per VNLR )
	nspline = max( 1, nint( vtot / vnlr ) )

* KDH : 2017 OCT 26 - TESTING ON RMID 62, 123, 185, 272

* KDH : 1 SPLINE PER VNLR (better for RM272)
c	stiffnlr = 1.
* KDH : 1 SPLINE PER 3 * VNLR (good for RM062)
c	stiffnlr = 3.
* KDH : RM272 NEEDS MORE FLEXIBLE SPLINE
* KDH : NOW SET USING COMMAND N

	if( stiffnlr .le. 0. ) stiffnlr = 1.
	v = vnlr * stiffnlr

	nspline = max( 1, nint( vtot / v ) )
	
      if( gabby ) then
	write(*,*)
	write(*,*) '1 spline per', stiffnlr, ' NLR WinHW', nint(vnlr), ' ->', nint(v)
	write(*,*) 'split NLR from AVG with', nspline, ' splines.'
      end if

* evaluate absorption model
* KDH : DO WE REALLY NEED TO DO THIS AGAIN HERE?
* KDH : MAKE A SUBROUTINE ?

      IF( .TRUE. ) THEN
      do iw = 1, nw
	od = 0.
	dim = 1.
	fitod_w( iw ) = od
	fitdim_w( iw ) = dim
	fitod_agn_w( iw ) = od
	fitdim_agn_w( iw ) = dim
      end do

      if( dips ) then
* galactic lines
	ltype = ltype_galactic
	call odspec( nw, w8_w, fitod_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, ltype )
* intrinsic lines
	ltype = ltype_intrinsic
	call odspec( nw, w8_w, fitod_agn_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, ltype )
* dim <= exp( - optical depth )
      do i=1,nw
	od = fitod_w( i ) 
c	wobs = w8_w( i ) * opz
c	od = od + odlya( wobs, wobs_lya, v1_lya, tau0_lya )
	fitdim_w( i ) = exp( - od )
	od = fitod_agn_w( i )
	fitdim_agn_w( i ) = exp( - od )
      end do
      end if


* KDH : DELETE OBSOLETE CODE BELOW ONCE ABOVE CODE TESTED
      ELSE
* absorption line spectrum
      do iw = 1, nw
      if( .not. dips ) then
	od = 0.
	dim = 1.
	fitod_w( iw ) = od
	fitdim_w( iw ) = dim
	fitod_agn_w( iw ) = od
	fitdim_agn_w( iw ) = dim
      else
* KDH: EVALUATE THE ABSORPTION LINE MODEL
* KDH: SLOW - SHOULD DO THIS OUTSIDE THE WAVELENGTH LOOP
	wobs = w8_w( i ) * opz	
* galactic lines
	ltype = ltype_galactic
	od = odlines( wobs, nl, wobs_l, sigv_l, tau0_l, ltype_l, ltype )
c	od = od + odlya( wobs, wobs_lya, v1_lya, tau0_lya )
	dim = exp( -od )
	fitod_w( i ) = od 
	fitdim_w( i ) = dim	
* intrinsic lines
	ltype = ltype_intrinsic
	od = odlines( wobs, nl, wobs_l, sigv_l, tau0_l, ltype_l, ltype )
	dim = exp( -od )
	fitod_agn_w( i ) = od 
	fitdim_agn_w( i ) = dim	
      end if
* next wavelength iw
      end do
* KDH : END OF OBSOLETE CODE
      END IF

* DEBUG report
      if( dips ) then
	write(*,*) '1+z', opz
	write(*,*) 'Absorption lines', nl
	call mnmx( nl, sigv_l, vmn, vmx )
	call mnmx( nl, tau0_l, tmn, tmx )
	write(*,*) ' SigV mn,mx', vmn, vmx
	write(*,*) ' tau0 mn,mx', tmn, tmx

	write(*,*) 'Galactic Absorption spectrum', nw
	call mnmx( nw, fitod_w, omn, omx )
	call mnmx( nw, fitdim_w, dmn, dmx )
	call medmad( nw, fitod_w, omed, omad )
	call medmad( nw, fitdim_w, dmed, dmad )
	write(*,*) ' tau mn,mx', omn, omx, ' med,mad', omed, omad
	write(*,*) ' exp(-tau)', dmn, dmx, ' med,mad', dmed, dmad

	write(*,*) 'Intrinsic Absorption spectrum', nw
	call mnmx( nw, fitod_agn_w, omn, omx )
	call mnmx( nw, fitdim_agn_w, dmn, dmx )
	call medmad( nw, fitod_agn_w, omed, omad )
	call medmad( nw, fitdim_agn_w, dmed, dmad )
	write(*,*) ' tau mn,mx', omn, omx, ' med,mad', omed, omad
	write(*,*) ' exp(-tau)', dmn, dmx, ' med,mad', dmed, dmad
      end if

* mask bad pixels and dips
      IF( .FALSE. ) THEN
      do i = 1, nw
	sig = sigavg_w( i )
	if( maskdim( i ) ) sig = - abs( sig )
	plot2( i ) = sig
      end do
      END IF

* mask bad pixels and high optical depth pixels
	odmin = 0.01
	n = 0
	nod = 0
      do i = 1, nw
	od = fitod_w( i ) + fitod_agn_w( i )
	sig = sigavg_w( i )
	mask = od .gt. odmin
* KDH : TRY NOT MASKING HIGH OPTICAL DEPTH
	MASK = .FALSE.
	if( mask ) nod = nod + 1
* KDH : MASK BAL - FIXES FIT TO BLR IN AVG SPECTRUM !
	mask = mask .or. maskbal( i )
	if( mask ) sig = - abs( sig )
	if( mask ) n = n + 1
* stow
	plot2( i ) = sig
	maskdim( i ) = mask
      end do
* report
      if( dips ) then
	write(*,*) 'Optical depths >', odmin, ' pixels', nod
     &		, ' =', nod*100./nw, ' %'
      end if
      if( gabby ) then
	write(*,*) 'masked pixels', n, ' of', nw
     &		, ' =', n*100./nw, ' %'
      end if

* sigma clip
* KDH TRY CHANGING NCYCLE FROM 2 TO 10
c	ncycle = 2
c	ncycle = 10
* CHANGE TO 1 (2018-Feb 27)  rm272 [OIII] truncated
	ncycle = 1
* CHANGE BACK TO 2 (2018-Feb 27)
	ncycle = 2

	thrhi = 3.
* KDH TRY CHANGING THRLO FROM -3 to -10
c	thrlo = -3.
c	thrlo = -10.
* KDH 2019 MAY : TRY TO MASK ABSORPTION LINES
	thrlo = -5.

* loose spline fit to mean spectrum - isolate NLR
* (does not use soft BLR windows)
* KDH : FORCE INTERACTIVE SPLINE FIT TO DEBUG
C      if( autofit .and. .FALSE. ) then
      if( autofit ) then
	call splfita( nw, w_w, avg_w, plot2, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
      else
	write(*,*) 'Try', nspline, ' splines, clip hi/lo', thrhi, thrlo
	call splfitr( nw, w_w, avg_w, plot2, fit_w, ifail )
      end if
	call peqp( nw, fitavg_w, fit_w )
	nelr = nspline

* SMOOTH NLR SPECTRUM remove dips affecting the narrow lines
* KDH: DOESN'T WORK SO WELL, SO DISABLE
      IF( .FALSE. ) THEN
C      IF( dips ) THEN
      do i = 1, nw
	plot1(i) = avg_w(i) - fit_w(i)
      end do

* DISABLED CODE
* sigma clip
	ncycle = 10
	thrhi = 100.
	thrlo = -2.
	nspline = nelr * 2

* DISABLED CODE
* KDH : SHOULD BASE THIS ON RATIO OF VNLR TO VDIP
* 5-times looser spline to smooth NLR spectrum
	nspline = nelr * 5

* KDH : OMIT THIS
      if( .false. ) then
c      if( autofit ) then
	call splfita( nw, w_w, plot1, plot2, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )

      else
	write(*,*) 'Try', nspline, ' splines, hi/lo', thrhi, thrlo
	call splfitr( nw, w_w, plot1, plot2, fit_w, ifail )
      end if

      if( gabby ) then
	write(*,*) 'NLR spectrum smoothed with', nspline, ' splines.'
	write(*,*) '    clipped at', thrlo, thrhi, ' sigma'
      end if

* DISABLED CODE
* move flux from AVG to NLR 
      do i = 1, nw
      if( masknlr(i) ) then
	add = max( 0., fit_w(i) )
	elr_w(i) = elr_w(i) + add
	avg_w(i) = avg_w(i) - add
      else
	elr_w(i) = 0.
      end if
      end do

* KDH: END OF DISABLED CODE.  DO THIS INSTEAD
      ELSE

* KDH : SUPPRESS NOISY NLR WINDOWS 
      IF( .TRUE. ) THEN
* zero NLR spectrum
      do i = 1, nw
	elr_w( i ) = 0.
	plot3( i ) = avg_w( i ) - fit_w( i )
	plot4( i ) = sigavg_w( i )
	elr_raw_w( i ) = plot3( i )
      end do

* narrow absorption-line mask
	thrabsn = -3.
	thrabsn = -2.5
      do i = 1, nw
	maskabsn( i ) = .false.
* KDH : 2019 MAY - SWITCH OFF (BREAKS BLR FIT?)
      if( useabsnmask ) then
	sig = sigavg_w( i )
	maskabsn( i ) = elr_raw_w( i ) .lt. sig * thrabsn
      end if
      end do
      
* min S/N to use NLR line window
	snrmin = 3.
	snrmin = 0.
	keep = 0
	nlrwin = 0

	lowi1 = 1
* NLR window starts at i1 > 1
  777 do i1 = lowi1, nw
	im = max( 1, i1 - 1 )
* NLR window must start with i1 > 1
      if( masknlr( i1 ) .and. .not. masknlr( im ) ) then
* NLR window ends at i2
      do i2 = i1, nw
	ip = min( nw, i2 + 1 )
* NLR window must end with i2 < nw
      if( masknlr( i2 ) .and. .not. masknlr( ip ) ) then
	nlrwin = nlrwin + 1

* KDH : DOES THIS S/N ESTIMATE SUFFICE ?
	n = i2 - i1 + 1
c	call optavg( n, plot3(i1), plot4(i1), avg, sig )
c	snr = avg / sig

* use center half of the window
	klip = nint( 0.25 * n )
	ii1 = i1 + klip
	ii2 = i2 - klip
	nn = ii2 - ii1 + 1
	call optavg( nn, plot3( ii1 ), plot4( ii1 ), avg, sig ) 
	snr = avg / sig
	lam = nint( ( w_w( i1 ) + w_w( i2 ) ) / 2. )
* smooth cut-off based on snr
	f = max( 0., min( snr, 6. ) )
	f = 1. - exp( - 0.5 * f * f )
* report
      if( snr .lt. snrmin ) then
	if( gabby ) write(*,*) 'NLR', lam, n, ' S/N', snr, f, ' Skipped.'
      else
	keep = keep + 1
	if( gabby ) write(*,*) 'NLR', lam, n, ' S/N', snr, f, ' OK'

* move flux from avg to nlr spectrum
      do i = i1, i2
	add = max( 0., avg_w( i ) - fit_w( i ) )
	add = add * f
	elr_w( i ) = elr_w( i ) + add
	avg_w( i ) = avg_w( i ) - add
      end do
      end if
* report
      if( gabby ) then
      do i = i1, i2
	write(*,*) i, nint( w_w(i) ), avg_w(i), fit_w(i), plot3(i), plot4(i)
      end do
      end if
* go look for the next window
	lowi1 = i2 + 1
	goto 777

* next i2
      end if
      end do

* next i1
      end if
      end do
	if( gabby ) write(*,*) 'NLR windows', nlrwin, ' kept', keep, ' S/N >', snrmin

      END IF

	call avgrms( nw, elr_w, avgnlrw, rmsnlrw )
	call mnmx  ( nw, elr_w, elrwmn,  elrwmx )

      if( gabby ) then
	write(*,*) 'elr_w avg', avgnlrw, ' rms', rmsnlrw
	write(*,*) 'elr_w min', elrwmn, ' max', elrwmx

* KDH : DEBUG PLOT 1 - looks OK
  776 IF( .FALSE. ) THEN
	call pgstart( 1, 1, notused )
	call pgbgw
      do i = 1, nw
	plot8( i ) = avg_w( i ) + elr_w( i )
      end do 
	xmn = w_w(1)
	xmx = w_w(nw)
	call mnmx( nw, avg_w, ymn, ymx )
	call mnmx( nw, plot8, dmn, dmx )
	ymn = min( ymn, dmn, elrwmn, 0. )
	ymx = max( ymx, dmx, elrwmx, 0. )
	ymx = 1.05 * ymx
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pglabel( 'rest lam', 'flux', 'debug plot 1' )
	call pgsci( kred )
	call pgbin( nw, w_w, plot8, .true. )
	call pgsci( kblack )
	call pgbin( nw, w_w, avg_w, .true. )
	call pgsci( korange )
	call pgbin( nw, w_w, elr_w, .true. )
	call pgsci( kblue )
	call pgbin( nw, w_w, fit_w, .true. )
	call pgsci( kblack )
	call pgstop
	if( pgagain() ) goto 776
      END IF

      end if
c      end if


* Continuum fit to AVG spectrum =========================

  230	npoly = 0
	nspline = max( 1, nint( vtot / ( 5. * vblr ) ) )
* KDH : TRY A STIFFER SPLINE
c	splines = vtot / ( 10. * vblr )
* KDH : TRY 1 SPLINE PER 3 VBLR
	splines = vtot / ( 3. * vblr )
* KDH : 2018-Mar-02 TRY 1 SPLINE PER 5 VBLR
	splines = vtot / ( 5. * vblr )

* KDH : 2021-04-19 TRY JUST 1 SPLINE
c	splines = 1
* KDH : or 2 ?
c	splines = 2

	nspline = max( 1, nint( splines ) )
* use polynomial instead
	if( splines .lt. 1 ) npoly = max( 2, nsplines )
	nfitcont = max( nspline, npoly )

* report
      if( gabby ) then
	write(*,*)
	if( npoly .le. 0 ) write(*,*) 'Fit AVG continuum with splfit(', nspline, ' ).'
	if( npoly .gt. 0 ) write(*,*) 'Fit AVG continuum with polyfit(', npoly, ' ).'
      end if

* error bars for continuum fit
	ng = 0
      do i=1,nw
	sig = sigavg_w( i )

	mask = masknlr( i )
	mask = mask .or. maskdim( i )
	mask = mask .or. maskbad( i )
* KDH 2019 MAY : USE MASKABSN
* KDH 2019 Aug : USE MASKBAL
	mask = mask .or. maskabsn( i ) .or. maskbal( i )
* KDH : TRY NOT MASKING BLR WINDOWS TO PREVENT NEGATIVE BLR FLUX
* KDH : THAT WASN'T ADEQUATE (WITH -10,+3 SIGMA CLIP)
	mask = mask .or. maskblr( i )
	if( mask ) sig = - abs( sig )
* stow
	cfitsig_w( i ) = sig
	if( sig .gt. 0. ) ng = ng + 1
      end do
* report
      if( gabby ) then
	pct = ( nw - ng ) * 100. / nw 
	write(*,*) 'masked line pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if

*-----------------------------------------------------------
* KDH : SOFT BLR WINDOWS -- CODE REPEATED ELSEWHERE
* KDH : THIS IGNORES THE ELABORATE MASK ABOVE.
	nl = lastbroad
      do i = 1, nw
	mask_w( i ) = masknlr( i )
     &		.or. maskabsn( i )
     &		.or. maskbal( i )
* 2023 Feb 21 KDH: TRY MASKING BALMER CONTINUUM (NEEDED FOR RM160)
     &		.or. maskbac( i )
      end do
	call softblr( nw, w_w, wgt_w, avg_w, sig_w, mask_w,
     &		nl, expand_l, iw1_l, iw2_l )

* 2021-04-18 KDH
* reduce weight for Ly alpha forest and continuum
* KDH - factor could be redshift-dependent
      do i = 1, nw
	w = w_w( i )
	wgt = wgt_w( i )
	if( w .lt. rest_l( line_lya ) ) wgt = wgt * 0.1
	if( w .lt. wlyc2 ) wgt = wgt * 0.1
	wgt_w( i ) = wgt
      end do

* stow for later plots
      do i = 1, nw
	avgwgt_w( i ) = wgt_w( i )
	cfitsig_w( i ) = sig_w( i )
      end do

* pixel count
	p = 0.
      do i = 1, nw
      if( sig_w( i ) .gt. 0. ) then
	p = p + wgt_w( i )
      end if
      end do
* report
      if( gabby .or. p .eq. 0. ) then
	call mnmx( nw, wgt_w, wmn, wmx )
	write(*,*) 'Continuum pixel weights', wmn, wmx
	pct = ( nw - p ) * 100. / nw 
	write(*,*) 'soft BLR pixels:', nint(nw-p), ' of', nw, ' =', pct, ' %'
      end if

* spline tower ----------------------------------------------------
* spline tower decomposition of AVG spectrum 
	nlev = 1
c	nlev = 2
      if( fulltower ) then
	nlev = nint( 1 + alog( nw / 3. ) / alog( 2. ) )
	nlev = min( nlev, maxlev )
      end if

* sigma-clip
	ncycle = 20
c	thrhi = +10.
c	thrlo = -10.
	thrhi = +2.
	thrlo = -5.
* 2021-04-19 KDH - try more agressive sigma clip
	thrlo = -2.
* report
      if( .TRUE. .or. gabby ) then
	write(*,*) 'Spline tower decomposition of AVG spectrum.'
	write(*,*) 'Top level', nlev, ' of max', maxlev, ' splines', 2**(nlev-1)
	write(*,*) 'Clip lo', thrlo, ' hi', thrhi
      end if
* KDH : START AT TOP AND EVOLVE THE MASK ?
	k = 1
      do n = 1, nlev
	call peqp( nw, sig_w, cfitsig_w )
	call splfita( nw, w_w, avg_w, sig_w, fitavg_wn(1,n),
     &		k, ncycle, thrhi, thrlo, ifail )
	k = 2 ** n
      end do

* ----------------------------------------------------
* fit continuum + Fe2 to avg spectrum

* KDH : SHOULD MAKE THIS FE2 TWEAK A SUBROUTINE

c	call fe2fit( )
c	subroutine fe2fit( nw, w8_w, avgfe2_w, avg_w, sigavg_w, w_w, 
c    &	fe2uv, fe2opt, fe2kms, fe2ang, 
c    &	fe2converged, gabby )
c	call fe2spec( nw, w8_w, avgfe2_w, fe2uv, fe2opt, fe2kms, fe2ang )

* 2020-Mar-18 - skip FeII tweak
      if( fe2uv .ne. 0. .or. fe2opt .ne. 0. ) then

      if( gabby .or. .true. ) then
	kmsfe2 = nint( fe2kms )
	kmsfe2sig = nint( sigfe2kms )
	write(*,*) '========== FeII',
     &		kmsfe2, ' +/-', kmsfe2sig, ' km/s',
     &		' ======', ' Iter', nits
      end if

* gabby fe2
	igabfe2 = 0
	if( gabby ) igabfe2 = 1
* KDH : SET GABBY TRUE FOR TESTING
c	gabby = .true.

* fe2 spectrum
	call fe2spec( nw, w8_w, avgfe2_w, fe2uv, fe2opt, fe2kms, fe2ang )
	call mnmx( nw, avgfe2_w, fe2mn, fe2mx )
* report
      if( gabby ) then
	write(*,*) 'Fe2 scl', fe2scl, ' uv', fe2uv, ' opt', fe2opt
	write(*,*) 'Fe2 kms', nint(fe2kms), ' A', fe2ang
	write(*,*) 'Fe2 template range', fe2mn, fe2mx 
      end if

* pixel count
	i1 = 0
	i2 = -1
      do i = 1, nw
	ic = nw - i + 1
	if( i1 .le. 0 .and. avgfe2_w( i ) .gt. 0. ) i1 = i
	if( i2 .le. 0 .and. avgfe2_w( ic) .gt. 0. ) i2 = ic
      end do
	npixfe2 = i2 - i1 + 1
* report
      if( gabby ) then
	write(*,*) 'Fe2 pixels', npixfe2, i1, i2
      if( i1 .ge. 1 .and. i2 .ge. i1 ) then
	write(*,*) 'Fe2 waves', nint( w_w(i1) ), nint( w_w(i2) )
      end if
      end if

* max fe2 scale factor
	call optscl( nw, avg_w, sigavg_w, avgfe2_w, x, s )
	x = max( 0., x )
	fe2sclmx = fe2scl * x

* default to max/10
      if( x .gt. 0. .and. x .lt. 1. ) then
	old = fe2scl
	fe2scl = fe2sclmx / 10.
	fe2uv = fe2scl
	fe2opt = fe2scl
	call fe2spec( nw, w8_w, avgfe2_w, fe2uv, fe2opt, fe2kms, fe2ang )
      end if
* report
      if( gabby ) then
	write(*,*) 'Fe2 scl =>', fe2scl, ' max', fe2sclmx
      end if

* velocity dispersion loop
	NLOOPV = 3
      DO LOOPV = 1, NLOOPV

* diagnostic plot
  234	plots = npixfe2 .gt. 0
	plots = plots .and. gabby

* fe2 scale loop
	nloopfe2 = 4
	if( loopv .eq. 1 ) nloopfe2 = 7
	if( npixfe2 .lt. 1 ) nloopfe2 = 1
	fe2converged = .false.
	lastplot = .false.
      DO LOOPfe2 = 1, NLOOPfe2
      if( .not. fe2converged .or. lastplot ) then

* last plot only
	plots = gabby .and. lastplot

* format
      if( plots ) then
	nx = 1
	ny = 2
	if( ngridv .gt. 1 ) ny = 3
* open
	call pgstart( nx, ny, notused )
	call pgbgw
	csize = csizedef
	call pgsch( csize )
* window
	xmn = w_w( i1 )
	xmx = w_w( i2 )
	call mnmx( nw, avg_w, ymn, ymx )
	call medmad( nw, avg_w, amed, amad )
	ymn = min( ymn, 0. )
	ymx = min( ymx, 2. * amed )
	ymn = ymn - 0.05 * ( ymx - ymn )
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
* labels
	xlabel = 'Rest \gl (\A)'
	ylabel = 'flux'
	title = 'Fe2 + Continuum Fit'
	call pglabel( xlabel, ylabel, title )
* avg 
	call pgbin( nw, w_w, avg_w, .true. )
* +/- cont fit error bars
	call pgsci( kyellow )
	call peqpmc( nw, sig_w, cfitsig_w, -1. )
	call pgbin( nw, w_w, cfitsig_w, .true. )
	call pgbin( nw, w_w, sig_w, .true. )
* +/- error bars
	call pgsci( kred )
	call peqpmc( nw, sig_w, sigavg_w, -1. )
	call pgbin( nw, w_w, sigavg_w, .true. )
	call pgbin( nw, w_w, sig_w, .true. )
	call pgsci( kblack )	
      end if

* fit continuum to ( avg - fe2 )
* fe2 grid
      if( loopfe2 .eq. 1 ) then
	ngrid = 0
	dlnscl = 0.05
      end if
	ngrid1 = ngrid + 1
	npow = 0
	if( npixfe2 .gt. 0 ) npow = 2
	if( plots ) npow = 2
	kmax = 2 * npow + 1
      do ipow = -npow, npow
* scan index k = 1, kmax
	k = ipow + npow + 1
* scaled fe2
c	scl = ( 1. + dlnscl ) ** ipow
	scl = exp( ipow * dlnscl )
      do i = 1, nw
	f = avgfe2_w( i ) * scl
	dat_w( i ) = avg_w( i ) - f
	sig_w( i ) = cfitsig_w( i )
	fe2_w( i ) = f
      end do

* sigma-clip
	ncycle = 10
	thrhi = 2.
	thrlo = -10.
* stow
	npoly_avg = npoly
	nspline_avg = nspline

* 2021-04-19 KDH - try a stiffer continuum fit
c	nspline_avg = 2
c	thrlo = -2

* report
      if( gabby ) then
	write(*,*) 'Npoly', npoly, ' Nspline', nspline
	write(*,*) 'reject cycles', ncycle, ' clip', thrlo, thrhi, ' sigma.'
      end if
* poly fit continuum for AVG spectrum
      if( npoly .gt. 0 ) then
      if( autofit ) then
	call polyfita( nw, w_w, dat_w, sig_w, fit_w,
     &		npoly, ncycle, thrhi, thrlo, ifail )
      else
	call polyfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if
* spline fit continuum for AVG spectrum 
      else
* KDH : COULD TRY FITTING THIS WITH SLOPE = 0 ON THE ENDS.
      if( autofit ) then
	call splfita( nw, w_w, dat_w, sig_w, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
      else
	call splfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if
      end if

* did the fit change sig_w ?
	big = 0.
	n = 0
      do i = 1, nw
	dif = sig_w( i ) - cfitsig_w( i )
	if( abs( diff ) .gt. big ) n = n + 1
	big = max( big, abs( diff ) )
      end do
      if( big .gt. 0. ) then
	write(*,*) '** WARNING: FIT CHANGED', n, ' ERROR BARS BY UP TO', big
      end if

* residuals
      do i = 1, nw
	cont_w( i ) = fit_w( i )
	fit_w( i ) = fe2_w( i ) + cont_w( i )
	dif_w( i ) = avg_w( i ) - fit_w( i )
      end do
* cumulative chi2
	n = 0
	sum = 0.d0
      do i = 1, nw
	s = cfitsig_w( i )
      if( s .gt. 0. ) then
	x = dif_w( i ) / s
	n = n + 1
	sum = sum + x * x
      end if
	cdf_w( i ) = sum
      end do

* normalise cumulative
      do i = 1, nw
	cdf_w( i ) = cdf_w( i ) / cdf_w( nw )
      end do
* KDH : IS X2 DOUBLE?
	x2 = sum
	if( gabby ) write(*,*) ipow, scl, ' Chi2', x2

* stow 
	ngrid = ngrid + 1

      if( ngrid .gt. maxgrid ) then
	write(*,*) '** WARNING: FE2 GRID OVERFLOW', ngrid
	ngrid = maxgrid
      end if

	fe2kms_k( ngrid ) = fe2kms
	fe2scl_k( ngrid ) = fe2scl * scl
	fe2bof_k( ngrid ) = x2

	bof8_k( ngrid ) = sum
c	fe2bof8_k( ngrid ) = sum

* best in current scan
* KDH : DO THIS AT END OF LOOP?
	if( k .eq. 1 ) kbest = k
	ibest = ngrid1 + kbest - 1
	if( bof8_k( ngrid ) .le. bof8_k( ibest ) ) kbest = k

* best in full grid
	if( ngrid .eq. 1 ) nbest = 1
	if( bof8_k( ngrid ) .le. bof8_k( nbest ) ) nbest = ngrid

* stow best fit continuum
	if( ngrid .eq. nbest ) call peqp( nw, avgcont_w, cont_w )

      if( plots ) then
* avg-fit
	call pgsci( kdkgrey )
	call pgbin( nw, w_w, dif_w, .true. )
* fe2+cont
	call pgsci( kblue )
	call mnmx( nw, fit_w, fmn, fmx )
	write(*,*) 'Fit (fe2+cont) range', fmn, fmx
	call pgline( nw, w_w, fit_w, .true. )
* continuum
	call pgsci( kred )
	call pgline( nw, w_w, cont_w )
* fe2
	call pgsci( kltblue )
	call pgline( nw, w_w, fe2_w )
* cumulative chi2
	call pgsci( korange )
	call pgswin( xmn, xmx, 0., 1. )
	call pgbin( nw, w_w, cdf_w, .true. )
	call pgswin( xmn, xmx, ymn, ymx )
	call pgsci( kblack )
      end if
* next scan point k = 1 + ipow + npow
      end do

* best fe2 scale factor from tail
	scl = fe2scl_k( ibest ) / fe2scl
	bofmin = bof8_k( ibest )
	if( gabby ) write(*,*) 'best in tail ', i, scl, bofmin

* delta chi2
* 2021-04-20 KDH : avoid precision loss.
c	call peqpac( ngrid, dbof_k, fe2bof_k, -bofmin )
      do i = 1, ngrid
c	dbof_k( i ) = fe2bof8_k( i ) - bof8_k( ibest )
	dbof_k( i ) = bof8_k( i ) - bof8_k( ibest )
      end do

* KDH : FINISH TOP PANEL
* label best reduced chi2
      if( plots ) then
	label = ' '
	call append_chi2dof( label, bofmin, nw, 4 )
	call pgmtxt( 'T', 0.5, 0.99, 1.0, label )
* label velocity dispersion range
	label = ' '
	call append_sigv( label, ngrid, fe2kms_k )

	call pgmtxt( 'T', 0.5, 0.01, 0.0, label )
      end if

* grid tail
	k = 0
      do i = ngrid1, ngrid
	k = k + 1
	plot1( k ) = fe2scl_k( i )
	plot2( k ) = dbof_k( i )
      end do
	ntail = k
* full grid sorted
	call quicksort( ngrid, fe2scl_k, irank_k )
	if( gabby ) write(*,*) 'Chi2min', bofmin, ' on grid.'
      do ir = 1, ngrid
	i = irank_k( ir )
	plot3( ir ) = fe2scl_k( i )
	plot4( ir ) = dbof_k( i )
      end do

* rescale dbof to bofmin/Nw = 1
	bofdiv = 1.
      if( bofmin .gt. 0. ) then
	bofdiv = bofmin / nw
	if( gabby ) write(*,*) 'Best BoF', bofmin, ' /', nw, ' =', bofdiv
	call peqpmc( ntail, plot2, plot2, 1./bofdiv )
	call peqpmc( ngrid, plot4, plot4, 1./bofdiv )
      end if

* window for plot (and fit)
	call mnmx( ntail, plot1, xmn, xmx )
	call mnmx( ntail, plot2, ymn, ymx )
* change to full range
	call mnmx( ngrid, plot3, xmn, xmx )
	call mnmx( ngrid, plot4, ymn, ymx )

	if( gabby ) write(*,*) xmn, xmx, ymn, ymx
	add = ( xmx - xmn ) * 0.5
	xmn = xmn - add
	xmx = xmx + add
	xmn = max( 0., xmn )
	add = ( ymx - ymn ) * 0.05
	add = max( add, 0.01 )
	ymn = ymn - add
	ymx = ymx + add
* fit parabola to points in window
* KDH : FIT TO ALL POINTS, WITH DOWN-WEIGHT FOR HIGH ONES?
	n = 0
      do i = 1, ngrid
	x = plot3( i )
	y = plot4( i )
	wgt = -1.
      if( x .ge. xmn .and. x .le. xmx
     &	.and. y .ge. ymn .and. y .le. ymx ) then
	n = n + 1
	wgt = 1.
      end if
	plot5( i ) = wgt
      end do
	ndfit = n
	npfit = min( n, 3 )
	if( gabby ) write(*,*) 'Nfit', n, ' Npoly', npfit
	call polyfit1( ngrid, plot3, plot4, plot5, plot6, npfit, ifail )
      if( ifail .ne. 0 ) then
	write(*,*) '** POLYFIT FAILED.'
	write(*,*) 'x', (plot3(i),i=1,n)
	write(*,*) 'y', (plot4(i),i=1,n)
	write(*,*) 'w', (plot5(i),i=1,n)
      end if
      if( ifail .eq. 0 ) then

* rms and mad residuals
	ng = 0
	sum = 0.d0
	sum1 = 0.d0
      do i = 1, n
      if( plot5( i ) .gt. 0. ) then
	x = plot4( i ) - plot6( i )
	sum = sum + x * x
	sum1 = sum1 + abs( x )
	ng = ng + 1
      end if
      end do
	fitrms = dsqrt( sum / max( 1, ng ) )
	fitmad = sum1 / max( 1, ng )
	call mnmx( n, plot6, fitmn, fitmx )
	fitspan = fitmx - fitmn
      if( gabby ) then
	write(*,*) 'dBoF range', fitmn, fitmx, ' span', fitspan
	write(*,*) 'RMS', fitrms, ' rms/span', fitrms / fitspan
     &	, ' want <', rms_over_span_max
      end if

* evaluate poly on finer grid even spacing
	n = 100
	nfine = n
      do i = 1, n
	p = (i-1.)/max(1,n-1)
	x = xmn * (1.-p) + p * xmx
	plot7(i) = x
      end do
	call polycalc( n, plot7, plot8, ifail )
      if( ifail .ne. 0 ) then
	write(*,*) '** POLYCALC failed', ifail
      else
* min chi2
	i = minpos( n, plot8 )
* interior min chi2
      if( i .gt. 1 .and. i .lt. n ) then
	x = plot7( i )
	y = plot8( i )
* parabola
	ip = i + 1
	im = i - 1
	xp = plot7( ip )
	xm = plot7( im )
	dx = ( xp - xm ) / 2.
	yp = plot8( ip )
	ym = plot8( im )
	b = ( yp - ym ) / 2.
	c = ( yp - y ) - ( y - ym )
* min y0 and x0 +/- s0
	di = - b / ( c + c )
	x0 = x - dx * di
	s0 = dx * sqrt( 2. / c )
	y0 = y + di * ( b + di * c )
	y = y0 + 1.

c	bofred = ( bofmin * y0 + nw ) / nw
	bofred = ( bofmin + y0 ) / nw
      if( gabby .or. bofred .le. 0. ) then
c	write(*,*) 'Poly[dChi2(scl)]', bofred * y0, ' Npoly', npfit, ' Nfit', ndfit
	write(*,*) 'Poly[dChi2(scl)]', y0, ' Npoly', npfit, ' Nfit', ndfit
	write(*,*) 'Chi2min', bofmin, ' dChi2', y0, ' nw', nw, ' Chi^2/Nw', bofred
	if( bofred .le. 0. ) write(*,*) '** WARNING: CHI2 POLYFIT MIN < 0'

	if( bofred .le. 0. ) write(*,*) '** WARNING: CHI2 POLYFIT MIN < 0'
      end if

      end if
      end if
      end if
	if( ifail .ne. 0 ) s0 = -1.

* KDH : PANEL 2
      if( plots ) then
* extend plot window to include minimum
	if( s0 .gt. 0. ) ymn = min( ymn, y0 )
* KDH : omit very high points ?

	logx = 0
	logy = 0
	logxy = 10 * logx + 20 * logy
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, logxy, ' )'
	call pgenv( xmn, xmx, ymn, ymx, 0, logxy )
	call pgmove( 0., ymn )
	call pgdraw( 0., ymx )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
* labels
	title = 'Fe2 Scale Factor \gx\u2\d Diagnosis'
	xlabel = 'Fe2 scale factor'
	ylabel = '\gD\gx\u2\d /'
	call append_n( ylabel, bofdiv, 4 )
	call pglabel( xlabel, ylabel, title )

* agn name
	call pgmtxt( 'T', -1.5, 0.05, 0., agn )

* full grid
	call pgsci( kdkgrey )
	call pgline( ngrid, plot3, plot4 )
	call pgpt( ngrid, plot3, plot4, 20 )
* full grid best
	i = minpos( ngrid, plot4 )
	x = plot3( i )
	y = plot4( i )
	call pgpt( 1, x, y, kstar )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
* tail 
	call pgsci( kblue )
	call pgline( ntail, plot1, plot2 )
	call pgpt( ntail, plot1, plot2, 23 )
* best
	call pgsci( kgreen )
	x = plot1( kbest )
	y = plot2( kbest )
	call pgsch( csize * 2. )
	call pgpt( 1, x, y, kstar )
	call pgsch( csize )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )

* parabola
	call pgsci( kyellow )
	call pgline( ngrid, plot3, plot6 )
	call pgsci( kred )
	call pgline( nfine, plot7, plot8 )
* 1-sigma interval
      if( s0 .gt. 0. ) then
      do i = -1, 1
	x = x0 + i * s0
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do
* error bar
	call pgsci( kblack )
	y = y0 + 1.
	call pgerrb( 5, 1, x0, y, s0, 1. )
	call pgsch( csize * 2. )
	call pgpt( 1, x0, y, kstar )
	call pgsch( csize )
      end if
* label fit rms
      if( fitrms .ge. 0 ) then
	label = 'RMS'
	call append_n( label, fitrms, 3 )
	call pgsci( kblack )
	call pgmtxt( 't', -1.5, 0.95, 1.0, label )
      end if
* label fit rms
      if( fitrms .ge. 0 ) then
	label = 'MAD'
	call append_n( label, fitmad, 3 )
	call pgsci( kblack )
	call pgmtxt( 't', -3.0, 0.95, 1.0, label )
      end if

* labels
	call pgsci( kblack )
* best reduced chi2
	label = ' '
	call append_chi2dof( label, bofmin, nw, 4 )
	call pgmtxt( 'T', 0.5, 0.99, 1.0, label )
* velocity dispersion
	label = ' '
	call append_sigv( label, ngrid, fe2kms_k )
	call pgmtxt( 'T', 0.5, 0.01, 0.0, label )
* best fit parameter and error bar
      if( s0 .gt. 0. ) then
	label = ' '
	call append_datsig( label, x0, s0, 2 )
	call pgsci( kblack )
	call pgmtxt( 'T', 0.5, 0.5, 0.5, label )
      end if
      end if

* KDH : PANEL 3
* bof vs velocity dispersion
      if( ngridv .gt. 1 ) then
      if( plots ) then

	n = ngridv
	call peqp( n, plot0, vdisp_v )

	logx = 0
	logy = 0
      if( logx .ne. 0 ) then
      do i = 1, n
	plot0( i ) = alog10( plot0( i ) )
      end do
      end if

* window
	call mnmx( n, plot0, xmn, xmx )
	call mnmx( n, dbof_v, ymn, ymx )
* x range
	x = fe2kms
	if( logx .ne. 0 ) x = alog10( x )
	xmn = min( xmn, x )
	xmx = max( xmx, x )

	add = ( xmx - xmn ) * 0.3
	xmn = xmn - add
	xmx = xmx + add
      if( logx .eq. 0 ) then
	xmn = max( xmn, 0. )
      end if

* y range
* KDH : OMIT VERY HIGH POINTS?
	if( sigvfit .gt. 0. ) ymn = min( ymn, bofvfit )
	ymn = min( ymn, 0. )
	add = ( ymx - ymn ) * 0.05
	ymn = ymn - add
	ymx = ymx + add


	logxy = logx * 10 + logy * 20
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, logxy, ' )'
	call pgenv( xmn, xmx, ymn, ymx, 0, logxy )
* vertical
      if( logx .ne. 0 ) then
	call pgmove( 0., ymn )
	call pgdraw( 0., ymx )
      end if
* horizontal
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
* labels
	xlabel = 'Fe2 Dispersion (km/s)'
	ylabel = '\gD\gx\u2\d /'
	call append_n( ylabel, chi2div, 4 )
	title = 'Fe2 Velocity Dispersion \gx\u2\d Diagnosis'
	call pglabel( xlabel, ylabel, title )

* agn name
	call pgmtxt( 'T', -1.5, 0.05, 0., agn )

* best reduced chi2
	label = ' '
	call append_chi2dof( label, bofmin, nw, 4 )
	call pgmtxt( 'T', 0.5, 0.99, 1.0, label )
* velocity dispersion range
	label = ' '
	call append_sigv( label, ngridv, fe2kms_v )
* velocity dispersion prior
      if( fe2kmsprior .gt. 0. ) then
	i = index( label, 'km/s' )
	if( i .gt. 1 ) label = label(:i-1)
	call append( label, 'prior' )
	call append_i( label, nint( fe2kmsprior ) )
	call append( label, 'km/s' )
      end if

	call pgmtxt( 'T', 0.5, 0.01, 0.0, label )

* prior
	call pgsci( korange )
	call pgline( n, plot0, prior_v )

* polyfit
	call pgsci( kyellow )
	call pgline( n, plot0, fit_v )

* dchi2 curve
	call pgsci( kdkgrey )
	n = ngridv
	call pgline( n, plot0, dchi2_v )	
c	call pgpt( n, plot0, dchi2_v, 23 )
* scale point size with weight
      do i = 1, n
	call pgsch( csize * 1.5 * wgt_v(i) )
	call pgpt( 1, plot0(i), dchi2_v(i), 23 )
      end do
	call pgsch( csize )


* KDH : DEBUG REPORT
	call mnmx( n, vdisp_v, vmn, vmx )
	write(*,*) 'Dispersion grid', n, vmn, vmx

      do i = 0, n
      if( i .gt. 1 ) then
	title = ' '
	call append_i( title, i )
	call append_f( title, vdisp_v( i ), '*' )
	call append_f( title, fe2scl_v( i ), '*' )
	call append_f( title, real(chi2_v( i )), '*' )
	call append_f( title, prior_v( i ), '*' )
	call append_f( title, dbof_v( i ), '*' )
	call append_f( title, fit_v( i ), '*' )
	call append_f( title, wgt_v( i ), '*' )
	write(*,*) title( :len1( title ) )
      end if
      if( mod( i, 10 ) .eq. 0 .or. i .eq. n ) then
	write(*,*) 'rank'
     &		, '  kms   '
     &		, '    scl   '
     &		, '    Chi2  '
     &		, '    Prior '
     &		, '    dBoF  '
     &		, '    Fit   '
     &		, '    Wgt   '
      end if
      end do
	
* dbof curve
	call pgsci( kblue )
	n = ngridv
	call pgline( n, plot0, dbof_v )	
* scale point size with weight
      do i = 1, n
	call pgsch( csize * 1.5 * wgt_v(i) )
	call pgpt( 1, plot0(i), dbof_v(i), 23 )
      end do
	call pgsch( csize )

* best on grid
	i = minpos( n, dbof_v )
	x = vdisp_v( i )
	y = dbof_v( i )
	call pgsci( kgreen )
	call pgsch( csize * 2. )
	call pgpt( 1, plot0( i ), dbof_v( i ), kstar )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgsch( csize )

* current velocity dispersion and error bar
	v = fe2kms
	dv = sigfe2kms
	if( dv .lt. 0. ) dv = 0.
	call pgsci( kdkgrey )
      do i = -1, 1
	x = v + i * dv
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do

* plot current best in scale factor grid
	i = minpos( ngrid, plot4 )
	call pgpt( 1, x, dbof_k, 23 )

* best fit parameter and error bar
	dat = fe2kms
	sig = sigfe2kms
      if( sigvfit .gt. 0. ) then
	dat = vfit
	sig = sigvfit
      end if
      if( sig .gt. 0. ) then
	label = ' '
	call append_datsig( label, dat, sig, 2 )
	call pgsci( kblack )
	call pgmtxt( 'T', 0.5, 0.5, 0.5, label )
	call pgsci( kred )
      do i = -1, 1
	x = dat + sig * i
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do
      end if

* parabola
      if( sigvfit .gt. 0. ) then
	y0 = bofvfit
	x0 = vfit
	s0 = sigvfit
	write(*,*) 'Polyfit Vdisp', vfit, ' +/-', sigvfit, ' km/s'
	n = 100
	call pgsci( kred )
      do i=1,n
	p = (i-1.)/max(1,n-1)
	x = xmn * ( 1.-p ) + p * xmx
	y = y0 + ( ( x - x0 ) / s0 )**2
	if( i .eq. 1 ) call pgmove( x, y )
	call pgdraw( x, y )
      end do
* best fit and error bar
      do i = -1, 1
	x = x0 + s0 * i
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do
	y = y0 + 1.
	call pgsci( kblack )
	call pgsch( csize * 2. )
	call pgerrb( 5, 1, x0, y, s0, 1. )
	call pgsch( csize )
	call pgpt( 1, x0, y, kstar )
      end if

* fit rms
	label = 'RMS'
	call append_n( label, fitrmsv, 3 )
	call pgsci( kblack )
	call pgmtxt( 't', -1.5, 0.95, 1.0, label )
* fit mad
	label = 'MAD'
	call append_n( label, fitmadv, 3 )
	call pgsci( kblack )
	call pgmtxt( 't', -3.0, 0.95, 1.0, label )

      end if
      end if

* close 
      if( plots ) then
	call pgstop
* repeat
	if( pgagain() ) goto 234
      end if

* revise Fe2 scale factors
	fe2uv = fe2uv * scl
	fe2opt = fe2opt * scl
	fe2scl = fe2scl * scl
* revise Fe2 and continuum spectra
      do i = 1, nw
	f = avgfe2_w( i ) * scl
	c = avgcont_w( i )
	avgfe2_w( i ) = f
	dat_w( i ) = f / c
      end do
* stats
	call mnmx( nw, avgfe2_w, f2mn, f2mx )
	call mnmx( nw, avgcont_w, cmn, cmx )
	call mnmx( nw, dat_w, rmn, rmx )
	fe2pct = 100.*rmx
* report
      if( gabby ) then
	write(*,*) 'Fe2 uv', fe2uv, ' opt', fe2opt
	write(*,*) 'Fe2  mn,mx', f2mn, f2mx 
	write(*,*) 'cont mn,mx', cmn, cmx 
	write(*,*) 'Fe2/cont ', 100.*rmn, fe2pct, ' %'
      end if

* Chi2
	n = 0
	sum = 0.d0
      do i = 1, nw
	sig = cfitsig_w( i )
      if( sig .gt. 0. ) then
	fit = avgcont_w( i ) + avgfe2_w( i )
	dif = avg_w( i ) - fit
	x = dif / sig
	n = n + 1
	sum = sum + x * x
      end if
      end do
	if( loopfe2 .eq. 1 ) fe2bof = 0.
	fe2bofold = fe2bof
	fe2bof = sum
	fe2dbof = fe2bof - fe2bofold
	fe2bofred = fe2bof / max( 1, n )

* report
	title = 'Fe2 loop'
	call append_i( title, loopfe2 )
	call append( title, 'Fe2/cont' )
	call append_n( title, 100.*rmx, 4 )
	call append( title, '% Chi2 /' )
	call append_i( title, n )
	call append( title, '=' )
	call append_n( title, real(fe2bofred), 4 )
	call append( title, 'dChi2' )
	call append_f( title, real(fe2dbof), '*' )
	if( fe2dbof .gt. 0. ) call append( title, ':(((.' )

	if( gabby ) write(*,*) title(:len1(title))
	if( gabby ) write(*,*) '-----------------------------------------'

* convergence test
c	call mnmx( k, plot2, ymn, ymx )
	call mnmx( k, dbof_k(ngrid1), ymn, ymx )

	tiny = 1.e-3
	fe2converged = abs( fe2dbof ) .le. tiny
	fe2converged = fe2converged .and. dlnscl .le. tiny
c	fe2converged = fe2converged .and. ymx .le. ymn + tiny
	if( fe2converged ) write(*,*) 'Fe2 fit converged. :)))))'
	lastplot = fe2converged .or. loopfe2 .eq. nloopfe2 - 1

* KDH : MODIFY TO AVOID OVERLAPS?
* expand/shrink dlnscl
c	rms_over_span_max = 0.1
	x = 1.5
	b = dlnscl
* expand
      if( kbest .eq. 1 .or. kbest .eq. kmax 
     &	.or. fitrms .gt. rms_over_span_max * fitspan ) then
	dlnscl =  b * x
	if( gabby ) write(*,*) 'Expand dlnscl', b, ' *', x, ' =>', dlnscl
* shrink
      else
	dlnscl = dlnscl / x
	if( gabby ) write(*,*) 'Shrink dlnscl', b, ' /', x, ' =>', dlnscl
      end if

* next LOOPfe2
      end if
      END DO

	kbest = minpos( ngrid, bof8_k )
	bofbest = bof8_k( kbest )

* DEBUG CHECK
      if( ngrid .le. 0 .or. bofbest .le. 0. ) then
	write(*,*) '** PANIC : Best Chi^2( scl )', bofbest, ngrid
      do i=1,ngrid
	write(*,*) i, ' scl', fe2scl_k( i ), ' bof', bof8_k(i)
      end do
	write(*,*) 'OK to proceed?'
	read(*,*)
	stop
      end if

* stow results in unsorted velocity grid
	ngridv = ngridv + 1
      if( ngridv .gt. maxgrid ) then
	write(*,*) '** WARNING: VELOCITY DISPERSION GRID OVERFLOW', ngridv
	ngridv = maxgrid
* KDH : COULD DO SOMETHING MORE SENSIBLE HERE
      end if
	n = ngridv
	fe2kms_v( n )  = fe2kms
	fe2scl_v( n )  = fe2scl_k( kbest )
	fe2chi2_v( n ) = bof8_k( kbest )
* note : bof8_k is just chi^2
* stow results in sorted velocity grid
	call quicksort( n, fe2kms_v, irank_k )
      do ir = 1, n
	i = irank_k( ir )
	vdisp_v( ir ) = fe2kms_v( i )
	scl_v( ir )   = fe2scl_v( i )
	chi2_v( ir )  = fe2chi2_v( i )
      end do

* -2ln(Prior) 
	fe2kmsprior = max( fe2kmsprior_min , abs( vnlr ) / 4. )
* KDH : KEEP AT 100 FOR TESTING
c	fe2kmsprior = fe2kmsprior_min
* KDH : CALCULATE AND STOW PRIOR WHEN VDISP IS CHANGED, NOT HERE
      do i = 1, n
	v = vdisp_v( i )
	x = v / fe2kmsprior
	prior_v( i ) = x * x
      end do

* rescale to reduced chi2 = 1
	i = minpos( n, chi2_v )
	chi2min = chi2_v( i )
	chi2div = chi2min / nw
	ibest = i
      do i = 1, n
	dchi2 = chi2_v( i ) - chi2_v( ibest )
	if( chi2div .gt. 0. ) dchi2 = dchi2 / chi2div
	dchi2_v( i ) = dchi2
	dbof_v( i ) = dchi2 + prior_v( i )
	wgt_v( i ) = 1.
	sig_v( i ) = 1.
      end do

* fit parabola to bof vs velocity dispersion
	ifail = 1
      if( n .gt. 3 ) then
* taper high points to focus fit near minimum
	call medmad( n, dbof_v, dbmed, dbmad )
	call mnmx( n, dbof_v, dbmn, dbmx )
	if( gabby ) write(*,*) 'dBoF min', dbmn, ' max', dbmx
	if( gabby ) write(*,*) 'dBoF med', dbmed, ' mad', dbofmad
      if( dbmad .gt. 0. ) then
      do i = 1, n
* downweight high bof points
	s = dbmad * 4.
	s = dbmad * 2.
	x = ( dbof_v( i ) - dbmed ) / s
	w = 1.
	if( x .gt. 0. ) w = exp(-0.5 * min( 36., x * x ) )
* sum weights
	if( i .eq. 1 ) g = 0.
	g = g + w
* stow
	wgt_v( i ) = w
	sig_v( i ) = 1. / sqrt( w )
      end do
	if( gabby ) write(*,*) ' Nv =', n, ' =>', g
      end if
      end if

* polyfit to BoF vs vdisp
	good = g
	ndfit = n
	npfit = min( n, 3 )
	if( gabby ) write(*,*) 'Nfit', n, ' Good', good, ' Npoly', npfit
	call polyfit1( n, vdisp_v, dbof_v, sig_v, fit_v, npfit, ifail )
      if( ifail .ne. 0 ) then
	write(*,*) '** POLYFIT FAILED.'
	write(*,*) 'vdisp', (vdisp_v(i),i=1,n)
	write(*,*) 'dbof ', ( dbof_v(i),i=1,n)
	write(*,*) ' wgt ', (  wgt_v(i),i=1,n)
	write(*,*) ' sig ', (  sig_v(i),i=1,n)
      else
* rms and mad residuals
	sum = 0.d0
	sum1 = 0.d0
	nsum = 0
      do i = 1, n
	x = dbof_v( i ) - fit_v( i )
	sum = sum + x * x
	sum1 = sum1 + abs( x )
	nsum = nsum + 1
      end do
	fitrms = dsqrt( sum / max( 1, nsum ) )
	fitmad = sum1 / max( 1, nsum )
	fitrmsv = fitrms
	fitmadv = fitmad
* span
	call mnmx( n, fit_v, fitmn, fitmx )
	fitspan = fitmx - fitmn
	fitspanup = fit_v( n ) - fitmn
	fitspandn = fit_v( 1 ) - fitmn
	
      if( gabby ) then
	write(*,*) 'dBoF range', fitmn, fitmx, ' span', fitspan
	write(*,*) 'RMS', fitrms, ' rms/span', fitrms / fitspan
     &	, ' want <', rms_over_span_max
      end if

* finer grid
	nvdisp = n
	call mnmx( n, vdisp_v, xmn, xmx )

	n = 100
      do i = 1, n
	p = (i-1.)/max(1,n-1)
	x = xmn * (1.-p) + p * xmx
	plot14(i) = x
      end do
* evaluate poly
	call polycalc( n, plot14, plot16, ifail )
      if( ifail .ne. 0 ) then
	write(*,*) '** POLYCALC failed', ifail
      else
* min chi2
	i = minpos( n, plot16 )
	x = plot14( i )
	y = plot16( i )

* report min on grid edge
      if( i .eq. 1 .or. i .eq. n ) then
	write(*,*) '** POLYFIT MIN ON GRID EDGE.', 1, i, n
	write(*,*) '  vdisp', plot14( 1 ), x, plot14( n )
	write(*,*) '    BoF', plot16( 1 ), y, plot16( n )
      end if

* parabola y = a + b x + c x^2
	im = max( i - 1, 1 )
* 2021-04-19 KDH - nudge away from grid edge
* the error bars were coming out very small on edge of grid.
	i = im + 1
	ip = min( i + 1, n )
	i = ip - 1
	im = i - 1
	x = plot14( i )
	y = plot16( i )
	xp = plot14( ip )
	yp = plot16( ip )
	xm = plot14( im )
	ym = plot16( im )
* assume even sampling dx
	dx = ( xp - xm ) / 2.
* slope
	b = ( yp - ym ) / 2.
* curvature
	c = ( yp - y ) - ( y - ym )
* min y0 and x0 +/- s0
	di = - b / ( c + c )
c	x0 = x - dx * di
* 2021-AUG-09 KDH - fix bug ?
	x0 = x + dx * di
	y0 = y + di * ( b + di * c )
* 1-sigma error bar
	s0 = dx * sqrt( abs( 2. / c ) )

      if( im .eq. 1 .or. ip .eq. n .or. c .le. 0. ) then
	write(*,*) 'Parabola fit near BoF min:'
	write(*,*) ' im,xm,ym', im, xm, ym
	write(*,*) ' i ,x ,y ', i, x, y
	write(*,*) ' ip,xp,yp', ip, xp, yp
	write(*,*) ' dx,b,c,di', dx, b, c, di
	write(*,*) ' x0,y0,s0', x0, y0, s0
      end if

* require concave up
      if( c .gt. 0. ) then
	write(*,*) '** FeII dBoF(Vdisp) PARABOLA CONCAVE up :).'

* parabola minimum at negative dispersion
      if( x0 .lt. 0. ) then
	write(*,*) '** FeII dBoF(Vdisp) PARABOLA MIN AT VDisp < 0 :(.'
      end if

      else if( c .lt. 0. ) then
	write(*,*) '** FeII dBoF(Vdisp) PARABOLA CONCAVE down :(.'
	s0 = - s0
      else
	write(*,*) '** FeII dBoF(Vdisp) PARABOLA NO CURVATURE :(.'
	s0 = -1.
      end if

* 1-sigma confidence level
	y = y0 + 1.
* reduced Chi^2
c	bofred = ( bofmin * y0 + nw ) / nw
	bofred = ( bofmin + y0 ) / nw
      if( gabby .or. bofred .le. 0. ) then
c	write(*,*) 'Poly[dBof(vdisp)]', bofmin * y0, ' Npoly', npfit, ' Nfit', ndfit
	write(*,*) 'Poly[dBof(vdisp)]', y0, ' Npoly', npfit, ' Nfit', ndfit
	write(*,*) ' BoFmin', bofmin, '  dBoF ', y0, ' nw', nw, ' BoF/Nw', bofred
	if( bofred .le. 0. ) write(*,*) '** WARNING: CHI2 POLYFIT MIN < 0'
      end if

      end if
      end if

* stow result if not failed
      if( ifail .eq. 0 ) then
	vfit = x0
	sigvfit = s0
	bofvfit = y0
      else
	sigvfit = -1.
      end if

* revise fe2 velocity dispersion 
	vold = fe2kms
* derivative spectrum  dspec/dlnvdisp
	dlnv = 0.05
	vnew = vold * exp( dlnv )
	call fe2spec( nw, w8_w, avgfe2_w, fe2uv, fe2opt, vold, fe2ang )
	call fe2spec( nw, w8_w, davgfe2_w, fe2uv, fe2opt, vnew, fe2ang )
* stow
      do i = 1, nw
	df = davgfe2_w( i ) - avgfe2_w( i )
	pat_w( i ) = df / dlnv
	fit = avgcont_w( i ) + avgfe2_w( i )
	dat_w( i ) = avg_w( i ) - fit
	sig_w( i ) = cfitsig_w( i )
      end do
* scale pattern
	call optscl( nw, dat_w, sig_w, pat_w, scl, sigscl )

	dlnv = dlnv * scl
	sigdlnv = dlnv * sigscl
	f = exp( dlnv )
	df = f * sigdlnv
      if( gabby ) then
	write(*,*) 'ln(fe2kms)', dlnv, ' factor', f, ' +/-', sigdlnv
      end if
* new velocity dispersion
	vold = fe2kms	
	vopt = fe2kms * f
	sigvopt = fe2kms * df
* apply prior
	s = fe2kmsprior / sigvopt
	w = s * s
	v = vopt * w / ( w + 1. )
	sigvopt = sigvopt / sqrt( w + 1. )

* expand grid
	up = vdisp_v(n) / vnew
	dn = vnew / vdisp_v(1)
      if( up .gt. dn ) then
	vmore = vnew / sqrt( up )
      else
	vmore = vnew * sqrt( dn )
      end if
	vmore = min( vmore, abs(vblr)/4. )

* last loop
      if( loopv .ge. nloopv ) then
	why = '?'
* best fit parabola
      if( sigvfit .gt. 0. .and. vfit .lt. fe2kmsmax ) then
	call mnmx( n, vdisp_v, vmn, vmx )
	vnew = vfit
	sigvnew = sigvfit
	why = 'from polyfit.'
      if( gabby ) then
	write(*,*) 'New vdisp', vnew, ' from polyfit.'
      end if
* or optimally scaled pattern
      else if( sigvopt .gt. 0. .and. vopt .gt. 0.
     &		.and. vopt .lt. fe2kmsmax ) then
	vnew = vopt
	sigvnew = sigvopt
	why = ' from optscl.'
      if( gabby ) then
	write(*,*) 'New vdisp', vnew, ' from optscl.'
      end if
* or the minimum bof
      else

* 2021-04-20 KDH : SHOULD THIS BE DBOF_V ?
c	i = minpos( n, bof_v )
	i = minpos( n, dbof_v )
	vnew = vdisp_v( i )
	why = ' best from vdisp grid'
	call append_i( why, i )
	call append( why, 'of' )
	call append_i( why, ngridv )
      if( gabby ) then
	write(*,*) 'New vdisp', vnew, ' best from grid.'
      end if
      end if

* no good final options
      else
	vnew = vmore
	sigvnew = -1.

* is vnew already in the grid ?
	yes = .false. 
      do i = 1, ngridv
	yes = yes .or. alog( vnew / vdisp_v( i ) ) .lt. 1./vdisp_v(i) 
      end do
* if so, fill a gap
      if( yes ) then
      do i = 1, ngridv - 1
	ip = min( i + 1, ngridv )
	step = alog( vdisp_v( ip ) / vdisp_v( i ) ) / max( 1, ip - i )
	dlnv_v( i ) = step
      end do
	i = maxpos( ngridv-1, dlnv_v )
	if( gabby ) write(*,*) 'Vdisp grid gap', dlnv_v( i )
	vnew = sqrt( vdisp_v( i ) ) * sqrt( vdisp_v( i + 1 ) )
	why = ' fill vdisp grid gap'
	call append_n( why, dlnv_v( i ), 2 )
      if( gabby ) then
	write(*,*) 'New vdisp', vnew, ' fill a gap in the grid.'
      end if
* expand the grid 
      else
	why = ' expand grid.'
      if( gabby ) then
	write(*,*) 'New vdisp', vnew, ' expand grid.'
      end if
      end if

      end if

* report vdisp change

	title = 'Fe2 scl'
	call append_n( title, fe2scl, 2 )
	call append( title, ' Nv' )
	call append_i( title, ngridv )
	call append( title, 'km/s' )
	call append_i( title, nint( vold ) )
	call append( title, '=>' )
	call append_i( title, nint( vnew ) )
      if( sigvnew .gt. 0. ) then
	call append( title, '+/-' )
	call append_i( title, nint( sigvnew ) )
      end if
	call append( title, why )
	write(*,*) title(:len1(title))

* keep in range
	vnew = max( fe2kmsmin, min( fe2kmsmax, vnew ) )
* update velocity dispersion
	fe2kms = vnew
	sigfe2kms = sigvnew

* 2021-04-20 KDH : trap bad dispersion
      if( vnew .le. 0. ) then
	write(*,*) '** non-positive velocity dispersion :('
	write(*,*) vnew, ' +/-', sigvnew
      end if


* NEXT LOOPV
      END DO

      if( gabby .or. .true. )  then
	kmsfe2 = nint( fe2kms )
	kmsfe2sig = nint( sigfe2kms )
	write(*,*) '========== FeII',
     &		kmsfe2, ' +/-', kmsfe2sig, ' km/s',
     &		' ======', ' Iter', nits
      end if

* stow per-iteration values
      if( nits .gt. 0 ) then
	vfe2_i( nits ) = fe2kms
	sigvfe2_i( nits ) = sigfe2kms
	sclfe2_i( nits ) = fe2scl
      end if

      if( gabby .or. .true. ) then
	write(*,*) 'FeII velocity', nint( fe2kms ),  ' scl', fe2scl, ' stowed.'
      end if

* end fe2 tweak
      end if

* stow residuals as blr component of avg spectrum
* KDH : DO THIS LATER?
      do i = 1, nw
	fit = avgcont_w( i ) + avgfe2_w( i )
	avgblr_w( i ) = fitavg_w( i ) - fit
	sigavgblr_w( i ) = sigavg_w( i )
      end do

* narrow line ( and AVG BLR ) stats -------------------------------
      do lrank = 1, markline
	l = i_l( lrank )
* skip absn lines
	k = nabc( l )
      if( k .eq. narrow .or. k .eq. nbroad ) then
	n = npix_l( l )
* require pixels
      if( n .gt. 0 ) then
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	text = text_l( l )
	lt = len1( text )

      if( k .eq. narrow ) then
* KDH : LINESTAT1 IS CHANGING ELR_W - SHOULD NOT DO THAT.
	call linestat1( n, w_w(iw1), elr_w(iw1), mask_wl(iw1,l), 
     &		flx, wavg, wrms, wmed, wmad, wtop, wlo, whi, wlo10, whi10 )


* KDH : DEBUG PLOT 2a
  771 IF( .FALSE. ) THEN
	call pgstart( 1, 1, notused )
	call pgbgw
      do i = 1, nw
	plot8( i ) = avg_w( i ) + elr_w( i )
      end do 
	xmn = w_w(1)
	xmx = w_w(nw)
	call mnmx( nw, avg_w, ymn, ymx )
	call mnmx( nw, plot8, dmn, dmx )
	ymn = min( ymn, dmn, elrwmn, 0. )
	ymx = max( ymx, dmx, elrwmx, 0. )
	ymx = 1.05 * ymx
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	title = 'debug plot 2a'
	call append_i( title, nint( rest_l( l ) ) )
	call pglabel( 'rest lam', 'flux', title )
	call pgsci( kred )
	call pgbin( nw, w_w, plot8, .true. )
	call pgsci( kblack )
	call pgbin( nw, w_w, avg_w, .true. )
	call pgsci( korange )
	call pgbin( nw, w_w, elr_w, .true. )
	call pgsci( kblue )
	call pgbin( nw, w_w, fit_w, .true. )
	call pgsci( kblack )
	call pgstop
	if( pgagain() ) goto 771
	END IF

      else
	call linestat1( n, w_w(iw1), avgblr_w(iw1), mask_wl(iw1,l), 
     &		flx, wavg, wrms, wmed, wmad, wtop, wlo, whi, wlo10, whi10 )
      end if

* error report
      IF( wmad .le. 0. .and. gabby ) THEN
      if( k .eq. narrow ) then
	write(*,*) 'linestat( ELR ', text(:lt), ' ) Wmad', wmad, ' :(('
      else
	write(*,*) 'linestat( AVG ', text(:lt), ' ) Wmad', wmad, ' :(('
      end if
	write(*,*) 'flx', flx, ' rest', rest_l( l )
	write(*,*) 'avg', nint(wavg), ' rms', nint(wrms)
	write(*,*) 'med', nint(wmed), ' mad', nint(wmad)
	m = 0
      do i = iw1, iw2
	if( mask_wl(i,l) ) m = m + 1
      end do
	lam1 = nint( w_w( iw1 ) )
	lam2 = nint( w_w( iw2 ) )
	write(*,*) 'Window', lam1, lam2, ' pixels', n, ' mask', m
	if( k .eq. narrow ) write(*,*) ( elr_w( i ), i = iw1, iw2 )
	if( k .eq. nbroad ) write(*,*) ( avgblr_w( i ), i = iw1, iw2 )
* end error report
      END IF

* velocities
	rest = rest_l( l )
	vavg = ckms * dlog( wavg / rest )
	vmed = ckms * dlog( wmed / rest )
	vtop = ckms * dlog( wtop / rest )
	vlo =  ckms * dlog(  wlo / rest )
	vhi =  ckms * dlog(  whi / rest )
	vlo10 = ckms * dlog( wlo10 / rest )
	vhi10 = ckms * dlog( whi10 / rest )
	vrms = ckms * alog( 1. + wrms / wavg )
	vmad = ckms * alog( 1. + wmad / wmed )
	vfwhm = ckms * alog( whi / wlo )
	vhw10 = ckms * alog( whi10 / wlo10 ) / 2.
* fix integrated line flux
	call fixflx( real( rest ), flx, fluxunit, inflxdex )
	wfwhm = whi - wlo
	whw10 = ( whi10 - wlo10 ) / 2.

* report
      if( gabby 
*     &	.or. wmad .le. 0
*     &	.or. ( l .eq. line_hb .and. npix_l(l) .gt. 0 )
*     &	.or. ( l .eq. line5007 .and. npix_l(l) .gt. 0 )
*     &	.or. ( l .eq. line4959 .and. npix_l(l) .gt. 0 )
     &		) then
	w1 = w_w( iw1 )
	w2 = w_w( iw2 )
	v1 = ckms * dlog( w1 / rest )
	v2 = ckms * dlog( w2 / rest )
      if( k .eq. narrow ) then
	write(*,*) 'Narrow line', l, ' rest', nint(rest), ' *********'
      else
	write(*,*) 'Mean BLR line', l, ' rest', nint(rest), ' *********'
      end if
	write(*,*) ' pix', iw1, iw2, ' span', iw2-iw1+1, n
	write(*,*) ' lam', nint(w1), nint(w2), ' span', nint(w2-w1), ' A'
	write(*,*) ' vel', nint(v1), nint(v2), ' span', nint(v2-v1), ' km/s'
	write(*,*) nint( rest ), '  Flx', flx, ' erg/cm2/s'
	write(*,*) nint( rest ), ' Wavg', wavg, nint( vavg ), ' km/s'
	write(*,*) nint( rest ), '  med', wmed, nint( vmed )
	write(*,*) nint( rest ), '  top', wtop, nint( vtop )

	write(*,*) nint( rest ), ' lo10', wlo10, nint( vlo10 )
	write(*,*) nint( rest ), '   lo', wlo,  nint( vlo )
	write(*,*) nint( rest ), '   hi', whi,  nint( vhi )
	write(*,*) nint( rest ), ' hi10', whi10, nint( vhi10 )

	write(*,*) nint( rest ), '  rms', wrms, nint( vrms )
	write(*,*) nint( rest ), '  mad', wmad, nint( vmad )
	write(*,*) nint( rest ), ' fwhm', wfwhm, nint(vfwhm)
	write(*,*) nint( rest ), ' hw10', whw10, nint(vhw10)
* end report
      end if
* stow
	flx_l( l ) = flx
	vavg_l( l ) = vavg
	vrms_l( l ) = vrms
	vmed_l( l ) = vmed
	vmad_l( l ) = vmad
	vtop_l( l ) = vtop
	vlo_l( l ) = vlo
	vhi_l( l ) = vhi
	vlo10_l( l ) = vlo10
	vhi10_l( l ) = vhi10
	vfwhm_l( l ) = vfwhm
	vhw10_l( l ) = vhw10

* -1 indicates no error bar
	f = -1.
	sigflx_l( l ) = f
	sigvavg_l( l ) = f
	sigvrms_l( l ) = f
	sigvmed_l( l ) = f
	sigvmad_l( l ) = f
	sigvtop_l( l ) = f
	sigvlo_l( l )  = f
	sigvhi_l( l )  = f
	sigvlo10_l( l ) = f
	sigvhi10_l( l ) = f
	sigvfwhm_l( l ) = f
	sigvhw10_l( l ) = f

* end require pixels
      end if
* end skip absn lines
      end if
* next lrank
      end do


      END IF


* KDH : DEBUG PLOT 2
  774 IF( .FALSE. ) THEN
	call pgstart( 1, 1, notused )
	call pgbgw
      do i = 1, nw
	plot8( i ) = avg_w( i ) + elr_w( i )
      end do 
	xmn = w_w(1)
	xmx = w_w(nw)
	call mnmx( nw, avg_w, ymn, ymx )
	call mnmx( nw, plot8, dmn, dmx )
	ymn = min( ymn, dmn, elrwmn, 0. )
	ymx = max( ymx, dmx, elrwmx, 0. )
	ymx = 1.05 * ymx
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pglabel( 'rest lam', 'flux', 'debug plot 2' )
	call pgsci( kred )
	call pgbin( nw, w_w, plot8, .true. )
	call pgsci( kblack )
	call pgbin( nw, w_w, avg_w, .true. )
	call pgsci( korange )
	call pgbin( nw, w_w, elr_w, .true. )
	call pgsci( kblue )
	call pgbin( nw, w_w, fit_w, .true. )
	call pgsci( kblack )
	call pgstop
	if( pgagain() ) goto 774
      END IF

* revise absorption spectrum ===============

      if( .not. dips ) then
      do i = 1, nw
	fitod_w( i ) = 0.
	datod_w( i ) = 0.
	fitdim_w( i ) = 1.
	datdim_w( i ) = 1.
	sigdim_w( i ) = 0.
	maskdim( i ) = .false.
      end do
	if( gabby ) write(*,*) 'No absorption dips.'
      else

* CONSTRUCT AN OPTICAL DEPTH SPECTRUM 

* number of splines
	vtot = ckms * alog( w_w( nw ) / w_w( 1 ) )
	vdim = 50.
	v = vnlr / 2.
	nspline = max( 1, nint( vtot / v ) )
      if( gabby ) then
	write(*,*)
	write(*,*) 'split ABSN from AVG with', nspline, ' splines.'
      end if

* mean spectrum * exp( - tau )
	ng = 0
	nb = 0
      do i=1,nw
	dim = fitdim_w( i )
	dat = avg_w( i ) * dim
	sig = sigavg_w( i ) * dim
	sigb = sig
	if( maskbad(i) .or. maskdim(i) ) sig = - abs( sig )
	if( maskbad(i) ) sigb = - abs( sigb )
	if( sig .gt. 0. ) ng = ng + 1
	if( sigb .gt. 0. ) nb = nb + 1
	plot1(i) = dat
	plot2(i) = sig
	plot3(i) = sigb
      end do
	pct = ( nw - ng ) * 100. / nw 
      if( gabby ) then
	write(*,*) 'masked line pixels:', nw-ng, ' of', nw, ' =', pct, ' %'
      end if

* fit spline, clipping narrow emission and absn lines
	ncycle = 2
	thrlo = -3.
	thrhi = 1000.
      if( autofit ) then
	call splfita( nw, w_w, plot1, plot2, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
      else
	call splfitr( nw, w_w, plot1, plot2, fit_w, ifail )
      end if

* data for optical depth spectrum 
      do i = 1, nw
	f = 1.
	s = -1.
	od = 0.
	odmx = 1e10
	fmn = exp( - odmx )
	c = fit_w( i )
      if( c .gt. 0. ) then
	f = plot1( i ) / c
	s = plot3( i ) / c
	od = - alog( max( f, fmn ) )
	f = exp( - od )
	s = f * s
      end if
	datod_w( i ) = od
	datdim_w( i ) = f
	sigdim_w( i ) = s
	difdim_w( i ) = f - fitdim_w( i )
      end do

* optical depth stats
	call avgrms( nw, datod_w, oavg, orms )
	call medmad( nw, datod_w, omed, omad )
	call mnmx( nw, datod_w, odmn, odmx )
      if( gabby ) then
	write(*,*) 'od_w min,max', odmn, odmx
	write(*,*) '     avg,rms', oavg, orms
	write(*,*) '     med,mad', omed, omad
      end if

* pixel range of each line
      do i = 1, nw
	plot1( i ) = w8_w( i ) * opz
      end do

* optical depth threshold for masking
	odclipmad = 5.
	odlow = omed + odclipmad * omad
* revise absorption mask
	ng = 0
      do i = 1, nw
	mask = datod_w( i ) .gt. odlow
	wobs = w8_w( i ) * opz
      do k = 1, nl
      if( i .ge. i1_l( k ) .and. i .le. i2_l( k ) ) then
	mask = .true.
      end if
      end do
	maskdim( i ) = mask
	if( mask ) ng = ng + 1
      end do

      if( gabby ) then
	pct = ng * 100. / nw 
	write(*,*) 'masked absn pixels:', ng, ' of', nw
     &		, ' =', pct, ' %'
      end if

* mean and rms of (intrinsic and galactic) linewidths
      do l = 1, 2
        if( l .eq. 1 ) ltype = intrinsic
        if( l .eq. 2 ) ltype = igalactic
* gather data for selected linetype
        n = 0
      do k = 1, nl
        ltype = ltype_l( k )
      if( ltype .eq. l ) then
        n = n + 1
        plot1( n ) = tau0_l( k )
        plot2( n ) = sigv_l( k )
        plot3( n ) = sigsigv_l( k )
      end if
      end do
* mean and intrinsic rms
        call avgrmsx( n, plot2, plot3, good, v, rms, s, sigrms )

* report
        write(*,*)
      if( l .eq. ltype_intrinsic ) then
        vint_avg = v
        vint_sig = s
        vint_rms = rms
        write(*,*) 'Intrinsic lines', n, ' good', good, ' bad', n-good
      else if( l .eq. ltype_galactic ) then
        vgal_avg = v
        vgal_sig = s
        vgal_rms = rms
        write(*,*) ' Galactic lines', n, ' good', good, ' bad', n-good
      end if

        call mnmx( n, plot1, tmn, tmx )
        call mnmx( n, plot2, vmn, vmx )
        write(*,*) ' tau0 mn mx', tmn, tmx
        write(*,*) ' sigv mn mx', vmn, vmx
        write(*,*) '  <sigv>', v, ' +/-', s, ' rms', rms
* next line type
      end do


* KDH : START OF TWEAK TO ABSORPTION LINE PARAMETERS
      if( tweaklines ) then

* REVISE LINE PARAMETERS
	write(*,*) 
	write(*,*) 'REVISING ABSN LINE WIDTHS AND OPTICAL DEPTHS'
	testloop = 10.
	nloops = 1
      do loops = 1, nloops
      if( testloop .gt. 1. ) then

        testloop = 0.
        chidn = 0.
        chiup = 0.
        chitdn = 0.
        chitup = 0.
        chisdn = 0.
        chisup = 0.
* lines
      do k = 1, nl
	i1 = i1_l( k )
	i2 = i2_l( k )
	n = i2 - i1 + 1
      if( i1 .ge. 1 .and. n .gt. 0 ) then
* KDH : CONFUSING THAT WOBS_L IS OBSERVED WHILE W_W IS REST FRAME 
	wobs = wobs_l( k ) / opz
	sigv = sigv_l( k ) / opz
	tau0 = tau0_l( k )
* fit
	oldtau0 = tau0
	oldsigv = sigv

	write(*,*)
	write(*,*) 'Line', k, real(wobs), i1, i2

	call fitaline2( n, w8_w(i1), difdim_w(i1), sigdim_w(i1),
     &          wobs, sigv, tau0, sigsigv, sigtau0, cor )

* safe step
	safe = 0.1
	dlnt = alog( tau0 / oldtau0 )
	dlns = alog( sigv / oldsigv )
	safedlnt = max( -safe, min( safe, dlnt ) )
	safedlns = max( -safe, min( safe, dlns ) )
	tau0 = oldtau0 * exp( safedlnt )
	sigv = oldsigv * exp( safedlns )

* hard limits
* KDH : THIS IS SOMEWHAT ARBITRARY
	tau0min = 1.e-3
	sigvmin = 1.
	sigvmax = 200.
	tau0 = max( tau0min, tau0 )
	sigv = max( sigvmin, min( sigvmax, sigv ) )

* apply linewidth prior
        ltype = ltype_l( k )
      if( ltype .eq. ltype_intrinsic ) then
        avg = vint_avg
        rms = vint_rms
      else if( ltype .eq. ltype_igalactic ) then
        avg = vgal_avg
        rms = vgal_rms
      end if
      if( avg .gt. 0. .and. rms .gt. 0. ) then
      if( sigsigv .le. 0. ) then
	write(*,*) '** WARNING: SIGSIGV', sigsigv, ' NOT POSITIVE. :((.'
      else
        w = 1. / ( sigsigv * sigsigv )
        w0 = 1. / ( rms * rms )
        var = 1. / ( w + w0 )
        sigv = ( sigv * w + avg * w0 ) * var
        sigsigv = sqrt( var )
      end if
      end if

* s/n
        snr = snr_aline( n, w8_w(i1), sigdim_w(i1), wobs, sigv, tau0 )

* convergence  test
        dlnt = alog( tau0 / oldtau0 )
        dlns = alog( sigv / oldsigv )
        siglnt = sigtau0 / tau0
        siglns = sigsigv / sigv
        chit = dlnt / siglnt
        chis = dlns / siglns

	chitup = max( chitup, chit )
	chitdn = min( chitdn, chit )
	chisup = max( chisup, chis )
	chisdn = min( chisdn, chis )
	chiup = max( chiup, chis, chit )
	chidn = min( chidn, chis, chit )
	
        if( chitup .eq. chit ) ktup = k
        if( chitdn .eq. chit ) ktdn = k
        if( chisup .eq. chis ) ksup = k
        if( chisdn .eq. chis ) ksdn = k

        tiny = 1.e-5
        chiloop = max( abs( chit ), abs( chis ) )
        test = chiloop / tiny

* report
      if( snr .le. 0. ) then
        write(*,*) 'line', k, real( wobs ), ' S/N', snr, ' :((('
      end if

      if( test .gt. testloop .or. .TRUE. ) then
        kbad = k
        write(*,*) 'line', k, real( wobs ), ' S/N', snr
        write(*,*) k, 'tau0', oldtau0, '->', tau0, chit, ' sigma'
        write(*,*) k, 'sigv', oldsigv, '->', sigv, chis, ' sigma'
      end if
        testloop = max( testloop, test )
* stow
	tau0_l( k ) = tau0
	sigtau0_l( k ) = sigtau0
	sigv_l( k ) = sigv * opz
	sigsigv_l( k ) = sigsigv * opz
	snr_l( k ) = snr
      end if
* next line
      end do

* report
        write(*,*)
        write(*,*) 'Loop', loops, ' Chi', chidn, chiup, ' Test', testloop
        write(*,*) ' tau0 up', real( wobs_l( ktup ) ), tau0_l( ktup ), sigv_l( ktup ), chitup
        write(*,*) '      dn', real( wobs_l( ktdn ) ), tau0_l( ktdn ), sigv_l( ktdn ), chitdn
        write(*,*) ' sigv up', real( wobs_l( ksup ) ), tau0_l( ksup ), sigv_l( ksup ), chisup
        write(*,*) '      dn', real( wobs_l( ksdn ) ), tau0_l( ksdn ), sigv_l( ksdn ), chisdn

* next loops
      end if
      end do
* END OF TWEAK TO ABSORPTION LINE PARAMETERS
       END IF

* evaluate absorption line model
      do i = 1, nw
	fitod_w( i ) = 0.
	fitod_agn_w( i ) = 0.
	fitdim_w( i ) = 1.
	fitdim_agn_w( i ) = 1.
      end do

      if( dips ) then
	call linespans( nw, w_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l )
	l = ltype_galactic
	call odspec( nw, w8_w, fitod_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, l )
	l = ltype_intrinsic
	call odspec( nw, w8_w, fitod_agn_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, l )
      do i = 1, nw
	od = fitod_w( i )
c	wobs = w8_w( i ) * opz
c	od = od + odlya( wobs, wobs_lya, v1_lya, tau0_lya )
	fitdim_w( i ) = exp( - od )
	fitdim_agn_w( i ) = exp( - fitod_agn_w( i ) )
      end do
      end if

      end if

* end of loop
* KDH : NOT SURE HERE 
      end if

      if( gabby ) then
	if( loop .eq. nloop ) write(*,*) 'Last loop', nloop
      end if
      end do
* restore gabby
	
	gabby = igab .ne. 0
C	write(*,*) 'Gabby', gabby



* recompute the model and difference image ===========================
	if( gabby ) write(*,*)
	if( gabby ) write(*,*) 'Compute difference image.'

      do it = 1, nt
      do iw = 1, nw
	x = xw_w( iw )
	avg = avg_w( iw )
	elr = elr_w( iw )
	dim = fitdim_w( iw )
	dim_agn = fitdim_agn_w( iw )
	gal = gal_w( iw ) * gal_t( it )

* blr
	blr = blr_w( iw ) * blr_t( it )
* rms blr components
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
c      if( npix_l( l ) .gt. 0 ) then
	blr = blr + dat_wl( iw, l ) * dat_tl( it, l )
      end if
      end do
* bac
	bac = bac_w( iw ) * bac_t( it )

* continuum
	c = 0.
	sigc = 0.
      if( npcont .gt. 0 ) then
      do k = 1, npcont
	cont_p( k ) = cont_tp( it, k )
      end do
	c = poly4( npcont, cont_p, x )
      end if

* sigma of noisy poly
      if( npar .gt. 0 .and. npcont .gt. 0 ) then
	i = 1 + npar * ( it - 1 )
	j = 1 + npar * ( i - 1 )  
	sigc = sigpoly( x, npar, npcont, ipcont, sig_pt(i), c_ppt(j) )
* ignore covariances
      else
* KDH : SCALE TO AVERT UNDER/OVERFLOW ?
* gather 
      do k = 1, npcont
	sigcont_p( k ) = sigcont_tp( it, k )
      end do
* scale
	call mnmx( npcont, sigcont_p, s, div )
	if( s .gt. 0. ) div = sqrt( s ) * sqrt( div )
	if( div .le. 0. ) div = 1.
* variance of scaled
      if( div .gt. 0. ) then
      do k = 1, npcont
	s = sigcont_p( k ) / div
	sigcont_p( k ) = s * s
      end do
      end if
	xx = x * x
	v = poly4( npcont, sigcont_p, xx )
	sigc = sqrt( max( 0., v ) ) * div
      end if

* broad lines
	b = blr + bac

* KDH: DIM_AGN DIMS ONLY VARIABLE PART OF AGN CONTINUUM AND LINES :(
      if( .false. ) then
* intrinsic absorption
	fagn = ( c + b ) * dim_agn
	f = avg + elr + gal
* galactic absorption
	f = ( fagn + f ) * dim
* dim everything
      else
	f = c + b + avg + elr + gal
	f = f * ( dim * dim_agn )
      end if
* stow
	f_w( iw ) = f
	iwt = iw + nw * ( it - 1 )
	cont_wt( iwt ) = c
	sigcont_wt( iwt ) = sigc
* next wavelength iw
      end do
	if( gabby ) write(*,*) 'Spectrum', it, ' done.'

* derivatives =========================================
* 1st and 2nd derivatives
      do i = 1, nw
	im = max( i - 1, 1 )
	ip = min( i + 1, nw )
	 n = max( 1, ip - im )
	fm = f_w( im )
	 f = f_w( i )
	fp = f_w( ip )
	df_w( i ) = ( fp - fm ) / n
	if( n .eq. 2 ) ddf_w( i ) = ( f + f - fm - fp )
      end do
	ddf_w( 1 )  = ddf_w( 2 )
	ddf_w( nw ) = ddf_w( nw - 1 )
* 3rd and 4th derivatives
      do i = 1, nw
	im = max( i - 1, 1 )
	ip = min( i + 1, nw )
	 n = max( 1, ip - im )
	fm = ddf_w( im )
	 f = ddf_w( i )
	fp = ddf_w( ip )
	d3f_w( i ) = ( fp - fm ) / n
	if( n .eq. 2 ) d4f_w( i ) = ( f + f - fm - fp )
      end do
	d4f_w( 1 )  = d4f_w( 2 )
	d4f_w( nw ) = d4f_w( nw - 1 )

	if( gabby ) write(*,*) '   derivatives done.'

* tweak flux, shift, blur
	i0t = nw * ( it - 1 )
      do iw = 1, nw
	xw = xw_w( iw )
	  f = f_w( iw )
	 df = df_w( iw )
	ddf = ddf_w( iw )
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	xc = x0_t( it ) + xw * x1_t( it )
	sc = s0_t( it ) + xw * s1_t( it ) 
	fitf =   p * f
	fitx = - p * xc * df
	fits =   p * sc * ddf
	fit = fitf + fitx + fits
	if( gabby .and. mod( iw, nw/5 ) .eq. 0. ) write(*,*) iw, i, fit
* stow
	i = i0t + iw
	fit_wt( i ) = fit
	dif_wt( i ) = datpic( iw, it ) - fit
	sig_wt( i ) = sigpic( iw, it )
	  f_wt( i ) = f
	 df_wt( i ) = df
	ddf_wt( i ) = ddf
	 p_wt( i ) = p
	fc_wt( i ) = fitf
	xc_wt( i ) = fitx
	sc_wt( i ) = fits
      end do
	if( gabby ) write(*,*) '   tweaks done.'

* next spectrum it
      end do
	if( gabby ) write(*,*) 'New difference image.'

* evaluate rms spectrum
* KDH : USE THE MAXIMUM LIKELIHOOD ESTIMATOR
	sigscale = min( chimedw, chimedt )
	if( gabby ) write(*,*) 'chimedw', chimedw, ' chimedt', chimedt, ' sigscale', sigscale

	lastgoodw = 0
      do iw = 1, nw
	w = w_w( iw )
	lam = nint( w )
	x = xw_w( iw )
	avg = avg_w( iw ) + elr_w( iw )
	n = 0
      do it = 1, nt
	iwt = iw + nw * ( it - 1 )

	sig = sig_wt( iwt )
      if( chifix ) then
	sig = sig * chifix_wt( iwt )
      else if( sigscale .gt. 0. ) then
	sig = sig * sigscale
      end if

      if( sig .gt. 0. ) then
	   raw = datpic( iw, it )
	sigraw = sig
	fit = fit_wt( iwt )
	f = f_wt( iwt )
* KDH : 2016 JUL : TWEAK DATA BEFORE COMPUTING RMS SPECTRUM
* tweaks ( shift, blur )
	tweak = xc_wt( iwt ) + sc_wt( iwt )
	dat = raw - tweak
* photometric correction
	p = p_wt( iwt )
	dat = dat / p
	sig = sig / p
* subtract avg (and nlr) spectrum
	dat = dat  - avg
* continuum
	c = cont_wt( iwt )
	sigc = sigcont_wt( iwt )
* stow
	n = n + 1
	plot1( n ) = dat
	plot2( n ) = sig
	plot3( n ) = c
	plot4( n ) = sigc
	plot5( n ) = fit
	plot6( n ) = f
	plot7( n ) = raw
	plot8( n ) = dat - c
	plot9( n ) = sigraw
      end if
* next it
      end do

* good data
	ngood = 0
	ncgood = 0
      do i = 1, n
	if( plot2( i ) .gt. 0. ) ngood = ngood + 1
	if( plot4( i ) .gt. 0. ) ncgood = ncgood + 1
      end do

* 2020-Mar-15 KDH : REPORT GAPS
* report gaps
	yes = ngood .gt. 0
      if( .not. yes .and. lastgoodw .eq. iw - 1 ) then
	write(*,*) 'NO DATA AT PIX', iw, ' LAM', w, ' :((((.'
      end if
      if( ( yes .and. lastgoodw .lt. iw - 1 ) 
     &	.or. ( .not. yes .and. iw .eq. nw ) ) then
	ngap = iw - lastgoodw
	if( yes ) ngap = ngap - 1
	write(*,*) '   THROUGH PIX', iw, ' LAM', w, ' GAP', ngap
      end if
	if( yes ) lastgoodw = iw

* report absent data
      if( gabby ) then
      if( n .le. 0 ) then
	write(*,*) 'w', w, ' n', n, ' ngood', ngood, ' ncgood', ncgood
	write(*,*) 'No data :('
      else if( ngood .le. 0 .or. ncgood .le. 0 ) then
	write(*,*) 'w', w, ' n', n, ' ngood', ngood, ' ncgood', ncgood
      if( ngood .le. 0 ) then
	write(*,*) 'No good data :('
	call mnmx( n, plot2, smn, smx )
	write(*,*) 'SIG(DAT)', n, ngood, smn, smx
	if( smn .ne. smx ) write(*,*) (plot2(i),i=1,n)
      end if
      if( ncgood .le. 0 ) then
	write(*,*) 'No good continuum data :('
	call mnmx( n, plot4, smn, smx )
	write(*,*) 'SIG(CONT)', n, ncgood, smn, smx
	if( smn .ne. smx ) write(*,*) (plot4(i),i=1,n)
      end if
      end if
      end if


* KDH : DEBUG PLOT 3
  773 IF( .FALSE. ) THEN
	call pgstart( 1, 1, notused )
	call pgbgw
      do i = 1, nw
	plot8( i ) = avg_w( i ) + elr_w( i )
      end do 
	xmn = w_w(1)
	xmx = w_w(nw)
	call mnmx( nw, avg_w, ymn, ymx )
	call mnmx( nw, plot8, dmn, dmx )
	ymn = min( ymn, dmn, elrwmn, 0. )
	ymx = max( ymx, dmx, elrwmx, 0. )
	ymx = 1.05 * ymx
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pglabel( 'rest lam', 'flux', 'debug plot 3' )
	call pgsci( kred )
	call pgbin( nw, w_w, plot8, .true. )
	call pgsci( kblack )
	call pgbin( nw, w_w, avg_w, .true. )
	call pgsci( korange )
	call pgbin( nw, w_w, elr_w, .true. )
	call pgsci( kblue )
	call pgbin( nw, w_w, fit_w, .true. )
	call pgsci( kblack )
	call pgstop
	if( pgagain() ) goto 773
      END IF

*----------------------------------------
* rms of raw (uncorrected) data
	call optavgrms( n, plot7, plot9, avg, rmsraw )
* report
      if( gabby .or. isnan( rmsraw ) ) then
	call   mnmx( n, plot7,  dmn,  dmx )
	call avgrms( n, plot7, davg, drms )
	call medmad( n, plot7, dmed, dmad )

	call   mnmx( n, plot9,  smn,  smx )
	call avgrms( n, plot9, savg, srms )
	call medmad( n, plot9, smed, smad )
	
	write(*,*) lam, ' RAW min,max', dmn, dmx
	write(*,*) lam, '  optavg,rms', avg, rmsraw
	write(*,*) lam, '     avg,rms', davg, drms
	write(*,*) lam, '     med,mad', dmed, dmad

	write(*,*) lam, ' SIG min,max', smn, smx
	write(*,*) lam, '     avg,rms', savg, srms
	write(*,*) lam, '     med,mad', smed, smad

* more if rmsraw is nan
      if( isnan( rmsraw ) ) then
	call mnmx( n, plot7, rmn, rmx )
	write(*,*) '    RAW ', n, rmn, rmx
	write(*,*) (plot7(i),i=1,n)
	call mnmx( n, plot2, smn, smx )
	write(*,*) 'SIG(RAW)', n, smn, smx
	write(*,*) (plot9(i),i=1,n)
      end if
      end if

*----------------------------------------
* 2021-01 KDH - simplify 
* debiased rms of lightcurve data at this wavelength
      IF( ngood .lt. 2 ) then
	call rmsnobias( n, plot1, plot2, avg, rms, sigrms, rmsbias )
* debiased rms of continuum-subtracted lightcurve data
	call rmsnobias( n, plot8, plot2, avgb, rmsb, sigavgb, sigrmsb )

*----------------------------------------
* rmsx = ML estimate of avg and extra rms
      ELSE
	call avgrmsx( n, plot1, plot2, good, avg, rms, sigavg, sigrms )
* rmsx of continuum-subtracted data
	call avgrmsx( n, plot8, plot2, goodb, avgb, rmsb, sigavgb, sigrmsb )

* KDH DEBUG 2021-01 KDH - Is it working now?
* THIS IS FAILING WITH 2017 SDSS-RM DATA    NGOOD=2
      if( gabby .or. rms .ne. rms ) then
      if( iw .eq. 1 .or. iw .eq. nw .or. mod( iw, max(1,nw/5) ) .eq. 0
     &		.or. rms .ne. rms ) then
	call mnmx( n, plot1, dmn, dmx )
	call avgrms( n, plot1, davg, drms )
	call medmad( n, plot1, dmed, dmad )
	call mnmx( n, plot2, smn, smx )
	call avgrms( n, plot2, savg, srms )
	call medmad( n, plot2, smed, smad )
	lam = nint( w_w( iw ) )
	write(*,*) lam, ' DAT min,max', dmn, dmx
	write(*,*) lam, '     avg,rms', davg, drms
	write(*,*) lam, '     med,mad', dmed, dmad
	write(*,*) lam, ' SIG min,max', smn, smx
	write(*,*) lam, '     avg,rms', savg, srms
	write(*,*) lam, '     med,mad', smed, smad
	write(*,*) lam, ' AVGx', avg, ' +/-', sigavg, ' N', n
	write(*,*) lam, ' RMSx', rms, ' +/-', sigrms, ' G', good
* report nan
      if( rms .ne. rms ) then
	write(*,*) '  RMSx', rms, ' is NAN                 :(((((((((((('
	write(*,*) ' DAT', n
	write(*,*) ( plot1(j), j = 1, n )
	write(*,*) ' SIG', n
	write(*,*) ( plot2(j), j = 1, n )
      end if
      end if 
      end if 

* KDH DEBUG REPORT
      if( gabby .or. rmsb .ne. rmsb ) then
      if( iw .eq. 1 .or. iw .eq. nw .or. mod( iw, max(1,nw/5) ) .eq. 0
     &		.or. rmsb .ne. rmsb ) then
	call mnmx( n, plot8, bmn, bmx )
	call avgrms( n, plot8, bavg, brms )
	lam = nint( w_w( iw ) )
	write(*,*) lam, ' DAT-CONT min,max', bmn, bmx
	write(*,*) lam, '          avg,rms', brms, brms
	write(*,*) lam, '  AVGx', avgb, ' +/-', sigavgb, ' N', n
	write(*,*) lam, '  RMSx', rmsb, ' +/-', sigrmsb, ' G', goodb
* report nan
      if( rmsb .ne. rmsb ) then
	write(*,*) '  RMSx', rmsb, ' is NAN                 :(((((((((((('
	write(*,*) ' DAT', n
	write(*,*) ( plot8(j), j = 1, n )
	write(*,*) ' SIG', n
	write(*,*) ( plot2(j), j = 1, n )
      end if
      end if
      end if

      END IF

*----------------------------------------
* 2021-01 KDH - simplify
* continuum avg and rms
      if( ncgood .lt. 2 ) then
	call rmsnobias( n, plot3, plot4, cavg, crms, sigcrms, crmsbias )
* ML estimate of continuum avg and rms
      else
	call avgrmsx( n, plot3, plot4, good, cavg, crms, sigcavg, sigcrms )
	crmsbias = 0.
      end if
* KDH DEBUG
c	WRITE(*,*) 'AVGRMSX( CONTINUUM )', cavg, crms, sigcavg, sigcrms

*----------------------------------------
* rms of the fit
	call avgrms( n, plot5, fit, rmsfit )
*----------------------------------------
* rms of calibrated model
	call avgrms( n, plot6, f, rmsf )

* 2020-07-30 KDH - hope to make continuum and model rms agree.
* ML estimate (to agree with crms above)
      if( ncgood .ge. 2 ) then
c	call avgrmsx( n, plot3, plot4, good, cavg, crms, sigcavg, sigcrms )
	call avgrmsx( n, plot5, plot4, good, fit, rmsfit, sigfit, sigrmsfit )
	call avgrmsx( n, plot6, plot4, good,   f,   rmsf,   sigf, sigf )
      end if

* stow new calibration
	    rms_w( iw ) = rms
	rmscont_w( iw ) = crms
	 rmsfit_w( iw ) = rmsfit
	   rmsf_w( iw ) = rmsf
	 rmsraw_w( iw ) = rmsraw
	   rmsb_w( iw ) = rmsb

	    sigrms_w( iw ) = sigrms
	sigrmscont_w( iw ) = sigcrms
	   sigrmsb_w( iw ) = sigrmsb

* next iw
      end do

*----------------------------------------
* evaluate chi2 (original error bars)
	sum = 0.d0
	ng = 0
      do i = 1, nt * nw
	sig = sig_wt( i )
      if( sig .gt. 0. ) then
	eta = dif_wt( i ) / sig
	sum = sum + eta * eta
	ng = ng + 1
      end if
      end do
	ngood = ng
	chi2 = sum

*----------------------------------------
* count fit parameters
* KDH : SHOULD CHECK THIS
	nfit = nfitavg + nfitcont + nfitblr
     &		+ nfitshift + nfitblur + nfitphot
     &		+ nfitbac
      do i = 1, ncomp
	nfit = nfit + nfit_c( i )
      end do
* degrees of freedom
	dof = ng - nfit
	ndof = max( 1, ng - nfit )
* reduced chi^2
	chi2red = sum / max( 1, ndof )
* bic
	bic = chi2 + alog( float( ng ) ) * nfit

      if( gabby ) then
	write(*,*) 'data', ng, ' rejected', nt*nw-ng, ' parms', nfit
	write(*,*) 'Chi2', chi2, ' / (', ng, ' -', nfit, ' ) =', chi2red
      end if

* KDH : SHOULD DO THIS WHENEVER CLIPHI/CLIPLO ARE ALTERED
*----------------------------------------
* chi and bias spectra
* unclipped
	noclip = 1
	call chi_bias_w( nw, nt, dif_wt, sig_wt, 
     &	chifix, chifix_t, noclip, bad_wt, plot1,
     &	chi_w, bias_w, sigchi_w, sigbias_w ) 

* clipped
	yes = .not. ( sdss .or. bhm )
      if( yes ) then
	noclip = 0
	call chi_bias_w( nw, nt, dif_wt, sig_wt, 
     &	chifix, chifix_t, noclip, bad_wt, plot1,
     &	chiclip_w, biasclip_w, sigchiclip_w, sigbiasclip_w ) 

* clipped, smoothed and mixed (fit with outliers)
      else
	noclip = 0
	call chi_bias_fit_w( nw, nt, xw_w, dif_wt, sig_wt, 
     &	chifix, chifix_t, noclip, bad_wt, plot1,
     &	chiclip_w, biasclip_w, sigchiclip_w, sigbiasclip_w,
     &  chifit_w, chimix_w, sigchifit_w, sigchimix_w )

* revise error-bar estimates for the clipped bias
* KDH : SHOULD USE ACTUAL DOF AT EACH WAVELENGTH
	dof = max( 1, nt - 1 )
	fac = 1. / sqrt( dof )
      do i = 1, nw
	chi = chimix_w( i )
	sigbiasclip_w( i ) = chi * fac
      end do

      end if
*----------------------------------------
* 2021-10-05 KDH - EXPERIMENTAL
* KDH : MAKE THIS A SUBROUTINE
* spline-fit to chi(w)
      if( .false. ) then
c      if( sdss .or. bhm ) then

* aim to smooth fit over 100 pixels
	pixels = 100.
* number of splines
	nspline = min( 100, max( 1, nint( nw / pixels ) ) )
	pixels = real( nw ) / nspline
* sigma clipped spline fit
	ncycle = 10
	thrhi = 4.
	thrlo = -4.
* report
	write(*,*) 'Chi(w) splines', nspline, ' pixels', pixels
	write(*,*) ' spline fit clipped at', thrlo, thrhi

* spline fit
	call splfita( nw, xw_w, chiclip_w, sigchiclip_w, chifit_w,
     &	nspline, ncycle, thrhi, thrlo, ifail )

* fit uncertainty (approximate)
	dof = nspline
	fac = 1. / sqrt( dof )
      do i = 1, nw
	sig = sigchiclip_w( i )
	sigchifit_w( i ) = sig * fac
      end do

* KDH : CHI FROM NT SAMPLES MAY BE NON-GAUSSIAN FOR SMALL NT
* estimate largest outlier for gaussian samples
* expect 2.5-sigma outliers in 100 pixels
	big = 2.5 * ( alog10( pixels ) / 2. )**(2./3.)
* uncertainty in largest outlier
	sigbig = big / sqrt( pixels )
	write(*,*) ' outlier threshold', big, ' +/-', sigbig, ' sigma.'

	out = 0.
      do i = 1, nw
	chi = chiclip_w( i )
	fit = chifit_w( i )
	sigchi = sigchiclip_w( i )
	sigfit = sigchifit_w( i )
	
* detect high outliers > big 
* KDH : MORE ACCURATE TAPER THAN 1-SIDED GAUSSIAN ?
* note that sigchi could be negative
      if( sigchi .le. 0. ) then
	p = 1.
* inlier probability
      else
	x = ( chi - fit ) / abs( sigchi )
	e = max( 0., ( x - big ) / sigbig )
	p = exp( -0.5 * e * e )
      end if
* outlier probability
	pout = 1. - p
* count outliers
	out = out + pout
* mixture model (retain high-chi outliers but smooth others)
	chimix = fit * p + pout * chi
	s1 = sigfit * p
	s2 = sigchi * pout
	sigmix = sqrt( s1 * s1 + s2 * s2 )
* report
	yes = mod( i, max( 1, nw / 10 ) ) .eq. 0
	yes = .false.
      if( yes ) then
	w = xplot( i )
	if( logx .ne. 0 ) w = 10. ** w
	lam = nint( w )
	write(*,*)
	write(*,*) lam, ' (', chi, ' -', fit, ' ) /', sigchi, ' =', x
	write(*,*)  ' (', x, ' -', big, ' ) /', sigbig, ' =', e
	write(*,*) ' in', p, ' out', pout, ' mix', chimix
      end if

* stow
	   chimix_w( i ) = chimix
	sigchimix_w( i ) = sigmix
* next wavelength i
      end do

* report outliers
	p = 100. * out / nw
	write(*,*) 'Outliers', out, ' /', nw, ' =', p, ' %'

* revise error-bar estimates for the clipped bias
      do i = 1, nw
	chi = chiclip_w( i )
      if( chi .gt. 0. ) then
	chimix = chimix_w( i )
	sigbias = sigbiasclip_w( i )
	sigbiasclip_w( i ) = sigbias * chimix / chi
      end if
      end do


      end if
* END EXPERIMENTAL
*----------------------------------------


*----------------------------------------
* chi and bias lightcurves
* unclipped
	noclip = 1
	call chi_bias_t( nw, nt, dif_wt, sig_wt, 
     &	chifix, chifix_w, noclip, bad_wt, plot1,
     &	chi_t, bias_t, sigchi_t, sigbias_t ) 
* clipped
	noclip = 0
	call chi_bias_t( nw, nt, dif_wt, sig_wt, 
     &	chifix, chifix_w, noclip, bad_wt, plot1,
     &	chiclip_t, biasclip_t, sigchiclip_t, sigbiasclip_t ) 

*----------------------------------------
* stats
	call medmad( nt, chi_t,  chimedt,  chimadt )
	call medmad( nw, chi_w,  chimedw,  chimadw )
	call medmad( nt, bias_t, biasmedt, biasmadt )
	call medmad( nw, bias_w, biasmedw, biasmadw )
* sigma clipped
	call medmad( nt, chiclip_t,  chiclipmedt,  chiclipmadt )
	call medmad( nw, chiclip_w,  chiclipmedw,  chiclipmadw )
	call medmad( nt, biasclip_t, biasclipmedt, biasclipmadt )
	call medmad( nw, biasclip_w, biasclipmedw, biasclipmadw )

*----------------------------------------
* error bar scale factors chifix_wt
      do i = 1, nt
	chifix_t( i ) = chi_t( i ) / chimedt
      end do
      do i = 1, nw
	chifix_w( i ) = chi_w( i ) / chimedw
      end do

* KDH : COULD REPLACE CHIMEDW BY A SPLINE FIT
      do it = 1, nt
	i0 = ( it - 1 ) * nw
      do iw = 1, nw
	i = i0 + iw
* TIMID - to converge after sufficient iterations
	cold = chifix_wt( i )
	cnew = chifix_t( it ) * chifix_w( iw ) * chimedw
      if( cold .le. 0. ) then
	chifix_wt( i ) = cold
      else
	chifix_wt( i ) = sqrt( cold * cnew )
      end if
      end do
      end do

*----------------------------------------
* chi_wt (using scaled error bars)
      do i = 1, nw * nt
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	chi_wt( i ) = dif_wt( i ) / sig
      end if
      end do

*----------------------------------------
* sigma clip bad pixels
	call pixclip( nw, nt, chi_wt, bad_wt, cliplo, cliphi,
     &	kliplo, kliphi, pixlo_w, pixhi_w, pixlo_t, pixhi_t ) 

* report
      if( gabby ) then
	n = nw * nt
	klip = kliplo + kliphi
	write(*,*) 'Sigma clip :', klip, ' of', n, ' =', klip * 100. / n, ' %'
	write(*,*) ' >', cliphi, ' :', kliphi, ' of', klip, ' =', nint( kliphi * 100. / klip ), ' %'
	write(*,*) ' <', cliplo, ' :', kliplo, ' of', klip, ' =', nint( kliplo * 100. / klip ), ' %'
      end if

* KDH : NOT SURE WHY THIS END IF IS HERE (WAS THE IF ACCIDENTALLY LOST?)
c      end if

*----------------------------------------
* chi2fix (using scaled error bars)
	sum = 0.d0
      do i = 1, nt * nw
	sig = sig_wt( i ) * chifix_wt( i )
      if( sig .gt. 0. ) then
	eta = dif_wt( i ) / sig
	sum = sum + eta * eta
      end if
      end do
	chi2fix = sum
	nfiterb = nt + nw
	chi2fixred = dsqrt( sum / max( 1, ndof - nfiterb ) )

* report
      if( gabby .or. chifix ) then
	write(*,*) 'Nt', nt, ' Bias(t)', biasmedt, ' Chi(t)', chimedt
	write(*,*) 'Nw', nw, ' Bias(w)', biasmedw, ' Chi(w)', chimedw
      if( chifix ) then
	legend = 'Fudged Chi2'
	call append_f( legend, chi2fix, '(f15.4)' )
	call append( legend, '/ (' )
	call append_i( legend, ng )
	call append( legend, '-' )
	call append_i( legend, nfit )
	call append( legend, '-' )
	call append_i( legend, nfiterb )
	call append( legend, ') =' )
	call append_f( legend, chi2fixred, '(f15.4)' )
	write(*,*) legend( : len1( legend ) )
c	write(*,*) 'Fudged Chi2', chi2fix,
c     &		' / (', ng, ' -', nfit, '-', nfiterb,' ) =', chi2fixred
      end if
      end if

* stow
	i = 1 + mod( nits - 1, maxiter )
* KDH : MAX(I,1) ? OR SKIP IF I<1 ?
* KDH : MAYBE HARMLESS TO STOW IN SLOT 1 WHEN NITS=0.
	i = max( 1, i )
      if( i .le. 0 .or. i .gt. maxiter ) then
	write(*,*) '** WARNING: i', i, ' outside', 1, maxiter
	write(*,*) '** nits', nits
      end if

	dof_i( i ) = ndof
	chi2_i( i ) = chi2
	chi2red_i( i ) = chi2red
	chi2fix_i( i ) = chi2fixred
	ndat_i( i ) = ng
	nfit_i( i ) = nfit
	bic_i( i ) = bic

	vnlr_i( i ) = vnlr
	vblr_i( i ) = vblr
	vnwant_i( i ) = vnwant
	vbwant_i( i ) = vbwant

* 4 window estimators
	vn1_i( i ) = vn1
	vn2_i( i ) = vn2
	vn3_i( i ) = vn3
	vn4_i( i ) = vn4

	vb1_i( i ) = vb1
	vb2_i( i ) = vb2
	vb3_i( i ) = vb3
	vb4_i( i ) = vb4


      if( nstage .gt. 0 ) then
	iter_s( nstage ) = i
	chi2_s( nstage ) = chi2
	ndat_s( nstage ) = ndat
	nfit_s( nstage ) = nfit

	bic_s( nstage ) = bic
	vnlr_s( nstage ) = vnlr
	vblr_s( nstage ) = vblr
      end if

	if( gabby ) write(*,*) 'Iteration', i, ' stage', nstage

      if( i .eq. 1 ) then
	write(*,*) 'Ndat', ng, ' Nfit', nfit
	write(*,*) 'Chi2/N', chi2red, ' BIC', bic_i( i )
      end if

* report
      if( i .gt. 0 ) then
* iteration
	label = 'Iter'
	call append_i( label, i )
* chi2
	call append( label, 'Chi^2/(' )
	call append_i( label, ng )
	call append( label, '-' )
	call append_i( label, nfit )
	call append( label, ') =' )
	call append_f( label, chi2red, '(f15.4)' )
* bic
	b = bic_i( i )
	call append( label, 'BIC' )
	call append_f( label, b, '(f15.2)' )
* change in BIC
	db = 0.
	iback = 0
	im1 = max( 1, i - 1 )
	im2 = 1
	if( nstage .gt. 1 ) im2 = max( 1, iter_s( nstage-1 ) -1 )
      do im = im1, im2, -1
      if( db .eq. 0. ) then
	iback = i - im
	db = bic_i( i ) - bic_i( im )
c	db = db / max( 1, i - im )
c	write(*,*) iback, ' BIC(', im, ' )', bic_i( im ), ' BIC(', i, bic_i( i ), ' )'
      end if
      end do
	call append( label, 'dBIC' )
	call append_f( label, db, '(f15.3)' )
      if( iback .gt. 1 ) then
	l = len1( label )
	call append( label, '/' )
	call append_i( label, iback )
	call nospace( label(l:) )
* unhappy
      else if( db .gt. 0. ) then
	call append( label, ':(' )
      end if
	write(*,*) label( :len1( label ) )
      end if

* statistics
	if( gabby ) write(*,*) 'Stats (avg,rms,mn,mx) : Nw', nw, ' Nt', nt

* avg
	call avgrms( nw, avg_w, baravg, barrms )
	call mnmx( nw, avg_w, avgmn, avgmx )
	if( gabby ) write(*,*) 'avg_w', baravg, barrms, avgmn, avgmx

* nlr
	call avgrms( nw, elr_w, elravg, elrrms )
	call mnmx( nw, elr_w, elrmn, elrmx )
	if( gabby ) write(*,*) 'elr_w', elravg, elrrms, elrmn, elrmx
* nlr
	call avgrms( nw, elr_w, avgnlrw, rmsnlrw )
	call avgrms( nt, elr_t, avgnlrt, rmsnlrt )

* gal
c	call avgrms( nw, gal_w, galwavg, galwrms )
c	call mnmx( nw, gal_w, galwmn, galwmx )
c	call avgrms( nt, gal_t, galtavg, galtrms )


* blr
c	call avgrms( nw, blr_w, blrwavg, blrwrms )
	call mnmx( nw, blr_w, blrwmn, blrwmx )
	call avgrms( nt, blr_t, blrtavg, blrtrms )
	call mnmx( nt, blr_t, blrtmn, blrtmx )

	if( gabby ) write(*,*) 'blr_w', blrwavg, blrwrms, blrwmn, blrwmx
	if( gabby ) write(*,*) 'blr_t', blrtavg, blrtrms, blrtmn, blrtmx

* bac
	call avgrms( nw, bac_w, bacwavg, bacwrms )
	call mnmx( nw, bac_w, bacwmn, bacwmx )
	call avgrms( nt, bac_t, bactavg, bactrms )
	call mnmx( nw, bac_t, bactmn, bactmx )

	if( gabby ) write(*,*) 'bac_w', bacwavg, bacwrms, bacwmn, bacwmx
	if( gabby ) write(*,*) 'bac_t', bactavg, bactrms, bactmn, bactmx


* cont
      if( gabby ) then
      do k = 1, npcont
	call avgrms( nt, cont_tp( 1, k ), avg, rms )
	write(*,*) 'cont(', k-1, ' )  avg', avg, ' rms', rms
      end do
      end if

* phot
	call avgrms( nt, p0_t, f0avg, f0rms )
	call avgrms( nt, p1_t, f1avg, f1rms )
	call avgrms( nt, p2_t, f2avg, f2rms )

	if( gabby ) write(*,*) 'phot avg', f0avg, f1avg, f2avg
	if( gabby ) write(*,*) 'phot rms', f0rms, f1rms, f2rms

* shift
	call avgrms( nt, x0_t, x0avg, x0rms )
	call avgrms( nt, x1_t, x1avg, x1rms )

	if( gabby ) write(*,*) 'shift avg', x0avg, x1avg
	if( gabby ) write(*,*) 'shift rms', x0rms, x1rms
* blur
	call avgrms( nt, s0_t, s0avg, s0rms )
	call avgrms( nt, s1_t, s1avg, s1rms )

	if( gabby ) write(*,*) 'blur avg', s0avg, s1avg
	if( gabby ) write(*,*) 'blur rms', s0rms, s1rms

	if( gabby ) write(*,*) 'Stats done.'

*================================================
* Evaluate various measures of linewidth
* NLR/BLR/VBLR loop
* KDH : STRIP THIS DOWN SO IT IS SILENT ?
	igab = 0
	if( gabby ) igab = 1
c	gabby = .false.

	ln = 1
	lb = 3
	lv = 2
* KDH : THE LAST ONE WILL BE USED TO SET VBLR WINDOW
      do loop = 1, 3
	if( loop .eq. ln ) ntest = narrow
	if( loop .eq. lb ) ntest = nbroad
	if( loop .eq. lv ) ntest = nbroad
* flux divisor
	n = 0
	f = 0.
      do lrank = 1, markline
	l = i_l( lrank )
      if( npix_l( l ) .gt. 0 .and. nabc( l ) .eq. ntest ) then
      if( .not. ( iw1_l( l ) .le. 1. .or. iw2_l( l ) .ge. nw ) ) then
	flx = flx_l( l )
	if( loop .eq. lv ) flx = vflx_l( l )
      if( flx .ne. 0. ) then
	n = n + 1
	f = max( f, abs( flx ) )
      end if
      end if
      end if
* next lrank
      end do
	div = f / 1000.
* line count
      if( n .gt. 0 ) then
      if( gabby ) then
	write(*,*)
	if( loop .eq. ln ) write(*,*) 'Narrow lines:', n, ' divisor', div
	if( loop .eq. lb ) write(*,*) 'Broad lines:', n, ' divisor', div
	if( loop .eq. lv ) write(*,*) 'RMS BLR lines:', n, ' divisor', div
      end if
* line loop
	k = 0
	kbig = 0
	lbig = 0
      do lrank = 1, markline
	l = i_l( lrank )
      if( npix_l( l ) .gt. 0 .and. nabc( l ) .eq. ntest ) then
	w0 = rest_l( l )
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	expand = expand_l( l )
	flx = flx_l( l )
	sigflx = sigflx_l( l )
	vmad = vmad_l( l )
	vmed = vmed_l( l )
	vrms = vrms_l( l )
	vfwhm = vfwhm_l( l )
	vhw10 = vhw10_l( l )
      if( loop .eq. lv ) then
	flx = vflx_l( l )
	sigflx = sigvflx_l( l )
	vmad = vvmad_l( l )
	vmed = vvmed_l( l )
	vrms = vvrms_l( l )
	vfwhm = vvfwhm_l( l )
	vhw10 = vvhw10_l( l )
      end if
	if( div .ne. 0. ) flx = flx / div
      if( vrms .gt. 0. .or. vmad .gt. 0. ) then
* report
      if( gabby ) then
	write(*, '( i5, i7, 5( a, i6 ), a, i6 )' )
     &		k+1, nint( w0 )
     &		, ' Vmad', nint( vmad )
     &		, ' Vrms', nint( vrms )
     &		, ' FWHM', nint( vfwhm )
     &		, ' HW10%', nint( vhw10 )
     &		, ' WinHW', nint( vblr * expand )
     &		, ' flx', nint(flx)
      end if
* skip
      if( iw1 .le. 1. .or. iw2 .ge. nw ) then
      if( gabby ) then
	write(*,*) '** SKIP', nint(w0), ' CLIPPED WINDOW', iw1, iw2, ' :(((.'
      end if
* stow
      else
	k = k + 1
	plot1( k ) = vmad
	plot2( k ) = vrms
	plot3( k ) = vfwhm
	plot4( k ) = vmad / expand
	plot5( k ) = vrms / expand
* downweight shifted lines
	x = vmed / vmad
	wgt = exp( -0.5 * x * x )
* downweight low s/n lines
      if( sigflx .gt. 0. ) then
	snr = flx / sigflx
	s = max( 0., snr )
	ss = s * s
	s0 = 20.
	wgt = wgt * ss / ( ss + s0 * s0 )
      end if
	plot6( k ) = wgt * abs( flx )
	plot7( k ) = wgt * flx * flx
	plot8( k ) = wgt * (flx/vmad)**2
	plot9( k ) = wgt
	plot10( k ) = vhw10


* note line with largest flux
      if( k .eq. 1 .or. abs( flx ) .gt. big ) then
	kbig = k
	big = abs( flx )
	lbig = l
	lambig = nint( rest_l( lbig ) )
      end if

      end if
      end if
      end if
* next lrank
      end do
      end if

* NLR/BLR linewidth stats
      if( n .gt. 0 ) then
	call medmad( n, plot1, vmad, vmadmad )
	call medmad( n, plot2, vrms, vrmsmad )
	call medmad( n, plot3, vfwhm, vfwhmmad )
	call medmad( n, plot10, vhw10, vhw10mad )
      else
	vmad = 0.
	vrms = 0.
	vfwhm = 0.
	vhw10 = 0.
	vmadmad = 0.
	vrmsmad = 0.
	vfwhmmad = 0.
	vhw10mad = 0.
      end if
* flux-weighted means
	call wgtavg( n, plot1, plot6, vmadavg )
	call wgtavg( n, plot2, plot6, vrmsavg )
	call wgtavg( n, plot3, plot6, vfwhmavg )
	call wgtavg( n, plot10, plot6, vhw10avg )
* flux^2-weighted mean
	call wgtavg( n, plot1, plot7, vmadavg2 )
	call wgtavg( n, plot2, plot7, vrmsavg2 )
	call wgtavg( n, plot3, plot7, vfwhmavg2 )
	call wgtavg( n, plot10, plot7, vhw10avg2 )
* (flux/Vmad)^2-weighted mean
	call wgtavg( n, plot1, plot8, vmadavg3 )
	call wgtavg( n, plot2, plot8, vrmsavg3 )
	call wgtavg( n, plot3, plot8, vfwhmavg3 )
	call wgtavg( n, plot10, plot8, vhw10avg3 )
* (flux/Vmad)^2-weighted mean
	call wgtavg( n, plot1, plot9, vmadavg4 )
	call wgtavg( n, plot2, plot9, vrmsavg4 )
	call wgtavg( n, plot3, plot9, vfwhmavg4 )
	call wgtavg( n, plot10, plot9, vhw10avg4 )

* report
      if( n .gt. 0 .and. gabby ) then
	write(*, '( 1x, a, i4, 4( a, i6 ), a )' )
     &		'   Median of', n
     &		, ' Vmad', nint( vmad )
     &		, ' Vrms', nint( vrms )
     &		, ' FWHM', nint( vfwhm )
     &		, ' HW10', nint( vhw10 ), ' km/s'
	write(*, '( 1x, a, i4, 4( a, i6 ), a )' )
     &		' Flux-avg of', n
     &		, ' Vmad', nint( vmadavg )
     &		, ' Vrms', nint( vrmsavg )
     &		, ' FWHM', nint( vfwhmavg )
     &		, ' HW10', nint( vhw10avg ), ' km/s'
	write(*, '( 1x, a, i4, 4( a, i6 ), a )' )
     &		'Flx^2-avg of', n
     &		, ' Vmad', nint( vmadavg2 )
     &		, ' Vrms', nint( vrmsavg2 )
     &		, ' FWHM', nint( vfwhmavg2 )
     &		, ' HW10', nint( vhw10avg2 ), ' km/s'
      end if

* window halfwidth options
* narrow lines
      if( loop .eq. ln ) then
	n_nlr = n
	l_nlr = lbig
	lam_nlr = lambig

      if( n .gt. 0 ) then
	call medmad( n, plot3, vnfwhmx, vnfwhmxmad )
	call medmad( n, plot4, vnmadx, vnmadxmad )
	call medmad( n, plot5, vnrmsx, vnrmsxmad )
      else
	vnfwhmx = 0.
	vnmadx = 0.
	vnrmsx = 0.
	vnfwhmxmad = 0.
	vnmadxmad = 0.
	vnrmsxmad = 0.
      end if

	vnfwhm1 = plot3( kbig )
	vnmad1 = plot4( kbig )
	vnrms1 = plot5( kbig )

	call wgtavg( n, plot3, plot6, vnfwhmavg )
	call wgtavg( n, plot4, plot6, vnmadavg )
	call wgtavg( n, plot5, plot6, vnrmsavg )

	call wgtavg( n, plot3, plot7, vnfwhmavg2 )
	call wgtavg( n, plot4, plot7, vnmadavg2 )
	call wgtavg( n, plot5, plot7, vnrmsavg2 )

	call wgtavg( n, plot3, plot8, vnfwhmavg3 )
	call wgtavg( n, plot4, plot8, vnmadavg3 )
	call wgtavg( n, plot5, plot8, vnrmsavg3 )

	call wgtavg( n, plot3, plot9, vnfwhmavg4 )
	call wgtavg( n, plot4, plot9, vnmadavg4 )
	call wgtavg( n, plot5, plot9, vnrmsavg4 )

* broad lines
      else if( loop .eq. lb .or. loop .eq. lv ) then
	n_blr = n
	l_blr = lbig
	lam_blr = lambig

      if( n .gt. 0 ) then
	call medmad( n, plot3, vbfwhmx, vbfwhmxmad )
	call medmad( n, plot4, vbmadx, vbmadxmad )
	call medmad( n, plot5, vbrmsx, vbrmsxmad )
      else
	vbfwhmx = 0.
	vbmadx = 0.
	vbrmsx = 0.
	vbfwhmxmad = 0.
	vbmadxmad = 0.
	vbrmsxmad = 0.
      end if

	vbfwhm1 = plot3( kbig )
	vbmad1 = plot4( kbig )
	vbrms1 = plot5( kbig )

	call wgtavg( n, plot3, plot6, vfwhmavg )
	call wgtavg( n, plot4, plot6, vbmadavg )
	call wgtavg( n, plot5, plot6, vbrmsavg )

	call wgtavg( n, plot3, plot7, vbfwhmavg2 )
	call wgtavg( n, plot4, plot7, vbmadavg2 )
	call wgtavg( n, plot5, plot7, vbrmsavg2 )

	call wgtavg( n, plot3, plot8, vbfwhmavg3 )
	call wgtavg( n, plot4, plot8, vbmadavg3 )
	call wgtavg( n, plot5, plot8, vbrmsavg3 )

	call wgtavg( n, plot3, plot9, vbfwhmavg4 )
	call wgtavg( n, plot4, plot9, vbmadavg4 )
	call wgtavg( n, plot5, plot9, vbrmsavg4 )
      end if

* next NLR/BLR/VBLR loop
      end do
	gabby = igab .ne. 0

* quit if there has been no change in 50 iterations
	if( maxback .le. 0 ) maxback = 50
      if( maxback .gt. 0 .and. iback .ge. maxback ) then
	write(*,*) '** NO CHANGE IN BIC OVER', iback, ' ITERATIONS.'
	lastit = nits
      end if

	goto 510

* revise average spectrum --------------------------------------

  530	if( gabby ) write(*,*) 'REVISING AVERAGE SPECTRUM'

* KDH: WHY DO WE NEED TO RE-EVALUATE THIS HERE ?
      IF( .FALSE. ) THEN
* absorption spectrum
      do i = 1, nw
	fitod_w( i ) = 0.
	fitod_agn_w( i ) = 0.
	fitdim_w( i ) = 1.
	fitdim_agn_w( i ) = 1.
      end do
      if( dips ) then
	call linespans( nw, w_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l )
	l = ltype_galactic
	call odspec( nw, w8_w, fitod_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, l )
	l = ltype_intrinsic
	call odspec( nw, w8_w, fitod_agn_w, zshift,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, l )
      do i = 1, nw
	od = fitod_w( i )
c	wobs = w8_w( i ) * opz
c	od = odlya( wobs, wobs_lya, v1_lya, tau0_lya )
	fitod_w( i ) = od
	fitdim_w( i ) = exp( - od )
	fitdim_agn_w( i ) = exp( - fitod_agn_w( i ) )
      end do
      end if
      END IF

* sanity-check chifix
      if( chifix ) then
	call mnmx( nt, chifix_t, cmn, cmx )
	write(*,*) 'Chifix(t)', cmn, cmx
	call mnmx( nw, chifix_w, cmn1, cmx1 )
	write(*,*) 'Chifix(w)', cmn1, cmx1
	call mnmx( nw*nt, chifix_wt, cmn2, cmx2 )
	write(*,*) 'Chifix(w,t)', cmn2, cmx2
      if( cmn .le. 0. .or. cmn1 .le. 0. .or. cmn2 .le. 0. ) then
	write(*,*) '** ERROR : Cannot fudge error bars :((('
	stop '** PrepSpec abort.  :((('
      end if
      end if

	xmn = 0.
	xmx = 0.
* wavelengths
      do iw = 1, nw
	xw = xw_w( iw )
* optical depth
	od = fitod_w( iw ) + fitod_agn_w( iw )
	dim = exp( - od )
* times
	i = iw - nw
      do it = 1, nt
	i = i + nw

* no pixel shifts
      if( nfitshift .le. 0 ) then
	x = 0.
	wobs = wavpic8( iw, it )

* 2020-Mar-13 KDH: TRAP INVALID WAVELENGTH
      IF( WOBS .LE. 0. ) THEN
	WRITE(*,*) '** INVALID WAVELENGTH', WOBS, ' IW', IW, ' IT', IT
	STOP 'SORRY :(((('
      END IF

	dat = datpic( iw, it )
	sig = sigpic( iw, it )
* error bar fudge
	if( chifix ) sig = sig * chifix_wt( i )

* absorption correction
      if( dips ) then
	dat = dat / dim
	sig = sig / dim
      end if

* with pixel shifts
      else
	x0 = x0_t( it )
	x1 = x1_t( it )
	x = x0 + xw * x1

	p8 = iw + x
	iw0 = nint( p8 )
	iw0 = max( 2, min( nw-1, iw0 ) )
	p8 = p8 - iw0
	iw1 = iw0 + 1
	if( p8 .lt. 0. ) iw1 = iw0 - 1
	p8 = dabs( p8 )
	omp8 = 1.d0 - p8
	wobs0 = wavpic8( iw0, it )
	wobs1 = wavpic8( iw1, it )
	d0 = datpic( iw0, it )
	d1 = datpic( iw1, it )
	s0 = sigpic( iw0, it )
	s1 = sigpic( iw1, it )
* error bar fudge
      if( chifix ) then
	s0 = s0 * chifix_wt( iw0 + nw * ( it - 1 ) )
	s1 = s1 * chifix_wt( iw1 + nw * ( it - 1 ) )
      end if
* absorption correction
* KDH: BOTH INTRINSIC AND GALACTIC LINES :(
      if( dips ) then
      IF( .FALSE. ) THEN
	wobs = wobs0
	od = odlya( wobs, wobs_lya, v1_lya, tau0_lya )
	ltype = ltype_galactic
	od = od + odlines( wobs, nl, wobs_l, sigv_l, tau0_l, ltype_l, ltype )
	ltype = ltype_intrinsic
	od = od + odlines( wobs, nl, wobs_l, sigv_l, tau0_l, ltype_l, ltype )
	dim = exp( - od )
      END IF
	d0 = d0 / dim
	s0 = s0 / dim   
      IF( .FALSE. ) THEN
	wobs = wobs1
	od = odlya( wobs, wobs_lya, v1_lya, tau0_lya )
	ltype = ltype_galactic
	od = od + odlines( wobs, nl, wobs_l, sigv_l, tau0_l, ltype_l, ltype )
	ltype = ltype_intrinsic
	od = od + odlines( wobs, nl, wobs_l, sigv_l, tau0_l, ltype_l, ltype )
	dim = exp( - od )
      END IF
	d1 = d1 / dim
	s1 = s1 / dim
      end if
	wobs = wobs0 * omp8 + wobs1 * p8
	dat = d0 * omp8 + d1 * p8
	sig = s0 * omp8 + s1 * p8
* KDH : SHOULD DO SOMETHING ABOUT BAD PIXELS
* KDH : SHOULD ACCOUNT FOR SEEING JITTER
      end if

* photometric scale factor 
	p0 = p0_t( it )
	p1 = p1_t( it )
	p2 = p2_t( it )
	p = p0 + xw * ( p1 + xw * p2 )
	if( logp ) p = exp( p )
* stow
* KDH : STOW ONLY GOOD DATA ?
	plot1( it ) = wobs / opz
	plot2( it ) = dat / p
	plot3( it ) = sig / p
	xmn = min( xmn, x )
	xmx = max( xmx, x )
* next time it
      end do

* count good data
	ngood = 0
      do i = 1, nt
	if( plot3( i ) .gt. 0 ) ngood = ngood + 1
      end do

* sanity check (SHOULD WE CARE ABOUT THIS ?)
	call mnmx( nt, plot3, smn, smx )
      if( smn .eq. smx ) then
      if( gabby .or. smx .le. 0. ) then
	write(*,*) '** WARNING: at W(', iw, ' )=', nint(w_w(iw))
     &		, ' all sigmas are', smn
	call mnmx( nt, plot1, wmn, wmx )
	call mnmx( nt, plot2, dmn, dmx )
	write(*,*) 'Nt', nt, ' Nw', nw, ' Ngood', ngood
	write(*,*) 'lam', wmn, wmx, ' flx', dmn, dmx
      if( chifix ) then
	write(*,*) 'sigpic(', iw, ', 1 -', nt, ' ) :'
	write(*,*) ( sigpic( iw, it ), it = 1, nt )
	write(*,*) 'chifix_wt(', iw, ', 1 -', nt, ' ) :'
	write(*,*) ( chifix_wt( iw + (it-1)*nw ), it = 1, nt )
	write(*,*) 'chifix_w(', iw, ' )', chifix_w( iw )
	write(*,*) 'chifix_t( 1 -', nt, ' ) :'
	write(*,*) ( chifix_t( it ), it = 1, nt )
      end if
c KDH : REMOVE THIS STOP AND TRY TO FIX LATER CRASH
c	if( iw .gt. 5 ) stop
      end if
      end if

* optimal time average of (shifted, de-absorbed) data (plot2)
	call optavg( nt, plot2, plot3, avg, sig )
* weighted average of wavelengths (plot1)
* 2020-Mar-15 - OPTAVGRMS FAILS IF NO GOOD DATA
      if( ngood .gt. 0 ) then
	call optavgrms( nt, plot1, plot3, avgw, rmsw )
      else
	call avgrms( nt, plot1, avgw, rmsw )
      end if

* stow
	w_w( iw ) = avgw
	w8_w( iw ) = avgw
	avg_w( iw ) = avg
	sigavg_w( iw ) = sig

* ML estimate of rms spectrum (needs 2 good epochs)
      IF( ngood .ge. 2 ) THEN
	call avgrmsx( nt, plot2, plot3, good, avg, rms, sigavg, sigrms )
* default to debiased sample variance
      ELSE
	call optavgrms( nt, plot2, plot3, avg, rms )
	dof = max( 1, ngood - 1 )
	sigrms = rms * sqrt( 2. / dof )
	rms = sqrt( max( 0., rms * rms - sigrms * sigrms ) )
      END IF
* stow
	rms_w( iw ) = rms
	sigrms_w( iw ) = sigrms

* reset fe2
	avgfe2_w( iw ) = 0.

* reset NLR spectrum
	elr_w( iw ) = 0.
* next wavelength
      end do
* reset fe2 velocity grid

* compute xw_w(i) ranging from -1 to +1
	call xwcalc( nw, w_w, xw_w )
	if( gabby ) write(*,*) 'xwcalc', nw, xw_w(1), xw_w(nw)

* KDH : SHOULD REVISE THE LINE MASK

* report
	if( gabby ) write(*,*) 'nt', nt, ' nw', nw, ' Pixel shifts:', xmn, xmx
	call avgrms( nw, avg_w, avg, rms )
	if( gabby ) write(*,*) 'new average spectrum avg', avg, ' rms', rms



* degrees of freedom
	nfitavg = nw
	goto 524

* extract nlr spectrum --------------------------------------------------
  535	if( gabby ) write(*,*) 'revise NLR spectrum'

      IF( .TRUE. ) THEN
c      IF( .FALSE. ) THEN
C	write(*,*) 'Not yet implemented :('
	write(*,*) ' '
	write(*,*) 'NLR spectrum is AVG spectrum minus a spline fit.'
	write(*,*) 'Stiff (>0) is 1/number of cubic splines per NLR window.'
	call inqr( 'Stiff', stiffnlr, val )
	if( val .gt. 0. ) stiffnlr = val

* KDH : SHOULD GO TO REVISE NLR SPECTRUM
	goto 530
c	goto 510

* KDH : THE CODE BELOW IS DISABLED (NOT TESTED OR NOT WORKING)
      ELSE

* extract the NLR lightcurve
	caution = 0.9
      do it=1,nt
	sum = 0.d0
	sumw = 0.d0
	ng = 0
	i = ( it - 1 ) * nw
      do iw=1,nw
	i = i + 1
      if( masknlr( iw ) ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = elr_w( iw ) * p
	wgt = pat / ( sig * sig )
	sum =  sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end if
      end do
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	elr_t( it ) = elr_t( it ) + add
	signlr_t( it ) = sig
      end if
      end do
	if( gabby ) write(*,*) 'NLR wavelengths', ng, ' of', nw
	call avgrms( nt, elr_t, avgnlrt, rmsnlrt )
	elrmed = xmedian( nt, elr_t )
	if( gabby ) write(*,*) 'NLR lightcurve avg', avgnlrt, ' rms', rmsnlrt

* scale NLR lightcurve
	div = elrmed
	if( gabby ) write(*,*) 'Divide by NLR median flux', div
      if( div .ne. 0. ) then
      do i=1,nt
	elr_t(i) = elr_t(i) / div
	signlr_t(i) = signlr_t(i) / div
      end do
      end if
	call avgrms( nt, elr_t, avgnlrt, rmsnlrt )
      if( gabby ) then
	write(*,*) 'NLR lightcurve avg', avgnlrt, ' rms', rmsnlrt
	write(*,*) 'NLR lightcurve median', xmedian( nt, elr_t )
      end if

* NLR spectrum
	caution = 0.9
      do iw=1,nw
	sum = 0.d0
	sumw = 0.d0
	xw = xw_w( iw )
	ng = 0
	i = iw - nw
      do it=1,nt
	i = i + nw
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = elr_t( it ) * p
	wgt = pat / ( sig * sig )
	sum =  sum +  wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end do
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	elr_w( iw ) = elr_w( iw ) + add
	signlr_w( iw ) = sig
      end if
      end do
	call avgrms( nw, elr_w, avgnlrw, rmsnlrw )
      if( gabby ) then
	write(*,*) 'NLR times', ng, ' of', nt
	write(*,*) 'NLR spectrum avg', avgnlrw, ' rms', rmsnlrw
      end if
* degrees of freedom
c	nfitnlr = nt + nw
	nfitnlr = nt + ng
C	goto 525
	goto 524

      END IF

* revise BLR model ==============================

  540	caution = 0.9
	if( gabby ) write(*,*) 'revise BLR model. Caution:', caution

* BLR lightcurve
	ngw = 0
	ngt = 0
      do it = 1, nt
	ng = 0
	i = ( it - 1 ) * nw
	p0 = p0_t( it )
	p1 = p1_t( it )
	p2 = p2_t( it )
      do iw = 1, nw
	i = i + 1
	mask = maskblr( iw ) .and. ( .not. maskbad( iw ) )

* 2019 AUG KDH : MASK BAL ?  MAYBE THIS BREAKS RMS BLR SPECTRUM
C	mask = mask .and. ( .not. maskbal( iw ) )

      if( mask ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	p = p0 + xw * ( p1 + xw * p2 )
	if( logp ) p = exp( p )
	pat = blr_w( iw ) * p
	pat = pat * fitdim_w( iw )
* stow
	ng = ng + 1
	plot1( ng ) = dif_wt( i )
	plot2( ng ) = sig
	plot3( ng ) = pat
      end if
      end if
* next iw
      end do

* scale blr profile to fit
	call optscl( ng, plot1, plot2, plot3, scl, sigscl )
	blr_t( it ) = blr_t( it ) + scl
	sigblr_t( it ) = sigscl
	if( sigscl .gt. 0. ) ngt = ngt + 1
	ngw = max( ngw, ng )

* report failures
      if( ng .le. 0 .or. sigscl .le. 0. ) then
	call avgrms( ng, plot3, pavg, prms )
      if( pavg .eq. 0. .and. prms .eq. 0. ) then
	write(*,*) '** NO BLR PIXELS AT TIME', it, ' :((('
      else
	write(*,*) '** SCALING BLR FAILED AT TIME', it, ' :(((('
	write(*,*) '** dBLR(', it, ' )=', scl, ' +/-', sigscl
	call avgrms( ng, plot1, davg, drms )
	call avgrms( ng, plot2, savg, srms )
	call avgrms( ng, plot3, pavg, prms )
	write(*,*) '   Dat avg', davg, ' drms', drms
	write(*,*) '   Sig avg', savg, ' srms', srms
	write(*,*) '   Pat avg', pavg, ' prms', prms
      end if
      end if

* next it
      end do
* subtract lightcurve mean
	call optavgrms( nt, blr_t, sigblr_t, blrtavg, blrtrms )
	call peqpac( nt, blr_t, blr_t, -blrtavg )

* report
      if( gabby ) then
	write(*,*) 'BLR waves', ngw, ' of', nw
	write(*,*) 'BLR times', ngt, ' of', nt
	write(*,*) 'BLR lightcurve avg', blrtavg, ' rms', blrtrms
	write(*,*) 'Mean subtracted'
      end if
	call optavgrms( nt, blr_t, sigblr_t, avg, rms )
      if( gabby ) then
	write(*,*) 'BLR lightcurve avg', avg, ' rms', rms
      end if

* BLR spectrum
  541	caution = 0.9
	ngw = 0
	ngt = 0
      do iw = 1, nw
      if( .not. maskbad( iw ) ) then
	dim = fitdim_w( iw )
	sum = 0.d0
	sumw = 0.d0
	ng = 0
	xw = xw_w( iw )
	i = iw - nw
      do it = 1, nt
	i = i + nw
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = blr_t( it ) * p * dim
	wgt = pat / ( sig * sig )
	sum  = sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end do

      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	blr_w( iw ) = blr_w( iw ) + add
	sigblr_w( iw ) = sig
	ngw = ngw + 1
	ngt = max( ngt, ng )
      end if
      else
	blr_w( iw ) = 0.
	sigblr_w( iw ) = -1.
      end if
* next iw
      end do
	call avgrms( nw, blr_w, blrwavg, blrwrms )
      if( gabby ) then
	write(*,*) 'BLR times', ngt, ' of', nt
	write(*,*) 'BLR waves', ngw, ' of', nw
	write(*,*) 'BLR spectrum avg', blrwavg, ' rms', blrwrms
      end if
* degrees of freedom
	nfitblr = nt + nw
	nfitblr = nt + ngw
	write(*,*) 'nfitblr=>', nt, ' +', ngw, ' =', nfitblr
* KDH : REVISE BLR COMPONENT SPECTRA
	goto 549

* ------------------------------------------------------
* REVISE RMS BLR COMPONENT LIGHTCURVES/SPECTRA
  549	caution = 0.9

	igab = 0
	if( gabby ) igab = 1
	gabby = .true.
	gabby = .false.
* components
      do ic = 1, ncomp
	l = line_lc( 1, ic )
	text = text_l( l )
	lt = len1( text )
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
c	np = npix_l( l )
	np = npix_c( ic )
      if( np .gt. 0 ) then

	if( gabby ) write(*,*)
	if( gabby ) write(*,*) 'revise ', text(:lt), ' model. Caution:', caution

* new lightcurve
* times
      do it = 1, nt
* scale spectral pattern to fit residuals
	sum = 0.d0
	sumw = 0.d0
	ng = 0
	i0 = ( it - 1 ) * nw
      do iw = iw1, iw2
	i = i0 + iw
      if( mask_wl( iw, l ) ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )

* KDH : SHOULD WE OMIT BAL HERE?

      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = dat_wl( iw, l ) * p
	wgt = pat / ( sig * sig )
	sum =  sum +  wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end if
      end do
* revise lightcurve
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	dat_tl( it, l ) = dat_tl( it, l ) + add
	sig_tl( it, l ) = sig
      end if
* next time it
      end do
* subtract mean
	call avgrms( nt, dat_tl( 1, l ), avg, rms )
      do it = 1, nt
	dat_tl( it, l ) = dat_tl( it, l ) - avg
      end do
* report
      if( gabby ) then
	write(*,*) text(:lt), ' wavelengths', ng, ' of', nw
	write(*,*) text(:lt), ' lightcurve avg', avg, ' rms', rms
      end if
	call avgrms( nt, dat_tl( 1, l ), avg, rms )
      if( gabby ) then
	write(*,*) 'Mean subtracted'
	write(*,*) text(:lt), ' lightcurve avg', avg, ' rms', rms
      end if

* new spectrum
 5491	caution = 0.9
	ngw = 0
* wavelengths
      do iw = iw1, iw2
* scale time pattern to fit residuals
	sum = 0.d0
	sumw = 0.d0
	xw = xw_w( iw )
	ng = 0
	i = iw - nw
      do it = 1, nt
	i = i + nw
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = dat_tl( it, l ) * p
	wgt = pat / ( sig * sig )
	sum =  sum +  wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end do
* revise spectrum
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	dat_wl( iw, l ) = dat_wl( iw, l ) + add
	sig_wl( iw, l ) = sig
	ngw = ngw + 1
      end if
* next wavelength iw
      end do
	nfit_l( l ) = nt + ngw
	call avgrms( nw, dat_wl(1,l), avg, rms )
* report
      if( gabby ) then
	write(*,*) text(:lt), ' times', ng, ' of', nt
	write(*,*) text(:lt), ' spectrum avg', avg, ' rms', rms

* KDH : NGW IS TOO BIG.
	write(*,*) 'nfit', nfit_l(l), ' nt', nt, ' ngw', ngw
      end if

* next component lc
      end if
      end do

	gabby = igab .ne. 0

	goto 524
* end revision of blr model

* BaC ------------------------------------------------------
  544	caution = 0.9
	if( gabby ) write(*,*) 'revise Balmer Continuum model', caution

* BaC lightcurve
      do it=1,nt
	sum = 0.d0
	sumw = 0.d0
	ng = 0
	i = ( it - 1 ) * nw
      do iw=1,nw
	i = i + 1
      if( maskbac( iw ) ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = bac_w( iw ) * p
	wgt = pat / ( sig * sig )
	sum =  sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end if
      end do
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	bac_t( it ) = bac_t( it ) + add
	sigbac_t( it ) = sig
      end if
      end do
	call avgrms( nt, bac_t, bactavg, bactrms )
      if( gabby ) then
	write(*,*) 'BaC wavelengths', ng, ' of', nw
	write(*,*) bac1, bac2
	write(*,*) 'BaC lightcurve avg', bactavg, ' rms', bactrms
      end if
      do i=1,nt
	bac_t(i) = bac_t(i) - bactavg
      end do
	if( gabby ) write(*,*) 'Mean subtracted'

	call avgrms( nt, bac_t, bactavg, bactrms )
	if( gabby ) write(*,*) 'BaC lightcurve avg', bactavg, ' rms', bactrms

* BaC spectrum
	caution = 0.9
	ngw = 0
      do iw=1,nw
c      if( maskbac( iw ) ) then
	sum = 0.d0
	sumw = 0.d0
	xw = xw_w( iw )
	ng = 0
	i = iw - nw
      do it=1,nt
	i = i + nw
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = bac_t( it ) * p
	wgt = pat / ( sig * sig )
	sum =  sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end do
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	bac_w(iw) = bac_w(iw) + add
	sigbac_w( iw ) = sig
	ngw = ngw + 1
      end if
c      else
c	bac_w(iw) = 0.
c      end if
      end do
	call avgrms( nw, bac_w, bacwavg, bacwrms )
      if( gabby ) then
	write(*,*) 'BaC times', ng, ' of', nt
	write(*,*) 'BaC spectrum avg', bacwavg, ' rms', bacwrms
      end if
	nfitbac = nt + ngw
C	goto 525
	goto 524

* continuum --------------------------------------------------
  545	nloop = max( 1, min( maxpcont, npcont ) )
	caution = 0.9
	if( gabby ) write(*,*) 'revise CONTINUUM', nloop, caution
      do it = 1, nt
	sum = 0.d0
	sumw = 0.d0
      do loop = 1, nloop
	i = ( it - 1 ) * nw
	ng = 0
      do iw = 1, nw
	i = i + 1
      if( .not. ( maskblr( iw ) .or. masknlr( iw ) ) ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = p
      do k = 2, nloop
	if( loop .ge. k ) pat = pat * xw
      end do
	pat = pat * fitdim_w( iw )
	wgt = pat / ( sig * sig )
	sum =  sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end if
      end do
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution

      do k = 1, nloop
	cont_tp( it, k ) = cont_tp( it, k ) + add
	sigcont_tp( it, k ) = sig
      end do

      end if
      end do
      end do

* report

      if( gabby ) then
      do k = 1, npcont
	call avgrms( nt, cont_tp( 1, k ), avg, rms )
	write(*,*) 'cont(', k-1, ' ) avg', avg, ' rms', rms
      end do
      end if

	nfitcont = nt * nloop
	goto 524


* revise lightcurves jointly ==================================

  551	write(*,*) 'Joint tweak of Lightcurves: Nt', nt

	fmt = '(4(a,i2,a,i2),(a,i3,a,i3),a,(a,i3,a,i3))'
	maxpar = npcont + npscale + npshift + npblur + ncomp + 1
	write(*,fmt) ' Phot:', npscale, ' /', maxpscale
     &		, ' Shift:', npshift, ' /', maxpshift
     &		, ' Blur:', npshift, ' /', maxpshift
     &		, ' Cont:', npcont, ' /', maxpcont
     &		, ' Lines:', ncomp, ' /', maxc
     &		, ' BLR: 1', ' Max:', maxpar, ' /', maxp


* last parameter index of each type
	l = npscale
	lphot = l
	l = l + npshift
	lshift = l
	l = l + npblur
	lblur = l
	l = l + npcont
	lcont = l
	l = l + ncomp
	lcomp = l
	lblr = l + 1

* initialise parameter key
      do i = 1, maxpoly
	ipcont( i ) = 0
	ipshift( i ) = 0
	ipblur( i ) = 0
	ipscale( i ) = 0
      end do

* build parameter key
	record = ' '
	n = 0
	notweak = 0
      do i = 1, maxpar
	iphot = 0
	ishift = 0
	iblur = 0
	icont = 0
	icomp = 0
	iblr = 0
	ipblr = 0
	text = ' '

* note, must do these in same order as above
* photometry
      if( i .le. lphot ) then
	k = i
	text = 'phot'
	if( k .eq. 2 ) text = 'ptilt'
	if( k .eq. 3 ) text = 'pbend'
	if( k .ge. 4 ) write( text, * ) 'p_', k-1
	call nospace( text )
	iphot = 0
	if( index( todolist, 'F' ) .gt. 0 ) iphot = k
* shift
      else if( i .le. lshift ) then
	k = i - lphot
	text = 'shift'
	if( k .ge. 2 ) text = 'xtilt'
	if( k .ge. 3 ) text = 'xbend'
	if( k .ge. 4 ) write( text, * ) 'dx_', k-1
	call nospace( text )
	ishift = 0
	if( index( todolist, 'W' ) .gt. 0 ) ishift = k
* blur
      else if( i .le. lblur ) then
	k = i - lshift
	text = 'blur'
	if( k .ge. 2 ) text = 'stilt'
	if( k .ge. 3 ) text = 'sbend'
	if( k .ge. 4 ) write( text, * ) 'blur', k-1
	call nospace( text )
	iblur = 0
	if( index( todolist, 'S' ) .gt. 0 ) iblur = k
* continuum
      else if( i .le. lcont ) then
	k = i - lblur
	text = 'cont'
	if( k .eq. 2 ) text = 'ctilt'
	if( k .eq. 3 ) text = 'cbend'
	if( k .ge. 4 ) write( text, * ) 'cont', k-1
	call nospace( text )
	icont = 0
	if( index( todolist, 'C' ) .gt. 0 ) icont = k
* RMS BLR components
      else if( i .le. lcomp ) then
	k = i - lcont
	l = line_lc( 1, k )
	text = text_l( l )
	icomp = k
	if( npix_l( l ) .le. 0 ) icomp = 0
	if( index( todolist, 'B' ) .le. 0 ) icomp = 0
* blr
      else if( i .le. lblr ) then
	text = 'BLR'
	if( npixblr .gt. 0 ) iblr = 1
	if( index( todolist, 'B' ) .le. 0 ) iblr = 0
* check for pattern
	call avgrms( nw, blr_w, avg, rms )
	if( avg .eq. 0. .and. rms .le. 0. ) iblr = 0
* crash on overflow
      else
	write(*,*) '** ERROR : TOO MANY PARAMETERS', n, maxpar
	stop '** PrepSpec abort.  :((('
      end if
* stow
	k = max( iphot, ishift, iblur, icont, icomp, iblr )
      if( k  .gt. 0 ) then
* crash on overflow
      if( n .ge. maxp ) then
	write(*,*) '** ERROR : TOO MANY PARAMETERS', n, maxp
	stop '** PrepSpec abort.  :((('
      end if
* stow 
	n = n + 1
	text_p( n ) = text
	iphot_p( n ) = iphot
	ishift_p( n ) = ishift
	iblur_p( n ) = iblur
	icont_p( n ) = icont
	icomp_p( n ) = icomp

	if( iphot .gt. 0 ) ipscale( iphot ) = n
	if( ishift .gt. 0 ) ipshift( ishift ) = n
	if( iblur .gt. 0 ) ipblur( iblur ) = n
	if( icont .gt. 0 ) ipcont( icont ) = n

	if( iblr .gt. 0 ) ipblr = n
      else
	notweak = notweak + 1
	lt = len1(text)
	call append( record, text(:lt) )
	if( gabby ) write(*,*) 'No basis for tweaking ', text(:lt)
      end if
* next parameter i
      end do
	np = n

* count number of lightcurves of each type
	jphot = 0
	jcont = 0
	jcomp = 0
	jshift = 0
	jblur = 0
      do ip = 1, np
	jphot = max( jphot, iphot_p( ip ) )
	jcont = max( jcont, icont_p( ip ) )
	jcomp = max( jcomp, icomp_p( ip ) )
	jshift = max( jshift, ishift_p( ip ) )
	jblur = max( jblur, iblur_p( ip ) )
      end do
	jblr = 0
	if( iblr .gt. 0 ) jblr = 1

* report
      if( notweak .lt. maxpar ) then
	write(*,*) 'No basis for tweaking', notweak, ' /', maxpar, ' parameters:'
	write(*,*) record(:len1(record))
      end if
	write(*,*) 'Lightcurves for joint fit:', np

* strip joint parameters from the todo list
      IF( .FALSE. ) THEN
c      IF( .TRUE. ) THEN
	list = todo
	call strip( list, 'F' )
	call strip( list, 'W' )
	call strip( list, 'S' )
	call strip( list, 'C' )
	call strip( list, 'B' )
	call strip( list, 'J' )
	write(*,*) 'ToDo : ', todo(:len1(todo)), ' => ', list(:len1(list))
	todo = list
      END IF


      if( np .gt. 0 ) then
	write( fmt, '(a,i3,a)' ) '(', np, '(i3,2a))'
	call nospace( fmt )
	write(*,fmt) ( i, ' ', text_p(i)(:len1(text_p(i))), i=1,np )

	write(*,*) 'Parameter key:'
	write( fmt, '(4(a,i3,a))' )
     &		  '(a,', npscale, 'i3'
     &		, ',a,', npshift, 'i3'
     &		, ',a,', npblur, 'i3'
     &		, ',a,', npcont, 'i3)'
	call nospace( fmt )
	write(*,fmt) ' Phot:', ( ipscale(i), i=1,npscale )
     &		, ' Shift:', ( ipshift(i), i=1,npshift )
     &		, ' Blur:', ( ipblur(i), i=1,npblur )
     &		, ' Cont:', ( ipcont(i), i=1,npcont )

* caution
	caution = 0.5
      if( npscale .gt. 0 .and. ipscale( 1 ) .gt. 0 ) then
	caution = 0.3
	if( logp ) caution = 0.2
      end if
	caution = 0.5

* time loop
      do it = 1, nt
	write(*,*) '=========== Epoch', it, ' of', nt, ' ===================='
	write(*,*) '=========== Iteration', nits, ' to go', lastit - nits


* compute and stow patterns
      do ip = 1, np
	icont = icont_p( ip )
	iphot = iphot_p( ip )
	icomp = icomp_p( ip )
	ishift = ishift_p( ip )
	iblur = iblur_p( ip )
	text = text_p( ip )
	lt = len1(text)
* report
c      if( gabby .or. .true. ) then
      if( gabby ) then
      if( iphot .gt. 0 ) then
	write(*,*) 'Pattern', ip, ' Phot', iphot, ' ', text(:lt)
      else if( ishift .gt. 0 ) then
	write(*,*) 'Pattern', ip, ' Shft', ishift, ' ', text(:lt)
      else if( iblur .gt. 0 ) then
	write(*,*) 'Pattern', ip, ' Blur', iblur, ' ', text(:lt)
      else if( icont .gt. 0 ) then
	write(*,*) 'Pattern', ip, ' Cont', icont, ' ', text(:lt)
      else if( icomp .gt. 0 ) then
	write(*,*) 'Pattern', ip, ' Comp', icomp, ' ', text(:lt)
      else if( ip .eq. ipblr ) then
	write(*,*) 'Pattern', ip, '  BLR', ipblr, ' ', text(:lt)
      end if
      end if


* Gaussian priors
	prior_p( ip ) = 0.
	sigprior_p( ip ) = 0.
      if( iphot .gt. 0 ) then
      if( siglnp0 .gt. 0. ) then
	sigprior_p( ip ) = siglnp0
      end if
      end if

* wavelengths
	n = 0
	iw1 = nw + 1
	iw2 = 0
      do iw = 1, nw
	iwt = iw + nw * ( it - 1 )

* masks for wavelength iw
* maskp = photometric factor
	maskp = npixnlr .le. 0 .or. masknlr( iw )
* maskb = blr
	maskb = maskblr( iw )
* maska = any other blr component
	maska = .false. 
      if( jcomp .gt. 0 ) then
      do i = 1, np
	ic = icomp_p( i )
      if( ic .gt. 0 ) then
      do lc = 1, nline_c( ic )
        l = line_lc( lc, ic )
      if( npix_l( l ) .gt. 0 ) then
        maska = maska .or. mask_wl( iw, l )
      end if
      end do
      end if
      end do
      end if
* maskc = continuum
	maskc = .not. ( maskb .or. maska .or. masknlr( iw ) )

* KDH : TRY THIS TO SEE IF IT HELPS CONVERGENCE
	maskc = .true.
	maskp = .true.

* masks for pattern ip at wavelength iw

* mask for cont fit
      if( icont .gt. 0 ) then
	mask = maskc

* mask for phot fit
      else if( iphot .gt. 0 ) then
	mask = maskp

* KDH : DOES THIS CORRECTLY INCLUDE CONTINUUM AND BLR WAVELENGTHS ?
	if( jcomp .gt. 0 ) mask = mask .or. maska
	if( jblr  .gt. 0 ) mask = mask .or. maskb
	if( jcont .gt. 0 ) mask = mask .or. maskc
* KDH : TRY THIS
c	mask =.true.

* mask for shift fit
      else if( ishift .gt. 0 ) then
	mask = maskp
* mask for blur fit
      else if( iblur .gt. 0 ) then
	mask = maskp
* mask for blr fit
      else if( ip .eq. ipblr ) then
	mask = maskb
* mask for any other line fit
      else if( icomp .gt. 0 ) then
        mask = .false.
	ic = icomp
      do lc = 1, nline_c( ic )
        l = line_lc( lc, ic )
      if( npix_l( l ) .gt. 0 ) then
        mask = mask .or. mask_wl( iw, l )
      end if
      end do
      end if

* compute pattern
	pat = 0.
      if( mask ) then
	xw = xw_w( iw )
* KDH : CAN WE AVOID THIS T-DEPENDENCE ?
	p0 = p0_t( it )
	p1 = p1_t( it )
	p2 = p2_t( it )
	p = p0 + xw * ( p1 + xw * p2 )
	if( logp ) p = exp( p )
* photometry
      if( iphot .gt. 0 ) then

c	pat = avg_w( iw )
c	if( npixnlr .gt. 0 ) pat = elr_w( iw )
* KDH : SHOULD THIS BE THE PHOTOMETRY PATTERN ?
	pat = avg_w( iw )
      if( npixnlr .gt. 0 ) then
	pat = fit_wt( iwt ) / p - avg_w( iw ) - elr_w( iw )
c	if( masknlr( iw ) ) pat = elr_w( iw )
	if( masknlr( iw ) ) pat = pat + elr_w( iw )
* KDH : TRY THIS
	pat = fit_wt( iwt ) / p - avg_w( iw )
      end if

      do k = 2, iphot
	pat = pat * xw
      end do

	if( logp ) pat = pat * p

* KDH : SHOULD DIM CORRECTION APPLY OTHER PATTERNS?
	pat = pat * fitdim_w( iw )

* shift
      else if( ishift .gt. 0 ) then
	pat = - p * df_wt( iwt )
	k = ishift
	if( k .ge. 2 ) pat = pat * xw
	if( k .ge. 3 ) pat = pat * xw

* blur
      else if( iblur .gt. 0 ) then
	pat = p * ddf_wt( iwt )
	k = iblur
	if( k .ge. 2 ) pat = pat * xw
	if( k .ge. 3 ) pat = pat * xw

* continuum
      else if( icont .gt. 0 ) then
	pat = p
      do k = 2, icont
	pat = pat * xw
      end do

* line components
      else if( icomp .gt. 0 ) then
	l = line_lc( 1, icomp )
      if( npix_l( l )  .gt. 0 ) then
	i1 = iw1_l( l )
	i2 = iw2_l( l )
      if( iw .ge. i1 .and. iw .le. i2 ) then
	pat = p * dat_wl( iw, l )
      end if
      end if
* blr
      else if( ip .eq. ipblr ) then
	pat = p * blr_w( iw )
	pat = pat * fitdim_w( iw )
      end if
* count non-zero pattern values
      if( pat .ne. 0. ) then
	n = n + 1
	iw1 = min( iw, iw1 )
	iw2 = max( iw, iw2 )
      end if
      end if

* min and max pattern
      if( iw .eq. 1 ) then
	pmn = pat
	pmx = pmn
      else
	pmn = min( pmn, pat )
	pmx = max( pmx, pat )
      end if

* stow
	ipw = ip + np * ( iw - 1 )
	mask_pw( ipw ) = mask
	pat_pw( ipw ) = pat

* next wavelength iw
      end do

* stow
	iw1_p( ip ) = iw1
	iw2_p( ip ) = iw2
* report
	if( gabby ) write(*,*) ' Patern mn,mx', pmn, pmx
      if( n .gt. 0 ) then
      if( gabby ) then
	write(*,*) ' Wavelengths', n, ' of', iw2-iw1+1
     &		, ' in', nint(w_w(iw1)), nint(w_w(iw2))
      end if
      else
	write(*,*) ' ** ERROR : Pattern vanishes at all wavelengths :((('
	write(*,*) ' Pattern', ip, ' ', text( : len1(text) ), pmn, pmx
	write(*,*) '   iw1,2', iw1, iw2
c	stop '** PrepSpec abort.  :((('
* KDH : BELOW WE SET H_PP=1 AND C_P=0 WHEN THIS OCCURS
      end if
* next pattern ip
      end do

* zap hessian matrix and correlation vector
      do i = 1, np * np
	h_pp( i ) = 0.d0
      end do
      do i = 1, np
	c_p( i ) = 0.d0
	ipt = i + np * ( it - 1 )
	par_p( i ) = par_pt( ipt )
      end do

	if( gabby )
     &	write(*,*) 'Hessian matrix and correlation vector now 0.'

* Gaussian priors
	k = 0
      do i = 1, np
        sig = sigprior_p( i )
      if( sig .gt. 0. ) then
* prior for change from current parameter value
        dat = prior_p( i ) - par_p( i )
        wgt = 1. / ( sig * sig )
        ii = i + ( i - 1 ) * np
	h_pp( ii ) = h_pp( ii ) + wgt
        c_p( i ) = c_p( i ) + dat * wgt
	k = k + 1
      if( gabby ) then
	text = text_p( i )
	write(*,*) ' ', text(:len1(text)), ' ', dat, ' +/-', sig
      end if
      end if
      end do
* report
      if( k .eq. 0 ) then
	write(*,*) 'Priors uniform on all', np, ' parameters.'
      else
	write(*,*) 'Priors uniform on all but', k, ' of', np, ' parameters.'
      do i = 1, np
	sig = sigprior_p( i )
      if( sig .gt. 0. ) then
	p = par_p( i )
	s = sig_p( i )
	dat = prior_p( i )
	text = text_p( i )
	lt = len1( text )
	write(*,*) ' Param(', i, ' ) = (', p, ' +/-', s, ' ) ', text(:lt)
	write(*,*) ' Prior(', i, ' ) = (', dat, ' +/-', sig, ' )'
      end if
      end do
      end if
      if( gabby ) then
	write(*,*) 'Initial Correlation vector:', np
	call showvec( np, c_p, text_p )
	write(*,*) 'Initial Hessian matrix:'
	call showmat( np, h_pp, text_p )
      end if

* KDH : FOR SOME REASON CRASHES WHEN THIS IS ON
      if( chifix ) then
	call mnmx( nw * nt, chifix_wt, cmn, cmx )
	if( gabby ) write(*,*) 'Chifix:', chifix, ' mn,mx', cmn, cmx
      end if

* build hessian matrix and correlation vector

* parameter loops
      do ip = 1, np
      do jp = 1, ip
	iw1 = max( iw1_p( ip ), iw1_p( jp ) )
	iw2 = min( iw2_p( ip ), iw2_p( jp ) )
      if( iw1 .le. iw2 ) then
* wavelengths
	ng = 0
	sum = 0.d0
	sumw = 0.d0
      do iw = iw1, iw2
	iwt = iw + nw * ( it - 1 )
	ipw = ip + np * ( iw - 1 )
	jpw = jp + np * ( iw - 1 )
* pre-stowed patterns
	maski = mask_pw( ipw )
	maskj = mask_pw( jpw )
	pati = pat_pw( ipw )
	patj = pat_pw( jpw )
* wavelength must pass both masks
      if( maski .and. maskj ) then
	sig = sig_wt( iwt )
	if( chifix ) sig = sig * chifix_wt( iwt )
      if( sig .gt. 0. ) then
* data
	dat = dif_wt( iwt )
	wgt = pati / ( sig * sig )
	sum =  sum  + wgt * dat
	sumw = sumw + wgt * patj
	ng = ng + 1
      end if
* next wavelength iw
      end if
      end do
* accumulate
      if( ng .gt. 0 ) then
	ij = ip + ( jp - 1 ) * np
	ji = jp + ( ip - 1 ) * np
	h_pp( ij ) = h_pp( ij ) + sumw
	h_pp( ji ) = h_pp( ij )
	if( jp .eq. ip ) c_p( jp ) = c_p( jp ) + sum
      end if
      end if
* next jp
      end do
* next ip
      end do

* catch bad patterns
      do i = 1, np
	ii = i + np * ( i - 1 )
	h = h_pp( ii )
      if( h .le. 0. ) then
	text = text_p( i )
	c = c_p( i )
	write(*,*) '** BAD PATTERN', i, ' ', text(:len1(text) ), ' :(((('
	write(*,*) '** Col:', ( real( h_pp( i + np*(j-1) ) ), j=1,np )
	write(*,*) '** Row:', ( real( h_pp( j + np*(i-1) ) ), j=1,np )
	write(*,*) '** H =', h, ' ->', 1.
	write(*,*) '** C =', c, ' ->', 0.
	h_pp( ii ) = 1.
	c_p( i ) = 0.
      end if
      end do

* Correct Hession for curvature vectors
* KDH : CURVATURE VECTORS NOT IMPLEMENTED


* KDH : TEMPORARY - GABBY
	igab = 0
	if( gabby ) igab = 1
	gabby = .true.
	gabby = .false.

* report
      if( gabby ) then

* correlation vector
      do ip = 1, np
	title = 'C('
	call append_i( title, ip )
	call append( title, ')=' )
	call append_f( title, real( c_p(ip) ), '*' )
	call nospace( title )
	call append( title, text_p(ip) )
	write(*,*) title(:len1(title))
      end do

* hessian matrix
      do ip = 1, np
      do jp = 1, ip
	title = 'H('
	call append_i( title, ip )
	call append( title, ',' )
	call append_i( title, jp )
	call append( title, ')=' )
	h = h_pp( ip + np * ( jp - 1 ) )
	call append_f( title, h, '*' )
	call nospace( title )
	call append( title, text_p(ip) )
	call append( title, text_p(jp) )
	write(*,*) title(:len1(title))
      end do
      end do

* report
	write(*,*) 'Correlation vector:', np
	call showvec( np, c_p, text_p )
      do i = 1, np * np
	c_pp( i ) = h_pp( i )
      end do
	write(*,*) 'Hessian:'
	call showmat( np, c_pp, text_p )
	call matinv( c_pp, np, det )
	write(*,*) 'Det(H)', det
	write(*,*) 'Inverse Hessian:'
	call showmat( np, c_pp, text_p )
      end if

* KDH : ESTIMATE CHANGE IN CHI^2
* KDH : THIS JUST CONFIRMS THAT THE LINEAR SOLUTION IS WORKING
      IF( .FALSE. ) THEN
c      IF( .true. ) THEN
* parameter steps
	cold = 0.
	caution = caution_t( it )
	nloop = 3
      do loop = 1, nloop
      if( caution .ne. cold ) then
	write(*,*) 'Loop', loop, ' of', nloop

	if( gabby ) write(*,*) 'Parameter steps:', np, ' caution', caution
      do i = 1, np
	add = 0.d0
	ij = ( i - 1 ) * np
        ii = i + ij
      do j = 1, np
	ij = ij + 1
	add = add + c_pp( ij ) * c_p( j )
      end do
	add = add * caution
* stow
	dp_p( i ) = add
* report
      if( gabby ) then
	sigp = sqrt( c_pp( ii ) )
	sigpold = sqrt( 1. / h_pp( ii ) )
	text = text_p( i )
	write(*,*) 'dP(', i, ' )', add, ' ', text(:len1(text))
     &	, ' sig', sigp, ' old', sigpold
      end if
* next parameter
      end do

* old and new Chi^2
* KDH : IGNORES SCALE/SHIFT/BLUR CHANGES IN PATTERNS
*   AND PATTERNS EXTENDING OUTSIDE THEIR FIT MASK
      
* trial steps
	nstep = 4
      do istep = 1, nstep
	step = istep - 2
	chi2old = 0.d0
	chi2new = 0.d0
* wavelengths
	i0 = nw * ( it - 1 )
      do iw = 1, nw
	iwt = i0 + iw 
	dif = dif_wt( iwt )
	sig = sig_wt( iwt )
	if( chifix ) sig = sig * chifix_wt( iwt )
      if( sig .gt. 0. ) then
	e = dif / sig
	chi2old = chi2old + e * e
* new Chi2 with parameter step
	sum = 0.d0
	i0 = np * ( iw - 1 )
      do ip = 1, np
	ipw = i0 + ip
	sum = sum + step * dp_p( ip ) * pat_pw( ipw )
      end do
	e = ( dif - sum ) / sig
	e = ( dif + sum ) / sig
	chi2new = chi2new + e * e
* next iw
      end if
      end do
* stow
	plot1( istep ) = step
	plot2( istep ) = chi2new - chi2old
	write(*,*) 'Step', step, ' Chi2', chi2new
     &		, ' dChi2', chi2new - chi2old
* next trial step
      end do
* report
c	write(fmt,*) '(a,', nstep, 'f10.2)'
c	call nospace( fmt )	
c	write(*,fmt) ' step', ( plot1( i ), i = 1, nstep )
c	write(*,fmt) 'dChi2', ( plot2( i ), i = 1, nstep )

* adjust caution
	dchi2 = chi2new - chi2old
	cfac = 0.7
	cold = caution
      if( dchi2 .lt. 0. ) then
	write(*,*) 'DeltaChi2', dchi2, ' :)'
	cnew = cold / cfac
      else if( dchi2 .eq. 0. ) then
	write(*,*) 'DeltaChi2', dchi2, ' :|'
	cnew = cold
      else if( dchi2 .gt. 0. ) then
	write(*,*) 'DeltaChi2', dchi2, ' :('
	cnew = cold * cfac
      end if

* shorten the step
	caution = max( 0.1, min( 1.0, cnew ) )
      if( caution .ne. cold ) then
	write(*,*) 'Caution: ', cold, ' ->', caution
c	read(*,*)
      end if

* next loop
      end if
      end do
* stow 
	caution_t( it ) = caution
	gabby = igab .ne. 0
	igab = 0
* CODE ABOVE DISABLED
      END IF

* KDH : THIS IS DISABLED
* Levenberg-Marquardt loop  -----------------------------------------
	lmon = 0
      IF( lmon .ne. 0 ) THEN
	dchi2 = 1.
	bad = 0.0
	loop = 0
	lastloop = 1
	alam = alam_t( it )
      do while( loop .lt. lastloop .and. dchi2 .gt. bad )
	loop = loop + 1
	write(*,*) '----------------------------------------'
	write(*,*) 'Levenberg-Marquardt Loop', loop, ' lambda', alam

* copy hessian
	nn = np * np
      do i = 1, np * np
	c_pp( i ) = h_pp( i )
      end do
* boost diagonals
      if( alam .gt. 0. ) then
      do i = 1, nn, n+1
	c_pp( i ) = h_pp( i ) * ( 1. + alam )
      end do
* report
	write(*,*) 'Boosted Hessian matrix:', np, ' x', np
	call showmat( np, c_pp, text_p )
      end if

* invert matrix
	call matinv( c_pp, np, det )

* report determinant
      if( det .le. 0. ) then
	write(*,*) '** Determinant:', det, ' not positive  :((('
	write(*,*) '   it', it, ' np', np, ' det(H)', det
      else if( gabby ) then
	write(*,*) '** Determinant:', det, ' > 0  :)'
      end if

! check for vanishing variances
        nbad = 0
      do i = 1, np
        ii = i + np * ( i - 1 )
      if( c_pp( ii ) .le. 0.d0 ) then
        write(*,*) '** VAR[', i, ']=', c_pp(ii), ' :(((('
        nbad = nbad + 1
      end if

      end do

* parameter steps
	if( gabby ) write(*,*) 'Parameter steps:', np, ' caution', caution
      do i = 1, np
	add = 0.d0
	ij = ( i - 1 ) * np
        ii = i + ij
      do j = 1, np
	ij = ij + 1
	add = add + c_pp( ij ) * c_p( j )
      end do
	add = add * caution
* stow
	dp_p( i ) = add
* report
      if( gabby ) then
	sigp = sqrt( c_pp( ii ) )
	sigpold = sqrt( 1. / h_pp( ii ) )
	text = text_p( i )
	write(*,*) 'dP(', i, ' )', add, ' ', text(:len1(text))
     &	, ' sig', sigp, ' old', sigpold
      end if
* next parameter
      end do

* old and new Chi^2
* KDH : IGNORES SCALE/SHIFT/BLUR CHANGES IN PATTERNS
*   AND PATTERNS EXTENDING OUTSIDE THEIR FIT MASK
	chi2old = 0.d0
	chi2new = 0.d0
	i0 = nw * ( it - 1 )
      do iw = 1, nw
	iwt = i0 + iw 
	dif = dif_wt( iwt )
	sig = sig_wt( iwt )
	if( chifix ) sig = sig * chifix_wt( iwt )
      if( sig .gt. 0. ) then
	eta = dif / sig
	chi2old = chi2old + eta * eta
* new Chi2 with parameter step
	sum = 0.d0
	i0 = np * ( iw - 1 )
      do ip = 1, np
	ipw = i0 + ip
	sum = sum + dp_p( ip ) * pat_pw( ipw )
      end do
	eta = ( dif - sum ) / sig
	chi2new = chi2new + eta * eta 
* next iw
      end if
      end do
* report
	write(*,*) 'Chi2old', chi2old, ' new', chi2new
	dchi2 = chi2new - chi2old
	if( dchi2 .lt. 0. ) write(*,*) 'DeltaChi2', dchi2, ' :)'
	if( dchi2 .eq. 0. ) write(*,*) 'DeltaChi2', dchi2, ' :|'
	if( dchi2 .gt. 0. ) write(*,*) 'DeltaChi2', dchi2, ' :('

* boost lambda if Chi2 got worse
	boost = 10.
      if( dchi2 .gt. bad ) then
	if( alam .le. 0. ) alam = 1.e-6
        write(*,*) 'Lambda', alam, ' =>', alam * boost
        alam = alam * boost
* deboost lambda if Chi2 improved
      else if( dchi2 .le. 0. ) then
        write(*,*) 'Lambda', alam, ' =>', alam / boost
	alam = alam / boost
      end if
* next L-M loop
      end do
	write(*,*) '----------------------------------------'
	write(*,*) 'Final L-M Loop', loop, ' lambda', alam
* stow lambda for next iteration
	alam_t( it ) = alam
      END IF
* KDH : THIS IS DISABLED
* END OF L-M CODE ---------------------------------------------------

* copy hessian
	nn = np * np
      do i = 1, nn
	c_pp( i ) = h_pp( i )
      end do
* inverse hessian
	call matinv( c_pp, np, det )

* report
      if( gabby ) then
	write(*,*) 'Hessian matrix:'
	call showmat( np, h_pp, text_p )
	if( det .gt. 0. ) write(*,*) 'Det(H):', det, ' > 0 :)))'
      end if

* singular matrix
      if( det .le. 0. ) then
	write(*,*) 'Det(H):', det, ' not > 0 :(((('
	write(*,*) '** SINGULAR HESSIAN.  it', it, ' np', np
      if( .not. gabby ) then
	write(*,*) 'Hessian matrix:'
	call showmat( np, h_pp, text_p )
	write(*,*) 'Correlation vector:'
	call showvec( np, c_p, text_p )
	write(*,*) 'Inverse Hessian:'
	call showmat( np, c_pp, text_p )
      end if
      end if

      if( gabby ) then
	write(*,*) 'Inverse Hessian:'
	call showmat( np, c_pp, text_p )
      end if

* parameter steps
	if( gabby ) write(*,*) 'Parameter steps:', np, ' caution', caution
      do i = 1, np
	add = 0.d0
	ij = ( i - 1 ) * np
	ii = i + ij
      do j = 1, np
	ij = ij + 1
	add = add + c_pp( ij ) * c_p( j )
      end do
	add = add * caution
	dp_p( i ) = add
* report
      if( gabby ) then
	sigp = -1.
	sigpold = -1.
	ss = c_pp( ii )
      if( ss .gt. 0. ) then
	sigp = sqrt( ss )
	sigpold = sqrt( 1. / h_pp( ii ) )
      end if
	text = text_p( i )
	write(*,*) 'dP(', i, ' )', add, ' ', text(:len1(text))
     &	, ' sig', sigp, ' old', sigpold
      end if
      end do
c	call showvec( np, dp_p, text_p )

* c_pp should be a positive-definite covariance matrix
      do i = 1, np
	ii = i + np * ( i - 1 )
* parameter error bars
	var = c_pp( ii )
      if( var .gt. 0. ) then
	sig_p( i ) = sqrt( var )
* bad variance
      else
	write(*,*) '** Var[', i, ' ]', var, ' not > 0. :((((((((('
	sig_p( i ) = -1.
c	stop '** PrepSpec abort.  :((('
      end if

* correlation matrix
      do j = 1, i
	ij = i + (j-1) * np
	c_pp( ij ) = c_pp( ij ) / sig_p( i ) / sig_p( j )
	ji = j + (i-1) * np
	c_pp( ji ) = c_pp( ij )
      end do
      end do

* report
c      if( gabby ) then
	write(*,*) 'Correlation matrix:'
	call showmat( np, c_pp, text_p )
c      end if

* KDH : sometimes F and B components unstable
* KDH 2019 MAY : SHORTEN STEPS IF PHOT FACTOR STEP TOO LARGE
* shorten steps to (hopefully) prevent
	add = 0.
      do i = 1, np
	iphot = iphot_p( i )
      if( iphot .gt. 0 ) then
	add = max( add, abs( dp_p( i ) ) )
      end if
      end do
	care = 1.
	big = 0.1
      if( add .gt. big ) then
	write(*,*) '** WARNING: PHOTOMETRIC CORRECTION', add, ' > ', big
	care = care * big / add
      end if

* tweak parameters
      do i = 1, np 
	add = dp_p( i ) * care
	sig = sig_p( i )
	icont = icont_p( i )
	iphot = iphot_p( i )
	icomp = icomp_p( i )
	ishift = ishift_p( i )
	iblur = iblur_p( i )
* continuum
      if( icont .ge. 1 .and. icont .le. npcont ) then

	p = cont_tp( it, icont ) + add
	cont_tp( it, icont ) = p
	sigcont_tp( it, icont ) = sig

* photometry
      else if( iphot .eq. 1 ) then
	p = p0_t( it ) + add
	p0_t( it ) = p
	sigp0_t( it ) = sig
      else if( iphot .eq. 2 ) then
	p = p1_t( it ) + add
	p1_t( it ) = p
	sigp1_t( it ) = sig
      else if( iphot .eq. 3 ) then
	p = p2_t( it ) + add
	p2_t( it ) = p
	sigp2_t( it ) = sig
* shift
      else if( ishift .eq. 1 ) then
	p = x0_t( it ) + add
	x0_t( it ) = p
	sigx0_t( it ) = sig
      else if( ishift .eq. 2 ) then
	p = x1_t( it ) + add
	x1_t( it ) = p
	sigx1_t( it ) = sig	
* blur
      else if( iblur .eq. 1 ) then
	p = s0_t( it ) + add
	s0_t( it ) = p
	sigs0_t( it ) = sig
      else if( iblur .eq. 2 ) then
	p = s1_t( it ) + add
	s1_t( it ) = p
	sigs1_t( it ) = sig	
* spectral components
      else if( icomp .gt. 0 ) then
	l = line_lc( 1, icomp )
	p = dat_tl( it, l ) + add
	dat_tl( it, l ) = p
	sig_tl( it, l ) = sig
* blr
      else if( i .eq. ipblr ) then
	p = blr_t( it ) + add
	blr_t( it ) = p
	sigblr_t( it ) = sig
      end if

* stow parameter
	par_p( i ) = p
* stow time-dependent parameter
	ipt = i + np * ( it - 1 )
	par_pt( ipt ) = p
	sig_pt( ipt ) = sig

* report
	if( i .eq. 1 ) write(*,*) 'Caution:', caution, ' Care', care
	text = text_p( i )
	write(*,'( 1x, a5, i3, 3(a,1pe11.3), a, 1pe11.3, a )' )
     &		text(: len1(text) ), i
     &		, ' ', p
     &		, ' sigma', sig
     &		, ' step', add
     &		, ' =', add / sig, ' sigma.'

* next parameter i
      end do

* stow time-dependent correlation matrix
      if( it .gt. 1 .and. np .ne. npar ) then
	write(*,*) '** ERROR npar =', npar, ' ->', np
	stop '** PrepSpec abort.  :((('
      end if

	npar = np
	nn = np * np
	i0 = nn * ( it - 1 )
      do i = 1, nn
	c_ppt( i0 + i ) = c_pp( i )
      end do

* DEBUG OUTPUT
      IF( .FALSE. ) THEN
	write(*,*) 'IT', it, ' npar', npar
      do i = 1, npar
	k = nn * ( it - 1 ) + npar * ( i - 1 )
	write(*,*) i, ( nint( c_ppt( k + j ) * 1000 ), j = 1, npar )
      end do
      END IF
* END OF DEBUG OUTPUT

* next time it
      end do
	write(*,*) '=========== Final Epoch', nt, ' ===================='
	write(*,*) ' BLR/NLR', nint( vblr), nint( vnlr )
	write(*,*) '    want', nint( vbwant), nint( vnwant )
	write(*,*) '=========== Iteration', nits, ' to go', lastit - nits

* report largest L-M lambda
      IF( lmon .ne. 0 ) THEN
	call mnmx( nt, alam_t, amn, amx )
	write(*,*) 'L-M lambda range:', amn, amx
	write(*,*) (alam_t(i),i=1,nt)
      END IF

* report
	write(*,*) 'Lightcurve stats:'
      do i = 1, np
	icont = icont_p( i )
	iphot = iphot_p( i )
	ishift = ishift_p( i )
	iblur = iblur_p( i )
	icomp = icomp_p( i )
	text = text_p( i )
	lt = len1( text )
* continuum
      if( icont .ge. 1 .and. icont .le. npcont ) then
	call avgrms( nt, cont_tp( 1, icont ), avg, rms )
	write(*,*) 'cont(', icont-1, ' ) avg', avg, ' rms', rms

* photometry
      else if( iphot .eq. 1 ) then
	call avgrms( nt, p0_t, f0avg, f0rms )
	write(*,*) '   phot p0 avg', f0avg, ' rms', f0rms
      else if( iphot .eq. 2 ) then
	call avgrms( nt, p1_t, f1avg, f1rms )
	write(*,*) '        p1 avg', f1avg, ' rms', f1rms
      else if( iphot .eq. 3 ) then
	call avgrms( nt, p2_t, f2avg, f2rms )
	write(*,*) '        p2 avg', f2avg, ' rms', f2rms
      else if( iphot .eq. 4 ) then
	call avgrms( nt, p3_t, f3avg, f3rms )
	write(*,*) '        p3 avg', f3avg, ' rms', f3rms
* shift
* KDH : WHY ARE THESE 0 AFTER JOINT FIT ?
      else if( ishift .eq. 1 ) then
	call avgrms( nt, x0_t, x0avg, x0rms )
	write(*,*) '  shift x0 avg', x0avg, ' rms', x0rms
      else if( ishift .eq. 2 ) then
	call avgrms( nt, x1_t, x1avg, x1rms )
	write(*,*) '        x1 avg', x1avg, ' rms', x1rms
* blur
      else if( iblur .eq. 1 ) then
	call avgrms( nt, s0_t, s0avg, s0rms )
	write(*,*) '   blur s0 avg', s0avg, ' rms', s0rms
      else if( iblur .eq. 2 ) then
	call avgrms( nt, s1_t, s1avg, s1rms )
	write(*,*) '        s1 avg', s1avg, ' rms', s1rms
* VarBLR components
      else if( icomp .gt. 0 ) then
	l = line_lc( 1, icomp )
	call avgrms( nt, dat_tl( 1, l ), avg, rms )
	write(*,*) text(:lt), ' avg', avg, ' rms', rms
	if( rms .le. 0. ) write(*,*) '** WARNING: RMS NOT POSITIVE :((.'
* BLR component ?
      end if      
* next parameter i
      end do

* KDH : REVISE FIT DEGREES OF FREEDOM
	icont = 0
	iphot = 0
	icomp = 0
	ishift = 0
	iblur = 0
      do i = 1, np
	icont = max( icont, icont_p( i ) )
	iphot = max( iphot, iphot_p( i ) )
	icomp = max( icomp, icomp_p( i ) )
	ishift = max( ishift, ishift_p( i ) )
	iblur = max( iblur, iblur_p( i ) )
      end do
	if( icont .gt. 0 ) nfitcont = max( nfitcont, nt * npcont )
	if( iphot .gt. 0 ) nfitphot = max( nfitphot, nt * npscale )
	if( ishift .gt. 0 ) nfitshift = max( nfitshift, nt * npshift )
	if( iblur .gt. 0 ) nfitblur = max( nfitblur, nt * npblur )
* report
	write(*,*) 'Nfit cont', nfitcont,  ' phot', nfitphot
	write(*,*) '    shift', nfitshift, ' blur', nfitblur
      else
	write(*,*) '** NO LIGHTCURVES TO TWEAK', np
      end if

* remove joint parameters from the todo list
c      IF( .FALSE. ) THEN
      IF( .TRUE. ) THEN
	list = todo
	call strip( list, 'F' )
	call strip( list, 'W' )
	call strip( list, 'S' )
	call strip( list, 'C' )
	call strip( list, 'B' )
	call strip( list, 'J' )
	write(*,*) 'ToDo : ', todo(:len1(todo)), ' => ', list(:len1(list))
	todo = list
      END IF

* KDH : REVISE VarBLR SPECTRA
* KDH : TEMPORARY CODE LETS USER CHOOSE
	write(*,*) 'icomp', icomp, ' iblr', iblr
	reply = 'N'
	if( icomp .gt. 0 .or. iblr .gt. 0 ) reply = 'Y'
c	call inq( 'Revise BLR spectra', reply, reply )
	call upcase( reply, reply )

* KDH : COULD HAVE A SWITCH TO TURN OFF LIGHTCURVE TWEAK AT 541
* KDH : BELOW WE DUPLICATE THE SPECTRUM TWEAK CODE.

* REVISE BLR SPECTRUM
      IF( reply .eq. 'Y' ) THEN
	igab = 0
	if( gabby ) igab = 1
	gabby = .true.
	gabby = .false.
* report
      if( gabby ) then
	write(*,*) 'BLR waves', ngw, ' of', nw
	write(*,*) 'BLR times', ngt, ' of', nt
	write(*,*) 'BLR lightcurve avg', blrtavg, ' rms', blrtrms
	write(*,*) 'Mean subtracted'
      end if
	call optavgrms( nt, blr_t, sigblr_t, avg, rms )
      if( gabby ) then
	write(*,*) 'BLR lightcurve avg', avg, ' rms', rms
      end if

* REVISE BLR SPECTRUM
	caution = 0.9
	ngw = 0
	ngt = 0
      do iw = 1, nw
      if( .not. maskbad( iw ) ) then
	dim = fitdim_w( iw )
	sum = 0.d0
	sumw = 0.d0
	ng = 0
	xw = xw_w( iw )
	i = iw - nw
      do it = 1, nt
	i = i + nw
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = blr_t( it ) * p * dim
	wgt = pat / ( sig * sig )
	sum  = sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
* next it
      end do
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	blr_w( iw ) = blr_w( iw ) + add
	sigblr_w( iw ) = sig
	ngw = ngw + 1
	ngt = max( ngt, ng )
      end if
      else
	blr_w( iw ) = 0.
	sigblr_w( iw ) = -1.
      end if
* next iw
      end do
	call avgrms( nw, blr_w, blrwavg, blrwrms )
      if( gabby ) then
	write(*,*) 'BLR times', ngt, ' of', nt
	write(*,*) 'BLR waves', ngw, ' of', nw
	write(*,*) 'BLR spectrum avg', blrwavg, ' rms', blrwrms
      end if
* degrees of freedom
c	nfitblr = nt + nw
	nfitblr = nt + ngw
	write(*,*) 'nfitblr=>', nt, ' +', ngw, ' =', nfitblr

* ------------------------------------------------------
* REVISE RMS BLR COMPONENTS
	caution = 0.9
* components
      do ic = 1, ncomp
	l = line_lc( 1, ic )
	text = text_l( l )
	lt = len1( text )
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	np = npix_c( ic )
      if( np .gt. 0 ) then

	if( gabby ) write(*,*)
	if( gabby ) write(*,*) 'revise ', text(:lt), ' model. Caution:', caution

* revise the lightcurve
* KDH : NO NEED TO REVISE THE LIGHTCURVE ?
      IF( .FALSE. ) THEN
* times
      do it = 1, nt
* scale spectral pattern to fit residuals
	sum = 0.d0
	sumw = 0.d0
	ng = 0
	i0 = ( it - 1 ) * nw
      do iw = iw1, iw2
	i = i0 + iw
      if( mask_wl( iw, l ) ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = dat_wl( iw, l ) * p
	wgt = pat / ( sig * sig )
	sum =  sum +  wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end if
      end do
* revise lightcurve
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	dat_tl( it, l ) = dat_tl( it, l ) + add
	sig_tl( it, l ) = sig
      end if
* next time it
      end do
      END IF

* subtract mean
	call avgrms( nt, dat_tl( 1, l ), avg, rms )
      do it = 1, nt
	dat_tl( it, l ) = dat_tl( it, l ) - avg
      end do

* report
      if( gabby ) then
	write(*,*) text(:lt), ' wavelengths', ng, ' of', nw
	write(*,*) text(:lt), ' lightcurve avg', avg, ' rms', rms
      end if
	call avgrms( nt, dat_tl( 1, l ), avg, rms )
      if( gabby ) then
	write(*,*) 'Mean subtracted'
	write(*,*) text(:lt), ' lightcurve avg', avg, ' rms', rms
      end if
* END REVISE BLR LIGHTCURVE

* REVISE BLR SPECTRUM
	caution = 0.9
	ngw = 0
* wavelengths
      do iw = iw1, iw2
* scale time pattern to fit residuals
	sum = 0.d0
	sumw = 0.d0
	xw = xw_w( iw )
	ng = 0
	i = iw - nw
      do it = 1, nt
	i = i + nw
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	p = p0_t( it ) + xw * ( p1_t( it ) + xw * p2_t( it ) )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = dat_tl( it, l ) * p
	wgt = pat / ( sig * sig )
	sum =  sum +  wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end do
* revise spectrum
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
	dat_wl( iw, l ) = dat_wl( iw, l ) + add
	sig_wl( iw, l ) = sig
	ngw = ngw + 1
      end if
* next wavelength iw
      end do
	nfit_l( l ) = nt + ngw
	call avgrms( nw, dat_wl(1,l), avg, rms )
* report
      if( gabby ) then
	write(*,*) text(:lt), ' times', ng, ' of', nt
	write(*,*) text(:lt), ' spectrum avg', avg, ' rms', rms
* KDH : IS NGW TOO BIG ?
	write(*,*) 'nfit', nfit_l(l), ' nt', nt, ' ngw', ngw
      end if

* next VarBLR component lc
      end if
      end do
	gabby = igab .ne. 0

* END BLR REVISION
	END IF
* now impose constraints
C	goto 525
	goto 524
* END OF JOINT PARAMETER FITS

* galaxy

  550	write(*,*) 'revise GALAXY'
	write(*,*) 'Not yet implemented :('
	goto 510

* wavelength jitter

  555	nloop = max( 1, min( 2, npshift ) )
	caution = 0.8
	if( gabby ) write(*,*) 'WAVELENGTH jitter ', nloop, caution
      do it = 1, nt
	p0 = p0_t( it )
	p1 = p1_t( it )
	p2 = p2_t( it )
	sum = 0.d0
	sumw = 0.d0
      do loop = 1, nloop
	ng = 0
	i = ( it - 1 ) * nw
      do iw = 1, nw
	i = i + 1
* KDH : USE FULL SPECTRUM IF NO NLR PIXELS.
      if( npixnlr .eq. 0 .or. masknlr( iw ) ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	p = p0 + xw * ( p1 + xw * p2 )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = - p * df_wt( i )
	if( loop .ge. 2 ) pat = pat * xw
	if( loop .ge. 3 ) pat = pat * xw
	wgt = pat / ( sig * sig )
	sum =  sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end if
* next iw
      end do

      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
      if( loop .eq. 1 ) then
	x0_t(it) = x0_t(it) + add
	sigx0_t(it) = sig
      else if( loop .eq. 2 ) then
	x1_t(it) = x1_t(it) + add
	sigx1_t(it) = sig
      end if
      end if
* next loop
      end do
* next it
      end do

	call avgrms( nt, x0_t, x0avg, x0rms )
	call avgrms( nt, x1_t, x1avg, x1rms )
      if( gabby ) then
	write(*,*) 'NLR wavelengths', ng, ' of', nw
	write(*,*) 'pixel jitter avg', x0avg, ' rms', x0rms
	write(*,*) '       slope avg', x1avg, ' rms', x1rms
      end if
	nfitshift = nt * nloop
C	goto 525
	goto 524

* seeing jitter

  560	nloop = max( 1, min( 2, npblur ) )
c	caution = 0.8
	caution = 0.5
	if( gabby ) write(*,*) 'SEEING jitter', nloop, caution
      do it=1,nt
	p0 = p0_t( it )
	p1 = p1_t( it )
	p2 = p2_t( it )
	sum = 0.d0
	sumw = 0.d0
      do loop = 1, nloop
	ng = 0
	i = ( it - 1 ) * nw
      do iw=1,nw
	i = i + 1
c      if( masknlr( iw ) .and. ( .not. maskblr( iw ) ) ) then
* KDH : USE FULL SPECTRUM IF NO NLR PIXELS.
      if( npixnlr .eq. 0 .or. masknlr( iw ) ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	p = p0 + xw * ( p1 + xw * p2 )
	if( logp ) p = exp( p )
	dat = dif_wt( i )
	pat = p * ddf_wt( i )
	if( loop .ge. 2 ) pat = pat * xw
	if( loop .ge. 3 ) pat = pat * xw
	wgt = pat / ( sig * sig )
	sum =  sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end if
* next wavelength iw
      end do
* update time-dependent coefficients
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
      if( loop .eq. 1 ) then
	s0_t( it ) = s0_t( it ) + add
	sigs0_t( it ) = sig
      else if( loop .eq. 2 ) then
	s1_t( it ) = s1_t( it ) + add
	sigs1_t( it ) = sig
      end if
      end if
* next loop
      end do
* next time it
      end do
* stats
	call avgrms( nt, s0_t, s0avg, s0rms )
	call avgrms( nt, s1_t, s1avg, s1rms )
	nfitblur = nt * nloop
* report
      if( gabby ) then
	write(*,*) 'NLR wavelengths', ng, ' of', nw
	write(*,*) 'seeing jitter avg', s0avg, ' rms', s0rms
	write(*,*) '        slope avg', s1avg, ' rms', s1rms
      end if
C	goto 525
	goto 524

* flux jitter

  565	nloop = max( 1, min( 3, npscale ) )
	caution = 0.5
	if( gabby ) write(*,*) 'FLUX jitter', nloop, caution
	if( npixnlr .le. 0 ) write(*,*) '** No NLR pixels - using full spectrum.'
      do it = 1, nt
	sum = 0.d0
	sumw = 0.d0
      do loop = 1, nloop
	i = ( it - 1 ) * nw
	p0 = p0_t( it )
	p1 = p1_t( it )
	p2 = p2_t( it )
	ng = 0
      do iw = 1, nw
	i = i + 1
* KDH : USE AVG SPECTRUM IF NO NLR PIXELS.
      if( npixnlr .eq. 0 .or. masknlr( iw ) ) then
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
      if( sig .gt. 0. ) then
	xw = xw_w( iw )
	dat = dif_wt( i )
* KDH : USE AVG SPECTRUM IF NO NLR PIXELS.
      if( npixnlr .gt. 0 ) then
	pat = elr_w( iw )
      else
	pat = avg_w( iw )
      end if
	if( loop .ge. 2 ) pat = pat * xw
	if( loop .ge. 3 ) pat = pat * xw
      if( logp ) then
	p = p0 + xw * ( p1 + xw * p2 )
	p = exp( p )
	pat = p * pat
      end if
	wgt = pat / ( sig * sig )
	sum =  sum  + wgt * dat
	sumw = sumw + wgt * pat
	ng = ng + 1
      end if
      end if
* next iw
      end do
      if( ng .gt. 0 .and. sumw .gt. 0.d0 ) then
	sig = dsqrt( 1.d0 / sumw )
	add = sum / sumw
	add = add * caution
      if( loop .eq. 1 ) then
	p0_t( it ) = p0_t( it ) + add
	sigp0_t( it ) = sig
      else if( loop .eq. 2 ) then
	p1_t( it ) = p1_t( it ) + add
	sigp1_t( it ) = sig
      else if( loop .eq. 3 ) then
	p2_t( it ) = p2_t( it ) + add
	sigp2_t( it ) = sig
      end if
      end if
* next loop
      end do
* next it
      end do
	call avgrms( nt, p0_t, f0avg, f0rms )
	call avgrms( nt, p1_t, f1avg, f1rms )
	call avgrms( nt, p2_t, f2avg, f2rms )
      if( gabby ) then
      if( npixnlr .gt. 0 ) then
	write(*,*) 'NLR wavelengths', ng, ' of', nw
      else
	write(*,*) 'Spectrum wavelengths', ng, ' of', nw
      end if
	write(*,*) 'flux jitter avg', f0avg, ' rms', f0rms
	if( nloop .gt. 1 ) write(*,*) '      slope avg', f1avg, ' rms', f1rms
	if( nloop .gt. 2 ) write(*,*) '       bend avg', f2avg, ' rms', f2rms
      end if
	nfitphot = nt * nloop
C	goto 525
	goto 524

* plot panel codes
  590	ipanavg = 0
	ipancont = 0
	ipannlrw = 0
	ipannlrt = 0
	ipanblrw = 0
	ipanblrt = 0
	ipanfit = 0
	ipandf = 0
	ipanddf = 0
	ipandiff = 0
	ipaneta = 0
	ipancal = 0
	ipanfc = 0
	ipanxc = 0
	ipansc = 0
	ipanbiasw = 0
	ipanbiast = 0
	ipanabsn = 0

	write(*,*) 'reply ', reply(:len1(reply))
	write(*,*) ' todo ', todo(:len1(todo))
	write(*,*) ' todolist ', todolist(:len1(todolist))

* 1-5 panel plot
      if(    reply(1:1) .eq. '1' 
     &	.or. reply(1:1) .eq. '2' 
     &	.or. reply(1:1) .eq. '3' 
     &	.or. reply(1:1) .eq. '4' 
     &	.or. reply(1:1) .eq. '5'
     &	) then
	nx = 1
	read( reply(1:1), * ) ny
	npan = ny
      if( ny .eq. 4 ) then
	nx = 2
	ny = 2
      else if( ny .eq. 5 ) then
	nx = 2
	ny = 3
      end if


* plot panel menu
	write(*,*) 'Plot panel menu:'

	write(*,*) ' M ... Mean spectrum A(lam)'
	write(*,*) ' N ... NLR spectrum  N(lam)'
	write(*,*) ' A ... Absorption spectrum'
	write(*,*) ' C ... Continuum lightcurve C(t)'
	write(*,*) ' B ... BLR spectrum B(w)'
	write(*,*) ' L ... BLR lightcurve B(t)'

	write(*,*) ' F ... Flux Correction p(w,t)'
	write(*,*) ' W ... Wavelength Correction dx(w,t)'
	write(*,*) ' S ... Seeing Correction ds(w,t)'
	write(*,*) ' 3 ... All 3 : p(t) dx(t) ds(t)'
	label = 'A'
	if( nstage .gt. 0 ) label = todo_s( nstage )
	write(*,*) ' G ... Greyscale Model ', label(:len1(label))
	write(*,*) ' '' ... D(model)/D(lam)'
	write(*,*) ' " ... DD(model)/D(lam)^2'
	write(*,*) ' R ... Residuals (Data-Model) eps(w,t)'
	write(*,*) ' E ... Eta (Data-Model)/Sigma chi(w,t)'

	write(*,*) ' X ... Chi-Bias spectrum   chi(w) mu(w)'
	write(*,*) ' T ... Chi-Bias lightcurve chi(t) mu(t)'

* default plot options
	if( reply(1:1) .eq. '1' ) toplot = toplot1(1:1)
	if( reply(1:1) .eq. '2' ) toplot = toplot2(1:2)
	if( reply(1:1) .eq. '3' ) toplot = toplot3(1:3)
	if( reply(1:1) .eq. '4' ) toplot = toplot4(1:4)
	if( reply(1:1) .eq. '5' ) toplot = toplot5(1:len1(toplot5))
	if( reply(1:1) .eq. '7' ) toplot = toplot7(1:len1(toplot7))

* what to plot ?
	write(*,*) 'Panels:', npan
	call inq( 'What to plot', toplot, toplot )	
	call upcase( toplot, toplot )
* stow
* KDH : SHOULD DO VALIDITY CHECK FIRST
	if( reply(1:1) .eq. '1' ) toplot1 = toplot(1:1)
	if( reply(1:1) .eq. '2' ) toplot2 = toplot(1:2)
	if( reply(1:1) .eq. '3' ) toplot3 = toplot(1:3)
	if( reply(1:1) .eq. '4' ) toplot4 = toplot(1:4)
	if( reply(1:1) .eq. '5' ) toplot5 = toplot(1:len1(toplot5))
	if( reply(1:1) .eq. '7' ) toplot7 = toplot(1:len1(toplot7))

* add extra panel 
      if( npan .eq. 5 .and. len1( toplot ) .gt. 5 ) then
	npan = 6
	toplot = toplot5(1:6)
	write(*,*) 'Extra panel 5->6 ', toplot(1:6)
      end if
      if( npan .eq. 7 .and. len1( toplot ) .gt. 7 ) then
	npan = 7
	toplot = toplot7(1:7)
	write(*,*) 'Extra panel 7->8 ', toplot(1:8)
      end if


* what to plot in each panel
      do i = 1, npan
      if( len1( toplot ) .lt. i ) then
	write(*,*) 'Panel', i
	call inq( 'What to plot', toplot(i:), toplot(i:) )	
      end if
	if( toplot(i:i) .eq. 'M' ) ipanavg = i
	if( toplot(i:i) .eq. 'A' ) ipanabsn = i
	if( toplot(i:i) .eq. 'N' ) ipannlrw = i
	if( toplot(i:i) .eq. 'B' ) ipanblrw = i
	if( toplot(i:i) .eq. 'L' ) ipanblrt = i
	if( toplot(i:i) .eq. 'C' ) ipancont = i
	if( toplot(i:i) .eq. 'G' ) ipanfit = i
	if( toplot(i:i) .eq. '''' ) ipandf = i
	if( toplot(i:i) .eq. '"' ) ipanddf = i
	if( toplot(i:i) .eq. 'R' ) ipandiff = i
	if( toplot(i:i) .eq. 'E' ) ipaneta = i
	if( toplot(i:i) .eq. '3' ) ipancal = i
	if( toplot(i:i) .eq. 'F' ) ipanfc = i
	if( toplot(i:i) .eq. 'W' ) ipanxc = i
	if( toplot(i:i) .eq. 'S' ) ipansc = i
	if( toplot(i:i) .eq. 'X' ) ipanbiasw = i
	if( toplot(i:i) .eq. 'T' ) ipanbiast = i
      end do

* 6-panel plot
      else if( reply(1:1) .eq. '6' ) then
	nx = 2
	ny = 3
	ipanavg = 1
	ipancont = 2
	ipaneta = 3
c	ipancal = 4
* KDH: SHOULD CHANGE TO IPANBLRT IF NO CALIBRATIONS
      if( nfitphot .gt. 0
     &	.or. nfitshift .gt. 0
     &	.or. nfitblur .gt. 0 ) then
	ipancal = 4
      else
	ipanblrt = 4
      end if
	ipanbiasw = 5
	ipanbiast = 6
	npan = 6

* 8-panel plot
      else if( reply(1:1) .eq. '8' ) then
	nx = 2
	ny = 4
	ipanavg = 1
	ipancont = 2
	ipanblrw = 3
	ipanblrt = 4
      if( dips ) then
	ipanabsn = 5
      else
	ipaneta = 5
      end if
	ipancal = 6
	ipanbiasw = 7
	ipanbiast = 8
	npan = 8

* 12-panel plot
      else if( reply(1:1) .eq. 'P' ) then
	nx = 2
	ny = 6
	ipanavg = 1
	ipancont = 2
	ipanblrw = 3
	ipanblrt = 4
      if( dips ) then
	ipanabsn = 5
      else
	ipanfit = 5
      end if
	ipancal = 6
	ipandiff = 7
	ipanxc = 8
	ipaneta = 9
	ipansc = 10
	ipanbiasw = 11
	ipanbiast = 12

	npan = 12

* default option
      else
	write(*,*) '** ERROR - SOMETHING WRONG :(('
	write(*,*) 'reply ', reply(:len1(reply))
	write(*,*) ' todo ', todo(:len1(todo))
	write(*,*) ' todolist ', todolist(:len1(todolist))
	nx = 1
	ny = 1
	npan = 1
	ipanavg = 1
      end if

* open the multi-panel plot
	call pgstart( nx, ny, new )
* white background
	call pgbgw
* character size
	csize = csizedef
c      if( nx * ny .ge. 3 ) then
      if( nx * ny .le. 3 ) then
	csize = csizedef * 1.5
      end if
	call pgsch( csize )
* line width
	lwide = lwidedef
	if( max( nx, ny ) .gt. 3 ) lwide = min( lwide, 3 )
	call pgslw( lwide )
* panels
      do ipan = 1, npan
	write(*,*)
	write(*,*) 'Panel', ipan, ' of', npan, ' -----------------------------'

	ipantx = 0
	ipanwx = 0
* time on x axis
      if(    ipan .eq. ipancont
     &	.or. ipan .eq. ipanblrt
     &	.or. ipan .eq. ipannlrt
     &	.or. ipan .eq. ipanbiast
     &	.or. ipan .eq. ipancal ) then
	ipantx = ipan
	np = nt
	write(*,*) 'Lightcurve Nt', nt
* wavelength on x axis
      else
	ipanwx = ipan
	np = nw
	write(*,*) 'Spectrum Nw', nw
      end if

* log options
	logx = 0
	logy = 0
	if( logwave .and. ipan .eq. ipanwx ) logx = 1

* flux (with units) on y axis
	ipanfy = 0
      if(    ipan .eq. ipanavg
     &	.or. ipan .eq. ipancont
     &	.or. ipan .eq. ipannlrw
     &	.or. ipan .eq. ipanblrw ) then
	ipanfy = ipan
      end if

* greyscale image panel
	ipanpic = 0
      if(    ipan .eq. ipanfit
     &	.or. ipan .eq. ipandiff
     &	.or. ipan .eq. ipaneta
     &	.or. ipan .eq. ipanfc
     &	.or. ipan .eq. ipanxc
     &	.or. ipan .eq. ipansc
     &	.or. ipan .eq. ipandf
     &	.or. ipan .eq. ipanddf ) then
	ipanpic = ipan
	write(*,*) 'Greyscale Nw', nw, ' Nt', nt
      IF( .FALSE. ) THEN
	write(*,*) 'fit', ipanfit, ' diff', ipandiff, ' eta', ipaneta
	write(*,*) 'fc', ipanfc, ' xc', ipanxc, ' sc', ipansc
	write(*,*) 'df', ipandf, ' ddf', ipanddf, ' sc', ipansc
      END IF
      end if

* load x arrays
* spectrum plot
      if( ipan .eq. ipanwx ) then
	xlabel = '\gl (\A)'
	if( simpleplot ) xlabel = 'wavelength (\A)'
      if( zshift .ne. 0.d0 ) then
	call append( xlabel, 'z =' )
	call append_f( xlabel, real(zshift), '(f10.5)' )
	if( simpleplot ) xlabel = 'rest wavelength (\A)'
      end if

* wavelengths
      do i=1,nw
	xplot(i) = w8_w(i)
      end do

* log wavelengths
      if( logx .ne. 0 ) then
      do i = 1, nw
	x = xplot( i )
	xplot( i ) = alog10( x )
      end do
      end if

* lightcurve plot
      else if( ipan .eq. ipantx ) then
* hjd 
      if( timex ) then
	call label_time( xlabel, timebase, jdsub )
	call peqp( nt, xplot, time )
* sequence
      else
	xlabel = 'spectrum number'
	call peqp( nt, xplot, seq_t )
      end if
      end if

* load y arrays
	ncurves = 0

*------------------------------------------
* AVG and NLR spectra
      if( ipan .eq. ipanavg ) then

	ylabel = 'NLR and AVG'
	labels( 1 ) = 'AVG'
	labels( 2 ) = ' '
	labels( 3 ) = ' '
	labels( 4 ) = ' '
	labels( 5 ) = ' '
	labels( 6 ) = ' '
	labels( 7 ) = ' '
	labels( 8 ) = 'cont'
	labels( 9 ) = ' '
	labels( 10 ) = ' '
c	labels( 11 ) = 'absn'
	labels( 11 ) = ' '
	labels( 12 ) = 'Fe2'
	labels( 13 ) = 'BLR'
	labels( 14 ) = 'NLR'

	ncurves = 14

	kolors( 1 ) = kolor_avg
	kolors( 2 ) = kltgrey
	kolors( 3 ) = kolor_avg
	kolors( 4 ) = kolor_absn
c	kolors( 5 ) = kyellow
	kolors( 5 ) = kblugrn

	if( simpleplot ) kolors( 5 ) = 0

	kolors( 6 ) = kolor_fe2
	kolors( 7 ) = kblue
	kolors( 8 ) = kolor_cont
	kolors( 9 ) = kdkgrey
	kolors( 10 ) = kdkgrey

	kolors( 11 ) = kolor_absn
	kolors( 11 ) = kred
	kolors( 12 ) = kolor_fe2
c	kolors( 13 ) = kblugrn
	kolors( 13 ) = kblue
	kolors( 14 ) = kolor_nlr

      do i = 1, nw
	avg = avg_w( i )
	elr = elr_w( i )
	raw = elr_raw_w( i )
	dim = 0.
* KDH 2019 Aug : USE MASKBAL
	mask = maskabsn( i ) .or. maskbal( i )
	if( mask ) dim = raw
	c = cont_w( i )
	fe2 = avgfe2_w( i )
	blr = avgblr_w( i )
	fit = fitavg_w( i )
	curves( i, 1 ) = avg
	curves( i, 2 ) = avg + elr
	curves( i, 3 ) = avg
	curves( i, 4 ) = c
	curves( i, 5 ) = raw
	curves( i, 6 ) = c + fe2
	curves( i, 7 ) = fit
	curves( i, 8 ) = c

	curves( i, 9 ) = 0.
	curves( i, 10 ) = 0.

* 2021-04-19 KDH - turn on by default
* 2021-09-25 KDH - turn off
      if( .false. ) then
      if( nlev .gt. 0 ) then
	curves( i, 9 ) = fitavg_wn(i,1)
	n = min( nlev, 2 )
	curves( i, 10 ) = fit - fitavg_wn(i,n)
      end if
      end if

	curves( i, 11 ) = dim
	curves( i, 12 ) = fe2
	curves( i, 13 ) = blr
	curves( i, 14 ) = elr

* KDH : THINK THAT SIGMAS NOT USED 
	sigmas( i, 1 ) = sigavg_w( i )
	sigmas( i, 2 ) = sigavg_w( i )
	sigmas( i, 3 ) = sigavg_w( i )
	sigmas( i, 4 ) = sigavg_w( i )
	sigmas( i, 5 ) = signlr_w( i )
	sigmas( i, 6 ) = sigavg_w( i )
	sigmas( i, 7 ) = sigavg_w( i )
	sigmas( i, 8 ) = sigavg_w( i )
	sigmas( i, 9 ) = sigavg_w( i )
	sigmas( i, 10 ) = sigavgblr_w(i)
	sigmas( i, 11 ) = sigavg_w( i )
	sigmas( i, 12 ) = sigfe2_w( i )
	sigmas( i, 13 ) = sigavgblr_w( i )
	sigmas( i, 14 ) = signlr_w( i )
      end do

*------------------------------------------
* absorption
      else if( ipan .eq. ipanabsn ) then
	ylabel = 'Absorption'
	ncurves = 6
* labels
	labels( 1 ) = 'ABSN'
	labels( 2 ) = ' '
	labels( 3 ) = ' '
	labels( 4 ) = 'DIF'
	labels( 5 ) = ' '
	labels( 6 ) = ' '
* kolors
	kolors( 1 ) = kblack
	kolors( 2 ) = kred
	kolors( 3 ) = kblue
	kolors( 4 ) = kolor_absn
	kolors( 5 ) = kred
	kolors( 6 ) = kred
* curves
      do i = 1, nw
	dat = datdim_w( i )
	sig = sigdim_w( i )
	dim = fitdim_w( i )
	dimagn = fitdim_agn_w( i )
	curves( i, 1 ) = dat
	curves( i, 2 ) = dim
	curves( i, 3 ) = dimagn
* total absn
	fit = dim * dimagn
* residuals
	curves( i, 4 ) = dat - fit
* error bar envelope
	curves( i, 5 ) = sig
	curves( i, 6 ) = -sig
      end do

*------------------------------------------
* continuum lightcurves at fiducial wavelengths
      else if( ipan .eq. ipancont ) then
	ylabel = 'Continuum'
	k050 = 0
	k000 = 0
	k100 = 0
	k025 = 0
	k075 = 0
* central wavelength
      if( npcont .le. 1 ) then
	k050 = 1
	ncurves = 1
* more wavelengths if polyfit
      else
	ncurves = 5
* order of curves
	k000 = 1
	k100 = 2
	k025 = 3
	k075 = 4
* central wavelength last
	k050 = 5
      end if

* colours and wavelength labels
      do k = 1, ncurves
	label = ' '
      if( k .eq. k050 ) then
	kolor = 1
	x = 0.5
      else if( k .eq. k000 ) then
	kolor = 4
	x = 0.
      else if( k .eq. k100 ) then
	kolor = 2
	x = 1.
      else if( k .eq. k025 ) then
	kolor = 3
	x = 0.25
      else if( k .eq. k075 ) then
	kolor = 8
	x = 0.75
      else
	write(*,*) '** NO MATCH FOR CURVE', k, ' of', ncurves
      end if
	iw = nint(  1 + x * ( nw - 1 ) )
	iw = max( 1, min( nw, iw ) )
	w = w_w( iw )
	x = xw_w( iw )
	call append_i( label, nint( w ) )
	call append( label, '\A' )
	call nospace( label )
* stow
	kolors( k ) = kolor
	labels( k ) = label
	iw_k( k ) = iw
	x_k( k ) = x
	write(*,*) 'Curve', k, ' kolor', kolor, ' w(', iw, ' )=', nint(w), x
* next curve
      end do
* continuum lightcurves at fiducial wavelengths
      if( npar .gt. 0 .and. npcont .gt. 0 ) then
	write(*,*) 'npar', npar, ' npcont', npcont
      do k = 1, ncurves
	iw = iw_k( k )
      do it = 1, nt
	i = iw + nw * ( it - 1 )
	curves( it, k ) = cont_wt( i )
	sigmas( it, k ) = sigcont_wt( i )
* next it
      end do
* next curve k
      end do

* no covariance matrix - use monte-carlo simulation
* KDH : THIS UNDER-ESTIMATES THE ERROR BARS
      else
* monte-carlo samples
	n = min( maxplot, 1000 )
	write(*,*) 'Monte-Carlo samples', n, ' npcont', npcont
* times
      do it = 1, nt
* curves
      do k = 1, ncurves
	x = x_k( k )
      do i = 1, n
      do j = 1, npcont
	c = cont_tp( it, j )
	s = sigcont_tp( it, j )
	cont_p( j ) = rang( c, s, iseed )
      end do
	plot5( i ) = poly4( npcont, cont_p, x )
      end do
* mean and rms
	call avgrms( n, plot5, avg, rms )
* stow
	curves( it, k ) = avg
	sigmas( it, k ) = rms
* next curve k
      end do
* next it
      end do
      end if

* report
      do k = 1, ncurves
	iw = iw_k( k )
	l = nint( w_w( iw ) )
	call optavgrms( nt, curves( 1, k ), sigmas( 1, k ), avg, rms )
	write(*,*) 'Curve', k, ' c(', l, ' ) avg', avg, ' rms', rms
      end do

* BLR spectra -----------------------------------
      else if( ipan .eq. ipanblrw ) then
	k = 0
	krmsx = 0

*-------------------------------
* debiased rms spectrum
	k = k + 1
	labels( k ) = 'RMS'
* green-cyan
	kolors( k ) = kblugrn
* omit raw/debiased rms spectrum for simple plots
	if( simpleplot ) kolors( k ) = 0
	nobias = 0
* raw rms
      if( nobias .eq. 0 ) then
	labels( k ) = 'raw'
	call peqp( nw, curves( 1, k ), rmsraw_w )
	call peqp( nw, sigmas( 1, k ), sigrms_w )
* de-biased rms
      else
	labels( k ) = 'debiased'
      do i = 1, nw
	rms = rmsraw_w( i )
	bias = rmsbias_w( i )
	rms = sqrt( max( 0., rms * rms - bias * bias ) )
	curves( i, k ) = rms
	sigmas( i, k ) = sigrms_w( i )
      end do
      end if


*-------------------------------
* rms of the model fitted to the data (RMSu)
	call avgrms( nw, rmsf_w, avg, rms )

* skip if no model
      if( avg .ne. 0. .or. rms .gt. 0. ) then

* pre-calibration model
      IF( .FALSE. ) THEN
	call avgrms( nw, rmsfit_w, favg, frms )
* skip if no calibration
      if( avg .ne. favg .or. rms .ne. frms ) then
	k = k + 1
	labels( k ) = 'RMSu'
	labels( k ) = 'uncal'
* aqua
	kolors( k ) = 5
	call peqp( nw, curves( 1, k ), rmsfit_w )
	call peqp( nw, sigmas( 1, k ), sigrms_w )
      end if
      end if
      END IF

*-------------------------------
* RMSx of the data with continuum and calib tweaks removed
* skip if no continuum
      if( cavg .ne. 0. .and. crms .ne. 0. ) then
	k = k + 1
	labels( k ) = 'RMSb'
	labels( k ) = '-cont'
	kolors( k ) = kolor_rmslines
	call peqp( nw, curves( 1, k ), rmsb_w )
	call peqp( nw, sigmas( 1, k ), sigrmsb_w )
      end if

*-------------------------------
* error bar on RMSX
C      IF( .FALSE. ) THEN
c      IF( .TRUE. ) THEN
c      if( .not. simpleplot ) then
	k = k + 1
	labels( k ) = '\gs\dRMSx\u'
	kolors( k ) = kolor_sigrms
	call peqp( nw, curves( 1, k ), sigrms_w )
	call peqp( nw, sigmas( 1, k ), sigrms_w )
* KDH 2019 AUG : SIGRMSB BLOWS UP IN CONTINUUM REGIONS
c	call peqp( nw, curves( 1, k ), sigrmsb_w )
c	call peqp( nw, sigmas( 1, k ), sigrmsb_w )
c      END IF

*-------------------------------
* ML estimate of rms (RMSx) (data with tweaks applied)
	k = k + 1
	labels( k ) = 'RMSx'
	kolors( k ) = kolor_rms
	call peqp( nw, curves( 1, k ), rms_w )
	call peqp( nw, sigmas( 1, k ), sigrms_w )
	krmsx = k

* 2020-03-22 KDH - this messes up ymx
* over-write the first curve
      if( simpleplot ) then
	labels( k ) = ' '
	labels( 1 ) = 'RMSx'
	kolors( 1 ) = kolor_rms
	call peqp( nw, curves( 1, 1 ), rms_w )
	call peqp( nw, sigmas( 1, 1 ), sigrms_w )
      end if

*-------------------------------
* rms of continuum variations (cont)
	call avgrms( nw, rmscont_w, cavg, crms )
* skip if no continuum
      if( cavg .ne. 0. .and. crms .ne. 0. ) then
	k = k + 1
	labels( k ) = 'RMSc'
	labels( k ) = ' '
	kolors( k ) = kolor_rmscont
	call peqp( nw, curves( 1, k ), rmscont_w )
	call peqp( nw, sigmas( 1, k ), sigrmscont_w )
      end if

*-------------------------------
* rms of the model
      if( avg .ne. 0. .or. rms .gt. 0. ) then
* skip if model same as continuum
      if( avg .ne. cavg .or. rms .ne. crms ) then
	k = k + 1
	labels( k ) = 'RMSm'
	labels( k ) = 'model'
	kolors( k ) = kolor_fit
	call peqp( nw, curves( 1, k ), rmsf_w )
	call peqp( nw, sigmas( 1, k ), sigrms_w )
      end if
      end if


*-------------------------------
* BLR
      if( nfitblr .gt. 0 ) then
* require variations
	call avgrms( nt, blr_t, avg, rms )
      if( avg .ne. 0. .or. rms .gt. 0. ) then
	k = k + 1
	labels( k ) = 'BLR'
	kolors( k ) = kolor_blr
	call peqp( nw, curves( 1, k ), blr_w )
	call peqp( nw, sigmas( 1, k ), sigblr_w )
      end if
      end if

*-------------------------------
* RMS BLR components

* debug report
	write(*,*) 'Ncomp', ncomp
	write(*,*) 'line_c', ( line_lc(1,i),i=1,ncomp )
	write(*,*) 'rest_l', ( nint( rest_l( line_lc(1,i) ) ), i=1,ncomp )
	write(*,*) 'Npix_c', ( npix_c(i),i=1,ncomp)
	write(*,*) 'Npix_l', ( npix_l( line_lc(1,i) ), i=1,ncomp )
	write(*,*) 'Nfit_l', ( nfit_l( line_lc(1,i) ), i=1,ncomp )

* 2019 AUG KDH : DEBUG PLOT FIT TO RMS BLR SPECTRUM
      IF( .FALSE. ) THEN

	call peqc( nw, plot1, 0. )
	call peqc( nw, plot2, 0. )
	call peqc( nw, plot3, 0. )
      do i=1,ncomp
      if( npix_c( i ) .gt. 0 ) then
	l = line_lc( 1, i )
      do iw = iw1_l( l ), iw2_l( l )
	plot1( iw ) = plot1( iw ) + dat_wl( iw, l )
	plot2( iw ) = max( plot2( iw ), sig_wl( iw, l ) )
	plot3( iw ) = min( plot3( iw ), sig_wl( iw, l ) )
      end do
      end if
      end do

	k = k + 1
	call peqp( nw, curves(1,k), plot1 )
	call peqp( nw, sigmas(1,k), sigblr_w )
	labels( k ) = ' '
	kolors( k ) = korange

	call avgrms( nw, curves(1,k), dmn, dmx )
	write(*,*) 'dat_wl', dmn, dmx, ' orange'

	k = k + 1
	call peqp( nw, curves(1,k), plot3 )
	call peqp( nw, sigmas(1,k), sigblr_w )
	labels( k ) = ' '
	kolors( k ) = kcyan

	call avgrms( nw, curves(1,k), dmn, dmx )
	write(*,*) 'min(sig_wl)', dmn, dmx, ' cyan'

	k = k + 1
	call peqp( nw, curves(1,k), plot2 )
	call peqp( nw, sigmas(1,k), sigblr_w )
	labels( k ) = ' '
	kolors( k ) = kgreen

	call avgrms( nw, curves(1,k), dmn, dmx )
	write(*,*) 'max(sig_wl)', dmn, dmx, ' green'

	k = k + 1
	call peqp( nw, curves(1,k), fitavgblr_w )
	call peqp( nw, sigmas(1,k), sigblr_w )
	labels( k ) = ' '
	kolors( k ) = kdkgrey

	call avgrms( nw, curves(1,k), dmn, dmx )
	write(*,*) 'AVG BLR fit', dmn, dmx, ' dkgrey'

	k = k + 1
	call peqp( nw, curves(1,k), contrmsblr_w )
	call peqp( nw, sigmas(1,k), sigblr_w )
	labels( k ) = ' '
	kolors( k ) = kred

	call avgrms( nw, curves(1,k), dmn, dmx )
	write(*,*) 'RMS BLR Continuum', dmn, dmx, ' red'


	k = k + 1
	call peqp( nw, curves(1,k), fitrmsblr_w )
	call peqp( nw, sigmas(1,k), sigblr_w )
	labels( k ) = ' '
	kolors( k ) = kblue

	call avgrms( nw, curves(1,k), dmn, dmx )
	write(*,*) 'RMS BLR fit', dmn, dmx, ' blue'


c	k = k + 1
c	call peqp( nw, curves(1,k), sigfitrmsblr_w )
c	call peqp( nw, sigmas(1,k), sigblr_w )
c	labels( k ) = ' '
c	kolors( k ) = kgreen

* END OF DEBUG PLOT
      END IF
	
	n = k
      do i = 1, ncomp
      if( npix_c( i ) .gt. 0 ) then
	l = line_lc( 1, i )
      if( npix_l( l ) .gt. 0 ) then
      if( nfit_l( l ) .gt. 0 .or. .TRUE. ) then
	text = text_l( l )
	lt = len1( text )
* stow spectral data and error bars
* KDH : THE ERROR BAR SPECTRA ARE NOT CURRENTLY USED
      if( k .ge. maxcurves ) then
	write(*,*) '** NO ROOM FOR ', text(:lt)
      else
* require time variations
c	call avgrms( nw, dat_wl( 1, l ), avg, rms )
	call avgrms( nt, dat_tl( 1, l ), avg, rms )
      if( avg .ne. 0. .or. rms .gt. 0. .or. .TRUE. ) then
	k = k + 1
	write(*,*) 'Spectrum', k, ' : ', text(:lt)
	labels( k ) = label_l( l )
	kolors( k ) = kolor_l( l )
	call peqp( nw, curves( 1, k ), dat_wl( 1, l ) )
	call peqp( nw, sigmas( 1, k ), sig_wl( 1, l ) )
      end if
      end if
      end if
      end if
      end if
* next component i
      end do
	ncurves = k

* DEBUG REPORT
      IF( .FALSE. ) THEN
	write(*,*) '-- Spectrum --'
      do ic = 1, ncomp
	l = line_lc( 1, ic )
	text = text_l( l )
	lt = len1(text)
	title = text
	call append_i( title, iw1_l( l ) )
	call append_i( title, iw2_l( l ) )
	call append_i( title, npix_l( l ) )
	call append_i( title, nfit_l( l ) )
	write(*,*) title(:len1(title))
	call mnmx( nw, dat_wl( 1, l ), ymn, ymx )
	write(*,*) ' dat_wl(', text(:lt), ') mn,mx', ymn, ymx
      end do
	write(*,*) '--------------'
      END IF
* END DEBUG REPORT


* BLR lightcurve ---------------------------------------
      else if( ipan .eq. ipanblrt ) then
	ylabel = 'BLR'
	k = 0
      if( nfitblr .ne. 0 ) then
	call avgrms( nt, blr_t, avg, rms )
      if( avg .ne. 0. .or. rms .gt. 0. ) then
	k = 1
	labels( k ) = 'BLR'
	kolors( k ) = kolor_blr
	call peqp( nt, curves( 1, k ), blr_t )
	call peqp( nt, sigmas( 1, k ), sigblr_t )
      end if
      end if
* RMS BLR lightcurves
      do i = 1, ncomp
* require pixels
      if( npix_c( i ) .gt. 0 ) then
	l = line_lc( 1, i )
c      if( npix_l( l ) .gt. 0 ) then
* avert overflow
      if( k .ge. maxcurves ) then
	text = text_l( l )
	write(*,*) '** NO ROOM FOR ', text(:len1(text))
* stow lightcurve data and error bars
      else
* require variations
	call avgrms( nt, dat_tl( 1, l ), avg, rms )
      if( avg .ne. 0. .or. rms .gt. 0 ) then
	k = k + 1
	labels( k ) = label_l( l )
	kolors( k ) = kolor_l( l )
	call peqp( nt, curves( 1, k ), dat_tl( 1, l ) )
	call peqp( nt, sigmas( 1, k ), sig_tl( 1, l ) )
* report stats
	call mnmx( nt, curves( 1, k ), dmn, dmx )
	write(*,*) 'Curve', k, dmn, dmx, ' ', text(:len1(text))
      if( dmx .eq. dmn ) then
	write(*,*) '** SHOULD WE SKIP THIS ONE ?'
      end if
      end if
      end if
      end if
      end do
	ncurves = k

* DEBUG REPORT
      IF( .FALSE. ) THEN
	write(*,*) '-- Lightcurve --'
      do ic = 1, ncomp
	l = line_lc( 1, ic )
	text = text_l(l)
	lt = len1(text)
	title = text
	call append_i( title, iw1_l( l ) )
	call append_i( title, iw2_l( l ) )
	call append_i( title, npix_l( l ) )
	call append_i( title, nfit_l( l ) )
	write(*,*) title(:len1(title))
	call mnmx( nt, dat_tl( 1, l ), ymn, ymx )
	write(*,*) ' dat_tl(', text(:lt), ') mn,mx', ymn, ymx
      end do
	write(*,*) '----------------'
      END IF
* END DEBUG REPORT

* -----------------------------
* NLR spectrum 
      else if( ipan .eq. ipannlrw ) then
	ylabel = 'NLR'
	k = 1
	labels( k ) = ' '
	kolors( k ) = 7
	call peqp( nw, curves( 1, k ), elr_ras_w )
	k = k + 1
	labels( k ) = 'NLR'
	kolors( k ) = kolor_nlr
	call peqp( nw, curves( 1, k ), elr_raw )
	call peqp( nw, sigmas( 1, k ), signlr_w )
	ncurves = k
* -----------------------------
* NLR lightcurve
      else if( ipan .eq. ipannlrt ) then
	ylabel = 'NLR'
	k =  1
	labels( k ) = 'NLR'
	kolors( k ) = kolor_nlr
	call peqp( nt, curves( 1, k ), elr_t )
	call peqp( nt, sigmas( 1, k ), signlr_t )
	ncurves = k
* -----------------------------
* chi-bias spectra
      else if( ipan .eq. ipanbiasw ) then
	ylabel = '\gm and \gx'
	k = 0
	kchi = 0
	kbias = 0
* unclipped

	yes = cliphi .gt. cliplo .and. kliphi + kliplo .gt. 0
	write(*,*) kliplo, ' <', cliplo, kliphi, ' >', cliphi, ' sigma.'

      if( yes ) then
* raw chi
	k = k + 1
	labels( k ) = ' '
	kolors( k ) = 15
	call peqp( nw, curves( 1, k ),    chi_w )
	call peqp( nw, sigmas( 1, k ), sigchi_w )
c	kchi = k
* raw mu
	k = k + 1
	labels( k )= ' '
	kolors( k ) = 15
	call peqp( nw, curves( 1, k ),    bias_w )
	call peqp( nw, sigmas( 1, k ), sigbias_w )
c	kbias = k
      end if


* mu uncertainty envelope
      do j = -1, 1, 2
	k = k + 1
	labels( k ) = ' '
	kolors( k ) = korange
      do i = 1, nw
	dat =    biasclip_w( i )
	sig = sigbiasclip_w( i )
	curves( i, k ) = sig * j + dat
	sigmas( i, k ) = sig
      end do
      end do

* sigma-clipped mu
	k = k + 1
	labels( k ) = '\gm'
	kolors( k ) = kred
	call peqp( nw, curves( 1, k ),    biasclip_w )
	call peqp( nw, sigmas( 1, k ), sigbiasclip_w )
	kbias = k

* sigma-clipped chi
	k = k + 1
	labels( k ) = '\gx'
	kolors( k ) = kblue
	call peqp( nw, curves( 1, k ),    chiclip_w )
	call peqp( nw, sigmas( 1, k ), sigchiclip_w )
	kchi = k

* fit to clipped chi(w)
	k = k + 1
	labels( k ) = ' '
	kolors( k ) = kcyan
      do i = 1, nw
	curves( i, k ) =    chifit_w( i )
	sigmas( i, k ) = sigchifit_w( i )
      end do
	k0 = k

* add and subtract the per-pixel uncertainty
      do j = -1, 1, 2
	k = k + 1
	if( j .eq. 0 ) kchi = k
	labels( k ) = ' '
	kolors( k ) = kcyan
      do i = 1, nw
	fit = chifit_w( i )
	sig = sigchiclip_w( i )
	curves( i, k ) = sig * j + fit
	sigmas( i, k ) = sig
      end do
      end do
	write(*,*) 'Chi(w) is curve', kchi

* mixture model
	k = k + 1
	labels( k ) = ' '
	kolors( k ) = kgreen
      do i = 1, nw
	curves( i, k ) =    chimix_w( i )
	sigmas( i, k ) = sigchimix_w( i )
      end do


	ncurves = k
* -----------------------------
* chi-bias lightcurves
      else if( ipan .eq. ipanbiast ) then
	ylabel = '\gm and \gx'
	k = 0
* unclipped
	yes = cliphi .gt. cliplo .and. kliphi + kliplo .gt. 0
	write(*,*) kliplo, ' <', cliplo, kliphi, ' >', cliphi, ' sigma.'
      if( yes ) then
	k = k + 1
	labels( k ) = ' '
	kolors( k ) = 15
	call peqp( nt, curves( 1, k ), chi_t )
	call peqp( nt, sigmas( 1, k ), sigchi_t )
	k = k + 1
	labels( k ) = ' '
	kolors( k ) = 15
	call peqp( nt, curves( 1, k ), bias_t )
	call peqp( nt, sigmas( 1, k ), sigbias_t )
      end if
* sigma-clipped 
	k = k + 1
	labels( k ) = '\gx'
	kolors( k ) = 4
	call peqp( nt, curves( 1, k ), chiclip_t )
	call peqp( nt, sigmas( 1, k ), sigchiclip_t )
	k = k + 1
	labels( k ) = '\gm'
	kolors( k ) = 2
	call peqp( nt, curves( 1, k ), biasclip_t )
	call peqp( nt, sigmas( 1, k ), sigbiasclip_t )

	ncurves = k

* -----------------------------
* calibration lightcurves
      else if( ipan .eq. ipancal ) then
	ylabel = '\gD\gl  \gD\gs  \gDp'
	ylabel = ' '

* photometry
	call mnmx( nt, p0_t, pmn, pmx )
	write(*,*) ' lnp0(t)  mn,mx', pmn, pmx
* KDH : PLOT CURVE FOR CENTRE AND ENDS OF SPECTRUM
	k = 0
	n = max( 0, min( 1, npscale - 1 ) )
      DO i = -n, n
	k = k + 1

* LCR = dark grey, black, black
	kolor = 1
	if( i .lt. 0 ) kolor = 14
	kolors( k ) = kolor

	labels( k ) = '\gDp'
	if( i .ne. 0 ) labels( k ) = ' '
      do it = 1, nt
	p = p0_t( it )
	s = sigp0_t( it )
      if( i .ne. 0 ) then
	p1 = p1_t( it )
	p2 = p2_t( it )
	p = p + i * p1 + p2
* KDH: THIS IGNORES CO-VARIANCES :(
	s1 = sigp1_t( it )
	s2 = sigp2_t( it )
	if( i .ne. 0 ) s = sqrt( s*s + s1*s1 + s2*s2 )
      end if
      if( logp ) then
	p = exp( p )
	s = p * s
      else
	p = 1. + p
      end if
	curves( it, k ) = p
	sigmas( it, k ) = s
* next it
      end do
* stats
	call mnmx( nt, curves( 1, k ), pmn, pmx )
* report
	write(*,*) k, i, ' phot(t)  mn,mx', pmn, pmx
      END DO

* shift
* KDH : PLOT CURVE FOR CENTRE AND ENDS OF SPECTRUM
	n = max( 0, min( 1, npshift - 1 ) )
      DO i = -n, n
	k = k + 1
* LCR = orange, red, red
	kolor = 2
	if( i .lt. 0 ) kolor = 8
	kolors( k ) = kolor
	labels( k ) = ' '
	if( i .eq. 0 ) labels( k ) = '\gD\gl'
      do it = 1, nt
	dat = x0_t( it )
	sig = sigx0_t( it )
      if( i .ne. 0 ) then
	dat = dat + i * x1_t( it )
* KDH: THIS IGNORES CO-VARIANCES :(
	s1 = sigx1_t( it )
	sig = sqrt( sig * sig + s1 * s1 )
      end if
	curves( it, k ) = dat
	sigmas( it, k ) = sig
* next it
      end do
* stats
	call mnmx( nt, curves( 1, k ), dxmn, dxmx )
* omit if zero
	if( dxmn .eq. 0. .and. dxmx .eq. dxmn ) k = k - 1
* report
	write(*,*) k, i, ' shift(t)  mn,mx', dxmn, dxmx
      END DO

* blur tweaks
* KDH : PLOT CURVE FOR CENTRE AND ENDS OF SPECTRUM
	n = max( 0, min( 1, npblur - 1 ) )
      do i = -n, n
	k = k + 1
* blue-cyan, blue, blue
	kolor = 4
	if( i .lt. 0 ) kolor = 11
	kolors( k ) = kolor
	labels( k ) = ' '
	if( i .eq. 0 ) labels( k ) = '\gD\gs'
      do it = 1, nt
	dat = s0_t( it )
	sig = sigs0_t( it )
      if( i .ne. 0 ) then
	dat = dat + i * s1_t( it )
* KDH: THIS IGNORES CO-VARIANCES :(
	s = sigs0_t( i )
	sig = sqrt( sig * sig + s * s )
      end if
	curves( it, k ) = dat
	sigmas( it, k ) = sig
      end do
* stats
	call mnmx( nt, curves( 1, k ), dsmn, dsmx )
* omit if zero
	if( dsmn .eq. 0. .and. dsmx .eq. dsmn ) k = k - 1
* report
	write(*,*) k, i, ' blur(t)  mn,mx', dsmn, dsmx
      end do

	ncurves = k

* -----------------------------
* monte-carlo error bars on p(t) at spectrum ends
* KDH : SHOULD USE COVARIANCE MATRIX :(
* KDH : SHOULD DO SO FOR SHIFT AND BLUR
	n = min( nfitphot, npscale )
      if( n .gt. 1 .and. k + 3 .le. maxcurves ) then
	k100 = k + 1
	k000 = k + 2
	k050 = k + 3

	kolors( k050 ) = 1
	kolors( k000 ) = 4
	kolors( k100 ) = 2

	labels( k050 ) = ' '
	labels( k100 ) = ' '
	labels( k000 ) = ' '

      do it = 1, nt
* monte-carlo samples
* KDH : MAYBE NEEDS REVAMPED TO DO MORE CURVES
	n = 1000
      do i = 1, n
	p0 = rang( p0_t( it ), sigp0_t( it ), iseed )
	p1 = rang( p1_t( it ), sigp1_t( it ), iseed )
	p2 = rang( p2_t( it ), sigp2_t( it ), iseed )
	plot7( i ) = p0
	x = -1.
	plot8( i ) = p0 + x * ( p1 + x * p2 )
	x = +1.
	plot9( i ) = p0 + x * ( p1 + x * p2 )
* next sample i
      end do
      if( logp ) then
      do i = 1, n
	plot7( i ) = exp( plot7( i ) )
	plot8( i ) = exp( plot8( i ) )
	plot9( i ) = exp( plot9( i ) )
      end do
      end if
	call avgrms( n, plot7, curves( it, k050 ), sigmas( it, k050 ) )
	call avgrms( n, plot8, curves( it, k000 ), sigmas( it, k000 ) )
	call avgrms( n, plot9, curves( it, k100 ), sigmas( it, k100 ) )
* next it
      end do
* KDH : NOT PLOTTED SINCE NCURVES NOT INCREMENTED.
      end if

* -----------------------------
* greyscale images
      else if( ipan .eq. ipanpic ) then
	ylabel = 'spectrum number'
	call peqp( nt, yplot, seq_t )
	call peqp( nt, curves( 1, 1 ), seq_t )
	n = nt * nw
	if( ipan .eq. ipanfit )  call peqp( n, pic_wt, fit_wt )
	if( ipan .eq. ipandiff ) call peqp( n, pic_wt, dif_wt )
	if( ipan .eq. ipandf )   call peqp( n, pic_wt, df_wt )
	if( ipan .eq. ipanddf )  call peqp( n, pic_wt, ddf_wt )
	if( ipan .eq. ipanfc )   call peqp( n, pic_wt, fc_wt )
	if( ipan .eq. ipanxc )   call peqp( n, pic_wt, xc_wt )
	if( ipan .eq. ipansc )   call peqp( n, pic_wt, sc_wt )

      if( ipan .eq. ipaneta ) then
	call peqc( n, pic_wt, 0. )
      do i = 1, n
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
	if( sig .gt. 0. ) pic_wt(i) = dif_wt( i ) / sig
      end do
      end if

* image stats
	call mnmx( n, pic_wt, dmn, dmx )
	call avgrms( n, pic_wt, davg, drms )
	call medmad( n, pic_wt, dmed, dmad )
	write(*,*) 'Pic mn,mx', dmn, dmx
	write(*,*) '  avg,rms', davg, drms
	write(*,*) '  med,mad', dmed, dmad

* greyscale range
	add = 3. * drms
	if( add .eq. 0. ) add = 0.1
	fg = davg + add
	bg = davg - add
	write(*,*) '    fg,bg', fg, bg
      end if
* -----------------------------
* stats
	write(*,*) 'Curves to plot', ncurves
      do k = 1, ncurves
	text = labels( k )
	call mnmx( np, curves( 1, k ), dmn, dmx )
	write(*,*) 'Curve', k, dmn, dmx, ' ', text(:len1(text))
      if( dmx .eq. dmn ) then
	write(*,*) '** SHOULD WE SKIP THIS ONE ?'
      end if
      end do

* -----------------------------
* x range
	call mnmx( np, xplot, xmn, xmx )
      if( ipan .eq. ipantx ) then
	add = ( xmx - xmn ) / max( 1, np-1 ) / 2.
	xmn = xmn - add
	xmx = xmx + add
      end if

* y range

	k = 1
* use mid-spectrum continuum lightcurve
      if( ipan .eq. ipancont ) then
	k = k050
	write(*,*) 'Y range for mid-spectrum continuum lightcurve', k
      end if

	call peqp( np, yplot, curves( 1, k ) )
* images
      if( ipan .eq. ipanpic ) then
	call mnmx( nt, yplot, ymn, ymx )
	add = ( ymx - ymn ) / max( 1, nt-1 ) / 2.
	ymn = ymn - add
	ymx = ymx + add
* non-images
      else
* clip pixels for scaling
	klip = 0
	if( ipan .eq. ipanwx ) klip = 3
	i = 1 + klip
	kp = np - 2 * klip
	call mnmx( np, yplot, ymn, ymx )
	write(*,*) 'Curve 1', ymn, ymx, ' Np', np
      if( klip .gt. 0 ) then
	call mnmx( kp, yplot(i), ymn, ymx )
	write(*,*) 'Curve 1', ymn, ymx, ' Np', np, '->', kp, ' klipped', np-kp
      end if

* use fmult x median of rms spectrum
      if( ipan .eq. ipanblrw .and. ncurves .gt. 1 ) then
	call medmad( np, yplot, ymed, ymad )
	fmult = 1.5
	fmult = 2.
	fmult = 3.
	ymn = 0.
	ymx = ymed * fmult
	write(*,*) 'Median', ymed, ' x', fmult, ' ymn,ymx ->', ymn, ymx
	nseg = 4
	fmult = 1.5
	fmult = 2.
	fmult = 3.
      do iseg = 1, nseg
	n = max( 1, np / nseg )
	i = 1 + n * ( iseg - 1 )
	call medmad( n, yplot(i), ymed, ymad )
	y = ymed * fmult
	ymx = max( ymx, y )
	write(*,*) 'Seg', iseg, ' of', nseg, ' ymn,ymx ->', ymn, ymx
      end do
      end if

* y range for lightcurves
      if( ipan .eq. ipantx ) then
	k = 1
* use mid-spectrum continuum lightcurve
      if( ipan .eq. ipancont ) then
	k = k050
	write(*,*) 'Y range for mid-spectrum continuum lightcurve', k
      end if

* avoid domination by major outliers
	call medmad( np, curves( 1, k ), dmed, dmad )
	call medmad( np, sigmas( 1, k ), smed, smad )
c	write(*,*) ' med', dmed, ' mad', dmad, ' med(sig)', smed
	write(*,*) '  data MED,MAD', dmed, dmad
	write(*,*) ' sigma MED,MAD', smed, smad
* BLR lightcurve
* 2021-10-02 KDH : TEST THIS OPTION FOR BLR LIGHTCURVE
      if( ipan .eq. ipanblrt ) then
	write(*,*) 'BLR lightcurve range:', ymn, ymx, ' curve', 1
	add = max( 0., 4 * dmad + smed )
	WRITE(*,*) ' add = ( MED(sig) + MAD(dat) ) X 4  ', add
	ymx = min( ymx, dmed + add )
	ymn = max( ymn, dmed - add )
	write(*,*) 'Shrink Y range to', dmed - add, dmed + add
	write(*,*) '   New Y range   ', ymn1, ymx1
* non-BLR lightcurves
      else
* expand lightcurves by median error bar
* KDH : ONE NOISY LIGHTCURVE CAN DOMINATE
	add = max( 0., smed )
	ymn = min( ymn, ymn - add )
	ymx = max( ymx, ymx + add )
	write(*,*) 'Expand Y range by ', add,  ' min,max', ymn, ymx
      end if
* 2020-03-21 KDH - expand a bit more
	fac = 0.3
* 2020-05-20 KDH - don't shrink the window
c	if( ymx .gt. 0. ) ymx = fac * ymx
c	if( ymn .lt. 0. ) ymn = fac * ymn
c	if( .not. simpleplot ) ymx = fac * ymx
* 2020-12-30 KDH - revise
c	add = fac * abs( ymx - max( 0., ymn ) )
c	sub = fac * abs( ymn - min( 0., ymx ) )
	add = fac * abs( ymx - ymn )
	sub = add
	write(*,*) 'fac', fac, ' add', add, ' sub', sub
	ymx = ymx + add
	ymn = ymn - sub
	if( .not. simpleplot ) ymx = ymx + add
	write(*,*) 'Expanded Y range min,max', ymn, ymx

* 2020-12-30 KDH - adjust range for p(t) plot
c      if( ipan .eq. ipancal .and. ymn .gt. 0. ) then
c	ymx = min( ymx, sqrt( ymx / ymn ) )
c	write(*,*) 'Calibration Y range:', ymn, ymx
c      end if

      end if

* other curves
      do k = 2, ncurves
	label = labels( k )
	call   mnmx( np, curves(1,k), ymn1, ymx1 )
	call medmad( np, curves(1,k), ymed1, ymad1 )

* lightcurves
      if( ipan .eq. ipantx ) then
	call medmad( np, curves( 1, k ), dmed, dmad )
	call medmad( np, sigmas( 1, k ), smed, smad )
	write(*,*) '  data MED,MAD', dmed, dmad
	write(*,*) ' sigma MED,MAD', smed, smad
* BLR lightcurve
* 2021-10-02 KDH : TEST THIS OPTION FOR BLR LIGHTCURVE
      if( ipan .eq. ipanblrt ) then
	write(*,*) 'BLR lightcurve range:', ymn1, ymx1, ' curve', k
	add = max( 0., ( dmad + smed ) * 4 )
	WRITE(*,*) ' add = ( MED(sig) + MAD(data) ) X 4', add
	ymx1 = min( ymx1, dmed + add )
	ymn1 = max( ymn1, dmed - add )
	write(*,*) 'Shrink Y range to', dmed - add, dmed + add
	write(*,*) '   New Y range is', ymn1, ymx1

* non-BLR lightcurves
      else
* expand lightcurves by median error bar
* KDH : ONE NOISY LIGHTCURVE MAY DOMINATE
	add = max( 0., smed )
	ymx1 = ymx1 + add
	ymn1 = ymn1 - add
	write(*,*) 'Expand y range by ', add,  ' min,max', ymn1, ymx1
      end if

      end if

* use ymx = fmult x median for rms spectra with continuum
* 2020-03-22 KDH - include model in this list
      if( ipan .eq. ipanblrw ) then
	label = labels( k )
      if(    index( label, 'raw') .gt. 0
     &	.or. index( label, '-cont' ) .gt. 0
     &	.or. index( label, 'model' ) .gt. 0
     &	.or. index( label, 'RMSx' ) .gt. 0
     &		) then
	write(*,*) 'Curve', k, ymn1, ymx1, ' ', label(:len1(label))
	call avgrms( np, curves(1,k), avg, rms )
	write(*,*) ' avg', avg, ' rms', rms
	call medmad( np, curves(1,k), ymed, ymad )
	call mnmx( np, curves(1,k), ymin, ymax )
	write(*,*) ' med', ymed, ' mad', ymad
	write(*,*) ' min', ymin, ' max', ymax
c	fmult = 1.5
	fmult = 2.
	ymx1 = ymed * fmult
	ymn1 = 0.
* ymx2 is upper limit to ymx 
	if( k .eq. 2 ) ymx2 = 0.
	y = max( ymx2, ymax * 2. )
	write(*,*) 'blrw ymx2', ymx2, ' ->', y
	ymx2 = y
* ignore other curves on rms spectrum plot
      else if( index( label, 'model' ) .eq. 0 ) then
	ymx1 = ymx
	ymn1 = ymn
      end if
      end if

* expand the y range to include this curve
	write(*,*) 'Curve', k, ymn1, ymx1, ' ', label(:len1(label))
	if( ymn1 .lt. ymn ) write(*,*) k, ' ymn', ymn, ' ->', ymn1
	if( ymx1 .gt. ymx ) write(*,*) k, ' ymx', ymx, ' ->', ymx1
	ymn = min( ymn, ymn1 )
	ymx = max( ymx, ymx1 )

* next curve k
      end do

* 2020-03-22 KDH - WHY IS THIS IS EXCLUDING RMSX CURVE ?
* impose upper limit to ymx
      if( ipan .eq. ipanblrw .and. ymx2 .lt. ymx ) then
	y = min( ymx, ymx2 )
	write(*,*) 'blrw ymx', ymx, ' ->', y
	ymx = y
      end if

      if( ipan .eq. ipanabsn ) then
	ymn = -0.3
	ymx = 1.4
      end if

* modify y range to avoid large outliers dominating
      if(    ipan .eq. ipanavg 
     &	.or. ipan .eq. ipanblrw
     &	.or. ipan .eq. ipanbiasw
     &	.or. ipan .eq. ipanbiast ) then

* KDH : YMX CAN BE DOMINATED BY A NOISE SPIKE
      if( ipan .eq. ipanblrw .and. krmsx .ge. 1 ) then
	k = krmsx
	call medmad( np, curves( k, k ), ymed, ymad )
	write(*,*) 'RMSx curve', k, ' med', ymed, ' mad', ymad

      else if( ipan .eq. ipanbiasw .and. kchi .ge. 1 ) then
      if( kbias .ge. 1 ) then
	k = kbias
	call medmad( np, curves( k, k ), ymed, ymad )
	write(*,*) 'Bias curve', k, ' med', ymed, ' mad', ymad
      end if
	k = kchi
	call medmad( np, curves( k, k ), ymed, ymad )
	write(*,*) ' Chi curve', k, ' med', ymed, ' mad', ymad

      else
	call medmad( np, curves( 1, 1 ), ymed, ymad )
	write(*,*) 'Curve 1 med', ymed, ' mad', ymad
      end if

* ymn
	add = ymad * 4
	y = min( 0., max( ymn, ymed - add ) )
      if( y .lt. ymn ) then
	write(*,*) 'ymn', ymn, ' ->', y
	ymn = y 
      end if
* ymx
	y = max( 0., min( ymx, ymed * 5., ymed + add ) )
      if( y .gt. ymx ) then
	write(*,*) 'ymx', ymx, ' ->', y
	ymx = y
      end if

* KDH : TOP OF STRONG BROAD LINES IN AVG SPECTRUM
      if( ipan .eq. ipanavg ) then
      do k = 5, 5
* curve 4 is elr_w  curve 5 is avgfit_w
      if( k .eq. 1 .or. k .eq. 4 .or. k .eq. 5 ) then
* omit ends of spectrum where large noise spikes can occur
	j = np * 0.03
	call mnmx( np-2*j, curves( 1+j, k ), fmn, fmx )
	if( fmx .gt. ymx ) write(*,*) 'ymx', ymx, ' ->', fmx
	ymx = max( ymx, fmx )
      end if
      end do
      end if

* 2022 Jul KDH : clip (ymn,ymx) to avoid overly-wide range.
* clip range of chi-bias panel
      if( ipan .eq. ipanbiasw .or. ipan .eq. ipanbiast
     &		.or. ipan .eq. ipanblrw ) then
	y = ymed + 4. * ymad
	ymn = max( ymn, - y )
	ymx = min( ymx, 2*y )
c	if( ymn .eq. -y .or. ymx .eq. 2*y )
	write(*,*) 'Clip (', ymn, ymx, ' ) to (', -y, 2*y, ')'
      end if


* add space at top and bottom
	add = max( 0., ymx / 5. )
	ymx = ymx + add
	ymn = min( ymn, -add )
      end if
      if( ipan .eq. ipannlrw ) then
	if( ymx .gt. 0. ) ymn = min( ymn, -ymx/5. )
      end if

* further expansion
	add = 0.05 * abs( ymx - ymn )
	if( add .le. 0. ) add = 0.1
	f = 10. ** ( inflxdex - iflxdex )
	if( ipan .eq. ipanfy ) add = add / f
	ymx = ymx + add * 3.
	ymn = ymn - add
	if( ipan .eq. ipancont ) ymn = ymn - add * 2
      end if


	write(*,*) 'T : ', title(:len1(title))
	write(*,*) 'X : ', xlabel(:len1(xlabel))
	write(*,*) 'Y : ', ylabel(:len1(ylabel))

	logxy = 10 * logx + 20 * logy
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, logxy, ' )'

* window
	call pgsci( kolor_axis )
      if( ipan .eq. ipanfy ) then
	write(*,*) 'y axis flux scale factor', f
	call pgenv( xmn, xmx, ymn * f, ymx * f, 0, logxy )
	call pgswin( xmn, xmx, ymn, ymx )
	call plotlabel_flux( ylabel, fluxunit, iflxdex )
      else
	call pgenv( xmn, xmx, ymn, ymx, 0, logxy )
      end if

* log wavelength scale
      if( logx .ne. 0 ) then
	dex = xmx - xmn
	write(*,*) 'X range', dex, ' dex'
* more tick marks and labels
      if( ipan .eq. ipanwx ) then
	call pgloglam( xmn, xmx, ymn, ymx )
* KDH: ABOVE PGENV LOGX LABELS DECADES - SHOULD SUPPRESS THAT
      end if
      end if

* continuum wavelengths
      if( ipan .eq. ipancont ) then
	write(*,*) 'Ncurves', ncurves, ' nw', nw, ' nt', nt
* KDH : SHOULD SPACE EQUALLY BY RANK
      do k = 1, ncurves
	kolor = kolors( k )
	label = labels( k )
	iw = iw_k( k )
* rank
	kr = 0
      do i = 1, ncurves
	if( iw_k( i ) .le. iw_k( k ) ) kr = kr + 1
      end do
	x = ( kr - 1. ) / max( 1, ncurves - 1 )
	xw = 0.05 * ( 1. - x ) + x * 0.95

* 2020-03-22 KDH - a bit smaller
	call pgsch( csize * 0.9 )
	call pgsci( kolor )
c	call pgmtxt( 'B', -0.5, xw, x, label )
	call pgmtxt( 'B', -0.7, xw, x, label )
	call pgsch( csize )

	write(*,*) 'Curve', k, ' w(', iw, ' ) = ', label(:len1(label))
     &		, ' kolor',  kolor
c	write(*,*) 'xw', xw, ' x', x

* 2020-03-22 KDH - omit for simple plots
      if( .not. simpleplot ) then
* percent variation on right axis
	c = avgcont_w( iw )
* flux factor
	c = c / 100.
* stretch window
	call pgswin( xmn, xmx, ymn / c, ymx / c )
* external ticks
	call pgbox( ' ', 0., 0, 'CTI', 0., 0 )
* label ticks
      if( k .eq. k050 ) then
	call pgbox( ' ', 0., 0, 'CM', 0., 0 )
	call pgmtxt( 'R', 3.0, 0.5, 0.5, '\gDc %' )
      end if
* restore original window and colour index
	call pgswin( xmn, xmx, ymn, ymx )
      end if
	call pgsci( kolor_axis )
* next k
      end do
      end if

* horizontals
	call pgsls( kdot )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
      if( ipan .eq. ipancal 
     &	.or. ipan .eq. ipanbiasw
     &	.or. ipan .eq. ipanbiast ) then
	call pgmove( xmn, 1. )
	call pgdraw( xmx, 1. )
      end if
	call pgsls( 1 )


* label
	call pgsci( kolor_label )

      if( nstage .le. 0 ) then
	label = 'Model'
      else
	label = model_s( nstage )
	write(*,*) 'Model : ', label(:len1(label))
	label = 'Model ' // label(:len1(label))
      end if

	title = ' ' 
	if( ipan .eq. ipanavg ) title = 'Mean Spectrum'
	if( ipan .eq. ipancont ) title = 'Continuum Lightcurve'
	if( ipan .eq. ipannlrw ) title = 'NLR Spectrum'
	if( ipan .eq. ipanabsn ) title = 'Absorption Spectrum'
	if( ipan .eq. ipanblrw ) title = 'RMS Spectrum'
	if( ipan .eq. ipanblrt ) title = 'BLR Lightcurve'
	if( ipan .eq. ipanfit ) title = label(:len1(label))
	if( ipan .eq. ipandiff ) title = 'Data - ' // label(:len1(label))
      if( ipan .eq. ipaneta ) then
	title = '\gx(\gl,t) = ( Data - ' // label(:len1(label)) // ' ) / \gs '
	if( chifix ) title = title(:len1(title) ) // ' \gx'
      end if
	if( ipan .eq. ipandf ) title = 'd ' // label(:len1(label)) // ' / d pix '
	if( ipan .eq. ipanddf ) title = 'd\u2\d ' // label(:len1(label)) // ' / d pix \u2\d'

      if( ipan .eq. ipancal ) then
	title = 'Corrections'
	if( nfitblur .gt. 0 ) title = 'Blur ' // title
	if( nfitshift .gt. 0 ) title = 'Shift ' // title
	if( nfitphot .gt. 0 ) title = 'Phot ' // title
      end if

	if( ipan .eq. ipanfc ) title = 'Phot \gDp Correction'
	if( ipan .eq. ipanxc ) title = 'Shift \gD\gl Correction'
	if( ipan .eq. ipansc ) title = 'Blur \gD\gs Correction'
     
	yes = cliphi .gt. cliplo .and. kliplo+kliphi .gt. 0

      if( ipan .eq. ipanbiast ) then
      if( .not. simpleplot ) then
	call pgmtxt( 'T', 0.5, 0.5, 0.5, 'med(mad)' )
      end if
	title = 'Lightcurve Residuals'
	title = ' '
	call append( title, '\gm =' )
	call append_datsig( title, biasmedt, biasmadt, 2 )
	call append( title, '\gx =' )
	call append_datsig( title, chimedt, chimadt, 2 )
* KDH : SHOW CLIPPED RESULTS TOO
      if( yes ) then
	call append( title, '=>' )
	call append_datsig( title, chiclipmedt, chiclipmadt, 2 )
      end if
      end if

      if( ipan .eq. ipanbiasw ) then
      if( .not. simpleplot ) then
	call pgmtxt( 'T', 0.5, 0.5, 0.5, 'med(mad)' )
      end if
	title = 'Spectrum Residuals'
	title = ' '
	call append( title, '\gm =' )
	call append_datsig( title, biasmedw, biasmadw, 2 )
	call append( title, '\gx =' )
	call append_datsig( title, chimedw, chimadw, 2 )
* KDH : SHOW CLIPPED RESULTS TOO
      if( yes ) then
	call append( title, '=>' )
	call append_datsig( title, chiclipmedw, chiclipmadw, 2 )
      end if
      end if

	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )

* top right label -----------------------------------
	title = ' '
      if( ipan .eq. ipanblrw ) then
	call label_blrnlr( title, vblr, vnlr )
      else if( ipan .eq. ipanfit
     &	  .or. ipan .eq. ipandiff
     &	  .or. ipan .eq. ipaneta ) then
	title = ' '
	call append_i( title, nw )
	call append( title, '\x' )
	call append_i( title, nt )
	call nospace( title )

      if( simpleplot ) then
	call pgsch( csize * 0.7 )
	call pgmtxt( 'T', 0.5, 1., 1., title )
	call pgsch( csize )
      end if

      else if( ipan .eq. ipanavg .or. ipan .eq. ipannlrw ) then
	call label_blrnlr( title, vblr, vnlr )


      else if( ipan .eq. ipanbiasw .or. ipan .eq. ipanbiast ) then
	title = stage( :len1( stage ) )
	if( nstage .gt. 0 ) title = model_s( nstage )
	write(*,*) ' NSTAGE : ', nstage, ' MODEL : ', title(:len1(title))
      else if( ipan .eq. ipancont ) then
	title = 'C'
	call append_i( title, min( nfitcont, npcont ) )

      else if( ipan .eq. ipancal ) then
	title = ' '
      if( nfitphot .gt. 0 ) then
	call append( title , '\gDp' )
	call append_i( title, min( nfitphot, npscale ) )
      end if
      if( nfitshift .gt. 0 ) then
	call append( title, '\gD\gl' )
	call append_i( title, min( nfitshift, npshift ) )
      end if
      if( nfitblur .gt. 0 ) then
	call append( title, '\gD\gs' )
	call append_i( title, min( nfitblur, npblur ) )
      end if
      else if( ipan .eq. ipanxc ) then
	title = '\gD\gl'
	call append_i( title, min( nfitshift, npshift ) )
      else if( ipan .eq. ipansc ) then
	title = '\gD\gs'
	call append_i( title, min( nfitblur, npblur ) )
      end if

* omit for simple plots
      if( .not. simpleplot ) then
	call pgsch( csize * 0.7 )
	call pgmtxt( 'T', 0.5, 1., 1., title )

* fe2 label
* 2021-04-20 KDH : make subroutine
      if( ipan .eq. ipanavg ) then
	call label_fe2( title, fe2pct, fe2kms, sigfe2kms )
	call pgmtxt( 'T', 1.5, 1., 1., title )
      end if

	call pgsch( csize )
      end if

* greyscale panels ------------------------------------
      if( ipan .eq. ipanpic ) then


* chi2 label
	title = agn(:len1(agn))
	if( simpleplot ) title = ' '
      if( ipan .eq. ipaneta ) then
	title = '\gx\u2\d / ('
	call append_i( title, nt*nw )
	call append( title, '-' )
	call append_i( title, nfit )
	call append( title, ') =' )
	call append_f( title, chi2red, '(f15.3)' )
	write(*,*) 'Chi2 / (', nt*nw, ' -', nfit, ' ) =', chi2red
      if( chifix ) then
	call append( title, '=>' )
	call append_f( title, chi2fixred, '(f15.3)' )
      end if
      end if
	call nospace( title )

	call pgsch( csize * 0.7 )
	call pgmtxt( 't', 0.5, 0., 0., title(:len1(title)) )
	call pgsch( csize )

* greyscale
	call mnmx( nw*nt, pic_wt, pmn, pmx )
	write(*,*) 'Pic mn,mx', pmn, pmx
	write(*,*) '    fg,bg', fg, bg
      if( pmn .ne. pmx .or. pmn .ne. 0. ) then
	call pgpic( 'g', pic_wt, nw, nt, 1, nw, 1, nt,
     &		fg, bg, xplot, yplot )
	call pgupdt
	call pgsci( kolor_axis )

* re-draw the axis ticks
      if( logx .eq. 0 ) then
	call pgbox( 'bcst', 0., 0, 'bcst', 0., 0 )
      else
	call pgbox( 'bcslt', 0., 0, 'bcst', 0., 0 )
	call pgloglam( xmn, xmx, ymn, ymx )
      end if

* greyscale wedge
	call pgwedg( 'r', 1.5, 2.5, fg, bg, ' ' )

* full range on right edge
	call pgsch( csize * 0.7 )
	p = pmn
	y = 0.
      do k = 1, 2
	title = ' '
	call append_n( title, p, 3 )
	call pgmtxt( 'R', 1.2, y, y, title )
	p = pmx
	y = 1.
      end do
	call pgsch( csize )

* mark time gaps longer than dtgap
	dtgap = 60.
* narrow yellow
	call pgsci( kyellow )
	call pgslw( 1 )
	call pgsls( kdot )
      do it = 1, nt
	im = max( it - 1, 1 )
	ip = min( it + 1, nt )
	dtp = time( ip ) - time( it )	
	dtm = time( it ) - time( im )
      if( dtp .gt. dtgap ) then
	y = it + 0.5
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
      end if
      end do
	call pgsci( kblack )
	call pgsls( 1 )
	call pgslw( lwide )

	write(*,*) 'Bad data ', nada, ' of', nt*nw, ' =', nada*100./nt/nw, ' %'

* 2020-Mar-15 KDH - omit for simple plots
      if( .not. simpleplot ) then

* mark missing data
	kolor_bad = kred
	call pgsci( kolor_bad )
	call pgslw( 1 )
      if( nada .gt. 0 ) then
      do it = 1, nt
      do iw = 1, nw
      if( .not. good_wt( iw, it ) ) then
* mark with a dot
	x = xplot( iw )
	y = yplot( it )
	call pgpt( 1, x, y, 1 )
      end if
      end do
      end do
	call pgslw( lwide )
* label bad pixel count
	y = 2.4
	x = 0.
	label = ' '
	call append_i( label, nada )
	call append( label, '=' )
	call append_n( label, nada * 100. / nt / nw, 2 )
	call append( label, '%' )
	call nospace( label )

	call pgsch( csize * 0.7 )
	y = y / 0.5
	call pgmtxt( 'b', y, x, 1., 'bad:' )
	call pgmtxt( 'b', y, x, 0., label )
	call pgsch( csize )
      end if

      end if

* strike out bad times
	write(*,*) 'Bad times', nadat, ' of', nt, ' =', nadat*100./nt, ' %'
      if( nadat .gt. 0 ) then
      do it = 1, nt
      if( .not. good_t( it ) ) then
	y = yplot( it )
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
      end if
      end do
      end if

* strike out bad waves
	write(*,*) 'Bad waves', nadaw, ' of', nw, ' =', nadaw*100./nw, ' %'
      if( ndataw .gt. 0 ) then
      do iw = 1, nw
      if( .not. good_w( iw ) ) then
	x = xplot( iw )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end if
      end do
      end if
	call pgsci( kblack )

* count and mark hi and lo sigma-clipped pixels
      if( ipan .eq. ipaneta
     &	.or. ipan .eq. ipandiff ) then
      if( cliphi .gt. cliplo ) then

	nhi = 0
	nlo = 0
      do it = 1, nt
      do iw = 1, nw
	i = iw + nw * ( it - 1 )
      if( bad_wt( i ) ) then
	k = 0
	chi = chi_wt( i )
      if( chi .ge. cliphi ) then
	nhi = nhi + 1
	k = kolor_hi
      else if( chi .le. cliplo ) then
	nlo = nlo + 1
	k = kolor_lo
      end if
* mark with a dot
	x = xplot( iw )
	y = yplot( it )
	call pgsci( k )
	call pgslw( 1 )
	call pgpt( 1, x, y, 1 )
      end if
      end do
      end do
	call pgslw( lwide )
	kliphi = nhi
	kliplo = nlo
	klip = nhi + nlo
* clip legend
	call pgsch( csize * 0.7 )
	call pgclip( cliplo, cliphi, kliplo, kliphi, kolor_lo, kolor_hi )
	call pgsch( csize )

	call pgsci( kblack )
* report
	pcthi = kliphi * 100. / klip
	pctlo = kliplo * 100. / klip
	write(*,*) ' >', cliphi, ' :', kliphi, ' of', klip, ' =', nint( pcthi ), ' %'
	write(*,*) ' <', cliplo, ' :', kliplo, ' of', klip, ' =', nint( pctlo ), ' %'
      end if
	write(*,*) 'Clipped pixels', klip, ' of', n, ' =', klip*100./n, ' %'

      end if
      end if

* non-greyscale plots
      else

* top-left object name
      if( .not. simpleplot ) then
	call pgmtxt( 't', 0.5, 0.0, 0.0, agn )
      end if
* 5% tail
	i95 = max( 1, nint( np * 0.95 ) )
	last5 = np - i95 + 1

* spectra
      if( ipan .eq. ipanwx ) then
	write(*,*) 'Spectra:', ncurves, ' np', np

* count labels
	nlabel = 0
      do k = 1, ncurves
	call peqp( np, yplot, curves( 1, k ) )
	call avgrms( np, yplot, avg, rms )
      if( rms .gt. 0. ) then
	if( labels( k ) .ne. ' ' ) nlabel = nlabel + 1
      end if
      end do

* curves
	klabel = 0
      do k = 1, ncurves
	kolor = kolors( k )
	label = labels( k )
	call peqp( np, yplot, curves( 1, k ) )
* require variations
* KDH : IMPOSE THIS EARLIER?
	call avgrms( np, yplot, avg, rms )
      if( rms .gt. 0. ) then
	call pgsci( kolor )

      if( ipan .ne. ipanblrw ) then
	call pgbin( np, xplot, yplot, .true. )

* rms spectrum - positive values only 
      else
	i1 = np
	i2 = 1
      do i = 1, np
      if( yplot( i ) .ne. 0. ) then
	i1 = min( i1, i )
	i2 = max( i2, i )
      end if
      end do
* one pixel before and after
	i1 = max( i1 - 1, 1 )
	i2 = min( i2 + 1, np )
	n = i2 - i1 + 1
	if( n .gt. 0 ) call pgbin( n, xplot( i1 ), yplot( i1 ), .true. )
      end if

	call mnmx( np, yplot, x, y )
	if( label .eq. 'dat' ) write(*,*) 'dat: mn', x, ' mx', y
c	if( label .eq. 'dat' ) read(*,*)
* legend on right axis
      if( ipan .eq. ipanblrw .or. ipan .eq. ipanavg ) then
	if( label .ne. ' ' ) klabel = klabel + 1
	y = ymn + ( nlabel - klabel + 1 ) * ( ymx - ymn ) / 10
* place near right edge of data
      else
	call medmad( last5, yplot( i95 ), y, e )
      end if
	x = xmx + 0.01 * ( xmx - xmn )
	call pgtext( x, y, label )

	write(*,*) 'Spec', k, ' ', label(:len1(label)), avg, rms, x, y
      end if
* next curve k
      end do

* horizontal line at flux 0.
      if( ipan .eq. ipanblrw ) then
	call pgsci( kblack )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
      end if

* KDH : DEBUG - PLOT SOFT BLR WINDOW WEIGHTS
      if( .not. simpleplot ) then
      if( ipan .eq. ipanavg .or. ipan .eq. ipanblrw ) then
	if( ipan .eq. ipanavg ) call peqp( nw, wgt_w, avgwgt_w )
	if( ipan .eq. ipanblrw) call peqp( nw, wgt_w, blrwgt_w )
	f = 10.
	call pgswin( xmn, xmx, 0., f )
	call pgsci( kdkgrey )
	call pgline( nw, xplot, wgt_w )
	call pgswin( xmn, xmx, ymn, ymx )
      end if
      end if

* 2021-04-19 KDH - turn on
* 2021-09-25 KDH - turn off
* full spline tower 
      if( .FALSE. ) THEN
      if( .TRUE. .or. fulltower ) then
      if( ipan .eq. ipanavg ) then
      do n = 1, nlev
	call pgsci( n )
	call pgline( nw, xplot, fitavg_wn(1,n) )
      end do
      end if
      end if
      END IF

	call pgsci( kblack )




* absorption lines
* KDH : NEED TO MAKE AWARE OF LOGX
      if( dips ) then
	call markdips( nl, ltype_l, wobs_l, ymn, ymx, real(zshift) )
	call pgsci( kblack )
      end if

* mark lines
	write(*,*) 'Marking lines'
      do lrank = 1, markline
	l = i_l( lrank )
	xline = rest_l( l )
	expand = expand_l( l )
	vmed = vmed_l( l )
	vmad = vmad_l( l )
* velocity range
	v = 0.
* broad line
      if( nabc( l ) .eq. nbroad ) then
	v = vblr * expand
	y = ymn + 0.95 * ( ymx - ymn )
	y = ymn + 1.05 * ( ymx - ymn )
	call pgsci( kolor_blr )
* narrow line
      else if( nabc( l ) .eq. narrow ) then
	v = vnlr * expand
	y = ymn + 0.9 * ( ymx - ymn )
	y = ymn + 1.1 * ( ymx - ymn )
	call pgsci( kolor_nlr )
      end if

      if( v .gt. 0. ) then
* KDH : SWITCH THESE OFF
      IF( .FALSE. ) THEN
* KDH : NEED TO FIX FOR LOGX
	x = xline * exp( v / ckms )
	call pgerrb( 1, 1, xline, y, x-xline, 1. )
	x = xline * exp( - v / ckms )
	call pgerrb( 3, 1, xline, y, xline-x, 1. )
      END IF
	call pgsls( kdot )
	if( logx .ne. 0 ) xline = alog10( xline )
	call pgmove( xline, ymn )
	call pgdraw( xline, ymx )
	call pgsls( 1 )
      end if
* next lrank
      end do



* lightcurves =======================================
* KDH: CAN WE TREAT LIGHTCURVES ON SAME BASIS AS SPECTRA ?
*      NO. LIGHTCURVES USE PGLINE, PGPT AND PGERRB
*      SPECTRA USE PGBIN

      else if( ipan .eq. ipantx ) then
	write(*,*) 'Lightcurves:', ncurves, ' nt', nt

* site legend
      if( ipan .eq. ipanblrt ) then
	dy = -1.5
	y = 0
	title = ' '
      do i = 1, nsite
	if( i .eq. nosite ) cycle
	n = nt_s( i )
	if( n .lt. 1 ) cycle
	name = name_s( i )
	isymb = isymb_s( i )
	write(*,*) 'Site ', name(:len1(name)), ' Nt', n, ' isymb', isymb
	y = y + dy
c	call pgmtxt( 'T', y, 1.0, 0.0, ' ' // char( isymb ) // ' ' // name )
c	call pgmtxt( 'T', y, 0.0, 0.0, ' ' // char( isymb ) // ' ' // name )
	call append( title, char( isymb ) )
	call append( title, name )
* next site is
      end do
c	call pgmtxt( 'T', 0.5, 1.0, 1.0, title )
	x = 0.95
	call pgmtxt( 'B', -0.5, x, x, title )
      end if

* curves
      DO k = 1, ncurves
	label = labels( k )
	kolor = kolors( k )
	call peqp( np, yplot, curves( 1, k ) )
	call avgrms( np, yplot, avg, rms )

* require variations
      if( rms .le. 0. ) then
	write(*,*) '** Curve', k, ' avg', avg, ' rms', rms, ' NO VARIATIONS :((.'
      else

	call pgsci( kolor )
	call pgline( np, xplot, yplot )
	call pgerrb( 6, np, xplot, yplot, sigmas( 1, k ), 1. )

* each site has a different symbol
      do is = 1, nsite
	n = nt_s( is )
	if( n .lt. 1 ) cycle
	name = name_s( is )
	isymb = isymb_s( is )
	write(*,*) 'Site ', name(:len1(name)), ' Nt', n, ' isymb', isymb
      do it = 1, n
	i = i_ts( it, is )
	call pgpt( 1, xplot( i ), yplot( i ), isymb )
      end do
* next site is
      end do



* legend on right axis --------------------
* continuum
      if( ipan .eq. ipancont ) then
      else
* BLR
	x = xmx + 0.01 * ( xmx - xmn )
      if( ipan .eq. ipanblrt ) then
	y = ymn + ( k - 1 ) * ( ymx - ymn ) / 10
* debug report
c	write(*,*) 'BLR lightcurve', k, x, y, ' ', label(:len1(label))
* others
      else 
	call medmad( last5, yplot( i95 ), y, e )
      end if
	call pgtext( x, y, label )
      end if
      end if
* next curve k
      END DO
	call pgsci( kblack )

* top-centre label --------------------------
      if( ipan .eq. ipancont
     &	.or. ipan .eq. ipancal
     &	.or. ipan .eq. ipanfc ) then

* stats
	kref = 1
	if( ipan .eq. ipancont ) kref = k050

* KDH : SHOULD REMOVE POINTS WITH NEGATIVE SIGMAS
	call peqp( np, dat_t, curves( 1, kref ) )
	call peqp( np, sig_t, sigmas( 1, kref ) )
	call optavgrms( np, dat_t, sig_t, yavg, yrms )
	call medmad( np, dat_t, ymed, ymad )

* require variations
	if( yrms .gt. 0. ) then

* 2020-03-22 KDH - omit on simple plots
* horizontal lines at med +/- mad
      if( .not. simpleplot ) then
      do k = -1, 1
	y = ymed + k * ymad
	if( k .ne. 0 ) call pgsls( kdot )
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
	call pgsls( 1 )
      end do
      end if

* Prior( p(t) )
      if( ipan .eq. ipancal ) then
      if( siglnp0 .gt. 0. ) then
	title = 'Prior(\gDp)'
	call append_n( title, 100.*siglnp0, 2 )
	call append( title, '%' )
	call pgsci( korange )
	call pgmtxt( 'T', -3., 0.5, 0.5, title )
      do k = -1, 1, 2
	y = exp( k * siglnp0 )
	call pgsls( kdot )
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
      end do
	call pgsls( 1 )
	call pgsci( kblack )
      end if
      end if


      if( ipan .eq. ipancal .or. ipan .eq. ipanfc ) then
	title = '\gDp'

* continuum wavelengths
      else if( ipan .eq. ipancont ) then
	k = k050
	kolor = kolors( k )
	call pgsci( kolor )
	iw = iw_k( k )
	title = '\gDc('
	call append_i( title, nint( w_w( iw ) ) )
	call append( title, '\A)' )
	call nospace( title )
* divide by continuum
* KDH : THIS DIVIDE SHOULD BE UNDONE BEFORE SNR CALCULATION
	c = avgcont_w( iw )
	yavg = yavg / c
	yrms = yrms / c
	ymed = ymed / c
	ymad = ymad / c
      end if

* percent
	yavgpct = 100. * yavg
	yrmspct = 100. * yrms
	ymedpct = 100. * ymed
	ymadpct = 100. * ymad

* 2020-03-21 KDH - smaller, omit for simple plots
      if( .not. simpleplot ) then
	call pgsch( csize * 0.9 )
	call pgmtxt( 'T', 0.5, 0.5, 0.5, 'med(mad)%' )
	call pgsch( csize )
      end if

	call append_datsig( title, ymedpct, ymadpct, 2 )
	title = title(:len1( title ) ) // '%'

* compute snr

	n = 0
      do i=1,np
	sig = sigmas( i, 1 )
      if( sig .gt. 0. ) then
	n = n + 1
	sig_t( n ) = sig
	dat_t( n ) = curves( i, 1 )
      end if
      end do

	call snr3( n, dat_t, sig_t, sn1, sn2, snx )

* s/n on plot
c	snr = sn1
	snr = sn2
	call append( title, 'S/N' )
      do kk = 0, 0
c      do kk = 1, 2
	s = snr
	if( kk .eq. 1 ) s = sn1
	if( kk .eq. 2 ) s = sn2
	if( kk .eq. 3 ) s = snx
      if( s .le. 1000. ) then
	call append_n( title, s, 2 )
      else
	call append( title, '10\u' )
	l = len1( title )
	call append_n( title, alog10( s ), 2 )
	call append( title, '\d' )
	call nospace( title(l:) )
      end if
      end do
	call pgsci( kolors( kref ) )

* 2020-03-21 KDH - smaller, omit for simple plots
      if( .not. simpleplot ) then
	call pgsch( csize * 0.9 )
	call pgmtxt( 'T', -2.0, 0.5, 0.5, title )
c	call pgmtxt( 'T', -1.5, 0.5, 0.5, title )
	call pgsch( csize )
      end if

      end if

      end if
* 1st lightcurve fini
      end if
	call pgsci( kblack )
      end if

* report S/N for BLR variations
	title = ' '
      if( ipan .eq. ipanblrt .and. np .gt. 0 ) then
      do k = 1, ncurves
	label = labels( k )

* report snr (if there are variations)
c      IF( .FALSE. ) THEN
c	call peqp( np, dat_t, curves( 1, k ) )
c	call peqp( np, sig_t, sigmas( 1, k ) )
c	call mnmx( np, dat_t, dmn, dmx )
c      if( dmn .ne. dmx ) then
c	call optavg( np, dat_t, sig_t, a, s )
c	call medmad( np, dat_t, am, sm )
c	n = 0
c	sum = 0.d0
c	sum2 = 0.d0
c      do i = 1, np
c	sig = sig_t( i )
c	dat = dat_t( i )
c      if( sig .gt. 0. ) then
c	n = n + 1
c	e = ( dat - a ) / sig
c	sum2 = sum2 + e * e
c	e = ( dat - am ) / sig
c	sum = sum + abs( e )
c      end if
c      end do
c      end if
c      END IF

* compute snr
	n = 0
      do i = 1, np
	sig = sigmas( i, k )
      if( sig .gt. 0. ) then
	n = n + 1
	sig_t( n ) = sig
	dat_t( n ) = curves( i, k )
      end if
      end do

      if( n .gt. 0 ) then
	call snr3( n, dat_t, sig_t, sn1, sn2, snx )

* KDH : REMOVE CODE BELOW ONCE TESTED
c      IF( .FALSE. ) THEN
c	call optavg( n, dat_t, sig_t, a, s )
c	call medmad( n, dat_t, am, sm )
c	sum = 0.d0
c	sum2 = 0.d0
c      do i = 1, n
c	sig = sig_t( i )
c	dat = dat_t( i )
c	e = ( dat - a ) / sig
c	sum2 = sum2 + e * e
c	e = ( dat - am ) / sig
c	sum = sum + abs( e )
c      end do
* s/n from L1 or L2 norm
c	chi2r = sum2 / max( 1, n - 1 )
c	chi1 = sum / max( 1, n - 1 )
c	sn2 = sqrt( max( 0., sum2 - n ) )
c	sn1 = sum
* s/n from avgrmsx
* KDH : SATURATES AT N-1, SO UNCLEAR IF USEFUL.
c	call avgrmsx( n, dat_t, sig_t, good, avg, rmsx, sig, sigrmsx )
c	snx = rmsx / sigrmsx
c      END IF
* KDH : END OF CODE TO DELETE

* s/n on plot
	snr = sn1
	snr = sn2
	if( title .eq. ' ' ) title = 'S/N'
	call append( title, label )

      do kk = 0, 0
c      do kk = 1, 2
	s = snr
	if( kk .eq. 1 ) s = sn1
	if( kk .eq. 2 ) s = sn2
	if( kk .eq. 3 ) s = snx
      if( s .le. 9999. ) then
	call append_n( title, s, 2 )
      else
	call append( title, '10\u' )
	l = len1( title )
	call append_n( title, alog10( s ), 2 )
	call append( title, '\d' )
	call nospace( title(l:) )
      end if
* next kk
      end do
      end if
* next lightcurve k
      end do
	call pgsci( kblack )

* 2020-03-21 KDH - smaller, omit for simple plot
      if( .not. simpleplot ) then
	call pgsch( csize * 0.9 )
	call pgmtxt( 'T', -2.0, 0.5, 0.5, title )
c	call pgmtxt( 'T', -1.5, 0.5, 0.5, title )
	call pgsch( csize )
      end if

	write(*,*) title(:len1(title))
* end n > 0
      end if


* report bad and clipped data

      IF( ipan .eq. ipanbiasw .or. ipan .eq. ipanbiast ) then
	yes = ipan .eq. ipanbiast

* bad times
      if( yes ) then
	nbad = nadat
	n = nt
* bad waves
      else
	nbad = nadaw
	n = nw 
      end if
      if( nbad .gt. 0 ) then
	y = 2.4
	x = 0.
	label = ' '
	call append_i( label, nbad )
	call append( label, '/' )
	call append_i( label, n )
	call nospace( label )
	call pgsci( kred )
* 2020-Mar-15 KDH - omit for simple plots
      if( .not. simpleplot ) then
	call pgsch( csize * 0.7 )
	y = y / 0.5
	call pgmtxt( 'b', y, x, 1., 'bad:' )
	call pgmtxt( 'b', y, x, 0., label )
	call pgsch( csize )
      end if
      end if

* clip legend
      if( .not. simpleplot ) then
	call pgsch( csize * 0.7 )
	call pgclip( cliplo, cliphi, kliplo, kliphi, kolor_lo, kolor_hi )
	call pgsch( csize )
      end if
	klip = kliplo + kliphi

* clip histograms
      if( klip .gt. 0 ) then
      if( yes ) then
	n = nt
	call peqp( n, plot1, pixlo_t )
	call peqp( n, plot2, pixhi_t )
	call peqpap( n, plot3, pixlo_t, pixhi_t )
      else
	n = nw
	call peqp( n, plot1, pixlo_w )
	call peqp( n, plot2, pixhi_w )
	call peqpap( n, plot3, pixlo_w, pixhi_w )
      end if
	call mnmx( n, plot1, p1mn, p1mx )
	call mnmx( n, plot2, p2mn, p2mx )
	call mnmx( n, plot3, pmn, pmx )
	write(*,*) n, ' pix/bin lo', p1mx, ' hi', p2mx, ' tot', pmx	
* 2020-03-22 KDH - omit for simple plots
      if( pmx .gt. 0. .and. ( .not. simpleplot ) ) then
	call pgswin( xmn, xmx, 0., pmx * 10. )
	call pgsci( kolor_hi )
	call pgbin( n, xplot, plot3, .true. )
	call pgsci( kolor_lo )
	call pgbin( n, xplot, plot1, .true. )
	call pgswin( xmn, xmx, ymn, ymx )
      end if
      end if

* KDH: MOVE UP TO FIDUCIALS?  No - we want this on top.
* median chi and bias levels
	i1 = 3
	if( cliphi .gt. cliplo .and. klip .gt. 0 ) i1 = 1
      DO i = i1, 4
* unclipped chi
      if( i .eq. 1 ) then
	k = 15
	y = chimedw
	if( yes ) y = chimedt
* unclipped bias
      else if( i .eq. 2 ) then
	k = 15
	y = biasmedw
	if( yes ) y = biasmedt
* sigma clipped chi
      else if( i .eq. 3 ) then
	k = 3
	y = chiclipmedw
	if( yes ) y = chiclipmedt
* sigma clipped bias
      else if( i .eq. 4 ) then
	k = 8
	y = biasclipmedw
	if( yes ) y = biasclipmedt
      end if
	write(*,*) ' horizontal', i, y, ' colour index', k
	call pgsci( k )
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
* next i
      END DO

* end biasw .or biast
      END IF

* label selected lines -----------------------------------
	csz = 0.7 * csize
c	if( nx .gt. 1 ) csz = 0.5 * csize
	call pgsch( csz )
      if( ipan .eq. ipanavg
     &	.or. ipan .eq. ipannlrw
     &	.or. ipan .eq. ipanblrw ) then

	write(*,*) 'label selected lines'
* optical lines
	kha = 1
	khe1 = 2
	khb = 3	
	khg = 4
	khe2 = 5
* uv lines
	kmg2 = 6
	kc3 = 7
	k1640 = 8
	kc4 = 9
	ksi4 = 10
	klya = 11
* narrow lines
	ko3 = 12
	ko2 = 13
	ko1 = 14
* ir lines
	k8446 = 15
	k10830 = 16
	kpa = 17
	kpb = 18
	kpg = 19
	kpd = 20

	kk = 20

* additional lines (if single-column)
      if( nx .eq. 1 ) then
* si2
	kk = kk + 1
	ksi2 = kk
* ne5
	kk = kk + 1
	kne5 = kk
* s3
	kk = kk + 1
	ks3 = kk
* n5
	kk = kk + 1
	kn5 = kk
      end if

* line labels

      do k = 1, kk
	if( k .eq. kha ) l = line_ha
	if( k .eq. khe1 ) l = line_he1
	if( k .eq. khb ) l = line_hb
	if( k .eq. khg ) l = line_hg
	if( k .eq. khe2 ) l = line_he2
	if( k .eq. kmg2 ) l = line_mg2
	if( k .eq. kc3 ) l = line_c3
	if( k .eq. k1640 ) l = line_1640
	if( k .eq. kc4 ) l = line_c4
	if( k .eq. ksi4 ) l = line_si4
	if( k .eq. kn5 ) l = line_n5
	if( k .eq. klya ) l = line_lya
	if( k .eq. ko3 ) l = line_o3
	if( k .eq. ko2 ) l = line_o2
	if( k .eq. ko1 ) l = line_o1
	if( k .eq. ksi2 ) l = line_si2
	if( k .eq. kne5 ) l = line_ne5
	if( k .eq. kn2 ) l = line_n2
* ir lines
	if( k .eq. k8446 ) l = line8446
	if( k .eq. ks3 ) l = line_s3
	if( k .eq. k10830 ) l = line10830
	if( k .eq. kpa ) l = line_pa
	if( k .eq. kpb ) l = line_pb
	if( k .eq. kpg ) l = line_pg
	if( k .eq. kpd ) l = line_pd
	if( k .eq. kpe ) l = line_pe
	if( k .eq. kpz ) l = line_pz

* KDH : OMIT IF LINE NOT VARIABLE ?
      if( l .gt. 0 ) then
      if( expand_l( l ) .gt. 0. ) then
	x = rest_l( l )
	if( logx .ne. 0 ) x = alog10( x )
	x = ( x - xmn ) / ( xmx - xmn )
* KDH : OMIT LINES OUTSIDE PLOT WINDOW
      if( x .gt. 0.01 .and. x .lt. 0.99 ) then
	call pgsci( kolor_l( l ) )

* lines down from top axis
      if( nabc(l) .eq. nbroad .and. ipan .ne. ipannlrw
     &	) then
* line names below spectrum (ALWAYS)
      if( simpleplot .or. .TRUE. ) then
	y = -0.5
* raise major line names
	yup = -1.5
	if( k .eq. klya ) y = yup
	if( k .eq. kc4 )  y = yup
	if( k .eq. kc3 )  y = yup
	if( k .eq. kmg2 ) y = yup
	if( k .eq. khb )  y = yup 
	if( k .eq. kha )  y = yup
	call pgmtxt( 'b', y, x, 0.5, label_l( l ) )
c	write(*,*) nint( rest_l( l ) ), ' ', label_l( l ) (: len1( label_l( l ) )

* line names above spectrum
      else
	y = -3.
* lower minor line names
	ydn = -4.5
	if( k .eq. kn5 )    y = ydn
	if( k .eq. khe2 )   y = ydn
	if( k .eq. k1640 )  y = ydn
	if( k .eq. khe1 )   y = ydn
	if( k .eq. k10830 ) y = ydn
	if( k .eq. k8446 )  y = ydn
	call pgmtxt( 't', y, x, 0.5, label_l( l ) )
c	write(*,*) nint( rest_l( l ) ), ' ', label_l( l ) (: len1( label_l( l ) )

      end if
* narrow lines below spectrum
      else if( nabc( l ) .eq. narrow .and. ipan .ne. ipanblrw ) then
	y = -0.5
	call pgmtxt( 'b', y, x, 0.5, label_l( l ) )
c	write(*,*) nint( rest_l( l ) ), ' ', label_l( l ) (: len1( label_l( l ) )

      end if
      end if
      end if
      end if
* next line k
      end do

* Balmer and Paschen and Lyman continuum labels
      if( ipan .ne. ipannlrw ) then
      do k = 1, 3
      if( k .eq. 1 ) then
	x = bac2
	label = 'H\(766)'
      else if( k .eq. 2 ) then
	x = pac2
	label = 'P\(766)'
      else if( k .eq. 3 ) then
	x = wlyc2
	label = 'L\(766)'
      end if
	if( logx .ne. 0 ) x = alog10( x )

      if( x .gt. xmn .and. x .lt. xmx ) then
	x = ( x - xmn ) / ( xmx - xmn )
	call pgsci( kolor_bac )
      if( simpleplot .or. .true. ) then
	y = -0.5
c	call pgmtxt( 'b', y, x, 0.5, 'H\(766)' )
	call pgmtxt( 'b', y, x, 0.5, label )
      else
	y = -3.
c	call pgmtxt( 't', y, x, 0.5, 'H\(766)' )
	call pgmtxt( 't', y, x, 0.5, label )
      end if
      end if
      end do

      end if
      end if


* restore character size
	call pgsch( csize )
	call pgsci( kblack )

*---------------------------------
* spectral masks 
* KDH : 2023 FEB - MARK ON BORDERS OF GREYSCALE PLOTS
      if( ipan .eq. ipanwx ) then

* vertical locations (plot window units)
	dy = 0.01 / 3.
	top  = 1.00
	top1 = top  - dy
	top2 = top1 - dy

	bot  = 0.00
	bot1 = bot  + dy
	bot2 = bot1 + dy

	upnlr = 0.95
	upblr = 0.97
	upbal = 0.96
	upvar = 0.93
	upabs = 0.85
	upbf = upvar

* loops 
	ltop = 1
	lbot = 2
	l1 = 1
	if( ipan .ne. ipanpic ) l1 = 0
      do loop = l1, 2

* vertical offset
      if( loop .eq. ltop ) then
	upnlr = top
	upbal = top
	upabs = top
	upblr = top1
	upbf  = top2
	upvar = top2
      else if( loop .eq. lbot ) then
	upnlr = bot
	upbal = bot
	upabs = bot
	upblr = bot1
	upbf  = bot2
	upvar = bot2
      end if

* KDH : VALUES OUTSIDE PLOT WINDOW (0-1) DON'T WORK
* expand viewport by 1% at top and bottom
      if( loop .eq. 1 ) then
	call pgqvp( 0, x1, x2, y1, y2 )
	dy = ( y2 - y1 ) * 0.01
	call pgsvp( x1, x2, y1 - dy, y2 + dy )
      end if

* loop over cases, wide first, narrow last
	kbf = 1
	kblr = 2
	kvar = 3
	kbal = 4
	knlr = 5
      do k = 1, 5
* omit if simpleplot
      IF( .not. simpleplot ) THEN

* NLR mask --------------------------
      if( k .eq. knlr ) then
	up = upnlr
c	write(*,*) up, ' NLR'
	y = ymn + up * ( ymx - ymn )
	x = xplot( 1 )
	call pgsci( kolor_nlr )
	call pgmove( x, y )
      do i = 1, nw
	x = xplot( i )
	if( masknlr(i) ) call pgdraw( x, y )
	call pgmove( x, y )
      end do
* end kabs
      end if

* BLR mask --------------------------
      if( k .eq. kblr ) then
	up = upblr
c	write(*,*) up, ' BLR'
	y = ymn + up * ( ymx - ymn )
	x = xplot( 1 )
	call pgsci( kolor_blr )
	call pgmove( x, y )
      do i = 1, nw
	x = xplot( i )
	if( maskblr(i) ) call pgdraw( x, y )
	call pgmove( x, y )
      end do
* end kblr
      end if

* BAL mask -------------------------
      if( k .eq. kbal ) then
	up = upbal
c	write(*,*) up, ' BAL'
	y = ymn + up * ( ymx - ymn )
	x = xplot( i )
	call pgsci( kolor_bal )
	call pgmove( x, y )
      do i = 1, nw
	x = xplot( i )
	if( maskbal(i) ) call pgdraw( x, y )
	call pgmove( x, y )
      end do
* end kbal
      end if

* Variable lines --------------------
      if( k .eq. kvar ) then
      do ic = 1, ncomp
	up = upvar
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
	text = text_l( l )
* nudge N5 and He2 down to avoid overlap with Ly1, C4 and Hb
      if( loop .eq. 0 ) then
	yes = l .eq. line1240 .or. l .eq. line1640 .or. l .eq. line4686
	if( yes ) up = up - 0.02
      end if
c	write(*,*) up, ' ', text(:len1(text) )

* KDH : SHOULD TWEAK UP TO AVOID OVERLAPS
	x = xplot( 1 )
	y = ymn + up * ( ymx - ymn )
	kolor = kolor_l( l )
	call pgsci( kolor )
	call pgmove( x, y )
      do i=1,nw
	x = xplot( i )
	if( mask_wl(i,l) ) call pgdraw( x, y )
	call pgmove( x, y )
      end do
c	write(*,*) 'Line ', text( :len1( text) ), ' kolor', kolor
      end if
      end do
	call pgsci( 1 )
* end kvar
      end if


* absn mask -------------------------
      if( k .eq. kabs ) then
	up = upabs
c	write(*,*) up, ' ABSN'
	y = ymn + up * ( ymx - ymn )
	x = xplot( 1 )
	call pgsci( kolor_absn )
	call pgmove( x, y )
      do i=1,nw
	x = xplot( i )
      if( maskdim( i ) ) then
	call pgdraw( x, y )
      else
	call pgmove( x, y )
      end if
      end do
* end kabs
      end if

* end not simpleplot
      END IF

* bound-free continua ---------------------
      if( k .eq. kbf ) then
	up = upbf
* BaC
	call pgsci( kolor_bac )
	call pgsls( kdot )
	x = bac2
	if( logx .ne. 0 ) x = alog10( x )
	call pgmove( x, ymx )
	call pgdraw( x, ymn )
	call pgsls( 1 )

      if( .not. simpleplot ) then
c	write(*,*) up, ' BaC'
	y = ymn + up * (ymx-ymn)
	x = xplot( 1 )
	call pgmove( x, y )
      do i=1,nw
	x = xplot( i )
	if( maskbac(i) ) call pgdraw( x, y )
	call pgmove( x, y )
      end do
      end if

* LyC
	call pgsci( kolor_lyc )
	call pgsls( kdot )
	x = wlyc2
	if( logx .ne. 0 ) x = alog10( x )
	call pgmove( x, ymx )
	call pgdraw( x, ymn )
	call pgsls( 1 )

* not implemented for LyC
      IF( .FALSE. ) THEN
      if( .not. simpleplot ) then
c	write(*,*) up, ' LyC'
	y = ymn + up * (ymx-ymn)
	x = xplot( 1 )
	call pgmove( x, y )
      do i=1,nw
	x = xplot( i )
C	if( masklyc(i) ) call pgdraw( x, y )
	call pgmove( x, y )
      end do
      end if
      END IF

* PaC
	call pgsci( kolor_pac )
	call pgsls( kdot )
	x = pac2
	if( logx .ne. 0 ) x = alog10( x )
	call pgmove( x, ymx )
	call pgdraw( x, ymn )
	call pgsls( 1 )

* not implemented for PaC
      IF( .FALSE. ) THEN
      if( .not. simpleplot ) then
c	write(*,*) up, ' PaC'
	y = ymn + up * (ymx-ymn)
	x = xplot( 1 )
	call pgmove( x, y )
      do i=1,nw
	x = xplot( 1 )
C	if( maskpsc(i) ) call pgdraw( x, y )
	call pgmove( x, y )
      end do
      end if
      END IF

* end kbf
      end if
* next k
      end do
* next loop
      end do

* restore viewport
	call pgsvp( x1, x2, y1, y2 )
* end ipanwx
      end if


* next panel
      end do
* close
	call pgstop
* again
	if( pgagain() ) goto 590

	goto 510
c	if( reply(1:1) .eq. 'I' ) goto 510
c	goto 500

* Output menu ------------------------------------------

  570 if( iwlo .le. 0 .or. iwhi .lt. iwlo ) then
	iwlo = 1
	iwhi = nw
	nwout = iwhi - iwlo + 1
	iwbin = 1
      end if
	write(*,*) '-----------------------------------------------'
	write(*,*) 'PrepSpec Output Menu: Nt', nt, ' Nw', nw
	write(*,*) ' P ... Prefix ' // prefix( :len1( prefix ) ) 
	write(*,*) ' W ... Waves', nwout, w_w(iwlo), w_w(iwhi), ' bin', iwbin

* out flux units
	title = '  U ... Units of Output Flux : '
	call append( title, outfluxunit )
      if( outfluxunit .eq. 'FLAM' ) then
	i = ioutdex
      if( i .ne. 0 ) then
	call append( title, '10^(' )
	call append_i( title, i )
	call append( title, ')' )
      end if
	call append( title, 'erg/cm2/s/A' )
      end if
	write(*,'(A)') title(:len1(title))

	write(*,*) '  T ... Trailed spectrogram'
	write(*,*) '  S ... Individual Spectra (with and without narrow lines)'
	write(*,*) '  A ... Avg, RMS, and NLR spectra'
	write(*,*) '  C ... Continuum lightcurves'
	write(*,*) '  L ... Line profiles and lightcurves'
	write(*,*) '  X ... Chi/Bias spectrum and lightcurve'
	write(*,*) '  F ... Flux Shift Blur calibrations'
	write(*,*) '  V ... Velocity widths'
	write(*,*) ' M ... MCMC linewidth error bar test'
	write(*,*) ' Q ... Quit'

* output commands -----------------------------

  571	call inq( 'PrepSpec Output >', ' ', reply )
	call upcase( reply, reply )
	if( reply .eq. 'Q' ) goto 510

	if( reply .eq. 'W' ) goto 572
	if( reply .eq. 'T' ) goto 572
	if( reply .eq. 'S' ) goto 572
	if( reply .eq. 'A' ) goto 573
	if( reply .eq. 'C' ) goto 574
	if( reply .eq. 'L' ) goto 575
	if( reply .eq. 'X' ) goto 576
	if( reply .eq. 'F' ) goto 577
	if( reply .eq. 'V' ) goto 578
	if( reply .eq. 'M' ) goto 579

* output file prefix
      if( reply .eq. 'P' ) then
	call inq( 'Prefix for output files : ', prefix, reply )
	if( reply .ne. ' ' ) prefix = reply(:len1(reply))
	goto 570

* output flux units and scale
* KDH : THIS IS UNDER TEST
      else if( reply .eq. 'U' ) then
	reply = outfluxunit
	call inq( 'Output flux units (FLAM, AB, MJY)', reply, reply )
	call upcase( reply, reply )
	if( reply(1:1) .eq. 'F' ) outfluxunit = 'FLAM'
	if( reply(1:1) .eq. 'M' ) outfluxunit = 'MJY'
	if( reply(1:1) .eq. 'A' ) outfluxunit = 'AB'

      if( outfluxunit .eq. 'FLAM' ) then
	in = inflxdex
	write(*,*) 'Input  FLAM units 10^', in, ' erg/cm2/s/A'
	i = ioutdex
	write(*,*) 'Output FLAM units 10^', i,  ' erg/cm2/s/A'
	call inqi( 'Output FLAM units (dex) (e.g. -14)', i, i )
	ioutdex = i
      end if
      end if
	goto 570


* Clip output wavelength limits
  572	if( iwlo .le. 0 ) iwlo = 1
	if( iwhi .lt. iwlo ) iwhi = min( nw, iwhi )
	nwout = iwhi - iwlo + 1
	wlo = w_w( iwlo )
	whi = w_w( iwhi )
	write(*,*) 'Wavelength range:', nw, w_w(1), w_w(nw)
	write(*,*) 'To be clipped to:', nwout, wlo, whi
	call inq2r( 'Wavelength range', wlo, whi )
	iwlo = 1
      do i = 1, nw
	if( w_w( i ) .le. wlo ) iwlo = i
      end do
	iwhi = nw
      do i = nw, 1, -1
	if( w_w( i ) .ge. whi ) iwhi = i
      end do
	nwout = iwhi - iwlo + 1
	wlo = w_w( iwlo )
	whi = w_w( iwhi )
      if( nwout .le. 0 ) then
	write(*,*) '** NO DATA IN WAVELENGTH RANGE :((.'
	goto 570
      end if
	write(*,*) 'Output wavelengths:', nwout, wlo, whi

* bin factor
	dw = ( whi - wlo ) / nwout
	dlnw = alog( whi / wlo ) / nwout
	dkms = dlnw * ckms
	pix = nwout * dkms / 250.
	write(*,*) 'Mean A/pix', dw, ' km/s/pix', dkms
	iwbin = nwout / pix
	iwbin = max( 1, iwbin )
	write(*,*) 'Bin factor', iwbin, ' gives', dkms * iwbin, ' km/s/pix'
	call inqi( 'Wavelength Bin factor', iwbin, iwbin )
	iwbin = max( 1, iwbin )

* KDH : NOT SURE IF THIS ADDITIVE FUDGE IS APPROPRIATE :(

* add a bit to keep lightcurves positive
	call mnmx( nt, blr_t, blrmn, blrmx )
	call mnmx( nt, bac_t, bacmn, bacmx )
* variable line components
	flo = 0.
	fhi = 0.
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
c      if( npix_l( l ) .gt. 0 ) then
	call mnmx( nt, dat_tl( 1, l ), fmn, fmx )
	text = text_l( l )
	write(*,*) text(:len1(text)), ' mn,mx', fmn, fmx
	flo = min( flo, fmn )
	fhi = max( fhi, fmx )
      end if
      end do

* add these only for trailed spectrum output
	safe = 0.
	if( reply .eq. 'T' ) safe = 1.05

	addf   = abs(   flo ) * safe
	addblr = abs( blrmn ) * safe
	addbac = abs( bacmn ) * safe

	write(*,*) 'BLR  mn,mx', blrmn, blrmx, ' add', addblr
	write(*,*) 'all  mn,mx', flo, fhi, ' add', addf
	write(*,*) 'BaC min', bacmn, ' max', bacmx, ' add', addbac

	j = 0
	nbad = 0
	chimax = 0.
* times
      do it = 1, nt
	i0 = ( it - 1 ) * nw
      do k = 1, npcont
	cont_p( k ) = cont_tp( it, k )
      end do

* wavelengths
      do iw = iwlo, iwhi
	i = i0 + iw
	dif = dif_wt( i )
	sig = sig_wt( i )
	if( chifix ) sig = sig * chifix_wt( i )
* mean spectrum (omitting narrow line component )
	avg = avg_w( iw )
	avgcont = avgcont_w( iw )
* narrow emission line spectrum
	elr = elr_w( iw )
* continuum variations
	w = w_w( iw )
	xw = xw_w( iw )
c	c = c0 + xw * ( c1 + xw * ( c2 + xw * ( c3 + xw * c4 ) ) ) 
	varcont = poly4( npcont, cont_p, xw )

	c = avgcont + varcont

* line variations

* KDH : THIS NEEDS WORK...
	blr = ( blr_t( it ) + addblr ) * blr_w( iw )
* variable line components
	f = 0.
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	l = line_lc( 1, ic )
	f = f + ( dat_tl( it, l ) + addf ) * dat_wl( iw, l )
      end if
      end do

	bac = ( bac_t( it ) + addbac ) * bac_w( iw )
	fline = f + blr + bac
* mean spectrum plus variable lines and continuum
	fit = avg + varcont + fline
* data with no NLR
	dat = dif + fit
* data with NLR 
	datnlr = dat + elr
* trailed spectrogram data (no NLR or continuum)
	if( reply .eq. 'T' ) dat = dif + fline

* absn (place-holder)
	a = 1.

* 2021-05-20 KDH - Is elr non-zero?
* debug report
      if( abs( w - 5008 ) .lt. 1. ) then
	halfpixel = ( w_w( iw+1 ) - w_w( iw-1 ) ) / 4.
      if( abs( w - nint( w ) ) .lt. halfpixel ) then
	write(*,*) 'SEQ', it, ' ANG', w
	write(*,*) 'DAT', dat, ' +NLR', datnlr
	WRITE(*,*) 'SIG', sig, ' cont', c, ' ABSN', a
	write(*,*)
      end if
      end if


* fudge error bars

* KDH : NEED TO BOOST ERROR BARS TO ACCOUNT FOR FLUX, SHIFT, BLUR

* stow
	j = j + 1
	buf1( j ) = dat
	buf2( j ) = sig
	buf3( j ) = datnlr
	buf4( j ) = c
	buf5( j ) = a
* KDH : NEED DOUBLE PRECISION FOR WAVELENGTHS
	if( it .eq. 1 ) plot1( j ) = w_w( iw )
	if( it .eq. 1 ) wave8( j ) = w8_w( iw )
* next wavelength iw
      end do
	write(*,*)
* next time it
      end do

*      if( reply .ne. 'W' ) then
	write(*,*) 'Error bar scale factor', chimedw
	ipc = nint( nbad * 100. / (nw*nt) )
	write(*,*) 'Boost sigmas on', nbad, ' of', nw*nt, 'pixels =', ipc, ' %' 
	write(*,*) 'Max boost factor', chimax
*      end if

* bin wavelengths

      if( iwbin .ge. 1 ) then
	i = 0
      do it = 1, nt
	j0 = (it-1) * nwout
      do i1 = 1, nwout-iwbin+1, iwbin
	i = i + 1
	j = j0 + i1
* 2021-05-20 KDH - rearrange this as narrow lines not reaching output files
* spectrum data ( sans narrow lines )
	call optavg( iwbin, buf1(j), buf2(j), dat, sig )
* spectrum data ( with narrow lines )
	call optavg( iwbin, buf3(j), buf2(j), datnlr, sign )
* continuum ( mean + variable )
	call optavg( iwbin, buf4(j), buf2(j), c, sigc )
* absn
	call optavg( iwbin, buf5(j), buf2(j), a, siga )
* stow bin-averages
	buf1( i ) = dat
	buf2( i ) = sig
	buf3( i ) = datnlr
	buf4( i ) = c
	buf5( i ) = a
* bin-centre wavelength
      if( it .eq. 1 ) then
	jp = j + iwbin - 1
	wm = plot1( j )
	wp = plot1( jp )
	wm8 = wave8( j )
	wp8 = wave8( jp )
	plot1( i ) = ( wm + wp ) / 2.
	wave8( i ) = ( wm8 + wp8 ) / 2.d0
	nwbin = i
      end if
      end do
      end do
      end if

* report
	write(*,*) 'Binned wavelengths:', nwbin, plot1(1), plot1(nwbin)
	write(*,*) 'Binned wavelengths:', nwbin, wave8(1), wave8(nwbin)
	call mnmx( nwbin, plot1, wmn, wmx )
c	call dmnmx( nwbin, wave8, wmn8, wmx8 )
	dw = ( wmx - wmn ) / nwbin
	dlnw = alog( wmx / wmn ) / nwbin
	dkms = dlnw * ckms
	pix = nwbin * dkms / 250.
	write(*,*) 'Mean A/pix', dw, ' km/s/pix', dkms

	if( reply .eq. 'W' ) goto 571

* scale FLAM to output flux units
      if( outfluxunit .eq. 'FLAM' ) then
	write(*,*) 'Output fluxes FLAM'
      if( ioutdex .ne. iflxdex ) then
	f = 10. ** ( inflxdex - ioutdex )	
	write(*,*) 'In', inflxdex, ' Out', ioutdex, ' dex'
	write(*,*) 'Scale by factor', f
	n = nwbin * nt
      do i = 1, n
	buf1( i ) = buf1( i ) * f
	buf2( i ) = buf2( i ) * f
	buf3( i ) = buf3( i ) * f
	buf4( i ) = buf4( i ) * f
      end do
      end if
      end if


* trailed spectrogram
      if( reply .eq. 'T' ) then

	call word1( prefix, l1, l2 )
	file = prefix(l1:l2) // '.trs'
	write(*,*) 'Suggested Output file ', file(:len1(file))
	call inq( 'Trailed Spectrogram Output file (0 if none): ', file, reply )

      if( reply(1:1) .ne. '0' ) then

	file = reply
	call dump2d2( file, 2, nwbin, nt, plot1, time, buf1, buf2 )
	write(*,*) 'Output Nt', nt, ' Nw', nwbin

* revise prefix
	i = index( file, '.' )-1
	if( i .le. 0 ) i = len1( file )
	prefix = file( : i )
	write(*,*) 'Prefix for output files ', prefix(:len1(prefix))

      end if

* corrected spectra

      else if( reply .eq. 'S' ) then
	write(*,*) '** WARNING: Code in development. Use with caution'
	write(*,*) 'Spectra to output:', nt

* hjd filename
	call word1( prefix, l1, l2 )
	file = prefix(l1:l2) // '.hjd'
	if( timebase(1:3) .eq. 'MJD' ) file = prefix(l1:l2) // '.mjd'
	if( timebase(1:3) .eq. 'RJD' ) file = prefix(l1:l2) // '.rjd'

	write(*,*) 'Timebase ', timebase(:len1(timebase))
	write(*,*) 'Suggested Output file ', file(:len1(file))
	call inq( 'Output file (0 if none)', file, reply )
      if( reply(1:1) .ne. '0' ) then
	file = reply
	call word1( file, l1, l2 )
	hjdfile = file( l1:l2 )

* open hjd file
	iout = 15
	CALL OPENFILE( iout, hjdfile, 'FORMATTED', 'UNKNOWN', IER )
      IF( IER .NE. 0 ) then
	write(*,*) '** ERROR: JD file open failed.  :(((((('
	GOTO 571
      end if

* revise prefix
	i = index( hjdfile, '.' )-1
	if( i .le. 0 ) i = len1( hjdfile )
	prefix = hjdfile( : i )
	write(*,*) 'Prefix for output files ', prefix(:len1(prefix))


* open another hjd file (for spectra with narrow lines)
	i = index( hjdfile, '.' )
	hjdfile1 = hjdfile(:i-1) // '_nlr' // hjdfile(i:)
	iout1 = iout + 1
	CALL OPENFILE( iout1, hjdfile1, 'FORMATTED', 'UNKNOWN', IER )
      IF( IER .NE. 0 ) then
	write(*,*) '** ERROR: JD file open failed.  :(((((('
	GOTO 571
      end if

* times
      do i = 1, nt
* spectrum file name
	write( number, '(I4.4)' ) i
	call word1( number, l1, l2 )
	file = prefix(:len1(prefix)) // '_' // number(l1:l2) // '.dat'
	write(*,*) i, file(:len1(file)), time( i )

* write spectrum data (no narrow lines) to file
	k = 1 + (i-1) * nwbin
	call textlabel_wave( label, zshift )
	hlines( 1 ) = 'PrepSpec tweaked spectrum (-NLR) ' // file(:len1(file))
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	call textlabel_flux( label, fluxunit, iflxdex )
	hlines( 3 ) = ' Col 2 : ' // label(:len1(label))
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	hlines( 5 ) = ' Col 4 : Continuum'
	hlines( 6 ) = ' Col 5 : Absorption'
	nh = 6
	call dumplc5h( file, nh, hlines, 5, nwbin,
     &		wave8, buf1( k ), buf2( k ), buf4( k ), buf5( k ) )

* write to hjd file
	write( iout, * ) file(:len1(file)), '  ', time( i )

* write spectrum data (with NLR and continuum) 
	j = index( file, '.dat' )
	file = file(:j-1) // '_nlr.dat'
	hlines( 1 ) = 'PrepSpec tweaked spectrum ' // file(:len1(file))

	call dumplc5h( file, nh, hlines, 5, nwbin,
     &		wave8, buf3( k ), buf2( k ), buf4( k ), buf5( k ) )

* write to hjd file
	write( iout1, * ) file(:len1(file)), '  ', time( i )

* next time
      end do

* close hjd file
	close( unit = iout )
	write(*,*) 'Closed JD File ', hjdfile(:len1(hjdfile))
	close( unit = iout1 )
	write(*,*) 'Closed JD File ', hjdfile1(:len1(hjdfile1))

	write(*,*) 'Output Nt', nt, ' Nw', nwbin
      end if
      end if

	goto 571


*----------------------------------------------------------------------------
  573	write(*,*) 'Output AVG, NLR, RMS, RMSBLR spectra.'

* KDH : USE dumplc*h FOR COLUMN HEADERS

	call word1( prefix, l1, l2 )
* average spectrum (and its continuum)
	file = 'avg_w.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'AVG(lam) => ', file(:len1(file))

	hlines( 1 ) = 'PrepSpec AVG spectrum ' // file(:len1(file))
	call textlabel_wave( label, zshift )
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	call textlabel_flux( label, fluxunit, iflxdex )
	hlines( 3 ) = ' Col 2 : ' // label(:len1(label))
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	hlines( 5 ) = ' Col 4 : Continuum'
	hlines( 6 ) = ' Col 5 : NLR'
	hlines( 7 ) = ' Col 6 : BLR'
	hlines( 8 ) = ' Col 7 : Fe2'

c	nh = 5
	nh = 8
      if( nh .eq. 5 ) then
	call dumplc4h( file, nh, hlines, 4, nw, w8_w, avg_w, sigavg_w, avgcont_w )
      else if( nh .eq. 6 ) then
	call dumplc5h( file, nh, hlines, 5, nw, w8_w, avg_w, sigavg_w,
     &		avgcont_w, elr_w )
      else if( nh .eq. 7 ) then
	call dumplc6h( file, nh, hlines, 6, nw, w8_w, avg_w, sigavg_w,
     &		avgcont_w, elr_w, avgblr_w )
      else if( nh .eq. 8 ) then
	call dumplc7h( file, nh, hlines, 7, nw, w8_w, avg_w, sigavg_w,
     &		avgcont_w, elr_w, avgblr_w, avgfe2_w )
      end if

* nlr spectrum
	file = 'nlr_w.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'NLR(lam) => ', file(:len1(file))

	hlines( 1 ) = 'PrepSpec NLR spectrum ' // file(:len1(file))
	call textlabel_wave( label, zshift )
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	call textlabel_flux( label, fluxunit, iflxdex )
	hlines( 3 ) = ' Col 2 : ' // label(:len1(label))
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	nh = 4

	call dumplc3h( file, nh, hlines, 3, nw, w8_w, elr_w, signlr_w )

* rms spectrum
	file = 'rms_w.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'RMS(lam) => ', file(:len1(file))

	hlines( 1 ) = 'PrepSpec RMS spectrum ' // file(:len1(file))
	call textlabel_wave( label, zshift )
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	call textlabel_flux( label, fluxunit, iflxdex )
	hlines( 3 ) = ' Col 2 : ' // label(:len1(label))
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	hlines( 5 ) = ' Col 4 : Continuum'
	hlines( 6 ) = ' Col 5 : Model (Continuum+BLR)'

c	nh = 4
	nh = 6

c	call dumplc4h( file, nh, hlines, 4, nw, w8_w,
c     &		rms_w, sigrms_w, rmscont_w )

	call dumplc5h( file, nh, hlines, 5, nw, w8_w,
     &		rms_w, sigrms_w, rmscont_w, rmsf_w )

* rms blr spectrum
	file = 'rmsblr_w.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'RMS(lam) => ', file(:len1(file))

	hlines( 1 ) = 'PrepSpec RMS BLR spectrum ' // file(:len1(file))
	call textlabel_wave( label, zshift )
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	call textlabel_flux( label, fluxunit, iflxdex )
	hlines( 3 ) = ' Col 2 : ' // label(:len1(label))
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	nh = 4

	call dumplc3h( file, nh, hlines, 3, nw, w8_w, rmsb_w, sigrmsb_w )

	goto 571

*----------------------------------------------------------------------------
* output continuum lightcurve

  574	wmn = min( w_w(1), w_w(nw) )
	wmx = max( w_w(1), w_w(nw) )
	call xwcalc( nw, w_w, xw_w )

	write(*,*) 'Continuum wavelength in (', wmn, wmx, ' )'
	write(*,*) 'or the corresponding x in range (-1,1).'
	call inqr( 'Continuum wavelength:', 0., w )

* convert (-1,1) to wavelength
	x = w
      if( x .ge. -1. .and. x .le. 1. ) then
	p = ( x + 1. ) / 2.
	w = exp( alog( wmn ) * (1.-p) + p * alog( wmx ) )
	write(*,*) 'x', x, ' ->', w
      end if

* skip if out of range
c	w = max( wmn, min( wmx, w ) )
	dw = 1.
      if( w .lt. wmn - dw .or. w .gt. wmx + dw ) then
	write(*,*) '** WARNING: Wavelength', w, ' out of range', wmn, wmx
	goto 571
      end if

* round to nearest 10A
	idiv = 10
	w = idiv * nint( w / idiv )

* report
	call lookup( nw, w_w, w, i1, i2, p )
	x = xw_w( i1 ) * ( 1.-p ) + p * xw_w( i2 )
	cbar = avgcont_w( i1 ) * (1.-p) + p * avgcont_w( i2 )
	write(*,*) 'Wavelength', w, ' X(-1...+1) ', x
	write(*,*) 'Mean continuum', cbar

	write(*,*) 'Continuum lightcurve:'

* use covariance matrix for continuum error brs
      if( npar .gt. 0 .and. npcont .gt. 0 ) then
      do it = 1, nt

      do k = 1, npcont
	cont_p( k ) = cont_tp( it, k )
      end do
	c = poly4( npcont, cont_p, x )

	i = 1 + npar * ( it - 1 )
	j = 1 + npar * npar * ( it - 1 )  
	sigc = sigpoly( x, npar, npcont, ipcont, sig_pt(i), c_ppt(j) )
	plot1( it ) = c + cbar
	plot2( it ) = sigc
      end do

* monte-carlo evaluation of continuum error bar
* KDH : OBSOLETE. UNDER-ESTIMATES THE ERROR BARS
      else
      do it = 1, nt
	n = 10000
      do i = 1, n
      do k = 1, npcont
	c = cont_tp( it, k )
	s = sigcont_tp( it, k )
	cont_p( k ) = rang( c, s, iseed )
      end do
	c = poly4( npcont, cont_p, x )

	xplot( i ) = c + cbar
      end do
	call avgrms( n, xplot, plot1(it), plot2(it) )
	write(*,*) it, time(it), plot1(it), plot2(it)
      end do
      end if

* stats
	call   mnmx( nt, plot1, cmn,  cmx )
	call avgrms( nt, plot1, cavg, crms )
	call medmad( nt, plot1, cmed, cmad )
* report
	write(*,*) 'Continuum Lightcurve: Nt', nt
	write(*,*) ' min', cmn,  ' max', cmx
	write(*,*) ' avg', cavg, ' rms', crms
	write(*,*) ' med', cmed, ' mad', cmad

* check and fix negative continuum
      if( cmn .le. 0. ) THEN 
	write(*,*) '** WARNING, MIN FLUX', cmn, ' NOT POSITIVE :((' 
	add = 0.1 * abs( cbar - cmn )
	write(*,*) '** add ', add, ' to keep contonuum positive'
      do i=1,nt
	plot1( i ) = plot1( i ) + add
      end do
      end if

* scale FLAM to output flux units
	f = 1.
      if( outfluxunit .eq. 'FLAM' ) then
      if( ioutdex .ne. iflxdex ) then
	f = 10. ** ( inflxdex - ioutdex )	
	write(*,*) 'In', inflxdex, ' Out', ioutdex, ' dex'
	write(*,*) 'Scale by factor', f
      do i = 1, nt
	plot1( i ) = plot1( i ) * f
	plot2( i ) = plot2( i ) * f
      end do
      end if
      end if


* output stats
	call mnmx( nt, plot1, cmn, cmx )
	call avgrms( nt, plot1, cavg, crms )
	call medmad( nt, plot1, cmed, cmad )
	write(*,*) 'Output Continuum Lightcurve'
	write(*,*) ' min', cmn, ' max', cmx
	write(*,*) ' avg', cavg, ' rms', crms
	write(*,*) ' med', cmed, ' mad', cmad

	call mnmx( nt, plot2, emn, emx )
	call avgrms( nt, plot2, eavg, erms )
	call medmad( nt, plot2, emed, emad )
	write(*,*) 'Output Continuum Error Bars'
	write(*,*) ' min', emn, ' max', emx
	write(*,*) ' avg', eavg, ' rms', erms
	write(*,*) ' med', emed, ' mad', emad

* output filename
	call word1( prefix, l1, l2 )
	file = prefix(l1:l2) // '_c'
	call append_i( file, nint( w ) )
	call append( file, '.dat' )
	call nospace( file )
	write(*,*) 'Continum Lightcurve => ', file(:len1(file))
* header


	hlines( 1 ) = 'PrepSpec Continuum Lightcurve ' // file(:len1(file))
	call label_time( label, timebase, jdsub )
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))

* fluxes were not rescaled above
      if( f .eq. 1. ) then
	call textlabel_flux( label, fluxunit, iflxdex )
* fluxes were rescaled
      else
	call textlabel_flux( label, fluxunit, 0 )
      end if
	hlines( 3 ) = ' Col 2 : ' // label(:len1(label))
	hlines( 4 ) = ' Col 3 : error bar on Col 2'
	nh = 4

* dump
* KDH : SHOULD THIS BE DUMPLC3H ?  OK SINCE JSUB IS SUBTRACTED?
	call dump1d3h( file, nh, hlines, 3, nt, time, plot1, plot2 )
	write(*,*)

* continuum lightcurve stats
	l = index( file, '.dat' ) - 1
	if( l .le. 0 ) l = len1( file )
	file = file(:l) // '_stats.dat'
	title = file
	call dumpstats( file, nt, plot1, plot2, title )

	goto 571

*----------------------------------------------------------------------------
  575	write(*,*) 'Output line profiles and lightcurves'

	call word1( prefix, l1, l2 )
* BLR
	call mnmx( nt, blr_t, bot, top )
      if( bot .ne. top ) then
* lightcurve
	file = 'blr_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'BLR(t) => ', file(:len1(file))

* restore BLR lightcurve mean and rms
      if( fluxunit .eq. 'FLAM' ) then
	avg = sumflam( nw, w8_w, avgblr_w, 1, nw )
	rms = sumflam( nw, w8_w,    blr_w, 1, nw )
      else if( fluxunit .eq. 'MJY' ) then
	avg = sumfmjy( nw, w8_w, avgblr_w, 1, nw )
	rms = sumfmjy( nw, w8_w,    blr_w, 1, nw )
      end if
      if( rms .le. 0. ) then
	avg = 0.
	rms = 1.
      end if
	write(*,*) 'BLR flux avg', avg, ' rms', rms
      do i = 1, nt
	dat_t( i ) = rms * blr_t( i ) + avg
	sig_t( i ) = rms * sigblr_t( i )
      end do

* header
	hlines( 1 ) = 'PrepSpec BLR Lightcurve ' // file(:len1(file))
	call label_time( label, timebase, jdsub )	
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	hlines( 3 ) = ' Col 2 : Flux (erg/cm2/s)'
	hlines( 4 ) = ' Col 3 : Error bar on Col 2'
	hlines( 5 ) = ' Col 4 : Lightcurve (mean 0 rms 1)'
	hlines( 6 ) = ' Col 5 : Error bar on Col 4'
	nh = 6
* dump
	call dump1d5h( file, nh, hlines, 5, nt,
     &		time, dat_t, sig_t, blr_t, sigblr_t )
	write(*,*)

* BLR lightcurve stats
	l = index( file, '.dat' ) - 1
	if( l .le. 0 ) l = len1( file )
	file = file(:l) // '_stats.dat'
	title = file
	call dumpstats( file, nt, dat_t, sig_t, title )

* BLR spectrum
	file = 'blr_w.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'BLR(lam) => ', file(:len1(file))

* KDH : TWEAK ERROR BARS TO ALLOW FOR SMOOTHING
	div = 1.
	if( idived .eq. 0 ) div = sqrt( max( 1., blurpixblr ) )
	if( div .ne. 1. ) write(*,*) 'Error bar divisor', div
      do i = 1, nw
	dat_w( i ) = blr_w( i )
	sig_w( i ) = sigblr_w( i ) / div
      end do
* header
* KDH : NEED UNITS FOR COL 2
	call textlabel_wave( label, zshift )
	hlines( 1 ) = 'PrepSpec BLR Spectrum ' // file(:len1(file))
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	hlines( 3 ) = ' Col 2 : dat_w'
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	nh = 4
* dump
	call dumplc3h( file, nh, hlines, 3, nw, w8_w, dat_w, sig_w )
	write(*,*)
      end if

* variable line components
	write(*,*)
	write(*,*) 'Variable line components:', ncomp
      do ic = 1, ncomp
	n = npix_c( ic )
	l = line_lc( 1, ic )
	text = text_l( l )
	lt = len1( text )
	call mnmx( nt, dat_tl( 1, l ) , bot, top )
	write(*,*) text(:lt), ' npix', n, ' mn,mx', bot, top
      if( n .gt. 0 .and. bot .ne. top ) then
* line lightcurve
	file = file_c( ic )
	if( file .eq. ' ' ) file = text(:lt)
	call nospace( file )
	file = file(:len1(file)) // '_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) text(:lt), ' Lightcurve => ', file(:len1(file))
* restore mean and rms line flux
* KDH : SHOULD WE COMPUTE THIS HERE TO BE SURE IT IS AOK ?
	avg =  flx_l( l )
	rms = vflx_l( l )
      if( rms .le. 0. ) then
	write(*,*) '** WARNING: AVG', avg, ' RMS', rms, ' NOT POSITIVE. :(.'
	avg = 0.
	rms = 1.
      end if
	write(*,*) 'Line flux avg', avg, ' rms', rms
      do i = 1, nt
	dat_t( i ) = rms * dat_tl( i, l ) + avg
	sig_t( i ) = rms * sig_tl( i, l )
      end do
* header
	call label_time( label, timebase, jdsub )	
	hlines( 1 ) = 'PrepSpec Line Lightcurve ' // file(:len1(file))
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	hlines( 3 ) = ' Col 2 : Flux (erg/cm2/s)'
	hlines( 4 ) = ' Col 3 : Error bar on Col 2'
	hlines( 5 ) = ' Col 4 : Lightcurve (mean 0 rms 1)'
	hlines( 6 ) = ' Col 5 : Error bar on Col 4'
	nh = 6
* dump
	call dump1d5h( file, nh, hlines, 5, nt,
     &		time, dat_t, sig_t, dat_tl( 1, l ), sig_tl( 1, l ) )
	write(*,*)

* dump lightcurve stats
	lf = index( file, '.dat' ) - 1
	if( lf .le. 0 ) lf = len1( file )
	file = file(:lf) // '_stats.dat'
	title = file
	call dumpstats( file, nt, dat_t, sig_t, title )

* spectrum
	file = file_c( ic )
	if( file .eq. ' ' ) file = text(:lt)
	call nospace( file )
	file = file(:len1(file)) // '_w.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) text(:lt), ' Spectrum => ', file(:len1(file))

* KDH : TWEAK ERROR BARS TO ALLOW FOR SMOOTHING
	div = 1.
	if( idived .eq. 0 ) div = sqrt( max( 1., blurpix_l( l ) ) )
	if( div .ne. 1. ) write(*,*) 'Error bar divisor', div
      do i = 1, nw
	dat_w( i ) = dat_wl( i, l )
	sig_w( i ) = sig_wl( i, l ) / div
      end do
* header
	call textlabel_wave( label, zshift )
	hlines( 1 ) = 'PrepSpec RMS Line Profile ' // file(:len1(file))
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	call textlabel_flux( label, fluxunit, iflxdex )
	hlines( 3 ) = ' Col 2 : ' // label(:len1(label))
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	nh = 4
* dump
	call dumplc3h( file, nh, hlines, 3, nw, w8_w, dat_w, sig_w )
	write(*,*)

      end if
* next component
      end do
	goto 571

*----------------------------------------------------------------------------
  576	write(*,*) 'Output Chi/Bias SPECTRA and LIGHTCURVES'
	call word1( prefix, l1, l2 )

* chi-bias_w
	file = 'chi-bias_w.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'Chi(lam) Bias(lam) => ', file(:len1(file))
* header
	call textlabel_wave( label, zshift )
	hlines( 1 ) = 'PrepSpec Chi-Bias Spectra ' // file(:len1(file))
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	hlines( 3 ) = ' Col 2 : Chi = sqrt( < (data-model)^2/sigma^2 > )'
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	hlines( 5 ) = ' Col 4 : Bias = < (data-model)/sigma >'
	hlines( 6 ) = ' Col 5 : 1-sigma error bar on Col 4'
	nh = 6
* dump
	call dumplc5h( file, nh, hlines, 5, nw, w8_w,
     &		chi_w, sigchi_w, bias_w, sigbias_w )
	write(*,*)

* chi-bias_t
	file = 'chi-bias_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'Chi(t) Bias(t) => ', file(:len1(file))
* header
	call label_time( label, timebase, jdsub )	
	hlines( 1 ) = 'PrepSpec Chi-Bias Lightcurve ' // file(:len1(file))
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	hlines( 3 ) = ' Col 2 : Chi'
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Chi'
	hlines( 5 ) = ' Col 4 : Bias'
	hlines( 6 ) = ' Col 5 : 1-sigma error bar on Bias'
	nh = 6
* dump
	call dump1d5h( file, nh, hlines, 5, nt, time,
     &		chi_t, sigchi_t, bias_t, sigbias_t )
	write(*,*)

* stats
	kct = 1
	kcw = 2
	kbt = 3
	kbw = 4
	nk = 4
      do k = 1, nk
* chi_t
      if( k .eq. kct ) then
	file = 'chi_t_stats.dat'
	call peqp( nt, plot1, chi_t )
	call peqp( nt, plot2, sigchi_t )
* chi_w
      else if( k .eq. kcw ) then
	file = 'chi_w_stats.dat'
	call peqp( nw, plot1, chi_w )
	call peqp( nw, plot2, sigchi_w )
* bias_t
      else if( k .eq. kbt ) then
	file = 'bias_t_stats.dat'
	call peqp( nt, plot1, bias_t )
	call peqp( nt, plot2, sigbias_t )
* bias_w
      else if( k .eq. kbw ) then
	file = 'bias_w_stats.dat'
	call peqp( nw, plot1, bias_w )
	call peqp( nw, plot2, sigbias_w )
      end if
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	title = file
	call dumpstats( file, nt, plot1, plot2, title )
      end do

	goto 571
*----------------------------------------------------------------------------
  577	write(*,*) 'Output Flux Shift Blur calibrations'
	write(*,*) npscale, npshift, npblur
	call word1( prefix, l1, l2 )

	kp0 = 1
	kp1 = 2
	kp2 = 3
	kx0 = 4
	kx1 = 5
	ks0 = 6
	ks1 = 7
	nk = max( kp0, kp1, kp2 )
	nk = max(  nk, kx0, kx1 )
	nk = max(  nk, ks0, ks1 )
      do k = 1, nk
	file = ' '
	hline = ' '
* p0
      if( k .eq. kp0 ) then
	file = 'p0_t.dat'
	hline = ' p_0(t) where ln(p(t)) = Sum_k p_k(t) X(lam)^k'
	call peqp( nt, plot1, p0_t )
	call peqp( nt, plot2, sigp0_t )
* p1
      else if( k .eq. kp1 ) then
	file = 'p1_t.dat'
	hline = ' p_1(t) where ln(p(t)) = Sum_k p_k(t) X(lam)^k'
	call peqp( nt, plot1, p1_t )
	call peqp( nt, plot2, sigp1_t )
* p2
      else if( k .eq. kp2 ) then
	file = 'p2_t.dat'
	hline = ' p_2(t) where ln(p(t)) = Sum_k p_k(t) X(lam)^k'
	call peqp( nt, plot1, p2_t )
	call peqp( nt, plot2, sigp2_t )
* x0
      else if( k .eq. kx0 ) then
	hline = ' x_0(t) where x(t) = Sum_k x_k(t) X(lam)^k'
	file = 'x0_t.dat'
	call peqp( nt, plot1, x0_t )
	call peqp( nt, plot2, sigx0_t )
* x1
      else if( k .eq. kx1 ) then
	file = 'x1_t.dat'
	hline = ' x_1(t) where x(t) = Sum_k x_k(t) X(lam)^k'
	call peqp( nt, plot1, x1_t )
	call peqp( nt, plot2, sigx1_t )
* s0
      else if( k .eq. ks0 ) then
	file = 's0_t.dat'
	hline = ' s_0(t) where s(t) = Sum_k s_k(t) X(lam)^k'
	call peqp( nt, plot1, s0_t )
	call peqp( nt, plot2, sigs0_t )
* s1
      else if( k .eq. ks1 ) then
	file = 's1_t.dat'
	hline = ' s_1(t) where s(t) = Sum_k s_k(t) X(lam)^k'
	call peqp( nt, plot1, s1_t )
	call peqp( nt, plot2, sigs1_t )
      end if

* skip if no match
      if( file .ne. ' ' ) then
* skip if no range or no positive error bar
	call mnmx( nt, plot1, dmn, dmx )
	call mnmx( nt, plot2, smn, smx )
      if( dmn .ne. dmx .or. smx .gt. 0. ) then
* lightcurve
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))

* report
	write(*,*)
	write(*,*) '----------------------------------------'
	l = index( file, '_t.dat' )
	write(*,*) file(l-2:l-1) // '(t) => ', file(:len1(file))
	write(*,*) ' dat mn,mx', dmn, dmx
	write(*,*) ' sig mn,mx', smn, smx
* header
	call label_time( label, timebase, jdsub )	
	hlines( 1 ) = 'PrepSpec Calibration Tweak ' // file(:len1(file))
	hlines( 2 ) = ' Col 1 : ' // label(:len1(label))
	hlines( 3 ) = ' Col 2 : ' // hline( : len1( hline ) )
	hlines( 4 ) = ' Col 3 : 1-sigma error bar on Col 2'
	nh = 4
* dump
	call dump1d3h( file, nh, hlines, 3, nt, time, plot1, plot2 )
	write(*,*)
* stats
	l = index( file, '.dat' )
	file = file(:l-1) // '_stats.dat'
	title = file
	call dumpstats( file, nt, plot1, plot2, title )
      end if
      end if
* next calibration k
      end do

* KDH : OBSOLETE CODE BELOW - DELETE AFTER ABOVE TESTED
      IF( .FALSE. ) THEN
	call mnmx( nt, p0_t, bot, top )
      if( bot .ne. top ) then
	file = 'p0_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'p0(t) => ', file(:len1(file))
	call dump1d3( file, 3, nt, time, p0_t, sigp0_t )
	write(*,*)

	file = 'p0_t_stats.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	title = file

      if( .false. ) then
c	call dumpstats( file, nt, p0_t, sigp0_t, title )
      else
      do i = 1, nt
	p = exp( p0_t( i ) )
	sig = sigp0_t( i )
	plot1( i ) = p
	plot2( i ) = p * sig
      end do
	write(*,*) ' lnp(t) -> p(t)'
      end if
	call dumpstats( file, nt, plot1, plot2, title )

      end if

	call mnmx( nt, p1_t, bot, top )
      if( bot .ne. top ) then
	file = 'p1_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'p1(t) => ', file(:len1(file))
	call dump1d3( file, 3, nt, time, p1_t, sigp1_t )
	write(*,*)

	file = 'p1_t_stats.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	title = file
	call dumpstats( file, nt, p1_t, sigp1_t, title )

      end if

	call mnmx( nt, p2_t, bot, top )
      if( bot .ne. top ) then
	file = 'p2_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'p2(t) => ', file(:len1(file))
	call dump1d3( file, 3, nt, time, p2_t, sigp2_t )
	write(*,*)

	file = 'p2_t_stats.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	title = file
	call dumpstats( file, nt, p2_t, sigp2_t, title )

      end if

	call mnmx( nt, x0_t, bot, top )
      if( bot .ne. top ) then
	file = 'x0_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'x0(t) => ', file(:len1(file))
	call dump1d3( file, 3, nt, time, x0_t, sigx0_t )
	write(*,*)

	file = 'x0_t_stats.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	title = file
	call dumpstats( file, nt, x0_t, sigx0_t, title )

      end if

	call mnmx( nt, x1_t, bot, top )
      if( bot .ne. top ) then
	file = 'x1_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 'x1(t) => ', file(:len1(file))
	call dump1d3( file, 3, nt, time, x1_t, sigx1_t )
	write(*,*)


	file = 'x1_t_stats.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	title = file
	call dumpstats( file, nt, x1_t, sigx1_t, title )

      end if

	call mnmx( nt, s0_t, bot, top )
      if( bot .ne. top ) then
	file = 's0_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	call dump1d3( file, 3, nt, time, s0_t, sigs0_t )
	write(*,*)

	file = 's0_t_stats.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	title = file
	call dumpstats( file, nt, s0_t, sigs0_t, title )


      end if

	call mnmx( nt, s1_t, bot, top )
      if( bot .ne. top ) then
	file = 's1_t.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	write(*,*) 's1(t) => ', file(:len1(file))
	call dump1d3( file, 3, nt, time, s1_t, sigs1_t )
	write(*,*)

	file = 's1_t_stats.dat'
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
	title = file
	call dumpstats( file, nt, s1_t, sigs1_t, title )

      end if

      END IF
* KDH : END OF OBSOLETE CODE

	goto 571
*----------------------------------------------------------------------------
  578	write(*,*)
	write(*,*) 'Output line (flux,width,centroid) measures.'
	write(*,*) 'Wavelength range:', w_w( 1 ), w_w( nw )
	lam1 = nint( w_w( 1 ) )
	lam2 = nint( w_w( nw ) )

* sort lines by rest wavelength
      do i = 1, markline
	wav_l( i ) = rest_l( i )
      end do
	call quicksort( markline, wav_l, i_l )

* up to 3 loops ( nlr, blr, rmsblr )

	nloop = 3
	loopnlr = 1
	loopblr = 2
	looprmsblr = 3
	nwant = 0
      do loop = 1, nloop
	iout = -1
	nout = 0
	ipan = 0
* report
	write(*,*) '-------------------------------------'
      if( loop .eq. loopnlr ) then
	write(*,*) 'NLR stats:'
	nwant = narrow
	npan = npannlr
      else if( loop .eq. loopblr ) then
	write(*,*) 'AVG BLR stats:'
	nwant = nbroad
	npan = npanblr
      else if( loop .eq. looprmsblr ) then
	write(*,*) ' RMS BLR stats:'
	nwant = nbroad
	npan = npanrmsblr
      else if( loop .eq. loopavgblr ) then
	write(*,*) ' AVG BLR stats:'
	nwant = nbroad
	npan = npanavgblr
      end if

* error bars ?
	ierbs = 1

* lines ranked by wavelength
      do lrank = 1, markline
	l = i_l( lrank )
	line2plot = 0
      if( l .eq. line2plot .or. line2plot .le. 0 ) then
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	rest = rest_l( l )
	lam = nint( rest )
	w0 = rest
* active line of the right type
	expand = expand_l( l )
      if( nabc( l ) .eq. nwant ) then
      if( expand .gt. 0. ) then
      if( w_w( 1 ) .lt. rest .and. rest .lt. w_w( nw ) ) then

* KDH : SHOULD WE RE-COMPUTE THESE TO BE SURE THEY ARE CORRECT ?
* RMS BLR
      if( loop .eq. looprmsblr ) then
	flx = vflx_l( l )
	vavg = vvavg_l( l )
	vrms = vvrms_l( l )
	vmed = vvmed_l( l )
	vmad = vvmad_l( l )
	vtop = vvtop_l( l )
	vlo = vvlo_l( l )
	vhi = vvhi_l( l )
	vfwhm = vvfwhm_l( l )
	vhw10 = vvhw10_l( l )
* error bars
	sigflx = sigvflx_l( l )
	sigvavg = sigvvavg_l( l )
	sigvrms = sigvvrms_l( l )
	sigvmed = sigvvmed_l( l )
	sigvmad = sigvvmad_l( l )
	sigvtop = sigvvtop_l( l )
	sigvlo = sigvvlo_l( l )
	sigvhi = sigvvhi_l( l )
	sigvfwhm = sigvvfwhm_l( l )
	sigvhw10 = sigvvhw10_l( l )
      else
* NLR or AVG BLR
	flx = flx_l( l )
	vavg = vavg_l( l )
	vrms = vrms_l( l )
	vmed = vmed_l( l )
	vmad = vmad_l( l )
	vtop = vtop_l( l )
	vlo = vlo_l( l )
	vhi = vhi_l( l )
	vfwhm = vfwhm_l( l )
	vhw10 = vhw10_l( l )
* error bars
	sigflx = sigflx_l( l )
	sigvavg = sigvavg_l( l )
	sigvrms = sigvrms_l( l )
	sigvmed = sigvmed_l( l )
	sigvmad = sigvmad_l( l )
	sigvtop = sigvtop_l( l )
	sigvlo = sigvlo_l( l )
	sigvhi = sigvhi_l( l )
	sigvfwhm = sigvfwhm_l( l )
	sigvhw10 = sigvhw10_l( l )
      end if

* good lines
* KDH : MORE STRINGENT REQUIREMENT HERE ?
	vvrms = vvrms_l( l )
	vvmad = vvmad_l( l )
	vvfwhm = vvfwhm_l( l )
      if( loop .eq. looprmsblr .or. loop .eq. loopavgblr ) then
	test = max( vvrms, vvmad, vvfwhm )
      else
	test = max( vrms, vmad, vfwhm )
      end if
      if( test .gt. 0. ) then
	nout = nout + 1
c	ipan = ipan + 1
* output unit
      IF( iout .le. 0 ) then
	file = 'NONE'
	iout = 50 + loop
	write(*,*) 'nout', nout, ' iout', iout
* filename
	file = 'v.dat'
      if( loop .eq. loopnlr ) then
	file = 'vnlr.dat'
	write(*,*) 'NLR velocities => ', file(:len1(file))
      else if( loop .eq. loopblr ) then
	file = 'vblr.dat'
	write(*,*) 'BLR velocities => ', file(:len1(file))
      else if( loop .eq. looprmsblr ) then
	file = 'vvblr.dat'
	write(*,*) 'RMS BLR velocities => ', file(:len1(file))
      end if
	call word1( prefix, l1, l2 )
	if( l2 .gt. l1 ) file = prefix(l1:l2) // '_' // file(:len1(file))
* open file
	call openfile( iout, file(:len1(file)), 'formatted', 'unknown', ier )
      END IF

* column headings
      if( nout .eq. 1 ) then
      if( ierbs .eq. 0 ) then
	write( header, '(a1, a12, a10, 3a7, 3a7, 2a7)' )
     &	'#', 'rest(A)', 'erg/cm2/s'
     &		, 'fwhm', 'rms', 'mad'
     &		, 'top', 'avg', 'med'
     &		, 'winhw'
c     &		, 'hw10%'
      else
	write( header, '(a1, a12, 2a11, 3(a7,a7), 3(a7,a7), 2a7 )' )
     &	'#', 'rest(A)'
     &		, 'erg/cm2/s'
     &		, '+/-'
     &		, 'fwhm'
     &		, '+/-'
     &		, 'rms'
     &		, '+/-'
     &		, 'mad'
     &		, '+/-'
     &		, 'top'
     &		, '+/-'
     &		, 'avg'
     &		, '+/-'
     &		, 'med'
     &		, '+/-'
     &		, 'winhw'
c     &		, 'hw10%'
      end if

	lh = len1( header )
      if( iout .le. 0 ) then
	write( *, * ) header(:lh)
      else
	write( iout, '(3A,f8.5)' ) '# ', agn(:len1(agn)), ' z =', zshift
c	write( iout, '(A)' ) header(:lh)
      end if

      end if

* window halfwidth
	if( nwant .eq. nbroad ) vwin = vblr
	if( nwant .eq. narrow ) vwin = vnlr
	vwin = vwin * expand

* fit range
	n = iw2 - iw1 + 1
	lam1 = nint( w_w( iw1 ) )
	lam2 = nint( w_w( iw2 ) )
* RMS BLR
      if( loop .eq. looprmsblr ) then
	write(*,*) 'RMS BLR MCMC', mcmc
     &		, ' lam', lam1, lam2, ' pix', n

* KDH : TWEAK ERROR BARS TO ALLOW FOR SMOOTHING
* KDH : IS THIS DONE ALREADY ?
	div = 1.
      if( idived .eq. 0 ) then
	div = sqrt( max( 1., blurpix_l( l ) ) )
      end if
	if( div .ne. 1. ) write(*,*) 'Error bar divisor', div
      do i = iw1, iw2
	dat_w( i ) = dat_wl( i, l )
	sig_w( i ) = sig_wl( i, l ) / div
      end do
* NLR
      else if( loop .eq. loopnlr ) then
	if( gabby ) write(*,*) 'NLR MCMC', mcmc
     &		, ' lam', lam1, lam2, ' pix', n
      do i = iw1, iw2
	dat = elr_w( i )
	sig = sigavg_w( i )
c	if( dat .le. 0. ) sig = - abs( sig )
	dat_w( i ) = dat
	sig_w( i ) = sig
      end do
* AVG BLR
      else if( loop .eq. loopblr .or. loop .eq. loopavgblr ) then
	if( gabby ) write(*,*) 'BLR MCMC', mcmc
     &		, ' lam', lam1, lam2, ' pix', n
      do i = iw1, iw2
	dat_w( i ) = avgblr_w( i )
	sig_w( i ) = sigavgblr_w( i )
	plot4( i ) = elr_w( i )
	plot5( i ) = dat_w( i ) + plot4( i )
      end do
      end if

* fit spline to the line profile -
	thrhi = 5.
	thrlo = -5.
	ncycle = 10
	i = iw1
	n = iw2 - iw1 + 1
	blur = max( 3., n / 15. )
	nspline = max( 1, nint( n / blur ) )
	call splfita( n, w_w(i), dat_w(i), sig_w(i), fit_w(i),
     &		nspline, ncycle, thrhi, thrlo, ifail )


* mcmc iterations ?
	mcmc = 0
	if( ierbs .gt. 0 ) mcmc = 10000
* loop accordingly
* with and without mcmc iterations
	nkerb = 1
	if( mcmc .gt. 0 ) nkerb = 2
	kmcmc = 2
      do kerb = 1, nkerb
	i = iw1
	n = iw2 - iw1 + 1
* mcmc linewidth stats
	nmcmc = mcmc * ( kerb - 1 )
	call linestat_mcmc( n, w_w(i), dat_w(i), sig_w(i), mask_wl(i,l),
     &	 w0, nmcmc, iseed, flx, sigflx,
     &	 vavg, sigvavg, vrms, sigvrms,
     &	 vmed, sigvmed, vmad, sigvmad,
     &	 vtop, sigvtop, vlo, sigvlo, vhi, sigvhi,
     &	 vlo1, sigvlo1, vhi1, sigvhi1,
     &	 vlo2, sigvlo2, vhi2, sigvhi2,
     &	 vlo10, sigvlo10, vhi10, sigvhi10 )
c	if( gabby ) write(*,*) 'sigvtop:', sigvtop, ' sigvavg', sigvavg
* fwhm
	vfwhm = vhi - vlo
	sigvfwhm = sqrt( ( sigvhi )**2 + ( sigvlo )**2 )
	if( sigvhi .lt. 0. .or. sigvlo .lt. 0. ) sigvfwhm = - sigvfwhm

* KDH : DO WE NEED FWHM1 AND FWHM2 FOR OUTPUT
* fwhm1
	vfwhm1 = vhi1 - vlo1
	sigvfwhm1 = sqrt( ( sigvhi1 )**2 + ( sigvlo1 )**2 )
	if( sigvhi1 .lt. 0. .or. sigvlo1 .lt. 0. ) sigvfwhm1 = - sigvfwhm1
* fwhm2
	vfwhm2 = vhi2 - vlo2
	sigvfwhm2 = sqrt( ( sigvhi2 )**2 + ( sigvlo2 )**2 )
	if( sigvhi2 .lt. 0. .or. sigvlo2 .lt. 0. ) sigvfwhm2 = - sigvfwhm2

* h210%
	vhw10 = ( vhi10 - vlo10 ) / 2.
	sigvhw10 = sqrt( ( sigvhi10 )**2 + ( sigvlo10 )**2 ) / 2.
	if( sigvhi10 .lt. 0. .or. sigvlo10 .lt. 0. ) sigvhw10 = - sigvhw10

* fix integrated line flux
	call fixflx( w0, flx, fluxunit, inflxdex )
	call fixflx( w0, sigflx, fluxunit, inflxdex )

	if( sigflx .lt. 0. ) sigflx = -1.
	if( sigvfwhm  .lt. 0. ) sigvfwhm  = -1.
	if( sigvfwhm1 .lt. 0. ) sigvfwhm1 = -1.
	if( sigvfwhm2 .lt. 0. ) sigvfwhm2 = -1.

* integer km/s velocities
	kvwin = nint( vwin )
	kvfwhm = nint( vfwhm )
	kvfwhm1 = nint( vfwhm1 )
	kvfwhm2 = nint( vfwhm2 )
	kvhw10 = nint( vhw10 )
	kvrms = nint( vrms )
	kvmad = nint( vmad )
	kvtop = nint( vtop )
	kvavg = nint( vavg )
	kvmed = nint( vmed )
* error bars
	ksigvfwhm = nint( sigvfwhm )
	ksigvfwhm1 = nint( sigvfwhm1 )
	ksigvfwhm2 = nint( sigvfwhm2 )
	ksigvhw10 = nint( sigvhw10 )
	ksigvrms = nint( sigvrms )
	ksigvmad = nint( sigvmad )
	ksigvtop = nint( sigvtop )
	ksigvavg = nint( sigvavg )
	ksigvmed = nint( sigvmed )

* KDH : MAYBE PROBLEM IF INTEGERS ROUND DOWN TO 0
	ksigvmin = min( ksigvfwhm, ksigvrms, ksigvmad )
	ksigvmin = min( ksigvmin, ksigvtop, ksigvavg, ksigvmed )
	kvmax = max( kvfwhm, kvrms, kvmad, kvtop, kvavg, kvmed )
	kvmin = min( kvfwhm, kvrms, kvmad, kvtop, kvavg, kvmed )

* clip range to prevent overflow
	k2 = 99999
	k1 = - k2

c	write(*,*) 'sigvtop:', sigvtop, ksigvtop
c	write(*,*) 'sigvavg:', sigvavg, ksigvavg

* no error bars
      if( ierbs .eq. 0 ) then
	write( record, '( 1x, f12.3, 1pe10.3, 3i7, 3i7, 2i7)' )
     &	rest, flx 
     &	, min( k2, max( k1, kvfwhm ) )
     &	, min( k2, max( k1, kvrms ) )
     &	, min( k2, max( k1, kvmad ) )
     &	, min( k2, max( k1, kvtop ) )
     &	, min( k2, max( k1, kvavg ) )
     &	, min( k2, max( k1, kvmed ) )
     &	, min( k2, max( k1, kvwin ) )
c     &	, min( k2, max( k1, kvhw10 ) )
* with error bars
      else 
	yes = loop .ne. loopnlr .and. nmcmc .gt. 0
	yes = yes .and. ksigvmin .lt. 10

* warning
      if( yes ) then
      if( max( iabs( kvmax ), iabs( kvmin ) ) .ge. 10000 ) then
	write(*,*) '** WARNING: Large velocity and small error bar.'
	write(*,*) '** kvmax', kvmax, ' ksigvmin', ksigvmin
	write(*,*) '** POSSIBLE OUTPUT FORMAT OVERFLOW.'
      end if
      end if

* small error bars need 0.1 km/s precision
      if( loop .eq. loopnlr .or. yes ) then
	v2 = 9999.9
	v1 = -999.9
	write( record,
     &	'( 1x,f12.3, 1pe11.3,1pe11.2, 6(0pf7.1,f7.1), 2i7 )' )
     &	rest, flx, sigflx
     &	, min( v2, max( v1, vfwhm ) )
     &	, min( v2, max( v1, sigvfwhm ) )
     &	, min( v2, max( v1, vrms ) )
     &	, min( v2, max( v1, sigvrms ) )
     &	, min( v2, max( v1, vmad ) )
     &	, min( v2, max( v1, sigvmad ) )
     &	, min( v2, max( v1, vtop ) )
     &	, min( v2, max( v1, sigvtop ) )
     &	, min( v2, max( v1, vavg ) )
     &	, min( v2, max( v1, sigvavg ) )
     &	, min( v2, max( v1, vmed ) )
     &	, min( v2, max( v1, sigvmed ) )
     &	, min( k2, max( k1, kvwin ) )
c     &	, min( k2, max( k1, kvhw10 ) )
* BLR with error bars
      else 
	write( record,
     & '( 1x,f12.3, 1pe11.3,1pe11.2, 3(i7,i7), 3(i7,i7), 2i7 )' )
     &	rest, flx, sigflx
     &	, min( k2, max( k1, kvfwhm ) )
     &	, min( k2, max( k1, ksigvfwhm ) )
     &	, min( k2, max( k1, kvrms ) )
     &	, min( k2, max( k1, ksigvrms ) )
     &	, min( k2, max( k1, kvmad ) )
     &	, min( k2, max( k1, ksigvmad ) )
     &	, min( k2, max( k1, kvtop ) )
     &	, min( k2, max( k1, ksigvtop ) )
     &	, min( k2, max( k1, kvavg ) )
     &	, min( k2, max( k1, ksigvavg ) )
     &	, min( k2, max( k1, kvmed ) )
     &	, min( k2, max( k1, ksigvmed ) )
     &	, min( k2, max( k1, kvwin ) )
c     &	, min( k2, max( k1, kvhw10 ) )
      end if
      end if
* write (header and) record
      if( kerb .eq. 1 ) then
	write(*,*) header(:lh)
	if( iout .gt. 0 ) write( iout, '(A)' ) header(:lh)
      end if
	lr = len1( record )
	write(*,*) record(:lr)
	if( iout .gt. 0 ) write( iout, '(A)' ) record(:lr)

* next kerb
      end do
	write(*,*)
	if( iout .gt. 0 ) write( iout, '(A)' ) '#'

      end if
      end if
      end if
      end if

* next lrank
      end if
      end do

* close the output file
      if( iout .gt. 0 ) then
	close( iout )
	write(*,*) 'Close(', iout, ' ) ', file(:len1(file))
	iout = -1
      end if

* next loop
      end do

	goto 571


*----------------------------------------------------------------------------
  579	write(*,*) 'MCMC test on Gaussian Line Profile:'

	if( sigv .le. 0. ) sigv = 1000.
	if( photons .le. 0. ) photons = 10000.
	if( mcmc .le. 0 ) mcmc = 10000

	call inq2r( 'flux(photons) and sigv(km/s)', photons, sigv )
	if( sigv .le. 0. .or. photons .le. 0. ) goto 571

	call inqi( 'MCMC samples:', mcmc, mcmc )
	if( mcmc .le. 0 ) goto 571

* fake data
	p = 0.25 + 0.5 * ran( iseed )
	wlog = alog( w_w( 1 ) ) * (1.-p) + p * alog( w_w( nw ) )
	w0 = exp( wlog )
	div = sqrt( 2. * pi * sigv )
	big = 6.
      do k = 1, 2
	sum = 0.d0
	n = 0
      do i = 1, nw
	ip = min( i + 1, nw )
	im = max( i - 1, 1 )
	dw = ( w_w( ip ) - w_w( im ) ) / max( 1, ip - im )
	w = w_w( i )
	v = ckms * alog( w / w0 )
	x = v / sigv
	mask = abs( x ) .lt. big
      if( i .eq. 1 ) then
	xlo = x
	xhi = x
      else
	xlo = min( xlo, x )
	xhi = max( xhi, x )
      end if
      if( mask ) then
	g = exp( - 0.5 * x * x ) / div
	dat = photons * g / dw
	sig = sqrt( dat / dw )
	sum = sum + g
	n = n + 1
      else
	dat = 0.
	sig = -1.
      end if
	mask_w( i ) = mask
	dat_w( i ) = dat
	sig_w( i ) = sig
      end do
	write(*,*) 'Pixels', n, ' Sum', sum, ' x', xlo, xhi
      do i = 1, nw
      if( mask_w( i ) ) then
	dat_w( i ) = dat_w( i ) / sum
	sig_w( i ) = sig_w( i ) / sum
      end if
      end do
	div = div * sum
* next k
      end do

* mcmc stats
	call linestat_mcmc( nw, w_w, dat_w, sig_w, mask_w,
     &	 w0, mcmc, iseed, flx, sigflx,
     &	 vavg, sigvavg, vrms, sigvrms,
     &	 vmed, sigvmed, vmad, sigvmad,
     &	 vtop, sigvtop, vlo, sigvlo, vhi, sigvhi,
     &	 vlo1, sigvlo1, vhi1, sigvhi1,
     &	 vlo2, sigvlo2, vhi2, sigvhi2,
     &	 vlo10, sigvlo10, vhi10, sigvhi10 )
	vfwhm = vhi - vlo
	sigvfwhm = sqrt( sigvhi * sigvhi + sigvlo * sigvlo )

* true stats
	fwhm = sigv * sqrt( 8. * alog( 2. ) )
	gmad = sigv * sqrt( 2. / pi )	

* report

	write(*,*) 'Rest', w0, ' MCMC samples', mcmc

	nphot = nint( photons )
	kflx = nint( sqrt( photons ) )
	write(*,*) ' flux:', nphot, ' +/-', kflx, ' =>', nint(flx), ' +/-', nint(sigflx)	

	kavg = nint( sigv / sqrt( photons ) )
	write(*,*) '  avg:', 0, ' +/-', kavg, ' =>', nint(vavg), ' +/-', nint(sigvavg)

	kmed = nint( sigv * sqrt( pi / 2. / photons ) )
	write(*,*) '  med:', 0, ' +/-', kmed, ' =>', nint(vmed), ' +/-', nint(sigvmed)

	write(*,*) '  top:', 0, ' =>', nint(vtop), ' +/-', nint(sigvtop)

	krms = nint( sigv * sqrt( 1. / photons ) )
	write(*,*) '  rms:', nint( sigv ), ' +/-', krms, ' =>', nint(vrms), ' +/-', nint(sigvrms)

	kmad = nint( gmad * sqrt( 1. / photons ) )
	write(*,*) '  mad:', nint( gmad ), ' +/-', kmad, ' =>', nint(vmad), ' +/-', nint(sigvmad)

	kfwhm = nint( fwhm * sqrt( 1. / photons ) )
	write(*,*) ' fwhm:', nint( fwhm ), ' +/-', kfwhm, ' =>', nint(vfwhm), ' +/-', nint(sigvfwhm)

	goto 579


*----------------------------------------------------------------------------
* iteration plot

  580 if( nits .le. 0 ) then
	write(*,*) ' No iterations have been done.'
      else
	call mnmx( nits, chi2red_i, cmn, cmx )
	call mnmx( nits, bic_i, bmn, bmx )

* toggle plotting of v1-4 
	noscatter = 1
	if( gabby ) noscatter = 0

      do i = 1, nits
	j = 1 + mod( i-1, maxplot )
	plot1( j ) = i
	plot2( j ) = chi2_i( i )
	plot3( j ) = bic_i( i )
	plot6( j ) = dof_i( i )
	plot7( j ) = nfit_i( i )
* blr
	plot8( j ) = vblr_i( i )
	plot10( j ) = vbwant_i( i )
* nlr
	plot9( j ) = vnlr_i( i )
	plot11( j ) = vnwant_i( i )

* v1-4
      if( noscatter .eq. 0 ) then
* blr
	plot12( j ) = vb1_i( i )
	plot14( j ) = vb2_i( i )
	plot16( j ) = vn3_i( i )
	plot18( j ) = vn4_i( i )
* nlr
	plot13( j ) = vn1_i( i )
	plot15( j ) = vn2_i( i )
	plot17( j ) = vn3_i( i )
	plot19( j ) = vn4_i( i )

      end if
* fe2
	v = vfe2_i( i )
	sigv = sigvfe2_i( i )
	s = sclfe2_i( i )
      if( s .le. 0. ) then
	v = 1.
	sigv = 0.
      end if
	plot20( j ) = max( 1., v )
	plot21( j ) = max( 1., v + sigv )
	plot22( j ) = max( 1., v - sigv )
* next iteration i
      end do
	np = min( maxplot, nits )
	call mnmx( np, plot2, cmn, cmx )
	write(*,*) 'chi2', cmn, cmx

	floor = 1e-30
	f = - 0.5 * alog10( exp(1.) )
* logs
      do i=1,np
	c = plot2( i )
	b = plot3( i )
	plot2( i ) = alog10( c )
	plot3( i ) = alog10( b )
* log( prel )
	plot4( i ) = f * ( c - cmn )
	plot5( i ) = f * ( b - bmn )
	plot6( i ) = alog10( plot6( i ) )
	plot7( i ) = alog10( plot7( i ) )
	plot8( i ) = alog10( plot8( i ) )
	plot9( i ) = alog10( plot9( i ) )
	plot10( i ) = alog10( plot10( i ) )
	plot11( i ) = alog10( plot11( i ) )
      if( noscatter .eq. 0 ) then
	plot12( i ) = alog10( plot12( i ) )
	plot13( i ) = alog10( plot13( i ) )
	plot14( i ) = alog10( plot14( i ) )
	plot15( i ) = alog10( plot15( i ) )
	plot16( i ) = alog10( plot16( i ) )
	plot17( i ) = alog10( plot17( i ) )
	plot18( i ) = alog10( plot18( i ) )
	plot19( i ) = alog10( plot19( i ) )
      end if
* fe2
* KDH - PROTECT AGAINST NEGATIVE VALUES
	plot20( i ) = alog10( plot20( i ) )
	plot21( i ) = alog10( plot21( i ) )
	plot22( i ) = alog10( plot22( i ) )
      end do

* format
  581	npan = 3
	npanx = 1
	npany = 3
	ipanbic = 1
	ipanprel = 2
	ipanv = 3


* open
	call pgstart( npanx, npany, new )
	lwide = lwidedef
	call pgslw( lwide )
	csize = 1.5
	csize = 1.8
c	csize = 2.
	csize = csizedef * 1.8 / 1.5
	call pgsch( csize )
* white background
	call pgbgw

* panels
      do ipan = 1, npan

	logx = 0
	logy = 1

* window
	call mnmx( np, plot1, xmn, xmx )
	xmn = xmn - 0.5
	xmx = xmx + 0.5
* chi2, bic
      if( ipan .eq. ipanbic ) then
	call mnmx( np, plot2, cmn, cmx )
	call mnmx( np, plot3, bmn, bmx )
	call mnmx( np, plot6, dmn, dmx )
	ymn = min( cmn, bmn, dmn )
	ymx = max( cmx, bmx, dmx )
* prel
      else if( ipan .eq. ipanprel ) then
	ymx = 0.
	ymn = -4.
* vblr, vnlr
      else if( ipan .eq. ipanv ) then

	call mnmx( np, plot6,  dmn,  dmx )
	call mnmx( np, plot7,  fmn,  fmx )
	call mnmx( np, plot8,  vbmn,  vbmx )
	call mnmx( np, plot9,  vnmn,  vnmx )
	call mnmx( np, plot10, vbwmn, vbwmx )
	call mnmx( np, plot11, vnwmn, vnwmx )

* fe2
* KDH : SHULD PROTECT AGAINST NEGATIVE VALUES
	call mnmx( np, plot20, vfe2mn, vfe2mx )
	call medmad( np, plot20, vfe2med, vfe2mad )
	call mnmx( np, plot21, vfe2himn, vfe2himx )
	call mnmx( np, plot22, vfe2lomn, vfe2lomx )

* care to avoid log(0)
	ymx = max( vbmx, vnmx )
	ymn = min( vbmn, vnmn )
c	ymx = max( ymx, vfe2mx )
	y = max( 1.5, vfe2med - vfe2mad, vfe2mn )
	ymn = min( ymn, y )
      if( noscatter .eq. 0 ) then
      do i = 1, 4
	if( i .eq. 1 ) v = vnwmn
	if( i .eq. 2 ) v = vnwmx
	if( i .eq. 3 ) v = vbwmn
	if( i .eq. 4 ) v = vbwmx
	k = nint( 10.** v )
      if( k .gt. 0 ) then
	ymx = max( ymx, v )
	ymn = min( ymn, v )
      end if
      end do
      end if

	write(*,*) ' DoF', nint( 10.**dmn ), nint( 10.**dmx )
	write(*,*) 'Nfit', nint( 10.**fmn ), nint( 10.**fmx )
	write(*,*) ' BLR', nint( 10.**vbmn ), nint( 10.**vbmx )
	write(*,*) 'want', nint( 10.**vbwmn ), nint( 10.**vbwmx )
	write(*,*) ' NLR', nint( 10.**vnmn ), nint( 10.**vnmx )
	write(*,*) 'want', nint( 10.**vnwmn ), nint( 10.**vnwmx )


	write(*,*) ' Fe2', nint( 10.**vfe2mn ), nint( 10.**vfe2mx )
	write(*,*) '  + ', nint( 10.**vfe2himn ), nint( 10.**vfe2himx )
	write(*,*) '  - ', nint( 10.**vfe2lomn ), nint( 10.**vfe2lomx )

      end if

* expand to next 0.5 dex
      if( logy .ne. 0 ) then
	div = 2.
	ymx = nint( ymx * div + 1. ) / div
	ymn = nint( ymn * div - 1. ) / div
	write(*,*) 'x', xmn, xmx, ' y', ymn, ymx
      end if

* labels
      if( ipan .eq. ipanprel ) then
	ylabel = 'Relative Probability'
      else if( ipan .eq. ipanbic ) then
	ylabel = '\gx\u2\d,  BIC'
      else if( ipan .eq. ipanv ) then
	ylabel = 'Window Half-Width (km/s)'
      end if

* space at the top for the legend
      if( ipan .eq. ipanprel ) then
	ymn = min( ymn, plot4(np), plot5(np), ymx - 4. )
	div = 2.
	ymn = ymn - ( ymx - ymn ) * 0.05
	ymn = nint( ymn * div - 1. ) / div
* make space at top
	ymx = ymx + ( ymx - ymn ) / 5.
	ymx = nint( ymx * div + 1. ) / div
      end if

* wide log range
      if( logy .ne. 0 .and. abs( ymx - ymn ) .gt. 8 ) then
	logy = 0
	ylabel = 'log[ ' // ylabel(:len1(ylabel)) // ' ]'
      end if

* y range not 0
      if( ymx .eq. ymn ) then
	add = 0.1
	ymx = ymx + add
	ymn = ymn - add
      end if

	logxy = 10 * logx + 20 * logy
	call pgsci( kolor_axis )
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, logxy, ' )'
	call pgenv( xmn, xmx, ymn, ymx, 0, logxy )

* KDH : USE PGBOX FOR LABELS ON LOG(LAM) AXIS

* horizontals
      if( ipan .eq. ipanprel .or. ipan .eq. ipanv ) then
	call pgsls( kdot )
      if( logy .ne. 0 ) then
	call pgbox( ' ', 0., 0, 'G', 1., 0 )
      else
	call pgbox( ' ', 0., 0, 'G', 0., 0 )
      end if
	call pgsls( 1 )
      end if

* verticals
      if( .false. ) then
	call pgsls( kdot )
	call pgsci( kblue )
      do i = 2, np
      if( plot6( i ) .ne. plot6( i-1 ) ) then
	x = ( plot1( i ) + plot1( i - 1 ) ) / 2.
	y = ( plot6( i ) + plot6( i - 1 ) ) / 2.
	call pgmove( x, ymn )
	call pgdraw( x, y )
      end if
      end do
      end if
	call pgsls( 1 )
	call pgsci( kblack )

* label fit stages
      do j = 1, nstage
	i = iter_s( j )
* iteration range
	i1 = 1
	if( j .gt. 1 ) i1 = iter_s( j - 1 )
	i2 = min( nits, i )
	if( j .lt. nstage ) i2 = max( i1, i2 - 1 )
	n = i2 - i1 + 1
	write(*,*) 'Stage', j, ' its', i1, ' to', i2, ' total', n

* vertical dashed line at end of stage
      if( j .lt. nstage ) then
	x = i - 0.5
	call pgsls( kdot )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgsls( 1 )
      end if
* centre of stage
	x = 0.5 * ( min( nits, i ) + 1 ) - 0.5
	if( j .gt. 1 ) x = x + 0.5 * iter_s( j - 1 )
	if( j .eq. 1 ) x = x + 0.5
	x = ( x - xmn ) / ( xmx - xmn )
* model
	label = todo_s( j )

* elaborate model icon
      do k = 1, 5
	l = len1( label )
	title = label(:l)
	ii = 0
      if( k .eq. 1 ) then
	ii = index( title, 'C' )
	nn = nfitcont
	jj = npcont_s( j )
      else if( k .eq. 2 ) then
	ii = index( title, 'F' )
	nn = nfitphot
	jj = npscale_s( j )
      else if( k .eq. 3 ) then
	ii = index( title, 'W' )
	nn = nfitshift
	jj = npshift_s( j )
      else if( k .eq. 4 ) then
	ii = index( title, 'S' )
	nn = nfitblur
	jj = npblur_s( j )

      else if( k .eq. 5 ) then
	ii = index( title, 'B' )
	jj = 0
	nn = 0
* VarBLR components
      do ic = 1, ncomp
      if( npix_c( ic ) .gt. 0 ) then
	ll = line_lc( 1, ic )
	if( nfit_l( ll ) .gt. 0 ) jj = jj + 1
	if( nfit_l( ll ) .gt. 0 ) nn = nn + nfit_l( ll )
      end if
      end do
      end if

      if( ii .gt. 0 .and. nn .gt. 0 .and. jj .gt. 1 ) then
	label = title(:ii)
	call append( label, '\d' )
	call append_i( label, jj )
	call append( label, '\u' )
	if( l .gt. ii ) call append( label, title(ii+1:l) )
c	write(*,*) label(:len1(label))
	call nospace( label )
c	write(*,*) label(:len1(label))
      end if
* next k
      end do

	call pgmtxt( 'b', -1., x, 0.5, label )
* number of parameters
	label = ' '
	call append_i( label, nfit_s( j ) )
	call pgmtxt( 'b', -2.5, x, 0.5, label )

* best iteration in this stage
      if( ipan .eq. ipanbic ) then
      do k = 1,2
* lowest chi2
	ib1 = i1
	ib2 = ib1
      if( k .eq. 1 ) then
	kolor = kolor_chi2
	isymb = 4
      do ii = i1, i2
	if( chi2_i( ii ) .lt. chi2_i( ib1 ) ) ib1 = ii
	if( chi2_i( ii ) .le. chi2_i( ib2 ) ) ib2 = ii
      end do
	yb = plot2( ib1 )
	if( ib2 .eq. ib1 ) write(*,*) ' best  Chi2', chi2_i(ib1), ' at iter', ib1
	if( ib2 .gt. ib1 ) write(*,*) ' best  Chi2', chi2_i(ib1), ' from iter', ib1, ' to', ib2
* lowest bic
      else if( k .eq. 2 ) then
	kolor = kolor_bic
	isymb = 4
      do ii = i1, i2
	if( bic_i( ii ) .lt. bic_i( ib1 ) ) ib1 = ii
	if( bic_i( ii ) .le. bic_i( ib2 ) ) ib2 = ii
      end do
	yb = plot3( ib1 )
	if( ib2 .eq. ib1 ) write(*,*) ' best  BIC', bic_i(ib1), ' at iter', ib1
	if( ib2 .gt. ib1 ) write(*,*) ' best  BIC', bic_i(ib1), ' from iter', ib1, ' to', ib2
      end if

* symbol at first and last best iteration
	call pgsci( kolor )
	xb = ib1
	call pgpt( 1, xb, yb, isymb )
	xb = ib2
	call pgpt( 1, xb, yb, isymb )

* bold line atop all best iterations
	call pgslw( 2 * lwide )
      do ib = ib1, ib2
	xb = ib - 0.5
	call pgmove( xb, yb )
	xb = ib + 0.5
      if(   ( k .eq. 1 .and. chi2_i( ib ) .le. chi2_i( ib1 ) )
     & .or. ( k .eq. 2 .and.  bic_i( ib ) .le.  bic_i( ib1 ) ) ) then
	call pgdraw( xb, yb )
      end if
      end do
	call pgslw( lwide )
* next k
      end do
	call pgsci( kblack )
      end if

* delta chi2 
      if( ipan .eq. ipanbic .and. j .gt. 1 ) then
	jm = max( 1, j - 1 )
	c = chi2_s( j ) - chi2_s( jm )
	b = bic_s( j ) - bic_s( jm )
	label = ' '
	if( j .eq. 2 ) label = '\gD\gx\u2\d'
      if( abs( c ) .lt. 1000. ) then
	call append_f( label, c, '(f15.1)' )
      else
	call append_n( label, c, 4 )
      end if
	if( c .gt. 0. ) call append( label, ':(' )
	call pgsci( kolor_chi2 )
	call pgmtxt( 'b', -4.0, x, 0.5, label )
	call pgsci( kblack )

* delta bic
	label = ' '
	if( j .eq. 2 ) label = '\gDBIC'
      if( abs( b ) .lt. 1000. ) then
	call append_f( label, b, '(f15.1)' )
      else
	call append_n( label, b, 4 )
      end if
	if( b .gt. 0. ) call append( label, ':(' )
	call pgsci( kolor_bic )
	call pgmtxt( 'b', -5.5, x, 0.5, label )
	call pgsci( kblack )
      end if

* next stage j
      end do

* labels
	call pgsci( kolor_label )
	xlabel = ' '
	call append_i( xlabel, nits )
	call append( xlabel, 'iterations' )
	title = ' '
	call pglabel( xlabel, ylabel, title )



      if( ipan .eq. ipanbic .or. ipan .eq. ipanprel ) then

* chi2 label 
	c = chi2_i( nits )
	call append( title, '\gx\u2\d' )
	call append( title, '/(' )
	call append_i( title, ndat_i(nits) )
	call append( title, '-' )
	call append_i( title, nfit_i(nits) )
	call append( title, ')=' )
	c = chi2red_i( nits )
	call append_f( title, c, '(F15.3)' )
	call nospace( title )
	call pgmtxt( 'T', 0.5, 1.0, 1.0, title(:len1(title)) )
	call pgsci( kblack )

* bic legend
	title = ' '

	b = bic_i( nits )
	call append( title, 'BIC' )
	call append_f( title, b, '(f15.2)' )

	db = b - bic_i( max( 1, nits-1 ) )
	call append( title, '\gDBIC' )
	call append_f( title, db, '(f15.3)' )

*	p = alog10( exp( -0.5 * db ) )
	dlogp = -0.5 * db * alog10( exp( 1. ) )
	call append( title, '\gDlogP' )
	call append_f( title, dlogp, '(f16.4)' )
	call pgsci( kolor_bic )
	call pgmtxt( 'T', -1.5, 0.98, 1.0, title(:len1(title)) )
	call pgsci( kblack )

* chi2 legend
	title = ' '
	c = chi2_i( nits )
	call append( title, '\gx\u2\d' )
	call append_f( title, c, '(f15.2)' )

	dc = c - chi2_i( max( 1, nits-1 ) )
	call append( title, '\gD\gx\u2\d' )
	call append_f( title, dc, '(f15.3)' )

*	p = alog10( exp( -0.5 * dc ) )
	dlogp = -0.5 * dc * alog10( exp( 1. ) )
	call append( title, '\gDlogP' )
	call append_f( title, dlogp, '(f16.4)' )
	call pgsci( kolor_chi2 )
	call pgmtxt( 'T', -3., 0.98, 1.0, title(:len1(title)) )
	call pgsci( kblack )

      end if

* line window width legend
	call label_blrnlr( title, vblr, vnlr )
      if( ipan .eq. ipanprel ) then
      if( ipanv .le. 0 .or. ipanv .gt. npan ) then
	call pgmtxt( 'R', 1.5, 0.01, 0., title(:len1(title)) )
      end if
      else if( ipan .eq. ipanv ) then
	call pgmtxt( 'T', 0.5, 1.0, 1.0, title(:len1(title)) )
* fe2 label
	call label_fe2( title, fe2pct, fe2kms, sigfe2kms )
	call pgmtxt( 'T', 1.5, 1., 1., title )

      end if

* legend
	call pgmtxt( 'T', 0.5, 0., 0., agn )


* curves
	call pgsci( kblack )
      if( ipan .eq. ipanbic ) then
* chi2
	call pgsci( kolor_chi2 )
	call pgbin( np, plot1, plot2, .true. )
	add = 0.05 * ( ymx - ymn )
	call pgtext( xmx, plot2(np) - add , '  \gx\u2\d' )
* bic
	call pgsls( kdash )
	call pgsci( kolor_bic )
	call pgbin( np, plot1, plot3, .true. )
	call pgtext( xmx, plot3(np), ' BIC' )
* dof
	call pgsls( kdot )
	call pgsci( kolor_dof )
	call pgbin( np, plot1, plot6, .true. )
	call pgsls( 1 )

      else if( ipan .eq. ipanprel ) then
* exp(-chi2/2)
	call pgsci( kolor_chi2 )
	call pgbin( np, plot1, plot4, .true. )
* exp(-bic/2)
	call pgsls( kdash )
	call pgsci( kolor_bic )
	call pgbin( np, plot1, plot5, .true. )

      else if( ipan .eq. ipanv ) then

* blr
      if( noscatter .eq. 0 ) then
	call pgsci( kcyan )
	call pgsls( kdot )
	call pgsci( kblack )
	call pgline( np, plot1, plot12 )
	call pgsci( kred )
	call pgline( np, plot1, plot14 )
	call pgsci( kgreen )
	call pgline( np, plot1, plot16 )
	call pgsci( kblue )
	call pgline( np, plot1, plot18 )
	call pgsls( 1 )
      end if

	call pgsci( kolor_blr )
	call pgsci( kblue )
	call pgbin( np, plot1, plot8, .true. )
	call pgsls( kdash )
	call pgbin( np, plot1, plot10, .true. )
	call pgsls( 1 )
	call pgtext( xmx, plot8(np), ' BLR' )

* nlr
      if( noscatter .eq. 0 ) then
	call pgsci( korange )
	call pgsls( kdot )
	call pgsci( kblack )
	call pgline( np, plot1, plot13 )
	call pgsci( kred )
	call pgline( np, plot1, plot15 )
	call pgsci( kgreen )
	call pgline( np, plot1, plot17 )
	call pgsci( kblue )
	call pgline( np, plot1, plot19 )
	call pgsls( 1 )
      end if

	call pgsci( kolor_nlr )
	call pgsci( kred )
	call pgbin( np, plot1, plot9, .true. )
	call pgsls( kdash )
	call pgbin( np, plot1, plot11, .true. )
	call pgsls( 1 )
	call pgtext( xmx, plot9(np), ' NLR' )

* fe2
	call pgsci( kolor_fe2 )
	call pgsci( kpurple )
	call pgbin( np, plot1, plot20, .true. )
	call pgsls( kdash )
	call pgbin( np, plot1, plot21, .true. )
	call pgbin( np, plot1, plot22, .true. )
	call pgsls( 1 )
	y = plot20( np )
      if( y .ge. ymn .and. y .le. ymx ) then
	call pgtext( xmx, y, ' FeII' )
      end if

	call pgsls( 1 )

* dof
      IF( .FALSE. ) THEN
	call pgsci( kblack )
	call pgbin( np, plot1, plot6, .true. )
	call pgtext( xmx, plot6(np), ' DoF' )
* Nfit
	call pgsci( kblack )
	call pgbin( np, plot1, plot7, .true. )
	call pgtext( xmx, plot7(np), ' Npar' )
      END IF
      end if
	call pgsls( 1 )
* next panel
      end do
* identify user date time
	call pgiden
* stop
	call pgstop
* again
	if( pgagain() ) goto 581
      end if
	goto 510



*----------------------------------------------------------------------------
* Velocity Profile Plots
  600	write(*,*)
	write(*,*) 'Velocity Profile Plots -------------------------'
	write(*,*) 'Wavelength range:', w_w(1), w_w(nw)

* major lines within range
	lam1 = nint( w_w( 1 ) )
	lam2 = nint( w_w( nw ) )
	title = ' '
* summarise lines in range
	kn = 1
	kb = 2
	kv = 3
      do k = 1, 3
      if( k .eq. kn ) then
	nwant = narrow
	title = 'NLR:'
      else if( k .eq. kb ) then
	nwant = nbroad
	title = 'BLR:'
      else if( k .eq. kv ) then
	nwant = nbroad
	title = 'VarBLR:'
      end if
	n = 0
	nmax = 10
* lines sorted by wavelength
      do lrank = 1, markline
	l = i_l( lrank )
	expand = expand_l( l )
* active lines of correct type
      if( nabc( l ) .eq. nwant .and. expand .gt. 0. ) then
* line in range
	rest = rest_l( l )
	lam = nint( rest )
      if( w_w( 1 ) .le. rest .and. rest .le. w_w( nw ) ) then
* VarBLR component
	kc = 0
      if( k .eq. kv ) then
      do ic = 1, ncomp
	if( l .eq. line_lc( 1, ic ) ) kc = ic
      end do
      end if

* add lambda to title
      if( k .ne. kv .or. kc .gt. 0 ) then
	call append_i( title, lam )
* distinguish twins by marking narrow lines with n
      if( nwant .eq. narrow ) then
      do j = 1, markline
	lamj = nint( rest_l( j ) )
      if( j .ne. l .and. iabs( lamj - lam ) .le. 1 ) then
	title = title(:len1(title)) // 'n'
      end if
      end do
      end if
* line count
	n = n + 1
      end if

* max lines per row
      if( n .gt. 0 .and. mod( n, nmax ) .eq. 0 ) then
	if( n .gt. nmax ) title = '     ' // title(:len1(title))
	write(*,*) '  ' // title(:len1(title))
	title = ' '
      end if
      end if
      end if
* next lrank
      end do
      if( n .gt. 0 ) then
	if( n .gt. nmax ) title = '     ' // title(:len1(title))
	if( len1(title) .gt. 0 ) write(*,*) '  ' // title(:len1(title))
      end if
	if( k .eq. kn ) ngn = n
	if( k .eq. kb ) ngb = n
	if( k .eq. kv ) ngv = n
* next k
      end do	

* menu 
	write(*,*) ' N ... NLR lines:', ngn
	write(*,*) ' B ... BLR lines:', ngb
	write(*,*) ' R ... RMS VarBLR lines:', ngv
	write(*,*) ' A ... Avg VarBLR lines:', ngv
	write(*,*) ' V ... VarBLR Lines (AVG+RMS):', ngv
	write(*,*) ' F ... Fe2'
	write(*,*) ' Q ... Quit'

  605	write(*,*) 'Pick a line, e.g. 1550n 1550b 15550r 1550v (n b r v for all).'
	call inq( 'Lambda(A) for line to plot >', ' ', reply )
	call upcase( reply, reply )
	write(*,*) reply(:len1(reply))

      if( reply .eq. 'Q' ) then
	goto 510
      end if

* line selection options
	line2plot = 0
	if( reply .eq. 'N' ) goto 610
	if( reply .eq. 'B' ) goto 610
	if( reply .eq. 'R' ) goto 610
	if( reply .eq. 'A' ) goto 610
	if( reply .eq. 'V' ) goto 610
	if( reply .eq. 'F' ) goto 607

* KDH : MAKE A LIST OF LINES TO PLOT?
* KDH : OPTION OF AVG AND RMS PLOT FOR SAME LINE?

* line specified by wavelength
	line2plot = 0
      if( len1(reply) .gt. 1 ) then
* text = first word of reply
	call word1( reply, l1, l2 )
	text = reply( l1 : l2 )
	reply = reply( l2+1 : )
* text = first 2 words of reply
      if( l1 .eq. l2 ) then
	call word1( reply, l3, l4 )
	text = text(l1:l2) // reply(l3:l4)
	reply = reply( l4+1 : )
      end if
	call upcase( text, text )
	nwant = -1
* KDH : COULD SIMPLIFY LOGIC BELOW
* narrow line
	k = index( text, 'N' )
      if( k .gt. 0 ) then
	nwant = narrow
	write(*,*) 'Narrow line request : ', text(:len1(text))
	text = text(:k-1) // text(k+1:)
      end if
* broad line
	k = index( text, 'B' )
      if( k .gt. 0 ) then
	nwant = nbroad
	write(*,*) 'Broad line request : ', text(:len1(text))
	text = text(:k-1) // text(k+1:)
      end if
* rms
	k = index( text, 'R' )
      if( k .gt. 0 ) then
	write(*,*) 'RMS BLR request : ', text(:len1(text))
	text = text(:k-1) // text(k+1:)
	nwant = nbroad
	reply = 'R'
      end if
* avg + rms
	k = index( text, 'V' )
      if( k .gt. 0 ) then
	write(*,*) 'AVG+RMS BLR request : ', text(:len1(text))
	text = text(:k-1) // text(k+1:)
	nwant = nbroad
	reply = 'V'
      end if

* wavelength
	read( text, *, err=600 ) lamwant
* find the line
      if( w_w( 1 ) .le. lamwant .and. lamwant .le. w_w( nw ) ) then
	n = 0
	lbest = 0
      do l = 1, markline
      if( expand_l( l ) .gt. 0. ) then
      if( nwant .lt. 0 .or. nabc( l ) .eq. nwant ) then
	rest = rest_l( l )
	test = lamwant - rest
	if( lbest .le. 0 ) lbest = l
	best = lamwant - rest_l( lbest )
	if( abs( test ) .lt. abs( best ) ) lbest = l
* match to 1A
      if( nint( abs( test ) ) .le. 1 ) then
	n = n + 1
	text = text_l( l )
	write(*,*) 'Line found :', lamwant, rest, ' ', text(:len1(text))
* default to broad
	if( n .eq. 1 .or. nabc(l) .eq. nbroad ) line2plot = l
      end if
      end if
      end if
* next line
      end do
	if( line2plot .gt. 0 ) goto 610

* KDH : SHOULD WE JUST GO WITH THE BEST ?
	write(*,*) 'No lines match ', reply(:len1(reply)), ' :(.'
	if( lbest .gt. 0 ) write(*,*) 'Best match:', nint( rest_l( lbest ) )
	goto 600
      end if
      end if
	goto 600

* Fe2 plot
  607	write(*,*) '** FeII plot UNDER TEST **'

	call fe2plot( agn, nw, w_w, avg_w, sigavg_w,
     &	cfitsig_w, avgfe2_w, fe2kms, sigfe2kms, fe2scl, fe2kmsprior,
     &	ngrid, ngrid1, fe2kms_k, fe2scl_k, fe2bof_k, bof8_k,
     &	ngridv, vdisp_v, fe2kms_v, fe2scl_v,
     &	fit_v, chi2_v, dchi2_v, dbof_v, prior_v, wgt_v,
     &	vfit, sigvfit, bofvfit, npoly_avg, nspline_avg, fitrmsv, fitmadv )

	goto 600

* sort lines by rest wavelength
  610 do i = 1, markline
	wav_l( i ) = rest_l( i )
      end do
	call quicksort( markline, wav_l, i_l )

* up to 3 loops ( nlr, blr, rmsblr )
	loopnlr = 0
	loopblr = 0
	looprmsblr = 0
	loopavgblr = 0
	nloop = 1
* specified line
      if( line2plot .gt. 0 ) then
	ltype = nabc( line2plot )
      if( ltype .eq. narrow ) then
	loopnlr = 1
      else if( ltype .eq. nbroad ) then
      if( reply .eq. 'R' ) then
	looprmsblr = 1
      else if( reply .eq. 'V' ) then
	nloop = 2
	loopavgblr = 1
	looprmsblr = 2
      else
	loopblr = 1
      end if
      end if
* all lines
      else if( reply .eq. 'N' ) then
	loopnlr = 1
      else if( reply .eq. 'B' ) then
	loopblr = 1
      else if( reply .eq. 'R' ) then
	looprmsblr = 1
      else if( reply .eq. 'A' ) then
	loopavgblr = 1
      else if( reply .eq. 'V' ) then
	nloop = 2
	loopavgblr = 1
	looprmsblr = 2
* try all 3
      else
	nloop = 3
	loopnlr = 1
	loopblr = 2
	looprmsblr = 3
      end if
* report
	write(*,*) 'Loops', nloop, ' nlr', loopnlr, ' blr', loopblr
     &		, ' avg', loopavgblr, ' rms', looprmsblr

* How many lines of required type?
      do loop = 1, nloop
	nwant = nbroad
	if( loop .eq. loopnlr ) nwant = narrow
	lines2plot = 0
	record = ' '
      do l = 1, markline
      if( line2plot .le. 0 .or. l .eq. line2plot ) then
      if( nabc( l ) .eq. nwant ) then
      if( expand_l( l ) .gt. 0. ) then
	rest = rest_l( l )
      if( w_w( 1 ) .le. rest .and. rest .le. w_w( nw ) ) then
* RMS or AVG BLR
      if(    loop .eq. looprmsblr
     &	.or. loop .eq. loopavgblr ) then
	flx = vflx_l( l )
	vrms = vvrms_l( l )
	vmad = vvmad_l( l )
	vfwhm = vvfwhm_l( l )
      else
* NLR or BLR
	flx = flx_l( l )
	vrms = vrms_l( l )
	vmad = vmad_l( l )
	vfwhm = vfwhm_l( l )
      end if

* select good lines
* KDH : MORE STRINGENT REQUIREMENT HERE ?
      if( max( vrms, vmad, vfwhm ) .gt. 0. ) then
	lines2plot = lines2plot + 1
	text = text_l( l )
	call append( record, text(:len1(text)) )
* KDH : BUILD HERE A LIST OF SELECTED LINES 
	lines_l( lines2plot ) = l
* KDH : NOT CURRENTLY USED
      end if
      end if
      end if
      end if
      end if
* next line l
      end do
* report

* plot format
	npanperline = 1
	if( reply .eq. 'V' ) npanperline = 2

	n = lines2plot * npanperline
	nx = max( 1, nint( sqrt( real( n ) ) ) )
	ny = 1 + ( n - 1 ) / nx
	npan = lines2plot

* more sophisticated format needed
      if( reply .eq. 'V' ) then

      end if

* report
      if( loop .eq. loopnlr ) then
	write(*,*) 'NLR lines', lines2plot
      else if( loop .eq. loopblr ) then
	write(*,*) 'BLR lines', lines2plot
      else if( loop .eq. looprmsblr ) then
	write(*,*) 'RMS BLR lines', lines2plot
      else if( loop .eq. loopavgblr ) then
	write(*,*) 'AVG BLR lines', lines2plot
      end if
	write(*,*) record(:len1(record))
	write(*,*) 'Panels/line', npanperline
	write(*,*) 'Plot format', nx, ' x', ny
* stow
	if( loop .eq. loopnlr ) npannlr = lines2plot
	if( loop .eq. loopblr ) npanblr = lines2plot
	if( loop .eq. looprmsblr ) npanrmsblr = lines2plot
	if( loop .eq. loopavgblr ) npanavgblr = lines2plot
* next loop
      end do


* loop for different line types ========================
  620	nwant = 0
      do loop = 1, nloop
	nout = 0
	ipan = 0

* report
	write(*,*) '======= Loop', loop, ' of', nloop, ' ========='
      if( loop .eq. loopnlr ) then
	write(*,*) 'NLR stats:'
	nwant = narrow
	npan = npannlr
      else if( loop .eq. loopblr ) then
	write(*,*) 'AVG BLR stats:'
	nwant = nbroad
	npan = npanblr
      else if( loop .eq. looprmsblr ) then
	write(*,*) ' RMS BLR stats:'
	nwant = nbroad
	npan = npanrmsblr
      else if( loop .eq. loopavgblr ) then
	write(*,*) ' AVG BLR stats:'
	nwant = nbroad
	npan = npanavgblr
      end if

* error bars ?
	ierbs = 1

* lines ranked by wavelength
      do lrank = 1, markline
	l = i_l( lrank )
      if( l .eq. line2plot .or. line2plot .le. 0 ) then
	iw1 = iw1_l( l )
	iw2 = iw2_l( l )
	rest = rest_l( l )
	lam = nint( rest )
	w0 = rest
* active line of the right type
	expand = expand_l( l )
      if( nabc( l ) .eq. nwant ) then
      if( expand .gt. 0. ) then
      if( w_w( 1 ) .le. rest .and. rest .le. w_w( nw ) ) then

* KDH : SHOULD WE RE-COMPUTE THESE TO BE SURE THEY ARE CORRECT ?
* RMS BLR
      if( loop .eq. looprmsblr ) then
	flx = vflx_l( l )
	vavg = vvavg_l( l )
	vrms = vvrms_l( l )
	vmed = vvmed_l( l )
	vmad = vvmad_l( l )
	vtop = vvtop_l( l )
	vlo = vvlo_l( l )
	vhi = vvhi_l( l )
	vfwhm = vvfwhm_l( l )
	vhw10 = vvhw10_l( l )
* error bars
	sigflx = sigvflx_l( l )
	sigvavg = sigvvavg_l( l )
	sigvrms = sigvvrms_l( l )
	sigvmed = sigvvmed_l( l )
	sigvmad = sigvvmad_l( l )
	sigvtop = sigvvtop_l( l )
	sigvlo = sigvvlo_l( l )
	sigvhi = sigvvhi_l( l )
	sigvfwhm = sigvvfwhm_l( l )
	sigvhw10 = sigvvhw10_l( l )
      else
* NLR or AVG BLR
	flx = flx_l( l )
	vavg = vavg_l( l )
	vrms = vrms_l( l )
	vmed = vmed_l( l )
	vmad = vmad_l( l )
	vtop = vtop_l( l )
	vlo = vlo_l( l )
	vhi = vhi_l( l )
	vfwhm = vfwhm_l( l )
	vhw10 = vhw10_l( l )
* error bars
	sigflx = sigflx_l( l )
	sigvavg = sigvavg_l( l )
	sigvrms = sigvrms_l( l )
	sigvmed = sigvmed_l( l )
	sigvmad = sigvmad_l( l )
	sigvtop = sigvtop_l( l )
	sigvlo = sigvlo_l( l )
	sigvhi = sigvhi_l( l )
	sigvfwhm = sigvfwhm_l( l )
	sigvhw10 = sigvhw10_l( l )
      end if

* good lines
* KDH : MORE STRINGENT REQUIREMENT HERE ?
	vvrms = vvrms_l( l )
	vvmad = vvmad_l( l )
	vvfwhm = vvfwhm_l( l )
      if( loop .eq. looprmsblr .or. loop .eq. loopavgblr ) then
	test = max( vvrms, vvmad, vvfwhm )
      else
	test = max( vrms, vmad, vfwhm )
      end if
      if( test .gt. 0. ) then
	nout = nout + 1
	ipan = ipan + 1

* column headings
      if( nout .eq. 1 ) then
      if( ierbs .eq. 0 ) then
	write( header, '(a1, a12, a10, 3a7, 3a7, 2a7)' )
     &	'#', 'rest(A)', 'erg/cm2/s'
     &		, 'fwhm', 'rms', 'mad'
     &		, 'top', 'avg', 'med'
     &		, 'winhw'
c     &		, 'hw10%'
      else
	write( header, '(a1, a12, 2a11, 3(a7,a7), 3(a7,a7), 2a7 )' )
     &	'#', 'rest(A)', 'erg/cm2/s', '+/-'
     &		, 'fwhm', '+/-'
     &		, 'rms', '+/-'
     &		, 'mad', '+/-'
     &		, 'top', 'avg', 'med'
     &		, 'winhw'
c     &		, 'hw10%'
      end if
	lh = len1( header )
c	write( *, * ) header(:lh)
      end if

* window halfwidth
	if( nwant .eq. nbroad ) vwin = vblr
	if( nwant .eq. narrow ) vwin = vnlr
	vwin = vwin * expand

* mcmc iterations ?
	mcmc = 0
	if( ierbs .gt. 0 ) mcmc = 10000

* loop accordingly
	nkerb = 1
	if( mcmc .gt. 0 ) nkerb = 2
	kmcmc = 2
      do kerb = 1, nkerb

* mcmc error bars 
      if( kerb .eq. kmcmc ) then
	n = iw2 - iw1 + 1
	lam1 = nint( w_w( iw1 ) )
	lam2 = nint( w_w( iw2 ) )

* load arrays

* NLR ============================================
      IF( loop .eq. loopnlr ) then

	if( gabby ) write(*,*) 'NLR MCMC', mcmc
     &		, ' lam', lam1, lam2, ' pix', n
      do i = iw1, iw2
	dat = elr_w( i )
	sig = sigavg_w( i )
c	if( dat .le. 0. ) sig = - abs( sig )
* stow
	dat_w( i ) = dat
	sig_w( i ) = sig
      end do

* AVG BLR ========================================
      ELSE IF( loop .eq. loopblr .or. loop .eq. loopavgblr ) then

	if( gabby ) write(*,*) 'BLR MCMC', mcmc
     &		, ' lam', lam1, lam2, ' pix', n
      do i = iw1, iw2
	sig = sigavgblr_w( i )
* KDH 2019 May : MASK ABSN
	mask = maskabsn( i )
* KDH 2019 Aug : MASK BAL
	mask = mask .or. maskbal( i )
	if( mask ) sig = - abs( sig )
* stow
	dat_w( i ) = avgblr_w( i )
	sig_w( i ) = sig
	plot4( i ) = avg_w( i ) - avgcont_w( i )
	plot5( i ) = dat_w( i ) + elr_w( i )
	plot6( i ) = elr_w( i )
      end do

* RMS BLR ======================================
      ELSE IF( loop .eq. looprmsblr ) then

	write(*,*) 'RMS BLR MCMC', mcmc
     &		, ' lam', lam1, lam2, ' pix', n
* KDH : TWEAK ERROR BARS TO ALLOW FOR SMOOTHING
* KDH : IS THIS DONE ALREADY ?
	blurpix = blurpix_l( l )
	write(*,*) 'RMS BLR profile was smoothed over', blurpix, ' pixels.'
	div = 1.
      if( idived .eq. 0 ) then
	div = sqrt( max( 1., blurpix ) )
      end if
	if( div .ne. 1. .or. .true. ) write(*,*) 'Error bar divisor', div
	ng = 0
	ng0 = 0
      do i = iw1, iw2
	sig = sig_wl( i, l ) / div
	if( sig .gt. 0. ) ng0 = ng0 + 1
* KDH 2019 May : MASK ABSN
	mask = maskabsn( i )
* KDH 2019 Aug : MASK BAL
	mask = mask .or. maskbal( i )
	if( mask ) sig = - abs( sig )	
	if( sig .gt. 0. ) ng = ng + 1
	dat = dat_wl( i, l )

* 2021-11-11 KDH: TRY TO DE-BLEND
* KDH - should pre-identify list of blended lines.
* subtract blended lines
	blend = 0.
      do ll = 1, markline
      if( ll .ne. l ) then
* active line of the right type
      if( nabc( ll ) .eq. nwant ) then
      if( expand_l( ll ) .gt. 0. ) then
	blend = blend + dat_wl( i, ll )
      end if
      end if
      end if
      end do
	dat = dat - blend

* stow
	dat_w( i ) = dat
	sig_w( i ) = sig
	plot4( i ) = rmsb_w( i ) - blend
      end do
	write(*,*) 'Good pixels before/after masking:', ng0, ' =>', ng, ' of', n
	panic = ng .lt. max(1,n/2) 
	if( gabby .and. panic ) stop '** PANIC!'
      END IF
* arrays loaded

* fit spline to the line profile 
	thrhi = 5.
	thrlo = -5.
	ncycle = 10
	blur = max( 3., n / 15. )
	nspline = max( 1, nint( n / blur ) )
	i = iw1
	n = iw2 - iw1 + 1
	call splfita( n, w_w(i), dat_w(i), sig_w(i), fit_w(i),
     &		nspline, ncycle, thrhi, thrlo, ifail )
	write(*,*) 'Data', n, ' splines', nspline, ' ratio', float(n)/nspline

* with and without mcmc iterations
      do k = 0, 1
	i = iw1
	n = iw2 - iw1 + 1
* mcmc linewidth stats
	nmcmc = mcmc * k
	write(*,*) 'Loop', loop, ' Nmcmc', nmcmc, ' top,avg,med', vtop, vavg, vmed
      do iii=1,3
	call linestat_mcmc( n, w_w(i), dat_w(i), sig_w(i), mask_wl(i,l),
     &	 w0, nmcmc, iseed, flx, sigflx,
     &	 vavg, sigvavg, vrms, sigvrms,
     &	 vmed, sigvmed, vmad, sigvmad,
     &	 vtop, sigvtop, vlo, sigvlo, vhi, sigvhi,
     &	 vlo1, sigvlo1, vhi1, sigvhi1,
     &	 vlo2, sigvlo2, vhi2, sigvhi2,
     &	 vlo10, sigvlo10, vhi10, sigvhi10 )
	write(*,*) ' back from mcmc:', iii, ' top,avg,med', vtop, vavg, vmed
      end do
* fwhm
	vfwhm = vhi - vlo
	sigvfwhm = sqrt( ( sigvhi )**2 + ( sigvlo )**2 )
	if( sigvhi .lt. 0. .or. sigvlo .lt. 0. ) sigvfwhm = - sigvfwhm
* fwhm1
	vfwhm1 = vhi1 - vlo1
	sigvfwhm1 = sqrt( ( sigvhi1 )**2 + ( sigvlo1 )**2 )
	if( sigvhi1 .lt. 0. .or. sigvlo1 .lt. 0. ) sigvfwhm1 = - sigvfwhm1
* fwhm2
	vfwhm2 = vhi2 - vlo2
	sigvfwhm2 = sqrt( ( sigvhi2 )**2 + ( sigvlo2 )**2 )
	if( sigvhi2 .lt. 0. .or. sigvlo2 .lt. 0. ) sigvfwhm2 = - sigvfwhm2

* h210%
	vhw10 = ( vhi10 - vlo10 ) / 2.
	sigvhw10 = sqrt( ( sigvhi10 )**2 + ( sigvlo10 )**2 ) / 2.
	if( sigvhi10 .lt. 0. .or. sigvlo10 .lt. 0. ) sigvhw10 = - sigvhw10

* fix integrated line flux
	call fixflx( w0, flx, fluxunit, inflxdex )
	call fixflx( w0, sigflx, fluxunit, inflxdex )

* stow pre-mcmc fit values
      if( nmcmc .eq. 0 ) then
	flxfit = flx
	vavgfit = vavg
	vrmsfit = vrms
	vmedfit = vmed
	vmadfit = vmad
	vtopfit = vtop
	vlofit = vlo
	vhifit = vhi
	vfwhmfit = vfwhm
	vfwhm1fit = vfwhm1
	vfwhm2fit = vfwhm2
	vlo1fit = vlo1
	vhi1fit = vhi1
	vlo2fit = vlo2
	vhi2fit = vhi2
      end if
* next k (=0,1)
      end do

* format
	npan = max( 1, npan )
	write(*,*)
	write(*,*) '----------------------------------------------------'
	write(*,*) 'Panel', ipan, ' of', npan
* open
      if( ipan .eq. 1 .or. npan .eq. 1 ) then
      if( loop .eq. 1 ) then
	nx = max( 1, nint( sqrt( real( npan ) ) ) )
	ny = 1 + ( npan - 1 ) / nx

* force ny to be multiple of npanperline
      if( npanperline .ne. 1 ) then
	nxold = nx
	nyold = ny
	n = npanperline * npan
	nx = max( 1, nint( sqrt( real( n ) ) ) )
	ny = 1 + ( n - 1 ) / nx
	ny = ( ny / npanperline ) * npanperline
	nx = 1 + ( n - 1 ) / ny
	write(*,*) 'Nx,Ny', nxold, nyold, ' ->', nx, ny
      end if

	write(*,*) 'pgstart(', nx, ny, ' )'
	call pgstart( nx, ny, notused )
	call pgbgw
* character size
	csize = csizedef
      if( nx * ny .le. 3 ) then
	csize = csizedef * 1.5
      end if
	call pgsch( csize )
* linewidth
	lwide = lwidedef
	if( max( nx, ny ) .gt. 3 ) lwide = min( 3, lwide )
	call pgslw( lwide )

* set up first panel, but draw nothing
	call pgenv( 0., 1., 0., 1., 0, -2 )

      end if
      end if

* jump to the required panel
	write(*,*) 'ipan', ipan, ' nx', nx, ' ny', ny
	ipany = 1 + ( ipan - 1 ) / nx
	ipanx = ipan - nx * ( ipany - 1 )
	ipany = 1 + ( ipany - 1 ) * npanperline + ( loop - 1 )
	write(*,*) 'loop', loop, ' ix', ipanx, ' iy', ipany

	write(*,*) ' pgpanl(', ipanx, ipany, ' )'
	call pgpanl( ipanx, ipany )

* velocity grid
      do i = 1, nw
	v_w( i ) = ckms * alog( w_w( i ) / w0 )
      end do
* window
	i = iw1
	n = iw2 - iw1 + 1
	call   mnmx( n,   v_w( i ), xmn, xmx )
	call   mnmx( n, dat_w( i ), dmn, dmx )
	call   mnmx( n, fit_w( i ), fmn, fmx )
	call   mnmx( n, sig_w( i ), smn, smx )
	call medmad( n, sig_w( i ), smed, smad )
* KDH 2019 MAY : stat positive error bars
* KDH 2019 AUG : stat negative error bars
      if( smn .lt. 0. ) then
	k = 0
	j = 0
      do i = iw1, iw2
	sig = sig_w( i )
      if( sig .gt. 0. ) then
	k = k + 1
	plot1( k ) = sig
      else if( sig .le. 0. ) then
	j = j + 1
	plot2( j ) = sig
      end if
      end do
	call   mnmx( k, plot1, smn, smx )
	call medmad( k, plot1, smed, smad )
	call   mnmx( j, plot2, snegmn, snegmx )
	call medmad( j, plot2, snegmed, snegmad )
      end if
	write(*,*) 'Sig>0', k, ' mn', smn, ' mx', smx, ' med', smed
	write(*,*) 'Sig<0', j, ' mn', snegmn, ' mx', snegmx, ' med', snegmed
* y range
	ymx = fmx + smed
	ymn = dmn - smed
	ymn = min( ymn, 0. )
	ymn = min( ymn, snegmed * 1.5 )
	f = 1.2
c	ymx = max( f * ymx, f * smx, 5 * abs( ymn ) )
	ymx = max( f * ymx, f * smx, 3 * abs( ymn ) )
* expand y range
	xtra = 0.05
	add = ( ymx - ymn ) * xtra
	if( ymn .lt. 0. ) ymn = ymn - add
	ymx = ymx + add * 3.
* expand x range
	xtra = 0.05
	add = ( xmx - xmn ) * xtra
	xmn = xmn - add
	xmx = xmx + add

* account for the flux units on the plots
	funit = 10. ** ( inflxdex - iflxdex )
	f = funit
      if( f .eq. 1. ) then
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
c	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgswin( xmn, xmx, ymn, ymx )
	call pgbox( 'bcnst', 0., 0, 'bcnst', 0., 0 )

      else
	write(*,*) 'y axis flux scale factor', f
	write(*,*) 'pgenv(', xmn, xmx, ymn*f, ymx*f, ' )'
c	call pgenv( xmn, xmx, ymn * f, ymx * f, 0, 0 )
	call pgswin( xmn, xmx, ymn * f, ymx * f )
	call pgbox( 'bcnst', 0., 0, 'bcnst', 0., 0 )
	write(*,*) 'pswin(', xmn, xmx, ymn, ymx, ' )'
	call pgswin( xmn, xmx, ymn, ymx )
      end if

* horizontal
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )

* KDH : SHOULD THIS BE 0 RATHER THAN W0 ?
	call pgmove( w0, ymn )
	call pgdraw( w0, ymx )

* BAL windows
      if( nbal .gt. 0 ) then
      do ibal = 1, nbal
	w = restbal_l( ibal )
	v = ckms * alog( w / w0 )
	v1 = v + v1bal_l( ibal )
	v2 = v + v2bal_l( ibal )
      if(    ( v1 .ge. xmn .and. v1 .le. xmx )
     &	.or. ( v2 .ge. xmn .and. v2 .le. xmx ) ) then
	write(*,*) 'BAL', v1, v2, ' km/s lam0', w, w0
	call pgsci( kyellow )
	y = ymn + ( ymx - ymn ) * 0.975
	call pgmove( v1, ymn )
	call pgdraw( v1, y )
	call pgmove( v2, ymn )
	call pgdraw( v2, y )
	call pgmove( v1, y )
	call pgdraw( v2, y )
      end if
      end do

* sanity check : mark bal window ranges
	write(*,*) 'BALMASK:', (maskbal(iw),iw=iw1,iw2)
	y = ymn + ( ymx - ymn ) * 0.97
	x = v_w( iw1 )
	call pgsci( kyellow )
	call pgmove( x, y )
      do i = iw1, iw2
	im = max( i - 1, 1 )
	ip = min( i + 1, nw )
	v = v_w( i )
	vp = v_w( ip )
	vm = v_w( im )
	x = ( vm + v ) / 2.
	mask = maskbal( i ) .and. ( i .eq. iw1 .or. .not. maskbal( im ) )
      if( mask ) then
	write(*,*) 'BAL ON at v =', nint(x)
	call pgmove( x, y )
      end if
	x = ( v + vp ) / 2. 
	mask = maskbal( i ) .and. ( i .eq. iw2 .or. .not. maskbal( ip ) )
      if( mask ) then
	write(*,*) 'BAL OFF at v =', nint(x)
	call pgdraw( x, y )
      end if
      end do
	x = v_w( iw2 )
	if( maskbal( iw2 ) ) call pgdraw( x, y )
	call pgsci( 1 )
	call pgsls( 1 )
      end if

* x label
	xlabel = 'velocity (km/s)'
	IF( ZSHIFT .NE. 0.D0 ) WRITE( XLABEL, '(A,F8.6)')
     &		XLABEL(:LEN1(XLABEL)) // '  z=', ZSHIFT
* y label
	call plotlabel_flux( ylabel, fluxunit, iflxdex )
* title
	title = agn
	if( loop .eq. loopnlr ) call append( title, 'NLR' )
	if( loop .eq. loopblr ) call append( title, 'BLR' )
	if( loop .eq. loopavgblr ) call append( title, 'AVG BLR' )
	if( loop .eq. looprmsblr ) call append( title, 'RMS BLR' )
	text = text_l( l )
	label = label_l( l )
	call append( title, label )
	call append_f( title, w0, '(f15.2)' )

	write(*,*) ' X: ', xlabel(:len1(xlabel)) 
	write(*,*) ' Y: ', ylabel(:len1(ylabel)) 
	write(*,*) ' T: ', title(:len1(title)) 

	call pglabel( xlabel, ylabel, title )

* linewidth legend
	call label_blrnlr( title, vblr, vnlr )
* 2021-04-17 KDH: reduce character size
	if( nx .eq. 1 ) call pgsch( csize * 0.7 )
	call pgmtxt( 'R', 1.5, 0.01, 0., title(:len1(title)) )
	call pgsch( csize )

c	call pgsci( kltgrey )
	call pgsci( kblack )

* narrow lines affecting broad lines
	i = iw1
      if( loop .eq. loopblr .or. loop .eq. loopavgblr ) then
	call pgsci( korange )
	call pgbin( n, v_w(i), plot5(i), .true. )
	call pgbin( n, v_w(i), plot6(i), .true. )
* avg blr spectrum
	call peqp( n, plot7(i), plot4(i) )
* rms blr spectrum
      else
	call peqp( n, plot7(i), plot4(i) )
      end if

* black histogram data
	call pgsci( kblack )
	call pgbin( n, v_w(i), plot4(i), .true. )

	i = iw1
      if( loop .eq. loopavgblr .or. loop .eq. loopblr ) then
* data - fe2
	call peqpmcap( n, plot8(i), fe2_w(i), -1., plot4(i) )
	call pgsci( kblack )
	call pgbin( n, v_w(i), plot8(i), .true. )
* black filled dots 
	isymb = 17
      do j=iw1, iw2
	mask = maskbal( j ) .or. maskabsn( j )
      if( mask ) then
	plot8(j) = 0.
      else
	call pgpt( 1, v_w(j), plot8(j), isymb )
      end if
      end do
* light grey histogram if masked
	call pgsci( kltgrey )
	call pgbin( n, v_w(i), plot8(i), .true. )

* fe2 on avg blr 
	call pgsci( kblugrn )
	call pgbin( n, v_w(i), fe2_w(i), .true. )
	call peqpap( n, plot8(i), fe2_w(i), fit_w(i) )
	call pgbin( n, v_w(i), plot8(i), .true. )
      end if

      do i = iw1, iw2
	y = plot4( i )
	mask = maskbal( i ) .or. maskabsn( i )
* ltgrey small open circles if masked
      if( mask ) then
	plot7( i ) = y
	isymb = 20
	kolor = kltgrey
* black filled dots
      else
	plot7( i ) = 0.
	isymb = 17
	kolor = kblack
      end if 
	call pgsci( kolor )
	call pgpt( 1, v_w(i), y, isymb )
      end do
* ltgrey histogram if masked
	i = iw1
	call pgsci( kltgrey )
	call pgbin( n, v_w(i), plot7(i), .true. )

* histogram data
	i = iw1
c	call pgslw( 2 * lw )
	call pgslw( 2 * lwide )
	call pgsci( kblue )
	call pgline( n, v_w( i ), dat_w( i ) )
	call pgbin( n, v_w( i ), dat_w( i ), .true. )

* linear continuum
	cfrac = 0.1
	call linecont( n, dat_w(i), 1, n, c1, c2, cfrac )
	i2 = i + n - 1
	write(*,*) ' cont', nint( v_w(i) ), c1, nint( v_w(i2) ), c2
	call pgmove( v_w( i ), c1 )
	call pgdraw( v_w( i2 ), c2 )

	call pgslw( lwide )

* error bar spectrum
	call pgsci( kgreen )
	call pgbin( n, v_w( i ), sig_w( i ), .true. )

* error bars
	call pgsci( kblue )
      do i = iw1, iw2
	x = v_w( i )
	y = dat_w( i )
	s = sig_w( i )
	if( s .gt. 0. ) call pgerrb( 6, 1, x, y, s, 1. )
      end do

* nj spline fits to jiggled line profile
	n = iw2 - iw1 + 1
	v1 = v_w( iw1 )
	v2 = v_w( iw2 )
	nj = 15
	if( nj .gt. 1 ) write(*,*) 'Jiggled continuum samples', nj
      do j = 1, nj
* jiggle the data
      do i = iw1, iw2
	dat = dat_w( i )
	sig = sig_w( i )
	plot1( i ) = rang( dat, sig, iseed )
      end do

* jiggled linear continua
	i = iw1
	call linecont( n, plot1(i), 1, n, c1, c2, cfrac )
	write(*,*) j, ' cont', nint( v1 ), c1, nint( v2 ), c2

	call pgsci( kpuce )
	call pgmove( v1, c1 )
	call pgdraw( v2, c2 )

* KDH : USE SAME VALUES AS ABOVE
C	thrhi = 5.
C	thrlo = -5.
C	ncycle = 10
C	blur = max( 3., n / 15. )
C	nspline = max( 1, nint( n / blur ) )
	call splfita( n, w_w(i), plot1(i), sig_w(i), plot2(i),
     &		nspline, ncycle, thrhi, thrlo, ifail )
	call pgline( n, v_w( i ), plot2( i ) )

* next MC sample j
      end do

* points
	i = iw1
	call pgsci( kblue )
	call pgpt( n, v_w( i ), dat_w( i ), 17 )

* spline fit to line profile data
	i = iw1
	call pgsci( kred )
	call pgline( n, v_w( i ), fit_w( i ) )

* horizontals
	call pgsci( kblack )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )


* pgplot colour indices
	kolor_vwin = kblack
	kolor_vrms = kblack
	kolor_rms1 = kgreen
	kolor_vmad = kred
	kolor_fwhm = kblue
	kolor_fwhm1 = kgreen
	kolor_fwhm2 = kcyan

* gaussian scaled to fit data
	write(*,*) 'w0', w0, ' vavg', vavg, ' vrms', vrms
      do ig = 0, 1

      if( ig .eq. 1 ) then
	avg = vavg
	rms = vrms
	kolor = kolor_rms
      else
	avg = vavgfit
	rms = vrmsfit
	kolor = kolor_rms1
      end if

      do i = iw1, iw2 
	w = w_w( i )
	v = ckms * ( ( w / w0 ) - 1. )
	e = ( v - avg ) / rms
	g = 0.
	if( abs( e ) .le. 6. ) g = exp( -0.5 * e * e )
	plot1( i ) = g	
      if( iw .eq. iw1 .or. iw .eq. iw2 ) then
	write(*,*) 'w(', iw, ' )=', nint( w ), nint( v ), x
      end if
      end do
	i = iw1
	call mnmx( n, plot1( i ), gmn, gmx )
	write(*,*) 'Gaussian pattern', gmn, gmx
	call optscl( n, dat_w(i), sig_w(i), plot1(i), scl, sigscl )
	write(*,*) 'Scale to fit', scl, ' +/-', sigscl
      do i = iw1, iw2
	g = plot1( i )
	add = g * sigscl
	avg = g * scl
	plot1( i ) = avg
	plot2( i ) = avg + add
	plot3( i ) = avg - add
      end do
	i = iw1
	call pgsci( kolor )
	call pgline( n, v_w( i ), plot1( i ) )
	call pgline( n, v_w( i ), plot2( i ) )
	call pgline( n, v_w( i ), plot3( i ) )
* next ig
       end do

* linear continuum
	v1 = v_w( iw1 )
	v2 = v_w( iw2 )
	n = iw2 - iw1 + 1
	call linecont( n, dat_w(iw1), 1, n, c1, c2, cfrac )
	write(*,*) ' cont', nint( v1 ), c1, nint( v2 ), c2

* cumulative distributions
	sum = 0.d0
	sum2 = 0.d0
	sum3 = 0.d0
	v1 = v_w( iw1 )
	v2 = v_w( iw2 )
      do i = iw1, iw2
	im = max( i - 1, 1 )
	ip = min( i + 1, nw )
	dw = ( w_w( ip ) - w_w( im ) ) / max( 1, ip - im )
	dat = dat_w( i )
	v = v_w( i )
	p = ( v - v1 ) / ( v2 - v1 )
	c = c1 * ( 1. - p ) + p * c2
	add = abs( dat ) * dw
	add2 = abs( dat - c ) * dw
	add3 = ( dat - c ) * dw
	sum = sum + add
	sum2 = sum2 + add2
	sum3 = sum3 + add3
	plot5( i ) = sum
	plot6( i ) = sum2
	plot7( i ) = sum3
      end do
* normalise
      do i = iw1, iw2
	im = max( i - 1, 1 )
	ip = min( i + 1, nw )
	w = w_w( i )
	dw = ( w_w( ip ) - w_w( im ) ) / max( 1, ip - im )
	p  = plot5( i ) / sum
	p2 = plot6( i ) / sum2
	p3 = plot7( i ) / sum3
      if( i .eq. iw1 ) then
	k = 1
	plot4( k ) = ckms * alog( ( w - dw / 2. ) / w0 )
	plot5( k ) = ymn
	plot6( k ) = ymn
	plot7( k ) = ymn
      end if
	k = k + 1
	plot4( k ) = ckms * alog( ( w + dw / 2. ) / w0 )
	plot5( k ) = ymn * ( 1. - p  ) + p  * ymx
	plot6( k ) = ymn * ( 1. - p2 ) + p2 * ymx
	plot7( k ) = ymn * ( 1. - p3 ) + p3 * ymx
      end do
	call pgsci( korange )
	call pgline( k, plot4, plot7 )
	call pgline( k, plot4, plot6 )
	call pgline( k, plot4, plot5 )

c	call pgbin( k, plot4, plot5, .false. )

* quartiles
	tail = ( 1. - 0.684 ) / 2.
      do j = 1,3
	p = j * 0.25
	if( j .eq. 1 ) p = tail
	if( j .eq. 2 ) p = 0.5
	if( j .eq. 3 ) p = 1. - tail
	y = ymn * (1.-p) + p * ymx
	call lookup( k, plot5, y, i1, i2, p )
	x = terp1( k, plot4, i1, i2, p )
	y = terp1( k, plot5, i1, i2, p )
	call pgpt( 1, x, y, 6 )
      end do

* MCMC linewidths
	jv10 = 0 
	jvrms = 1
	jvmad = 2
	jfwhm1 = 3
	jfwhm2 = 4
	jfwhm = 5
	jvwin = 6
	jflx = 7
	jsnr = 8

      do j = 1, 8
* default
	kolor = 1
* 2021-04-17 KDH:
	if( nx .eq. 1 ) call pgsch( csize * 0.7 )

* avg +/- rms
      if( j .eq. jvrms ) then
	y0 = exp( -0.5 ) * scl
	v0 = vavg
	sv0 = sigvavg
	dv = vrms
	sv = sigvrms
	dvhi = +dv
	dvlo = -dv
	svhi = sv
	svlo = sv
c	write(*,*) ' avg', nint(v0), ' rms', nint(dv), ' +/-', nint(sv)
	title = 'avg'
	legend = 'rms'
	kolor = kolor_vrms
	isymb = 4

* pre-mcmc
	vfit = vavgfit
	dvfit = vrmsfit
	dvhifit = +dvfit
	dvlofit = -dvfit
	isymb1 = 17

* med +/- mad
      else if( j .eq. jvmad ) then
c	y0 = 1.1 * exp( -0.5 ) * scl
	y0 = ( ymx + ymn ) / 2.
	v0 = vmed
	sv0 = sigvmed
	dv = vmad
	sv = sigvmad
	dvhi = +dv
	dvlo = -dv
	svhi = sv
	svlo = sv
c	write(*,*) ' med', nint(v0), ' mad', nint(dv), ' +/-', nint(sv)
	legend = 'mad'
	title = 'med'
	kolor = kolor_vmad
	isymb = 6

* pre-mcmc
	vfit = vmedfit
	dvfit = vmadfit
	dvhifit = +dvfit
	dvlofit = -dvfit
	isymb1 = 16

* top + vhi, top - vlo
      else if( j .eq. jfwhm 
     &	.or. j .eq. jfwhm1
     &  .or. j .eq. jfwhm2 ) then
	i = iw1
c	call mnmx( n, dat_w(i), dmn, dmx )
	call mnmx( n, fit_w(i), dmn, dmx )
	y0 = 0.5 * dmx
	v0 = vtop
	sv0 = sigvtop
	dvhi = vhi - v0
	dvlo = vlo - v0
	svhi = sigvhi
	svlo = sigvlo
	legend = 'fwhm'
	title = 'top'
	kolor = kolor_fwhm
	isymb = 7
      if( j .eq. jfwhm1 ) then
	dvhi = vhi1 - v0
	dvlo = vlo1 - v0
	svhi = sigvhi1
	svlo = sigvlo1
	legend = '>'
	kolor = kolor_fwhm1
      else if( j .eq. jfwhm2 ) then
	dvhi = vhi2 - v0
	dvlo = vlo2 - v0
	svhi = sigvhi2
	svlo = sigvlo2
	legend = '<'
	kolor = kolor_fwhm2
      end if
	dv = dvhi - dvlo
	sv = sqrt( svhi * svhi + svlo * svlo )

* pre-mcmc
	vfit = vtopfit
	dvhifit = vhifit - vfit
	dvlofit = vlofit - vfit
	dvfit = dvhifit - dvlofit
      if( j .eq. jfwhm1 ) then
	dvhi1fit = vhi1fit - vfit
	dvlo1fit = vlo1fit - vfit
	dvfit = dvhi1fit - dvlo1fit
      else if( j .eq. jfwhm2 ) then
	dvhi2fit = vhi2fit - vfit
	dvlo2fit = vlo2fit - vfit
	dvfit = dvhi2fit - dvlo2fit
      end if
	isymb1 = 13

* top + vhi10, top - vlo10
* KDH : THIS OPTION DISABLED
      else if( j .eq. jv10 ) then
	i = iw1
c	call mnmx( n, dat_w(i), dmn, dmx )
	call mnmx( n, fit_w(i), dmn, dmx )
	y0 = 0.1 * dmx
	v0 = vtop
	sv0 = sigvtop
	dvhi = vhi10 - v0
	dvlo = vlo10 - v0
	svhi = sigvhi10
	svlo = sigvlo10
	dv = dvhi - dvlo
	sv = sqrt( svhi * svhi + svlo * svlo )
c	write(*,*) ' top', nint(v0), ' hwhm', nint(dv), ' +/-', nint(sv)
	legend = ' '
	title = ' '
	kolor = kolor_fwhm
	isymb = 7

* window
      else if( j .eq. jvwin ) then
	y0 = ymx
	v0 = 0.
	sv0 = 0.
	dv = vwin
	sv = 0.
	dvhi = +dv - v0
	dvlo = -dv - v0
	svhi = sv
	svlo = sv
	title = ' '
	legend = 'WinHW'
	kolor = kolor_vwin
	isymb = 3
      end if
* report
* window
      if( j .eq. jvwin ) then
	write(*,*) legend(:len1(legend)), nint(dv)
* fwhm
      else if( j .eq. jfwhm ) then 
	write(*,*) ' top', nint(vfit), 
     &		' ->', nint(v0), ' +/-', nint(sv0)
	write(*,*) ' dvlo', nint(dvlofit),
     &		' ->', nint(dvlo), ' +/-', nint(svlo)
	write(*,*) ' dvhi', nint(dvhifit),
     &		' ->', nint(dvhi), ' +/-', nint(svhi)
	write(*,*) ' fwhm', nint(vfwhmfit),
     &		' ->', nint(dv), ' +/-', nint(sv)
* fwhm1
      else if( j .eq. jfwhm1 ) then 
	write(*,*) ' dvlo1', nint(dvlo1fit),
     &		' ->', nint(dvlo), ' +/-', nint(svlo)
	write(*,*) ' dvhi1', nint(dvhi1fit),
     &		' ->', nint(dvhi), ' +/-', nint(svhi)
	write(*,*) ' fwhm1', nint(vfwhm1fit),
     &		' ->', nint(dv), ' +/-', nint(sv)
* fwhm2
      else if( j .eq. jfwhm2 ) then 
	write(*,*) ' dvlo2', nint(dvlo2fit),
     &		' ->', nint(dvlo), ' +/-', nint(svlo)
	write(*,*) ' dvhi2', nint(vhi2fit),
     &		' ->', nint(dvhi), ' +/-', nint(svhi)
	write(*,*) ' fwhm2', nint(vfwhm2fit),
     &		' ->', nint(dv), ' +/-', nint(sv)

* asymmetric
      else if( abs(dvhi) .ne. abs(dvlo) ) then
	write(*,*) ' ', title(:len1(title)), nint(vfit), 
     &		' ->', nint(v0), ' +/-', nint(sv0)
	write(*,*) ' d', legend(:len1(legend)), 'lo'
     &	, nint(dvlofit), ' ->', nint(dvlo), ' +/-', nint(svlo)
	write(*,*) ' d', legend(:len1(legend)), 'hi'
     &	, nint(dvhifit), ' ->', nint(dvhi), ' +/-', nint(svhi)

* symmetric
      else
	write(*,*) ' ', title(:len1(title)), nint(vfit),
     &		' ->', nint(v0), ' +/-', nint(sv0)
	write(*,*) ' ', legend(:len1(legend)), nint(dvfit),
     &		' ->', nint(dv), ' +/-', nint(sv)
      end if

*-----------------------------------------
* legend
	call pgsci( kolor )

* halfwidth
	ll = len1( legend ) + 2
	call append_i( legend, nint( dv ) )

* flux
      if( j .eq. jflx ) then
	legend = 'Fcgs'
	call append_datsig( legend, flxfit, sigflx, 2 )
c	call append( legend, 'erg/cm\u2\d/s' )
c	call append( legend, 'cgs' )
	y = -1.5
	x = 0.97
	f = 1.
	call pgmtxt( 'T', y, x, f, legend )

* KDH : VERIFY THIS VALUE MATCHES THAT IN OUTPUT FILE
	write(*,*) legend(:len1(legend))

* put out the MCMC result as well
* KDH : CAN WE REPLACE LEGEND2 WITH LEGEND ?
	legend2 = ' '
	call append_datsig( legend2, flx, sigflx, 2 )
	y = -3.0
	call pgmtxt( 'T', y, x, f, legend2 )

* S/N
      else if( j .eq. jsnr ) then
	legend = 'S/N'
	snr = flx / sigflx
	call append_n( legend, snr, 3 )
	write(*,*) legend(:len1(legend))
	y = 0.5
	x = 1.
	f = 1.
	call pgmtxt( 'T', y, x, f, legend )

* window
      else if( j .eq. jvwin ) then
	call append( legend, 'km/s' )
	call append_i( legend, nint( w0 * exp(-vwin/ckms) ) )
	call append_i( legend, nint( w0 * exp(+vwin/ckms) ) )
	x = 0.03
	x = 0.
	f = 0.
	y = +0.5
	call pgmtxt( 'T', y, x, f, legend )
* width
      else
	legend = legend(:ll-1)
	call append_i( legend, nint( dvfit ) )
* error bar
	call append( legend, '(' )
	call append_i( legend, nint( dv ) )
	call append( legend, '\(2233)' )
	call append_i( legend, nint( sv ) )
	call append( legend, ')' )
	call nospace( legend(ll:) )
* placement
	x = 0.03
	f = 0.
	if( j .eq. jvrms ) y = -1.5
	if( j .eq. jvmad ) y = -3.0
      if( j .eq. jfwhm .or. j .eq. jfwhm1 .or. j .eq. jfwhm2 ) then
	x = 0.97
	f = 1.
	if( j .eq. jfwhm ) y = -4.5
	if( j .eq. jfwhm1 ) y = -6.0
	if( j .eq. jfwhm2 ) y = -7.5
      end if
* write this line of the legend
	call pgmtxt( 'T', y, x, f, legend )

* centre
      if( j .eq. jvrms .or. j .eq. jvmad .or. j .eq. jfwhm ) then
	legend = title
	ll = len1( legend ) + 2
	call append_i( legend, nint( vfit ) )
* error bar
	call append( legend, '(' )
	call append_i( legend, nint( v0 ) )
	call append( legend, '\(2233)' )
	call append_i( legend, nint( sv0 ) )
	call append( legend, ')' )
	call nospace( legend(ll:) )
* placement
	x = 0.03
	f = 0.
	if( j .eq. jvrms ) y = -5.0
	if( j .eq. jvmad ) y = -6.5
	if( j .eq. jfwhm ) y = -8.0
	call pgmtxt( 'T', y, x, 0., legend )
      end if
      end if
	call pgsch( csize )

*---------------------------------------------
* vertical lines
      do jj = -1, 1
* left
      if( jj .eq. 1 ) then
	dv = dvhi
	sig = svhi
	y = y0
* right
      else if( jj .eq. -1 ) then
	dv = dvlo
	sig = svlo
	y = y0
* centre
      else
	dv = 0.
	sig = sv0
	y = ymx
	if( j .eq. jfwhm ) y = y0 + y0
      end if
* error bar
      do k = -1, 1
	x = v0 + dv + k * sig
	if( k .ne. 0 ) call pgsls( kdash )
	if( j .eq. jvwin ) call pgsls( kdot )
	call pgmove( x, ymn )
	call pgdraw( x, y )
	call pgsls( 1 )
      end do
      end do
*---------------------------------------------
* horizontal intervals
	x = v0
	call pgpt( 1, x, y0, isymb )
	if( j .eq. jfwhm ) call pgpt( 1, x, y0+y0, isymb )
	x = v0 + dvlo
	call pgpt( 1, x, y0, isymb )
	call pgmove( x, y0 )
	x = v0 + dvhi
	call pgdraw( x, y0 )
	call pgpt( 1, x, y0, isymb )

* pre-mcmc
      if( j .ne. jvwin ) then
	x = vfit
	call pgpt( 1, x, y0, isymb1 )
	x = vfit + dvlofit
	call pgpt( 1, x, y0, isymb1 )
	call pgmove( x, y0 )
	x = vfit + dvhifit
	call pgdraw( x, y0 )
	call pgpt( 1, x, y0, isymb1 )
      end if

* next j
      end do

* blends
	call pgsci( korange )
	call pgsls( kdot )
      do j = 1, markline
	w = rest_l( j )
	x = ckms * alog( w / w0 )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do
	call pgsls( 1 )
	call pgsci( kblack )

* end mcmc error bar calculation
      end if

* integer km/s velocities
	kvwin = nint( vwin )
	kvfwhm = nint( vfwhm )
	kvfwhm1 = nint( vfwhm1 )
	kvfwhm2 = nint( vfwhm2 )
	kvhw10 = nint( vhw10 )
	kvrms = nint( vrms )
	kvmad = nint( vmad )
	kvtop = nint( vtop )
	kvavg = nint( vavg )
	kvmed = nint( vmed )
* error bars
	ksigvfwhm = nint( sigvfwhm )
	ksigvfwhm1 = nint( sigvfwhm1 )
	ksigvfwhm2 = nint( sigvfwhm2 )
	ksigvhw10 = nint( sigvhw10 )
	ksigvrms = nint( sigvrms )
	ksigvmad = nint( sigvmad )
	ksigvtop = nint( sigvtop )
	ksigvavg = nint( sigvavg )
	ksigvmed = nint( sigvmed )
* clip range to prevent overflow
	k2 = 99999
	k1 = - k2
* no error bars
      if( ierbs .eq. 0 ) then
	write( record, '( 1x, f12.3, 1pe10.3, 3i7, 3i7, 2i7)' )
     &	rest, flx 
     &	, min( k2, max( k1, kvfwhm ) )
     &	, min( k2, max( k1, kvrms ) )
     &	, min( k2, max( k1, kvmad ) )
     &	, min( k2, max( k1, kvtop ) )
     &	, min( k2, max( k1, kvavg ) )
     &	, min( k2, max( k1, kvmed ) )
     &	, min( k2, max( k1, kvwin ) )
c     &	, min( k2, max( k1, kvhw10 ) )
* NLR with error bars
      else if( loop .eq. loopnlr ) then
	v2 = 9999.9
	v1 = -999.9
	write( record,
     &	'( 1x,f12.3, 1pe11.3,1pe11.2, 3(0pf7.1,f7.1), 3(i7,i7), 2i7 )' )
     &	rest, flx, sigflx
     &	, min( v2, max( v1, vfwhm ) )
     &	, min( v2, max( v1, sigvfwhm ) )
     &	, min( v2, max( v1, vrms ) )
     &	, min( v2, max( v1, sigvrms ) )
     &	, min( v2, max( v1, vmad ) )
     &	, min( v2, max( v1, sigvmad ) )
     &	, min( k2, max( k1, kvtop ) )
     &	, min( k2, max( k1, kvavg ) )
     &	, min( k2, max( k1, kvmed ) )
     &	, min( k2, max( k1, kvwin ) )
c     &	, min( k2, max( k1, kvhw10 ) )
* BLR with error bars
      else 
	write( record,
     & '( 1x,f12.3, 1pe11.3,1pe11.2, 3(i7,i7), 3(i7,i7), 2i7 )' )
     &	rest, flx, sigflx
     &	, min( k2, max( k1, kvfwhm ) )
     &	, min( k2, max( k1, ksigvfwhm ) )
     &	, min( k2, max( k1, kvrms ) )
     &	, min( k2, max( k1, ksigvrms ) )
     &	, min( k2, max( k1, kvmad ) )
     &	, min( k2, max( k1, ksigvmad ) )
     &	, min( k2, max( k1, kvtop ) )
     &	, min( k2, max( k1, kvavg ) )
     &	, min( k2, max( k1, kvmed ) )
     &	, min( k2, max( k1, kvwin ) )
c     &	, min( k2, max( k1, kvhw10 ) )
      end if
* write (header and) record
	if( kerb .eq. 1 ) write(*,*) header(:lh)
	lr = len1( record )
	write(*,*) record(:lr)
* next kerb
      end do
	write(*,*)

      end if
      end if
      end if
      end if
* next lrank
      end if
      end do

* next loop
      end do

* KDH : CLOSE PLOT OUTSIDE THE LOOP
* close the plot
	call pgstop
* plot again ?
	if( pgagain() ) goto 620

* next loop
C      end do

	goto 600

* end of PrepSpec
	END



************************************************************
	SUBROUTINE LOAD_KRISS( FILE, NWAVE, WAVE, DATA, SIGMA,
     #	EPSILON, HJD, TITLE )
*
* load IUE files from J.Kriss
* 2001 Aug KDH @ St.And - OPENFILE, real*8 hjd
* 2014 May KDH @ St.And - real*8 wave
	REAL*8 WAVE(*)
	REAL*4 DATA(*)
	REAL*4 SIGMA(*)
	REAL*4 EPSILON(*)
	REAL*8 HJD
	CHARACTER*(*) FILE
	CHARACTER*(*) TITLE
	CHARACTER*79 REPLY
	MAXWAVE = NWAVE
	IF( NWAVE.LE.0 ) RETURN

* close the file

      IF( IOPEN.GT.0 ) THEN
	CLOSE( UNIT=IOPEN )
	IOPEN = 0
      END IF

	CALL OPENFILE( 10, FILE, 'FORMATTED', 'OLD', IER )
	IF( IER .NE. 0 ) GOTO 10
C	OPEN( UNIT=10, NAME=FILE, FORM='FORMATTED', TYPE='OLD',
C     #	ERR=10, READONLY )
	IOPEN = 10

* header information

	READ( 10, '(A)', ERR=10 ) REPLY
	WRITE(*,*) REPLY
	TITLE = REPLY
	IDAY = INDEX( REPLY, 'day' )
	IF( IDAY.LE.7 ) GOTO 10
	IYR1 = IDAY - 7
	IYR2 = IDAY - 1
	IDY1 = IDAY + 3
	IDY2 = IDAY + 8
	ICOLON = INDEX( REPLY, ':' )
	IF( ICOLON.LE.2 ) GOTO 10
	IHR1 = ICOLON - 2
	IHR2 = ICOLON - 1
	IMN1 = ICOLON + 1
	IMN2 = ICOLON + 2
	WRITE(*,*) 'IYR=', REPLY(IYR1:IYR2), ' IDY=', REPLY(IDY1:IDY2),
     #	' IHR=', REPLY(IHR1:IHR2), ' IMN=', REPLY(IMN1:IMN2)
	READ( REPLY(IYR1:IYR2), *, ERR=10, end=10 ) IYR
	READ( REPLY(IDY1:IDY2), *, ERR=10, end=10 ) IDY
	READ( REPLY(IHR1:IHR2), *, ERR=10, end=10 ) IHR
	READ( REPLY(IMN1:IMN2), *, ERR=10, end=10 ) IMN
	WRITE(*,*) IYR, IDY, IHR, IMN
	JD = JDATE( 1, 1, IYR ) + IDY - 1 - 2440000
	HJD = JD + ( IMN / 60.D0 + IHR ) / 24.D0 - 0.5D0
	WRITE(*,*) 'HJD=', HJD

* skip 1 line

	READ( 10, '(A)', ERR=10 ) REPLY

* read the data
	NWAVE = 0
      DO I=1,MAXWAVE
   20	READ( 10, '(A)', ERR=20, END=30 ) REPLY
	J=NWAVE+1
	IER = 1
	READ( REPLY, *, ERR=40, end=40 )
     &		WAVE(J), DATA(J), SIGMA(J), EPSILON(J)
	NWAVE = NWAVE + 1
	IER = 0
* report error reading data
   40 IF( IER .NE. 0 ) THEN
	WRITE(*,*) 'BAD:', REPLY(:LEN1(REPLY))
	GOTO 20
      END IF
* next wavelength
      END DO

	write(*,*) '**'
	write(*,*) '** WARNING: MAX WAVELENGTHS', NWAVE, MAXWAVE
	write(*,*) '**'

* close the file

   30	CLOSE( UNIT=10 )
	IOPEN = 0
	RETURN


   10	NWAVE = 0
	RETURN
	END
*--------------------------------------------------
	subroutine makelegend( legend, npolyc, syserb )
	character*(*) legend
	character*70 number
* legend
	legend = ' '
      if( npolyc .gt. 0 ) then
	number = 'C'
	call append_i( number, npolyc )
	call nospace( number )
	call append( legend, number )
      end if
      if( syserb .gt. 0. ) then
	call append_n( legend, syserb, 2 )
	call append( legend, '%' )
	call nospace( legend( len1(legend)-2: ) )
      end if
	return
	end

*-----------------------------------------------
	subroutine rectify( nt, x_t, s_t, nw, x_w )
* shift and scale to normalise x_t to optimal mean 0 rms 1
* flip sign if necessary to keep x_w positive
* In:	nt	i4 number of times
*	x_t	r4 lightcurve
*	s_t	r4 error bar lightcurve
*	nw	i4 number of wavelengths
*	x_w	r4 spectrum
* Out:	x_t	r4 rescaled lightcurve (mean 0, rms 1)
*	s_t	r4 rescaled error bar lightcurve
*	x_w	r4 rescaled spectrum
* 2012 Jul Keith Horne @ SAAO
* 2012 Sep KDH @ StA - add s_t for optimal average
* 2018 Feb KDH @ StA - try avgrmsx -> optavgrms -> avgrms
* 2018 Feb KDH @ StA - call rectify1
	real*4 x_t( nt )
	real*4 s_t( nt )
	real*4 x_w( nw )
	real*8 sum, sum1
	if( nt .le. 0 ) return
	if( nw .le. 0 ) return
	normfull = 0
	normcen = 1
	norm = normfull
	call rectify1( nt, x_t, s_t, nw, x_w, norm )
	return
	end
*-----------------------------------------------
	subroutine rectify1( nt, x_t, s_t, nw, x_w, norm )
* shift and scale to normalise x_t to optimal mean 0 rms 1
* flip sign if necessary to keep x_w positive
* In:	nt	i4 number of times
*	x_t	r4 lightcurve
*	s_t	r4 error bar lightcurve
*	nw	i4 number of wavelengths
*	x_w	r4 spectrum
*	norm	i4 normalise option (0=full window, 1=centre)
* Out:	x_t	r4 rescaled lightcurve (mean 0, rms 1)
*	s_t	r4 rescaled error bar lightcurve
*	x_w	r4 rescaled spectrum
* 2012 Jul Keith Horne @ SAAO
* 2012 Sep KDH @ StA - add s_t for optimal average
* 2018 Feb KDH @ StA - try avgrmsx -> optavgrms -> avgrms
* 2018 Feb KDH @ StA - keep centre larger than wings
* 2018 Jul KDH @ StA - try medmad (problems with rms large noisy outliers)
* 2018 Jul KDH @ StA - correct mad bias <rms> = 1.4826 <mad>
	real*4 x_t( nt )
	real*4 s_t( nt )
	real*4 x_w( nw )
	real*8 sum, sum1
	logical usemedmad/.true./
* 2023 APR KDH : chibias_t and chibias_w have usemedmad/.false./
	if( nt .le. 0 ) return
	if( nw .le. 0 ) return

C	call avgrms( nt, x_t, a, r )
c	call optavgrms( nt, x_t, s_t, a, r )

* KDH : USE AVGRMSX ?  POOR - RMS IS TOO SMALL.
      IF( .FALSE. ) THEN
C      IF( .TRUE. ) THEN
	call avgrmsx( nt, x_t, s_t, good, a, r, siga, sigr )
* optavgrms if avgrmsx failed
      if( r .le. 0. .or. sigr .le. 0. ) then
	call optavgrms( nt, x_t, s_t, a, r )
      end if

* use med/mad (good if bias-corrected)
      ELSE IF( usemedmad ) then
	call medmad( nt, x_t, a, rmad )
* correct mad bias (<mad> is smaller than <rms>)
	call mad2rms( rmad, r )
* use optavgrms
      ELSE
	call optavgrms( nt, x_t, s_t, a, r )
      END IF

* revert to avgrms if needed
	if( r .le. 0. ) call avgrms( nt, x_t, a, r )
	if( r .le. 0. ) r = 1.

	sub = a
	div = r

* flip sign to keep avg (or med) of spectrum positive
      IF( norm .eq. 0 ) THEN
      if( usemedmad ) then
	call medmad( nw, x_w, a, r )
      else
	call avgrms( nw, x_w, a, r )
      end if

* KDH : WEIGHT TOWARD CENTRE OF WINDOW
*       USEFUL FOR LINE WINDOWS
      ELSE
	i1 = 0
	i2 = 0
* first non-zero flux
      do i = 1, nw
      if( i1 .le. 0 ) then
	if( x_w( i ) .ne. 0. ) i1 = i
      end if
      end do
* last non-zero flux
      do i = nw, 1, -1
      if( i2 .le. 0 ) then
	if( x_w( i ) .ne. 0. ) i2 = i
      end if
      end do
* trap zero
      if( i1 .le. 0 .or. i2 .le. 0 ) then
	a = 0.
      else
	cen = ( i2 + i1 ) / 2.
	wid = ( i2 - i1 + 1 ) / 4.
	sum = 0.d0
	sum1 = 0.d0
	n = 0
	n1 = 0
      do i = i1, i2
	x = ( i - cen ) / wid
      if( abs( x ) .le. 1. ) then
	sum  =  sum + x_w( i )
	n = n + 1
      else
	sum1 = sum1 + x_w( i )
	n1 = n1 + 1
      end if
      end do
	a = sum / max( 1, n ) - sum1 / max( 1, n1 )
      end if
      END IF

	if( a .lt. 0. ) div = - div
* avert divide by 0
	if( div .eq. 0. ) div = 1.

* shift and scale lightcurve
      do i = 1, nt
	x_t( i ) = ( x_t( i ) - sub ) / div
      end do
* scale spectrum
      do i=1,nw
	x_w( i ) = x_w( i ) * div
      end do

* verify
      IF( .FALSE. ) THEN
c      IF( .true. ) THEN
	call optavgrms( nt, x_t, s_t, a, r )
	if( r .le. 0. ) call avgrms( nt, x_t, a, r )
	write(*,*) 'rectified lightcurve avg', a, ' rms', r
	call avgrms( nw, x_w, a, r )
	write(*,*) 'rectified spectrum   avg', a, ' rms', r
      END IF

	return
	end

*=========================================================
	subroutine linestat1( n, w, f, good, flx, wavg, wrms,
     &		wmed, wmad, wtop, wlo, whi, wlo10, whi10 )
* measure a line profile
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	good(n)	l  line mask (.true. for included pixels) 
* Out:  flx	r4 integrated line flux (<0 for absn lines)
*	wavg	r4 mean wavelength
*	wrms	r4 rms
*	wmed	r4 median
*	wmad	r4 mean absolute deviation
*	wtop	r4 peak wavelength
*	wlo	r4 half-peak wavelength low
*	whi	r4 half-peak wavelength high
*	wlo10	r4 peak/10 wavelength low
*	whi10	r4 peak/10 wavelength high
* 2014 Jul Keith Horne @ St-Andrews
* 2014 Dec KDH @ St-And - add wtop, wlo, whi
* 2014 Apr/May KDH @ St-And - call linestat2
	real*4 w( n ), f( n )
	logical good( n )

	call linestat2( n, w, f, good, flx, wavg, wrms,
     &		wmed, wmad, wtop, wlo1, whi1, wlo2, whi2, wlo10, whi10 )
	wlo = ( wlo1 + wlo2 ) / 2.
	whi = ( whi1 + whi2 ) / 2.
	return
	end

*=========================================================
	subroutine linestat2( n, w, f, good, flx, wavg, wrms,
     &		wmed, wmad, wtop, wlo1, whi1, wlo2, whi2, wlo10, whi10 )
* measure a line profile
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	good(n)	l  line mask (.true. for included pixels) 
* Out:  flx	r4 integrated line flux (<0 for absn lines)
*	wavg	r4 mean wavelength
*	wrms	r4 rms
*	wmed	r4 median
*	wmad	r4 mean absolute deviation
*	wtop	r4 peak wavelength
*	wlo1,whi1	r4 wave range in which all pixels above peak/2.
*	wlo2,whi2	r4 wave range including all pixels above peak/2.
*	wlo10	r4 peak/10 wavelength low
*	whi10	r4 peak/10 wavelength high
* 2014 Jul Keith Horne @ St-Andrews
* 2014 Dec KDH @ St-And - add wtop, wlo, whi
* 2014 Apr/May KDH @ St-And - call more specific subroutines
* 2015 Jun KDH @ St-And - adapt from linestat1
* 2017 Oct KDH @ St-And - subtract rough linear continuum
* 2019 Mar KDH @ St-And - abort if ng = 0 or 1
	real*4 w( n ), f( n )
	logical good( n )

* KDH : CURRENT VERSION LARGELY IGNORES THE MASK :(
* KDH : NEED TO SANITY-CHECK CONTINUUM

* sanity check
	if( n .le. 0 ) goto 100
* line pixel range
	call linerange( n, f, good, ipm, itop, i1, i2 )

* warn if 0 or 1 pixels
	ng = i2 - i1 + 1
      if( ng .eq. 0 ) then
	write(*,*) '** WARNING IN LINESTAT2. I1,I2', i1, i2, 'npix', ng
	goto 100
      else if( ng .eq. 1 ) then
	write(*,*) '** WARNING IN LINESTAT2.', nint( w(i1) ), ' 1 pixel', i1
	goto 100
      end if

* fraction of window assumed continuum
	cfrac = 0.1	
      if( cfrac .gt. 0. ) then
	call linecont( n, f, i1, i2, c1, c2, cfrac )
* subtract continuum
* KDH : DANGER - SHOULD AVOID CHANGING INPUT F(N)
      do i = i1, i2
	p = real( i - i1 ) / max( 1, i2 - i1 )
	c = c1 * ( 1. - p ) + p * c2
	f( i ) = f( i ) - c
      end do
      end if

* line flux
	call lineflux( n, w, f, i1, i2, flx )
* note flx > 0 for emission, <0 for absorption
* KDH : THIS IS NOT CURRENTLY USED
	ipm = 1
	if( flx .lt. 0. ) ipm = -1

* mean and rms
	call lineavgrms( n, w, f, i1, i2, wavg, wrms )
* med and mad
	call linemedmad( n, w, f, i1, i2, wmed, wmad )
* peak flux and wavelength
	call linetop( n, w, f, i1, i2, peak, wtop )

* KDH : PEAK IS FOR PARABOLA FITTED TO TOP POINT AND NEIGHBORS
* CAUSES PROBLEMS IF TOO HIGH ABOVE PEAK VALUE.
	pk = abs( f( i1 ) )
      do i = i1, i2
	pk = max( pk, abs( f( i ) ) )
      end do
* width at peak / 2
	cut = pk / 2.
	call lineovercut2( n, w, f, i1, i2, cut, wlo1, whi1, wlo2, whi2 )
	wlo = ( wlo1 + wlo1 ) / 2.
	whi = ( whi1 + whi2 ) / 2.
* report problem with wlo,whi out of range
	nbad = 0
      if( wlo .lt. w( i1 ) .or. wlo .gt. w( i2 ) ) then
	nbad = nbad + 1
	write(*,*)
	write(*,*) '*** wlo', wlo, ' outside', w( i1 ), w( i2 ), ' :((('
	write(*,*) '*** wlo1', wlo1, ' wlo2', wlo2
      end if
      if( whi .lt. w( i1 ) .or. whi .gt. w( i2 ) ) then
	nbad = nbad + 1
	write(*,*) '*** whi', whi, ' outside', w( i1 ), w( i2 ), ' :((('
	write(*,*) '*** whi1', whi1, ' whi2', whi2
      end if
      if( nbad .ne. 0 ) then
	write(*,*) '** ERROR in LINESTAT2:'
	write(*,*) '*** i1', i1, ' itop', itop, ' i2', i2, ' n', n
	write(*,*) '*** peak', peak, ' half', peak/2., ' pk', pk, ' cut', cut
	write(*,*) '*** Data', ( f(i), i = i1, i2 )
	write(*,*) '*** Good', ( good(i), i = i1, i2 )
	write(*,*) '*** Wave', ( w(i), i = i1, i2 )
      end if

* width at peak / 10
	cut = pk / 10.
	call lineovercut ( n, w, f, i1, i2, cut, wlo10, whi10 )
	call lineovercut2( n, w, f, i1, i2, cut, wlo101, whi101, wlo102, whi102 )

* restore continuum
* KDH : DANGER - SHOULD AVOID CHANGING INPUT F(N)
      if( cfrac .gt. 0. ) then
      do i = i1, i2
	p = real( i - i1 ) / max( 1, i2 - i1 )
	c = c1 * ( 1. - p ) + p * c2
	f( i ) = f( i ) + c
      end do

      end if

* normal return
	return

* aborted return
  100	write(*,*) '** NO DATA IN LINESTAT2.', n, w(1), w(n)
	wavg = ( w( 1 ) + w( n ) ) / 2.
	wmed = wavg
	wrms = 0.
	wmad = 0.
	wtop = wavg
	wlo1 = wavg
	whi1 = wavg
	wlo2 = wavg
	whi2 = wavg
	wlo10 = wavg
	whi10 = wavg
	return
	end

*====================================================
	subroutine linerange( n, f, good, ipm, itop, i1, i2 )
* find top and range of line profile
* In:	n	i4 number of wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	good(n)	l  line mask (.true. for included pixels) 
* Out:	ipm	i4 +1/-1 for emission/absorption line
*	itop	i4 pixel at top of the line
*	i1,i2	i4 first and last pixel of line (0 if error)
* 2015 Apr Keith Horne @ St-And
* 2015 Jun KDH @ St-And - fix bug affecting ilo
	real*4 f( n )
	logical good( n )
* sanity check
	itop = ( n + 1 ) / 2
	i1 = 0
	i2 = 0
	if( n .le. 0 ) return
* find extrema
	ihi = 0
	ilo = 0
      do i = 1, n
      if( good( i ) ) then
      if( ihi .le. 0 ) then
	ihi = i
	ilo = i
      else
	if( f( i ) .gt. f( ihi ) ) ihi = i
	if( f( i ) .lt. f( ilo ) ) ilo = i
      end if
      end if
      end do
* abort if no data
	if( ihi .le. 0 ) return
	if( ilo .le. 0 ) return
* ipm = +1 for emission, -1 for absorption
	ipm = 1
	if( abs( f( ihi ) ) .lt. abs( f( ilo ) ) ) ipm = -1
* peak
	itop = ihi
	if( ipm .lt. 0 ) itop = ilo

* first non-positive pixel before the peak
	i1 = itop
      do i = itop, 1, -1
      if( good( i ) ) then
      if( f( i1 ) * ipm .gt. 0. ) then
      if( f( i  ) * ipm .gt. 0. ) then
	i1 = i
      end if
      end if
      end if
      end do
	i1 = max( i1 - 1, 1 )

* first non-positive pixel after the peak
	i2 = itop
      do i = itop, n
      if( good( i ) ) then
      if( f( i2 ) * ipm .gt. 0. ) then
      if( f( i  ) * ipm .gt. 0. ) then
	i2 = i
      end if
      end if
      end if
      end do
	i2 = min( i2 + 1, n )

	return
	end

* ================================================
	subroutine linecont( n, f, i1, i2, c1, c2, part )
* rough estimate of continuum at i1 and i2
* In:	n	i4 number of wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	i1,i2	i4 first and last pixels
*	part	r4 fraction of continuum pixels on each side
* Out:  c1,c2	r4 continuum at i1, i2
* 2017 Oct Keith Horne @ St-Andrews
	real*4 f( n )
* sanity check
	c1 = 0.
	c2 = 0.
	if( n .le. 0 ) return
	if( i1 .lt. 1 .or. i1 .gt. n .or. i2 .lt. i1 ) return
* pixels to average
	k = i2 - i1 + 1
	k = max( 1, nint( k * part ) )
	dp = ( k - 1 ) / 2.
* near i1
	call avgrms( k, f( i1 ), c1, rms )
	p1 = i1 + dp
* near i2
	i = i2 - k + 1
	call avgrms( k, f( i ), c2, rms )
	p2 = i2 - dp
* KDH : SUPPRESS SLOPE IF NOT SIGNIFICANT ?
* tweak
	slope = ( c2 - c1 ) / ( p2 - p1 )
	c1 = c1 - slope * dp
	c2 = c2 + slope * dp
	return
	end
* ================================================
	subroutine lineflux( n, w, f, i1, i2, flx )
* integrate line flux f(i) d(w(i))
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	i1,i2	i4 first and last pixels
* Out:  flx	r4 integrated line flux (<0 for absn lines)
* assumes flambda units
* 2015 Apr Keith Horne @ St-Andrews
	real*4 w( n ), f( n )
	real*8 sum
* sanity check
	flx = 0.
	if( n .le. 0 ) return
	if( i1 .lt. 1 .or. i1 .gt. n .or. i2 .lt. i1 ) return
	sum = 0.d0
      do i = i1, i2
* wavelength span
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
	sum = sum + f( i ) * dw
      end do
	flx = sum
	return
	end

* ================================================
	function sumflam( n, w, f, i1, i2 )
* integrate line flux f(i) d(w(i))
* In:	n	i4 number of wavelengths
*	w( n )	r8 wavelengths (A)
*	f( n )	r4 flambda (erg/cm2/s/A)
*	i1, i2	i4 first and last pixels
* Out:  sumflam	r4 flux (erg/cm2/s)
* 2016 Aug Keith Horne @ St-Andrews
	real*8 w( n )
	real*4 f( n )
	real*8 sum, dw
* sanity check
	sumflam = 0.
	if( n .le. 0 ) return
	if( i1 .lt. 1 .or. i1 .gt. n .or. i2 .lt. i1 ) return
	sum = 0.d0
      do i = i1, i2
* wavelength span
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
	sum = sum + f( i ) * dw
      end do
	sumflam = sum
	return
	end

* ================================================
	function sumfmjy( n, w, f, i1, i2 )
* integrate mJy spectrum
* In:	n	i4 number of wavelengths
*	w( n )	r8 wavelengths (A)
*	f( n )	r4 fnu (mJy)
*	i1, i2	i4 first and last pixels
* Out:  sumfmjy	r4 flux (erg/cm2/s)
* 2016 Aug Keith Horne @ St-Andrews
	real*8 w( n )
	real*4 f( n )
	real*8 sum, dw
	logical firstcall/.true./
      if( firstcall ) then
	firstcall = .false.
	c = cgs( 'C' )
	angst = cgs( 'ANGSTROM' )
	fmjy = cgs( 'MJY' )
	fac = ( fmjy * c ) / angst
      end if
* sanity check
	sumfmjy = 0.
	if( n .le. 0 ) return
	if( i1 .lt. 1 .or. i1 .gt. n .or. i2 .lt. i1 ) return
	sum = 0.d0
      do i = i1, i2
* wavelength span
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
* KDH : THIS MIGHT PREVENT OVERFLOW
	x = w( i1 ) / w( i )
	sum = sum + f( i ) * dw / x / x
      end do
	sumfmjy = sum * fac * w( i1 ) * w( i1 )
	return
	end

*===================================================
	subroutine lineavgrms( n, w, f, i1, i2, avg, rms )
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	i1,i2	i4 first and last pixel
* Out:	avg	r4 mean wavelength
*	rms	r4 rms
* 2015 Apr Keith Horne @ St-Andrews
	real*4 w( n ), f( n )
	real*8 sum, sum1, sum2
* sanity check
	avg = 0.
	rms = 0.
	if( n .le. 0 ) return
	if( i1 .ge. 1 .and. i1 .le. n ) avg = w( i1 )
	if( i2 .le. i1 ) return
* mean wavelength
	sum = 0.d0
	sum1 = 0.d0
      do i = i1, i2
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
	p = abs( f( i ) )
c	p = ipm * f( i )
	p = p * dw
	sum = sum + p
	sum1 = sum1 + p * w( i )
      end do
	if( sum .le. 0.d0 ) return
	avg = sum1 / sum
* standard (rms) deviation
* KDH : SHOULD DO THIS IN LOOP ABOVE
	sum2 = 0.d0
      do i = i1, i2
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
	p = abs( f( i ) )
c	p = ipm * f( i )
	p = p * dw
	e = w( i ) - avg
	sum2 = sum2 + p * e * e
      end do
	rms = dsqrt( sum2 / sum )
	return
	end

*==============================================
	subroutine linemedmad( n, w, f, i1, i2, wmed, wmad )
* line profile median and mean-absolute-deviation
* profile weight is abs( f(i) ) * dw(i)
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	i1,i2	i4 first and last pixel
* Out:	wmed	r4 median wavelength
*	wmad	r4 mean absolute deviation
* 2015 Apr Keith Horne @ St-Andrews
* 2015 Jun KDH @ St-A - more careful median
	real*4 w( n ), f( n )
	real*8 sum, sumw, half, wlo, whi
* sanity checks
	wmed = 0.
	wmad = 0.
	if( n .le. 0 ) return
	if( i1 .ge. 1 .and. i1 .le. n ) wmed = w( i1 )
* 1 pixel
	if( i2 .le. i1 ) return
* median
      do loop = 1, 2
	ih = 0
	sumw = 0.d0
* pixels
      do i = i1, i2
* pixel weight
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
	p = abs( f( i ) )
	wgt = p * dw
* cumulative sum (left and right edge)
	sum = sumw
	sumw = sumw + wgt
* find median on second loop
      if( loop .eq. 2 ) then
* pixels holding or crossing half
      if( sum .le. half .and. sumw .ge. half ) then
* midpoint of pixels holding half
	if( ih .le. 0 ) ih = i
	ihp = i
	wmed = ( w( ih ) + w( i ) ) / 2.
* crossing half within a pixel
      if( ih .eq. i .and. sumw .gt. sum ) then
	wlo = w( i ) - dw / 2
	whi = w( i ) + dw / 2
	x = ( half - sum ) / ( sumw - sum )
	wmed = wlo * ( 1. - x ) + x * whi
      end if
      end if
      end if
* next pixel i
      end do
	half = sumw / 2.d0
* next loop
      end do

* trap error
      if( wmed .lt. w( i1 ) .or. wmed .gt. w( i2 ) ) then
	write(*,*) '** ERROR IN LINEMEDMAD:'
	write(*,*) '** WMED', wmed, ' outside', w( i1 ), w( i2 )
	write(*,*) '** i1,ih,ihp,i2:', i1, ih, ihp, i2
	write(*,*) '** w(ih), x, w(ihp):', w( ih ), x, w( ihp )
	write(*,*) '** sumw, half', sumw, half
	write(*,*) '** Data:', (f(i),i=i1,i2)
      end if


* mean absolute deviation
	sum = 0.d0
	sumw = 0.d0
      do i = i1, i2
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
	p = abs( f( i ) )
	wgt = p * dw
      if( wgt .gt. 0. ) then
	x = abs( w( i ) - wmed )
* median within pixel
	if( x .lt. dw / 2. ) x = dw
	sum =  sum  + wgt * x
	sumw = sumw + wgt
      end if
      end do
	if( sumw .gt. 0.d0 ) wmad = sum / sumw
	return
	end

* =======================================
	subroutine linetopm( n, w, f, good, i1, i2, peak, wtop )
* find flux and wavelength at top of line profile 
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	good(n)	l  good data (.true. for included pixels) 
*	i1,i2	i4 first and last pixels
* Out:  peak	r4 peak flux
*	wtop	r4 mean wavelength of pixels at peak flux
* 2015 May Keith Horne @ St-Andrews
* 2017 Oct KDH @ STA - prevent wtop = NAN
	real*4 w( n ), f( n )
	logical good( n )
	real*8 sum
* sanity checks
	peak = 0.
	wtop = 0.
	if( n .le. 0 ) return
c      if( i1 .ge. 1 .and. i1 .le. n ) then
c	wtop = w( i1 )
c	peak = f( i1 )
c      end if
	if( i2 .le. i1 ) return
* find the peak
	peak = -1.
	nsum = 0
	ngood = 0
      do i = i1, i2
      if( good( i ) ) then
	ngood = ngood + 1
	p = abs( f( i ) )
      if( p .ge. peak ) then
      if( p .gt. peak ) then
	sum = 0.d0
	nsum = 0
	i0 = i
      end if
	peak = p
	sum = sum + w( i )
	nsum = nsum + 1
      end if
      end if
      end do
* mean wavelength of good peak data
	if( ngood .le. 0 ) return
* nsum should never be 0
      if( nsum .gt. 0 ) then
	wtop = sum / nsum
      else
	write(*,*) '** ERROR IN LINETOPM. NSUM', nsum
      end if
* if single pixel peak, parabola at peak
      if( nsum .eq. 1 ) then
      if( i0 .gt. i1 .and. i0 .lt. i2 ) then
	im = max( i0 - 1, i1 )
	ip = min( i0 + 1, i2 )
* require good data on both sides
      if( good( i1 ) .and. good( i2 ) ) then
	xm = w( im ) - w( i0 )
	xp = w( ip ) - w( i0 )
	ym = abs( f( im ) ) - peak
	yp = abs( f( ip ) ) - peak
	a = abs( f( i0 ) )
	b = ym * xp * xp - yp * xm * xm
	c = yp * xm - ym * xp
* should always have require negative curvature
      if( c .lt. 0. ) then
	x = - b / ( c + c )
	peak = a + ( b + c * x ) * x
	wtop = w( i0 ) + x
      else
	write(*,*) '** ERROR IN LINETOPM. C =', c, ' NOT < 0'
      end if
      end if
      end if
      end if

	return
	end
* =======================================
	subroutine linetop( n, w, f, i1, i2, peak, wtop )
* find flux and wavelength at top of line profile 
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	i1,i2	i4 first and last pixels
* Out:  peak	r4 peak flux
*	wtop	r4 mean wavelength of pixels at peak flux
* 2015 May Keith Horne @ St-Andrews
* 2017 Oct KDH @ StA - avoid wtop=NaN
	real*4 w( n ), f( n )
	real*8 sum
* sanity checks
	peak = 0.
	wtop = 0.
	if( n .le. 0 ) return
      if( i1 .ge. 1 .and. i1 .le. n ) then
	wtop = w( i1 )
	peak = f( i1 )
      end if
	if( i2 .le. i1 ) return
* find the peak
	peak = -1.
      do i = i1, i2
	p = abs( f( i ) )
      if( p .ge. peak ) then
      if( p .gt. peak ) then
	sum = 0.d0
	nsum = 0
	i0 = i
      end if
	peak = p
	sum = sum + w( i )
	nsum = nsum + 1
      end if
      end do
* avg wavelenth over nsum peak pixels
      if( nsum .gt. 0 ) then
	wtop = sum / nsum
      else
	write(*,*) '** ERROR IN LINETOP. NSUM', nsum
      end if

* 1-pixel peak, fit parabola at peak
      if( nsum .eq. 1 ) then
      if( i0 .gt. i1 .and. i0 .lt. i2 ) then
	im = max( i0 - 1, i1 )
	ip = min( i0 + 1, i2 )
	xm = w( im ) - w( i0 )
	xp = w( ip ) - w( i0 )
	ym = abs( f( im ) ) - peak
	yp = abs( f( ip ) ) - peak
	a = abs( f( i0 ) )
	b = ym * xp * xp - yp * xm * xm
      if( c .lt. 0. ) then
	c = yp * xm - ym * xp
	x = - b / ( c + c )
	peak = a + ( b + c * x ) * x
	wtop = w( i0 ) + x
      else
c	write(*,*) '** ERROR IN LINETOP. C =', c, ' NOT <0'
      end if
      end if
      end if

	return
	end

*==============================================
	subroutine lineovercutm( n, w, f, good, i1, i2, cut, wlo, whi )
* KDH - THIS SUBROUTINE IS NOT USED ?
* wavelength range with line flux above specified cut
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	good(n)	l  line mask (.true. for included pixels) 
*	i1,i2	i4 first and last pixels
*	cut	r4 threshold flux 
* Out:  wlo,whi	r4 wavelength interval in which all f(i) > cut.
* 2015 May Keith Horne @ St-Andrews
	real*4 w( n ), f( n )
	logical good( n )
* sanity check
	wlo = 0.
	whi = 0.
	if( n .le. 0 ) return
      if( i1 .ge. 1 .and. i1 .le. n ) then
      if( good( i1 ) .and. f( i1 ) .gt. cut ) then
	wlo = w( i1 )
	whi = wlo
      end if
      end if
	if( i2 .le. i1 ) return

* pixel range above cut
	ilo = n
	ihi = 1
	i0 = i1
      do i = i1, i2
      if( good( i ) ) then
	p = abs( f( i ) )
      if( p .ge. cut ) then
	ilo = min( ilo, i )
	ihi = max( ihi, i )
	if( p .gt. abs( f( i0 ) ) ) i0 = i
      end if
      end if
      end do
	if( ilo .gt. ihi ) return
	w1 = w( ilo )
	w2 = w( ihi )

* first pixels below cut on each side of peak
	jhi = 0
      do i = i0, i2
      if( jhi .eq. 0 ) then
	if( abs( f( i ) ) .ge. cut ) jhi = i
      end if
      end do

	jlo = 0
      do i = i0, i1, -1
      if( jlo .eq. 0 ) then
	if( abs( f( i ) ) .ge. cut ) jlo = i
      end if
      end do

	w1 = w( jlo )
	w2 = w( jhi )

* linear interpolation
      if( jlo .gt. i1 ) then
	j = jlo - 1
	p = abs( f( jlo ) )
	q = abs( f( j ) )
      if( p .ge. cut .and. q .le. cut ) then
      if( q .ne. p ) then
	p = ( cut - p ) / ( q - p ) 
      else
	p = 0.5
      end if
	w1 = w( jlo ) * ( 1. - p ) + p * w( j )
      end if
      end if

      if( jhi .lt. i2 ) then
	j = jhi + 1
	p = abs( f( jhi ) )
	q = abs( f( j ) )
      if( p .ge. cut .and. q .le. cut ) then
      if( q .ne. p ) then
	p = ( cut - p ) / ( q - p ) 
      else
	p = 0.5
      end if
	w2 = w( jhi ) * ( 1. - p ) + p * w( j )
      end if
      end if

* wlo < whi
	wlo = min( w1, w2 )
	whi = max( w1, w2 )
	return
	end

*==============================================
	subroutine lineovercut( n, w, f, i1, i2, cut, wlo, whi )
* wavelength range with line flux above specified cut
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	i1,i2	i4 first and last pixels
*	cut	r4 threshold flux 
* Out:  wlo,whi	r4 wavelength interval in which all f(i) > cut.
* 2015 May Keith Horne @ St-Andrews
* 2021 Mar KDH @ StA - abort on NAN
	real*4 w( n ), f( n )

* sanity check
	wlo = 0.
	whi = 0.
	if( n .le. 0 ) return

* 1 pixel
      if( i1 .ge. 1 .and. i1 .le. n ) then
      if( abs( f( i1 ) ) .ge. cut ) then
	wlo = w( i1 )
	whi = wlo
      end if
      end if
	if( i2 .le. i1 ) return

* pixel range above cut
	ilo = n
	ihi = 1
	i0 = i1
      do i = i1, i2
	p = abs( f( i ) )
      if( p .ge. cut ) then
	ilo = min( ilo, i )
	ihi = max( ihi, i )
	if( p .gt. abs( f( i0 ) ) ) i0 = i
      end if
      end do

      if( ilo .gt. ihi ) then
	write(*,*) '** NO DATA ABOVE CUT', cut, ' :((.'
	write(*,*) '** Pixels', i1, i2
	write(*,*) '** Wave', ( w(i), i = i1, i2 )
	write(*,*) '** Data', ( f(i), i = i1, i2 )
	wlo = 0.
	whi = 0.
	stop
c	return
      end if

	w1 = w( ilo )
	w2 = w( ihi )

* first pixels below cut on each side of peak
	jhi = i2
      do i = i0, i2
      if( jhi .ge. i2 ) then
	if( abs( f( i ) ) .lt. cut ) jhi = i
      end if
      end do

	jlo = i1
      do i = i0, i1, -1
      if( jlo .le. i1 ) then
	if( abs( f( i ) ) .lt. cut ) jlo = i
      end if
      end do

	w1 = w( jlo )
	w2 = w( jhi )

* linear interpolation
      if( jlo .gt. i1 ) then
	j = jlo + 1
	p = abs( f( jlo ) )
	q = abs( f( j ) )
      if( p .le. cut .and. q .ge. cut ) then
      if( q .ne. p ) then
	p = ( cut - p ) / ( q - p ) 
      else
	p = 0.5
      end if
	w1 = w( jlo ) * ( 1. - p ) + p * w( j )
      end if
      end if

      if( jhi .lt. i2 ) then
	j = jhi - 1
	p = abs( f( jhi ) )
	q = abs( f( j ) )
      if( p .le. cut .and. q. ge. cut ) then
      if( q .ne. p ) then
	p = ( cut - p ) / ( q - p ) 
      else
	p = 0.5
      end if
	w2 = w( jhi ) * ( 1. - p ) + p * w( j )
      end if
      end if

* wlo < whi
	wlo = min( w1, w2 )
	whi = max( w1, w2 )
	return
	end

*==============================================
	subroutine lineovercut2( n, w, f, i1, i2, cut, wlo1, whi1, wlo2, whi2 )
* wavelength range with line flux above specified cut
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	i1,i2	i4 first and last pixels
*	cut	r4 threshold flux 
* Out:  wlo1,whi1	r4 wavelength interval with f(i) > cut for all pixels.
*	wlo2,whi2	r4 wavelength interval including all pixels with f(i) > cut.
* 2015 Jun Keith Horne @ St-Andrews
	real*4 w( n ), f( n )

* sanity check
	wlo = 0.
	whi = 0.
	if( n .le. 0 ) return
* 1 pixel
      if( i1 .ge. 1 .and. i1 .le. n ) then
      if( abs( f( i1 ) ) .ge. cut ) then
	wlo = w( i1 )
	whi = wlo
      end if
      end if
	if( i2 .le. i1 ) return

* interval (ilo,ihi) includes all pixels above cut
	ilo = n
	ihi = 1
	i0 = i1
      do i = i1, i2
	p = abs( f( i ) )
      if( p .ge. cut ) then
	ilo = min( ilo, i )
	ihi = max( ihi, i )
	if( p .gt. abs( f( i0 ) ) ) i0 = i
      end if
      end do

      if( ilo .gt. ihi ) then
	write(*,*) '** NO DATA ABOVE CUT', cut, ' :((.'
	write(*,*) '** Data', ( f(i),i = i1, i2 )
	stop
c	return
      end if

	w1 = w( ilo )
	w2 = w( ihi )

* loop 1 finds outer limits
* loop 2 finds inner limits
      do loop = 1, 2

* first pixels below cut on each side of peak
	is = i0
	if( loop .eq. 2 ) is = ihi 
	jhi = i2
      do i = is, i2
      if( jhi .ge. i2 ) then
	if( abs( f( i ) ) .lt. cut ) jhi = i
      end if
      end do

	if( loop .eq. 2 ) is = ilo
	jlo = i1
      do i = is, i1, -1
      if( jlo .le. i1 ) then
	if( abs( f( i ) ) .lt. cut ) jlo = i
      end if
      end do

* sanity check
* KDH : IF OK, THEN JLO=MAX(I1,ILO-1) AND JHI=MIN(I2,IHI+1) ON LOOP 2.
      if( loop .eq. 2 ) then
      if( jlo .ne. max(i1,ilo-1) .or. jhi .ne. min(i2,ihi+1) )then
	write(*,*) '** ERROR: OUTER LIMIT MISMATCH :(((.'
	write(*,*) '** top', i0, ' full range', i1, i2
	write(*,*) '** left', jlo, ilo, ' right', ihi, jhi
	stop
      end if
      end if

	w1 = w( jlo )
	w2 = w( jhi )

* linear interpolation
      if( jlo .gt. i1 ) then
	j = jlo + 1
	p = abs( f( jlo ) )
	q = abs( f( j ) )
      if( p .le. cut .and. q .ge. cut ) then
      if( q .ne. p ) then
	p = ( cut - p ) / ( q - p ) 
      else
	p = 0.5
      end if
	w1 = w( jlo ) * ( 1. - p ) + p * w( j )
      end if
      end if

      if( jhi .lt. i2 ) then
	j = jhi - 1
	p = abs( f( jhi ) )
	q = abs( f( j ) )
      if( p .le. cut .and. q. ge. cut ) then
      if( q .ne. p ) then
	p = ( cut - p ) / ( q - p ) 
      else
	p = 0.5
      end if
	w2 = w( jhi ) * ( 1. - p ) + p * w( j )
      end if
      end if

* wlo < whi
      if( loop .eq. 1 ) then
	wlo1 = min( w1, w2 )
	whi1 = max( w1, w2 )
      else
	wlo2 = min( w1, w2 )
	whi2 = max( w1, w2 )
      end if

* next loop
      end do

* split the difference
	wlo = ( wlo1 + wlo2 ) / 2.
	whi = ( whi1 + whi2 ) / 2.

	return
	end


* ================================================
	subroutine linefluxm( n, w, f, good, i1, i2, flx )
* integrate line flux f(i) d(w(i))
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	good(n)	l  line mask (.true. for included pixels) 
*	i1,i2	i4 first and last pixels
* Out:  flx	r4 integrated line flux (<0 for absn lines)
* 2015 Apr Keith Horne @ St-Andrews
	real*4 f( n ), w( n )
	logical good( n )
	real*8 sum

* sanity check
	flx = 0.
	if( n .le. 0 ) return
	if( i1 .le. 0 .or. i2 .lt. i1 ) return

	sum = 0.d0
	nsum = 0
      do i = i1, i2
* wavelength span
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
* good f(i)
      if( good( i ) ) then
	p = f( i )
* bad f(i) - interpolate
      else
* find good fluxes at ip above and im below i
	kp = ip
	km = im
      do while ( kp .lt. n .and. ( .not. good( kp ) ) )
	kp = kp + 1
      end do
      do while ( km .gt. 1 .and. ( .not. good( km ) ) )
	km = km - 1
      end do
	f1 = f( km )
	f2 = f( kp )
* cut to 0 if no good fluxes found
      if( .not. good( km ) ) then
	km = im
	f1 = 0.
      end if
      if( .not. good( kp ) ) then
	kp = ip
	f2 = 0.
      end if
* interpolate f(w) across the gap
	p = ( w( i ) - w( km ) ) / ( w( kp ) - w( km ) )
	p = f1 * ( 1. - p ) + p * f2
      end if
* accumulate the sum
	sum = sum + p * dw
	nsum = nsum + 1
      end do
	flx = sum
	return
	end
*===================================================
	subroutine lineavgrmsm( n, w, f, good, i1, i2, avg, rms )
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	good(n)	l  line mask (.true. for included pixels) 
*	i1,i2	i4 first and last pixel
* Out:	avg	r4 mean wavelength
*	rms	r4 rms
* 2015 Apr Keith Horne @ St-Andrews
	real*4 w( n ), f( n )
	logical good( n )
	real*8 sum, sum1, sum2
* sanity check
	avg = 0.
	rms = 0.
	if( n .le. 0 ) return
      if( i1 .ge. 1 .and. i1 .le. n ) then
	if( good( i1 ) ) avg = w( i1 )
      end if
	if( i2 .le. i1 ) return
* mean wavelength
	sum = 0.d0
	sum1 = 0.d0
	nsum = 0
      do i = i1, i2
	ip = min( n, i + 1 )
	im = max( 1, i - 1 )
	dw = abs( w( ip ) - w( im ) ) / max( 1, ip - im )
      if( good( i ) ) then
	p = abs( f( i ) )
c	p = ipm * f( i )
	sum = sum + p
	sum1 = sum1 + p * w( i )
	nsum = nsum + 1
      end if
      end do
	if( nsum .le. 0 ) return
	if( sum .le. 0.d0 ) return
	avg = sum1 / sum
* standard (rms) deviation
* KDH : SHOULD DO THIS IN LOOP ABOVE
	sum2 = 0.d0
      do i = i1, i2
      if( good( i ) ) then
	p = abs( f( i ) )
c	p = ipm * f( i )
	e = w( i ) - avg
	sum2 = sum2 + p * e * e
      end if
      end do
	rms = dsqrt( sum2 / sum )
	return
	end

*==============================================
	subroutine linemedmadm( n, w, f, m, i1, i2, wmed, wmad )
* line median and mean-absolute-deviation
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
*	f(n)	r4 line flux profile (continuum subtracted)
*	good(n)	l  line mask (.true. for included pixels) 
*	i1,i2	i4 first and last pixel
* Out:	wmed	r4 median wavelength
*	wmad	r4 mean absolute deviation
* 2015 Apr Keith Horne @ St-Andrews
	real*4 w( n ), f( n )
	logical good( n )
	real*8 sum, sum1, half
* sanity check
	wmed = 0.
	wmad = 0.
	if( n .le. 0 ) return
      if( i1 .ge. 1 .and. i1 .le. n ) then
	if( good( i1 ) ) wmed = w( i1 )
      end if
	if( i2 .le. i1 ) return
* flux
* KDH : SHOULD DW BE PART OF THE WEIGHT ?
	sum = 0.d0
      do i = i1, i2
      if( good( i ) ) then
	p = abs( f( i ) )
	sum = sum + p
      end if
      end do
* median
	half = sum / 2.d0
	sum = 0.d0
	x = 1.
	ip = 0
      do i = i1, i2
      if( good( i ) ) then
	p = abs( f( i ) )
	sum = sum + p
      if( sum .lt. half ) then
	ihalf = i
* fractional pixel for more accuracy
      else if( ip .eq. 0 .and. p .gt. 0. ) then
	ip = i
	x = ( sum - half ) / p
      end if
      end if
      end do
	wmed = w( ihalf )
	if( ip .gt. 0 ) wmed = wmed * x + ( 1. - x ) * w( ip )

* mean absolute deviation
	sum = 0.d0
	sum1 = 0.d0
      do i = i1, i2
      if( good( i ) ) then
	p = abs( f( i ) )
	sum1 = sum1 + p * abs( w( i ) - wmed )
      end if
      end do
	wmad = sum1 / sum
	return
	end

*=========================================================
	subroutine linestat_mcmc( nw, w, f, s, good,
     &	 w0, mcmc, iseed, flx, sigflx,
     &	 wavg, sigwavg, wrms, sigwrms,
     &	 wmed, sigwmed, wmad, sigwmad,
     &	 wtop, sigwtop, wlo, sigwlo, whi, sigwhi,
     &	 wlo1, sigwlo1, whi1, sigwhi1,
     &	 wlo2, sigwlo2, whi2, sigwhi2,
     &	 wlo10, sigwlo10, whi10, sigwhi10 )
* line stats with mcmc error bars
* In:	nw	i4 number of wavelengths
*	w(nw)	r4 wavelengths
*	f(nw)	r4 line flux profile (continuum subtracted)
*	s(nw)	r4 1-sigma error bar on f(n)
*	good(nw)	l  line mask (.true. for included pixels) 
*	w0	r8 rest wavelength (v=0 at w=w0)
*	mcmc	i4 number of mcmc iterations (can be 0)
*	iseed	i4 random number seed
* Out:	iseed	i4 random number seed
*	mean over the mcmc samples for:
*	flx	r4 integrated line flux (<0 for absn lines)
*	wavg	r4 mean wavelength (velocity in km/s if w0>0)
*	wrms	r4 rms wavelength (velocity) about wavg
*	wmed	r4 median wavelength (velocity)
*	wmad	r4 mean absolute deviation about wmed
*	wtop	r4 mean wavelength (velocity) at peak
*	wlo	r4 lo wavelength (velocity) at half-peak
*	whi	r4 hi wavelength (velocity) at half-peak
*	wlo1,whi1	r4 interval with all pixels above peak/2
*	wlo2,whi2	r4 interval including all pixels above peak/2
*	wlo10	r4 lo wavelength (velocity) at peak/10
*	whi10	r4 hi wavelength (velocity) at peak/10
*	sig...	r4 rms of the above over the mcmc samples
* 2015 May Keith Horne @ St-Andrews
* 2015 Jun KDH @ StA - trap NaN
	real*4 w( nw ), f( nw ), s( nw )
	logical good( nw )

	parameter( maxw = 10000 )
	parameter( maxk = 14 )
	real*4 p( maxw ), fit( maxw )
	real*8 sum( maxk ), sum2( maxk )
	real*8 avg( maxk ), var, sig( maxk )
	integer*4 nsum( maxk )

	logical gabby/.false./
c	logical gabby/.true./

* first call
	logical firstcall/.true./
      if( firstcall ) then
* constants
	ckms = cgs( 'C' ) / cgs( 'KMS' )
* parameter key
	kflx = 1
	kavg = 2
	krms = 3
	kmed = 4
	kmad = 5
	ktop = 6
	klo = 7
	khi = 8
	klo10 = 9
	khi10 = 10
	klo1 = 11
	klo2 = 12
	khi1 = 13
	khi2 = 14
	firstcall = .false.
      end if

	if( gabby ) write(*,*) 'linestat_mcmc(', w0, mcmc, ' )'

* sanity check
	sigflx = -1.
	sigwavg = -1.
	sigwrms = -1.
	sigwmed = -1.
	sigwmad = -1.
	sigwtop = -1.
	sigwlo = -1.
	sigwhi = -1.
	sigwlo1 = -1.
	sigwhi1 = -1.
	sigwlo2 = -1.
	sigwhi2 = -1.
	sigwlo10 = -1.
	sigwhi10 = -1.


      if( nw .gt. maxw ) then
	write(*,*) '** ERROR linestat_mcmc nw', nw, ' max', maxw
	STOP
      end if

* fit spline to the line profile
	thrhi = 5.
	thrlo = -5.
	ncycle = 10
	blur = max( 3., nw / 15. )
	nspline = max( 1, nint( nw / blur ) )
	call splfita( nw, w, f, s, fit,
     &		nspline, ncycle, thrhi, thrlo, ifail )
	if( gabby )
     &	write(*,*) 'Data', nw, ' splines', nspline, ' ratio', real(nw)/nspline

* line stats
	call linestat1( nw, w, fit, good,
     &	 flx, wavg, wrms, wmed, wmad,
     &	 wtop, wlo, whi, wlo10, whi10 )

* debug report
	vtop = ckms * alog( wtop / w0 )
	vavg = ckms * alog( wavg / w0 )
	vmed = ckms * alog( wmed / w0 )

* report
      if( gabby ) then
	write(*,*) 'linestat1 results:'
	write(*,*) ' flux', flx, ' wavg', wavg, ' wrms', wrms
	write(*,*) ' wfwhm', whi-wlo, ' wmed', wmed, ' wmad', wmad
	write(*,*) ' vtop,avg,med', vtop, vavg, vmed
       end if

	call linestat2( nw, w, fit, good,
     &	 flx, wavg, wrms, wmed, wmad,
     &	 wtop, wlo1, whi1, wlo2, whi2, wlo10, whi10 )

* debug report
	vtop = ckms * alog( wtop / w0 )
	vavg = ckms * alog( wavg / w0 )
	vmed = ckms * alog( wmed / w0 )

* report
      if( gabby ) then
	write(*,*) 'linestat2 results:'
	write(*,*) ' flux', flx, ' wavg', wavg, ' wrms', wrms
	write(*,*) ' wfwhm', whi-wlo, ' wmed', wmed, ' wmad', wmad
	write(*,*) ' wfwhm1', whi1-wlo1, ' wfwhm2', whi2-wlo2
	write(*,*) ' vtop,avg,med', vtop, vavg, vmed
       end if

* no mcmc samples
      if( mcmc .le. 0 ) then
* wavelengths to velocities
      if( w0 .gt. 0. ) then
	wrms = ckms * alog( 1. + wrms / wavg )
	wmad = ckms * alog( 1. + wmad / wmed )
	wavg = ckms * alog( wavg / w0 )
	wmed = ckms * alog( wmed / w0 )
	wtop = ckms * alog( wtop / w0 )
	wlo =  ckms * alog(  wlo / w0 )
	whi1 =  ckms * alog(  whi1 / w0 )
	wlo1 =  ckms * alog(  wlo1 / w0 )
	whi2 =  ckms * alog(  whi2 / w0 )
	wlo2 =  ckms * alog(  wlo2 / w0 )
	whi =  ckms * alog(  whi / w0 )
	wlo10 = ckms * alog( wlo10 / w0 )
	whi10 = ckms * alog( whi10 / w0 )
      end if
	return
      end if

* no pixels
	if( nw .le. 0 ) return

* valid pixels
	i1 = nw + 1
	i2 = 0
	ng = 0
      do i = 1, nw
      if( good( i ) .and. w( i ) .gt. 0. .and. s( i ) .gt. 0. ) then
	i1 = min( i1, i )
	i2 = max( i2, i )
	ng = ng + 1
      end if
      end do
	ngw = i2 - i1 + 1

      if( ngw .lt. 1 ) then
	write(*,*) '** linestat_mcmc ngw', ngw
	return
      else if( ngw .gt. maxw ) then
	write(*,*) '** PANIC: TOO MANY PIXELS IN LINESTAT_MCMC. :((('
	write(*,*) '** Nw', nw, ' good', ng, ' of', ngw, ' max', maxw
	stop
      end if
	ngw = min( maxw, ngw )
	i2 = i1 + ngw - 1

* overflow check
	nk = 14
      if( nk .gt. maxk ) then
	write(*,*) '** ERROR : OVERFLOW IN LINESTAT_MCMC', NK, MAXK
	STOP
      end if

* zero sums
	nk = min( nk, maxk )
      do k = 1, nk
	sum( k ) = 0.d0
	sum2( k ) = 0.d0
	nsum( k ) = 0
      end do

* mcmc loop
      do j = 1, mcmc
	jgabby = mod( j, mcmc/5 )

* report
      if( gabby .and. jgabby .eq. 0 ) then
	write(*,*) 'MCMC sample:', j, ' of', mcmc
      end if

* perturbed spectrum
	n = 0
      do i = i1, i2
	n = n + 1
	r = rang( 0., 1., iseed )
	p( n ) = f( i ) + s( i ) * r
c	p( n ) = rang( f( i ), s( i ), iseed )
* KDH : DEBUG REPORT
      if( gabby .and. jgabby .eq. 0 ) then
      if( mod( n, max( 1, (i2-i1)/5 ) ) .eq. 0 ) then
	write(*,*) n, f(i), ' +/-', s(i), ' =>', p(i)
	write(*,*) n, ' r', r, ' iseed', iseed
      end if
      end if
      end do
* spline fit
	call splfita( n, w( i1 ), p, s( i1 ), fit,
     &		nspline, ncycle, thrhi, thrlo, ifail )

* line stats on perturbed spectrum
	call linestat2( n, w( i1 ), fit, good( i1 ),
     &		flx, wavg, wrms, wmed, wmad,
     &		wtop, wlo1, whi1, wlo2, whi2, wlo10, whi10 )
	wlo = ( wlo1 + wlo2 ) / 2.
	whi = ( whi1 + whi2 ) / 2.

* report
      if( gabby .and. jgabby .eq. 0 ) then
c	write(*,*) 'MCMC sample:', j, ' of', mcmc
	write(*,*) ' flux', flx, ' avg', wavg, ' rms', wrms
	write(*,*) ' fwhm', whi-wlo, ' med', wmed, ' mad', wmad
      end if

* report problems
	ibad = 0
* lower half-width out of range
      if( wlo .lt. w( i1 ) .or. wlo .gt. w( i2 ) ) then
	ibad = ibad + 1
	write(*,*) '** WLO', wlo, ' outside', w(i1), w(i2), ' :(((('
      end if
* upper half-width out of range
      if( whi .lt. w( i1 ) .or. whi .gt. w( i2 ) ) then
	ibad = ibad + 1
	write(*,*) '** WHI', whi, ' outside', w(i1), w(i2), ' :(((('
      end if
      if( ibad .gt. 0 ) then
	call mnmx( n, p, pmn, pmx )
	call lineovercut( n, w(i1), fit, 1, n, pmx/2., wlo, whi )
	call lineovercut2( n, w(i1), fit, 1, n, pmx/2., wlo1, whi1, wlo2, whi2 )
	write(*,*) '** PEAK', pmx, ' HALF', pmx/2.
	write(*,*) '** lineovercut : ', wlo, whi
	write(*,*) '** lineovercut2 : ', wlo2, wlo1, whi2, whi1
      end if
* median out of range
      if( wmed .lt. w( i1 ) .or. wmed .gt. w( i2 ) ) then
	ibad = ibad + 1
	write(*,*) '** WMED', wmed, ' outside', w(i1), w(i2), ' :(((('
      end if
* mad out of range
	wide = w( i2 ) - w( i1 )
      if( wmad .gt. wide ) then
	ibad = ibad + 1
	write(*,*) '** WMAD', wmad, ' exceeds', wide, ' :(((('
      end if
      if( ibad .gt. 0 ) then
	write(*,*) '** Wave', ( w(i), i = i1, i2 )
	write(*,*) '** Data', ( p(i), i = 1, n )
	write(*,*) '**  Fit', ( fit(i), i = 1, n )
	write(*,*) '** Good', ( good(i), i = i1, i2 )
      end if

* wavelengths to velocities
      if( w0 .gt. 0. ) then
	wrms = ckms * alog( 1. + wrms / wavg )
	wmad = ckms * alog( 1. + wmad / wmed )
	wavg = ckms * alog( wavg / w0 )
	wmed = ckms * alog( wmed / w0 )
	wtop = ckms * alog( wtop / w0 )
	wlo =  ckms * alog(  wlo / w0 )
	whi1 =  ckms * alog(  whi1 / w0 )
	wlo1 =  ckms * alog(  wlo1 / w0 )
	whi2 =  ckms * alog(  whi2 / w0 )
	wlo2 =  ckms * alog(  wlo2 / w0 )
	whi =  ckms * alog(  whi / w0 )
	wlo10 = ckms * alog( wlo10 / w0 )
	whi10 = ckms * alog( whi10 / w0 )
      end if

* accumulate sums
      do k = 1, nk
	if( k .eq. kflx ) add = flx
	if( k .eq. kavg ) add = wavg
	if( k .eq. krms ) add = wrms
	if( k .eq. kmed ) add = wmed
	if( k .eq. kmad ) add = wmad
	if( k .eq. ktop ) add = wtop
	if( k .eq. klo )  add = wlo
	if( k .eq. khi )  add = whi
	if( k .eq. klo1 )  add = wlo1
	if( k .eq. khi1 )  add = whi1
	if( k .eq. klo2 )  add = wlo2
	if( k .eq. khi2 )  add = whi2
	if( k .eq. klo10 ) add = wlo10
	if( k .eq. khi10 ) add = whi10
* trap NaN
      if( add + 1. .eq. add ) then
	write(*,*) '** NaN in linestat_mcmc k=', k, add
	write(*,*) '** Wave', ( w(i), i = i1, i2 )
	write(*,*) '** Data', ( p(i), i = 1, n )
	write(*,*) '**  Fit', ( fit(i), i = 1, n )
	write(*,*) '** Good', ( good(i), i = i1, i2 )
      else
	nsum( k ) = nsum( k ) + 1
	 sum( k ) =  sum( k ) + add
	sum2( k ) = sum2( k ) + add * add
      end if
      end do
* next mcmc sample
      end do
* sample mean and rms
      do k = 1, nk
	n = nsum( k )
	avg( k ) = sum( k ) / max( 1, n )
	var = ( sum2( k ) - sum( k ) * avg( k ) ) / max( 1, n-1 )
	sig( k ) = dsqrt( max( 0.d0, var ) )
      end do
* stow
	flx = avg( kflx )
	wavg = avg( kavg )
	wrms = avg( krms )
	wmed = avg( kmed )
	wmad = avg( kmad )
	wtop = avg( ktop )
	wlo  = avg( klo )
	whi  = avg( khi )
	wlo1  = avg( klo1 )
	whi1  = avg( khi1 )
	wlo2  = avg( klo2 )
	whi2  = avg( khi2 )
	wlo10 = avg( klo10 )
	whi10 = avg( khi10 )
* error bars
	sigflx = sig( kflx )
	sigwavg = sig( kavg )
	sigwrms = sig( krms )
	sigwmed = sig( kmed )
	sigwmad = sig( kmad )
	sigwtop = sig( ktop )
	sigwlo  = sig( klo )
	sigwhi  = sig( khi )
	sigwlo1  = sig( klo1 )
	sigwhi1  = sig( khi1 )
	sigwlo2  = sig( klo2 )
	sigwhi2  = sig( khi2 )
	sigwlo10 = sig( klo10 )
	sigwhi10 = sig( khi10 )

	sigfwhm = sqrt( sighi * sighi + sigwlo * sigwlo )
	if( sigwhi .le. 0. .or. sigwlo .le. 0. ) sigfwhm = - sigfwhm
	sigfwhm1 = sqrt( sighi1 * sighi1 + sigwlo1 * sigwlo1 )
	if( sigwhi1 .le. 0. .or. sigwlo1 .le. 0. ) sigfwhm1 = - sigfwhm1
	sigfwhm2 = sqrt( sighi2 * sighi2 + sigwlo2 * sigwlo2 )
	if( sigwhi2 .le. 0. .or. sigwlo2 .le. 0. ) sigfwhm2 = - sigfwhm2

* report
      if( gabby ) then
	write(*,*) 'MCMC avg of', mcmc
	write(*,*) ' flux', flx, ' avg', wavg, ' rms', wrms
	write(*,*) ' fwhm', whi-wlo, ' med', wmed, ' mad', wmad
	write(*,*) 'MCMC rms of', mcmc
	write(*,*) ' flux', sigflx, ' avg', sigwavg, ' rms', sigwrms
	write(*,*) ' fwhm', sigfwhm, ' med', sigwmed, ' mad', sigwmad
      end if
	return
	end

*=========================================================
        subroutine markdips( n, ltype_l, w_l, ymn, ymx, z )
* mark the absorption lines on the plot
* In:	n	i4 number of lines
*	ltype_l	i4 line types
*	w_l	r8 wavelengths
*	ymn	r4 window bottom
*	ymx	r4 window top
*	z	r4 redshift
* 2014 Aug Keith Horne @ St Andrews
        real*8 w_l( n )
        integer*4 ltype_l( n )
        ltype_galactic = 1
        ltype_intrinsic = 2
	kolor_galactic = 2
	kolor_intrinsic = 4
	opz = 1. + z
        dy = ( ymx - ymn ) * 0.05
* mark lines
      do i = 1, n
        ltype = ltype_l( i )
* colour
        k = 1
        if( ltype .eq. ltype_intrinsic ) k = kolor_intrinsic
        if( ltype .eq. ltype_galactic ) k = kolor_galactic
        call pgsci( k )
* top of mark
        x = w_l( i ) / opz
        y = ymx - dy - dy
        if( ltype .eq. ltype_intrinsic ) y = y - dy
        call pgmove( x, y )
* bottom of mark
        y = y - dy
        call pgdraw( x, y )
      end do
        call pgsci( 1 )
        return
        end

*=========================================================
	real*4 function odlines( w, n, w_l, s_l, t_l, ltype_l, ltype )
* sum gaussian lines to obtain line optical depth
* In	w	r8 observed wavelength (A)
*	n	i4 number of lines
*	w_l(n)	r8 observed line-centre wavelengths (A)
*	s_l(n)	r4 observed velocity dispersions (km/s)
*	t_l(n)	r4 line-centre optical depths
*	ltype_l(n) i4 line types
*	ltype	i4 line type to include
* Out:	odlines	r4 optical depth
* 2014 Aug Keith Horne @ St Andrews
	real*8 x, sum, w, w_l( n )
	real*4 s_l( n ), t_l( n )
	integer*4 ltype_l( n )
	logical firstcall/.true./
      if( firstcall ) then
	ckms = cgs( 'C' ) / cgs( 'KMS' )
	firstcall = .false.
      end if
	odlines = 0.
	big = 10.
      if( n .gt. 0 ) then
	sum = 0.d0
      do i = 1, n
      if( ltype_l( i ) .eq. ltype ) then
	x = ckms * dlog( w / w_l( i ) ) / s_l( i )
      if( abs( x ) .lt. big ) then
	sum = sum + t_l( i ) * dexp( -0.5d0 * x * x )
      end if
      end if
      end do
	odlines = sum
      end if
	return
	end
*=================================================
	real*4 function odlya( w, rest, v1, tau0 )
* damped ly-alpha optical depth
* In:	w	r8 wavelength
*	rest	r8 rest wavelength
*	v1	r4 velocity where tau=1
*	tau0	r4 line centre optical depth
* Out:	odlya	r4 optical depth
* 2014 Aug Keith Horne @ St Andrews
	real*8 w, rest
	logical firstcall/.true./
      if( firstcall ) then
	ckms = cgs( 'C' ) / cgs( 'KMS' )
	firstcall = .false.
      end if
	vv1 = v1 * v1
	vv0 = vv1 / ( tau0 - 1. )
	v = ckms * dlog( w / rest )
	odlya = ( vv0 + vv1 ) / ( vv0 + v*v )
	return
	end

*===========================================================
	subroutine odspec( nw, w8_w, od_w, z,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l,
     &		ltype_l, ltype )
* evaluate optical depth spectrum for specified line type
* In	nw	i4 number of wavelengths
*	w8_w(nw)	r8 rest wavelengths (A)
*	z	r8 redshift
*	nl	i4 number of lines
*	i1_l(nl)	i4 first wavelength pixel 
*	i2_l(nl)	i4 last wavelength pixel
*	wobs_l(nw)	r8 wavelengths (A)
*	tau0_l(nw)	r4 line-centre optical depth
*	sigv_l(nw)	r4 observed velocity dispersion (km/s)
*	ltype_l(nl)
* Out	od_w(nw)	r4 optical depth spectrum
* 2014 Aug Keith Horne @ St-Andrews

	real*8 w8_w( nw ), wobs_l( nl )
	real*4 od_w( nw )
	real*4 sigv_l( nl ), tau0_l( nl )
	integer*4 i1_l( nl ), i2_l( nl ), ltype_l( nl )
	real*8 z, w, wobs, opz, sum

	write(*,*) '** odspec Nw', nw, ' Nl', nl, ' ltype', ltype

	ckms = cgs( 'C' ) / cgs( 'KMS' )
	opz = 1.d0 + z
      do iw = 1, nw
	od_w( iw ) = 0.
	w = w8_w( iw ) * opz
	sum = 0.d0
      do k = 1, nl
	l = ltype_l( k )
      if( l .eq. ltype ) then
	i1 = i1_l( k )
	i2 = i2_l( k )
      if( iw .ge. i1 .and. iw .le. i2 ) then
	wobs = wobs_l( k )
	t = tau0_l( k )
	s = sigv_l( k )
	x = ckms * dlog( w / wobs ) / s
	sum = sum + t * exp( -0.5 * x * x )
      end if
      end if
* next line
      end do
	od_w( iw ) = sum
* next wavelength iw
      end do

* DEBUG REPORT
	call mnmx( nw, od_w, omn, omx )
	write(*,*) ' optical depths', omn, omx

	return
	end

c	call linespans( nw, w_w, zshift,
c     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l )
* ==========================================
	subroutine linespans( nw, w_w, z,
     &		nl, i1_l, i2_l, wobs_l, sigv_l, tau0_l )
* deterime pixel ranges affected by absorpton lines
* In:	nw	i4 number of wavelengths
*	w_w(nw)	r4 rest wavelengths (redshift z)
*	z	r8 redshift
*	nl	i4 number of lines
*	wobs_l(nl)	r8 observed wavelength
*	sigv_l(nl)	r4 velocity dispersion
*	tau0_l(nl)	r4 line-centre optical depth
* Out	i1_l(nl) i4 first pixel
*	i2_l(nl) i4 last pixel
* 2014 Aug Keith Horne @ St-And
	real*4 w_w( nw )
	real*8 wobs_l( nl )
	integer*4 i1_l( nl ), i2_l( nl )
	real*8 wobs, w, opz, z
	real*4 sigv_l( nl ), tau0_l( nl )
	logical firstcall/.true./

	write(*,*) '** linespans Nw', nw, ' Nl', nl

	opz = 1.d0 + z
	ckms = cgs( 'C' ) / cgs( 'KMS' )
* lines
	ng = 0
      do k = 1, nl
	w = wobs_l( k ) / opz
	s = sigv_l( k ) / ckms / opz
	t = tau0_l( k )
	call linespan( nw, w_w, w, s, t, i1, i2 )
	i1_l( k ) = i1
	i2_l( k ) = i2
* active lines
      if( i1 .ge. 1 .and. i2 .ge. i1 .and. i2 .le. nw ) then
	ng = ng + 1
* report
	if( firstcall ) write(*,*) k, real(w), i1, i2, w_w(i1), w_w(i2)
      else if( firstcall ) then
	write(*,*) k, real(w), i1, i2
      end if
* next line
      end do
	if( firstcall ) write(*,*) 'Active lines:', ng
	firstcall = .false.
	return
	end
* ==============================================
	subroutine linespan( nw, w_w, w, s, t, i1, i2 )
* pixel range affected by an absorpton line
* In:	nw	i4 number of wavelengths
*	w_w	r4 wavelengths
*	w	r8 line centre wavelength
*	s	r4 velocity dispersion / light speed
*	t	r4 line-centre optical depth
* Out:	i1	i4 first pixel in line window (0 if out of range)
*	i2	i4 last pixel in line window (0 if out of range)
* 2014 Aug Keith Horne @ St-Andrews
	real*4 w_w( nw )
	real*8 w, v
	bigx = 3.
	if( t .gt. 1. ) bigx = 3. * max( 1., sqrt( alog( t ) ) )
	v = s * bigx
	w1 = w * dexp( -v )
	w2 = w * dexp( +v )
      if( w2 .lt. w_w(1) .or. w1 .gt. w_w(nw) ) then
	i1 = 0
	i2 = 0
      else
	call lookup( nw, w_w, w1, i1, i, p )
	call lookup( nw, w_w, w2, i, i2, p )
      end if
	return
	end

c	call fitaline2( n, w8_w(i1), datdim_w(i1), sigdim_w(i1),
c     &          wobs, sigv, tau0, sigsigv, sigtau0, cor )
*==============================================================
        subroutine fitaline2( n, wav, dat, sig,
     &          w0, sigv, tau0, sigsigv, sigtau0, cor )
* Fit absorption line velocity dispersion and optical depth
* In:   n       i4 number of data
*       wav(n)  r8 wavelengths (A)
*       dat(n)  r4 spectrum / continuum - fit
*       sig(n)  r4 1-sigma error bar (<0 to skip)
*       w0      r8 line centre wavelength (A)
*       sigv    r4 velocity dispersion (km/s)
*       tau0    r4 line centre optical depth
* Out:  sigv    r4 velocity dispersion (km/s)
*       tau0    r4 line centre optical depth
*       sigsigv r4 1-sigma error bar
*       sigtau0 r4 1-sigma error bar
*       cor     r4 correlation coefficient
* 2014 Aug Keith Horne @ St-Andrews
        real*8 w0, wav( n )
        real*4 dat( n ), sig( n )
        real*8 sum, det
        real*8 sumdt, sumds, sumtt, sumss, sumts

        logical firstcall/.true./
      if( firstcall ) then
        ckms = cgs( 'C' ) / cgs( 'KMS' )
        firstcall = .false.
      end if

* sanity check
	sigsigv = -1.
	sigtau0 = -1.
	cor = 0.
      if( n .le. 0 ) then
	write(*,*) '** fitaline2 NO DATA for line', real(w0), ':((('
	write(*,*) 'tau0', tau0, ' sigv', sigv
	return
      end if

* average sigmas (for safer scaling)
	sum = 0.d0
	ng = 0
      do i = 1, n
	s = sig( i )
      if( s .gt. 0. ) then
	ng = ng + 1
	sum = sum + s
      end if
      end do
	s0 = sum / max( 1, ng )

* DEBUG REPORT
      if( ng .le. 0 ) then
	write(*,*) '** fitaline2 NO DATA for line', real(w0), ':((('
	write(*,*) ' tau0', tau0, ' sigv', sigv
	write(*,*) ' lam', wav(1), wav(n)
	call mnmx( n, dat, dmn, dmx )
	call mnmx( n, sig, smn, smx )
	write(*,*) ' dat', dmn, dmx
	write(*,*) ' sig', smn, smx
	write(*,*) 'Good sigmas', ng, ' of', n
	return
      end if

* 2x2 regression fit for steps dlntau0 and dlnsigv
        sumdt = 0.d0
        sumds = 0.d0
        sumtt = 0.d0
        sumss = 0.d0
        sumts = 0.d0
        ng = 0
      do i = 1, n
        s = sig( i )
      if( s .gt. 0. ) then
        d = dat( i )
        w = s0 / s
	w = w * w
        x = ( ckms / sigv ) * dlog( wav( i ) / w0 )
        xx = x * x
        od = tau0 * exp( - 0.5 * xx )
        f = exp( - od )
        pt = - f * od
        ps = - f * od * xx
        sumdt = sumdt + w * pt * d
        sumds = sumds + w * ps * d
        sumtt = sumtt + w * pt * pt
        sumss = sumss + w * ps * ps
        sumts = sumts + w * pt * ps
        ng = ng + 1
      end if
      end do
        det = sumtt * sumss - sumts * sumts
* DEBUG REPORT
      if( ng .le. 0 .or. det .eq. 0. ) then
	write(*,*) '** fitaline2 NO DATA for line', real(w0), ':((('
	write(*,*) ' tau0', tau0, ' sigv', sigv
	write(*,*) ' lam', wav(1), wav(n)
	call mnmx( n, dat, dmn, dmx )
	call mnmx( n, sig, smn, smx )
	write(*,*) ' dat', dmn, dmx
	write(*,*) ' sig', smn, smx
	write(*,*) 'Good sigmas', ng, ' of', n
	if( smx .le. 0. ) write(*,*) '** NO POSITIVE SIGMAS :((('

	write(*,*) ' Det', det
	write(*,*) real(sumtt), real(sumts), real( sumdt )
	write(*,*) real(sumts), real(sumss), real( sumds )
      else
        sumss = sumss / det
        sumtt = sumtt / det
        sumts = sumts / det
      end if
        dlnt = sumdt * sumss - sumds * sumts
        dlns = sumds * sumtt - sumdt * sumts
        siglnt = dsqrt( sumss )
        siglns = dsqrt( sumtt )
        cov = - sumts
	cor = cov
        if( siglnt .gt. 0. ) cor = cov / siglnt / siglns


* update parameters
        tau0 = tau0 * exp( dlnt )
        sigv = sigv * exp( dlns )
        sigtau0 = s0 * tau0 * siglnt
        sigsigv = s0 * sigv * siglns

        return
        end

c        snr = snr_aline( n, w8_w(i1), sigdim_w(i1), wobs, sigv, tau0 )
*=======================================
        function snr_aline( n, wav, sig, wobs, sigv, tau0 )
* S/N ratio for detection of an absorption line
* In:   n       i4 number of wavelengths
*       wav(n)  r8 wavelengths
*       sig(n)  r4 1-sigma errors on spectrum/continuum
*       wobs      r8 line-centre wavelength
*       sigv    r4 velocity dispersion (km/s)
*       tau0    r4 line-centre optical depth
* Out:  snr_aline       r4 S/N ratio
* 2014 Aug Keith Horne @ St-Andrews
        real*8 wav( n )
        real*4 sig( n )
        real*8 wobs, sum
        logical firstcall/.true./
      if( firstcall ) then
        ckms = cgs( 'C' ) / cgs( 'KMS' )
        firstcall = .false.
      end if
        sum = 0.d0
	nsum = 0
      do i = 1, n
        s = sig( i )
      if( s .gt. 0. ) then
        x = ( ckms / sigv ) * dlog( wav( i ) / wobs )
        od = tau0 * exp( - 0.5 * x * x )
        x = ( exp( - od ) - 1. ) / s
        sum = sum + x * x
	nsum = nsum + 1
      end if
      end do
        snr_aline = dsqrt( sum )

      if( nsum .le. 0 .or. sum .le. 0.d0 ) then
	write(*,*) '** ABSOPRTION LINE S/N FAILED :((('
	write(*,*) '** snr_aline nw=', n, ' nsum=', nsum, ' :(((.'
	call mnmx( n, sig, smn, smx )
	write(*,*) '** wav', real( wav(1) ), real( wav(n) )
	write(*,*) '** sig', smn, smx
	write(*,*) '** wav0', real( wobs ), ' sigv', sigv, ' tau0', tau0
      end if

        return
        end

*================================
	subroutine plotlabel_wave( label, zshift )
* construct plot label for wavelengths
* In:	timebase	c*  timebase, e.g 'HJD' or 'MJD' 
*	jdsub	i4 days subtracted
* Out:	label	c* label
* 2018 Aug Keith Horne @ St Andrews
	character*(*) label
	real*8 zshift
	label = '\gl (\A)'
      if( zshift .gt. 0 ) then
	label = '\gl (\A) for z ='
	call append_f( label, real(zshift), '(f10.5)' )
      end if
	return
	end
*================================
	subroutine textlabel_wave( label, zshift )
* construct text label for wavelengths
* In:	timebase	c*  timebase, e.g 'HJD' or 'MJD' 
*	jdsub	i4 days subtracted
* Out:	label	c* label
* 2018 Aug Keith Horne @ St Andrews
	character*(*) label
	real*8 zshift
	label = 'Wavelength (A)'
      if( zshift .gt. 0 ) then
	label = 'Restframe Wavelength (A) for z ='
	call append_f( label, real(zshift), '(f10.5)' )
      end if
	return
	end
*================================
	subroutine label_time( label, timebase, jdsub )
* construct time label
* In:	timebase	c*  timebase, e.g 'HJD' or 'MJD' 
*	jdsub	i4 days subtracted
* Out:	label	c* time label
* 2018 Aug Keith Horne @ St Andrews
	character*(*) label, timebase 
	label = 'time'
	l = len1( timebase )
	j = iabs( jdsub )
      if( l .gt. 0 ) then
	label = timebase(:l)
	if( jdsub .gt. 0 ) call append( label, '-' )
	if( jdsub .lt. 0 ) call append( label, '+' )
	if( j .ne. 0 ) call append_i( label, j )
      end if
	return
	end
*==================================================
	subroutine plotlabel_flux( label, fluxunit, iflxdex )
* Create plot label reporting flux units
* In:	fluxunit	c* flux unit (MJY or FLAM)
*	iflxdex	i4 flux units are 10^iflxdex
* Out:	label	c* label
* 2014 Aug Keith Horne @ St Andrews
* 2014 Sep KDH @ StA use iflxdex
* 2018 Sep KDH @ StA adapt from label_flux 
	character*(*) label, fluxunit
	character*50 pow10

	label = ' '
      if( fluxunit .eq. 'MJY' ) then
	label = 'f\d\gn\u (mJy)'
      else if( fluxunit .eq. 'FLAM' ) then
	label = 'f\d\gl\u (erg cm\u-2\ds\u-1\d\A\u-1\d)'
      else
	return
      end if

* power of 10
      if( iflxdex .ne. 0 ) then
	pow10 = '10\u'
	call append_i( pow10, iflxdex )
	call append( pow10, '\d' )
	call nospace( pow10 )
	call word1( pow10, l1, l2 )
	i = index( label, '(' )
	label = label(:i) // pow10(l1:l2) // ' ' // label(i+1:)
      end if

	return
	end
*==================================================
	subroutine textlabel_flux( label, fluxunit, iflxdex )
* Create text label reporting flux units
* In:	fluxunit	c* flux unit (MJY or FLAM)
*	iflxdex	i4 flux units are 10^iflxdex
* Out:	label	c* label
* 2014 Aug Keith Horne @ St Andrews
* 2014 Sep KDH @ StA use iflxdex
* 2018 Sep KDH @ StA adapt from label_flux 
	character*(*) label, fluxunit
	character*50 pow10

	label = ' '

      if( fluxunit .eq. 'MJY' ) then
	label = 'Fnu (mJy)'
      else if( fluxunit .eq. 'FLAM' ) then
	label = 'Flam (erg/cm2/s/A)'
      else
	return
      end if

* power of 10
      if( iflxdex .ne. 0 ) then
	pow10 = '10^'
	call append_i( pow10, iflxdex )
	call nospace( pow10 )
	call word1( pow10, l1, l2 )
	i = index( label, '(' )
	label = label(:i) // pow10(l1:l2) // ' ' // label(i+1:)
      end if

	return
	end

*=================================
	subroutine sdssheader( file, z )
* get redshift from header
* In	file	c* input file (not yet open)
* Out	z	r4 redshift read from header
* 2014 Sep Keith Horne @ St Andrews

	character*(*) file
	character*128 head
* default redshift
	z = 0.
* check filename
	call word1( file, l1, l2 )
	if( l1 .lt. 0 .or. l2 .le. l1 ) goto 999
* open file
	iou = 33
	call openfile( iou, file(l1:l2), 'FORMATTED', 'OLD', ier )
* read header lines
      if( ier .eq. 0 ) then
	write(*,*) '------------------------------------------------------'
	nhead = 7
      do i = 1, nhead
   10	read( iou, '(a)', err=10, end=998 ) head
	lh = len1( head )
* report
	write(*,*) ' ', head( : lh )
* redshift
	iz = index( head, 'ZFINAL=' )
c	write(*,*) 'iz', iz, ' iz+7', iz+7, ' ', head( iz+7 : lh )
      if( iz .gt. 0 ) then
	read( head( iz+7 : ), * ) z
c	write(*,*) ' z', z
      end if
* next line
      end do
* close
  998	close( unit = iou )
	write(*,*) 'File closed ', file(l1:l2)
	write(*,*) 'Redshift : ', z
	write(*,*) '------------------------------------------------------'
      end if
	return

  999	write(*,*) '** sdssheader failed :(.'
	return
	end
*=======================================
	subroutine xwcalc( n, w, x )
* In:	n	i4 number of wavelengths
*	w(n)	r4 wavelengths
* Out:	x(n)	r4 ln(w) spanning -1 to +1
* 2015 Jan Keith Horne @ Annapolis
	real*4 w( n ), x( n )
	x1 = alog( w( 1 ) )
	x2 = alog( w( n ) )
	cen = ( x1 + x2 ) / 2.
	div = abs( x2 - x1 ) / 2.
      do i = 1, n
	x( i ) = ( alog( w( i ) ) - cen ) / div
      end do
	return
	end
*===========================================
	subroutine showmat( n, a, text )
* display nxn matrix a(n,n)
* In:	n	i4 dimension of matrix
*	a(n,n)	r8 matrix elements
*	text(n)	c* short label for each column/row
* 2015 Jan Keith Horne @ Annapolis
* 2015 Jan KDH @ StA - integer format for div=1.
* 2015 Oct KDH @ StA - avert divide by 0
	real*8 a( n, n )
	character*(*) text( n )
	character*128 fmt
	logical iform

	amn = a(1,1)
	amx = amn
      do i=1,n
      do j=1,n
	r = a(i,j)
	amn = min( amn, r )
	amx = max( amx, r )
      end do
      end do
* divisor
	div = max( abs( amn ), abs( amx ) )
* integer format
	mult = 1000
	iform = nint( mult * div ) .eq. mult
* avert divide by 0
      if( div .eq. 0. ) then
	div = 1.
	iform = .true.
      end if
* report
      if( iform ) then
	write(*,*) 'min', amn, ' max', amx, ' mult', mult
      else
	write(*,*) 'min', amn, ' max', amx, ' div', div
      end if


* columns
	k = 10
* column names
	nj = min( n, k )
      do j1 = 1, n, k
	j2 = min( n, j1 + k - 1 )
	write( fmt, * ) '(8x,', k,  'a7)'
	if( iform ) write( fmt, * ) '(8x,', k, 'a6)'
	call nospace( fmt )
	write( *, fmt ) ( text(j)(:len1(text(j))), j = j1, j2 )
      end do
* column numbers
	write( fmt, * ) '(8x,', k, 'i7)'
	if( iform ) write( fmt, * ) '(8x,', k, 'i6)'
	call nospace( fmt )
      do j1 = 1, n, k
	j2 = min( n, j1 + k - 1 )
	write( *, fmt ) ( j, j = j1, j2 )
      end do
* rows
      do i = 1, n
	l = len1( text( i ) )
* columns j1 to j2
      do j1 = 1, n, k
	j2 = min( n, j1 + k - 1 )
      if( j1 .eq. 1 ) then
	write( fmt, * ) '(a5,i3,', k, 'f7.3)'
	if( iform ) write( fmt, * ) '(a5,i3,', k, 'i6)'
	call nospace( fmt )
      if( iform ) then
	write( *, fmt ) text(i)(:l), i, ( nint( mult * a(i,j) ), j = j1, j2 )
      else
	write( *, fmt ) text(i)(:l), i, ( a(i,j) / div, j = j1, j2 )
      end if
      else
	write( fmt, * ) '(8x,', k, 'f7.3)'
	if( iform ) write( fmt, * ) '(8x,', k, 'i6)'
	call nospace( fmt )
      if( iform ) then
	write( *, fmt ) ( nint( mult * a(i,j) ), j = j1, j2 )
      else
	write( *, fmt ) ( a(i,j) / div, j = j1, j2 )
      end if
      end if
* next set of columns
      end do
* next row i
      end do
	return
	end
*===========================================
	subroutine showvec( n, a, text )
* display vector a(n)
* In:	n	i4 dimension of vector
*	a(n)	r8 vector elements
*	text(n)	c* short label for each column/row
* 2015 Jan Keith Horne @ Annapolis
* 2015 Oct KDH @ StA - avert div by 0
	real*8 a( n )
	character*(*) text( n )
	character*128 fmt
	amn = a(1)
	amx = amn
      do i=1,n
	r = a( i )
	amn = min( amn, r )
	amx = max( amx, r )
      end do
	div = max( abs( amn ), abs( amx ) )
	write(*,*) 'min', amn, ' max', amx, ' div', div
	if( div .eq. 0. ) div = 1.
* rows
      do i = 1, n
	l = len1( text( i ) )
	write( fmt, * ) '(a5,i3,1x,f8.4)'
	call nospace( fmt )
	write( *, fmt ) text(i)(:l), i, a( i ) / div
* next row i
      end do
	return
	end
* ===================================================
	subroutine fixflx( w, flx, funit, idex )
* In:	w	r4 wavelength (A)
*	flx	r4 integrated line flux Int( flx(w) dw )
*	funit	c* spectrum flux unit 'MJY' or 'FLAM'
*	idex	i4 spectrum flux multiplier (dex)
* Out:	flx	r4 integrated line flux (erg/cm2/s)
* 2015 Jan Keith Horne @ St-Andrews
* KDH : SHOULD TAKE REDSHIFT INTO ACCOUNT
	character*(*) funit
	logical firstcall/.true./
      if( firstcall ) then
	firstcall = .false.
	c = cgs( 'C' )
	ang = cgs( 'ANGSTROM' )
	pow = alog10( c ) - 2. * alog10( ang ) - 26.
      end if
      if( funit .eq. 'MJY' ) then
	flx = flx * 10. ** ( pow + idex - 2. * alog10( w ) )
      else if( funit .eq. 'FLAM' ) then
	flx = flx * 10. ** idex
      else
	write(*,*) '** ERROR in fixflx(', w, flx, idex, ' )'
	write(*,*) '** Unrecognised flux unit ', funit( :len1(funit) )
	stop '** PrepSpec abort.  :((('
      end if
	return
	end

*=========================================
	real*4 function sigpoly( x, np, n, k, sig, cor )
* standard deviation of a noisy poly
* In:	x	r4 x value of the poly
*	np	i4 number of parameters
*	n	i4 number of poly coefficients
*	k(n)	i4 parameter key for poly coefficients
*	sig(np)	r4 parameter sigmas
*	cor(np,np) r8 parameter covariance matrix
* Out:	sigpoly	r4 standard deviation at x (-1 if no data)
*
* 2015 Mar Keith Horne @ Warwick
	integer*4 k( n )
	real*4 sig( np )
	real*8 cor( np, np )
	real*8 sum, xi, xj, si, sj
* KDH : DELETE FIRSTCALL DIAGNOSTICS AFTER TESTING
	logical firstcall/.false./

* DEBUG REPORT
      if( firstcall ) then
	write(*,*) 'sigpoly(', x, np, n, ' )'
	write(*,*) 'k=(', (k(i),i=1,n), ' )'
	write(*,*) 'sig', (sig(i),i=1,np)
	idiv = 1000
	write(*,*) 'Params:', np
      do i = 1, np
	write(*,*) i, ( nint( idiv * cor(i,j) ), j=1,np )
      end do
	write(*,*) 'Selected:', n
      do i = 1, n
	write(*,*) i, ( nint( idiv * cor( k(i), k(j) ) ), j=1,n )
      end do
      end if

	sigpoly = -1.
	if( np .le. 0 .or. n .le. 0 ) return
	sum = 0.d0
	xi = 1.d0
      do i = 1, n
	if( i .gt. 1 ) xi = xi * x
	ip = k( i )
      if( ip .gt. 0 ) then
	si = xi * sig( ip )
	xj = 1.d0
      do j = 1, n
	if( j .gt. 1 ) xj = xj * x
	jp = k( j )
      if( jp .gt. 0 ) then
	sj = xj * sig( jp )
	add = si * sj * cor( ip, jp )
	sum = sum + add

      if( firstcall ) then
	write(*,*) ip, jp, real(xj*xi), sig(jp), nint(100*cor(ip,jp))
      end if

      end if
      end do
      end if
      end do
	sigpoly = sqrt( sum )

	if( firstcall ) write(*,*) 'sigpoly', sigpoly
	if( firstcall ) read(*,*)

	firstcall = .false.
	return
	end

* ===============================
	subroutine strip( list, string )
* remove from list all occurrences of string
* 2015 May Keith Horne @ StAndrews
	character*(*) list, string
	ls = len1( string )
	if( ls .le. 0 ) return
	l = len1( list )
	if( l .lt. ls ) return
	l = index( list, string )
      do while( l .gt. 0 ) 
	list = list( : l-1 ) // list( l+ls : )
	l = index( list, string )
      end do
	return
	end
* ==================================
	subroutine label_blrnlr( label, vb, vn )
* 2015 Jun Keith Horne @ St.And
* 2021 Apr KDH @ St.A revise format
	character*(*) label
      IF( .TRUE. ) THEN
	label = 'BLR'
	call append_i( label, nint( vb ) )
	call append  ( label, 'NLR' )
	call append_i( label, nint( vn ) )
      ELSE
	label = 'BLR/NLR='
	call append_i( label, nint( vb ) )
	call append( label, '/' )
	call append_i( label, nint( vn ) )
	call nospace( label )
      END IF
	call append( label, 'km/s' )

	return
	end

* ==================================
	subroutine rmsnobias( n, dat, sig, avg, rms, sigrms, rmsbias )
* compute rms of data corrected for noise variance
* In:	n	i4 number of data
*	dat(n)	r4 data
*	sig(n)	r4 1-sigma error bars
* Out:	avg	r4 mean of data
*	rms	r4 rms of data (corrected for error bars)
*	sigrms	r4 1-sigma error bar on rms
*	rmsbias	r4 rms bias due to noise variance
* 2016 Jun Keith Horne @ St-Andrews
	real*4 dat( n ), sig( n )
	real*8 sum

	call optavgrms( n, dat, sig, avg, rms )

	sum = 0.d0
	ng = 0
      do i = 1, n
	s = sig( i )
      if( s .gt. 0. ) then
	sum = sum + s * s
	ng = ng + 1
      end if
      end do
	dof = max( 1, ng - 1 )
	rmsbias = sqrt( sum / dof )
	rms = sqrt( max( 0., rms * rms - rmsbias * rmsbias ) )
	sigrms = rms * sqrt( 2. / dof )
	return
	end

* ==================================
	subroutine positive( n, x, xx )
* replace non-positive values by median of positive values
* In	n	i4 number of values
*	x(n)	r4 values
*	xx(n)	r4 workspace
* Out	x(n)	r4 revised values
* 2016 Jul Keith Horne @ St.Andrews
	real*4 x( n ), xx( n )
	if( n .le. 0 ) return
* min value
	call mnmx( n, x, xmn, xmx )
	if( xmn .gt. 0. ) return
* collect positive values
	nn = 0
      do i = 1, n
      if( x( i ) .gt. 0. ) then
	nn = nn + 1
	xx( nn ) = x( i )
      end if
      end do
	if( nn .le. 0 ) return
* replace non-positive values by median
	xmed = xmedian( nn, xx )
      do i = 1, n
	if( x( i ) .le. 0. ) x( i ) = xmed
      end do
	return
	end

*============================================
	subroutine chifixt( nw, nt, dat, sig, fudge, f, chi ) 
* normalised residuals chi(w,t) with sig(w,t) scaled by f(t)
* In	nw, nt	i4 number of wavelengths and times
*	dat(nw,nt) r4 residuals (data - model)
*	sig(nw,nt) r4 1-sigma error bars (skip if non-positive)
*	fudge	l4 fudge error bars ?
*	f(nt)	r4 error bar fudge factors 
* Out	chi(nw,nt)	r4 normalised residuals
* 2016 Jul Keith Horne @ St-Andrews
	real*4 dat( nw, nt )
	real*4 sig( nw, nt )
	real*4 chi( nw, nt )
	real*4 f( nt )
	logical fudge
      do it = 1, nt
      do iw = 1, nw
	s = sig( iw, it )
	d = dat( iw, it )
	if( fudge ) s = s * f( it )
	e = 0.
	if( s .gt. 0. ) e = d / s
	chi( iw, it ) = e
      end do
      end do
	return
	end
*============================================
	subroutine chifixw( nw, nt, dat, sig, fudge, f, chi ) 
* normalised residuals chi(w,t) with sig(w,t) scaled by f(w)
* In	nw, nt	i4 number of wavelengths and times
*	dat( nw, nt ) r4 residuals (data - model)
*	sig( nw, nt ) r4 1-sigma error bars (skip if non-positive)
*	fudge	l4 fudge error bars ?
*	f( nw )	r4 error bar fudge factors 
* Out	chi( nw, nt )	r4 normalised residuals 
* 2016 Jul Keith Horne @ St-Andrews
	real*4 dat( nw, nt )
	real*4 sig( nw, nt )
	real*4 chi( nw, nt )
	real*4 f( nw )
	logical fudge
      do it = 1, nt
      do iw = 1, nw
	s = sig( iw, it )
	d = dat( iw, it )
	if( fudge ) s = s * f( iw )
	e = 0.
	if( s .gt. 0. ) e = d / s
	chi( iw, it ) = e
      end do
      end do
	return
	end

*============================================
	subroutine chi_bias_w( nw, nt, dat, sig,
     &	fix, f, noclip, bad, w,
     &	chi, bias, sigchi, sigbias ) 
* mean and rms of clipped normalised residuals
* In	nw,nt	i4 number of wavelengths and times
*	dat( nw, nt )	r4 residuals ( data - model )
*	sig( nw, nt )	r4 1-sigma error bars (skip if not>0)
*	fix		l4 fudge error bars ?
*	f( nt )		r4 fudge factors
*	noclip		i4 0 clips bad pixels
*	bad( nw, nt )	l4 bad pixel mask
*	w( n )		r4 work n=max(nt,nw)
* Out	bias( nw )	r4 mean residual 
*	chi( nw )	r4 rms residual
* 	sigbias( nw )	r4 1-sigma error on bias_w
*	sigchi( nw )	r4 1-sigma error on chi_w
* 2016 Jul Keith Horne @ St-Andrews
* 2018 Jul KDH @ StA - try med/mad (bias-corrected)
* 2018 Oct KDH @ StA - try optimal avg and weighted rms

* in
	real*4 dat( nw, nt )
	real*4 sig( nw, nt )
	logical bad( nw, nt )
	logical fix
	real*4 f( nt )
	real*4 w( max( nw, nt ) )
* out
	real*4  chi( nw ),  sigchi( nw )
	real*4 bias( nw ), sigbias( nw )
	real*8 top, bot, sum2

* KDH : MEDMAD IS WORSE
	logical usemedmad/.false./
* KDH : OPTAVG NOT MUCH BETTER
	logical useoptavg/.false./

c	write(*,*) '* chi_bias_w'
      do iw = 1, nw
* defaults
	bias( iw ) = 0.
	chi( iw ) = 1.
	sigbias( iw ) = 0.
	sigchi( iw ) = 0.

* collect data / sigma
	n = 0
      do it = 1, nt
	d = dat( iw, it )
	s = sig( iw, it )
	if( fix ) s = s * f( it )
      if( s .gt. 0. ) then
      if( noclip .ne. 0 .or. ( .not. bad( iw, it ) ) ) then
* stow
	n = n + 1
	w( n ) = d / s
* increment sums for optavgrms
      if( useoptavg ) then
	wgt = 1. / s
      if( n .eq. 1 ) then
	bot  = wgt
	top  = wgt * w( n )
	sum2 = wgt * w( n ) * w( n )
      else
	bot  = bot  + wgt
	top  = top  + wgt * w( n )
	sum2 = sum2 + wgt * w( n ) * w( n )
      end if
      end if

      end if
      end if
* next it
      end do

* require valid data
      if( n .gt. 0 ) then
* median and bias-corrected mad
      if( usemedmad ) then
	call medmad( n, w, wmed, wmad )
	avg = wmed
	call mad2rms( wmad, rms )

* opt avg and weighted rms
      else if( useoptavg ) then
	avg = top / bot
	rms = dsqrt( max( 0.d0, sum2 - (top/bot*top) ) / bot )

* avg and rms
      else
* KDH : BIAS(W) OFTEN BUMPS UP IN VARIABLE LINES.
	call avgrms( n, w, avg, rms )
      end if
	dof = max( 1, n - 1 )
* 2021-10-05 KDH : fix bug here
c	s = rms / sqrt( dof )
	s = rms / sqrt( dof + dof )
* stow
	bias( iw ) = avg
	chi( iw ) = rms
	sigbias( iw ) = s
	sigchi( iw ) = s
* end n .gt. 0
      end if

* next iw
      end do
* replace non-positive values by median of positive values
	call positive( nw, chi, w )

	return
	end

*============================================
	subroutine chi_bias_fit_w(
     &	nw, nt, wlog, dat, sig, fix, f, noclip, bad, work,
     &	chi, bias, sigchi, sigbias,
     &	chifit, chimix, sigchifit, sigchimix ) 
* chi and bias spectra, clipped, smoothed, and mixed
* In:	nw,nt		i4 number of wavelengths and times
*	wlog( nw )	r4 log( wavelength )
*	dat( nw, nt )	r4 residuals ( data - model )
*	sig( nw, nt )	r4 1-sigma error bars (skip if not>0)
*	fix		l4 fudge error bars ?
*	f( nt )		r4 fudge factors
*	noclip		i4 0 clips bad pixels
*	bad( nw, nt )	l4 bad pixel mask
*	work( n )	r4 work n=max(nt,nw)
* Out:	chi( nw )	r4 rms residual
*	bias( nw )	r4 avg residual 
*	sigchi( nw )	r4 1-sigma uncertainty
* 	sigbias( nw )	r4 1-sigma uncertainty
*	chifit( nw )	r4 smoothed chi
*	chimix( nw )	r4 mix of fit and chi outliers
*	sigchifit( nw )	r4 1-sigma uncertainty
*	sigchimix( nw )	r4 1-sigma uncertainty
*
* 2021 Oct Keith Horne @ St.Andrews - extend chi_bias_w

* in
	real*4 dat( nw, nt )
	real*4 sig( nw, nt )
	logical bad( nw, nt )
	logical fix
	real*4 f( nt )
	real*4 work( max( nw, nt ) )
	real*4 wlog( nw )
* out
	real*4  chi( nw ),  sigchi( nw )
	real*4 bias( nw ), sigbias( nw )
	real*4 chifit( nw ),  sigchifit( nw )
	real*4 chimix( nw ),  sigchimix( nw )

* compute chi and bias spectra

	call chi_bias_w( nw, nt, dat, sig,
     &	fix, f, noclip, bad, work,
     &	chi, bias, sigchi, sigbias ) 

* smooth chi spectrum over 100 pixels
	pix = 100.
	write(*,*) 'Smooth Chi(w) over', pix, ' pixels.'
	call smooth( nw, wlog, chi, sigchi, pix, chifit, sigchifit )

* expect a 2.5-sigma outlier in 100 gaussian samples
	big = 2.5 * ( alog10( pix ) / 2. )**(2./3.)
* rough uncertainty in largest outlier
	sigbig = big / sqrt( pix )
	write(*,*) ' outlier threshold', big, ' +/-', sigbig, ' sigma.'

* mix fit -> chi at (chi-fit)/chisig > big + sigbig
	call mixfitdat( nw, chi, sigchi, chifit, sigchifit,
     &		big, sigbig, 1, chimix, sigchimix )

	return
	end

*----------------------------------------
	subroutine smooth( n, w, dat, sig, pix, fit, sigfit )
* spline-fit a spectrum over pix pixels
* In:	n	i4 number of wavelengths
*	w(n)	r4 log( wavelength )
*	dat(n)	r4 data
*	sig(n)	r4 1-sigma errors (<0 if bad)
* 2021 Oct Keith Horne @ St.Andrews
	real*4 w( n )
	real*4 dat( n )
	real*4 sig( n )
	real*4 fit( n )
	real*4 sigfit( n )

	if( n .le. 0 ) return
* default
      if( pix .le. 0. ) then
	call peqp( n, fit, dat )
	call peqp( n, sigfit, sig )
	return
      end if

* number of splines
	nspline = min( 100, max( 1, nint( n / pix ) ) )
	pix = real( n ) / nspline
* sigma clipped spline fit
	ncycle = 10
	thrhi = 4.
	thrlo = -4.
* report
	write(*,*) 'splines', nspline, ' pixels', pix, ' clip', thrlo, thrhi

* spline fit
	call splfita( n, w, dat, sig, fit,
     &	nspline, ncycle, thrhi, thrlo, ifail )

* rough fit uncertainty
	dof = nspline
	fac = 1. / sqrt( dof )
      do i = 1, n
	sigfit( i ) = sig( i ) * fac
      end do

	return
	end

* ====================================================
	subroutine mixfitdat( n, dat, sig, fit, sigfit,
     &		big, sigbig, keep, fdmix, sigfdmix )
* replace dat by fit if (dat-fit)<big*sig, 
* In:	n	i4 number of data
*	dat(n)	r4 data
*	sig(n)	r4 1-sigma uncertainty
*	fit(n)	r4 fit to data
*	sigfit(n) r4 1-sigma uncertainty
*	big	r4 outlier threshold in sigma units
*	sigbig	r4 rms of half-gaussian taper
*	keep	i4 +1 keeps hi, -1 keeps low, 0 keeps all outliers
* Out:	fdmix(n)	r4 mix of fit and outlying data
*	sigfdmix(n)	r4 1-sigma uncertainty
*
* 2021 Oct Keith Horne @ St Andrews

	real*4 dat( n ), sig( n )
	real*4 fit( n ), sigfit( n )
	real*4 fdmix( n ), sigfdmix( n )
	logical hi, lo

	hi = keep .ge. 0
	lo = keep .le. 0

	out = 0.
      do i = 1, n
	d = dat( i )
	s = sig( i )
	f = fit( i )
	sf = sigfit( i )

* p = probability of consistency with the fit
	p = 1.
* positive sigma
      if( s .gt. 0. ) then
* normalised residual
	x = ( d - f ) / s
* above big
      if( hi ) then
	e = ( x - big ) / sigbig 
	if( e .gt. 0. ) p = p * exp( -0.5 * e * e )
      end if
* below -big
      if( lo ) then
	e = ( x + big ) / sigbig 
	if( e .lt. 0. ) p = p * exp( -0.5 * e * e )
      end if
      end if

* outlier probability
	pout = 1. - p
* outlier count
	out = out + pout
* mix fit with outlying data
	d = f * p + d * pout
* mix the variances
	s1 = sf * p
	s2 =  s * pout
	s = sqrt( s1 * s1 + s2 * s2 )
* stow
	   fdmix( i ) = d
	sigfdmix( i ) = s
* next wavelength i
      end do

* report outlier count
	p = 100. * out / n
	write(*,*) 'Outliers', out, ' /', n, ' =', p, ' %'

	return
	end

*============================================
	subroutine chi_bias_t( nw, nt, dat, sig,
     &	fix, f, noclip, bad, w,
     &	chi, bias, sigchi, sigbias ) 
* mean and rms of clipped normalised residuals
* In	nw,nt	i4 number of wavelengths and times
*	dat( nw, nt )	r4 residuals ( data - model )
*	sig( nw, nt )	r4 1-sigma error bars (skip if not>0)
*	fix	l4 fudge error bars ? 
*	f( nw ) r4 error bar fudge factors
*	noclip	i4 0 clips bad pixels
*	bad( nw, nt )	l4 bad pixel mask
*	w( n )	r4 work n=max(nt,nw)
* Out	bias( nt )	r4 mean residual 
*	chi( nt )	r4 rms residual
* 	sigbias( nt )	r4 1-sigma error on bias
*	sigchi( nt )	r4 1-sigma error on chi
* 2016 Jul Keith Horne @ St-Andrews
* 2018 Jul KDH @ St-And - use median and bias-corrected mad
* 2018 Oct KDH @ St-And - revert to avgrms

* in
	real*4 dat( nw, nt )
	real*4 sig( nw, nt )
	logical bad( nw, nt )
	logical fix
	real*4 f( nw )
	real*4 w( max( nw, nt ) )
* out
	real*4  chi( nt ),  sigchi( nt )
	real*4 bias( nt ), sigbias( nt )

* KDH : MEDMAD worse
	logical usemedmad / .false. /

c	write(*,*) '* chi_bias_t'
      do it = 1, nt
* defaults
	bias( it ) = 0.
	chi( it ) = 1.
	sigbias( it ) = 0.
	sigchi( it ) = 0.
* collect data / sigma
	n = 0
      do iw = 1, nw
	s = sig( iw, it )
	d = dat( iw, it )
	if( fix ) s = s * f( iw )
      if( s .gt. 0. ) then
      if( noclip .ne. 0 .or. ( .not. bad( iw, it ) ) ) then
	n = n + 1
	w( n ) = d / s
      end if
      end if
* next iw
      end do
* require data
      if( n .gt. 0. ) then
* use median and debiased mad
      if( usemedmad ) then
	call medmad( n, w, wmed, wmad )
	avg = wmed
	call mad2rms( wmad, rms )
* avg and rms
      else
	call avgrms( n, w, avg, rms )
      end if
	dof = max( 1, n - 1 )
	s = rms / sqrt( dof )
* stow
	bias( it ) = avg
	chi( it ) = rms
	sigbias( it ) = s
	sigchi( it ) = s
      end if
* next it
      end do
* replace non-positive values by median of positive values
	call positive( nt, chi, w )
	return
	end
*===========================================
	subroutine pgclip( clo, chi, nlo, nhi, klo, khi )
* put clip legend on plot
* In	clo	r4 lo sigma clip threshold
*	chi	r4 hi sigma clip threshold
*	nlo	i4 number of low pixels
*	nhi	i4 number of high pixels
*	klo	i4 colour index for low pixels
*	khi	i4 colour index for high pixels
* 2016 Jul Keith Horne @ St-Andrews
	character*75 label
	write(*,*) '* pgclip', nlo, ' <', clo, nhi, ' >', chi
	if( clo .ge. chi ) return
	y = 1.2
	dy = 1.2
	x = 1.
* clip hi
      if( nhi .gt. 0 ) then
	call pgsci( khi )
	y = y + dy
	label = ' '
	call append_i( label, nhi )
	call pgmtxt( 'b', y, x, 1., label )
	label = '>+'
	call append_n( label, chi, 2 )
	call append( label, '\gs' )
	call nospace( label )
	call pgmtxt( 'b', y, x, 0., label )
      end if
* clip lo
      if( nlo .gt. 0 ) then
	call pgsci( klo )
	y = y + dy
	label = ' '
	call append_i( label, nlo )
	call pgmtxt( 'b', y, x, 1., label )
	label = '<'
	call append_n( label, clo, 2 )
	call append( label, '\gs' )
	call nospace( label )
	call pgmtxt( 'b', y, x, 0., label )
      end if
	return
	end

*=================================================
	subroutine pixclip( n1, n2, dat, bad, cutlo, cuthi,
     &	nlo, nhi, lo1, hi1, lo2, hi2 )
* find and count low and high outliers in n1 x n2 image data
* In	n1	i4 pixels on axis 1
*	n2	i4 pixels on axis 2
*	dat( n1, n2 )	r4 residuals
*	cutlo	r4 low  threshold
*	cuthi	r4 high threshold
* Out	bad( n1, n2 )	l4 bad pixel mask
*	nlo	i4 number of lo pixels
*	nhi	i4 number of hi pixels
*	lo1( n1 )	r4 lo pixel histogram on axis 1
*	hi1( n1 )	r4 hi pixel histogram on axis 1
*	lo2( n2 )	r4 lo pixel histogram on axis 2
*	hi2( n2 )	r4 hi pixel histogram on axis 2
* 2016 Jul Keith Horne @ St-Andrews

	real*4  dat( n1, n2 )
	logical bad( n1, n2 )
	real*4 lo1( n1 )
	real*4 hi1( n1 )
	real*4 lo2( n2 )
	real*4 hi2( n2 )
	logical lo, hi

* initialise
	nlo = 0
	nhi = 0
      do i1 = 1, n1
	lo1( i1 ) = 0
	hi1( i1 ) = 0
      end do
      do i2 = 1, n2
	lo2( i2 ) = 0
	hi2( i2 ) = 0
      do i1 = 1, n1
	bad( i1, i2 ) = .false.
      end do
      end do

* nada to clip
	if( n1 .le. 0 .or. n2 .le. 0 ) return
	if( cutlo .ge. cuthi ) return
* KDH: SHOULD COUNT INTEGERS
* find and count outliers
      do i2 = 1, n2
      do i1 = 1, n1
	d = dat( i1, i2 )
	lo = d .le. cutlo
	hi = d .ge. cuthi
	bad( i1, i2 ) = lo .or. hi
      if( lo ) then
	nlo = nlo + 1
	lo1( i1 ) = lo1( i1 ) + 1
	lo2( i2 ) = lo2( i2 ) + 1
      else if( hi ) then
	nhi = nhi + 1
	hi1( i1 ) = hi1( i1 ) + 1
	hi2( i2 ) = hi2( i2 ) + 1
      end if
      end do
      end do

	return
	end
*======================================================
	subroutine dumpstats( file, n, dat, sig, title )
* write statistics to specified file
* In	file	c* filename
*	n	i4 number of data
*	dat	r4 data
*	sig	r4 sigma
*	title	c* title to go in first line
* 2017 Sep Keith Horne @ St-Andrews
* 2018 Feb KDH @ StA - new->unknown, write to record first
* 2018 Feb KDH @ StA - change output format
* 2018 Feb KDH @ StA - rename to dumpstats
* 2018 Feb KDH @ StA - add sn1, sn2, snx from snr3
	character*(*) file, title
	real*4 dat( n )
	real*4 sig( n )

* nothing to do
	if( n .le. 0 ) return
	if( len1( file ) .le. 0 ) return
* stats
	call mnmx( n, dat, dmin, dmax )
	call medmad( n, dat, dmed, dmad )
	call avgrms( n, dat, davg, drms )

	call optavg( n, dat, sig, opt, sigopt )

	call mnmx( n, sig, smin, smax )
	call medmad( n, sig, smed, smad )
	call avgrms( n, sig, savg, srms )

	call avgrmsx( n, dat, sig, good, avg, rms, sigavg, sigrms )
* open
	iu = 77
	call openfile( iu, file, 'formatted', 'unknown', ier )

      if( ier .eq. 0 ) then
      if( len1( title ) .ne. 0 ) then
	write( iu, * ) '# ', title(:len1(title))
	write(  *, * ) '# ', title(:len1(title))
      end if	

* S/N
	snravg = 0.
	snrrms = 0.
	if( sigavg .gt. 0. ) snravg = avg / sigavg
	if( sigrms .gt. 0. ) snrrms = rms / sigrms

	call snr3( n, dat, sig, sn1, sn2, snx )

* Note : snx should be the same as snrrms

* fractional rms
	rmsrel = 0.
	sigrmsrel = 0.
	div = abs( avg )
      if( div .ne. 0. ) then
	rmsrel = rms / div
	sigrmsrel = sigrms / div
      end if

* report
	write(*,*) ' Ndat', n, ' good', good
	write(*,*) ' sigma min', smin, ' max', smax
	write(*,*) '       med', smed, ' mad', smad
	write(*,*) '       avg', savg, ' rms', srms
	write(*,*) ' data  min', dmin, ' max', dmax
	write(*,*) '       med', dmed, ' mad', dmad
	write(*,*) '       avg', davg, ' rms', drms
	write(*,*) '       opt', opt, ' +/-', sigopt
	write(*,*) 'avgrmsx: good', good
	write(*,*) ' avg', avg, ' +/-', sigavg, ' S/N', snravg
	write(*,*) ' rms', rms, ' +/-', sigrms, ' S/N', snrrms
	write(*,*) ' rms/avg', rms/avg, ' =', rms * 100/avg, ' %'

	write(*,*) ' snr1', sn1, ' snr2', sn2, ' snrx', snx

* write to file
	write( iu, * ) n, ' N(DAT)'
	write( iu, * )
	write( iu, * ) dmin, ' MIN(DAT)'
	write( iu, * ) dmax, ' MAX(DAT)'
	write( iu, * )
	write( iu, * ) dmed, ' MED(DAT)'
	write( iu, * ) dmad, ' MAD(DAT)'
	write( iu, * )
	write( iu, * ) davg, ' AVG(DAT)'
	write( iu, * ) drms, ' RMS(DAT)'
	write( iu, * )
	write( iu, * ) smin, ' MIN(SIG)'
	write( iu, * ) smax, ' MAX(SIG)'
	write( iu, * )
	write( iu, * ) smed, ' MED(SIG)'
	write( iu, * ) smad, ' MAD(SIG)'
	write( iu, * )
	write( iu, * ) savg, ' AVG(SIG)'
	write( iu, * ) srms, ' RMS(SIG)'
	write( iu, * )
	write( iu, * ) opt,    ' OPTAVG'
	write( iu, * ) sigopt, ' SIG(OPTAVG)'
	write( iu, * )
	write( iu, * ) avg,    ' AVG_ML'
	write( iu, * ) sigavg, ' SIG(AVG_ML)'
	write( iu, * ) snravg, ' S/N(AVG_ML)'
	write( iu, * )
	write( iu, * ) good, ' Good'
	write( iu, * ) rms,    ' RMS_ML'
	write( iu, * ) sigrms, ' SIG(RMS_ML)'
	write( iu, * ) snrrms, ' S/N(RMS_ML)'
	write( iu, * ) rmsrel, ' RMS_ML/AVG_ML'
	write( iu, * ) sigrmsrel, ' SIG(RMS_ML/AVG_ML)'
	write( iu, * )
c	write( iu, * ) sn1, ' SNR1 = S/N(MAD)'
c	write( iu, * ) sn2, ' SNR2 = (CHI2-DOF)/SQRT(2*DOF)'

	write( iu, * ) sn2, ' SNR2 = SQRT(CHI2-DOF)'

c	write( iu, * ) snx, ' SNRX = S/N(RMSX)'

* close
	close( iu )
      end if
	return
	end

* ================================================
	subroutine softblr( nw, w_w, wgt_w, dat_w, sig_w, mask_w,
     &		nl, good_l, i1_l, i2_l )
* soft blr window weights for continuum fit and revise sigmas accordingly
* In:	nw		i4 number of wavelengths
*	w_w(nw)		r4 wavelengths (Angstroms)
*	sig_w(nw)	r4 error bars (- if bad)
*	mask_w(nw)	l  mask (true for masked pixels)
*	nl		i4 number of lines
*	good_l(nl) 	r4 0 rejects line
*	i1_l(nl)	i4 first pixel of line window
*	i2_l(nl)	i4 last pixel of line window
*	flx_l(nl)	r4 line flux
*	sig_l(nl)	r4 sigma( line flux )
* Out:	wgt_w(nw)	r4 weights (0-1) 0=blr pixel, 1=continuum
*	sig_w(nw)	r4 revised sigma -> sigma / sqrt(wgt) 
* 2017 Oct Keith Horne @ St-Andrews
	real*4 w_w( nw )
	real*4 dat_w( nw )
	real*4 sig_w( nw )
	real*4 wgt_w( nw )
	logical mask_w( nw )
	integer*4 i1_l( nl )
	integer*4 i2_l( nl )
	real*4 good_l( nl )
	real*4 flx_l( nl )
	real*4 sig_l( nl )
	logical gabby

	pi = 4. * atan2( 1., 1. )
	gabby = .false.

* deepest window is exp(-snrmax)
	snrmax = 6.

* set weights to 1
      do i = 1, nw
	wgt_w( i ) = 1.
* error bars
	sig = abs( sig_w( i ) )
* KDH : SHOULD WE RESPECT THE PREVIOUS MASK ?
c	if( mask_w( i ) ) sig = - sig
	sig_w( i ) = sig
      end do
* lower weight close to selected lines
      do l = 1, nl
* line enabled
      if( good_l( l ) .ne. 0. ) then
* pixel limits
	i1 = i1_l( l )
	i2 = i2_l( l )
	n = i2 - i1 + 1

* KDH : REQUIRE REST WAVELENGTH TO BE IN THE WINDOW?
c	rest = rest_l( l )

* KDH : CHANGE N.GT.0 TO N.GE.5 TO PREVENT CRASH WHEN N=1.
C      if( n .gt. 0 ) then
      if( n .ge. 5 ) then
* wavelength limits
	w1 = w_w( i1 )
	w2 = w_w( i2 )
* line centre
	w0 = sqrt( w1 * w2 )
* wings
	i = i1
	k = max( 1, int( n * 0.2 ) )
	call optavg( k, dat_w( i ), sig_w( i ), c1, s1 )
	i = i2 - k + 1
	call optavg( k, dat_w( i ), sig_w( i ), c2, s2 )
* core
	i = i1 + k
	kc = max( 1, n - k - k )

* KDH : DEBUG REPORT  (I OUT OF RANGE)
      if( i .lt. 1 .or. i .gt. i2 
     &	.or. i+kc-1 .lt. 1 .or. i+kc-1 .gt. i2 ) then
	write(*,*) '** ERROR in rectify', k, kc
	write(*,*) ' pix', i1, i, i2-k+1, i2
	write(*,*) ' lam', nint( w_w(i1) ), nint( w_w(i2) )
	gabby = .true.
      end if

	call optavg( kc, dat_w( i ), sig_w( i ), f, s )

* debug report
      if( gabby ) then
	write(*,*) 'pix', i1, i1+k, i2-k+1, i2
	write(*,*) 'lam', nint(w_w(i1)), nint(w_w(i1+k)),
     &		nint(w_w(i2-k+1)), nint( w_w(i2))
	write(*,*) 'cfc', c1, f, c2, k, kc, k
	write(*,*) 'sig', s1, s, s2
      end if

* estimate S/N 
* KDH : COULD BE IMPROVED
	c = ( c1 + c2 ) / 2.
	flx = f - c
	var = s * s + ( s1 * s1 + s2 * s2 ) / 4.
	sigflx = sqrt( var )
	snr = flx / sigflx
	
      if( snr .gt. 0. ) then 
	s = min( snr, snrmax )
* report S/N and wgt
      if( gabby ) then
	wgt = exp( - s )
	write(*,*) 'softblr', nint( w0 ),
     &	' flx', flx, ' +/-', sigflx, ' S/N', snr, ' wgt', wgt
      end if
* apply weights across the line window
      do i = i1, i2
* x spans -1 to +1 across window
	x = alog( w_w( i ) / w0 ) / alog( w2 / w0 )
* c is 0 to 1 rising from edge to centre of window
	c = 0.5 * ( 1. + cos( pi * x ) )
* wgt falls edge to centre from 1 to exp(-s)
	wgt = exp( - s * c )
* stow
	wgt_w( i ) = min( wgt_w( i ), wgt )
      end do
      end if
      end if
      end if
* next line l
      end do

* apply the mask (not completely black)
	wgtmin = exp( - snrmax )
      do i = 1, nw
	if( mask_w( i ) ) wgt_w( i ) = wgtmin
      end do

* revise error bars
      do i = 1, nw
	wgt = wgt_w( i )
	sig = sig_w( i )
* negative sigma for zero-weight
      if( wgt .le. 0. ) then
	sig = - abs( sig )
	wgt = 0.
* revise sigma to include weights
      else if( wgt .gt. 0. ) then
	sig = abs( sig )
	if( wgt .lt. 1. ) sig = sig / sqrt( wgt )
      end if
* stow
	sig_w( i ) = sig
	wgt_w( i ) = wgt
* next iw
      end do
	return
	end
* ================================================
	subroutine snr3( n, dat, sig, sn1, sn2, snx )
* Compute 3 S/N ratios for detection of variations
* In:	n	i4 number of data
*	dat(n)	r4 data values
*	sig(n)	r4 1-sigma error bars
* Out	sn1	r4 S/N from L1 norm relative to median
* 	sn2	r4 S/N from L2 norm relative to optimal average
* 	snx	r4 S/N from avgrmsx (saturates at sqrt(good))
* 2018 Feb Keith Horne @ St-Andrews
	real*4 dat( n ), sig( n )
	sn1 = snr1( n, dat, sig )
	sn2 = snr2( n, dat, sig )
	snx = snrx( n, dat, sig )
	return
	end

* ================================================
	function snr2( n, dat, sig )
* S/N ratio (L2 norm) for detection of variations
* Can be negative if Chi^2 < dof
* In:	n	i4 number of data
*	dat(n)	r4 data values
*	sig(n)	r4 1-sigma error bars
* Out:	snr2	r4 S/N from L2 norm relative to optimal average
* 2018 Feb Keith Horne @ St-Andrews
	real*4 dat( n ), sig( n )
	real*8 chi2
* no data
	snr2 = 0.
	if( n .le. 0 ) return
* optimal average
	call optavg( n, dat, sig, avg, sigavg )
* chi^2
	chi2 = 0.d0
	ng = 0
      do i = 1, n
	s = sig( i )
      if( s .gt. 0. ) then
	ng = ng + 1
	x = ( dat( i ) - avg ) / s
	chi2 = chi2 + x * x
      end if
      end do
* degrees of freedom
	dof = ng - 1
* safe divisor
	div = max( 1., dof )
* shift to mean=0, scale to sigma=1
	snr2 = ( chi2 - dof ) / sqrt( 2. * div )

* KDH : REVERT TO debiased Chi^2
	snr2 = sqrt( abs( chi2 - dof ) )
	if( chi2 .lt. dof ) snr2 = - snr2

	return
	end

*================================================
	function snr1( n, dat, sig )
* S/N ratio (L1 norm) for detection of variations
* In:	n	i4 number of data
*	dat(n)	r4 data values
*	sig(n)	r4 1-sigma error bars
* Out:	snr1	r4 S/N from L1 norm relative to median
* 2018 Feb Keith Horne @ St-Andrews
	real*4 dat( n ), sig( n )
	real*8 sane
	logical firstcall /.true./
      if( firstcall ) then
	firstcall = .false.
	pi = 4. * atan2( 1., 1. )
      end if
* no data
	snr1 = 0.
	if( n .le. 0 ) return

* median
	a = xmedian( n, dat )
* KDH : SHOULD ITERATE TO MINIMISE SANE.
* sane = sum abs( normalised errors )
	sane = 0.d0
	ng = 0
      do i = 1, n
	s = sig( i )
      if( s .gt. 0. ) then
	ng = ng + 1
	x = ( dat( i ) - a ) / s
	sane = sane + abs( x )
      end if
      end do

* degrees of freedom
	dof = ng - 1
* safe divisor
	div = max( 1., dof )
* <MAD> = 1.4826 sigma
	sigbymad = 1.4826
	bias = sigbymad * dof
* Var[MED]= (pi/2) sigma^2
	sigma = sigbymad * sqrt( 2 * div )
* KDH : NEED SIMS TO VERIFY.
* shift to mean=0, scale to sigma=1
	snr1 = ( sane - bias ) / sigma
	return
	end

*================================================
	function snrx( n, dat, sig )
* S/N ratio for RMS_ML from avgrmsx
* Saturates near sqrt(n) when rms >> sig(i)
* In:	n	i4 number of data
*	dat(n)	r4 data values
*	sig(n)	r4 1-sigma error bars
* Out:	snrx	r4 S/N = RMS_ML / SIG(RMS_ML)
* 2018 Feb Keith Horne @ St-Andrews
	real*4 dat( n ), sig( n )
* no data
	snrx = 0.
	if( n .le. 0 ) return
* max likelihood estimates of avg and rms
	call avgrmsx( n, dat, sig, good, avg, rms, sigavg, sigrms )
* s/n ratio
	if( sigrms .gt. 0. ) snrx = rms / sigrms
	return
	end

*================================================
	subroutine i2bits( m, n, b )
* In:	m	i4 integer
*	n	i4 number of bits
* Out	b(n)	l1 bits
	logical*1 b( n )

	k = m
	idiv = 2 ** n
      do i = n, 1, -1
	idiv = idiv / 2
	j = k / idiv
	b( i ) = j .gt. 0
	k = k - j * idiv
      end do
* sanity
	k = 0
	j = 1
      do i = 1, n
	if( b(i) ) k = k + j
	j = j * 2
      end do
      if( k .ne. m ) then
	write(*,*) '** ERROR in I2BITS : In', m, ' Out', k
	write(*,*) (b(i),i=1,n)
	stop
      end if
	return
	end
* ===========================================
	subroutine append_chi2dof( label, chi2, ndof, nfigs )
* extend label to report chi^2/dof and dof 
* In:	label	c* label
*	chi2	r4 minimum chi^2
*	ndof	i4 degrees of freedom
*	nfigs	i4 number of significant figures
* Out:	label	c* extended label
* 2018 Oct Keith Horne @ St.Andrews
	character*(*) label
      if( ndof .le. 0 ) then
	call append( label, '\gx\u2\d\dmin\u' )
	call append( label, '=' )
	call append_n( label, chi2, nfigs )
      else
	call append( label, '\gx\u2\d\dmin\u /' )
	call append_i( label, ndof )
	call append( label, '=' )
	call append_n( label, chi2 / ndof, nfigs )
      end if
	return
	end
*==============================================
	subroutine append_sigv( label, n, sigv )
* extend label to report velocity dispersion range
* In:	label	c*
*	n	i4 number of values
*	sigv	r4 velocity dispersions (km/s)
* Out:	label	c* extended label
* 2018 Oct Keith Horne @ St.Andrews
	character*(*) label
	real*4 sigv(n)

	if( n .le. 0 ) return
	call mnmx( n, sigv, vmn, vmx )
	kmslo = nint( vmn )
	kmshi = nint( vmx )

	write(*,*) 'Velocity Dispersion', kmslo, kmshi, ' km/s'

	call append( label, '\gs\dV\u' )
	call append_i( label, kmslo )
	if( kmslo .ne. kmshi ) call append_i( label, kmshi )
	call append( label, 'km/s' )
	return
	end


*==============================================
	subroutine fe2plot( agn, nw, w_w, avg_w, sigavg_w,
     &	cfitsig_w, avgfe2_w, fe2kms, sigfe2kms, fe2scl, fe2kmsprior,
     &	ngrid, ngrid1, fe2kms_k, fe2scl_k, fe2bof_k, bof8_k,
     &	ngridv, vdisp_v, fe2kms_v, fe2scl_v,
     &	fit_v, chi2_v, dchi2_v, dbof_v, prior_v, wgt_v,
     &	vfit, sigvfit, bofvfit, npoly, nspline, fitrmsv, fitmadv )

* Diagnostic plot of Fe2 fit
*
* In:	agn	c* agn name
*	nw	i4 number of wavelengths
*	w_w(nw)	r4 wavelength grid
*	avg_w(nw)	r4 average spectrum
*	sigavg_w(nw)	r4 1-sigma error bars
*	cfitsig_w(nw)	r4 continuum fit error bar
*	avgfe2_w(nw)	r4 fe2 spectrum (already scaled to fit)
*	fe2kms	r4 best fit fe2 vdisp (km/s)
*	fe2scl	r4 best fit fe2 scale factor
*	sigfe2kms	r4 1-sigma on fe2kms
*	fe2kmsprior	r4 fe2 vdisp prior
* scale factor grid
*	ngrid	i4 number of grid nodes
*	ngrid1	i4 start of tail
* 	fe2kms_k( ngrid )	r4 fe2 velocity (km/s)
*	fe2scl_k( ngrid )	r4 fe2 scale factor
*	fe2bof_k( ngrid )	r4 fe2 badness of fit
*	bof8_k( ngrid )	r8 badness of fit
* velocity dispersion grid
*	ngridv	i4 number of vdisp grid points
* 	vdisp_v(ngridv)	r4 vdisp grid
* 	fe2kms_v(ngridv) r4 fe2 vdisp
* 	fe2scl_v(ngridv) r4 fe2 scale factor
* 	fit_v(ngridv)	r4 fit
* 	chi2_v(ngridv)	r8 chi^2
* 	dchi2_v(ngridv)	r4 dchi^2
* 	dbof_v(ngridv)	r4 badness-of-fit
* 	prior_v(ngridv)	r4 prior
* 	wgt_v(ngridv)	r4 weights
* parabola
*	vfit	r4 best vdisp
*	sigvfit	r4 dbof=1 at vfit +/- sigvfit
*	bofvfit	r4 best BoF
* continuum fit
*	npoly	i4 number poly coefficients for continuum fit
*	nspline	i4 number of splines for continuum fit
*	fitrmsv i4 ?
*	fitmadv i4 ?
* 2019 Aug Keith Horne @ St-Andrews- subroutine adapted from main code
* 2021 Jan KDH @ Crail - csize=1.5, lwide=2
* subroutine arguments
	character*(*) agn
* wavelengths
	real*4 w_w( nw )
	real*4 avg_w( nw )
	real*4 sigavg_w( nw )
	real*4 cfitsig_w( nw )
	real*4 avgfe2_w( nw )
* fe2 kms grid
	real*4 vdisp_v( ngridv )
	real*4 fe2kms_v( ngridv )
	real*4 fe2scl_v( ngridv )
	real*4 fit_v( ngridv )
	real*8 chi2_v( ngridv )
	real*4 dchi2_v( ngridv )
	real*4 dbof_v( ngridv )
	real*4 prior_v( ngridv )
	real*4 wgt_v( ngridv )
* fe2 scl grid
* KDH: MAKE THESE LOCAL?
	parameter( maxgrid = 10000 )
	integer*4 irank_k( maxgrid )

	real*4 fe2kms_k( ngrid )
	real*4 fe2scl_k( ngrid )

* 2021-04-20 KDH : bof_k -> bof8_k
	real*8 bof8_k( ngrid )
	real*4 fe2bof_k( ngrid )
	real*4 dbof_k( ngrid )


* local arrays (KDH : change to  plot1, etc?)
	parameter( maxw = 10000 )
	real*4 dat_w( maxw )
	real*4 sig_w( maxw )
	real*4 fe2_w( maxw )
	real*4 fit_w( maxw )
	real*4 avgcont_w( maxw )
	real*4 cont_w( maxw )
	real*4 dif_w( maxw )
	real*4 cdf_w( maxw )

	real*8 sum, sum1
	logical autofit /.true./
	logical gabby /.true./
	logical abort /.false./

* pgplot
	parameter( maxplot=10000 )
	real*4 plot0( maxplot )
	real*4 plot1( maxplot )
	real*4 plot2( maxplot )
	real*4 plot3( maxplot )
	real*4 plot4( maxplot )
	real*4 plot5( maxplot )
	real*4 plot6( maxplot )
	real*4 plot7( maxplot )
	real*4 plot8( maxplot )
	character*75 xlabel, ylabel, title, label
	logical pgagain
* pgplot colour indices
	parameter( kblack=1, kred=2, kgreen=3, kblue=4, kcyan=5 )
	parameter( kmagenta=6, kyellow=7, korange=8, kyelgrn=9 )
	parameter( kblugrn=10, kltblue=11, kpurple=12, kpuce=13 )
	parameter( kdkgrey=14, kltgrey=15 )
* pgplot symbols
	parameter( kstar=18 )
* pgplot line styles
	parameter( kdash=2, kdashdot=3, kdot=4, kdashdot3=5 )

	rms_over_span_max = 0.1

* intro
	write(*,*)
	write(*,*) '** Fe2 plot ========================'

* report input parameters

	write(*,*) 'Fe2 vdisp', fe2kms, ' +/-', sigfe2kms, ' km/s'
	write(*,*) 'Fe2 scl', fe2scl
	write(*,*) 'Grids: Nscl', ngrid, ' Nkms', ngridv
	write(*,*) 'Fe2 scl grid:', ngrid, ' i km/s scl bof'

	call quicksort( ngrid, fe2scl_k, irank_k )
      do ir = 1, ngrid
	i = irank_k( ir )
	write(*,*) i, fe2kms_k( i ), fe2scl_k( i ), fe2bof_k( i )
      end do

	write(*,*) 'Tail', ngrid1, ngrid
      do i = ngrid1, ngrid
	write(*,*) i, fe2kms_k( i ), fe2scl_k( i ), fe2bof_k( i )
      end do

	write(*,*) 'Fe2 kms grid:', ngridv, ' i km/s scl chi2 dbof'
	call quicksort( ngridv, fe2kms_v, irank_k )
      do ir = 1, ngridv
	i = irank_k( ir )
	write(*,*) i, fe2kms_v( i ), fe2scl_v( i ), 
     &		real(chi2_v( i )), dbof_v( i )
      end do

* abort
      if( nw .gt. maxw ) then
	write(*,*) '** TOO MANY WAVELENGTHS', nw, '>', maxw
	return
      end if
      if( ngrid .gt. maxgrid ) then
	write(*,*) '** GRID OVERFLOW', ngrid, '>', maxgrid
	return
      end if

* Fe2 pixel range
	i1 = 0
	i2 = -1
      do i = 1, nw
	ic = nw - i + 1
	if( i1 .le. 0 .and. avgfe2_w( i ) .gt. 0. ) i1 = i
	if( i2 .le. 0 .and. avgfe2_w( ic) .gt. 0. ) i2 = ic
      end do
	npixfe2 = i2 - i1 + 1

* report
      if( gabby .or. npixfe2 .le. 0 ) then
	write(*,*) 'Fe2 pixels', npixfe2, i1, i2
      if( i1 .ge. 1 .and. i2 .ge. i1 ) then
	write(*,*) 'Fe2 waves', nint( w_w(i1) ), nint( w_w(i2) )
      end if
      end if
* abort
	if( npixfe2 .le. 0 ) return

* format
   10	ipanfit = 1
	ipanscl = 2
	ipankms = 3
	nx = 1
	ny = 2
	if( ngridv .gt. 1 ) ny = ny + 1
	npan = ny
	
* open
	call pgstart( nx, ny, notused )
	call pgbgw
c	csize = csizedef
	csize = 1.5
	lwide = 2
	call pgsch( csize )
	call pgslw( lwide )

* panels
      do ipan = 1, npan

*====================================================
* plot fit to mean spectrum
* KDH : CHANGE TO BEST FIT ONLY?
      if( ipan .eq. ipanfit ) then

* window
	xmn = w_w( i1 )
	xmx = w_w( i2 )
	call mnmx( nw, avg_w, ymn, ymx )
	call medmad( nw, avg_w, amed, amad )
	ymn = min( ymn, 0. )
	ymx = min( ymx, 2. * amed )
	ymn = ymn - 0.05 * ( ymx - ymn )
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
* labels
	xlabel = 'Rest \gl (\A)'
	ylabel = 'flux'
	title = 'Fe2 + Continuum Fit'
	call pglabel( xlabel, ylabel, title )

* label
	label = '\gs\dFe2\u'
	call append_i( label, nint( fe2kms ) )
	call append( label, '+/-' )
	call append_i( label, nint( sigfe2kms ) )
	call append( label, 'km/s' )
	write(*,*) label(:len1(label))
	call pgmtxt('T', 0.5, 0.5, 0.5, label )

* avg 
	call pgbin( nw, w_w, avg_w, .true. )
* +/- cont fit error bars
	call pgsci( kyellow )
	call peqpmc( nw, sig_w, cfitsig_w, -1. )
	call pgbin( nw, w_w, cfitsig_w, .true. )
	call pgbin( nw, w_w, sig_w, .true. )
* +/- error bars
	call pgsci( kred )
	call peqpmc( nw, sig_w, sigavg_w, -1. )
	call pgbin( nw, w_w, sigavg_w, .true. )
	call pgbin( nw, w_w, sig_w, .true. )
	call pgsci( kblack )	

* fit continuum to ( avg - fe2 )

* fe2 scale loop
c	nloopfe2 = 4
c	if( loopv .eq. 1 ) nloopfe2 = 7
c	if( npixfe2 .lt. 1 ) nloopfe2 = 1
c	fe2converged = .false.
c	lastplot = .false.
c      DO LOOPfe2 = 1, NLOOPfe2
c      if( .not. fe2converged .or. lastplot ) then

* fe2 scale factor grid
* KDH : WHY NOT RETAIN INPUT GRID?
c	loopfe2 = 1
c      if( loopfe2 .eq. 1 ) then
c	ngrid = 0
c	dlnscl = 0.05
c      end if
c	ngrid1 = ngrid + 1
c	npow = 0
c	if( npixfe2 .gt. 0 ) npow = 2
c	kmax = 2 * npow + 1

* loop over a range of ln(scale factor)
c      do ipow = -npow, npow
* scan index k = 1, kmax
c	k = ipow + npow + 1
* scale factor
c	scl = exp( ipow * dlnscl )

* loop over scale factors
c	ngrid1 = 1




      do k = 1, ngrid
	scl = fe2scl_k( k )
	write(*,*) k, scl
* 2021-04-20 KDH : IS IT ALREADY SCALED?
	scl = 1.
      do i = 1, nw
	f = avgfe2_w( i ) * scl
	dat_w( i ) = avg_w( i ) - f
	sig_w( i ) = cfitsig_w( i )
	fe2_w( i ) = f
      end do

* sigma-clip
	ncycle = 10
	thrhi = 2.
	thrlo = -10.
* report
      if( gabby ) then
	write(*,*) 'Npoly', npoly, ' Nspline', nspline
	write(*,*) 'reject cycles', ncycle, ' clip', thrlo, thrhi, ' sigma.'
      end if
* poly fit continuum for AVG spectrum
      if( npoly .gt. 0 ) then
      if( autofit ) then
	call polyfita( nw, w_w, dat_w, sig_w, fit_w,
     &		npoly, ncycle, thrhi, thrlo, ifail )
      else
	call polyfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if
* spline fit continuum for AVG spectrum 
      else

* KDH : COULD TRY FITTING THIS WITH SLOPE = 0 ON THE ENDS.
      if( autofit ) then
	call splfita( nw, w_w, dat_w, sig_w, fit_w,
     &		nspline, ncycle, thrhi, thrlo, ifail )
      else
	call splfitr( nw, w_w, dat_w, sig_w, fit_w, ifail )
      end if
      end if

* did the fit change sig_w ?
	big = 0.
      do i = 1, nw
	dif = sig_w( i ) - cfitsig_w( i )
	big = max( big, abs( diff ) )
      end do
      if( big .gt. 0. ) then
	write(*,*) '** WARNING: FIT CHANGED ERROR BARS', big
      end if

* residuals
      do i = 1, nw
	cont_w( i ) = fit_w( i )
	fit_w( i ) = fe2_w( i ) + cont_w( i )
	dif_w( i ) = avg_w( i ) - fit_w( i )
      end do

* chi2
	n = 0
	sum = 0.d0
      do i = 1, nw
	s = cfitsig_w( i )
      if( s .gt. 0. ) then
	x = dif_w( i ) / s
	n = n + 1
	sum = sum + x * x
      end if
	cdf_w( i ) = sum
      end do

* cumulative
      do i = 1, nw
	cdf_w( i ) = cdf_w( i ) / cdf_w( nw )
      end do
	x2 = sum
	if( gabby ) write(*,*) ipow, ' scl', scl, ' Chi2', x2

* stow 
c	ngrid = ngrid + 1
c      if( ngrid .gt. maxgrid ) then
c	write(*,*) '** WARNING: FE2 GRID OVERFLOW', ngrid
c	ngrid = maxgrid
c      end if
c	fe2kms_k( ngrid ) = fe2kms
c	fe2scl_k( ngrid ) = fe2scl * scl
c	fe2bof_k( ngrid ) = x2
c	bof8_k( ngrid ) = sum


* KDH : FIND KBEST AT END OF LOOP ?
c	i = ngrid1 + kbest - 1
* KDH : TRAP ERROR - WHY IS I HUGE?
c	if( i .gt. ngrid ) write(*,*) i, ngrid1, kbest
c	if( bof8_k( ngrid ) .le. bof8_k( i ) ) kbest = k

* best in current scan
      if( k .ge. ngrid1 ) then
	if( k .eq. ngrid1 ) kbest = k
	if( bof8_k( k ) .le. bof8_k( kbest ) ) kbest = k
      end if

* best in full grid
c	if( ngrid .eq. 1 ) nbest = 1
c	if( bof8_k( ngrid ) .le. bof8_k( nbest ) ) nbest = ngrid

	if( k .eq. 1 ) nbest = 1
	if( bof8_k( k ) .le. bof8_k( nbest ) ) nbest = k


* stow best fit continuum
c	if( ngrid .eq. nbest ) call peqp( nw, avgcont_w, cont_w )
	if( k .eq. nbest ) call peqp( nw, avgcont_w, cont_w )

* avg-fit
	call pgsci( kdkgrey )
	call pgbin( nw, w_w, dif_w, .true. )
* fe2+cont
	call pgsci( kblue )
	call mnmx( nw, fit_w, fmn, fmx )
	write(*,*) 'Fit (fe2+cont) range', fmn, fmx
	call pgline( nw, w_w, fit_w, .true. )
* continuum
	call pgsci( kred )
	call pgline( nw, w_w, cont_w )
* fe2
	call pgsci( kltblue )
	call pgline( nw, w_w, fe2_w )
* cumulative chi2
	call pgsci( korange )
	call pgswin( xmn, xmx, 0., 1. )
	call pgbin( nw, w_w, cdf_w, .true. )
	call pgswin( xmn, xmx, ymn, ymx )
	call pgsci( kblack )

* next scan point k = 1 + ipow + npow
      end do

* best fe2 scale factor from tail
c	i = ngrid1 + kbest - 1
	i = kbest
	scl = fe2scl_k( i ) / fe2scl
	bofmin = bof8_k( i )
	if( gabby ) write(*,*) 'best in tail ', i, ' scl', scl, ' BoFmin', bofmin

* delta chi2
* KDH - PRECISION LOSS HERE :(  NEED DOUBLE PRECISION !
c	call peqpac( ngrid, dbof_k, fe2bof_k, -bofmin )
      do i = 1, ngrid
	dbof_k( i ) = bof8_k( i ) - bof8_k( kbest )
      end do

* label best reduced chi2
	label = ' '
	call append_chi2dof( label, bofmin, nw, 4 )
	call pgmtxt( 'T', 0.5, 0.99, 1.0, label )
* label velocity dispersion range
	label = ' '
	call append_sigv( label, ngrid, fe2kms_k )
	call pgmtxt( 'T', 0.5, 0.01, 0.0, label )

*====================================================
* plot fit to scale factor
      else if( ipan .eq. ipanscl ) then

* grid tail
	k = 0
      do i = ngrid1, ngrid
	k = k + 1
	plot1( k ) = fe2scl_k( i )
	plot2( k ) = dbof_k( i )
      end do
	ntail = k
* full grid sorted
	call quicksort( ngrid, fe2scl_k, irank_k )
	if( gabby ) write(*,*) 'Chi2min', bofmin, ' on grid.'
      do ir = 1, ngrid
	i = irank_k( ir )
	plot3( ir ) = fe2scl_k( i )
	plot4( ir ) = dbof_k( i )
      end do

* rescale dbof to bofmin/Nw = 1
	bofdiv = 1.
      if( bofmin .gt. 0. ) then
	bofdiv = bofmin / nw
	if( gabby ) write(*,*) 'Best BoF', bofmin, ' /', nw, ' =', bofdiv
	call peqpmc( ntail, plot2, plot2, 1./bofdiv )
	call peqpmc( ngrid, plot4, plot4, 1./bofdiv )
      end if

* window for plot (and fit)
	call mnmx( ntail, plot1, xmn, xmx )
	call mnmx( ntail, plot2, ymn, ymx )
* change to full range
	call mnmx( ngrid, plot3, xmn, xmx )
	call mnmx( ngrid, plot4, ymn, ymx )

	if( gabby ) write(*,*) xmn, xmx, ymn, ymx
	add = ( xmx - xmn ) * 0.5
	xmn = xmn - add
	xmx = xmx + add
	xmn = max( 0., xmn )
	add = ( ymx - ymn ) * 0.05
	add = max( add, 0.01 )
	ymn = ymn - add
	ymx = ymx + add
* fit parabola to points in window
* KDH : FIT TO ALL POINTS, WITH DOWN-WEIGHT FOR HIGH ONES?
	n = 0
      do i = 1, ngrid
	x = plot3( i )
	y = plot4( i )
	wgt = -1.
      if( x .ge. xmn .and. x .le. xmx
     &	.and. y .ge. ymn .and. y .le. ymx ) then
	n = n + 1
	wgt = 1.
      end if
	plot5( i ) = wgt
      end do
	ndfit = n
	npfit = min( n, 3 )
	if( gabby ) write(*,*) 'Nfit', n, ' Npoly', npfit
	call polyfit1( ngrid, plot3, plot4, plot5, plot6, npfit, ifail )
      if( ifail .ne. 0 ) then
	write(*,*) '** POLYFIT FAILED.'
	write(*,*) 'x', (plot3(i),i=1,n)
	write(*,*) 'y', (plot4(i),i=1,n)
	write(*,*) 'w', (plot5(i),i=1,n)
      end if
      if( ifail .eq. 0 ) then

* rms and mad residuals
	ng = 0
	sum = 0.d0
	sum1 = 0.d0
      do i = 1, n
      if( plot5( i ) .gt. 0. ) then
	x = plot4( i ) - plot6( i )
	sum = sum + x * x
	sum1 = sum1 + abs( x )
	ng = ng + 1
      end if
      end do
	fitrms = dsqrt( sum / max( 1, ng ) )
	fitmad = sum1 / max( 1, ng )
	call mnmx( n, plot6, fitmn, fitmx )
	fitspan = fitmx - fitmn
      if( gabby ) then
	write(*,*) 'dBoF range', fitmn, fitmx, ' span', fitspan
	write(*,*) 'RMS', fitrms, ' rms/span', fitrms / fitspan
     &	, ' want <', rms_over_span_max
      end if

* evaluate poly on finer grid even spacing
	n = 100
	nfine = n
      do i = 1, n
	p = (i-1.)/max(1,n-1)
	x = xmn * (1.-p) + p * xmx
	plot7(i) = x
      end do
	call polycalc( n, plot7, plot8, ifail )
      if( ifail .ne. 0 ) then
	write(*,*) '** POLYCALC failed', ifail
      else
* min chi2
	i = minpos( n, plot8 )
* interior min chi2
      if( i .gt. 1 .and. i .lt. n ) then
	x = plot7( i )
	y = plot8( i )
* parabola
	ip = i + 1
	im = i - 1
	xp = plot7( ip )
	xm = plot7( im )
	dx = ( xp - xm ) / 2.
	yp = plot8( ip )
	ym = plot8( im )
	b = ( yp - ym ) / 2.
	c = ( yp - y ) - ( y - ym )
* min y0 and x0 +/- s0
	di = - b / ( c + c )
	x0 = x - dx * di
	s0 = dx * sqrt( 2. / c )
	y0 = y + di * ( b + di * c )
	y = y0 + 1.

c	bofred = ( bofmin * y0 + nw ) / nw
	bofred = ( bofmin + y0 ) / nw
      if( gabby .or. bofred .le. 0. ) then
c	write(*,*) 'Poly[dChi2(scl)]', bofmin * y0, ' Npoly', npfit, ' Nfit', ndfit
	write(*,*) 'Poly[dChi2(scl)]', y0, ' Npoly', npfit, ' Nfit', ndfit
	write(*,*) 'Chi2min', bofmin, ' dBoF', y0, ' nw', nw, ' Chi^2/Nw', bofred
	if( bofred .le. 0. ) write(*,*) '** WARNING: CHI2 POLYFIT MIN < 0'
      end if

      end if
      end if
      end if
	if( ifail .ne. 0 ) s0 = -1.


* extend plot window to include minimum
	if( s0 .gt. 0. ) ymn = min( ymn, y0 )
* KDH : omit very high points ?

	logx = 0
	logy = 0
	logxy = 10 * logx + 20 * logy
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, logxy, ' )'
	call pgenv( xmn, xmx, ymn, ymx, 0, logxy )
	call pgmove( 0., ymn )
	call pgdraw( 0., ymx )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
* labels
	title = 'Fe2 Scale Factor \gx\u2\d Diagnosis'
	xlabel = 'Fe2 scale factor'
	ylabel = '\gD\gx\u2\d /'
	call append_n( ylabel, bofdiv, 4 )
	call pglabel( xlabel, ylabel, title )

* agn name
	call pgmtxt( 'T', -1.5, 0.05, 0., agn )

* full grid
	call pgsci( kdkgrey )
	call pgline( ngrid, plot3, plot4 )
	call pgpt( ngrid, plot3, plot4, 20 )
* full grid best
	i = minpos( ngrid, plot4 )
	x = plot3( i )
	y = plot4( i )
	call pgpt( 1, x, y, kstar )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgmove( xmn, y )
	call pgdraw( xmx, y )
* tail 
	call pgsci( kblue )
	call pgline( ntail, plot1, plot2 )
	call pgpt( ntail, plot1, plot2, 23 )
* best
	call pgsci( kgreen )
	x = plot1( kbest )
	y = plot2( kbest )
	call pgsch( csize * 2. )
	call pgpt( 1, x, y, kstar )
	call pgsch( csize )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )

* parabola
	call pgsci( kyellow )
	call pgline( ngrid, plot3, plot6 )
	call pgsci( kred )
	call pgline( nfine, plot7, plot8 )
* 1-sigma interval
      if( s0 .gt. 0. ) then
      do i = -1, 1
	x = x0 + i * s0
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do
* error bar
	call pgsci( kblack )
	y = y0 + 1.
	call pgerrb( 5, 1, x0, y, s0, 1. )
	call pgsch( csize * 2. )
	call pgpt( 1, x0, y, kstar )
	call pgsch( csize )
      end if
* label fit rms
      if( fitrms .ge. 0 ) then
	label = 'RMS'
	call append_n( label, fitrms, 3 )
	call pgsci( kblack )
	call pgmtxt( 't', -1.5, 0.95, 1.0, label )
      end if
* label fit rms
      if( fitrms .ge. 0 ) then
	label = 'MAD'
	call append_n( label, fitmad, 3 )
	call pgsci( kblack )
	call pgmtxt( 't', -3.0, 0.95, 1.0, label )
      end if

* labels
	call pgsci( kblack )
* best reduced chi2
	label = ' '
	call append_chi2dof( label, bofmin, nw, 4 )
	call pgmtxt( 'T', 0.5, 0.99, 1.0, label )
* velocity dispersion
	label = ' '
	call append_sigv( label, ngrid, fe2kms_k )
	call pgmtxt( 'T', 0.5, 0.01, 0.0, label )
* best fit parameter and error bar
      if( s0 .gt. 0. ) then
	label = ' '
	call append_datsig( label, x0, s0, 2 )
	call pgsci( kblack )
	call pgmtxt( 'T', 0.5, 0.5, 0.5, label )
      end if

* KDH : PANEL 3
      else if( ipan .eq. ipankms ) then

* bof vs velocity dispersion
      if( ngridv .gt. 1 ) then
	n = ngridv
	call peqp( n, plot0, vdisp_v )
* log 
	logx = 0
	logy = 0
      if( logx .ne. 0 ) then
      do i = 1, n
	plot0( i ) = alog10( plot0( i ) )
      end do
      end if

* window
	call mnmx( n, plot0, xmn, xmx )
	call mnmx( n, dbof_v, ymn, ymx )
* x range
	x = fe2kms
	if( logx .ne. 0 ) x = alog10( x )
	xmn = min( xmn, x )
	xmx = max( xmx, x )

	add = ( xmx - xmn ) * 0.3
	xmn = xmn - add
	xmx = xmx + add
      if( logx .eq. 0 ) then
	xmn = max( xmn, 0. )
      end if

* y range
* KDH : OMIT VERY HIGH POINTS?
	if( sigvfit .gt. 0. ) ymn = min( ymn, bofvfit )
	ymn = min( ymn, 0. )
	add = ( ymx - ymn ) * 0.05
	ymn = ymn - add
	ymx = ymx + add

	logxy = logx * 10 + logy * 20
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, logxy, ' )'
	call pgenv( xmn, xmx, ymn, ymx, 0, logxy )
* vertical
      if( logx .ne. 0 ) then
	call pgmove( 0., ymn )
	call pgdraw( 0., ymx )
      end if
* horizontal
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
* labels
	xlabel = 'Fe2 Dispersion (km/s)'
	ylabel = '\gD\gx\u2\d /'

* rescale to reduced chi2 = 1
	i = minpos( n, chi2_v )
	chi2min = chi2_v( i )
	chi2div = chi2min / nw

	call append_n( ylabel, chi2div, 4 )
	title = 'Fe2 Velocity Dispersion \gx\u2\d Diagnosis'
	call pglabel( xlabel, ylabel, title )

* agn name
	call pgmtxt( 'T', -1.5, 0.05, 0., agn )

* best reduced chi2
	label = ' '
	call append_chi2dof( label, bofmin, nw, 4 )
	call pgmtxt( 'T', 0.5, 0.99, 1.0, label )
* velocity dispersion range
	label = ' '
	call append_sigv( label, ngridv, fe2kms_v )
* velocity dispersion prior
      if( fe2kmsprior .gt. 0. ) then
	i = index( label, 'km/s' )
	if( i .gt. 1 ) label = label(:i-1)
	call append( label, 'prior' )
	call append_i( label, nint( fe2kmsprior ) )
	call append( label, 'km/s' )
      end if

	call pgmtxt( 'T', 0.5, 0.01, 0.0, label )

* prior
	call pgsci( korange )
	call pgline( n, plot0, prior_v )

* polyfit
	call pgsci( kyellow )
	call pgline( n, plot0, fit_v )

* dchi2 curve
	call pgsci( kdkgrey )
	n = ngridv
	call pgline( n, plot0, dchi2_v )	
c	call pgpt( n, plot0, dchi2_v, 23 )
* scale point size with weight
      do i = 1, n
	call pgsch( csize * 1.5 * wgt_v(i) )
	call pgpt( 1, plot0(i), dchi2_v(i), 23 )
      end do
	call pgsch( csize )


* KDH : DEBUG REPORT
	call mnmx( n, vdisp_v, vmn, vmx )
	write(*,*) 'Dispersion grid', n, vmn, vmx

      do i = 0, n
      if( i .gt. 1 ) then
	title = ' '
	call append_i( title, i )
	call append_f( title,  vdisp_v( i ), '*' )
	call append_f( title, fe2scl_v( i ), '*' )
	call append_f( title,   real(chi2_v( i )), '*' )
	call append_f( title,  prior_v( i ), '*' )
	call append_f( title,   dbof_v( i ), '*' )
	call append_f( title,    fit_v( i ), '*' )
	call append_f( title,    wgt_v( i ), '*' )
	write(*,*) title( :len1( title ) )
      end if
      if( mod( i, 10 ) .eq. 0 .or. i .eq. n ) then
	write(*,*) 'rank'
     &		, '  kms   '
     &		, '    scl   '
     &		, '    Chi2  '
     &		, '    Prior '
     &		, '    dBoF  '
     &		, '    Fit   '
     &		, '    Wgt   '
      end if
      end do
	
* dbof curve
	call pgsci( kblue )
	n = ngridv
	call pgline( n, plot0, dbof_v )	
* scale point size with weight
      do i = 1, n
	call pgsch( csize * 1.5 * wgt_v(i) )
	call pgpt( 1, plot0(i), dbof_v(i), 23 )
      end do
	call pgsch( csize )

* best on grid
	i = minpos( n, dbof_v )
	x = vdisp_v( i )
	y = dbof_v( i )
	call pgsci( kgreen )
	call pgsch( csize * 2. )
	call pgpt( 1, plot0( i ), dbof_v( i ), kstar )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgsch( csize )

* current velocity dispersion and error bar
	v = fe2kms
	dv = sigfe2kms
	if( dv .lt. 0. ) dv = 0.
	call pgsci( kdkgrey )
      do i = -1, 1
	x = v + i * dv
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do

* plot current best in scale factor grid
	i = minpos( ngrid, plot4 )
	call pgpt( 1, x, dbof_k, 23 )

* best fit parameter and error bar
	dat = fe2kms
	sig = sigfe2kms
      if( sigvfit .gt. 0. ) then
	dat = vfit
	sig = sigvfit
      end if
      if( sig .gt. 0. ) then
	label = ' '
	call append_datsig( label, dat, sig, 2 )
	call pgsci( kblack )
	call pgmtxt( 'T', 0.5, 0.5, 0.5, label )
	call pgsci( kred )
      do i = -1, 1
	x = dat + sig * i
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do
      end if

* parabola
      if( sigvfit .gt. 0. ) then
	y0 = bofvfit
	x0 = vfit
	s0 = sigvfit
	write(*,*) 'Polyfit Vdisp', vfit, ' +/-', sigvfit, ' km/s'
	n = 100
	call pgsci( kred )
      do i=1,n
	p = (i-1.)/max(1,n-1)
	x = xmn * ( 1.-p ) + p * xmx
	y = y0 + ( ( x - x0 ) / s0 )**2
	if( i .eq. 1 ) call pgmove( x, y )
	call pgdraw( x, y )
      end do
* best fit and error bar
      do i = -1, 1
	x = x0 + s0 * i
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
      end do
	y = y0 + 1.
	call pgsci( kblack )
	call pgsch( csize * 2. )
	call pgerrb( 5, 1, x0, y, s0, 1. )
	call pgsch( csize )
	call pgpt( 1, x0, y, kstar )
      end if

* fit rms
	label = 'RMS'
	call append_n( label, fitrmsv, 3 )
	call pgsci( kblack )
	call pgmtxt( 't', -1.5, 0.95, 1.0, label )
* fit mad
	label = 'MAD'
	call append_n( label, fitmadv, 3 )
	call pgsci( kblack )
	call pgmtxt( 't', -3.0, 0.95, 1.0, label )

      end if

* end of last panel
      end if
      end do

* close 
	call pgstop
* repeat
	if( pgagain() ) goto 10

	return
	end
*==========================================================
	subroutine label_fe2( title, fe2pct, fe2kms, sigfe2kms )
* Fe2 label for plots
* In:	fe2pct	r4 percentage
*	fe2kms	r4 fe2 velocity dispersion
*	sigfe2kms r4 error bar on fe2kms
* Out:	title	c* fe2 label for plots
* 2021 Apr Keith Horne @ St Andrews
	character*(*) title
	title = 'Fe2'
* percentage
	l = len1( title )
	call append_i( title, nint( fe2pct ) )
	call append  ( title, '%' )
	call nospace( title( l+2 : len1( title ) ) )
* dispersion with error bar
	l = len1( title )
	call append_i( title, nint( fe2kms ) )
	call append  ( title, '\(2233)' )
	call append_i( title, nint( sigfe2kms ) )
	call nospace( title( l+2 : len1( title ) ) )
	call append  ( title, 'km/s' )
	return
	end

* =================================================
	subroutine pgloglam( xmn, xmx, ymn, ymx )
* add more ticks to log(wavelength) scale
* In:	xmn, xmx	r4 plot window x limits (Angstroms)
* 	ymn, ymx	r4 plot window y limits
* 2023 Feb Keith Horne @ Crail
	character*20 label
	dex = xmx - xmn
	if( dex .gt. 2. ) return
      if( dex .lt. 1.5 ) then
* minor and major tick lengths
	dy1 = ( ymx - ymn ) * 0.01
	dy2 = dy1 + dy1
* 4 decades span 10 to 10^5 angstroms
      do k = 1, 4
* first tick in this decade
	i1 = 10 ** k
* minor tick interval i
	i  = i1 / 10
* last tick in this decade
	i2 = i1 * 10 - i
      do lam = i1, i2, i
	x = alog10( real( lam ) )
      if( x .gt. xmn .and. x .lt. xmx ) then
	dy = dy1
* major tick every 5 minor ticks
	if( mod( lam, 5 * i ) .eq. 0 ) dy = dy2
	call pgmove( x, ymn )
	call pgdraw( x, ymn + dy )
	call pgmove( x, ymx )
	call pgdraw( x, ymx - dy )
      end if	
* next lam
      end do
* next k
      end do
* more tick labels
	i1 = nint( xmn - 0.5 )
	i2 = nint( xmx - 0.5 ) 
	dy = dy * 2.
      do i = i1, i2
      do k = 1, 8
	lam = k * 10. ** i
	if( k .eq. 7 ) lam = 1.5 * 10. ** i
	x = alog10( real( lam ) )
      if( x .gt. xmn .and. x .lt. xmx ) then
* extend labelled tick
	call pgmove( x, ymn - dy1 )
	call pgdraw( x, ymn + dy2 )
	call pgmove( x, ymx )
	call pgdraw( x, ymx - dy2 )
	x = ( x - xmn ) / ( xmx - xmn )
* label the tick
	label = ' '
	call append_i( label, lam )	
* align with pgbox labels (by trial and error)
c	y = 1.235
c	y = 1.232
c hi?	y = 1.230
c lo	y = 1.231
c lo	y = 1.229
c lo	y = 1.228
	y = 1.226
	call pgmtxt( 'B', y, x, 0.5, label )
      end if
* next k
      end do
* next i
      end do
      end if
	return
	end

